//
// ACTION.C  -  Action replay code file
//
// Author: Mathew Twigg
// Created 24/03/1999
//

#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include <libmath.h>
#include <stdio.h>
#include <stdlib.h>

#include "frontend.h"
#include "rand.h"
#include "sdlib\sdfunc.h"
#include "header.h"
#include "render.h"
#include "frontend.h"
#include "psx\mathpsx.h"
#include "psx\gpuPSX.h"
#include "gameloop.h"
#include "objects.h"
#include "sim.h"
#include "mesh.h"
#include "camera.h"
#include "collide.h"
#include "state.h"
#include "hue.h"
#include "psx\textPSX.h"
#include "version.h"
#include "action.h"
#include "menu.h"

#define	__DEBUG_AR				0
#define __BODGE_AR_4_PRESUB		1


extern int AI_index_n;
extern int AI_total_flag;
extern u8 AI_timer_val;
extern int coll_pt_flag;
extern int AI_index;

#if !__BODGE_AR_4_PRESUB
AR_START arInitialState;
AR_FRAME arBuffer[MAX_AR_FRAMES] [6];
ARDEB arDebugBuf[MAX_AR_FRAMES] [2];
#endif

u32 arIndex;
u32 arNIndex;
u8 arState = AR_INIT;

//APAD AR_PadData[8];
//APAD AR_PadData2[8];

void arSaveInitialState(void)
	{
#if !__BODGE_AR_4_PRESUB

	register int i;
	register int n;

#if __DEBUG_AR >= 1
    mprintf("arSaveInitialState: %s\n",arState==AR_PLAY?"returning":"resetting");
#endif
	
	if(arState==AR_PLAY)
		{
		mprintf("arSaveInitalState() Called, arState == AR_PLAY !!\n");
		return;
		}

    n = arInitialState.nPlayer = STATE.wankers;

	// Save initial state
//	memcpy(AR_PadData,SD_PadData,sizeof(APAD)*8);

    arInitialState.G_cyc = G_cyc;
    memcpy(&arInitialState.STATE,&STATE,sizeof(STATESTRUCT));

	mprintf("G_cyc Recorded:  (G_cyc == % 8ld)  (arInitialState.G_cyc == % 8ld)\n",G_cyc,arInitialState.G_cyc);

	// Fill in ai / computer players
    for(i=0;i<n;i++)
        arInitialState.pType[i] = OBJ_players[i].computer==0?0:1;
	
	arState = AR_RECORD;
	arIndex = 0;

	srand(0);
	SD_Randomize(0xcafe);

#endif
	}

void arStart(void)
	{
#if __BODGE_AR_4_PRESUB

	register int i;
	
	if(STATE.finishedLevel)
		return;
	
	STATE.finishedLevel = 1;

	for(i=0;i<STATE.wankers;i++)
		OBJ_players[i].computer |= 0x02;

	menuState = MN_StartAction;

	// Bodge within a bodge !!
	menuState = MN_Start;
	GAMELOOP_state = GLgame;

#else

/*
	register int i;
	register int n;
*/
	
	// Restore initial state
	
	arState = AR_PLAY;
    arNIndex = arIndex;
	arIndex = 0;

	GAMELOOP_task_fadein = 255;
	GAMELOOP_state = GLfadeouttogame;
	
	mprintf("arStart() Called\n");
	
    arRestoreInitialState();

#endif
    }

void arRestoreInitialState(void)
	{
#if !__BODGE_AR_4_PRESUB

    G_cyc = arInitialState.G_cyc;
    memcpy(&STATE,&arInitialState.STATE,sizeof(STATESTRUCT));

	mprintf("G_cyc Restored: % 8ld  (% 8ld)\n",G_cyc,arInitialState.G_cyc);

//	memcpy(AR_PadData2,SD_PadData,sizeof(APAD)*8);

#if __DEBUG_AR >= 1
    mprintf("arStart: arNIndex = %lu, arIndex = %lu\n",arNIndex,arIndex);
#endif

	STATE_initstatesonboot();

	// initWake() ?????

	AI_index_n = 0;
	AI_total_flag = FALSE;
	AI_timer_val = 0;
	coll_pt_flag = 0;
	AI_index = 0;

	memset(&OBJ_players,0,sizeof(OBJ_PLAYERSTRUCT)*STATE.wankers);
	memset(&OBJ_objects,0,sizeof(OBJ_STRUCT)*MAXNUMOBJS);

	srand(0);
	SD_Randomize(0xcafe);
	
//  n = arInitialState.nPlayer;
//	for(i=0;i<n;i++)
//		OBJ_players[i].computer = 0;
	
	menuState = MN_StartAction;
#endif
	}

void arRecord(void)
	{
#if !__BODGE_AR_4_PRESUB

	register int i;
	register int n;

#if __DEBUG_AR >= 1
	char text[20];
#endif

	if(arState!=AR_RECORD)
		return;

#if __DEBUG_AR >= 1
    sprintf(text,"ar index %lu",arIndex);
	
	TEXT_x = -240;
	TEXT_y = 64;
    TEXT_prstr(text,128,128,192);
    
	TEXT_x = -240;		
	TEXT_y = 44;
    TEXT_prstr("AR Recording",128,128,192);
#endif

	if(arIndex>=MAX_AR_FRAMES)
		return;
		
	// Save this frames pad values

    n = arInitialState.nPlayer;
		
	for(i=0;i<n;i++)
		{
/*
        arBuffer[arIndex] [i].data = OBJ_players[i].SIM_input_data;
   	    arBuffer[arIndex] [i].An1X = OBJ_players[i].SIM_input_an1x;
   	    arBuffer[arIndex] [i].id = OBJ_players[i].SIM_input_id;
*/
		arBuffer[arIndex] [i].SIM_input_data = OBJ_players[i].SIM_input_data;
		arBuffer[arIndex] [i].SIM_input_push = OBJ_players[i].SIM_input_push;
		arBuffer[arIndex] [i].SIM_input_id = OBJ_players[i].SIM_input_id;
		arBuffer[arIndex] [i].SIM_input_an1x = OBJ_players[i].SIM_input_an1x;
/*
		arBuffer[arIndex] [i].SIM_input_an1y = OBJ_players[i].SIM_input_an1y;
		arBuffer[arIndex] [i].SIM_input_an2x = OBJ_players[i].SIM_input_an2x;
		arBuffer[arIndex] [i].SIM_input_an2y = OBJ_players[i].SIM_input_an2y;
*/
		}

    arDebugBuf[arIndex] [0].s = *OBJ_players[0].pobj;
    arDebugBuf[arIndex] [0].p = OBJ_players[0];
    arDebugBuf[arIndex] [0].G_cyc = G_cyc;
	
#if __DEBUG_AR >= 2
	mprintf("arDebugBuf[%ld] [0].G_cyc <= %ld, G_cyc == %ld\n",
		arIndex,arDebugBuf[arIndex] [0].G_cyc,G_cyc);
#endif
		
	arIndex++;
		
	return;
#endif
	}

void arPlay(void)
	{
#if !__BODGE_AR_4_PRESUB

	register int i;
	register int n;

#if __DEBUG_AR >= 1
	char text[20];
#endif

	if(arState!=AR_PLAY)
		return;

#if __DEBUG_AR >= 1
    sprintf(text,"ar index %lu",arIndex);
	
	TEXT_x = -240;
	TEXT_y = 64;
    TEXT_prstr(text,128,128,192);
    
	TEXT_x = -240;		
	TEXT_y = 44;
    TEXT_prstr("AR Playback",128,128,192);
#endif

	// Restore frame of pad values

    n = arInitialState.nPlayer;

	for(i=0;i<n;i++)
		{
/*
		AR_PadData[i].In = 1;
        AR_PadData[i].Id = arBuffer[arIndex] [i].id;
			
        AR_PadData[i].old = AR_PadData[i].data;
		
        AR_PadData[i].data = arBuffer[arIndex] [i].data;
        AR_PadData[i].An1X = arBuffer[arIndex] [i].An1X;
        AR_PadData[i].An1Y = 0;
        AR_PadData[i].An2X = 0;
        AR_PadData[i].An2Y = 0;

        AR_PadData[i].push = (AR_PadData[i].data^AR_PadData[i].old)&AR_PadData[i].old;
        AR_PadData[i].push2 = ~AR_PadData[i].push;
        AR_PadData[i].pull = (AR_PadData[i].data^AR_PadData[i].old)&AR_PadData[i].data;
        AR_PadData[i].old = ~AR_PadData[i].old;
*/

        OBJ_players[i].SIM_input_data = arBuffer[arIndex] [i].SIM_input_data;
        OBJ_players[i].SIM_input_push = arBuffer[arIndex] [i].SIM_input_push;
        OBJ_players[i].SIM_input_id = arBuffer[arIndex] [i].SIM_input_id;
        OBJ_players[i].SIM_input_an1x = arBuffer[arIndex] [i].SIM_input_an1x;
/*
        OBJ_players[i].SIM_input_an1y = arBuffer[arIndex] [i].SIM_input_an1y;
        OBJ_players[i].SIM_input_an2x = arBuffer[arIndex] [i].SIM_input_an2x;
        OBJ_players[i].SIM_input_an2y = arBuffer[arIndex] [i].SIM_input_an2y;
*/
        }

    arDebugBuf[arIndex] [1].s = *OBJ_players[0].pobj;
    arDebugBuf[arIndex] [1].p = OBJ_players[0];
    arDebugBuf[arIndex] [1].G_cyc = G_cyc;

	#if __DEBUG_AR >= 2

	mprintf("arDebugBuf[%ld] [1].G_cyc <= %ld, G_cyc == %ld\n",
		arIndex,arDebugBuf[arIndex] [1].G_cyc,G_cyc);

    if( (arDebugBuf[arIndex] [0].s.p.vx!=arDebugBuf[arIndex] [1].s.p.vx)||
        (arDebugBuf[arIndex] [0].s.p.vy!=arDebugBuf[arIndex] [1].s.p.vy)||
        (arDebugBuf[arIndex] [0].s.p.vz!=arDebugBuf[arIndex] [1].s.p.vz)||
        (arDebugBuf[arIndex] [0].s.v.vx!=arDebugBuf[arIndex] [1].s.v.vx)||
        (arDebugBuf[arIndex] [0].s.v.vy!=arDebugBuf[arIndex] [1].s.v.vy)||
        (arDebugBuf[arIndex] [0].s.v.vz!=arDebugBuf[arIndex] [1].s.v.vz)||
        (arDebugBuf[arIndex] [0].s.r.vx!=arDebugBuf[arIndex] [1].s.r.vx)||
        (arDebugBuf[arIndex] [0].s.r.vy!=arDebugBuf[arIndex] [1].s.r.vy)||
        (arDebugBuf[arIndex] [0].s.r.vz!=arDebugBuf[arIndex] [1].s.r.vz)||
        (arDebugBuf[arIndex] [0].s.w.vx!=arDebugBuf[arIndex] [1].s.w.vx)||
        (arDebugBuf[arIndex] [0].s.w.vy!=arDebugBuf[arIndex] [1].s.w.vy)||
        (arDebugBuf[arIndex] [0].s.w.vz!=arDebugBuf[arIndex] [1].s.w.vz)||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.m[0] [0]!=arDebugBuf[arIndex] [1].p.SIM_objmat.m[0] [0])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.m[0] [1]!=arDebugBuf[arIndex] [1].p.SIM_objmat.m[0] [1])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.m[0] [2]!=arDebugBuf[arIndex] [1].p.SIM_objmat.m[0] [2])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.m[1] [0]!=arDebugBuf[arIndex] [1].p.SIM_objmat.m[1] [0])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.m[1] [1]!=arDebugBuf[arIndex] [1].p.SIM_objmat.m[1] [1])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.m[1] [2]!=arDebugBuf[arIndex] [1].p.SIM_objmat.m[1] [2])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.m[2] [0]!=arDebugBuf[arIndex] [1].p.SIM_objmat.m[2] [0])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.m[2] [1]!=arDebugBuf[arIndex] [1].p.SIM_objmat.m[2] [1])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.m[2] [2]!=arDebugBuf[arIndex] [1].p.SIM_objmat.m[2] [2])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.t[0]!=arDebugBuf[arIndex] [1].p.SIM_objmat.t[0])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.t[1]!=arDebugBuf[arIndex] [1].p.SIM_objmat.t[1])||
        (arDebugBuf[arIndex] [0].p.SIM_objmat.t[2]!=arDebugBuf[arIndex] [1].p.SIM_objmat.t[2])||
        (arDebugBuf[arIndex] [0].G_cyc!=arDebugBuf[arIndex] [1].G_cyc)
        )
        {
		register int i;
		
		for(i=((arIndex==0)?(0):(arIndex-1));i<=arIndex;i++)
			{
			mprintf("[%5d] %s%s\n",i,arState==AR_PLAY?"Ply":"",arState==AR_RECORD?"Rec":"");
			mprintf("P:> % 8ld % 8ld % 8ld    (% 8ld % 8ld % 8ld)\n",
	            arDebugBuf[i] [0].s.p.vx,arDebugBuf[i] [0].s.p.vy,arDebugBuf[i] [0].s.p.vz, 
	            arDebugBuf[i] [1].s.p.vx,arDebugBuf[i] [1].s.p.vy,arDebugBuf[i] [1].s.p.vz);
	        mprintf("V:> % 8ld % 8ld % 8ld    (% 8ld % 8ld % 8ld)\n",
	            arDebugBuf[i] [0].s.v.vx,arDebugBuf[i] [0].s.v.vy,arDebugBuf[i] [0].s.v.vz, 
	            arDebugBuf[i] [1].s.v.vx,arDebugBuf[i] [1].s.v.vy,arDebugBuf[i] [1].s.v.vz);
	        mprintf("R:> % 8d % 8d % 8d    (% 8d % 8d % 8d)\n",
	            arDebugBuf[i] [0].s.r.vx,arDebugBuf[i] [0].s.r.vy,arDebugBuf[i] [0].s.r.vz, 
	            arDebugBuf[i] [1].s.r.vx,arDebugBuf[i] [1].s.r.vy,arDebugBuf[i] [1].s.r.vz);
	        mprintf("W:> % 8d % 8d % 8d    (% 8d % 8d % 8d)\n",
	            arDebugBuf[i] [0].s.w.vx,arDebugBuf[i] [0].s.w.vy,arDebugBuf[i] [0].s.w.vz, 
	            arDebugBuf[i] [1].s.w.vx,arDebugBuf[i] [1].s.w.vy,arDebugBuf[i] [1].s.w.vz);
			
            mprintf("SIM_objmat:>  %04X,%04X,%04X  %04X,%04X,%04X\n"
                   "              %04X,%04X,%04X  %04X,%04X,%04X\n"
                   "              %04X,%04X,%04X  %04X,%04X,%04X\n"
                   "              %04lX,%04lX,%04lX  %04lX,%04lX,%04lX\n",
                arDebugBuf[i] [0].p.SIM_objmat.m[0] [0]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.m[0] [1]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.m[0] [2]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.m[0] [0]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.m[0] [1]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.m[0] [2]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.m[1] [0]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.m[1] [1]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.m[1] [2]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.m[1] [0]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.m[1] [1]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.m[1] [2]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.m[2] [0]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.m[2] [1]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.m[2] [2]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.m[2] [0]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.m[2] [1]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.m[2] [2]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.t[0]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.t[1]&0xffff,
                arDebugBuf[i] [0].p.SIM_objmat.t[2]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.t[0]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.t[1]&0xffff,
                arDebugBuf[i] [1].p.SIM_objmat.t[2]&0xffff);

            mprintf("G_cyc:> % 8ld   (% 8ld)\n",
				arDebugBuf[i] [0].G_cyc,arDebugBuf[i] [1].G_cyc);

			mprintf("arDebugBuf[%d] [0].G_cyc => %ld, G_cyc == %ld\n",
				i,arDebugBuf[i] [0].G_cyc,G_cyc);
			mprintf("arDebugBuf[%d] [1].G_cyc => %ld, G_cyc == %ld\n",
				i,arDebugBuf[i] [1].G_cyc,G_cyc);
            }
            
		while(1)
			pollhost();

		}
		
	#endif

	arIndex++;
	if(arIndex>arNIndex)
		{
//      memcpy(SD_PadData,AR_PadData2,sizeof(APAD)*8);

		padRefresh();
		padRefresh();
        
		arState = AR_INIT;
		arSaveInitialState();
		}

#endif
	}

void arDebug(void)
	{
#if !__BODGE_AR_4_PRESUB

/*
	register int i = 0;

	mprintf("%s%s ",arState==AR_PLAY?"Ply":"",arState==AR_RECORD?"Rec":"");
	
	mprintf("[%5ld] %08lX %08lX %08lX %02X %02X %02X %02X\n",
		arIndex,
        OBJ_players[i].SIM_input_data,
        OBJ_players[i].SIM_input_push,
        OBJ_players[i].SIM_input_id,
        OBJ_players[i].SIM_input_an1x&0xff,
        OBJ_players[i].SIM_input_an1y&0xff,
        OBJ_players[i].SIM_input_an2x&0xff,
        OBJ_players[i].SIM_input_an2y&0xff);
*/

#endif
    }
