//AI map data
//Ian Tomkins
//26.1.99
//Data for collision lines for AI maps

#include "header.h"
#include "frontend.h"
#include "fade.h"
#include "render.h"
#include "camera.h"
#include "objects.h"
#include "collide.h"
#include "pickups.h"

#if   PSX

	#include <libsn.h>
	#include "sdlib\sdtypes.h"
   	#include "sdlib\sdfunc.h"

#endif

#include "ctrller.h"
#include "gameloop.h"
#include "state.h"

#if   PSX

	#include "PSX\loadpsx.h"
	#include "PSX\PSX_pcks.h"

#endif

#include "AI.H"

//AI TEST MAP VALUES

//start of joels track 1

PAIR_2D AI_test_map_a[175] = {

	{15535, 26106},                                                                                                                                           
	{16853, 25622},                                                                                                                                           
	{18190, 24944},                                                                                                                                           
	{19451, 24593},                                                                                                                                           
	{21226, 24234},                                                                                                                                           
	{22556, 23786},                                                                                                                                           
	{23546, 23280},                                                                                                                                           
	{23816, 23142},                                                                                                                                           
	{24126, 22742},                                                                                                                                           
	{25676, 20742},                                                                                                                                           
	{25892, 20402},                                                                                                                                           
	{26138, 19850},                                                                                                                                           
	{26156, 19250},                                                                                                                                           
	{25636, 18054},                                                                                                                                           
	{25180, 16938},                                                                                                                                           
	{25056, 16558},                                                                                                                                           
	{24867, 15367},                                                                                                                                           
	{24782, 13867},                                                                                                                                           
	{24740, 13267},                                                                                                                                           
	{24655, 12772},                                                                                                                                           
	{24603, 12578},                                                                                                                                           
	{24429, 12478},                                                                                                                                           
	{23939, 12393},                                                                                                                                           
	{22949, 12363},                                                                                                                                           
	{20761, 12583},                                                                                                                                           
	{19705, 12858},                                                                                                                                           
	{18124, 13436},                                                                                                                                           
	{17008, 13844},                                                                                                                                           
	{15320, 13867},                                                                                                                                           
	{13940, 13297},                                                                                                                                           
	{12646, 12211},                                                                                                                                           
	{11708, 11175},                                                                                                                                           
	{10808, 9975},                                                                                                                                            
	{9079, 8189},                                                                                                                                             
	{8307, 6904},                                                                                                                                             
	{7907, 5352},                                                                                                                                             
	{8342, 3912},                                                                                                                                             
	{9014, 2456},                                                                                                                                             
	{10445, 1346},                                                                                                                                            
	{11581, 359},                                                                                                                                             
	{12351, -817},                                                                                                                                            
	{13039, -1241},                                                                                                                                           
	{13655, -1584},                                                                                                                                           
	{13831, -1682},                                                                                                                                           
	{14491, -2690},                                                                                                                                           
	{15751, -3306},                                                                                                                                           
	{15919, -4077},                                                                                                                                           
	{16522, -4752},                                                                                                                                           
	{16616, -4930},                                                                                                                                           
	{17536, -5330},                                                                                                                                           
	{17865, -5953},                                                                                                                                           
	{17547, -6577},                                                                                                                                           
	{17661, -7171},                                                                                                                                           
	{18099, -7418},                                                                                                                                           
	{18271, -7524},                                                                                                                                           
	{17907, -8126},                                                                                                                                           
	{16918, -10196},                                                                                                                                          
	{16748, -10666},                                                                                                                                          
	{16488, -11940},                                                                                                                                          
	{16433, -13040},                                                                                                                                          
	{16313, -13832},                                                                                                                                          
	{15998, -15911},                                                                                                                                          
	{15497, -17846},                                                                                                                                          
	{14972, -19883},                                                                                                                                          
	{14780, -20235},                                                                                                                                          
	{14276, -20982},                                                                                                                                          
	{13778, -21312},                                                                                                                                          
	{12095, -21550},                                                                                                                                          
	{10808, -21485},                                                                                                                                          
	{9323, -21545},                                                                                                                                           
	{8159, -21833},                                                                                                                                           
	{7219, -22163},                                                                                                                                           
	{5535, -22127},                                                                                                                                           
	{1935, -22091},                                                                                                                                           
	{868, -21871},                                                                                                                                            
	{31, -21565},                                                                                                                                             
	{-734, -21097},                                                                                                                                           
	{-1287, -20677},                                                                                                                                          
	{-1871, -20141},                                                                                                                                          
	{-2382, -19672},                                                                                                                                          
	{-3530, -18888},                                                                                                                                          
	{-4581, -17839},                                                                                                                                          
	{-5073, -17503},                                                                                                                                          
	{-6378, -16783},                                                                                                                                          
	{-8016, -16081},                                                                                                                                          
	{-9225, -15639},                                                                                                                                          
	{-15079, -14552},                                                                                                                                         
	{-16615, -14152},                                                                                                                                         
	{-17833, -13480},                                                                                                                                         
	{-18768, -12908},                                                                                                                                         
	{-20666, -11166},                                                                                                                                         
	{-21098, -10502},                                                                                                                                         
	{-22206, -9396},                                                                                                                                          
	{-24790, -7220},                                                                                                                                          
	{-25200, -6320},                                                                                                                                          
	{-25552, -5286},                                                                                                                                          
	{-25656, -4494},                                                                                                                                          
	{-25501, -4019},                                                                                                                                          
	{-24971, -3169},                                                                                                                                          
	{-24443, -2101},                                                                                                                                          
	{-23953, -799},                                                                                                                                           
	{-23193, 930},                                                                                                                                            
	{-22793, 1840},                                                                                                                                           
	{-22450, 2449},                                                                                                                                           
	{-22206, 2765},                                                                                                                                           
	{-21816, 3075},                                                                                                                                           
	{-21150, 3289},                                                                                                                                           
	{-20190, 3569},                                                                                                                                           
	{-19225, 4103},                                                                                                                                           
	{-18835, 4413},                                                                                                                                           
	{-17985, 5255},                                                                                                                                           
	{-17400, 5939},                                                                                                                                           
	{-16812, 6983},                                                                                                                                           
	{-16409, 8218},                                                                                                                                           
	{-16806, 10069},                                                                                                                                          
	{-18110, 11808},                                                                                                                                          
	{-18270, 12278},                                                                                                                                          
	{-18348, 12872},                                                                                                                                          
	{-18438, 15842},                                                                                                                                          
	{-18726, 17410},                                                                                                                                          
	{-20178, 19038},                                                                                                                                          
	{-21379, 20075},                                                                                                                                          
	{-21643, 20371},                                                                                                                                          
	{-21775, 20519},                                                                                                                                          
	{-21592, 20756},                                                                                                                                          
	{-21409, 20993},                                                                                                                                          
	{-21019, 21303},                                                                                                                                          
	{-20179, 21843},                                                                                                                                          
	{-17615, 23562},                                                                                                                                          
	{-16484, 24212},                                                                                                                                          
	{-16136, 24412},                                                                                                                                          
	{-15756, 24540},                                                                                                                                          
	{-15376, 24668},                                                                                                                                          
	{-15182, 24616},                                                                                                                                          
	{-14887, 24211},                                                                                                                                          
	{-14233, 22642},                                                                                                                                          
	{-13934, 21685},                                                                                                                                          
	{-13752, 20385},                                                                                                                                          
	{-13356, 19245},                                                                                                                                          
	{-11841, 17001},                                                                                                                                          
	{-11291, 16424},                                                                                                                                          
	{-10851, 15752},                                                                                                                                          
	{-10334, 14773},                                                                                                                                          
	{-10163, 13722},                                                                                                                                          
	{-10113, 12222},                                                                                                                                          
	{-10123, 11222},                                                                                                                                          
	{-9727, 9417},                                                                                                                                            
	{-8929, 7688},                                                                                                                                            
	{-8042, 6229},                                                                                                                                            
	{-6803, 4528},                                                                                                                                            
	{-5274, 3567},                                                                                                                                            
	{-3274, 3687},                                                                                                                                            
	{-2224, 4611},                                                                                                                                            
	{-728, 6217},                                                                                                                                             
	{520, 7209},                                                                                                                                              
	{2236, 8573},                                                                                                                                             
	{3471, 10017},                                                                                                                                            
	{4372, 11462},                                                                                                                                            
	{4827, 11994},                                                                                                                                            
	{6402, 13380},                                                                                                                                            
	{7452, 14304},                                                                                                                                            
	{8622, 15672},                                                                                                                                            
	{8902, 16309},                                                                                                                                            
	{9491, 18114},                                                                                                                                            
	{9647, 18690},                                                                                                                                            
	{10055, 19128},                                                                                                                                           
	{10835, 19748},                                                                                                                                           
	{11771, 20645},                                                                                                                                           
	{12559, 21545},                                                                                                                                           
	{12999, 22435},                                                                                                                                           
	{13919, 24528},                                                                                                                                           
	{14204, 24938},                                                                                                                                           
	{14680, 25449},                                                                                                                                           
	{15205, 25911},                                                                                                                                           
	{15561, 26095}                                                                                                                                           

};

PAIR_2D AI_test_map_b[190] = {

                                                                                                                                                             
	{-4510, 5927},                                                                                                                                            
	{-5210, 6637},                                                                                                                                            
	{-5706, 7253},                                                                                                                                            
	{-7006, 9489},                                                                                                                                            
	{-7376, 10409},                                                                                                                                           
	{-7583, 11282},                                                                                                                                           
	{-7647, 13660},                                                                                                                                           
	{-7711, 14452},                                                                                                                                           
	{-7927, 15628},                                                                                                                                           
	{-8639, 17152},                                                                                                                                           
	{-10253, 19276},                                                                                                                                          
	{-10935, 20123},                                                                                                                                          
	{-11222, 20753},                                                                                                                                          
	{-11430, 22337},                                                                                                                                          
	{-12418, 25354},                                                                                                                                          
	{-13110, 26317},                                                                                                                                          
	{-14422, 27213},                                                                                                                                          
	{-16071, 27553},                                                                                                                                          
	{-18430, 25894},                                                                                                                                          
	{-19960, 25180},                                                                                                                                          
	{-22367, 23585},                                                                                                                                          
	{-23559, 22573},                                                                                                                                          
	{-24427, 20875},                                                                                                                                          
	{-24419, 20675},                                                                                                                                          
	{-23910, 19047},                                                                                                                                          
	{-23784, 18774},                                                                                                                                          
	{-22839, 17604},                                                                                                                                          
	{-21719, 16750},                                                                                                                                          
	{-21365, 16264},                                                                                                                                          
	{-21061, 15520},                                                                                                                                          
	{-20893, 14320},                                                                                                                                          
	{-20853, 13320},                                                                                                                                          
	{-20736, 12020},                                                                                                                                          
	{-20616, 11530},                                                                                                                                          
	{-20260, 10701},                                                                                                                                          
	{-19801, 9918},                                                                                                                                           
	{-19423, 9450},                                                                                                                                           
	{-19045, 8982},                                                                                                                                           
	{-18857, 8626},                                                                                                                                           
	{-19002, 8146},                                                                                                                                           
	{-19237, 7706},                                                                                                                                           
	{-19597, 7226},                                                                                                                                           
	{-20535, 6190},                                                                                                                                           
	{-20879, 5986},                                                                                                                                           
	{-22779, 5406},                                                                                                                                           
	{-24219, 4344},                                                                                                                                           
	{-25704, 4494},                                                                                                                                           
	{-26484, 3204},                                                                                                                                           
	{-26759, 2321},                                                                                                                                           
	{-26397, 1724},                                                                                                                                           
	{-26419, 1446},                                                                                                                                           
	{-26978, 276},                                                                                                                                            
	{-27468, 351},                                                                                                                                            
	{-27714, 187},                                                                                                                                            
	{-28101, -623},                                                                                                                                           
	{-28493, -699},                                                                                                                                           
	{-28647, -825},                                                                                                                                           
	{-28848, -1047},                                                                                                                                          
	{-29212, -1649},                                                                                                                                          
	{-29472, -2079},                                                                                                                                          
	{-29694, -2280},                                                                                                                                          
	{-29964, -2406},                                                                                                                                          
	{-30209, -2718},                                                                                                                                          
	{-29973, -3042},                                                                                                                                          
	{-29391, -3198},                                                                                                                                          
	{-28852, -3653},                                                                                                                                          
	{-28159, -4511},                                                                                                                                          
	{-27963, -5911},                                                                                                                                          
	{-27557, -7255},                                                                                                                                          
	{-26946, -8412},                                                                                                                                          
	{-26415, -9141},                                                                                                                                          
	{-24105, -11091},                                                                                                                                         
	{-23397, -12063},                                                                                                                                         
	{-23012, -12388},                                                                                                                                         
	{-21808, -13130},                                                                                                                                         
	{-19588, -15170},                                                                                                                                         
	{-19231, -15779},                                                                                                                                         
	{-18112, -16455},                                                                                                                                         
	{-16996, -16935},                                                                                                                                         
	{-15396, -17031},                                                                                                                                         
	{-10496, -18081},                                                                                                                                         
	{-8755, -18566},                                                                                                                                          
	{-8290, -18766},                                                                                                                                          
	{-7300, -19250},                                                                                                                                          
	{-6697, -19925},                                                                                                                                          
	{-5812, -21140},                                                                                                                                          
	{-5102, -21860},                                                                                                                                          
	{-4647, -22646},                                                                                                                                          
	{-4422, -22841},                                                                                                                                          
	{-3014, -23609},                                                                                                                                          
	{-1514, -23774},                                                                                                                                          
	{-10, -24334},                                                                                                                                            
	{2832, -24943},                                                                                                                                           
	{5732, -24880},                                                                                                                                           
	{6569, -24547},                                                                                                                                           
	{9044, -24097},                                                                                                                                           
	{9539, -24007},                                                                                                                                           
	{10339, -23943},                                                                                                                                          
	{12339, -23936},                                                                                                                                          
	{14139, -23792},                                                                                                                                          
	{15919, -22872},                                                                                                                                          
	{17041, -21222},                                                                                                                                          
	{17461, -20106},                                                                                                                                          
	{18021, -18196},                                                                                                                                          
	{18588, -15577},                                                                                                                                          
	{18812, -14205},                                                                                                                                          
	{18998, -11136},                                                                                                                                          
	{19397, -10562},                                                                                                                                          
	{20117, -9257},                                                                                                                                           
	{20549, -8474},                                                                                                                                           
	{20913, -7130},                                                                                                                                           
	{20591, -5772},                                                                                                                                           
	{20147, -4668},                                                                                                                                           
	{19335, -3548},                                                                                                                                           
	{18785, -2602},                                                                                                                                           
	{17982, -1865},                                                                                                                                           
	{17568, -1073},                                                                                                                                           
	{16656, -305},                                                                                                                                            
	{15906, 985},                                                                                                                                             
	{14749, 1544},                                                                                                                                            
	{13999, 2834},                                                                                                                                            
	{11975, 3692},                                                                                                                                            
	{11453, 3974},                                                                                                                                            
	{11105, 4454},                                                                                                                                            
	{10859, 4994},                                                                                                                                            
	{10805, 5288},                                                                                                                                            
	{11445, 6760},                                                                                                                                            
	{11781, 7369},                                                                                                                                            
	{13413, 9121},                                                                                                                                            
	{14145, 10069},                                                                                                                                           
	{14781, 10708},                                                                                                                                           
	{15381, 11236},                                                                                                                                           
	{15969, 11374},                                                                                                                                           
	{16369, 11386},                                                                                                                                           
	{17242, 11152},                                                                                                                                           
	{17806, 10942},                                                                                                                                           
	{18886, 10414},                                                                                                                                           
	{20662, 10096},                                                                                                                                           
	{21632, 9836},                                                                                                                                            
	{22760, 9416},                                                                                                                                            
	{24734, 9750},                                                                                                                                            
	{26300, 10650},                                                                                                                                           
	{27155, 11880},                                                                                                                                           
	{27545, 13115},                                                                                                                                           
	{27622, 13808},                                                                                                                                           
	{27601, 14501},                                                                                                                                           
	{27835, 15365},                                                                                                                                           
	{27868, 15662},                                                                                                                                           
	{27850, 16256},                                                                                                                                           
	{27994, 17138},                                                                                                                                           
	{28176, 17810},                                                                                                                                           
	{28456, 18454},                                                                                                                                           
	{28650, 19829},                                                                                                                                           
	{28174, 21444},                                                                                                                                           
	{27564, 22345},                                                                                                                                           
	{26254, 23956},                                                                                                                                           
	{25732, 24676},                                                                                                                                           
	{25382, 25031},                                                                                                                                           
	{24544, 25565},                                                                                                                                           
	{24216, 25789},                                                                                                                                           
	{23007, 26231},                                                                                                                                           
	{22356, 26469},                                                                                                                                           
	{21396, 26719},                                                                                                                                           
	{20318, 26884},                                                                                                                                           
	{18893, 27319},                                                                                                                                           
	{17942, 27844},                                                                                                                                           
	{16947, 28281},                                                                                                                                           
	{16371, 28431},                                                                                                                                           
	{15685, 28536},                                                                                                                                           
	{15091, 28566},                                                                                                                                           
	{14236, 28305},                                                                                                                                           
	{12796, 27243},                                                                                                                                           
	{12220, 26550},                                                                                                                                           
	{11280, 24790},                                                                                                                                           
	{10539, 23023},                                                                                                                                           
	{9829, 22313},                                                                                                                                            
	{8553, 21198},                                                                                                                                            
	{7548, 20088},                                                                                                                                            
	{7048, 19054},                                                                                                                                            
	{6571, 17319},                                                                                                                                            
	{6259, 16803},                                                                                                                                            
	{5589, 16063},                                                                                                                                            
	{3580, 14278},                                                                                                                                            
	{2645, 13392},                                                                                                                                            
	{1917, 12313},                                                                                                                                            
	{1447, 11433},                                                                                                                                            
	{666, 10652},                                                                                                                                             
	{-370, 9714},                                                                                                                                             
	{-2372, 8076},                                                                                                                                            
	{-4461, 5940}                                                                                                                                            

};

PAIR_2D	AI_test_map_c[8] = {

{-24116, 4456},
{-25465, 3107},                                                                                                                                           
{-26055, 2307},                                                                                                                                           
{-26601, 1051},                                                                                                                                           
{-27033, -695},                                                                                                                                           
{-27369, -2053},                                                                                                                                          
{-27831, -3369},                                                                                                                                          
{-28143, -5103}
                                                                                                                                          
};                                                                                                                                      

PAIR_2D	AI_test_map_d[13] = {

{-12297, 25112},                                                                                                                                          
{-13740, 28516},                                                                                                                                          
{-15252, 29258},                                                                                                                                          
{-16890, 29663},                                                                                                                                          
{-19355, 28126},                                                                                                                                          
{-21314, 26945},                                                                                                                                          
{-22418, 26465},                                                                                                                                          
{-24333, 24682},                                                                                                                                          
{-25363, 23601},                                                                                                                                          
{-26306, 21508},                                                                                                                                          
{-25057, 18669},                                                                                                                                          
{-24368, 17551},                                                                                                                                          
{-21708, 16627}                                                                                                                                          

};

PAIR_2D AI_test_map_e[7] = {

{10556, 9778},
{9716, 8658},                                                                                                                                             
{9105, 7514},                                                                                                                                             
{8895, 6142},                                                                                                                                             
{9161, 4770},                                                                                                                                             
{10167, 2827},                                                                                                                                            
{11583, 303}
                                                                                                                                             
};                                                                                                                                            

PAIR_2D AI_test_map_f[14] = {
                                                                                                                                           
{16341, 14103},
{14661, 13903},                                                                                                                                           
{13485, 13723},                                                                                                                                           
{11721, 13363},                                                                                                                                           
{10447, 13168},                                                                                                                                           
{9189, 12029},                                                                                                                                            
{7488, 9923},                                                                                                                                             
{6012, 7324},                                                                                                                                             
{5852, 5724},                                                                                                                                             
{6137, 3843},                                                                                                                                             
{7584, 1423},                                                                                                                                             
{8436, 559},                                                                                                                                              
{9100, 111},                                                                                                                                              
{12421, -635}

};                                                                                                                                            
//end of joels track 1

/*PAIR_2D	AI_test_map[373] = {

{-29447, -9658},                                                                                                                                          
{-29612, -10747},                                                                                                                                         
{-29414, -12947},                                                                                                                                         
{-29162, -13820},                                                                                                                                         
{-28926, -14148},                                                                                                                                         
{-27802, -14853},                                                                                                                                         
{-25756, -15316},                                                                                                                                         
{-24256, -15291},                                                                                                                                         
{-23698, -15069},                                                                                                                                         
{-23370, -14837},                                                                                                                                         
{-22845, -14375},                                                                                                                                         
{-21598, -12940},                                                                                                                                         
{-21028, -12120},                                                                                                                                         
{-20538, -11250},                                                                                                                                         
{-19572, -10228},                                                                                                                                         
{-18812, -9582},                                                                                                                                          
{-17562, -8752},                                                                                                                                          
{-16107, -8347},                                                                                                                                          
{-15225, -8140},                                                                                                                                          
{-13331, -7983},                                                                                                                                          
{-9133, -8140},                                                                                                                                           
{-7471, -8517},                                                                                                                                           
{-6481, -9001},                                                                                                                                           
{-5641, -9865},                                                                                                                                           
{-4519, -11779},                                                                                                                                          
{-3173, -14802},                                                                                                                                          
{-2375, -16755},                                                                                                                                          
{-1506, -18201},                                                                                                                                          
{-322, -19305},                                                                                                                                           
{1262, -20187},                                                                                                                                           
{3049, -20461},                                                                                                                                           
{4449, -20514},                                                                                                                                           
{5649, -20473},                                                                                                                                           
{6933, -20272},                                                                                                                                           
{8102, -19974},                                                                                                                                           
{9285, -19441},                                                                                                                                           
{10433, -18629},                                                                                                                                          
{12483, -17179},                                                                                                                                          
{13106, -16857},                                                                                                                                          
{13757, -16598},                                                                                                                                          
{14436, -16409},                                                                                                                                          
{16009, -16071},                                                                                                                                          
{20167, -15315},                                                                                                                                          
{23632, -14685},                                                                                                                                          
{24997, -14070},                                                                                                                                          
{26052, -13147},                                                                                                                                          
{26964, -11835},                                                                                                                                          
{28189, -9660},                                                                                                                                           
{29549, -6566},                                                                                                                                           
{29983, -5236},                                                                                                                                           
{30298, -3781},                                                                                                                                           
{30514, -1999},                                                                                                                                           
{30540, -699},                                                                                                                                            
{30412, 885},                                                                                                                                             
{30142, 2355},                                                                                                                                            
{29758, 3483},                                                                                                                                            
{29160, 4627},                                                                                                                                            
{28350, 5872},                                                                                                                                            
{27668, 6730},                                                                                                                                            
{26719, 7614},                                                                                                                                            
{25615, 8750},                                                                                                                                            
{25153, 9268},                                                                                                                                            
{23645, 11374},                                                                                                                                           
{23213, 12038},                                                                                                                                           
{22753, 12918},                                                                                                                                           
{22337, 14140},                                                                                                                                           
{22148, 14812},                                                                                                                                           
{21665, 16849},                                                                                                                                           
{21406, 17493},                                                                                                                                           
{20848, 18195},                                                                                                                                           
{20337, 18671},                                                                                                                                           
{19784, 19091},                                                                                                                                           
{19104, 19507},                                                                                                                                           
{18303, 19894},                                                                                                                                           
{17559, 20166},                                                                                                                                           
{16783, 20326},                                                                                                                                           
{15694, 20447},                                                                                                                                           
{13912, 20375},                                                                                                                                           
{11972, 19895},                                                                                                                                           
{11236, 19591},                                                                                                                                           
{10548, 19183},                                                                                                                                           
{9838, 18483},                                                                                                                                            
{9446, 17902},                                                                                                                                            
{9231, 17452},                                                                                                                                            
{8991, 16684},                                                                                                                                            
{8751, 15916},                                                                                                                                            
{8646, 15223},                                                                                                                                            
{8634, 14023},                                                                                                                                            
{8697, 12829},                                                                                                                                            
{9127, 10556},                                                                                                                                            
{9431, 8972},                                                                                                                                             
{9583, 8600},                                                                                                                                             
{9793, 8145},                                                                                                                                             
{10549, 7197},                                                                                                                                            
{11289, 6507},                                                                                                                                            
{12089, 5897},                                                                                                                                            
{12705, 5554},                                                                                                                                            
{13165, 5354},                                                                                                                                            
{13650, 5224},                                                                                                                                            
{14442, 5096},                                                                                                                                            
{16834, 4856},                                                                                                                                            
{19334, 4556},                                                                                                                                            
{20180, 4241},                                                                                                                                            
{20696, 3923},                                                                                                                                            
{21235, 3468},                                                                                                                                            
{21655, 3036},                                                                                                                                            
{22033, 2562},                                                                                                                                            
{22832, 1049},                                                                                                                                            
{23084, 176},                                                                                                                                             
{23165, -724},                                                                                                                                            
{23228, -1424},                                                                                                                                           
{23192, -2024},                                                                                                                                           
{23156, -2624},                                                                                                                                           
{22886, -3794},                                                                                                                                           
{22648, -4452},                                                                                                                                           
{22264, -5156},                                                                                                                                           
{21720, -5748},                                                                                                                                           
{20768, -6784},                                                                                                                                           
{20282, -7138},                                                                                                                                           
{19754, -7420},                                                                                                                                           
{19050, -7796},                                                                                                                                           
{18392, -8027},                                                                                                                                           
{17608, -8179},                                                                                                                                           
{16420, -8287},                                                                                                                                           
{14932, -8202},                                                                                                                                           
{14041, -8103},                                                                                                                                           
{13077, -7873},                                                                                                                                           
{12116, -7628},                                                                                                                                           
{11093, -7254},                                                                                                                                           
{10381, -6910},                                                                                                                                           
{9616, -6442},                                                                                                                                            
{8747, -5782},                                                                                                                                            
{8163, -5238},                                                                                                                                            
{7266, -4315},                                                                                                                                            
{6708, -3613},                                                                                                                                            
{6222, -2866},                                                                                                                                            
{4486, 808},                                                                                                                                              
{3424, 2592},                                                                                                                                             
{2194, 3882},                                                                                                                                             
{807, 5174},                                                                                                                                              
{-102, 5946},                                                                                                                                             
{-828, 6629},                                                                                                                                             
{-1550, 7447},                                                                                                                                            
{-2212, 8318},                                                                                                                                            
{-3151, 9839},                                                                                                                                            
{-3427, 10367},                                                                                                                                           
{-3916, 12192},                                                                                                                                           
{-4726, 16602},                                                                                                                                           
{-5334, 18388},                                                                                                                                           
{-6360, 19965},                                                                                                                                           
{-6684, 20463},                                                                                                                                           
{-7000, 20703},                                                                                                                                           
{-7380, 21023},                                                                                                                                           
{-7790, 21303},                                                                                                                                           
{-8597, 21677},                                                                                                                                           
{-9642, 22007},                                                                                                                                           
{-11072, 22432},                                                                                                                                          
{-12448, 22611},                                                                                                                                          
{-13537, 22512},                                                                                                                                          
{-14119, 22368},                                                                                                                                          
{-14771, 22123},                                                                                                                                          
{-15631, 21613},                                                                                                                                          
{-16305, 21018},                                                                                                                                          
{-17628, 19533},                                                                                                                                          
{-18458, 18047},                                                                                                                                          
{-18906, 17383},                                                                                                                                          
{-19482, 16690},                                                                                                                                          
{-20058, 15997},                                                                                                                                          
{-21316, 14858},                                                                                                                                          
{-22455, 14040},                                                                                                                                          
{-27948, 11505},                                                                                                                                          
{-28500, 11277},                                                                                                                                          
{-29018, 10808},                                                                                                                                          
{-29562, 10216},                                                                                                                                          
{-29925, 9394},                                                                                                                                           
{-30258, 8372},                                                                                                                                           
{-30393, 7481},                                                                                                                                           
{-30337, 6581},                                                                                                                                           
{-30253, 5981},                                                                                                                                           
{-30075, 5203},                                                                                                                                           
{-29809, 4552},                                                                                                                                           
{-29401, 3856},                                                                                                                                           
{-28582, 2829},                                                                                                                                           
{-28254, 2449},                                                                                                                                           
{-27764, 1945},                                                                                                                                           
{-26780, 1082},                                                                                                                                           
{-26263, 103},                                                                                                                                            
{-25867, -1037},                                                                                                                                          
{-25727, -2037},                                                                                                                                          
{-25805, -3337},                                                                                                                                          
{-25905, -3827},                                                                                                                                          
{-26256, -4655},                                                                                                                                          
{-26856, -5455},                                                                                                                                          
{-27808, -6491},                                                                                                                                          
{-29447, -9658},                                                                                                                                          

//INNER LINE

{-22871, 16023},                                                                                                                                          
{-23964, 15327},                                                                                                                                          
{-25069, 14651},                                                                                                                                          
{-26313, 14039},                                                                                                                                          
{-27928, 13529},                                                                                                                                          
{-29479, 12895},                                                                                                                                          
{-30315, 12191},                                                                                                                                          
{-31245, 11021},                                                                                                                                          
{-31993, 9389},                                                                                                                                           
{-32217, 8621},                                                                                                                                           
{-32361, 7829},                                                                                                                                           
{-32345, 6229},                                                                                                                                           
{-32009, 4661},                                                                                                                                           
{-31502, 3452},                                                                                                                                           
{-30774, 2248},                                                                                                                                           
{-29756, 1004},                                                                                                                                           
{-28631, -1},                                                                                                                                             
{-28143, -641},                                                                                                                                           
{-27933, -1205},                                                                                                                                          
{-27744, -2087},                                                                                                                                          
{-27816, -2887},                                                                                                                                          
{-27977, -3573},                                                                                                                                          
{-28299, -4196},                                                                                                                                          
{-28956, -4808},                                                                                                                                          
{-29762, -5822},                                                                                                                                          
{-30630, -6914},                                                                                                                                          
{-31090, -7804},                                                                                                                                          
{-31520, -9332},                                                                                                                                          
{-31592, -10632},                                                                                                                                         
{-31350, -13332},                                                                                                                                         
{-31119, -14410},                                                                                                                                         
{-30687, -15202},                                                                                                                                         
{-30211, -15720},                                                                                                                                         
{-29320, -16380},                                                                                                                                         
{-28592, -16724},                                                                                                                                         
{-26632, -17204},                                                                                                                                         
{-24538, -17324},                                                                                                                                         
{-22872, -16984},                                                                                                                                         
{-21672, -16084},                                                                                                                                         
{-20820, -15232},                                                                                                                                         
{-19662, -13864},                                                                                                                                         
{-18897, -12574},                                                                                                                                         
{-18037, -11614},                                                                                                                                         
{-16896, -10803},                                                                                                                                         
{-15898, -10351},                                                                                                                                         
{-14918, -10151},                                                                                                                                         
{-12918, -10041},                                                                                                                                         
{-9118, -10231},                                                                                                                                          
{-8334, -10423},                                                                                                                                          
{-7711, -10752},                                                                                                                                          
{-7261, -11154},                                                                                                                                          
{-6838, -11717},                                                                                                                                          
{-5826, -13810},                                                                                                                                          
{-3750, -18496},                                                                                                                                          
{-2390, -19976},                                                                                                                                          
{-95, -21543},                                                                                                                                            
{1209, -22071},                                                                                                                                           
{2892, -22326},                                                                                                                                           
{4792, -22396},                                                                                                                                           
{7869, -21971},                                                                                                                                           
{9843, -21257},                                                                                                                                           
{11838, -19929},                                                                                                                                          
{13159, -18870},                                                                                                                                          
{15803, -17937},                                                                                                                                          
{18845, -17343},                                                                                                                                          
{24546, -16268},                                                                                                                                          
{25992, -15583},                                                                                                                                          
{26664, -14988},                                                                                                                                          
{27179, -14515},                                                                                                                                          
{27839, -13635},                                                                                                                                          
{29844, -10412},                                                                                                                                          
{31245, -7108},                                                                                                                                           
{31774, -5713},                                                                                                                                           
{32110, -4355},                                                                                                                                           
{32305, -3081},                                                                                                                                           
{32425, -1497},                                                                                                                                           
{32345, 87},                                                                                                                                              
{32140, 1561},                                                                                                                                            
{31760, 3404},                                                                                                                                            
{31488, 4148},                                                                                                                                            
{31184, 4884},                                                                                                                                            
{30608, 5922},                                                                                                                                            
{29488, 7562},                                                                                                                                            
{28818, 8292},                                                                                                                                            
{27543, 9533},                                                                                                                                            
{26904, 10163},                                                                                                                                           
{26194, 11111},                                                                                                                                           
{25294, 12296},                                                                                                                                           
{24784, 13146},                                                                                                                                           
{24354, 14046},                                                                                                                                           
{24180, 14616},                                                                                                                                           
{23660, 17138},                                                                                                                                           
{23090, 18518},                                                                                                                                           
{21683, 20051},                                                                                                                                           
{20483, 20936},                                                                                                                                           
{19163, 21622},                                                                                                                                           
{17935, 22009},                                                                                                                                           
{16588, 22330},                                                                                                                                           
{14006, 22304},                                                                                                                                           
{11678, 21800},                                                                                                                                           
{10283, 21275},                                                                                                                                           
{9415, 20784},                                                                                                                                            
{8758, 20172},                                                                                                                                            
{8230, 19572},                                                                                                                                            
{7900, 19068},                                                                                                                                            
{7564, 18340},                                                                                                                                            
{7228, 17612},                                                                                                                                            
{6920, 16556},                                                                                                                                            
{6668, 15170},                                                                                                                                            
{6676, 14370},                                                                                                                                            
{6760, 12970},                                                                                                                                            
{7512, 8828},                                                                                                                                             
{7712, 8052},                                                                                                                                             
{8152, 7142},                                                                                                                                             
{8625, 6371},                                                                                                                                             
{10065, 4951},                                                                                                                                            
{10956, 4291},                                                                                                                                            
{11739, 3832},                                                                                                                                            
{12762, 3414},                                                                                                                                            
{14346, 3110},                                                                                                                                            
{18346, 2710},                                                                                                                                            
{19039, 2605},                                                                                                                                            
{19474, 2350},                                                                                                                                            
{19942, 1972},                                                                                                                                            
{20282, 1602},                                                                                                                                            
{20709, 1042},                                                                                                                                            
{21021, 298},                                                                                                                                             
{21231, -374},                                                                                                                                            
{21273, -1074},                                                                                                                                           
{21279, -1674},                                                                                                                                           
{21216, -2374},                                                                                                                                           
{21090, -3067},                                                                                                                                           
{20757, -3904},                                                                                                                                           
{20457, -4426},                                                                                                                                           
{19967, -4930},                                                                                                                                           
{19283, -5506},                                                                                                                                           
{18709, -5905},                                                                                                                                           
{17872, -6220},                                                                                                                                           
{17186, -6332},                                                                                                                                           
{16097, -6398},                                                                                                                                           
{15503, -6344},                                                                                                                                           
{14810, -6281},                                                                                                                                           
{13928, -6119},                                                                                                                                           
{13249, -5958},                                                                                                                                           
{12591, -5727},                                                                                                                                           
{11855, -5431},                                                                                                                                           
{11225, -5137},                                                                                                                                           
{10561, -4697},                                                                                                                                           
{9791, -4077},                                                                                                                                            
{9010, -3307},                                                                                                                                            
{8530, -2675},                                                                                                                                            
{7990, -1964},                                                                                                                                            
{7215, -467},                                                                                                                                             
{6276, 1623},                                                                                                                                             
{5460, 2983},                                                                                                                                             
{4740, 3931},                                                                                                                                             
{3211, 5619},                                                                                                                                             
{2175, 6543},                                                                                                                                             
{420, 8155},                                                                                                                                              
{-1089, 10118},                                                                                                                                           
{-1606, 11075},                                                                                                                                           
{-2646, 15507},                                                                                                                                           
{-3706, 19514},                                                                                                                                           
{-5066, 21453},                                                                                                                                           
{-6286, 22600},                                                                                                                                           
{-8170, 23489},                                                                                                                                           
{-10645, 24242},                                                                                                                                          
{-12709, 24528},                                                                                                                                          
{-14764, 24178},                                                                                                                                          
{-15781, 23780},                                                                                                                                          
{-16971, 23052},                                                                                                                                          
{-17702, 22378},                                                                                                                                          
{-18778, 21193},                                                                                                                                          
{-19395, 20410},                                                                                                                                          
{-20386, 18669},                                                                                                                                          
{-20750, 18192},                                                                                                                                          
{-21612, 17220},                                                                                                                                          
{-22871, 16023}

};
*/
/*
//start // outer tunnel
PAIR_2D	AI_test_map_a[145] = {

	{7189, 9190},                                                                                                                                             
	{7577, 9090},                                                                                                                                             
	{8317, 8410},                                                                                                                                             
	{9261, 6752},                                                                                                                                             
	{10445, 5664},                                                                                                                                            
	{11694, 5026},                                                                                                                                            
	{12194, 5071},                                                                                                                                            
	{12831, 5365},                                                                                                                                            
	{13327, 6230},                                                                                                                                            
	{13436, 7515},                                                                                                                                            
	{13172, 8267},                                                                                                                                            
	{12356, 9627},                                                                                                                                            
	{10403, 12014},                                                                                                                                           
	{9983, 12914},                                                                                                                                            
	{9563, 15147},                                                                                                                                            
	{8923, 16135},                                                                                                                                            
	{8158, 16594},                                                                                                                                            
	{6320, 16947},                                                                                                                                            
	{5622, 16849},                                                                                                                                            
	{3938, 15990},                                                                                                                                            
	{3259, 15822},                                                                                                                                            
	{2962, 15837},                                                                                                                                            
	{2128, 16162},                                                                                                                                            
	{544, 17008},                                                                                                                                             
	{-396, 17338},                                                                                                                                            
	{-1180, 17450},                                                                                                                                           
	{-2764, 17390},                                                                                                                                           
	{-4316, 17006},                                                                                                                                           
	{-6612, 16039},                                                                                                                                           
	{-7412, 15439},                                                                                                                                           
	{-8267, 15178},                                                                                                                                           
	{-10825, 12946},                                                                                                                                          
	{-12113, 12006},                                                                                                                                          
	{-13723, 10373},                                                                                                                                          
	{-15538, 7634},                                                                                                                                           
	{-16527, 5541},                                                                                                                                           
	{-17136, 3525},                                                                                                                                           
	{-17516, 1545},                                                                                                                                           
	{-18568, -1705},                                                                                                                                          
	{-18196, -1861},                                                                                                                                          
	{-17476, -1322},                                                                                                                                          
	{-16804, -338},                                                                                                                                           
	{-16594, 327},                                                                                                                                            
	{-16110, 1317},                                                                                                                                           
	{-15590, 2167},                                                                                                                                           
	{-14915, 2761},                                                                                                                                           
	{-14147, 2521},                                                                                                                                           
	{-13347, 2513},                                                                                                                                           
	{-12579, 2737},                                                                                                                                           
	{-11443, 3857},                                                                                                                                           
	{-10715, 4193},                                                                                                                                           
	{-10271, 3785},                                                                                                                                           
	{-9970, 3148},                                                                                                                                            
	{-10092, 1857},                                                                                                                                           
	{-10700, 369},                                                                                                                                            
	{-10988, -795},                                                                                                                                           
	{-10903, -2495},                                                                                                                                          
	{-10645, -3038},                                                                                                                                          
	{-10318, -4918},                                                                                                                                          
	{-9896, -5604},                                                                                                                                           
	{-9751, -6084},                                                                                                                                           
	{-9407, -6812},                                                                                                                                           
	{-9302, -7505},                                                                                                                                           
	{-9036, -8156},                                                                                                                                           
	{-9011, -11256},                                                                                                                                          
	{-9705, -12192},                                                                                                                                          
	{-9876, -13083},                                                                                                                                          
	{-9864, -13774},                                                                                                                                          
	{-9600, -14852},                                                                                                                                          
	{-9319, -15916},                                                                                                                                          
	{-9219, -16916},                                                                                                                                          
	{-8771, -17588},                                                                                                                                          
	{-8771, -18288},                                                                                                                                          
	{-7636, -19696},                                                                                                                                          
	{-6855, -20477},                                                                                                                                          
	{-6357, -20813},                                                                                                                                          
	{-5427, -21203},                                                                                                                                          
	{-3843, -21523},                                                                                                                                          
	{-1843, -21343},                                                                                                                                          
	{-79, -20929},                                                                                                                                            
	{812, -20280},                                                                                                                                            
	{2412, -18355},                                                                                                                                           
	{3532, -16715},                                                                                                                                           
	{4108, -15659},                                                                                                                                           
	{4139, -13090},                                                                                                                                           
	{3767, -11440},                                                                                                                                           
	{3669, -10754},                                                                                                                                           
	{4509, -10204},                                                                                                                                           
	{5209, -10211},                                                                                                                                           
	{6067, -10915},                                                                                                                                           
	{6835, -11851},                                                                                                                                           
	{7240, -12151},                                                                                                                                           
	{8124, -13613},                                                                                                                                           
	{9226, -13770},                                                                                                                                           
	{10186, -14070},                                                                                                                                          
	{10888, -14646},                                                                                                                                          
	{12134, -15318},                                                                                                                                          
	{13880, -15768},                                                                                                                                          
	{14550, -16518},                                                                                                                                          
	{14032, -16987},                                                                                                                                          
	{13042, -17087},                                                                                                                                          
	{12952, -17987},                                                                                                                                          
	{17803, -18722},                                                                                                                                          
	{19303, -18587},                                                                                                                                          
	{20538, -18158},                                                                                                                                          
	{21288, -17498},                                                                                                                                          
	{21684, -16688},                                                                                                                                          
	{21783, -15797},                                                                                                                                          
	{22751, -13817},                                                                                                                                          
	{22163, -13703},                                                                                                                                          
	{21465, -14101},                                                                                                                                          
	{20337, -14509},                                                                                                                                          
	{19842, -14459},                                                                                                                                          
	{19417, -14204},                                                                                                                                          
	{19668, -13345},                                                                                                                                          
	{19598, -12855},                                                                                                                                          
	{19234, -11620},                                                                                                                                          
	{19777, -9811},                                                                                                                                           
	{20506, -9280},                                                                                                                                           
	{21397, -9154},                                                                                                                                           
	{22654, -9363},                                                                                                                                           
	{21763, -6825},                                                                                                                                           
	{21055, -5865},                                                                                                                                           
	{20618, -4022},                                                                                                                                           
	{20204, -3230},                                                                                                                                           
	{19817, 1027},                                                                                                                                            
	{19608, 2105},                                                                                                                                            
	{18481, 3352},                                                                                                                                            
	{18321, 3470},                                                                                                                                            
	{17628, 3540},                                                                                                                                            
	{16844, 3380},                                                                                                                                            
	{14567, 3150},                                                                                                                                            
	{12785, 3060},                                                                                                                                            
	{10034, 2575},                                                                                                                                            
	{7333, 2041},                                                                                                                                             
	{6689, 2307},                                                                                                                                             
	{5357, 3340},                                                                                                                                             
	{4649, 4300},                                                                                                                                             
	{4316, 5128},                                                                                                                                             
	{4162, 6206},                                                                                                                                             
	{4402, 7382},                                                                                                                                             
	{4882, 8022},                                                                                                                                             
	{5494, 8536},                                                                                                                                             
	{6630, 9280},                                                                                                                                             
	{7224, 9190}                                                                                                                                             
};

		//145 // inner tunnel
PAIR_2D	AI_test_map_b[25] = {

	{7230, 10547},                                                                                                                                            
	{8130, 10448},                                                                                                                                            
	{8868, 9720},                                                                                                                                             
	{9434, 9025},                                                                                                                                             
	{10038, 7759},                                                                                                                                            
	{10518, 7111},                                                                                                                                            
	{11182, 6663},                                                                                                                                            
	{11740, 6429},                                                                                                                                            
	{11957, 6340},                                                                                                                                            
	{12157, 7036},                                                                                                                                            
	{12073, 7624},                                                                                                                                            
	{11414, 8847},                                                                                                                                            
	{10501, 10023},                                                                                                                                           
	{9775, 10837},                                                                                                                                            
	{9112, 11942},                                                                                                                                            
	{8818, 12572},                                                                                                                                            
	{8433, 14819},                                                                                                                                            
	{8157, 15347},                                                                                                                                            
	{6420, 15737},                                                                                                                                            
	{5485, 15405},                                                                                                                                            
	{5995, 14559},                                                                                                                                            
	{6571, 13857},                                                                                                                                            
	{7259, 13441},                                                                                                                                            
	{7802, 12724},                                                                                                                                            
	{7299, 10571}                                                                                                                                            
};
*/
/*		//170	flyover - one side
PAIR_2D	AI_test_map_c[28] = {

	{-3151, -5377},                                                                                                                                           
	{-4933, -3379},                                                                                                                                           
	{-6396, -2182},                                                                                                                                           
	{-7098, -1639},                                                                                                                                           
	{-7828, -969},                                                                                                                                            
	{-8458, -339},                                                                                                                                            
	{-8656, 225},                                                                                                                                             
	{-8633, 2525},                                                                                                                                            
	{-8717, 3113},                                                                                                                                            
	{-8878, 3792},                                                                                                                                            
	{-8198, 4522},                                                                                                                                            
	{-7938, 4947},                                                                                                                                            
	{-7709, 5597},                                                                                                                                            
	{-6809, 5543},                                                                                                                                            
	{-5621, 5303},                                                                                                                                            
	{-4984, 4995},                                                                                                                                            
	{-3937, 4402},                                                                                                                                            
	{-3209, 4050},                                                                                                                                            
	{-2239, 3800},                                                                                                                                            
	{-1357, 3617},                                                                                                                                            
	{-457, 3518},                                                                                                                                             
	{167, 3006},                                                                                                                                              
	{122, 2106},                                                                                                                                              
	{202, 1306},                                                                                                                                              
	{467, 653},                                                                                                                                               
	{763, -519},                                                                                                                                              
	{-2898, -5156},                                                                                                                                           
	{-3120, -5357}                                                                                                                                           
};

		//flyover other side
PAIR_2D	AI_test_map_d[68] = {

	{-467, -5479},                                                                                                                                            
	{2301, -2059},                                                                                                                                            
	{2791, -1417},                                                                                                                                            
	{3591, -1355},                                                                                                                                            
	{3959, -903},                                                                                                                                             
	{3775, -128},                                                                                                                                             
	{1941, 1398},                                                                                                                                             
	{1757, 1750},                                                                                                                                             
	{1851, 2738},                                                                                                                                             
	{2463, 3395},                                                                                                                                             
	{3063, 3419},                                                                                                                                             
	{3756, 3279},                                                                                                                                             
	{4176, 2712},                                                                                                                                             
	{5814, 1368},                                                                                                                                             
	{6416, 1004},                                                                                                                                             
	{6812, 924},                                                                                                                                              
	{7610, 848},                                                                                                                                              
	{8110, 893},                                                                                                                                              
	{9099, 1043},                                                                                                                                             
	{11931, 1711},                                                                                                                                            
	{12822, 1051},                                                                                                                                            
	{13212, 731},                                                                                                                                             
	{14083, -244},                                                                                                                                            
	{14553, -894},                                                                                                                                            
	{14690, -1193},                                                                                                                                           
	{14690, -1893},                                                                                                                                           
	{15090, -1857},                                                                                                                                           
	{15876, -1941},                                                                                                                                           
	{16644, -2877},                                                                                                                                           
	{17022, -4647},                                                                                                                                           
	{16636, -5995},                                                                                                                                           
	{16586, -6995},                                                                                                                                           
	{16466, -8195},                                                                                                                                           
	{15962, -8819},                                                                                                                                           
	{15392, -8993},                                                                                                                                           
	{15272, -10193},                                                                                                                                          
	{14609, -11311},                                                                                                                                          
	{13538, -12637},                                                                                                                                          
	{11954, -12797},                                                                                                                                          
	{10974, -12657},                                                                                                                                          
	{9952, -11719},                                                                                                                                           
	{9385, -11026},                                                                                                                                           
	{8591, -10048},                                                                                                                                           
	{7934, -9445},                                                                                                                                            
	{7161, -8819},                                                                                                                                            
	{6751, -8544},                                                                                                                                            
	{6157, -7878},                                                                                                                                            
	{5618, -7437},                                                                                                                                            
	{5123, -7412},                                                                                                                                            
	{4143, -7544},                                                                                                                                            
	{3549, -7514},                                                                                                                                            
	{2813, -7818},                                                                                                                                            
	{2355, -8198},                                                                                                                                            
	{1838, -9177},                                                                                                                                            
	{1556, -9711},                                                                                                                                            
	{1292, -10778},                                                                                                                                           
	{599, -11636},                                                                                                                                            
	{-247, -11942},                                                                                                                                           
	{-841, -12002},                                                                                                                                           
	{-1881, -11235},                                                                                                                                          
	{-2321, -10571},                                                                                                                                          
	{-2353, -9779},                                                                                                                                           
	{-2263, -9191},                                                                                                                                           
	{-2253, -8191},                                                                                                                                           
	{-2367, -7603},                                                                                                                                           
	{-2235, -7333},                                                                                                                                           
	{-1830, -7038},                                                                                                                                           
	{-450, -5463}                                                                                                                                            
};
		//volcano
PAIR_2D	AI_test_map_e[26] = {

	{-3663, -15540},                                                                                                                                          
	{-3651, -14340},                                                                                                                                          
	{-3782, -13458},                                                                                                                                          
	{-3877, -12968},                                                                                                                                          
	{-4285, -12288},                                                                                                                                          
	{-5050, -11829},                                                                                                                                          
	{-5614, -11631},                                                                                                                                          
	{-6802, -11751},                                                                                                                                          
	{-7594, -11671},                                                                                                                                          
	{-8514, -12051},                                                                                                                                          
	{-9163, -12942},                                                                                                                                          
	{-9198, -13642},                                                                                                                                          
	{-8822, -14354},                                                                                                                                          
	{-8822, -16054},                                                                                                                                          
	{-8622, -17044},                                                                                                                                          
	{-8086, -17644},                                                                                                                                          
	{-7814, -18404},                                                                                                                                          
	{-6941, -18629},                                                                                                                                          
	{-6341, -18605},                                                                                                                                          
	{-5549, -18725},                                                                                                                                          
	{-5054, -18655},                                                                                                                                          
	{-4417, -18361},                                                                                                                                          
	{-3849, -17801},                                                                                                                                          
	{-3499, -16457},                                                                                                                                          
	{-3651, -15673},                                                                                                                                          
	{-3679, -15477}                                                                                                                                          
};
		//ship volcano
PAIR_2D	AI_test_map_f[12] = {

	{-8147, -6571},                                                                                                                                           
	{-6747, -6655},                                                                                                                                           
	{-6054, -6557},                                                                                                                                           
	{-5934, -5969},                                                                                                                                           
	{-5844, -4484},                                                                                                                                           
	{-6201, -3889},                                                                                                                                           
	{-7785, -3899},                                                                                                                                           
	{-8471, -3801},                                                                                                                                           
	{-9247, -3993},                                                                                                                                           
	{-9418, -4884},                                                                                                                                           
	{-9238, -5775},                                                                                                                                           
	{-8114, -6575}                                                                                                                                           
};
*/		//divit island

PAIR_2D	AI_test_map_g[24] = {

	{-2084, 5943},                                                                                                                                            
	{-203, 5658},                                                                                                                                             
	{97, 6810},                                                                                                                                               
	{793, 6732},                                                                                                                                              
	{913, 6242},                                                                                                                                              
	{917, 5564},                                                                                                                                              
	{1712, 5446},                                                                                                                                             
	{2793, 5588},                                                                                                                                             
	{2859, 6182},                                                                                                                                             
	{2864, 6682},                                                                                                                                             
	{3064, 7662},                                                                                                                                             
	{3688, 8806},                                                                                                                                             
	{2487, 10739},                                                                                                                                            
	{1591, 11166},                                                                                                                                            
	{-103, 9758},                                                                                                                                             
	{-755, 9141},                                                                                                                                             
	{-1217, 8757},                                                                                                                                            
	{-3123, 7900},                                                                                                                                            
	{-4071, 7598},                                                                                                                                            
	{-4169, 7583},                                                                                                                                            
	{-4079, 6788},                                                                                                                                            
	{-3284, 6361},                                                                                                                                            
	{-2144, 5953},                                                                                                                                            
	{-1944, 5931}                                                                                                                                            
};

		//mountains - 6 in total
PAIR_2D	AI_test_map_h[12] = {

	{-14413, 4123},                                                                                                                                           
	{-13837, 3943},                                                                                                                                           
	{-13249, 4081},                                                                                                                                           
	{-12737, 4697},                                                                                                                                           
	{-12233, 5435},                                                                                                                                           
	{-11945, 5963},                                                                                                                                           
	{-11927, 6260},                                                                                                                                           
	{-12226, 7521},                                                                                                                                           
	{-12716, 7446},                                                                                                                                           
	{-13302, 6407},                                                                                                                                           
	{-14340, 4979},                                                                                                                                           
	{-14340, 4079}                                                                                                                                           
};

PAIR_2D	AI_test_map_i[19] = {

	{-10392, 5697},                                                                                                                                           
	{-10175, 4827},                                                                                                                                           
	{-9745, 4567},                                                                                                                                            
	{-9073, 5007},                                                                                                                                            
	{-8849, 5335},                                                                                                                                            
	{-8769, 5727},                                                                                                                                            
	{-8754, 7227},                                                                                                                                            
	{-8782, 7920},                                                                                                                                            
	{-8877, 8410},                                                                                                                                            
	{-9255, 8872},                                                                                                                                            
	{-9675, 9292},                                                                                                                                            
	{-10071, 9736},                                                                                                                                           
	{-10391, 9972},                                                                                                                                           
	{-10646, 9542},                                                                                                                                           
	{-11022, 8830},                                                                                                                                           
	{-10761, 7966},                                                                                                                                           
	{-10565, 7186},                                                                                                                                           
	{-10385, 6295},                                                                                                                                           
	{-10393, 5602}                                                                                                                                           
};

PAIR_2D	AI_test_map_j[16] = {

	{-7425, 8957},                                                                                                                                            
	{-6655, 9163},                                                                                                                                            
	{-6073, 9313},                                                                                                                                            
	{-5281, 9435},                                                                                                                                            
	{-4917, 9603},                                                                                                                                            
	{-3780, 9984},                                                                                                                                            
	{-4180, 10990},                                                                                                                                           
	{-4474, 11620},                                                                                                                                           
	{-4810, 12340},                                                                                                                                           
	{-5604, 11921},                                                                                                                                           
	{-6156, 11693},                                                                                                                                           
	{-6606, 11478},                                                                                                                                           
	{-7209, 10812},                                                                                                                                           
	{-7946, 9998},                                                                                                                                            
	{-7421, 9025},                                                                                                                                            
	{-7328, 8986}                                                                                                                                            
};

PAIR_2D	AI_test_map_k[10] = {

	{-3774, 12793},                                                                                                                                           
	{-2824, 10468},                                                                                                                                           
	{-1903, 11066},                                                                                                                                           
	{-1003, 11858},                                                                                                                                           
	{167, 12803},                                                                                                                                             
	{-1363, 13534},                                                                                                                                           
	{-1863, 13534},                                                                                                                                           
	{-2457, 13474},                                                                                                                                           
	{-3009, 13246},                                                                                                                                           
	{-3749, 12772}                                                                                                                                           
};

PAIR_2D	AI_test_map_l[12] = {

	{3351, 14638},                                                                                                                                            
	{4527, 14914},                                                                                                                                            
	{5151, 13882},                                                                                                                                            
	{5151, 13682},                                                                                                                                            
	{5535, 13214},                                                                                                                                            
	{5133, 12770},                                                                                                                                            
	{4673, 12580},                                                                                                                                            
	{4008, 12377},                                                                                                                                            
	{3198, 12764},                                                                                                                                            
	{3178, 13259},                                                                                                                                            
	{3375, 14540},                                                                                                                                            
	{3395, 14638}                                                                                                                                            
};

PAIR_2D	AI_test_map_m[8] = {

	{4409, 11852},                                                                                                                                            
	{4107, 10894},                                                                                                                                            
	{4891, 9718},                                                                                                                                             
	{6197, 10505},                                                                                                                                            
	{6797, 11864},                                                                                                                                            
	{6120, 12720},                                                                                                                                            
	{5512, 12208},                                                                                                                                            
	{4396, 11798}                                                                                                                                            
};

PAIR_2D	AI_test_map_n[6] = {

	{17862, 530},                                                                                                                                             
	{17822, 1520},                                                                                                                                            
	{17129, 1485},                                                                                                                                            
	{17174, 585},                                                                                                                                             
	{17766, 541},                                                                                                                                             
	{17866, 540}                                                                                                                                             
};


//START OF LAVA 1 TRACK
/*
PAIR_2D AI_test_map_a[63] = {

	{510, -10428},
	{1137, -11319},                                                                                                                                           
	{889, -14388},                                                                                                                                            
	{1394, -16324},                                                                                                                                           
	{3201, -18794},                                                                                                                                           
	{3495, -20152},                                                                                                                                           
	{3144, -21400},                                                                                                                                           
	{2394, -22705},                                                                                                                                           
	{-1777, -23823},                                                                                                                                          
	{-3909, -25305},                                                                                                                                          
	{-4989, -25833},                                                                                                                                          
	{-5989, -25903},                                                                                                                                          
	{-7056, -25606},                                                                                                                                          
	{-8872, -23878},                                                                                                                                          
	{-10280, -23078},                                                                                                                                         
	{-11580, -23039},                                                                                                                                         
	{-14524, -24319},                                                                                                                                         
	{-16324, -24265},                                                                                                                                         
	{-17076, -23977},                                                                                                                                         
	{-17650, -23571},                                                                                                                                         
	{-17754, -22271},                                                                                                                                         
	{-17382, -17014},                                                                                                                                         
	{-15789, -13880},                                                                                                                                         
	{-15369, -11920},                                                                                                                                         
	{-13997, -9456},                                                                                                                                          
	{-13421, -4656},                                                                                                                                          
	{-14771, -2280},                                                                                                                                          
	{-16220, -747},                                                                                                                                           
	{-19841, 3514},                                                                                                                                           
	{-20456, 4894},                                                                                                                                           
	{-21591, 7571},                                                                                                                                           
	{-21825, 9371},                                                                                                                                           
	{-21090, 10691},                                                                                                                                          
	{-20298, 11450},                                                                                                                                          
	{-18717, 12062},                                                                                                                                          
	{-15735, 13178},                                                                                                                                          
	{-14583, 14282},                                                                                                                                          
	{-14167, 15834},                                                                                                                                          
	{-14232, 18334},                                                                                                                                          
	{-13378, 19440},                                                                                                                                          
	{-12508, 19940},                                                                                                                                          
	{-10726, 19904},                                                                                                                                          
	{-7942, 18336},                                                                                                                                           
	{-6574, 17044},                                                                                                                                           
	{-5150, 16340},                                                                                                                                           
	{-2222, 15784},                                                                                                                                           
	{-290, 14565},                                                                                                                                            
	{1778, 14421},                                                                                                                                            
	{2562, 13029},                                                                                                                                            
	{2885, 11167},                                                                                                                                            
	{1008, 10223},                                                                                                                                            
	{-233, 9067},                                                                                                                                             
	{-953, 7643},                                                                                                                                             
	{-992, 6356},                                                                                                                                             
	{309, 3254},                                                                                                                                              
	{267, 1868},                                                                                                                                              
	{-498, 355},                                                                                                                                              
	{-2478, -613},                                                                                                                                            
	{-3513, -1693},                                                                                                                                           
	{-3997, -3827},                                                                                                                                           
	{-3359, -6089},                                                                                                                                           
	{-1174, -8498},                                                                                                                                           
	{729, -10750}                                                                                                                                            

};                                                                                                                                            

PAIR_2D AI_test_map_b[89] = {

//	{2511, -9529},                                                                                                                                            
	{-1521, -5721},                                                                                                                                           
	{-2241, -4083},                                                                                                                                           
	{-2208, -2994},                                                                                                                                           
	{-1858, -2385},                                                                                                                                           
	{344, -1165},                                                                                                                                             
	{1074, -485},                                                                                                                                             
	{1929, 1206},                                                                                                                                             
	{2171, 2579},                                                                                                                                             
	{2027, 3767},                                                                                                                                             
	{1572, 4976},                                                                                                                                             
	{625, 6948},                                                                                                                                              
	{751, 7634},                                                                                                                                              
	{2065, 8858},                                                                                                                                             
	{3209, 9495},                                                                                                                                             
	{5109, 10115},                                                                                                                                            
	{8772, 10744},                                                                                                                                            
	{11472, 10798},                                                                                                                                           
	{14572, 10395},                                                                                                                                           
	{16052, 10915},                                                                                                                                           
	{17667, 11922},                                                                                                                                           
	{19567, 13547},                                                                                                                                           
	{20643, 14723},                                                                                                                                           
	{22321, 17075},                                                                                                                                           
	{23756, 20260},                                                                                                                                           
	{24149, 22007},                                                                                                                                           
	{23915, 24165},                                                                                                                                           
	{23425, 25467},                                                                                                                                           
	{22473, 26475},                                                                                                                                           
	{20562, 27529},                                                                                                                                           
	{19506, 27815},                                                                                                                                           
	{16536, 27835},                                                                                                                                           
	{13622, 26843},                                                                                                                                           
	{10262, 25078},                                                                                                                                           
	{6789, 23322},                                                                                                                                            
	{4632, 21550},                                                                                                                                            
	{3494, 19659},                                                                                                                                            
	{2136, 17088},                                                                                                                                            
	{1724, 16654},                                                                                                                                            
	{794, 16294},                                                                                                                                             
	{-1068, 16617},                                                                                                                                           
	{-2868, 17847},                                                                                                                                           
	{-4650, 18063},                                                                                                                                           
	{-5346, 18455},                                                                                                                                           
	{-8310, 21078},                                                                                                                                           
	{-9357, 21820},                                                                                                                                           
	{-11359, 22700},                                                                                                                                          
	{-12943, 22812},                                                                                                                                          
	{-13903, 22542},                                                                                                                                          
	{-15442, 21440},                                                                                                                                          
	{-16126, 20456},                                                                                                                                          
	{-16591, 19031},                                                                                                                                          
	{-16426, 17304},                                                                                                                                          
	{-16115, 15830},                                                                                                                                          
	{-16527, 15370},                                                                                                                                          
	{-18123, 14344},                                                                                                                                          
	{-21084, 13465},                                                                                                                                          
	{-21885, 13060},                                                                                                                                          
	{-23601, 11696},                                                                                                                                          
	{-24305, 10256},                                                                                                                                          
	{-24545, 8256},                                                                                                                                           
	{-23538, 5523},                                                                                                                                           
	{-22350, 3653},                                                                                                                                           
	{-19668, 797},                                                                                                                                            
	{-17188, -2363},                                                                                                                                          
	{-15144, -4295},                                                                                                                                          
	{-15522, -8177},                                                                                                                                          
	{-16814, -10550},                                                                                                                                         
	{-18662, -14556},                                                                                                                                         
	{-19123, -17739},                                                                                                                                         
	{-19411, -23639},                                                                                                                                         
	{-18796, -25019},                                                                                                                                         
	{-17690, -25887},                                                                                                                                         
	{-15422, -26337},                                                                                                                                         
	{-12822, -26220},                                                                                                                                         
	{-11017, -25631},                                                                                                                                         
	{-8393, -27487},                                                                                                                                          
	{-7493, -27937},                                                                                                                                          
	{-5493, -28197},                                                                                                                                          
	{-3349, -27675},                                                                                                                                          
	{-1257, -25819},                                                                                                                                          
	{-492, -25342},                                                                                                                                           
	{2710, -24545},                                                                                                                                           
	{4448, -23203},                                                                                                                                           
	{5342, -19738},                                                                                                                                           
	{4585, -17633},                                                                                                                                           
	{3313, -15617},                                                                                                                                           
	{3040, -14356},                                                                                                                                           
	{3391, -11683},                                                                                                                                           
	{2479, -9502}                                                                                                                                            

};

PAIR_2D AI_test_map_c[25] = {

	{4320, 11166},                                                                                                                                            
	{3549, 14455},                                                                                                                                            
	{3627, 15049},                                                                                                                                            
	{4379, 16461},                                                                                                                                            
	{4863, 18595},                                                                                                                                            
	{5997, 20359},                                                                                                                                            
	{7822, 22059},                                                                                                                                            
	{10700, 23856},                                                                                                                                           
	{13184, 24936},                                                                                                                                           
	{17161, 26002},                                                                                                                                           
	{19443, 25734},                                                                                                                                           
	{20673, 24864},                                                                                                                                           
	{21429, 23674},                                                                                                                                           
	{21541, 22274},                                                                                                                                           
	{21373, 19874},                                                                                                                                           
	{20723, 17872},                                                                                                                                           
	{18972, 15318},                                                                                                                                           
	{17068, 13274},                                                                                                                                           
	{16093, 12416},                                                                                                                                           
	{14936, 11831},                                                                                                                                           
	{13649, 11727},                                                                                                                                           
	{10283, 12135},                                                                                                                                           
	{6917, 12033},                                                                                                                                            
	{5459, 11712},                                                                                                                                            
	{4307, 11388}                                                                                                                                            

};

//END OF LAVA 1 TRACK

*/