#if N64
#include <ultra64.h>
#include <sched.h>
#endif

#if PSX
#include "CTRLLER.h"
#endif

#include	"header.h"
#include "render.h"
#include	"objects.h"
#include "sim.h"
#include "gameloop.h"
#include "mesh.h"
#include "state.h"

#if PSX
   #include "psx\mathPSX.h"
   #include "sdlib\sdtypes.h"
   #include "psx\TEXTpsx.h"
#endif

#if N64
   #include "n64\mathn64.h"
   #include "n64\n64_libs.h"
   #include "n64core\control.h"
#endif

#include	"collide.h"

///////////////////////////////////////////////////////////////////////////////////////////////
//		Camera control routines.
///////////////////////////////////////////////////////////////////////////////////////////////
//		Started:		19/5/2098bc
//		Geeza:		J.coelho
//    Notes:      Confine cam. PSX o.k.     N64 fucked
///////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Globals                                                                    //
////////////////////////////////////////////////////////////////////////////////

//Ians Test vars and cam flag for roaming
s32      handycam = FALSE;
s32      missile_cam = FALSE;//TRUE;
s32      fx_allowed = TRUE;

extern APAD SD_PadData[8];
s32	     camera_craft_num = 0;


u8       CAM_c;//current camera

mat16    CAM_camm[4];            // cam  I rot mat s32
vec32    CAM_camp[4]=   { {0,0,0},{0,0,0},{0,0,0},{0,0,0} };    // cam  position  s16.16
vec32    CAM_campo[4]=  { {0,0,0},{0,0,0},{0,0,0},{0,0,0} };    // cam  oldposition  s16.16
vec32    CAM_came[4]=   {800,0,0};  // cam  rotation  s16.16
vec32    CAM_camc[4];            // cam  foc point
//s32      CAM_camseg;
s32      CAM_cammode[4]={0,0,0,0};
s32      CAM_obj[4]={0,1,2,3};

////////////////////////////////////////////////////////////////////////////////
// Private                                                                    //
////////////////////////////////////////////////////////////////////////////////

s32   dcamrx[4]   =  {800,800,800,800};
vec32 camoff[4]={{0,0,0},{0,0,0},{0,0,0},{0,0,0}};
s32   dfoc[4]={512,512,512,512};
void  CAM_pancam();

////////////////////////////////////////////////////////////////////////////////
// Functions                                                                  //
////////////////////////////////////////////////////////////////////////////////
void  CAMERA_camerao()
   {
   s16   x,y,z;
   vec32 doff;
   vec16 v;
   vec16 sv;
   mat16    m;
   vec16 dcamp;
   vec16 dcame;

   CAM_came[0].vx =0 ;
   CAM_came[0].vy =  -vatan2( (OBJ_objects[0].p.vx>>8) - CAM_camp[0].vx ,
                              (OBJ_objects[0].p.vz>>8) - CAM_camp[0].vz )<<4;
   CAM_came[0].vz =0 ;

//   sv.vx =0;
//   sv.vy =CAM_came[0].vy>>4;
//   sv.vz =0;
//   vrotmatrix( &sv, &m );

//   vequ( &doff, 0, -125, -0x130 );
//   vapplymatrix32( &m, &doff, &doff );// v=offset

//   //GPU_line(0,0,doff.vx, doff.vz);

//   equ( dcamp, OBJ_objects[0].p.vx>>8, OBJ_objects[0].p.vy>>8, OBJ_objects[0].p.vz>>8 );
//   add( dcamp, doff );

//   //dcame.vx =  0;
//   //dcame.vy =  -OBJ_objects[ CAM_obj[CAM_c] ].r.vy;
//   //dcame.vz =  0;

//   mov( v, dcamp );
//   sub( v, CAM_camp[0] );
//   shr( v, 2 );

//   add( CAM_camp[0], v );


   //mov( CAM_came[0], dcame );

   equ( v, OBJ_objects[0].p.vx>>8, (OBJ_objects[0].p.vy>>8)-125, OBJ_objects[0].p.vz>>8 );
   sub( v, CAM_camp[0] );
   shr( v, 2 );
   add( CAM_camp[0], v );
   }

void  CAMERA_camera()
	{
	int		temp_camera, pad_data;
	u8 		text[11];
   vec16    CAM_cameo;
   //GsSetProjection(200); // Set projection

pad_data = 0;
   mov( CAM_cameo, CAM_came[0] );
   CAM_campo[CAM_c].vx =  CAM_camp[CAM_c].vx;
   CAM_campo[CAM_c].vy =  CAM_camp[CAM_c].vy;
   CAM_campo[CAM_c].vz =  CAM_camp[CAM_c].vz;

//	camera_craft_num = 0;
#if IAN

	if (STATE.numscreens == 1)
	{
	    if (SD_PadData[4].push & PAD_LD)
	    {
	        camera_craft_num ++;

			if (camera_craft_num ==  STATE.wankers)
				camera_craft_num = MAXNUMOBJS - 1;

			if (camera_craft_num == MAXNUMOBJS)
				camera_craft_num = 0;

//	        missile_cam = !missile_cam;
	    }
	}
	else
		missile_cam = FALSE;
#else
		missile_cam = FALSE;
#endif
/*
	if (STATE.numscreens == 1)
	{

		sprintf(text, "Player: %d",camera_craft_num);
//		sprintf(text, "Player: 0");

		TEXT_x = 150;
		TEXT_y = -115;
		TEXT_prstr(text,255,64,64);

		sprintf(text, "Frags: %d",OBJ_players[camera_craft_num].frag_count);
//		sprintf(text, "Frags: %d",OBJ_players[0].frag_count);

		TEXT_x = 150;
		TEXT_y = -105;
		TEXT_prstr(text,64,64,255);
	}
	else
	{
		//player 0
		sprintf(text, "Player: 0");

		TEXT_x = 150;
		TEXT_y = -60;
		TEXT_prstr(text,255,64,64);

		sprintf(text, "Frags: %d",OBJ_players[0].frag_count);

		TEXT_x = 150;
		TEXT_y = -50;
		TEXT_prstr(text,64,64,255);

		//player 1
		sprintf(text, "Player: 1");

		TEXT_x = 150;
		TEXT_y = -60;
		TEXT_prstr(text,255,64,64);

		sprintf(text, "Frags: %d",OBJ_players[1].frag_count);

		TEXT_x = 150;
		TEXT_y = -50;
		TEXT_prstr(text,64,64,255);
	}
*/
//need next section for AI map drawing

//	pad_data = SD_PadData[4].push;
/*
	if (handycam)
	{
		AI_draw_map_on_screen();

		if (pad_data & PAD_START)
		{
			handycam = 0;
			fx_allowed = 1;
			pad_data = 0;
		}

		if (pad_data & PAD_RL)
		{
			AI_place_point();

		}

		if (pad_data & PAD_RR)
		{
			AI_remove_point();

		}
	}
*/

	if (!handycam)
	{
		if (pad_data & PAD_START)
		{
			handycam = 1;
			pad_data = 0;

			CAM_camp[CAM_c].vy = -6000;
			CAM_came[CAM_c].vx = 1024 << 4;
		}
	}


//end of need next section for AI map drawing

	if (handycam)
	{
//        if (!(SD_PadData[4].data & PAD_LU))
//            CAM_came[CAM_c].vz -= 50;

//        if (!(SD_PadData[4].data & PAD_LD))
//            CAM_came[CAM_c].vz += 50;

        if (!(SD_PadData[4].data & PAD_LR))
            CAM_came[CAM_c].vy -= 512;

        if (!(SD_PadData[4].data & PAD_LL))
            CAM_came[CAM_c].vy += 512;

//        if (!(SD_PadData[4].data & PAD_LD))
//            CAM_came[CAM_c].vx -= 255;

//        if (!(SD_PadData[4].data & PAD_LU))
//            CAM_came[CAM_c].vx += 255;

        if (!(SD_PadData[4].data & PAD_FLT))
			CAM_camp[CAM_c].vy -= 50;

        if (!(SD_PadData[4].data & PAD_FRT))
			CAM_camp[CAM_c].vy += 50;

        if (!(SD_PadData[4].data & PAD_RU))
		{
//            CAM_camp[CAM_c].vy -= ((75 * rsin(CAM_came[CAM_c].vx >> 4)) >> 12);
            temp_camera = 100;//((75 * rcos(CAM_came[CAM_c].vx >> 4)) >> 12);

//			CAM_camp[CAM_c].vy = -750;
//			CAM_came[CAM_c].vx = 1024 << 4;

            CAM_camp[CAM_c].vx += ((temp_camera * rsin(CAM_came[CAM_c].vy >> 4)) >> 12);
            CAM_camp[CAM_c].vz -= ((temp_camera * rcos(CAM_came[CAM_c].vy >> 4)) >> 12);
		}

        if (!(SD_PadData[4].data & PAD_RD))
		{
//            CAM_camp[CAM_c].vy += ((75 * rsin(CAM_came[CAM_c].vx >> 4)) >> 12);
            temp_camera = 100;//((75 * rcos(CAM_came[CAM_c].vx >> 4)) >> 12);


//			CAM_camp[CAM_c].vy = -750;
//			CAM_came[CAM_c].vx = 1024 << 4;

            CAM_camp[CAM_c].vx -= ((temp_camera * rsin(CAM_came[CAM_c].vy >> 4)) >> 12);
            CAM_camp[CAM_c].vz += ((temp_camera * rcos(CAM_came[CAM_c].vy >> 4)) >> 12);
		}
 	}
    else
		{ // follow cam
      vec16    sv;
      vec32    v;
      mat16    m;
      vec32    c0, c1;
      s32      col;
      vec32    doff;
      s32      foc=512, a;

      //CAM_came[CAM_c].vz   = -OBJ_objects[ CAM_obj[CAM_c] ].r.vz;
//		if (missile_cam)
			CAM_obj[0] = camera_craft_num;//MAXNUMOBJS - 1;
//		else
//			CAM_obj[0] = 0;

//		if (missile_cam)
       		a  =  OBJ_objects[ CAM_obj[CAM_c] ].r.vy;// << 4;
//		else
//      		a  =  OBJ_objects[ CAM_obj[CAM_c] ].r.vy;
/*		if (missile_cam)
			CAM_obj[0] = 1;//MAXNUMOBJS - 1;
		else
			CAM_obj[0] = 0;

		if (missile_cam)
      		a  =  OBJ_objects[ CAM_obj[CAM_c] ].r.vy;// << 4;
		else
      		a  =  OBJ_objects[ CAM_obj[CAM_c] ].r.vy;
*/
      //a  =  vatan2( OBJ_objects[0].v.vx, OBJ_objects[0].v.vz )<<4;
      /*
      switch( OBJ_players[OBJ_objects[CAM_obj[CAM_c]].owner].mode360 )
         {
         case  -1:break;
         case   1:a+=16384;break;
         case   2:a+=32768;break;
         case   3:a+=49152;break;
         }
       */
      //CAM_came[CAM_c].vy -= vangdiff( CAM_came[CAM_c].vy, -a )>>1;
      CAM_came[CAM_c].vy -= vangdiff( CAM_came[CAM_c].vy, -a );

      //if(STATE.numscreens==1)
      if(1)
         {
         switch( CAM_cammode[CAM_c] )
            {
            case  0: vequ( &doff, 0, -160, -0x130 );
                     dcamrx[CAM_c]   =  800;
                     foc      =  512;
                     break;
            case  1: vequ( &doff, 0, -225, -0x275 );
                     dcamrx[CAM_c]  =  800;
                     foc      =  512;
                     break;
            case  2: vequ( &doff, 0,   -50,      -25 );
                     dcamrx[CAM_c]  = 0;
                     foc      =  512;
                     break;   //first person
            case  3: vequ( &doff, 0,-1600, -0x1000 );
                     dcamrx[CAM_c]  =  4000;
                     foc      =  512;
                     break;
            case  4: vequ( &doff, 0,-10000, 0 );	  //was (0, -10000, 0)
                     dcamrx[CAM_c]  =  16384;
                     foc      =  512;
                     break;
            case  5: vequ( &doff, 0,-80, -0x80 );
                     dcamrx[CAM_c]  =  800;
                     foc      =  512;
                     break;

            }
         }
      else
         {
         vequ( &doff, 0, -225, -0x375 );
         dcamrx[CAM_c]   =  1000;
         foc      =  512;
         }

      dfoc[CAM_c]  =  ((dfoc[CAM_c]<<4)-dfoc[CAM_c] +foc)>>4;
      //SD_ViewInit(0,0,0,0,0,0,dfoc); // camera at 0,0,0,looking at 0,0,0,lens 500

      CAM_came[CAM_c].vx =  ( (dcamrx[CAM_c]) + (CAM_came[CAM_c].vx<<4)-CAM_came[CAM_c].vx )>>4;
      camoff[CAM_c].vx =  ( (doff.vx) + (camoff[CAM_c].vx<<4)-camoff[CAM_c].vx )>>4;
      camoff[CAM_c].vy =  ( (doff.vy) + (camoff[CAM_c].vy<<4)-camoff[CAM_c].vy )>>4;
      camoff[CAM_c].vz =  ( (doff.vz) + (camoff[CAM_c].vz<<4)-camoff[CAM_c].vz )>>4;

      // change 0x10000=360 to 0x1000=360
      //CAM_came[0].vz=OBJ_objects[0].r.vz;
      sv.vx =0;
      sv.vy =(-CAM_came[CAM_c].vy)>>4;
      sv.vz =0;

      vrotmatrix( &sv, &m );
      vapplymatrix32( &m, &camoff[CAM_c], &v );// v=offset

      CAM_camc[CAM_c].vx =  ((CAM_camc[CAM_c].vx*106)>>8)  + (((OBJ_objects[CAM_obj[CAM_c]].p.vx>>8)*150)>>8);
      CAM_camc[CAM_c].vy =  ((CAM_camc[CAM_c].vy*106)>>8)  + (((OBJ_objects[CAM_obj[CAM_c]].p.vy>>8)*150)>>8);
      CAM_camc[CAM_c].vz =  ((CAM_camc[CAM_c].vz*106)>>8)  + (((OBJ_objects[CAM_obj[CAM_c]].p.vz>>8)*150)>>8);
      if( OBJ_players[OBJ_objects[CAM_obj[CAM_c]].owner].mode360 == 2)
         {
         CAM_camc[CAM_c].vx =   (OBJ_objects[CAM_obj[CAM_c]].p.vx>>8);
         CAM_camc[CAM_c].vy =   (OBJ_objects[CAM_obj[CAM_c]].p.vy>>8);
         CAM_camc[CAM_c].vz =   (OBJ_objects[CAM_obj[CAM_c]].p.vz>>8);
         }
      CAM_camp[CAM_c].vx =   v.vx +  CAM_camc[CAM_c].vx;
      CAM_camp[CAM_c].vy =   v.vy +  CAM_camc[CAM_c].vy;
      CAM_camp[CAM_c].vz =   v.vz +  CAM_camc[CAM_c].vz;

      // rightside
      {
      static   vec16 statasd={0,0,0};
      vec16 asd;

      equ( c0, -200,0,-100 );
      equ( c1, 400,-100,300 );

      sv.vx =0;
      sv.vy =(-CAM_came[CAM_c].vy)>>4;
      sv.vz =0;
      vrotmatrix( &sv, &m );
      vapplymatrix32( &m, &c0, &c0 );// v=offset
      vapplymatrix32( &m, &c1, &c1 );// v=offset

      //GPU_line( c0.vx>>3, c0.vz>>3, c1.vx>>3, c1.vz>>3 );

      add( c0, CAM_camp[CAM_c] );
      add( c1, CAM_camp[CAM_c] );

      col   =  COL_test2( &c0, &c1 );

      if(col>=0)
         {
         s32   d;
         //d  =  vqlen( COL_inter.vx-c1.vx, COL_inter.vy-c1.vy, COL_inter.vz-c1.vz  );
         //CAM_came[CAM_c].vx+=2*d;

         mov( asd, COL_inter );
         sub( asd, c1 );
         //TEXT_x = 0;
         //TEXT_y = 0;
         //TEXT_prstr("cam col r side", 128, 128, 128);
         }
      else
         {
         equ(asd, 0,0,0);
         }
      statasd.vx  =  (statasd.vx*15 + asd.vx)>>4;
      statasd.vy  =  (statasd.vy*15 + asd.vy)>>4;
      statasd.vz  =  (statasd.vz*15 + asd.vz)>>4;

         add( CAM_camp[CAM_c], statasd );
      }

      // left
      {
      static   vec16 statasd={0,0,0};
      vec16 asd;

      equ( c0, 200,0,-100 );
      equ( c1, -400,-100,300 );

      sv.vx =0;
      sv.vy =(-CAM_came[CAM_c].vy)>>4;
      sv.vz =0;
      vrotmatrix( &sv, &m );
      vapplymatrix32( &m, &c0, &c0 );// v=offset
      vapplymatrix32( &m, &c1, &c1 );// v=offset
      //GPU_line( c0.vx>>3, c0.vz>>3, c1.vx>>3, c1.vz>>3 );

      add( c0, CAM_camp[CAM_c] );
      add( c1, CAM_camp[CAM_c] );

      col   =  COL_test2( &c0, &c1 );

      if(col>=0)
         {
         s32   d;
         //d  =  vqlen( COL_inter.vx-c1.vx, COL_inter.vy-c1.vy, COL_inter.vz-c1.vz  );
         //CAM_came[CAM_c].vx+=2*d;

         mov( asd, COL_inter );
         sub( asd, c1 );
         //TEXT_x = 0;
         //TEXT_y = 0;
         //TEXT_prstr("cam col l side", 128, 128, 128);
         }
      else
         {
         equ(asd, 0,0,0);
         }
         statasd.vx  =  (statasd.vx*15 + asd.vx)>>4;
         statasd.vy  =  (statasd.vy*15 + asd.vy)>>4;
         statasd.vz  =  (statasd.vz*15 + asd.vz)>>4;

         add( CAM_camp[CAM_c], statasd );
      }

      // back
      {
      static   vec16 statasd={0,0,0};
      vec16 asd;

      equ( c0, 0,0,200 );
      equ( c1, 0,0,-200 );

      sv.vx =0;
      sv.vy =(-CAM_came[CAM_c].vy)>>4;
      sv.vz =0;
      vrotmatrix( &sv, &m );
      vapplymatrix32( &m, &c0, &c0 );// v=offset
      vapplymatrix32( &m, &c1, &c1 );// v=offset
      //GPU_line( c0.vx>>3, c0.vz>>3, c1.vx>>3, c1.vz>>3 );

      add( c0, CAM_camp[CAM_c] );
      add( c1, CAM_camp[CAM_c] );

      col   =  COL_test2( &c0, &c1 );

      if(col>=0)
         {
         s32   d;
         //d  =  vqlen( COL_inter.vx-c1.vx, COL_inter.vy-c1.vy, COL_inter.vz-c1.vz  );
         //CAM_came[CAM_c].vx+=2*d;

         mov( asd, COL_inter );
         sub( asd, c1 );
         //TEXT_x = 0;
         //TEXT_y = 0;
         //TEXT_prstr("cam col back", 128, 128, 128);
         }
      else
         {
         equ(asd, 0,0,0);
         }

      statasd.vx  =  (statasd.vx*15 + asd.vx)>>4;
      statasd.vy  =  (statasd.vy*15 + asd.vy)>>4;
      statasd.vz  =  (statasd.vz*15 + asd.vz)>>4;

      add( CAM_camp[CAM_c], statasd );
      }


      // demo mode!!!
      if( STATE.demomode || STATE.finishedLevel )
         {
         static democam =  0;
         switch( democam )
            {
            case  0:
               CAM_pancam();
               break;
            case  1:
               CAM_pancam();
               break;
            case  2:
               {
               s16   x,y,z;

               x  =  ( OBJ_objects[ 0 ].p.vx>>8 ) - CAM_camp[CAM_c].vx;
               y  =  ( OBJ_objects[ 0 ].p.vy>>8 ) - CAM_camp[CAM_c].vy;
               z  =  ( OBJ_objects[ 0 ].p.vz>>8 ) - CAM_camp[CAM_c].vz;

               equ( CAM_came[CAM_c], 0,0,0 );
               mov( CAM_camp[CAM_c], OBJ_objects[0].p );
               shr( CAM_camp[CAM_c], 8 );
               CAM_camp[CAM_c].vz -= 300;
               CAM_camp[CAM_c].vy -= 50;
               //CAM_camp[CAM_c].vy = 0;
               //CAM_came[CAM_c].vx =  vatan2( y, vroot32( x*x+z*z ) )<<4;
               CAM_came[CAM_c].vx =  400;
               }
               break;
            case  3:
               {
               s16   x,y,z;
               //RENDER_swirl();
               x  =  ( OBJ_objects[ 0 ].p.vx>>8 ) - CAM_camp[CAM_c].vx;
               y  =  ( OBJ_objects[ 0 ].p.vy>>8 ) - CAM_camp[CAM_c].vy;
               z  =  ( OBJ_objects[ 0 ].p.vz>>8 ) - CAM_camp[CAM_c].vz;

               equ( CAM_came[CAM_c], 0,0,0 );
               mov( CAM_camp[CAM_c], OBJ_objects[0].p );
               shr( CAM_camp[CAM_c], 8 );
               CAM_camp[CAM_c].vz -= 300;
               CAM_camp[CAM_c].vy -= 50;
               //CAM_camp[CAM_c].vy = 0;
               //CAM_came[CAM_c].vx =  vatan2( y, vroot32( x*x+z*z ) )<<4;
               CAM_came[CAM_c].vx =  400;
               }
               break;
            }

         // demo cam

         if((rand()&127)==1)
            democam  =  rand()%4;
         }
      // demo mode!!!

//      //test camline here
//      // rightside
//      {
//      equ( c0, -100,0,0 );
//      equ( c1, 400,0,0 );

//      sv.vx =0;
//      sv.vy =(-CAM_came[CAM_c].vy)>>4;
//      sv.vz =0;
//      vrotmatrix( &sv, &m );
//      vapplymatrix32( &m, &c0, &c0 );// v=offset
//      vapplymatrix32( &m, &c1, &c1 );// v=offset

//      add( c0, CAM_camp[CAM_c] );
//      add( c1, CAM_camp[CAM_c] );

//      col   =  COL_test2( &c0, &c1 );
//      GPU_3dline( &c0, &c1, 255,255,30);

//      if(col>=0)
//         {
//         s32   d;
//         d  =  vqlen( COL_inter.vx-c1.vx, COL_inter.vy-c1.vy, COL_inter.vz-c1.vz  );
//         CAM_came[CAM_c].vy-=d*20;

//         shr( COL_inter, 0);
//         shr( c1, 0);
//         add( CAM_camp[CAM_c], COL_inter );
//         sub( CAM_camp[CAM_c], c1 );

//         TEXT_x = 0;
//         TEXT_y = 0;
//         TEXT_prstr("cam col r side", 128, 128, 128);
//         }
//      }

//      {
//      equ( c0, 100,0,0 );
//      equ( c1, -400,0,0 );

//      sv.vx =0;
//      sv.vy =(-CAM_came[CAM_c].vy)>>4;
//      sv.vz =0;
//      vrotmatrix( &sv, &m );
//      vapplymatrix32( &m, &c0, &c0 );// v=offset
//      vapplymatrix32( &m, &c1, &c1 );// v=offset

//      add( c0, CAM_camp[CAM_c] );
//      add( c1, CAM_camp[CAM_c] );

//      col   =  COL_test2( &c0, &c1 );
//      GPU_3dline( &c0, &c1, 255,255,30);

//      if(col>=0)
//         {
//         s32   d;
//         d  =  vqlen( COL_inter.vx-c1.vx, COL_inter.vy-c1.vy, COL_inter.vz-c1.vz  );
//         CAM_came[CAM_c].vy+=d*20;

//         shr( COL_inter, 0);
//         shr( c1, 0);
//         add( CAM_camp[CAM_c], COL_inter );
//         sub( CAM_camp[CAM_c], c1 );

//         TEXT_x = 0;
//         TEXT_y = 0;
//         TEXT_prstr("cam col left side", 128, 128, 128);
//         }
//      }


//      {//back
//      equ( c0, 0,0,100 );
//      equ( c1, 0,0,-400 );

//      sv.vx =0;
//      sv.vy =(-CAM_came[CAM_c].vy)>>4;
//      sv.vz =0;
//      vrotmatrix( &sv, &m );
//      vapplymatrix32( &m, &c0, &c0 );// v=offset
//      vapplymatrix32( &m, &c1, &c1 );// v=offset

//      add( c0, CAM_camp[CAM_c] );
//      add( c1, CAM_camp[CAM_c] );

//      col   =  COL_test2( &c0, &c1 );

//      if(col>=0)
//         {
//         add( CAM_camp[CAM_c], COL_inter );
//         sub( CAM_camp[CAM_c], c1 );
//         TEXT_x = 0;
//         TEXT_y = 10;
//         TEXT_prstr("cam col z", 128, 128, 128);
//         }
//      }


      //col   =  COL_test2( &c0, &c1 );
      //if(col>=0)
      //   {
      //   CAM_camp[CAM_c].vx =  COL_inter.vx;
      //   CAM_camp[CAM_c].vy =  COL_inter.vy;
      //   CAM_camp[CAM_c].vz =  COL_inter.vz;
      //   }
		}

   if( CAM_cammode[CAM_c]==5 )
      CAM_pancam();
	}

mat16 CAM_yrotmat[64];

void  CAM_precalcmatricies()
   {
   u16   f;
   vec16 objrot;
   mat16 cammat, objmat;

//   vec16 camrot   =  { dcamrx>>4, 0, 0 };

   vec16 camrot;
   camrot.vx = dcamrx[CAM_c]>>4;
   camrot.vy = camrot.vz = 0;

   vrotmatrix( &camrot, &cammat );

   for(f=0;f<64;f++)
      {
      vequs( &objrot, 0, f<<6, 0 );
      vrotmatrix( &objrot, &objmat );
      vmulmatrix2( &cammat, &objmat );

      CAM_yrotmat[f].m[0][0]  =  objmat.m[0][0];
      CAM_yrotmat[f].m[0][1]  =  objmat.m[0][1];
      CAM_yrotmat[f].m[0][2]  =  objmat.m[0][2];

      CAM_yrotmat[f].m[1][0]  =  objmat.m[1][0];
      CAM_yrotmat[f].m[1][1]  =  objmat.m[1][1];
      CAM_yrotmat[f].m[1][2]  =  objmat.m[1][2];

      CAM_yrotmat[f].m[2][0]  =  objmat.m[2][0];
      CAM_yrotmat[f].m[2][1]  =  objmat.m[2][1];
      CAM_yrotmat[f].m[2][2]  =  objmat.m[2][2];
      }
   }

u8    CAM_numpancam  =  0;
vec16 pancam[20];

void  CAM_pancam()
   {
   s32   f, a, dis=99999999, i=0, obj=0, pr;
   s16   x, y, z;


   for(f=0;f<CAM_numpancam;f++)
      {
      x  =  ( OBJ_objects[ obj ].p.vx>>8 ) - pancam[f].vx;
      z  =  ( OBJ_objects[ obj ].p.vz>>8 ) - pancam[f].vz;
      a  =  vqlen2( x,z );
      if( a<dis )
         {
         dis=a;
         i=f;
         }
      }

   CAM_camp[CAM_c].vx =  pancam[i].vx;
   CAM_camp[CAM_c].vy =  pancam[i].vy;
   CAM_camp[CAM_c].vz =  pancam[i].vz;
   x  =  ( OBJ_objects[ obj ].p.vx>>8 ) - pancam[i].vx;
   y  =  ( OBJ_objects[ obj ].p.vy>>8 ) - pancam[i].vy;
   z  =  ( OBJ_objects[ obj ].p.vz>>8 ) - pancam[i].vz;
   CAM_came[CAM_c].vy =  -vatan2(x, z)<<4;
   dis   =  vroot32( x*x+z*z );
   CAM_came[CAM_c].vx =  vatan2( y, dis  )<<4;

//   pr =   (dis>>4);
//   if(pr<50)pr=50;
//   if(pr>800)pr=800;

//   GsSetProjection(pr); // Set projection

   }
//      {
//      equ( c0, -100,0,0 );
//      equ( c1, 400,0,0 );

//      sv.vx =0;
//      sv.vy =(-CAM_came[CAM_c].vy)>>4;
//      sv.vz =0;
//      vrotmatrix( &sv, &m );
//      vapplymatrix32( &m, &c0, &c0 );// v=offset
//      vapplymatrix32( &m, &c1, &c1 );// v=offset
//      add( c0, CAM_camp[CAM_c] );
//      add( c1, CAM_camp[CAM_c] );

//      col   =  COL_test2( &c0, &c1 );
//      GPU_3dline( &c0, &c1, 255,255,30);

//      if(col>=0)
//         {
//         s32   d0, d1;
//         s32   alpha;
//         vec32 v;

//         d0  =  vqlen( COL_inter.vx-c1.vx, COL_inter.vy-c1.vy, COL_inter.vz-c1.vz  );
//         d1  =  vqlen( c0.vx-c1.vx, c0.vy-c1.vy, c0.vz-c1.vz  );

//         //CAM_came[CAM_c].vy-=d*10;
//         alpha =  (d0<<8)/d1;
//         FntPrint("alpha(%d)\n", alpha);
//         //alpha =  (alpha*alpha)>>8;
//         FntPrint("alpha(%d)\n", alpha);
//         v.vx  =   ((c0.vx-c1.vx)*alpha)>>8;
//         v.vy  =   ((c0.vy-c1.vy)*alpha)>>8;
//         v.vz  =   ((c0.vz-c1.vz)*alpha)>>8;

//         add( CAM_camp[CAM_c], v );

//         TEXT_x = 0;
//         TEXT_y = 0;
//         TEXT_prstr("cam col right side", 128, 128, 128);
//         }
//      }