#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <inline_c.h>
#include <libsnd.h>
#include <libspu.h>
#include <libcd.h>
#include <libds.h>
#include <libapi.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "version.h"
#include "header.h"
#include "cdlib.h"
#include "fileaddr.h"
#include "loadit.h"

#define	FADE_FRAMES		90

int m_strcmp(register char *,register char *);

// psx\loadpsx.c
void LOAD_PutLogo();

trackinfo_t track[100];     // 8 Bytes per trackinfo_t
int nTracks;
unsigned char param[4];
u_char result[8];
int lastMode = -1;		// 0==playing cd, 1==reading files
int cTrack = -1;

u_char sectBuf[2048];

char *trackName[] =
	{
	"Data",
	"FE - Slow",
	"Bangin beat 1 dark_moon",
	"Bangin beat 2 jungle",
	"Bangin beat 3 lake_synth",
	"Bangin beat 4 rising_sun",
	"Bangin beat 5 kam_digital2",
	"Bangin beat 6 new",
	"Bangin beat 7 subit_2",
	"Bangin beat 8 timpani_rules",
    "Bangin beat 9 mishmash",
	"3min blank"
	};

int CDLIB_Init(void)
	{
	CdlLOC toc[100];			// Should be on stack ?
	int i,r;
	
	do	{
		r = CdInit();
		if(r==0)
			{
			mprintf("CDLIB_Init => CdInit() Failed, retrying.\n");
			VSync(5);
			}
		}while(r!=1);
	
	CdSetDebug(0);		// 0=none, 1=print commands, 2=print commands+info

	CdSyncCallback(CDLIB_Callback);
	CdReadyCallback(CDLIB_Callback);
	
	do	{
		r = CdDiskReady(0);		// Block until complete
		if(r==CdlDiskError)
			printf("No disc or defective disc, retrying.\n");
		else
	    if(r==CdlStatShellOpen)
			printf("CD tray is open, retrying.\n");
		else
		if(r!=CdlComplete)
			printf("Unknown return code %d, retrying.\n",r);
		}while(r!=CdlComplete);
	
	printf("CD sub-system is ready for action.\n");

	do	{
	    r = CdGetToc(toc);
		if(r<=0)
	        printf("Error reading TOC, retrying.\n");
		}while(r<=0);
	
	nTracks = r;
	for(i=0;i<nTracks;i++)
		{
		track[i].start = toc[i+1];
		track[i].end = i==nTracks-1?toc[0]:toc[i+2];
		}
/*	
	for(i=0;i<nTracks;i++)
		{
		printf("Track %-3d   %2x:%02x:%02x  ==>  %2x:%02x:%02x\n",
			i,track[i].start.minute,track[i].start.second,track[i].start.sector,
			track[i].end.minute,track[i].end.second,track[i].end.sector);
		}
*/	
	
	return 0;
	}

int CDLIB_Play(int t)
	{
//	CdlLOC pos;
//	int i,r;
	
	if(((t<1)||(t>=nTracks-1))&&(t!=-1))
		{
		printf("Invalid track, setting to 2\n");
		t = 2;
		}
	
	if(lastMode!=0)
		{
		printf("Changing from DATA -> AUDIO\n");
		
		// Setup single speed, report, notify
		param[0] = CdlModeRept|CdlModeDA|CdlModeAP /* |CdlModeSpeed */;
		CdControlB(CdlSetmode,param,NULL);

		// Give enough time for speed change if needed
		VSync(3);
		
		lastMode = 0;
		}

	cTrack = t;

	if(t==-1)
        {  
        if(WorldAvailable[4])
	        t = 2+(rand()%9);
		else{
	        t = 2+(rand()%8);
			if(t>3)
				t++;
			}
		}

	printf("Starting track %d (%s)\n",t,trackName[t]);
	
	// Non-blocking play
	CdControl(CdlPlay,(u_char *)&track[t].start,result);
	
	return 0;
	}

void CDLIB_Callback(u_char itr,u_char *result)
	{
#if 0
/*
	if(itr==CdlDataEnd)
		{
		printf("Track Ended ?  cTrack==%d\n",cTrack);
		}
*/

	switch(itr)
		{
		case CdlNoIntr:
//			printf("CDLIB_Callback, itr==%02X, ",itr);
//			printf("CdlNoIntr\n");
			break;

        case CdlDataReady:
//			printf("CDLIB_Callback, itr==%02X, ",itr);
//			printf("CdlDataReady\n");
			break;

        case CdlComplete:
//			printf("CDLIB_Callback, itr==%02X, ",itr);
//			printf("CdlComplete\n");
			break;

        case CdlAcknowledge:
//			printf("CDLIB_Callback, itr==%02X, ",itr);
//			printf("CdlAcknowledge\n");
			break;

        case CdlDataEnd:
			// Non-blocking play, restart track
			CdControl(CdlPlay,(u_char *)&track[cTrack].start,result);
//			printf("CDLIB_Callback, itr==%02X, ",itr);
//			printf("CdlDataEnd\n");
			break;

        case CdlDiskError:
			printf("CDLIB_Callback, itr==%02X, ",itr);
			printf("CdlDiskError\n");
			break;

        default:
//			printf("CDLIB_Callback, itr==%02X, ",itr);
//			printf("unknown\n");
			break;
		}
#endif

    // Track has finished, repeat (non-blocking)
	if(itr==CdlDataEnd)
		{
		int t = cTrack;
		
		if(t==-1)
			{
			if(WorldAvailable[4])
				{
		        t = 2+(rand()%9);
                printf("CB: Picking rand tune: %d\n",t);
				}
			else{
		        t = 2+(rand()%8);
				if(t>3)
					{
                    printf("CB: no junmungle today\n\n");
                    t++;
					}
                printf("CB: Picking rand tune: %d (no junmungle)\n",t);
                }
			}

        printf("CB: Starting track %d (%s)\n",t,trackName[t]);
        CdControl(CdlPlay,(u_char *)&track[t].start,result);
		}
	}

int lastVol;

#if !CDMASTER

void CDLIB_pctest()
	{
	int i;
	
	if(lastMode!=1)
		{
        printf("Changing from AUDIO -> DATA\n");
        
		// Fade out music over next couple of frames
        for(i=FADE_FRAMES;i>=0;i--)
			{
            SsSetSerialVol(SS_SERIAL_A,(lastVol*i)/FADE_FRAMES,(lastVol*i)/FADE_FRAMES);
            VSync(0);
			}
	
        // Stop the CD
        CdControl(CdlStop,0,0);
	
		// Setup double speed, report, notify
		param[0] = CdlModeRept|CdlModeDA|CdlModeSpeed;
		CdControlB(CdlSetmode,param,NULL);
		VSync(3);

		// Restore cd volume for next play
        SsSetSerialVol(SS_SERIAL_A,lastVol,lastVol);
		
		lastMode = 1;
		}
	}
#endif

void CDLIB_musvol(int v)
	{
	lastVol = v;
    SsSetSerialVol(SS_SERIAL_A,v,v);
	}

#if CDMASTER

#define bcd2num(x)	(((((x)>>4)&0x0f)*10)+((x)&0x0f))
#define num2bcd(x)	(((x/10)<<4)+(x%10))

int CDLIB_NRead(NFSRCH *n,void *b)
	{
	static int lumpValid = 0;
	static u32 lumpAbsSector;
		
	u32 sectorOffset;
	CdlLOC pos;
	
	u32 o,r;

	int nsector;
	int base;
	int rem;
	int cnt;

	int i;

	if(lastMode!=1)
		{
        printf("Changing from AUDIO -> DATA\n");
        
		// Fade out music over next couple of frames
        for(i=FADE_FRAMES;i>=0;i--)
            {
            SsSetSerialVol(SS_SERIAL_A,(lastVol*i)/FADE_FRAMES,(lastVol*i)/FADE_FRAMES);
            VSync(0);
			}
	
        // Stop the CD
        CdControl(CdlStop,0,0);
	
		// Setup double speed, report, notify
		param[0] = CdlModeRept|CdlModeDA|CdlModeSpeed;
		CdControlB(CdlSetmode,param,NULL);
		VSync(3);

		// Restore cd volume for next play
        SsSetSerialVol(SS_SERIAL_A,lastVol,lastVol);
		
		lastMode = 1;
		}
	
	if(!lumpValid)
		{
		CdlFILE lump;
		while(CdSearchFile(&lump,"\\LUMP.360;1")==0)
            printf("Lump file not found, retrying..\n");
		
		lumpAbsSector =
			(bcd2num(lump.pos.minute)*4500)+
            (bcd2num(lump.pos.second)*75)+
            bcd2num(lump.pos.sector);
        
//		printf("lumpAbsSector == %lu, (%02X:%02X.%02X)\n"
//			,lumpAbsSector,lump.pos.minute,lump.pos.second,lump.pos.sector);
		
//		printf("pos.minute == %02X, DEC == %d\n",lump.pos.minute,bcd2num(lump.pos.minute));
//		printf("pos.second == %02X, DEC == %d\n",lump.pos.second,bcd2num(lump.pos.second));
//		printf("pos.sector == %02X, DEC == %d\n",lump.pos.sector,bcd2num(lump.pos.sector));
		
		lumpValid = 1;
		}
	
    sectorOffset = n->offset >> 11;
	
	o = sectorOffset + lumpAbsSector;
	
//	printf("File sector: %lu, n->offset == %lu, n->size == %lu\n",o,n->offset,n->size);
	
	r = o/4500;
	
//	printf("Minute = %lu, BCD=%02lX\n",r,num2bcd(r));
	
    pos.minute = num2bcd(r);
	o -= r*4500;
	r = o/75;

//	printf("Second = %lu, BCD=%02lX\n",r,num2bcd(r));

    pos.second = num2bcd(r);
    o -= r*75;

//	printf("Sector = %lu, BCD=%02lX\n",o,num2bcd(o));

    pos.sector = num2bcd(o);
    
    base = (n->size&~0x07ff);
	rem = n->size&0x07ff;
	nsector = (n->size+2047)>>11;

	// Save sector buffer
	for(i=0;i<2048;i++)
        sectBuf[i] = ((u_char *)b)[base+i];

//	printf("Seek: (%02X:%02X.%02X)\n"
//        ,pos.minute,pos.second,pos.sector);

	// Seek to pos
	CdControl(CdlSetloc,(u_char *)&pos,0);
	
	do	{
		while(CdRead(nsector,(u_long *)b,CdlModeSpeed)!=1)
			printf("CdRead command issue failed, retrying.\n");
	
		// Wait until completion of cd read.
		i = 0;
		do	{
			DrawSync(0);
			VSync(1);
	        cnt = CdReadSync(1,NULL);

			LOAD_PutLogo();

			i++;
			if(i>=10)
				{
				printf(" %d",cnt);
				i = 0;
				}
			}while(cnt>0);
		
		if(i==-1)
			printf("PSX CdRead Failed, retrying..\n");
		}while(i==-1);

	// Restore partial sector buffer (destroyed by read);
	for(i=rem;i<2048;i++)
        ((u_char *)b)[base+i] = sectBuf[i];
	
    return n->size;
	
	return 0;
	}

#endif

#if 0
int CDLIB_Read(char *n,void *b)
	{
/*
	int len;
	len = CdReadFile(n,(u_long *)b,0);
	printf("%s = %d Bytes\n",n,len);
*/
	CdlFILE fp;
	int nsector;
	int base;
	int rem;
	int cnt;
	int i;
/*
	int idx = -1;

	// Search database for this file
	for(i=0;(flist[i].name!=NULL)&&(idx==-1);i++)
		if(m_strcmp(flist[i].name,n)==0)
			idx = i;
*/
	
/*	if(idx==-1)
	    {
*/
		while(CdSearchFile(&fp,n)==0)
			printf("File '%s' not found, retrying.\n",n);

//		printf("%s (%d bytes), %d:%02X:%02X\n",
//			fp.name,fp.size,fp.pos.minute,fp.pos.second,fp.pos.sector);
		
/*
		#if GETSECT
		printf("\n\t{\"%s\",{{%d,%d,%d,%d},%ld,\"%s\"}}\n",n,fp.pos.minute,fp.pos.second,fp.pos.sector,fp.pos.track,fp.size,fp.name);
		#endif
		}
	else{
		fp = flist[idx].f;
		}
*/	
    base = (fp.size&~0x07ff);
	rem = fp.size&0x07ff;
	nsector = (fp.size+2047)>>11;
    

	// Save sector buffer
	for(i=0;i<2048;i++)
        sectBuf[i] = ((u_char *)b)[base+i];


	// Seek to pos
	CdControl(CdlSetloc,(u_char *)&fp.pos,0);

	if(lastMode!=1)
		{
        // Setup double speed, report, notify
        param[0] = CdlModeRept|CdlModeDA|CdlModeSpeed;
		CdControlB(CdlSetmode,param,NULL);
		VSync(3);
		
		lastMode = 1;
		}
	
	do	{
		while(CdRead(nsector,(u_long *)b,CdlModeSpeed)!=1)
			printf("CdRead command issue failed, retrying.\n");
	
		// Wait until completion of cd read.
		i = 0;
		do	{
			DrawSync(0);
			VSync(1);
	        cnt = CdReadSync(1,NULL);

			LOAD_PutLogo();

			i++;
			if(i>=10)
				{
				printf(" %d",cnt);
				i = 0;
				}
			}while(cnt>0);
		
		if(i==-1)
			printf("PSX CdRead Failed, retrying..\n");
		}while(i==-1);

	// Restore partial sector buffer (destroyed by read);
	for(i=rem;i<2048;i++)
        ((u_char *)b)[base+i] = sectBuf[i];
    
//	printf("Restored %d bytes\n",2048-rem);
	
    return fp.size;
    }
#endif

void CDLIB_Stop(void)
	{
	CdControl(CdlStop,0,0);
	}

char *CDLIB_Cname(char *n)
	{
	static char newName[128];
	
	register int i,l;
	register char c;
	
	l = strlen(n) - 2;		// Yeah, I know its shit slow version of strlen.
	for(i=0;i<l;i++)
		{
		c = n[i+2];
		if(c>='a')
		if(c<='z')
			c += 'A'-'a';
        newName[i] = c;
		}
	newName[i++] = ';';
	newName[i++] = '1';
	newName[i] = 0;

//	printf("\"%s\" ==> \"%s\"\n",n,newName);
	
	return newName;
	}

void CDLIB_Cpos(CDPOS *p)
	{
    CdControlB(CdlGetlocP,param,(u_char *)p);
	}

int m_strcmp(register char *s1,register char *s2)
	{
    m_str_cmp_l1:
	
	if(*s1==0)
		{
		if(*s2==0)
			return 0;
		else
			return 1;
		}
	else
	if(*s2==0)
		{
		if(*s1==0)
			return 0;
		else
			return 1;
		}
	else
	if(*s1++!=*s2++)
		return 1;

	goto m_str_cmp_l1;
    }

/*

#if CDPASS2

NFSRCH nflist[] =
	{
	{"CARS\\CAR6MP2.SDF",10482,11752,NULL},
	{NULL,0,0,NULL}
	};

#endif

#if !CDPASS2

#define tims_lens_flare_btm "tims\\lens\\flare.btm"

#endif

*/
