 #include	"header.h"
  #include "psx\mathpsx.h"
#include "mesh.h"
#include	"camera.h"
#include	"objects.h"
#include	"collide.h"
#include "psx\mathpsx.h"
#include "state.h"
///////////////////////////////////////////////////////////////////////////////////////////////
//		360 Fixed point collision routines
///////////////////////////////////////////////////////////////////////////////////////////////
//		Started:		19/5/82
//    Geeza:      Mootack the Poon.
//		PSX:			Barely
//      N64:            Not too likely.
//    Notes:      line-mesh intersection routines.
// 4K code align, maths fn included
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Globals
///////////////////////////////////////////////////////////////////////////////////////////////
vec16    COL_norm;
vec32		COL_inter;		// for line-poly
PAIR_2D  COL_2dinter;
s32		COL_facenum;
s32		COL_subobjnum;
u8       COL_surftype;
s32      COL_testobj( vec32 *ll0, vec32 *ll1, s32  f );
s32      COL_gamma16;

u8 COL_stypename[26][16]={
   {"NA"},
   {"brick"},
   {"concrete"},
   {"crazy p"},
   {"dry ash"},
   {"foliage"},
   {"grass"},
   {"ice"},
   {"lava"},
   {"magma"},
   {"metal"},
   {"mud"},
   {"rock"},
   {"sand"},
   {"snow"},
   {"stone"},
   {"trees"},
   {"water"},
   {"waterfall"},
   {"wood"}};
///////////////////////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////////////////////
vec32    cl0   __attribute__ ((section("cachedata"))) ={0};
vec32    cl1   __attribute__ ((section("cachedata"))) ={0};
vec32    p0    __attribute__ ((section("cachedata"))) ={0};
vec32    p1    __attribute__ ((section("cachedata"))) ={0};
vec32    p2    __attribute__ ((section("cachedata"))) ={0};
vec32    p3    __attribute__ ((section("cachedata"))) ={0};

u16   idxv0        __attribute__ ((section("cachedata"))) = 0;
u16   idxv1        __attribute__ ((section("cachedata"))) = 0;
u16   idxv2        __attribute__ ((section("cachedata"))) = 0;
u16   idxv3        __attribute__ ((section("cachedata"))) = 0;
u32   *pcface                       __attribute__ ((section("cachedata"))) = 0;
vec16 *pcnorm                       __attribute__ ((section("cachedata"))) ={0};
vec16 *pcnorm2                      __attribute__ ((section("cachedata"))) ={0};
u32   *pcolmod                      __attribute__ ((section("cachedata"))) = 0;
vec16 norm                          __attribute__ ((section("cachedata"))) ={0};
u16   f                             __attribute__ ((section("cachedata"))) = 0;

vec16 *pvert      ;

s32   COL_test2a( vec32 *l0, vec32 *l1, s32 gx, s32 gz  );

s32   COL_test2( vec32 *l0, vec32 *l1 )
   {
   s32   gx, gz, c;
   //gx  =  (((s32)(l0->vx)+32768)*MESH_xgridnum)>>16;
   //gz  =  ((((s32)(-l0->vz))+32768)*MESH_zgridnum)>>16;
   gx  =  (((s32)(l0->vx)+32768)<<5)>>16;
   gz  =  ((((s32)(-l0->vz))+32768)<<5)>>16;
   c  =  COL_test2a( l0, l1, gx, gz  );
   return c;
   //if(c>=0)return c;

   //gx  =  (((s32)(l1->vx)+32768)*20)>>16;
   //gz  =  ((((s32)(-l1->vz))+32768)*20)>>16;
   //c  =  COL_test2a( l0, l1, gx, gz  );

   //return c;
   }


s32   COL_test2a( vec32 *l0, vec32 *l1, s32 gx, s32 gz  )
   {
register u32   *pmod       ;
register vec16 *pvert      ;
//register u32   *pface;

u32   ntrigcol    ;
u32   nquadcol    ;
u32   nbquadcol   ;
//   s32   lx, lz, ly, dis;
//   u32   nface;
   u32   f; //, g, t;
//   vec32 d0,d1;
   vec32 te, i, d;
   s32   da, db, gamma, gammab, gammat;
   s32   nax, nay, naz;
   s32   cross0, cross1, cross2, cross3;
   u8    surftype;
   u32   mmap;

   cl0.vx   =  l0->vx ;// face co-ords relative
   cl0.vy   =  l0->vy ;// to seg center,
   cl0.vz   =  l0->vz ;// NOT world origin

   cl1.vx   =  l1->vx ;
   cl1.vy   =  l1->vy ;
   cl1.vz   =  l1->vz ;

   //GPU_3dline( &cl0, &cl1,0xff,0xff,0xff );

   /////////////////////////////////////////


   if( (gx<0) + (gx>=MESH_xgridnum) + (gz<0) + (gz>=MESH_zgridnum) )return-1;
   //mmap  = MESH_map[gz][gx];
   mmap  =  *((u32*)MESH_map+((gz<<5)+gx));
   if( mmap ==0xffffffff )return -2;

   pmod =  MESH_track;
   pmod+=2;
   pvert =  (vec16*)*pmod;
   pmod+=4;


   //pmod += 35*MESH_map[gz][gx];
   //pmod += 12*mmap;
   pmod += (mmap<<3)+(mmap<<2);

   // pointer at tri info for obj

   pmod  += 9;

   // ptr to coll list
   pcolmod     = (u32 *) *pmod++;

   ntrigcol    =  *((u16*)pmod);
   nquadcol    =  *((u16*)pmod+1);
   nbquadcol   =  *((u16*)pmod+2);

   ///////////////////////////////////////////
   for( f=0;f<ntrigcol;f++)
      {
      pcface   = (u32 *) *pcolmod++;
      pcnorm   = (vec16 *) *pcolmod++;

      surftype  = (u32)pcface>>24;
      pcface    =(u32 *) ((u32)pcface&0xffffff)+0x80000000;

      if(surftype==0)continue;
      if(surftype==5)continue;
	if(STATE.currlevel<12||STATE.currlevel>15)
      if(surftype==18)continue;
      //idxv0  =  *((u16*)pcface+0);
      //idxv1  =  *((u16*)pcface+1);
      //idxv2  =  *((u16*)pcface+2);

      *((u32*)&idxv0)  =  *((u32*)pcface);
      idxv2  =  *((u16*)pcface+2);

      p0.vz  =  pvert[ idxv0 ].vz ;
      p1.vz  =  pvert[ idxv1 ].vz ;
      p2.vz  =  pvert[ idxv2 ].vz ;

      if((cl0.vz<p0.vz) + (cl0.vz<p1.vz) + (cl0.vz<p2.vz) +
         (cl1.vz<p0.vz) + (cl1.vz<p1.vz) + (cl1.vz<p2.vz) == 6 )continue;

      if((cl0.vz>p0.vz) + (cl0.vz>p1.vz) + (cl0.vz>p2.vz) +
         (cl1.vz>p0.vz) + (cl1.vz>p1.vz) + (cl1.vz>p2.vz) == 6 )continue;

      p0.vx  =  pvert[ idxv0 ].vx ;
      p1.vx  =  pvert[ idxv1 ].vx ;
      p2.vx  =  pvert[ idxv2 ].vx ;

      if((cl0.vx<p0.vx) && (cl0.vx<p1.vx) && (cl0.vx<p2.vx) &&
         (cl1.vx<p0.vx) && (cl1.vx<p1.vx) && (cl1.vx<p2.vx) )continue;

      if((cl0.vx>p0.vx) && (cl0.vx>p1.vx) && (cl0.vx>p2.vx) &&
         (cl1.vx>p0.vx) && (cl1.vx>p1.vx) && (cl1.vx>p2.vx) )continue;

      p0.vy  =  pvert[ idxv0 ].vy ;
      p1.vy  =  pvert[ idxv1 ].vy ;
      p2.vy  =  pvert[ idxv2 ].vy ;

      if((cl0.vy<p0.vy) && (cl0.vy<p1.vy) && (cl0.vy<p2.vy) &&
         (cl1.vy<p0.vy) && (cl1.vy<p1.vy) && (cl1.vy<p2.vy) )continue;

      if((cl0.vy>p0.vy) && (cl0.vy>p1.vy) && (cl0.vy>p2.vy) &&
         (cl1.vy>p0.vy) && (cl1.vy>p1.vy) && (cl1.vy>p2.vy) )continue;

//GPU_3dline( &p0, &p1,0x0,0xff,0xff );
//GPU_3dline( &p1, &p2,0x0,0xff,0xff );
//GPU_3dline( &p2, &p0,0x0,0xff,0xff );

      norm.vx  =  *((s16*)pcnorm+0);
      norm.vy  =  *((s16*)pcnorm+1);
      norm.vz  =  *((s16*)pcnorm+2);

      te.vx =  cl0.vx   -  p0.vx;
      te.vy =  cl0.vy   -  p0.vy;
      te.vz =  cl0.vz   -  p0.vz;

      da =  te.vx*(norm.vx)   +
            te.vy*(norm.vy)   +
            te.vz*(norm.vz)   ;//da;   1.19.12

      te.vx =  cl1.vx   -  p0.vx;
      te.vy =  cl1.vy   -  p0.vy;
      te.vz =  cl1.vz   -  p0.vz;

      db =  te.vx*(norm.vx)   +
            te.vy*(norm.vy)   +
            te.vz*(norm.vz)   ;//db;   1.19.12

//sprintf(debbuf,"x %d   y %d z %d", norm.vx, norm.vy, norm.vz  );
//RENDER_message(debbuf);
      if(surftype==3)
         {//double sided
         if( db <0 && da<0)continue;
         if( db >0 && da>0)continue;
         if(db>0)
            {
            // reverse norm
            norm.vx  =  -norm.vx;
            norm.vy  =  -norm.vy;
            norm.vz  =  -norm.vz;
            }
         }
      else
         {
         if( !((db<=0) && (da>=0))  )continue;
         }


      gammat   =  da<<8;
      gammab   =  (da-db)>>8;
		if(gammab==0)gammab = 1;//ATTN!
		gamma		=	 gammat / gammab;// gamma;	1.15.16

		//deb2	=gamma;

      d.vx  =  cl1.vx   -  cl0.vx;
      d.vy  =  cl1.vy   -  cl0.vy;
      d.vz  =  cl1.vz   -  cl0.vz;

      i.vx  =  (( d.vx*gamma  )>>16 ) + cl0.vx;//i;   1.31
      i.vy  =  (( d.vy*gamma  )>>16 ) + cl0.vy;// plane-line intersection point
      i.vz  =  (( d.vz*gamma  )>>16 ) + cl0.vz;

      // now test I is 'in' tri
		// project( ignore component) to largest norm component
      nax   =  vabss( norm.vx );
      nay   =  vabss( norm.vy );
      naz   =  vabss( norm.vz );
      if( (nax>nay) && (nax>naz) )
			{
			// remove x
// (SX1-SX0)(SY1-SY0) - (SX1-SX0)(SY1-SY0);
//= (SX1SY1+SX1SY0)-(SX1SY0+SX1SY1);
			cross0		=	v2dcross( p1.vy-p0.vy, p1.vz-p0.vz, i.vy-p0.vy, i.vz-p0.vz );
			cross1		=	v2dcross( p2.vy-p1.vy, p2.vz-p1.vz, i.vy-p1.vy, i.vz-p1.vz );
			cross2		=	v2dcross( p0.vy-p2.vy, p0.vz-p2.vz, i.vy-p2.vy, i.vz-p2.vz );
         if( !((cross0 <0 && cross1 <0 && cross2 <0)||
               (cross0 >0 && cross1 >0 && cross2 >0)) )continue;
			}
		else
			{
			if( nay>naz )
				{
				// remove y
				cross0		=	v2dcross( p1.vz-p0.vz, p1.vx-p0.vx, i.vz-p0.vz, i.vx-p0.vx );
				cross1		=	v2dcross( p2.vz-p1.vz, p2.vx-p1.vx, i.vz-p1.vz, i.vx-p1.vx );
				cross2		=	v2dcross( p0.vz-p2.vz, p0.vx-p2.vx, i.vz-p2.vz, i.vx-p2.vx );
            if( !((cross0 <0 && cross1 <0 && cross2 <0)||
                  (cross0 >0 && cross1 >0 && cross2 >0)) )continue;
				}
			else
				{
				// remove z
				cross0		=	v2dcross( p1.vx-p0.vx, p1.vy-p0.vy, i.vx-p0.vx, i.vy-p0.vy );
				cross1		=	v2dcross( p2.vx-p1.vx, p2.vy-p1.vy, i.vx-p1.vx, i.vy-p1.vy );
				cross2		=	v2dcross( p0.vx-p2.vx, p0.vy-p2.vy, i.vx-p2.vx, i.vy-p2.vy );
            if( !((cross0 <0 && cross1 <0 && cross2 <0)||
                  (cross0 >0 && cross1 >0 && cross2 >0)) )continue;
				}
			}
//GPU_3dline( &i, &p0,0xff,0x0,0xff );
//GPU_3dline( &i, &p1,0xff,0x0,0xff );
//GPU_3dline( &i, &p2,0xff,0x0,0xff );
		vmov( &COL_inter, &i );
//GPU_3dline( &cl0, &COL_inter,0xff,0xff,0xff );
      COL_gamma16 = gamma;

      COL_surftype   =  surftype;
      COL_norm.vx =   norm.vx;
      COL_norm.vy =   norm.vy;
      COL_norm.vz =   norm.vz;

	// Mat 24/03/1999
	if(STATE.currlevel>=12&&STATE.currlevel<=15)
		if(COL_surftype==18)
			COL_surftype = 1;

      return 1;
      }

   for( f=0;f<nquadcol;f++)
      {
      pcface   = (u32 *) *pcolmod++;                   //get 4b
      pcnorm   = (vec16 *) *pcolmod++;                   //get 4b

      surftype  = (u32)pcface>>24;
      pcface    =(u32 *) ((u32)pcface&0xffffff)+0x80000000;
      if(surftype==0)continue;
      if(surftype==5)continue;
	if(STATE.currlevel<12||STATE.currlevel>15)
      if(surftype==18)continue;

      //idxv0  =  *((u16*)pcface+0);
      //idxv1  =  *((u16*)pcface+1);
      //idxv2  =  *((u16*)pcface+2);
      //idxv3  =  *((u16*)pcface+3);

      *((u32*)&idxv0)  =  *((u32*)pcface);      //get 4b
      *((u32*)&idxv2)  =  *((u32*)pcface+1);    //get 4b

      p0.vx  =  pvert[ idxv0 ].vx ;             //get 2b
      p1.vx  =  pvert[ idxv1 ].vx ;             //get 2b
      p2.vx  =  pvert[ idxv3 ].vx ;             //get 2b
      p3.vx  =  pvert[ idxv2 ].vx ;             //get 2b

      //max= *( 0x8080008 + mode)
      //if pmax<pmin continue
      if((cl0.vx<p0.vx) + (cl0.vx<p1.vx) + (cl0.vx<p2.vx) + (cl0.vx<p3.vx) +
         (cl1.vx<p0.vx) + (cl1.vx<p1.vx) + (cl1.vx<p2.vx) + (cl1.vx<p3.vx) ==8)continue;

      if((cl0.vx>p0.vx) + (cl0.vx>p1.vx) + (cl0.vx>p2.vx) + (cl0.vx>p3.vx) +
         (cl1.vx>p0.vx) + (cl1.vx>p1.vx) + (cl1.vx>p2.vx) + (cl1.vx>p3.vx) ==8)continue;

      p0.vz  =  pvert[ idxv0 ].vz ;
      p1.vz  =  pvert[ idxv1 ].vz ;
      p2.vz  =  pvert[ idxv3 ].vz ;
      p3.vz  =  pvert[ idxv2 ].vz ;

      if((cl0.vz<p0.vz) + (cl0.vz<p1.vz) + (cl0.vz<p2.vz) + (cl0.vz<p3.vz) +
         (cl1.vz<p0.vz) + (cl1.vz<p1.vz) + (cl1.vz<p2.vz) + (cl1.vz<p3.vz) ==8)continue;

      if((cl0.vz>p0.vz) + (cl0.vz>p1.vz) + (cl0.vz>p2.vz) + (cl0.vz>p3.vz) +
         (cl1.vz>p0.vz) + (cl1.vz>p1.vz) + (cl1.vz>p2.vz) + (cl1.vz>p3.vz) ==8)continue;

      p0.vy  =  pvert[ idxv0 ].vy ;
      p1.vy  =  pvert[ idxv1 ].vy ;
      p2.vy  =  pvert[ idxv3 ].vy ;
      p3.vy  =  pvert[ idxv2 ].vy ;

      if((cl0.vy<p0.vy) + (cl0.vy<p1.vy) + (cl0.vy<p2.vy) + (cl0.vy<p3.vy) +
         (cl1.vy<p0.vy) + (cl1.vy<p1.vy) + (cl1.vy<p2.vy) + (cl1.vy<p3.vy) ==8)continue;

      if((cl0.vy>p0.vy) + (cl0.vy>p1.vy) + (cl0.vy>p2.vy) + (cl0.vy>p3.vy) +
         (cl1.vy>p0.vy) + (cl1.vy>p1.vy) + (cl1.vy>p2.vy) + (cl1.vy>p3.vy) ==8)continue;


//GPU_3dline( &p0, &p1,0x0,0xff,0xff );
//GPU_3dline( &p1, &p2,0x0,0xff,0xff );
//GPU_3dline( &p2, &p3,0x0,0xff,0xff );
//GPU_3dline( &p3, &p0,0x0,0xff,0xff );

      norm.vx  =  *((s16*)pcnorm+0);
      norm.vy  =  *((s16*)pcnorm+1);
      norm.vz  =  *((s16*)pcnorm+2);

      te.vx =  cl0.vx   -  p0.vx;
      te.vy =  cl0.vy   -  p0.vy;
      te.vz =  cl0.vz   -  p0.vz;

      da =  te.vx*(norm.vx)   +
            te.vy*(norm.vy)   +
            te.vz*(norm.vz)   ;//da;   1.19.12

      te.vx =  cl1.vx   -  p0.vx;
      te.vy =  cl1.vy   -  p0.vy;
      te.vz =  cl1.vz   -  p0.vz;

      db =  te.vx*(norm.vx)   +
            te.vy*(norm.vy)   +
            te.vz*(norm.vz)   ;//db;   1.19.12

//sprintf(debbuf,"x %d   y %d z %d", norm.vx, norm.vy, norm.vz  );
//RENDER_message(debbuf);
      if(surftype==3)
         {//double sided
         if( db <0 && da<0)continue;
         if( db >0 && da>0)continue;
         if(db>0)
            {
            // reverse norm
            norm.vx  =  -norm.vx;
            norm.vy  =  -norm.vy;
            norm.vz  =  -norm.vz;
            }
         }
      else
         {
         if( !((db<=0) && (da>=0))  )continue;
         }

      gammat   =  da<<8;
      gammab   =  (da-db)>>8;
		if(gammab==0)gammab = 1;//ATTN!
		gamma		=	 gammat / gammab;// gamma;	1.15.16

      d.vx  =  cl1.vx   -  cl0.vx;
      d.vy  =  cl1.vy   -  cl0.vy;
      d.vz  =  cl1.vz   -  cl0.vz;

      i.vx  =  (( d.vx*gamma  )>>16 ) + cl0.vx;//i;   1.31
      i.vy  =  (( d.vy*gamma  )>>16 ) + cl0.vy;// plane-line intersection point
      i.vz  =  (( d.vz*gamma  )>>16 ) + cl0.vz;
      // now test I is 'in' tri
		// project( ignore component) to largest norm component
      nax   =  vabss( norm.vx );
      nay   =  vabss( norm.vy );
      naz   =  vabss( norm.vz );

      if( (nax>nay) && (nax>naz) )
			{
			// remove x
			cross0		=	v2dcross( p1.vy-p0.vy, p1.vz-p0.vz, i.vy-p0.vy, i.vz-p0.vz );
			cross1		=	v2dcross( p2.vy-p1.vy, p2.vz-p1.vz, i.vy-p1.vy, i.vz-p1.vz );
			cross2		=	v2dcross( p3.vy-p2.vy, p3.vz-p2.vz, i.vy-p2.vy, i.vz-p2.vz );
			cross3		=	v2dcross( p0.vy-p3.vy, p0.vz-p3.vz, i.vy-p3.vy, i.vz-p3.vz );
         if( !((cross0 <0 && cross1 <0 && cross2 <0 && cross3 <0 )||
               (cross0 >0 && cross1 >0 && cross2 >0 && cross3 >0 )) )continue;
			}
		else
			{
			if( nay>naz )
				{
				// remove y
				cross0		=	v2dcross( p1.vz-p0.vz, p1.vx-p0.vx, i.vz-p0.vz, i.vx-p0.vx );
				cross1		=	v2dcross( p2.vz-p1.vz, p2.vx-p1.vx, i.vz-p1.vz, i.vx-p1.vx );
				cross2		=	v2dcross( p3.vz-p2.vz, p3.vx-p2.vx, i.vz-p2.vz, i.vx-p2.vx );
				cross3		=	v2dcross( p0.vz-p3.vz, p0.vx-p3.vx, i.vz-p3.vz, i.vx-p3.vx );
            if( !((cross0 <0 && cross1 <0 && cross2 <0 && cross3 <0 )||
                  (cross0 >0 && cross1 >0 && cross2 >0 && cross3 >0 )) )continue;
            }

			else
				{
				// remove z
				cross0		=	v2dcross( p1.vx-p0.vx, p1.vy-p0.vy, i.vx-p0.vx, i.vy-p0.vy );
				cross1		=	v2dcross( p2.vx-p1.vx, p2.vy-p1.vy, i.vx-p1.vx, i.vy-p1.vy );
				cross2		=	v2dcross( p3.vx-p2.vx, p3.vy-p2.vy, i.vx-p2.vx, i.vy-p2.vy );
				cross3		=	v2dcross( p0.vx-p3.vx, p0.vy-p3.vy, i.vx-p3.vx, i.vy-p3.vy );
            if( !((cross0 <0 && cross1 <0 && cross2 <0 && cross3 <0 )||
                  (cross0 >0 && cross1 >0 && cross2 >0 && cross3 >0 )) )continue;
				}
			}

//GPU_3dline( &i, &p0,0xff,0x0,0xff );
//GPU_3dline( &i, &p1,0xff,0x0,0xff );
//GPU_3dline( &i, &p2,0xff,0x0,0xff );
//GPU_3dline( &i, &p3,0xff,0x0,0xff );
		vmov( &COL_inter, &i );
//GPU_3dline( &cl0, &COL_inter,0xff,0xff,0xff );
      COL_gamma16 = gamma;
      COL_surftype   =  surftype;
      COL_norm.vx =   norm.vx;
      COL_norm.vy =   norm.vy;
      COL_norm.vz =   norm.vz;

	// Mat 24/03/1999
	if(STATE.currlevel>=12&&STATE.currlevel<=15)
		if(COL_surftype==18)
			COL_surftype = 1;

      return 1;
      }

   // bent quads!booo!
   for( f=0;f<nbquadcol;f++)
      {
      pcface   = (u32 *) *pcolmod++;                   //get 4b
      pcnorm   = (vec16 *) *pcolmod++;                   //get 4b
      pcnorm2  = (vec16 *) *pcolmod++;                   //get 4b

      surftype  = (u32)pcface>>24;
      pcface    =(u32 *) ((u32)pcface&0xffffff)+0x80000000;
      if(surftype==0)continue;
      if(surftype==5)continue;
	if(STATE.currlevel<12||STATE.currlevel>15)
      if(surftype==18)continue;

      *((u32*)&idxv0)  =  *((u32*)pcface);      //get 4b
      *((u32*)&idxv2)  =  *((u32*)pcface+1);    //get 4b

      p0.vx  =  pvert[ idxv0 ].vx ;             //get 2b
      p1.vx  =  pvert[ idxv1 ].vx ;             //get 2b
      p2.vx  =  pvert[ idxv3 ].vx ;             //get 2b
      p3.vx  =  pvert[ idxv2 ].vx ;             //get 2b
      //*((u32*)&p0)  =  *((u32*)&pvert[ idxv0 ].vx);      //get 4b
      //*((u32*)&p1)  =  *((u32*)&pvert[ idxv1 ].vx);      //get 4b
      //*((u32*)&p2)  =  *((u32*)&pvert[ idxv3 ].vx);      //get 4b
      //*((u32*)&p3)  =  *((u32*)&pvert[ idxv2 ].vx);      //get 4b

      if((cl0.vx<p0.vx) + (cl0.vx<p1.vx) + (cl0.vx<p2.vx) + (cl0.vx<p3.vx) +
         (cl1.vx<p0.vx) + (cl1.vx<p1.vx) + (cl1.vx<p2.vx) + (cl1.vx<p3.vx) ==8)continue;

      if((cl0.vx>p0.vx) + (cl0.vx>p1.vx) + (cl0.vx>p2.vx) + (cl0.vx>p3.vx) +
         (cl1.vx>p0.vx) + (cl1.vx>p1.vx) + (cl1.vx>p2.vx) + (cl1.vx>p3.vx) ==8)continue;

      p0.vz  =  pvert[ idxv0 ].vz ;
      p1.vz  =  pvert[ idxv1 ].vz ;
      p2.vz  =  pvert[ idxv3 ].vz ;
      p3.vz  =  pvert[ idxv2 ].vz ;

      if(cl0.vz<p0.vz && cl0.vz<p1.vz && cl0.vz<p2.vz && cl0.vz<p3.vz &&
         cl1.vz<p0.vz && cl1.vz<p1.vz && cl1.vz<p2.vz && cl1.vz<p3.vz )continue;

      if(cl0.vz>p0.vz && cl0.vz>p1.vz && cl0.vz>p2.vz && cl0.vz>p3.vz &&
         cl1.vz>p0.vz && cl1.vz>p1.vz && cl1.vz>p2.vz && cl1.vz>p3.vz )continue;

      p0.vy  =  pvert[ idxv0 ].vy ;
      p1.vy  =  pvert[ idxv1 ].vy ;
      p2.vy  =  pvert[ idxv3 ].vy ;
      p3.vy  =  pvert[ idxv2 ].vy ;

      if((cl0.vy<p0.vy) + (cl0.vy<p1.vy) + (cl0.vy<p2.vy) + (cl0.vy<p3.vy) +
         (cl1.vy<p0.vy) + (cl1.vy<p1.vy) + (cl1.vy<p2.vy) + (cl1.vy<p3.vy) ==8)continue;

      if((cl0.vy>p0.vy) + (cl0.vy>p1.vy) + (cl0.vy>p2.vy) + (cl0.vy>p3.vy) +
         (cl1.vy>p0.vy) + (cl1.vy>p1.vy) + (cl1.vy>p2.vy) + (cl1.vy>p3.vy) ==8)continue;


         {
         norm.vx  =  *((s16*)pcnorm+0);
         norm.vy  =  *((s16*)pcnorm+1);
         norm.vz  =  *((s16*)pcnorm+2);


         te.vx =  cl0.vx   -  p0.vx;
         te.vy =  cl0.vy   -  p0.vy;
         te.vz =  cl0.vz   -  p0.vz;

         da =  te.vx*(norm.vx)   +
               te.vy*(norm.vy)   +
               te.vz*(norm.vz)   ;//da;   1.19.12

         te.vx =  cl1.vx   -  p0.vx;
         te.vy =  cl1.vy   -  p0.vy;
         te.vz =  cl1.vz   -  p0.vz;

         db =  te.vx*(norm.vx)   +
               te.vy*(norm.vy)   +
               te.vz*(norm.vz)   ;//db;   1.19.12

//spri   ntf(debbuf,"x %d   y %d z %d", norm.vx, norm.vy, norm.vz  );
//REND   ER_message(debbuf);
      //if(surftype==3)
//         {//double sided
//         if( db <0 && da<0)continue;
//         if( db >0 && da>0)continue;
//         }
//      else
//         {
//         if( !((db<=0) && (da>=0))  )continue;
//         }
         if( ((surftype==3) && ( sgn(db)!=sgn(da) )) ||
             ((surftype!=3) && (db<=0) && (da>=0) ))
         //if( ((db<=0) && (da>=0))  )
            {
            if(db>0)
               {
               // reverse norm
               norm.vx  =  -norm.vx;
               norm.vy  =  -norm.vy;
               norm.vz  =  -norm.vz;
               }

            gammat   =  da<<8;
            gammab   =  (da-db)>>8;
            if(gammab==0)gammab = 1;//ATTN!
            gamma    =   gammat / gammab;// gamma; 1.15.16

            d.vx  =  cl1.vx   -  cl0.vx;
            d.vy  =  cl1.vy   -  cl0.vy;
            d.vz  =  cl1.vz   -  cl0.vz;

            i.vx  =  (( d.vx*gamma  )>>16 ) + cl0.vx;//i;   1.31
            i.vy  =  (( d.vy*gamma  )>>16 ) + cl0.vy;// plane-line intersection point
            i.vz  =  (( d.vz*gamma  )>>16 ) + cl0.vz;
            // now test I is 'in' tri
            // project( ignore component) to largest norm component
            nax   =  vabss( norm.vx );
            nay   =  vabss( norm.vy );
            naz   =  vabss( norm.vz );
            if( (nax>nay) && (nax>naz) )
               {
               // remove x
               cross0      =  v2dcross( p1.vy-p0.vy, p1.vz-p0.vz, i.vy-p0.vy, i.vz-p0.vz );
               cross1      =  v2dcross( p3.vy-p1.vy, p3.vz-p1.vz, i.vy-p1.vy, i.vz-p1.vz );
               cross2      =  v2dcross( p0.vy-p3.vy, p0.vz-p3.vz, i.vy-p3.vy, i.vz-p3.vz );
               if( ((cross0 <0 && cross1 <0 && cross2 <0)||
                     (cross0 >0 && cross1 >0 && cross2 >0)) )
                  {
                  vmov( &COL_inter, &i );
                  COL_gamma16 = gamma;
                  COL_surftype   =  surftype;
                  COL_norm.vx =   norm.vx;
                  COL_norm.vy =   norm.vy;
                  COL_norm.vz =   norm.vz;

				// Mat 24/03/1999
				if(STATE.currlevel>=12&&STATE.currlevel<=15)
					if(COL_surftype==18)
						COL_surftype = 1;

                  return 1;
                  }
               }
            else
               {
               if( nay>naz )
                  {
                  // remove y
                  cross0      =  v2dcross( p1.vz-p0.vz, p1.vx-p0.vx, i.vz-p0.vz, i.vx-p0.vx );
                  cross1      =  v2dcross( p3.vz-p1.vz, p3.vx-p1.vx, i.vz-p1.vz, i.vx-p1.vx );
                  cross2      =  v2dcross( p0.vz-p3.vz, p0.vx-p3.vx, i.vz-p3.vz, i.vx-p3.vx );
                  if( ((cross0 <0 && cross1 <0 && cross2 <0)||
                        (cross0 >0 && cross1 >0 && cross2 >0)) )
                     {
                     vmov( &COL_inter, &i );
                     COL_gamma16 = gamma;
                     COL_surftype   =  surftype;
                     COL_norm.vx =   norm.vx;
                     COL_norm.vy =   norm.vy;
                     COL_norm.vz =   norm.vz;

					// Mat 24/03/1999
					if(STATE.currlevel>=12&&STATE.currlevel<=15)
						if(COL_surftype==18)
							COL_surftype = 1;

                     return 1;
                     }
                  }
               else
                  {
                  // remove z
                  cross0      =  v2dcross( p1.vx-p0.vx, p1.vy-p0.vy, i.vx-p0.vx, i.vy-p0.vy );
                  cross1      =  v2dcross( p3.vx-p1.vx, p3.vy-p1.vy, i.vx-p1.vx, i.vy-p1.vy );
                  cross2      =  v2dcross( p0.vx-p3.vx, p0.vy-p3.vy, i.vx-p3.vx, i.vy-p3.vy );
                  if( ((cross0 <0 && cross1 <0 && cross2 <0)||
                       (cross0 >0 && cross1 >0 && cross2 >0)) )
                     {
                     vmov( &COL_inter, &i );
                     COL_gamma16 = gamma;
                     COL_surftype   =  surftype;
                     COL_norm.vx =   norm.vx;
                     COL_norm.vy =   norm.vy;
                     COL_norm.vz =   norm.vz;

					// Mat 24/03/1999
					if(STATE.currlevel>=12&&STATE.currlevel<=15)
						if(COL_surftype==18)
							COL_surftype = 1;

                     return 1;
                     }
                  }
               }
            }
         }

      norm.vx  =  *((s16*)pcnorm2+0);
      norm.vy  =  *((s16*)pcnorm2+1);
      norm.vz  =  *((s16*)pcnorm2+2);

      te.vx =  cl0.vx   -  p1.vx;
      te.vy =  cl0.vy   -  p1.vy;
      te.vz =  cl0.vz   -  p1.vz;

      da =  te.vx*(norm.vx)   +
            te.vy*(norm.vy)   +
            te.vz*(norm.vz)   ;//da;   1.19.12

      te.vx =  cl1.vx   -  p1.vx;
      te.vy =  cl1.vy   -  p1.vy;
      te.vz =  cl1.vz   -  p1.vz;

      db =  te.vx*(norm.vx)   +
            te.vy*(norm.vy)   +
            te.vz*(norm.vz)   ;//db;   1.19.12

//sprintf(debbuf,"x %d   y %d z %d", norm.vx, norm.vy, norm.vz  );
//RENDER_message(debbuf);

      if( !((db<=0) && (da>=0))  )continue;

      //if( db <0 && da<0)continue;
      //if( db >0 && da>0)continue;

      gammat   =  da<<8;
      gammab   =  (da-db)>>8;
		if(gammab==0)gammab = 1;//ATTN!
		gamma		=	 gammat / gammab;// gamma;	1.15.16

      d.vx  =  cl1.vx   -  cl0.vx;
      d.vy  =  cl1.vy   -  cl0.vy;
      d.vz  =  cl1.vz   -  cl0.vz;

      i.vx  =  (( d.vx*gamma  )>>16 ) + cl0.vx;//i;   1.31
      i.vy  =  (( d.vy*gamma  )>>16 ) + cl0.vy;// plane-line intersection point
      i.vz  =  (( d.vz*gamma  )>>16 ) + cl0.vz;
      // now test I is 'in' tri
		// project( ignore component) to largest norm component
      nax   =  vabss( norm.vx );
      nay   =  vabss( norm.vy );
      naz   =  vabss( norm.vz );
      if( (nax>nay) && (nax>naz) )
			{
			// remove x
         cross0      =  v2dcross( p1.vy-p3.vy, p1.vz-p3.vz, i.vy-p3.vy, i.vz-p3.vz );
			cross1		=	v2dcross( p2.vy-p1.vy, p2.vz-p1.vz, i.vy-p1.vy, i.vz-p1.vz );
         cross2      =  v2dcross( p3.vy-p2.vy, p3.vz-p2.vz, i.vy-p2.vy, i.vz-p2.vz );
         if( !((cross0 <0 && cross1 <0 && cross2 <0)||
               (cross0 >0 && cross1 >0 && cross2 >0)) )continue;
			}
		else
			{
			if( nay>naz )
				{
				// remove y
            cross0      =  v2dcross( p1.vz-p3.vz, p1.vx-p3.vx, i.vz-p3.vz, i.vx-p3.vx );
				cross1		=	v2dcross( p2.vz-p1.vz, p2.vx-p1.vx, i.vz-p1.vz, i.vx-p1.vx );
            cross2      =  v2dcross( p3.vz-p2.vz, p3.vx-p2.vx, i.vz-p2.vz, i.vx-p2.vx );
            if( !((cross0 <0 && cross1 <0 && cross2 <0)||
                  (cross0 >0 && cross1 >0 && cross2 >0)) )continue;
				}
			else
				{
				// remove z
            cross0      =  v2dcross( p1.vx-p3.vx, p1.vy-p3.vy, i.vx-p3.vx, i.vy-p3.vy );
				cross1		=	v2dcross( p2.vx-p1.vx, p2.vy-p1.vy, i.vx-p1.vx, i.vy-p1.vy );
            cross2      =  v2dcross( p3.vx-p2.vx, p3.vy-p2.vy, i.vx-p2.vx, i.vy-p2.vy );
            if( !((cross0 <0 && cross1 <0 && cross2 <0)||
                  (cross0 >0 && cross1 >0 && cross2 >0)) )continue;
				}
			}

//GPU_3dline( &i, &p1,0x0,0xff,0x0 );
//GPU_3dline( &i, &p2,0x0,0xff,0x0 );
//GPU_3dline( &i, &p3,0x0,0xff,0x0 );
//RENDER_message("BQ2!");
		vmov( &COL_inter, &i );
      COL_gamma16 = gamma;
      COL_surftype   =  surftype;
      COL_norm.vx =   norm.vx;
      COL_norm.vy =   norm.vy;
      COL_norm.vz =   norm.vz;

		// Mat 24/03/1999
		if(STATE.currlevel>=12&&STATE.currlevel<=15)
			if(COL_surftype==18)
				COL_surftype = 1;

      return 1;
      }
   return -1;
   }

///////////////////////////////////////////////////////////////////////////////////
// test for intersection between two line segments
// returns 1 and intersection if good
// returns -1 if none
// May not work with very long lines( slap Jon)
///////////////////////////////////////////////////////////////////////////////////
//PAIR_2D
//
s8  COL_2dline( PAIR_2D *l0, PAIR_2D *l1, PAIR_2D *s0, PAIR_2D *s1 )
      {
      s32   mins,maxs;
      s32   minl,maxl;
      s32   cps0,cps1;
      s32   cpl0,cpl1;
      s32   alpha16;
      PAIR_2D ds;
      PAIR_2D dl;
//      PAIR_2D ds0;
//      PAIR_2D ds1;
//      PAIR_2D dl0;
//      PAIR_2D dl1;

      // box test x
      if( s0->vx < s1->vx )
         {
         mins=s0->vx;
         maxs=s1->vx;
         }
      else
         {
         mins=s1->vx;
         maxs=s0->vx;
         }

      if( l0->vx < l1->vx )
         {
         minl=l0->vx;
         maxl=l1->vx;
         }
      else
         {
         minl=l1->vx;
         maxl=l0->vx;
         }

      if( minl > maxs )return -1;
      if( maxl < mins )return -1;
      /////////////

      // box test z
      if( s0->vz < s1->vz )
         {
         mins=s0->vz;
         maxs=s1->vz;
         }
      else
         {
         mins=s1->vz;
         maxs=s0->vz;
         }

      if( l0->vz < l1->vz )
         {
         minl=l0->vz;
         maxl=l1->vz;
         }
      else
         {
         minl=l1->vz;
         maxl=l0->vz;
         }

      if( minl > maxs )return -1;
      if( maxl < mins )return -1;
      /////////////

      ds.vx =  (s1->vx - s0->vx)>>2;
      ds.vz =  (s1->vz - s0->vz)>>2;

      dl.vx =  (l1->vx - l0->vx)>>2;
      dl.vz =  (l1->vz - l0->vz)>>2;

      // 2d cross prod for line 0-1
      cps1   =  ( l1->vx - s0->vx )*ds.vz - ( l1->vz - s0->vz)*ds.vx;
      cps0   =  ( l0->vx - s0->vx )*ds.vz - ( l0->vz - s0->vz)*ds.vx;
      if( (cps0^cps1) >= 0 )return  -1;
      /////////////////////////////

      // 2d cross prod for line 1-0
      cpl0   =  ( s0->vx - l0->vx )*dl.vz - ( s0->vz - l0->vz)*dl.vx;
      cpl1   =  ( s1->vx - l0->vx )*dl.vz - ( s1->vz - l0->vz)*dl.vx;
      if( (cpl0^cpl1) >= 0 )return  -1;
      /////////////////////////////


      if(((cps0-cps1)>>4) !=0 )
         {
         //alpha16=(cps0<<16)/(cps0-cps1);
            alpha16=(cps0<<4)/((cps0-cps1)>>4);

         COL_2dinter.vx  =  l0->vx +  ((alpha16*( l1->vx - l0->vx ))>>8);
         COL_2dinter.vz  =  l0->vz +  ((alpha16*( l1->vz - l0->vz ))>>8);
         }
      if(cps1>0)return 1;
      if(cps1<=0)return 2;

	  return -1;
	  }


/*
void coloptimus()
   {
    r0,r1,r2,r3
      if(cl0.vx<p0.vx && cl0.vx<p1.vx && cl0.vx<p2.vx &&
         cl1.vx<p0.vx && cl1.vx<p1.vx && cl1.vx<p2.vx )continue;

   xxx0= ( l0.vx ) | ( l0.vx<<6 ) | ( l0.x<<12 );
   etcy
   etcz
   xxx1= ( l1.vx ) | ( l1.vx<<6 ) | ( l1.x<<12 );
   etcy
   etcz

   *p0xp1xp2x

   r0 = *p0xp1xp2x;
   r1 =  r0-xxx0;
   r2 =  r0-xxx1;

   r1 &= 1000100001000;
   r2 &= 1000100001000;

   if (carry)continue();

   }
 */
/*

 (p0x-px)nx + (p0y-py)ny = -(p0y-py)ny
 (p0x-px)nx + (p0y-py)ny = -p0y.ny+py.ny
 (p0x-px)nx + (p0y-py)ny + p0y.ny= +py.ny

 (p0x-px)nx + (p0y-py)ny + p0y.ny= +py
  ny
 */

 //py  =  (p0x-x)nx + (p0z-z)nz   +p0y
 //       ---------------------
 //             ny

   //t.vx = va->vy;
   //t.vy =   -1;
   //t.vz =  vb->vy  ;



 //(b0x-l0x)(l1z-l0z) - (b0z-l0z)(l1x-l0x)
 //  b0xl1z-b0xl0z-l0xl1z+l0xl0z- b0zl1x-l0zl1x-l0zl1x+l0xl0z
