#include "header.h"
#include "mesh.h"
#include "camera.h"
#include "objects.h"
#include "collide.h"
#include "pickups.h"
#include "psx\mathpsx.h"
#include "PSX\PSX_libs.h"
#include "PSX\PSX_pcks.h"
#include "PSX\PSX_expn.h"
#include "PSX\soundPSX.h"

// Needed for collision rumble
#include "state.h"

///////////////////////////////////////////////////////////////////////////////////////////////
//    360 obj-obj collision
///////////////////////////////////////////////////////////////////////////////////////////////
//    Started:    5/1/99
//	  Geeza:	  J.coelho
//	  PSX:		  Yay
//    N64:        Like whatever.
//    Notes:      Try to be a nice person. Ian is a pigamuffin.
//                Must find where billie lives.
//                Time is nasty
//                Spunk man wos ere
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// External Declarations
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Private Declarations
///////////////////////////////////////////////////////////////////////////////////////////////

OBJ_STRUCT  *pobj0;
OBJ_STRUCT  *pobj1;

void  COL_bounce( OBJ_STRUCT *pobj0, OBJ_STRUCT *pobj1 );
void  COL_funct_null();
void  COL_funct_plyr();
void  COL_funct_pkup();
void  COL_funct_gascloud();
void  COL_funct_flam();
void  COL_funct_plas();
void  COL_funct_fog();

///////////////////////////////////////////////////////////////////////////////////////////////
// Definitions
///////////////////////////////////////////////////////////////////////////////////////////////

u32   *COL_oocgrid[COLGRIDMAXZ][COLGRIDMAXX];   // o-o coll grid

///////////////////////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// calcs intersection pos/time between two moving spheres(objects)
///////////////////////////////////////////////////////////////////////////////////////////////
s8  COL_timespheres( OBJ_STRUCT *pobj0, OBJ_STRUCT *pobj1 )
   {
   s16    ra=32,rb=32;
   vec32  dp;
   vec32  dv;
   s32    dsqr  =  4096;//(ra+rb)*(ra+rb);
   s32    eq,   t;
   s32    ca,cb,cc;
   s32    sroot;

   vec32 ca0,ca1,cb0,cb1;
   vec32 colpa,colpb;

   mov( ca0, OBJ_players[ pobj0->owner ].oldp );
   shr( ca0,10);
   mov( ca1, pobj0->p );
   shr( ca1,10);
   mov( cb0, OBJ_players[ pobj1->owner ].oldp );
   shr( cb0,10);
   mov( cb1, pobj1->p );
   shr( cb1,10);

   if( (ca0.vx+ra<cb0.vx-rb) && (ca0.vx+ra<cb1.vx-rb) && (ca1.vx+ra<cb0.vx-rb) && (ca1.vx+ra<cb1.vx-rb) )
      {
      return -1;
      }
   if( (cb0.vx+rb<ca0.vx-ra) && (cb0.vx+rb<ca1.vx-ra) && (cb1.vx+rb<ca0.vx-ra) && (cb1.vx+rb<ca1.vx-ra) )
      {
      return -1;
      }
   if( (ca0.vz+ra<cb0.vz-rb) && (ca0.vz+ra<cb1.vz-rb) && (ca1.vz+ra<cb0.vz-rb) && (ca1.vz+ra<cb1.vz-rb) )
      {
      return -1;
      }
   if( (cb0.vz+rb<ca0.vz-ra) && (cb0.vz+rb<ca1.vz-ra) && (cb1.vz+rb<ca0.vz-ra) && (cb1.vz+rb<ca1.vz-ra) )
      {
      return -1;
      }
   if( (ca0.vy+ra<cb0.vy-rb) && (ca0.vy+ra<cb1.vy-rb) && (ca1.vy+ra<cb0.vy-rb) && (ca1.vy+ra<cb1.vy-rb) )
      {
      return -1;
      }
   if( (cb0.vy+rb<ca0.vy-ra) && (cb0.vy+rb<ca1.vy-ra) && (cb1.vy+rb<ca0.vy-ra) && (cb1.vy+rb<ca1.vy-ra) )
      {
      return -1;
      }

   //if( pobj0 ==  &OBJ_objects[0] )
//      RENDER_message("good box");

   dp.vx  =  cb0.vx -  ca0.vx;
   dp.vy  =  cb0.vy -  ca0.vy;
   dp.vz  =  cb0.vz -  ca0.vz;

   dv.vx  =  (cb1.vx-cb0.vx)-(ca1.vx-ca0.vx)  ;
   dv.vy  =  (cb1.vy-cb0.vy)-(ca1.vy-ca0.vy)  ;
   dv.vz  =  (cb1.vz-cb0.vz)-(ca1.vz-ca0.vz)  ;
	// box test here do paths cross?

   //if( dp.vx> 128 || dp.vy> 128 || dp.vz> 128)RENDER_message("moverflow");
   //if( dp.vx<-128 || dp.vy<-128 || dp.vz<-128)RENDER_message("moverflow");

   //if( dv.vx> 128 || dv.vy> 128 || dv.vz> 128)RENDER_message("moverflow");
   //if( dv.vx<-128 || dv.vy<-128 || dv.vz<-128)RENDER_message("moverflow");

// (SX1-SX0)(SY1-SY0) - (SX1-SX0)(SY1-SY0);
//= (SX0SY1+SX1SY1+SX1SY0)-(SX0SY1+SX1SY0+SX1SY1);

	// quadratic coes
   cc =   ( dp.vx*dp.vx ) + ( dp.vy*dp.vy ) + ( dp.vz*dp.vz ) -dsqr;
   //FntPrint("cc %d",cc);

   cb =  (( dp.vx*dv.vx ) + ( dp.vy*dv.vy ) + ( dp.vz*dv.vz ))<<1;
   //FntPrint("cb %d",cb);

   ca =   ( dv.vx*dv.vx ) + ( dv.vy*dv.vy ) + ( dv.vz*dv.vz );// use 3dqhyp? //ca(+ve)
   //FntPrint("ca %d",ca);

   eq =  cb*cb - ((ca*cc)<<2);
   //sprintf(debbuf,"eq %d",eq);
   //RENDER_message(debbuf);

   if( eq < 0 )return -2; // Complex poo. No collision today thanks.

   sroot = SquareRoot0( eq );
   if(ca!=0)
      {
      t  =  (( -cb - sroot )<<15) / ca ;// t-> 0-0xffff
      //t  =  ((-cb<<15) - (sroot<<3)) / ca ;// t-> 0-0xffff
      }
   else
      {
      t  =  0xfffff;
      }

   if( (t>=0xffff) || (t<=0) )return -1; // No coll in this frame

   // hmmm

   //sprintf(debbuf,"ohhh! %d",G_cyc);
   //RENDER_message(debbuf);

   colpa.vx =  ca0.vx  +  ((t*(ca1.vx-ca0.vx))>>16);
   colpa.vy =  ca0.vy  +  ((t*(ca1.vy-ca0.vy))>>16);
   colpa.vz =  ca0.vz  +  ((t*(ca1.vz-ca0.vz))>>16);
   //circle( colpa.vx, colpa.vy, ra);

   colpb.vx =  cb0.vx  +  ((t*(cb1.vx-cb0.vx))>>16);
   colpb.vy =  cb0.vy  +  ((t*(cb1.vy-cb0.vy))>>16);
   colpb.vz =  cb0.vz  +  ((t*(cb1.vz-cb0.vz))>>16);
   //circle( colpb.vx, colpb.vy, rb);

   //shl( colpa, 10);
   //shl( colpb, 10);
   //mov( pobj0->p, colpa );
   //mov( pobj1->p, colpb );
   //COL_bounce( &OBJ_objects[0], &OBJ_objects[1] );
   //print(" t= %d",t);

   COL_bounce( pobj0, pobj1 );
   S2_sfxdynamic( 28 + (rand()&3), pobj0->p.vx>>8, pobj0->p.vz>>8, 0, 100, 4400+(rand()&511) );

   //mov( pobj0->p, OBJ_players[ pobj0->owner ].oldp  );
   //mov( pobj1->p, OBJ_players[ pobj1->owner ].oldp  );

   return 1;
   }

///////////////////////////////////////////////////////////////////////////////////////////////
// bounces/separates two touching objects
///////////////////////////////////////////////////////////////////////////////////////////////
void  COL_bounce( OBJ_STRUCT *pobj0, OBJ_STRUCT *pobj1 )
   {
	vec32	p0, p1, v0, v1, u;
   s32   l, s0, s1, fv0, fv1;
   s32   m0=10, m1=10, e=128;
   s32   in;

   //m0 =  OBJ_typeinfo[ pobj0->type ].mass;
   //m1 =  OBJ_typeinfo[ pobj1->type ].mass;

   //vsub( &pobj0->p, &pobj0->v );// prov res ob pos
   //vsub( &pobj1->p, &pobj1->v );

   mov( p0, pobj0->p );
   mov( p1, pobj1->p );

   mov( v0, pobj0->v );
   v0.vx >>= 8;//-8
   v0.vy >>= 8;//-8
   v0.vz >>= 8;//-8

   mov( v1, pobj1->v );
   v1.vx >>= 8;//-8
   v1.vy >>= 8;//-8
   v1.vz >>= 8;//-8

   mov( u, p1 );
   sub( u, p0 );

   u.vx >>= 8;//-8 distance vec
   u.vy >>= 8;
	u.vz >>= 8;

   l  =  vroot32( u.vx*u.vx + u.vy*u.vy + u.vz*u.vz );// -8
   //if(l<=256)
   if(1)
      {
      if(l)
         {
         u.vx  = ( u.vx<<8 )/l;  //8 dir unit vec
         u.vy  = ( u.vy<<8 )/l;  //8 dir unit vec
         u.vz  = ( u.vz<<8 )/l;  //8
         }
      s0 = u.vx * v0.vx + u.vy * v0.vy + u.vz * v0.vz;//0
      s1 = u.vx * v1.vx + u.vy * v1.vy + u.vz * v1.vz;//0

      // col vels
      fv0 = ( m0*s0 + m1*s1 - ((m1*e*(s0-s1))>>8) ) /
            (m0+m1);
      fv1 = ((e*(s0-s1))>>8) + fv0;

      //fv0   =  s1;//0
      //fv1   =  s0;//0

      // remove old component
      mov( v0, u );//8
      mov( v1, u );//8

      v0.vx = ( v0.vx * s0) >> 8;//0
      v0.vy = ( v0.vy * s0) >> 8;//0
      v0.vz = ( v0.vz * s0) >> 8;//0

      v1.vx = ( v1.vx * s1) >> 8;//0
      v1.vy = ( v1.vy * s1) >> 8;//0
      v1.vz = ( v1.vz * s1) >> 8;//0

      sub( pobj0->v, v0 );
      sub( pobj1->v, v1 );

      // add new component
      mov( v0, u );//8
      mov( v1, u );//8

      v0.vx = ( v0.vx * fv0) >> 8;//0
      v0.vy = ( v0.vy * fv0) >> 8;//0
      v0.vz = ( v0.vz * fv0) >> 8;//0

      v1.vx = ( v1.vx * fv1) >> 8;//0
      v1.vy = ( v1.vy * fv1) >> 8;//0
      v1.vz = ( v1.vz * fv1) >> 8;//0

      add( pobj0->v, v0 );
      add( pobj1->v, v1 );

      // extra bounce for luck
      shl( u,5 );
      sub( pobj0->v, u );
      add( pobj1->v, u );


      //limit y-vel
      if( pobj0->v.vy  >  20000 )pobj0->v.vy=  20000;
      if( pobj0->v.vy  < -20000 )pobj0->v.vy= -20000;

      if( pobj1->v.vy  >  20000 )pobj1->v.vy=  20000;
      if( pobj1->v.vy  < -20000 )pobj1->v.vy= -20000;

      /*
      in =  (200-l)>>1;
      if(l>200)
         {
         }
      else
         {
         scale(u,in);
         sub(pobj0->p, u);
         add(pobj1->p, u);
         }
      */
      }
   }

///////////////////////////////////////////////////////////////////////////////////////////////
// scans near objects in blast radius and applies force/damage
///////////////////////////////////////////////////////////////////////////////////////////////
void  COL_blast( vec32 *pos, s16 blaststrength )
   {
   s16   i;
   s32   len;
   s32   dismod;
   vec32 u;
   vec32 v;

   pobj0 =  &OBJ_objects[0];
   for(i=0;i<STATE.wankers;i++, pobj0++)
      {
      if( pobj0->stat==OFF )continue;
      if( pobj0->type!=OTcraft )continue;

      v.vx  =  ( pobj0->p.vx>>8 )   -   ( pos->vx>>8 );
      v.vy  =  ( pobj0->p.vy>>8 )   -   ( pos->vy>>8 );
      v.vz  =  ( pobj0->p.vz>>8 )   -   ( pos->vz>>8 );

      len   =  vqlen( v.vx, v.vy, v.vz );
      if( len>0 )
         {
         dismod   =  3000-len;
         if( dismod>0 )
            {
            v.vx  *= (dismod<<8);
            v.vy  *= (dismod<<8);
            v.vz  *= (dismod<<8);

            v.vx  /= len;
            v.vy  /= len;
            v.vz  /= len;

            v.vx  *= blaststrength;
            v.vy  *= blaststrength;
            v.vz  *= blaststrength;

            if(v.vx >2000)v.vx=2000;
            if(v.vx <-2000)v.vx=-2000;

            if(v.vy >2000)v.vy=2000;
            if(v.vy <-2000)v.vy=-2000;

            if(v.vz >2000)v.vz=2000;
            if(v.vz <-2000)v.vz=-2000;

            pobj0->v.vx  += v.vx>>8;
            pobj0->v.vy  += v.vy>>8;
            pobj0->v.vz  += v.vz>>8;
            }
         }
      }
   }

///////////////////////////////////////////////////////////////////////////////////////////////
// reset obj-obj collision grid/ used before objs movement
///////////////////////////////////////////////////////////////////////////////////////////////
void  COL_clearoocolgrid()
   {
   u32   *p, f;

   p =   (u32*)COL_oocgrid;
   for(f=0;f<COLGRIDMAXZ*COLGRIDMAXX;f++)*p++ = 0;
   }

///////////////////////////////////////////////////////////////////////////////////////////////
// links obj into col grid
///////////////////////////////////////////////////////////////////////////////////////////////
void  COL_addoocobj( OBJ_STRUCT *pobj )
   {
   s16   gx, gz;

   //dim   =  OBJ_typeinfo[ pobj->type ].coldim;
   //gx  =  R2CGX( pobj->p.vx-(dim<<8) );
   //gz  =  R2CGZ( pobj->p.vz+(dim<<8) );
   gx  =  R2CGX( pobj->p.vx )&31;
   gz  =  R2CGZ( pobj->p.vz )&31;

   //if( (gx>=0)+(gx<32)+(gz>=0)+(gz<32)==4 )// really necessary?
      {
      if( COL_oocgrid[gz][gx]== 0 )
         {
         // point gridpos to object
         //
         COL_oocgrid[gz][gx]  =  (u32*)pobj;
         }
      else
         {
         // point object to origonal obj
         // point gridpos to object
         pobj->link  =  (OBJ_STRUCT*)COL_oocgrid[gz][gx];
         COL_oocgrid[gz][gx]  =  (u32*)pobj;
         }
      }

   // link an object to collision grid
   }

///////////////////////////////////////////////////////////////////////////////////////////////
// tests (moved) objects for collision
// assumes obj 0-8 are plyrs 0-8
///////////////////////////////////////////////////////////////////////////////////////////////

s8 COL_offx[9]={  -1,0,1,     -1,0,1,  -1,0,1   };
s8 COL_offz[9]={  -1,-1,-1,   0,0,0,   1,1,1    };

s32	ancolstart;
s32	ancolend;

void  COL_objobj2()
   {
   s16               f, g;
   s16               gx, gz, ggx, ggz;
   OBJ_PLAYERSTRUCT  *pplyr;//   =  &OBJ_players[ plyr ];
   OBJ_PLAYERSTRUCT  *plyr_ptr;//   =  &OBJ_players[ plyr ];
	vec32			impact_vector;

   ancolstart=999;
   pobj0 =  &OBJ_objects[0];

   // check each player only
   for(f=0;f<MAXNUMOBJS;f++, pobj0++)
      {
      if( (pobj0->stat==ON) && ((pobj0->type==OTcraft)||pobj0->type==OTburst) )
         {
         gx  =  R2CGX( pobj0->p.vx );
         gz  =  R2CGZ( pobj0->p.vz );

         if( (gx<0)+(gx>=32)+(gz<0)+(gz>=32) )
            {
//sprintf(debbuf,"col bounds error",G_cyc);
//RENDER_message(debbuf);
            continue;
            }

         // scan adjacent grid squares
         for(g=0;g<9;g++)//poss cut to 4
            {
            ggx   =  (gx + COL_offx[g]) &31;
            ggz   =  (gz + COL_offz[g]) &31;

            pobj1 =  COL_oocgrid[ggz][ggx];
            // walk linked list until end
            while( pobj1 != 0 )
               {
               // objects
               if( (pobj0->type==OTcraft) && (pobj1->deleteme==0) )
                  {
                  // craft
                  if(   (pobj0 != pobj1) &&              //no self test
                        (pobj0->index != pobj1->owner) && //no test with owned object
                        ((pobj0->index < pobj1->index) ) ) // no test with prev test craft
                     {
                     //possible collision craft-obj , test further, qsphere test
                     s32   x, y, z;
                     s32   dis;
                     dis  =  OBJ_typeinfo[ pobj0->type ].coldim + OBJ_typeinfo[ pobj1->type ].coldim;

                     x  =  ( pobj1->p.vx   -  pobj0->p.vx )>>8;
                     y  =  ( pobj1->p.vy   -  pobj0->p.vy )>>8;
                     z  =  ( pobj1->p.vz   -  pobj0->p.vz )>>8;
                     //if( vqlen(x,y,z) < dis+300 )
                     if( vqlen(x,y,z) < dis )
                        {
                        //call appropriate funct
                        if (!((pobj1->type == OTpickup) && (pobj1->pkup_data.type == NULLVAL)))
                           OBJ_typeinfo[pobj1->type].COL_pfunct();
                        }
                     }
                  }
               else
                  {
                  // burst
                  if( (pobj1->type==OTmissile) || (pobj1->type==OTrocket) )
                     {
                     s32   x, y, z;
                     s32   dis;
                     dis  =  OBJ_typeinfo[ pobj0->type ].coldim + OBJ_typeinfo[ pobj1->type ].coldim;

                     x  =  ( pobj1->p.vx   -  pobj0->p.vx )>>8;
                     y  =  ( pobj1->p.vy   -  pobj0->p.vy )>>8;
                     z  =  ( pobj1->p.vz   -  pobj0->p.vz )>>8;
                     if( vqlen(x,y,z) < dis )
                        {
                        //call appropriate funct
sprintf(debbuf,"burst collision %d",G_cyc);
RENDER_message(debbuf);
                        }
                     }
                  }
               pobj1 =  pobj1->link;
               }
            // walk linked list until end
            }
         }
      }

   // weapons time

   // flame thrower
   pobj0 =  &OBJ_objects[0];
   for(f=0;f<STATE.wankers;f++, pobj0++)
      {
      if( (pobj0->stat==OFF) || (pobj0->type!=OTcraft) )continue;
      if( (OBJ_players[pobj0->index].flamer_in_use) &&
          (OBJ_players[pobj0->index].SIM_input_data & PAD_FRB ) )
         {
         pobj1 =  &OBJ_objects[0];
         for(g=0;g<STATE.wankers;g++, pobj1++)
            {
            s32   d,qd;
            vec32 v0,v1, vs;
            if(f==g)continue;
            if(pobj1->type!=OTcraft)continue;
            // test obj0 flame v obj1

            mov( v0, pobj0->p );
            shr( v0, 8 );
            mov( v1, pobj1->p );
            shr( v1, 8 );

            vs.vx = OBJ_players[f].SIM_objmat.m[0][0]   >>6;//8
            vs.vy = OBJ_players[f].SIM_objmat.m[1][0]   >>6;//8
            vs.vz = OBJ_players[f].SIM_objmat.m[2][0]   >>6;//8
            sub( v1, v0 );

            d  =  v1.vx*vs.vx + v1.vy*vs.vy + v1.vz*vs.vz;//8
            qd =  vqlen(v1.vx, v1.vy, v1.vz);

            if( (abs(d) < 100*256) && (qd<2000) )
               {
					plyr_ptr = &OBJ_players[pobj1->owner];

//					OBJ_damage_player(plyr_ptr, pobj0);

//					if (pobj0->stat)
//						OBJ_delobj(pobj0->index);
               //FntPrint("ooohhh mama!   %d,   %d\n", f,g);
               }
            }
         }
      }

   //if(STATE.gametype==1)
   if(STATE.numscreens==1)
      {
      // eight players
      for(f=0;f<STATE.wankers;f++)
         {
         if( OBJ_objects[f].stat==OFF )continue;
         for(g=0;g<STATE.wankers;g++)
            {
            if(g<=f)continue;
            if( OBJ_objects[g].stat==OFF )continue;
            COL_timespheres( &OBJ_objects[f], &OBJ_objects[g] );
            //FntPrint(" %d %d\n ", f,g);
            }
         }
      }
   else
      {
      // two players
      COL_timespheres( &OBJ_objects[0], &OBJ_objects[1] );
      }
   // plasma gun
   //for(f=0;f<MAXNUMOBJS;f++, pobj0++)
   //   {
   //   if( (OBJ_objects[f].type==OTlightning) && (OBJ_objects[f].stat==ON) )
   //      {
   //      pobj0 =  &OBJ_objects[ OBJ_objects[f].owner ];
   //      FntPrint("sizzle!  \n");
   //      }
   //   }
   ancolend=999;
   }

///////////////////////////////////////////////////////////////////////////////////////////////
// different col handling functions pobj0, pobj1 already set
///////////////////////////////////////////////////////////////////////////////////////////////

void  COL_funct_null()
   {
   // no collision i.e. smoke
   }

void  COL_funct_plyr()
   {
   //OBJ_players[ pobj0->owner ].stability=128;
   //OBJ_players[ pobj1->owner ].stability=128;

   //COL_bounce( pobj0, pobj1 );
   //OBJ_players[ pobj0->owner ].stability=0;
   //OBJ_players[ pobj1->owner ].stability=0;
   //sprintf(debbuf,"Ouch! %d %d",pobj0->owner,pobj1->owner );
   //RENDER_message(debbuf);
   //SOUND_sfx_dynamic( 13, 120, 254 );
   //FntPrint("player, %d, %d\n", pobj0->index,pobj1->index);
   //COL_timespheres( pobj0, pobj1 );
   }

void  COL_funct_pkup()
   {

   s32   has_pickup;
   u16   f, g;


   f  =  pobj0->index;
   g  =  pobj1->index;

   if (pobj1->pkup_data.type == NULLVAL)
		return;
   //collision!

   if ((OBJ_players[OBJ_objects[f].owner].flamer_in_use == FALSE) && (OBJ_players[OBJ_objects[f].owner].plasma_in_use == FALSE))
      has_pickup = PCK_collect_pickup(&OBJ_objects[g], &OBJ_players[OBJ_objects[f].owner]);
   else
      has_pickup = TRUE;

   if (has_pickup == FALSE)
   {
		pobj1->pkup_data.type = NULLVAL;
		pobj1->pkup_data.timer = 0;
//   }

//      OBJ_delobj(g);
//      PCK_init_pickup_object(OBJ_objects[g].pkup_data.type);
      //if(OBJ_objects[g].pkup_data.type == pck_torpedo)RENDER_message("pickup: torpedo");
      //if(OBJ_objects[g].pkup_data.type == pck_turbo)RENDER_message("pickup: high octane");
      //if(OBJ_objects[g].pkup_data.type == pck_shield)RENDER_message("pickup: shield");
      }

   }

void  COL_funct_weap()
   {
   u16         f, g, bollocks;
   OBJ_PLAYERSTRUCT        *plyr_ptr;
   vec32       impact_vector;

   f  =  pobj0->index;
   g  =  pobj1->index;

   plyr_ptr = &OBJ_players[OBJ_objects[f].owner]; //Used by Ian for calling shield code

   if( pobj1->type==OTmissile )
      {
	if (pobj1->fx_id != NULLVAL)
//	  PSX_expns[pobj1->fx_id].release_total = PSX_expns[pobj1->fx_id].total_flames;
	  PSX_flame_ctrls[pobj1->fx_id].used = PSX_flame_ctrls[pobj1->fx_id].total;

      SOUND_sfx_p(13, 32+(rand()&7));
	  pobj1->pkup_data.type = pck_missile;
//	  pobj1->pkup_data.type = missile_explosion;
      }

   if( pobj1->type==OTrocket )
      {
//	  	if (pobj1->fx_id != NULLVAL)
		if (pobj1->fx_id != NULLVAL)
	  		PSX_rocket_trail[pobj1->fx_id].in_use = FALSE;

      SOUND_sfx_p(13, 32+(rand()&7));
      }

   //FntPrint("bang\n");

	if (pobj1->index < 6)
		printf("what eh!!!\n");

	OBJ_damage_player(plyr_ptr, pobj1, FALSE);

   {
   // movement from hti
   vec32 p;
   p.vx  =  pobj1->p.vx  -  pobj1->v.vx;
   p.vy  =  pobj1->p.vy  -  pobj1->v.vy;
   p.vz  =  pobj1->p.vz  -  pobj1->v.vz;
   COL_blast( &p, 10 );
   }

//      if (OBJ_objects[g].stat)
//         OBJ_delobj(g);
//         }
      //}
   // explo sfx
//	OBJ_delobj(pobj1->index);
   }

void  COL_funct_gascloud()
   {
   u16         f, g;
   OBJ_PLAYERSTRUCT        *plyr_ptr;
   vec32       impact_vector;

   f  =  pobj0->index;
   g  =  pobj1->index;

   plyr_ptr = &OBJ_players[OBJ_objects[f].owner]; //Used by Ian for calling shield code
//   FntPrint("phewee!\n");

	OBJ_damage_player(plyr_ptr, pobj1, FALSE);
   }

void  COL_funct_flam()
   {
   }

void  COL_funct_plas()
   {
   }

void  COL_funct_fog()
   {
   }


/*
s32	COLLISION_spheresphere( vec32s32 *pa, vec32s32 *pb, vec32s32 *va, vec32s32 *vb )
	{
	vec32s32	dp, dv;        // diff in pos,vel
	s32			ca, cb, cc;		// quadratic coes
	s32			dsqr	= 400;   // distance squared
	s32			eq;
	s32			t;

	vmov( &dp, pb );
	vsub( &dp, pa );

	vmov( &dv, pb );
	vsub( &dv, pa );
	// box test here do paths cross?

	// quadratic coes
	ca	=	( dp.x*dp.x ) + ( dp.y*dp.y ) + ( dp.z*dp.z ) -dsqr;
	cb	=	( dp.x*dv.x ) + ( dp.y*dv.y ) + ( dp.z*dv.z );
   cc =  ( dv.x*dv.x ) + ( dv.y*dv.y ) + ( dv.z*dv.z );// use 3dqhyp?

	eq	=	cb*cb - ((ca*cc)<<2);

	if( eq < 0 )return -1; // Complex poo. No collision today thanks.

	t	=	(( -cb - (s32)sqrt( eq ) )<<16) / (ca<<1) ;// t-> 0-0xffff

	if( t>0xffff )return -1; // No coll in this frame

	vmov( &COLLISION_ispherea, va );
	vscale( &COLLISION_ispherea, t );
	COLLISION_ispherea.x>>=16;
	COLLISION_ispherea.y>>=16;
	COLLISION_ispherea.z>>=16;
	vadd( &COLLISION_ispherea, pa );


	vmov( &COLLISION_isphereb, vb );
	vscale( &COLLISION_isphereb, t );
	COLLISION_isphereb.x>>=16;
	COLLISION_isphereb.y>>=16;
	COLLISION_isphereb.z>>=16;
	vadd( &COLLISION_isphereb, pb );

	return 1;
	}
 */
//
/*
void  COL_objobj()
	{
   OBJ_PLAYERSTRUCT        *plyr_ptr;
   OBJ_PLAYERSTRUCT        *plyr_ptr2;
   vec32                   impact_vector;

	s32						i, j, boundary;

   s32   f, g, x,y, z ; //Has pickup is there so if you are in a track section and

	// assume both objects are in the same or adjacent render sections
	// test for plyr-plyr
	// test for plyr-bul

	for(f=0;f<MAXNUMOBJS;f++)
		{
      if( OBJ_objects[f].stat == OFF )continue;
      if( OBJ_objects[f].type == OTcraft )
			{
         plyr_ptr = &OBJ_players[OBJ_objects[f].owner]; //Used by Ian for calling shield code
			for(g=0;g<MAXNUMOBJS;g++)
				{
            if( OBJ_objects[g].stat == OFF )continue;
				if( g==f )continue;

            // plyr-plyr
            if( OBJ_objects[g].type == OTcraft )
               {
					x	=	( OBJ_objects[g].p.vx	-	OBJ_objects[f].p.vx )>>8;
               y  =  ( OBJ_objects[g].p.vy   -  OBJ_objects[f].p.vy )>>8;
			  		z	=	( OBJ_objects[g].p.vz	-	OBJ_objects[f].p.vz )>>8;
               deb8++;
               if( vqlen(x,y,z) < 200 )
			  			{
                  //collision!
                  COL_bounce( &OBJ_objects[f], &OBJ_objects[g] );
                  OBJ_players[ OBJ_objects[f].owner ].stability=0;
                  OBJ_players[ OBJ_objects[g].owner ].stability=0;
                  RENDER_message("Ouch!");


            #if NEWPAD
					// mats collison rumble
					{
                    int r = 255 - vqlen(x,y,z);
					if(r<0)
						r = -r;
					if(r>255)
						r = 255;
                    if((OBJ_objects[f].owner==0)||(OBJ_objects[g].owner==0))
                    if(STATE.numplayers>=1)
					    startRumble(0,r);
                    if((OBJ_objects[f].owner==1)||(OBJ_objects[g].owner==1))
                    if(!steer_mode)                 // iant botch
			//		if(STATE.numplayers>=2)			// maximum of 2 players ??
					    startRumble(4,r);
				    }
				#endif

                  //SOUND_sfx_dynamic( 13, g, 254 );
                  }
					}

            //PICKUP/WEAPON COLLISION
            //FLAME THROWER AND GAS CLOUD COLLISION
            for (i = 0; i < MAX_FLAMER_FLAMES; i++)
               {
               if (PSX_flamer_flames[i].in_use
            		&& PSX_flamers[PSX_flamer_flames[i].owner].owner != f)
                  {
	            	x = PSX_flamer_flames[i].position.vx - (OBJ_objects[f].p.vx >> 8);
                  y = 0;
                  z = PSX_flamer_flames[i].position.vz - (OBJ_objects[f].p.vz >> 8);

//	                deb8++;

//                  if (PSX_flamer_flames[i].type == flame)
//                     boundary = 50;

//                  if (PSX_flamer_flames[i].type == gas)
                     boundary = 100;

                  if(vqlen(x,y,z) < boundary)
                     {
                     //collision!
//	                    COL_bounce( f, g );
//	                    OBJ_players[ OBJ_objects[f].owner ].stability=0;
                     if (plyr_ptr->shield_strength)
                        {
	                        if (plyr_ptr->shield_strength >= 1)//OBJ_objects[PSX_flamers[PSX_flamer_flames[i].owner].owner].pkup_data.power)
	                        {
	                            plyr_ptr->shield_strength -= 1;//OBJ_objects[PSX_flamers[PSX_flamer_flames[i].owner].owner].pkup_data.power;

	                            impact_vector.vx = plyr_ptr->pobj->p.vx;
	                            impact_vector.vy = plyr_ptr->pobj->p.vy;
	                            impact_vector.vz = plyr_ptr->pobj->p.vz;

	                            PSX_init_shield_effect(plyr_ptr, &impact_vector);
	                        }
	                    }
	                    else
	                    {
	                        plyr_ptr->armour_level -= 1;//OBJ_objects[PSX_flamers[PSX_flamer_flames[i].owner].owner].pkup_data.power;

	                        if (plyr_ptr->armour_level <= 0)
	                        {
	                            //BANG !! Player dies!!!!!!!

								OPSX_init_new_explosion(&OBJ_objects[f], craft_explosion, OTHER_COLLISION);

                        //OBJ_initplayer(f,0,0);

	                            mprintf("You're dead player %d!\n", OBJ_players[OBJ_objects[f].owner].plyrnum);
	                            FntPrint("You're dead!\n");
	                        }
	                    }
	                }
            	}
			}

//GAS CLOUD COLLISIOSN
            for (i = 0; i < MAX_GAS_FLAMES; i++)
            {
               if (PSX_gas_flames[i].in_use
            		&& PSX_gas[PSX_gas_flames[i].owner].owner != f)
                  {
	            	x = PSX_gas_flames[i].position.vx - (OBJ_objects[f].p.vx >> 8);
                  y = 0;
                  z = PSX_gas_flames[i].position.vz - (OBJ_objects[f].p.vz >> 8);

//	                deb8++;

//                  if (PSX_flamer_flames[i].type == flame)
//                     boundary = 50;

//                  if (PSX_flamer_flames[i].type == gas)
                     boundary = 100;

                  if(vqlen(x,y,z) < boundary)
                     {
                     //collision!
//	                    COL_bounce( f, g );
//	                    OBJ_players[ OBJ_objects[f].owner ].stability=0;
                     if (plyr_ptr->shield_strength)
                        {
	                        if (plyr_ptr->shield_strength >= 10)//OBJ_objects[PSX_gas[PSX_gas_flames[i].owner].owner].pkup_data.power)
	                        {
	                            plyr_ptr->shield_strength -= 10;//OBJ_objects[PSX_gas[PSX_gas_flames[i].owner].owner].pkup_data.power;

	                            impact_vector.vx = plyr_ptr->pobj->p.vx;
	                            impact_vector.vy = plyr_ptr->pobj->p.vy;
	                            impact_vector.vz = plyr_ptr->pobj->p.vz;

	                            PSX_init_shield_effect(plyr_ptr, &impact_vector);
	                        }
	                    }
	                    else
	                    {
	                        plyr_ptr->armour_level -= 10;//OBJ_objects[PSX_gas[PSX_gas_flames[i].owner].owner].pkup_data.power;

	                        if (plyr_ptr->armour_level <= 0)
	                        {
	                            //BANG !! Player dies!!!!!!!

								OPSX_init_new_explosion(&OBJ_objects[f], craft_explosion, OTHER_COLLISION);

                        //OBJ_initplayer(f,0,0);

	                            mprintf("You're dead player %d!\n", OBJ_players[OBJ_objects[f].owner].plyrnum);
	                            FntPrint("You're dead!\n");
	                        }
	                    }
	                }
            	}
			}
//END OF GAS CLOUD COLLISIOSN

//PLASMA GUN COLLISION

            for (i = 0; i < MAX_PLASMAS; i++)
			{
				if (PSX_plasma[i].in_use
            		&& PSX_plasma[i].plyr_owner != f)
				{
					for (j = 0; j < MAX_PLASMA_SECTIONS; j++)
					{
		            	x = PSX_plasma[i].section[j].origin.vx - (OBJ_objects[f].p.vx >> 8);
						y = 0;
		                z = PSX_plasma[i].section[j].origin.vz - (OBJ_objects[f].p.vz >> 8);

//		                deb8++;

		                if(vqlen(x,y,z) < 50)
		                {
		                    //collision!
//		                    COL_bounce( f, g );
//		                    OBJ_players[ OBJ_objects[f].owner ].stability=0;

		                    if (plyr_ptr->shield_strength)
		                    {
		                        if (plyr_ptr->shield_strength >= OBJ_objects[PSX_plasma[i].owner].pkup_data.power)
		                        {
		                            plyr_ptr->shield_strength -= OBJ_objects[PSX_plasma[i].owner].pkup_data.power;

		                            impact_vector.vx = plyr_ptr->pobj->p.vx;
		                            impact_vector.vy = plyr_ptr->pobj->p.vy;
		                            impact_vector.vz = plyr_ptr->pobj->p.vz;

		                            PSX_init_shield_effect(plyr_ptr, &impact_vector);
		                        }
		                    }
		                    else
		                    {
		                        plyr_ptr->armour_level -= OBJ_objects[PSX_plasma[i].owner].pkup_data.power;

		                        if (plyr_ptr->armour_level <= 0)
		                        {
		                            //BANG !! Player dies!!!!!!!

									OPSX_init_new_explosion(&OBJ_objects[f], craft_explosion, OTHER_COLLISION);

                           //OBJ_initplayer(f);

		                            mprintf("You're dead player %d!\n", OBJ_players[OBJ_objects[f].owner].plyrnum);
		                            FntPrint("You're dead!\n");
		                        }
		                    }
		                }
					}
            	}
			}

//OTHER WEAPON COLLISION

			if (((OBJ_objects[g].type == OTtorpedo) ||
            	(OBJ_objects[g].type == OTion) ||
            	(OBJ_objects[g].type == OTcluster) ||
            	(OBJ_objects[g].type == OTfragment) ||
				(OBJ_objects[g].type == OTbullet) ||
			   	(OBJ_objects[g].type == OTrocket) ||
            	(OBJ_objects[g].type == OTmissile) ||
            	(OBJ_objects[g].type == OTmine))
				&& (OBJ_objects[g].owner != f))

            {
            x = (OBJ_objects[g].p.vx - OBJ_objects[f].p.vx) >> 8;
				y = 0;
            z = (OBJ_objects[g].p.vz - OBJ_objects[f].p.vz) >> 8;
            if(vqlen(x,y,z) < 150)
               {
               if (plyr_ptr->shield_strength)
                  {
                  if (plyr_ptr->shield_strength >= OBJ_objects[g].pkup_data.power)
                     {
                     plyr_ptr->shield_strength -= OBJ_objects[g].pkup_data.power;
                     impact_vector.vx = plyr_ptr->pobj->p.vx;
                     impact_vector.vy = plyr_ptr->pobj->p.vy;
                     impact_vector.vz = plyr_ptr->pobj->p.vz;
                     PSX_init_shield_effect(plyr_ptr, &impact_vector);
                     }
                  }
                  else
                  {
                  plyr_ptr->armour_level -= OBJ_objects[g].pkup_data.power;
						OPSX_init_new_explosion(&OBJ_objects[g], OBJ_objects[g].pkup_data.type, SHIP_COLLISION);

                  if (plyr_ptr->armour_level <= 0)
                     {
							OPSX_init_new_explosion(&OBJ_objects[g], craft_explosion, OTHER_COLLISION);
							OBJ_delobj(OBJ_objects[f].index);
                     mprintf("You're dead player %d!\n", OBJ_players[OBJ_objects[f].owner].plyrnum);
                     FntPrint("You're dead!\n");
                     }
                  }
               }
            }

            //plyr-toprpickup
            if(OBJ_objects[g].type == OTpickup)
               {
					x	=	( OBJ_objects[f].p.vx	-	OBJ_objects[g].p.vx >> 8);
               y  =  ( OBJ_objects[f].p.vy  -  OBJ_objects[g].p.vy >> 8);
			  		z	=	( OBJ_objects[f].p.vz	-	OBJ_objects[g].p.vz >> 8);
               deb8++;
               if( vqlen(x,y,z) < 200 )
                  {
                  s32   has_pickup;
                  //collision!
                  if (OBJ_players[OBJ_objects[f].owner].flamer_in_use == FALSE)
		               has_pickup = PCK_collect_pickup(&OBJ_objects[g], &OBJ_players[OBJ_objects[f].owner]);
                  else
                     has_pickup = TRUE;

                  if (has_pickup == FALSE)
                     {

                    OBJ_delobj(g);

                    if(OBJ_objects[g].pkup_data.type == pck_torpedo)RENDER_message("pickup: torpedo");
                    if(OBJ_objects[g].pkup_data.type == pck_turbo)RENDER_message("pickup: high octane");
                    if(OBJ_objects[g].pkup_data.type == pck_shield)RENDER_message("pickup: shield");

                    PCK_init_pickup_object(OBJ_objects[g].pkup_data.type);
                     }
                  }
               }
			   }
			}
		}
   }
  */
///////////////////////////////////////////////////////////////////////////////////////////////
// test map for intersection with ray, then test objects
///////////////////////////////////////////////////////////////////////////////////////////////
// void COL_raytest( vec32 *l0, vec32 *l1 )
//   {
//   #define  SHIFT 8
//   #define  GRID  (1<<SHIFT)
//   s16      maxlen=0;
//   s8       quad;
//   s32      f, dp;

//   s32   bx,bz;
//   s32   gx,gz;
//   s32   l0x,l0z;
//   s32   l1x,l1z;
//   s32   dx,dz;
//   s32   dgx,dgz;
//   s32   cx,cz;

//   l0x   =  l0->vx>>8;
//   l0z   =  l0->vz>>8;
//   l1x   =  l1->vx>>8;
//   l1z   =  l1->vz>>8;

//   gx =  R2CGX(l0->vx);
//   gz =  R2CGZ(l0->vz);

//   if(l1x>l0x)
//      {
//      quad= -1;
//      cx =  (l1x>>SHIFT)-(l0x>>SHIFT);
//      dx =   (l1z-l0z)<<SHIFT;
//      bx =  (l0x&~(GRID-1))+GRID;
//      dgx= 1;
//      }
//   else
//      {
//      quad= 1;
//      cx =  (l0x>>SHIFT)-(l1x>>SHIFT);
//      dx =  -(l1z-l0z)<<SHIFT;
//      bx =  (l0x&~(GRID-1));
//      dgx=-1;
//      }

//   if(l1z>l0z)
//      {
//      cz =  (l1z>>SHIFT)-(l0z>>SHIFT);
//      dz =  -(l1x-l0x)<<SHIFT;
//      bz =  (l0z&~(GRID-1))+GRID;
//      dgz= -1;//inversion cos coll grid
//      }
//   else
//      {//isign
//      quad=-quad;
//      cz =  (l0z>>SHIFT)-(l1z>>SHIFT);
//      dz =  (l1x-l0x)<<SHIFT;
//      bz =  (l0z&~(GRID-1));
//      dgz= 1;//inversion cos coll grid
//      }

//   dp =  (bx-l0x)*(l1z-l0z)-(bz-l0z)*(l1x-l0x);

//   while( (cx>=0) && (cz>=0) && ( maxlen-- >=0) )
//      {
//      if(MESH_map[gz][gx]!=0xffffffff)

//      //grid( gx, gz, 1 );
//      if( sgn(dp)==quad )
//         {
//         cx--;
//         dp+=dx;
//         gx+=dgx;
//         }
//      else
//         {
//         cz--;
//         dp+=dz;
//         gz+=dgz;
//         }
//      }
//   }
/*
void  raycast()
   {
   #define  BITSWORLDSIZE  16
   #define  BITSGRID       2
   #define  GRIDUNITLEN    ( 1<< (BITSWORLDSIZE-BITSGRID) )
   #define  SHIFT          (BITSWORLDSIZE-BITSGRID)

   s16      maxlen=30;
   s8       quad;
   s32   f, dp;

   s32   bx,bz;
   s32   gx,gz;
   s32   l0x,l0z;
   s32   l1x,l1z;
   s32   dx,dz;
   s32   dgx,dgz;
   s32   cx,cz;

   //l0x   =  xx0;// your co-ords go here
   //l0z   =  zz0;
   //l1x   =  xx1;
   //l1z   =  zz1;

   if(l1x>l0x)
      {
      quad= -1;
      cx =  (l1x>>SHIFT)-(l0x>>SHIFT);
      dx =   (l1z-l0z)<<SHIFT;
      bx =  (l0x&~(GRIDUNITLEN-1))+GRIDUNITLEN;
      dgx= 1;
      }
   else
      {
      quad= 1;
      cx =  (l0x>>SHIFT)-(l1x>>SHIFT);
      dx =  -(l1z-l0z)<<SHIFT;
      bx =  (l0x&~(GRIDUNITLEN-1));
      dgx=-1;
      }

   if(l1z>l0z)
      {
      cz =  (l1z>>SHIFT)-(l0z>>SHIFT);
      dz =  -(l1x-l0x)<<SHIFT;
      bz =  (l0z&~(GRIDUNITLEN-1))+GRIDUNITLEN;
      dgz= 1;
      }
   else
      {//isign
      quad=-quad;
      cz =  (l0z>>SHIFT)-(l1z>>SHIFT);
      dz =  (l1x-l0x)<<SHIFT;
      bz =  (l0z&~(GRIDUNITLEN-1));
      dgz=-1;
      }

   gx =  l0x>>SHIFT;
   gz =  l0z>>SHIFT;


   dp =  (bx-l0x)*(l1z-l0z)-(bz-l0z)*(l1x-l0x);

   while( (cx>=0) && (cz>=0) && ( (maxlen--) >=0) )
      {
      //grid( gx, gz, 1 );//do your stuff here
      if( sgn(dp)==quad )
         {
         cx--;
         dp+=dx;
         gx+=dgx;
         }
      else
         {
         cz--;
         dp+=dz;
         gz+=dgz;
         }
      }
   }

*/
///////////////////////////////////////////////////////////////////////////////////////////////
// note! Use poly cache for quick test
// some faces dont have to be edge tested( concave edge! )
// overflow detection debugging
// sphere-sphere use qhyp instead of circle?
///////////////////////////////////////////////////////////////////////////////////////////////