//
// Frontend.H
//
// Author: Mathew Twigg.
// Start: 22-sept-98
//
// Purpose: Selects players, level, all frontend stuff.
//

#if 0

#ifndef __FRONT__
#define __FRONT__

#if PSX
#include "sdlib\sdtypes.h"
#include "otlen.h"
#endif

#if N64
#include "n64core\control.h"
#include "n64\sdtypes.h"
#endif

#define debug 					0

#define	min(a,b)				(((a)>(b))?(b):(a))
#define	max(b,a)				(((a)>(b))?(b):(a))
#define	diff(a,b)				(((a)>(b))?((a)-(b)):((b)-(a)))

#define padSelect				0x0001
#define padStart				0x0008
#define padLup					0x0010
#define padLright				0x0020
#define padLdown				0x0040
#define padLleft				0x0080
#define padL2					0x0100
#define padR2					0x0200
#define padL1					0x0400
#define padR1					0x0800
#define padRup					0x1000
#define padRright				0x2000
#define padRdown				0x4000
#define padRleft				0x8000

#include "pal_ntsc.h"

#if PAL
#define XRES	512
#define YRES	256
#define	FPS		50
#endif

#if NTSC
#define XRES	512
#define YRES	240
#define	FPS		60
#endif


// Dummy functions currently
#if N64
extern void printf(char *,...);
extern void FntPrint(char *s,...);
#endif


void FRONTEND_LanguageSelect_Init();
void FRONTEND_LanguageSelect_Tick();


// Possible states of the frontend

enum{
	FRS_LANGSELECT = 0,
    FRS_LAST = 1
	};

enum{
	FCT_INIT = 0,
    FCT_TICK = 1,
    FCT_LAST = 2
	};

// Return types from FRONTEND_Start
enum{
	FR_Running = 0,		// Frontend still executing
	FR_Game = 1,		// Temp, start game normally
    FR_Abort = 2		// Timed out, used for stuff like demo.
	};


extern   APAD     SD_PadData[8];


#if PSX
//void resolveTpageUV(int bitDepth,int x,int y,int u,int v,u_short *tpage,u_char *up,u_char *vp);
#endif

#endif __FRONT__

#endif
