#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <libapi.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include <libmath.h>
#include <libcd.h>
#include <stdio.h>
#include <stdlib.h>

#include "header.h"
#include "frontend.h"
#include "fade.h"
#include "render.h"
#include "camera.h"
#include "objects.h"
#include "collide.h"
#include "sdlib\sdtypes.h"
#include "sdlib\sdfunc.h"
#include "ctrller.h"
#include "gameloop.h"
#include "state.h"
#include "PSX\PSX_pcks.h"
#include "PSX\PSX_expn.h"
#include "AI.h"
#include "psx\textPSX.h"
#include "psx\loadPSX.h"
#include "hue.h"
#include "menu.h"
#include "version.h"
#include "cdlib.h"
#include "rand.h"
#include "psx\mathpsx.h"
#include "psx\gpuPSX.h"
#include "sim.h"
#include "mesh.h"
#include "psx\onscreen.h"
#include "pickups.h"
#include "weapons.h"
#include "action.h"
#include "psx\soundpsx.h"
#include "poon.h"
#include "psx\gpupsx.h"
#include "s2.h"
#include "stack.h"

extern GsOT *MWotPtr;

extern   void	TWEAK_tweak();
extern	APAD	SD_PadData[8];

extern int fx_allowed;
extern   vec16 SIM_rp[];
extern   s16   SIM_numrp;
extern   void LoadIntro();

void  RENDER_swirl();
void PCK_process_missile(OBJ_STRUCT *);

void TBAR_bar(int x0,int x1,int y,int h,int r,int g,int b);
void TBAR_line(int x,int y,int h,int r,int g,int b);
void TBAR_draw(void);

int vs_f_init;
int vs_f_menu;
int vs_f_moveall;
int vs_f_render;
int vs_f_weap;
int vs_f_end;

int vs_f_rend_cam;
int vs_f_rend_upd;

int vs_f_upd_track;
int vs_f_upd_wake;
int vs_f_upd_obj;

        int maxd0=0,maxd1=0,maxd2=0;

int bng_timer_on;
int bng_timer_off;
int		drp_timer_on;
int		rip_timer_on;
int		gas_timer_on;
int		plyr_timer_on;
int		fla_timer_on;
int		pla_timer_on;
int	   	spl_timer_on;
int		drp_timer_off;
int		rip_timer_off;
int		gas_timer_off;
int		plyr_timer_off;
int		fla_timer_off;
int		pla_timer_off;
int	   	spl_timer_off;

int ons_timer_on;
int ons_timer_off;
int shd_timer_on;
int shd_timer_off;
int sfx_timer_on;
int sfx_timer_off;
///////////////////////////////////////////////////////////////////////////////////////////////
//		Game control loop.
///////////////////////////////////////////////////////////////////////////////////////////////
//	Started:		19/5/98
//	Geeza:			J.coolio
//	PSX:			Barely
//  N64:			Not too likely.
//  Notes:    I've died and gone to hell...  And theres no chicken McNuggets
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Globals
///////////////////////////////////////////////////////////////////////////////////////////////

// new pad stuff is declared in sdfunc.c
#if !NEWPAD
APAD	SD_PadData[8];
#endif

#if N64
u32   SplitScreen=2;
#endif

///////////////////////////////////////////////////////////////////////////////////////////////
// Private
///////////////////////////////////////////////////////////////////////////////////////////////

//s16 GAMELOOP_state  =    GLdebug;
s16   GAMELOOP_state  =    GLgame;
s16   GAMELOOP_task_fadein = 255;
void	GAMELOOP_game();
//void  GAMELOOP_intro();
void	GAMELOOP_pause();
void  GAMELOOP_debug();
void	GAMELOOP_tweak();
void  GAMELOOP_loadmenu();
void  GAMELOOP_fadeouttogame();
u32 GAMELOOP_pausecnt;
///////////////////////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////////////////////
void   GAMELOOP_doinput();

u8 RUMBLE[10]={1,0x03,1,0, 1,0x03,1,0};

void GAMELOOP_tick()
	{
//	printf("(G_cyc == %ld) G_cyc++\n",G_cyc);
	G_cyc++;
   SD_GetPadData((APAD*)&SD_PadData);

	switch(GAMELOOP_state)
		{
		case GLgame:
			GAMELOOP_game();
			break;

		case GLpause:
        	GAMELOOP_pause();
           	break;

      case GLtweak:
        	GAMELOOP_tweak();
            break;

      case GLdebug:
			GAMELOOP_debug();
            break;

      case GLloadmenu:
         GAMELOOP_loadmenu();
            break;

      case GLfadeouttogame:
         GAMELOOP_fadeouttogame();
            break;

        default:
        	break;
        }
	}

extern   GsOT        *ptrwot;//jof
extern   GsOT        Wotwin0[2];                    // OT header
extern   GsOT        Wotwin1[2];                    // OT header

extern   u32   SplitScreen;//from sdlibs
extern   u32   GPU_vsync[10];
extern   signed short fadeValue;      // 255 = black, 0 = off
extern   s16   RENDER_321startstate;
extern   s16   RENDER_alpha;

void  GAMELOOP_game()
	{
	int				ian, i, j;

	#if IAN
	SVECTOR			temp1, temp2;
	PAIR_2D			*AI_ptr;
	#endif

        GsInitVcount();


   if( STATE.demomode==1 )
      {
      if( (SD_PadData[0].push & PAD_START) || (SD_PadData[0].push & PAD_RD ) )
         {
         LoadIntro();
         }
      }

   OBJ_initobjlist();
   if( (!STATE.arena_mode) )
      RACE_doracepoints();


    STATE.raceclock++;           // (-n) = wait for start
    //if( (STATE.raceclock>750) && (STATE.demomode==1) )
    //     LoadIntro();

   //FntPrint("                 rclock(%d)\n", STATE.raceclock);
   // main drawing bit

	GPU_initdraw();
	SD_InitDraw();    // clear OT, reset GPU packet area pointer , set double buffer index

	CAM_c = 0;
	ptrwot = &Wotwin0[outbuf_idx];

    vs_f_init = GsGetVcount();
    if(  RENDER_321startstate==0 )
      fadeValue   =  RENDER_alpha;

    else
    if(  RENDER_321startstate==1 )
      fadeValue   =  0;

    menuUpdate();

    vs_f_menu = GsGetVcount();

#if 0
// Mattys cd pos counter
	{
	CDPOS p;
	CDLIB_Cpos(&p);
    sprintf(text,"CD Pos %2X:%02X:%02X",p.aMinute,p.aSecond,p.aFrame);
	TEXT_x = -240;
	TEXT_y = 84;
	TEXT_prstr(text,128,128,192);
	}
#endif

//   RENDER_swirl();


if(execGame)
	{
   OBJ_moveall();
   }

   switch( STATE.numscreens )
      {
      case 1:
         // one screen
         SplitScreen=1;// sdlib vvvar
         ptrwot  =  &Wotwin0[outbuf_idx];// sdlib vvvar
         CAM_c=0;

		if(execGame)
			CAMERA_camera();
		vs_f_rend_cam = GsGetVcount();
		RENDER_update();
		vs_f_rend_upd = GsGetVcount();

//		 SCRN_display_player_data(&OBJ_players[0]);
		 ons_timer_on = TRUE;
		 SCRN_display_player_data(&OBJ_players[camera_craft_num]);
		 ons_timer_off = TRUE;
         POON_wrongway0();

         break;

      case 2:
         // split screen
         SplitScreen=2;
         ptrwot  =  &Wotwin0[outbuf_idx];
         CAM_c=0;
 		if(execGame)
 	        CAMERA_camera();
         RENDER_update();
		 SCRN_display_player_data(&OBJ_players[0]);
         POON_wrongway0();

         ptrwot  =  &Wotwin1[outbuf_idx];
         CAM_c=1;
		if(execGame)
             CAMERA_camera();
         RENDER_update();
		 SCRN_display_player_data(&OBJ_players[1]);
         POON_wrongway1();

         break;
      }
   //FntPrint("x %d\n", OBJ_objects[0].v.vx>>8 );
   //FntPrint("z %d\n", OBJ_objects[0].v.vz>>8 );

   GPU_vsync[1]=VSync(1);

 //IAN TOMKINS WEAPONS CODE AND POLY DISPLAYING

//	if (CAM_c == 0)
//		PSX_display_lens_flare();

//	printf("%d%d%d%d%d%d%d%d%d%d\n", PSX_rocket_trail[0].in_use, PSX_rocket_trail[1].in_use, PSX_rocket_trail[2].in_use, PSX_rocket_trail[3].in_use, PSX_rocket_trail[4].in_use, PSX_rocket_trail[5].in_use, PSX_rocket_trail[6].in_use, PSX_rocket_trail[7].in_use, PSX_rocket_trail[8].in_use, PSX_rocket_trail[9].in_use);

vs_f_render = GsGetVcount();

	set_camera_matrix();
	set_identity_matrix();

if(execGame)
{
	plyr_timer_on = 210;
	for (i = 0; i < STATE.wankers; i++)
	{
		PCK_process_pickups(&OBJ_players[i], &OBJ_objects[OBJ_players[i].pobj->index]);
     	WPN_process_weapon(&OBJ_players[i]);
	}
	plyr_timer_off = 220;

   	for (i = 0; i < MAX_PLASMAS; i++)
   	{
		pla_timer_on = 70;
    	if (PSX_plasma[i].in_use)
        	PSX_process_plasma_weapon(&PSX_plasma[i], OBJ_players[PSX_plasma[i].owner].pobj);
		pla_timer_off = 80;
   	}

   	for (i = 0; i < MAX_FLAMERS; i++)
   	{
		fla_timer_on = 50;
    	if (PSX_flamers[i].in_use)
        	PSX_process_flamer(&PSX_flamers[i]);
		fla_timer_off = 60;
   	}

   	for (i = 0; i < MAX_GAS_CLOUDS; i++)
   	{
		gas_timer_on = 90;
    	if (PSX_gas[i].in_use)
        	PSX_process_gas_cloud(&PSX_gas[i]);
		gas_timer_off = 100;
   	}

   	for (i = 0; i < MAX_SPLASHES; i++)
   	{
		spl_timer_on = 150;

    	if (PSX_splash[i].in_use)
		{
			PSX_splash[i].timer ++;

			switch (PSX_splash[i].type)
			{
				case torpedo_splash:
				case mine_splash:
				{
		        	PSX_process_splash(&PSX_splash[i]);

					if (PSX_splash[i].timer == 30)
						PSX_splash[i].in_use = FALSE;

					if (PSX_splash[i].timer == 1)
					{
						for (j = 0; j < PSX_splash[i].no_droplets; j++)
							PSX_init_droplet(&PSX_splash[i], water);
					}

					break;
				}

				case torpedo_exp_splash:
				case mine_exp_splash:
				{
					if (PSX_splash[i].timer < 40)
			        	PSX_process_distortion(&PSX_floor_splash[PSX_splash[i].floor_index]);
					else
					{
						PSX_splash[i].in_use = FALSE;
						PSX_floor_splash[PSX_splash[i].floor_index].in_use = FALSE;
						PSX_inner_splash[PSX_splash[i].inner_index].in_use = FALSE;
					}

					if (PSX_splash[i].timer == 10)
					{
						for (j = 0; j < PSX_splash[i].no_droplets; j++)
							PSX_init_droplet(&PSX_splash[i], fragment);
					}

		        	if (PSX_splash[i].timer >= 10)
			        	PSX_process_splash(&PSX_splash[i]);

		        	if (PSX_splash[i].timer >= 5)
			        	PSX_process_inner_splash(&PSX_inner_splash[PSX_splash[i].inner_index]);

					break;
				}

				default:
					break;
			}
		}
		spl_timer_off = 160;
   	}

	drp_timer_on = 170;
	for (i = 0; i < MAX_DROPLETS; i++)
	{
		if (PSX_droplet[i].in_use)
			PSX_process_droplet(&PSX_droplet[i]);
	}
	drp_timer_off = 180;

	rip_timer_on = 190;
	for (i = 0; i < MAX_RIPPLES; i++)
	{
		if (PSX_ripple[i].in_use)
			PSX_process_ripple(&PSX_ripple[i]);
	}
	rip_timer_off = 200;
 }

#if IAN

	if (global_player_num == camera_craft_num)
	{
	  	for (i = 0; i < (MAXNUMRP - 1); i++)
		{
			temp1.vx = RACE_points[i].vx;
			temp1.vy = RACE_points[i].vy;
			temp1.vz = RACE_points[i].vz;

			temp2.vx = RACE_points[i + 1].vx;
			temp2.vy = RACE_points[i + 1].vy;
			temp2.vz = RACE_points[i + 1].vz;

			if (OBJ_players[1].rp0 == i)
				display_vector(temp1, temp2, 0, 255, 0);
			else
				display_vector(temp1, temp2, 0, 255, 255);
		}

		AI_ptr = AI_course_map.list[0];

		for (i = 0; i < AI_course_map.total; i++)
		{
			temp1.vx = AI_ptr->vx;//course_map.list[i].vx;
			temp1.vy = 0;//AI_ptr->vy;//AI_test_map_a[j].vx;//course_map.list[i].vy;
			temp1.vz = AI_ptr->vz;// AI_test_map_a[j].vx;//course_map.list[i].vz;

			AI_ptr ++;

	//		printf("temp1.vx = %d : vz = %d : ", temp1.vx, temp1.vz);
			temp2.vx = AI_ptr->vx;// AI_test_map_a[j + 1].vx;//course_map.list[i + 1].vx;
			temp2.vy = 0;//AI_ptr->vy;// AI_test_map_a[j + 1].vx;//course_map.list[i + 1].vy;
			temp2.vz = AI_ptr->vz;// AI_test_map_a[j + 1].vx;//course_map.list[i + 1].vz;

	//		printf("temp1.vx = %d : vz = %d\n", temp1.vx, temp1.vz);

			AI_ptr ++;

	 		if ((temp1.vx == -1) && (temp1.vz == -1) &&
				(temp2.vx == -1) && (temp2.vz == -1))
					continue;
			else
				display_vector(temp1, temp2, 255, 255, 255);
		}
	}
#endif

 if(execGame)
	{
// 	bng_timer_on = TRUE;
//  	PSX_process_explosions();

//#if IAN
	PSX_process_flame_ctrls();
	PSX_process_flame_animations();
//#endif

// 	bng_timer_off = TRUE;


    for (ian = 0; ian < MAXNUMOBJS; ian++)
	{
		if(( OBJ_objects[ian].stat==ON )	&& (OBJ_objects[ian].deleteme == FALSE))
		{
			switch( OBJ_objects[ian].type )
			{
			    case  OTshield :
					shd_timer_on = TRUE;
					if (fx_allowed)
			         PSX_process_shield(&OBJ_objects[ian]);
					shd_timer_off = TRUE;
			         break;

			    case  OTmine :
					if (fx_allowed)
			         PCK_process_mine(&OBJ_objects[ian]);
			         break;

			    case  OTshield_effect :
					sfx_timer_on = TRUE;
					if (fx_allowed)
			         PSX_process_shield_effect(&PCK_shields[OBJ_objects[ian].fx_id]);
					sfx_timer_off = TRUE;
			         break;

		   	    case  OTgas :
					if (fx_allowed)
		   	         PCK_process_gas(&OBJ_objects[ian]);
		   	         break;

//	            case  OTflame :
//					if (fx_allowed)
//	                 PSX_process_flame_thrower(&OBJ_objects[ian]);
//	                 break;

			    case  OTmissile :
					if (fx_allowed)
			         PCK_process_missile(&OBJ_objects[ian]);
			         break;

//		   	    case  OTrocket_set :
//					if (fx_allowed)
//		   	         PCK_process_rocket_set(&OBJ_objects[ian]);
//		   	         break;

		   	    case  OTrocket :
					if (fx_allowed)
		   	         PCK_process_rocket(&OBJ_objects[ian]);
		   	         break;

		   	    case  OTstart_pt :
					if (fx_allowed)
		   	         PSX_process_burst_effect(&OBJ_objects[ian]);
		   	         break;

		   	    case  OTpickup :
					if (fx_allowed)
		   	         PSX_display_pickup_icon(&OBJ_objects[ian]);
		   	         break;

	            case  OTtracer :
					if (fx_allowed)
	                 WPN_process_tracer(&OBJ_objects[ian]);
	                 break;

				default:
					break;
			}
		}
	}
	}

vs_f_weap = GsGetVcount();

//	PSX_explosions();


 //END OF IAN TOMKINS WEAPONS CODE AND POLY DISPLAYING
   GPU_vsync[2]=VSync(1);

// old: Mattys menu system
// old: 	menuUpdate();

   S2_update();
   OBJ_delobjs();

 //To test for Packet area overflow
   SD_test_packet_area();

vs_f_end = GsGetVcount();

if(STATE.timebar)
        TBAR_draw();

   SD_EndDraw();


   //
   /*
   if( SD_PadData[4].push&PAD_FRT )
      {
      if( OBJ_players[0].crafttype<7 )OBJ_players[0].crafttype++;
      }

   if( SD_PadData[4].push&PAD_FLT )
      {
      if( OBJ_players[0].crafttype>0 )OBJ_players[0].crafttype--;
      }
   */

#if !CDMASTER
	if(SD_PadData[4].push&PAD_SEL)
		{
		GAMELOOP_state = GLtweak;
		}

	if((SD_PadData[0].push&PAD_SEL))
		{
		GAMELOOP_state = GLpause;
		GAMELOOP_pausecnt = 0;
		SOUND_setvol(0);
		//GAMELOOP_state = GLdebug;
		//RENDER_message("Debug Mode");
		}

#endif

	if(SD_PadData[0].push&PAD_START)
		{
		//--------- changed by matty 11/3/1999 2:30pm

		/*
		// quit game and load DJS intro
		SOUND_setvol(0);
		#if CDMASTER
      	LoadIntro();
		#else
		GAMELOOP_state = GLloadmenu;
		#endif
		*/

		if(menuState==MN_Disabled)
			menuState = MN_Pause;
		//menuState = MN_Start;
		GAMELOOP_state = GLgame;
		}

#if CDMASTER
#else
   if( SD_PadData[4].push&PAD_START)
		{
      if(STATE.numscreens==1)
         {
         CAM_cammode[0]=2;
         CAM_cammode[1]=2;
         RENDER_message("split screen mode");
         GPU_changesplitscreen(2);
         STATE.numscreens=2;
         }
      else
         {
         RENDER_message("single screen mode");
         GPU_changesplitscreen(1);
         STATE.numscreens=1;
         }
      }
#endif

//sprintf(debbuf,"objp %d, %d ", OBJ_objects[0].p.vx>>8, OBJ_objects[0].p.vz>>8 );
//RENDER_message(debbuf);

   if(GAMELOOP_task_fadein)GAMELOOP_task_fadein--;
   if(GAMELOOP_task_fadein)GAMELOOP_task_fadein--;
   if(GAMELOOP_task_fadein)GAMELOOP_task_fadein--;
   if(GAMELOOP_task_fadein)GAMELOOP_task_fadein--;
   if(GAMELOOP_task_fadein)GAMELOOP_task_fadein--;
}

void  GAMELOOP_debug()
   {
   GAMELOOP_task_fadein=0;


   if( (SD_PadData[0].push&PAD_SEL) )
      {
      GAMELOOP_state=GLgame;
      SOUND_setvol(127);
		}

   if (!(SD_PadData[0].data & PAD_LR))
      OBJ_objects[ 0 ].r.vy+=400;
   if (!(SD_PadData[0].data & PAD_LL))
      OBJ_objects[ 0 ].r.vy-=400;

   if (!(SD_PadData[0].data & PAD_FRT))
      OBJ_objects[ 0 ].p.vy-=8000;
   if (!(SD_PadData[0].data & PAD_FRB))
      OBJ_objects[ 0 ].p.vy+=8000;

   if (!(SD_PadData[0].data & PAD_LU))
      CAM_came[0].vx+=200;
   if (!(SD_PadData[0].data & PAD_LD))
      CAM_came[0].vx-=200;

   if (!(SD_PadData[0].data & PAD_RU))
      {
      OBJ_objects[ 0 ].p.vx+=rsin( OBJ_objects[ 0 ].r.vy>>4 )<<4;
      OBJ_objects[ 0 ].p.vz+=rcos( OBJ_objects[ 0 ].r.vy>>4 )<<4;
      }

   if (!(SD_PadData[0].data & PAD_RD))
      {
      OBJ_objects[ 0 ].p.vx-=rsin( OBJ_objects[ 0 ].r.vy>>4 )<<4;
      OBJ_objects[ 0 ].p.vz-=rcos( OBJ_objects[ 0 ].r.vy>>4 )<<4;
      }

   if (!(SD_PadData[0].data & PAD_RR))
      {
      OBJ_objects[ 0 ].p.vx+=rcos( OBJ_objects[ 0 ].r.vy>>4 )<<2;
      OBJ_objects[ 0 ].p.vz-=rsin( OBJ_objects[ 0 ].r.vy>>4 )<<2;
      }

   if (!(SD_PadData[0].data & PAD_RL))
      {
      OBJ_objects[ 0 ].p.vx-=rcos( OBJ_objects[ 0 ].r.vy>>4 )<<2;
      OBJ_objects[ 0 ].p.vz+=rsin( OBJ_objects[ 0 ].r.vy>>4 )<<2;
      }

   FntPrint("x%d y%d z%d ry%d\n",OBJ_objects[0].p.vx>>8,OBJ_objects[0].p.vy>>8,OBJ_objects[0].p.vz>>8, OBJ_objects[0].r.vy );
//sprintf(debbuf,"x%d y%d z%d ry%d",OBJ_objects[0].p.vx>>8,OBJ_objects[0].p.vy>>8,OBJ_objects[0].p.vz>>8, OBJ_objects[0].r.vy );
//RENDER_message(debbuf);

   SD_InitDraw();    // clear OT, reset GPU packet area pointer , set double buffer index
   SplitScreen=1;
   ptrwot  =  &Wotwin0[outbuf_idx];
   CAM_c=0;
   GPU_initdraw();


      {
      s32   c;
      vec32 v0,v1;
      v0.vx =  OBJ_objects[0].p.vx>>8;
      v0.vy =  (OBJ_objects[0].p.vy>>8)-200;
      v0.vz =  OBJ_objects[0].p.vz>>8;
      v1.vx =  v0.vx-300;
      v1.vy =  v0.vy+300;
      v1.vz =  v0.vz;

      GPU_3dline( &v0, &v1, 255,255,255 );
      c=COL_test2( &v0,&v1);
      if(c>=0)
         {
         s32   dp;
         v0.vx =  COL_inter.vx - v1.vx;
         v0.vy =  COL_inter.vy - v1.vy;
         v0.vz =  COL_inter.vz - v1.vz;

         dp = v0.vx*COL_norm.vx +
              v0.vy*COL_norm.vy +
              v0.vz*COL_norm.vz +
              200000;  //12


         dp >>= 4;//8
         v0.vx = (COL_norm.vx>>4) * dp; //16
         v0.vy = (COL_norm.vy>>4) * dp; //16
         v0.vz = (COL_norm.vz>>4) * dp; //16

         v0.vx>>=16;
         v0.vy>>=16;
         v0.vz>>=16;

         v0.vx = v1.vx + v0.vx;
         v0.vy = v1.vy + v0.vy;
         v0.vz = v1.vz + v0.vz;

         //GPU_3dline( &v1, &v0,0,5,255 );

         }
      }

   CAMERA_camera();
   RENDER_update();
   SD_EndDraw();
   }
//u8 *filenames_tim[]
extern u8 temp[];

void  GAMELOOP_gameloop()
	{
   while(1)
    	GAMELOOP_tick();
   }
/*
void  LOAD_getdir()
   {
   // gets a dir /s/b  file from pc
   s32   len, idxname=0, idxchar=0, f ;
   u8    *p;

   len   =  LOAD_readPCfile(temp, "c:\\360\\data\\dir.txt" );
   p  =  temp;

   for(f=0;f<len;f++)
      {
      if( (*p == 0x0d ) )
         {
         filename[ idxname ][ idxchar ] = 0;
         //next
         idxname++;
         idxchar=0;
         if( idxname >= 100 )break;
         p++;
         p++;
         }
      else
         {
         filename[ idxname ][ idxchar ] = *p;
         idxchar++;
         if( idxchar >= 100 )break;
         p++;
         }
      }
   }
*/

#if 0
void (*frFuncTable[FRS_LAST] [FCT_LAST])(void) =
    {
    {FRONTEND_LanguageSelect_Init	,FRONTEND_LanguageSelect_Tick}
    };

int frState = FD_NEXTSCREEN;

int frScreen = -1;
int nextFrScreen = FRS_LANGSELECT;
int nextGLstate = GLintro;

/*
void GAMELOOP_intro()
	{
#if PSX
    SD_GetPadData((APAD *)&SD_PadData);
#endif

    if(frState==FD_NEXTSCREEN)
    	{
        frScreen = nextFrScreen;
        GAMELOOP_state = nextGLstate;
        frState = FD_FADEIN;

        // Init this screen.
       	frFuncTable[frScreen] [FCT_INIT]();
        }

	// Process this screen
    if(GAMELOOP_state==GLintro)
    	{
#if PSX
        SD_InitDraw();
#endif

        processFade();
        frFuncTable[frScreen] [FCT_TICK]();

#if PSX
//		SD_EndDrawCls();

        DrawSync(0);
		VSync(1);
        ResetGraph(1);
		GsSwapDispBuff();
		GsSortClear(0,0,0,&Wot[outbuf_idx]);
		GsDrawOt(&Wot[outbuf_idx]);
        FntFlush(-1);
#endif
        }
    }
*/
#endif

u8 TXTpause[]  =  "360 PAUSED";


void	GAMELOOP_pause()
	{
   RECT  clip;

   //sdinitdraw
   outbuf_idx=GsGetActiveBuff();    // Get double buffer index
   GsSetWorkBase((PACKET*)out_packet[outbuf_idx]);
   GsClearOt(0,0,&Wotwin0[outbuf_idx]);   // Clear OT
   ptrwot  =  &Wotwin0[outbuf_idx];
   //sdinitdraw

   TEXT_x=-91;
   TEXT_y=-31;
   //TEXT_prstr("360", newhue2rgb[G_cyc&255].r,newhue2rgb[G_cyc&255].g,newhue2rgb[G_cyc&255].b);
   TEXT_prstr(TXTpause, 255,255,128);

   TEXT_x=-90;
   TEXT_y=-30;
   TEXT_prstr(TXTpause, 0,0,0);


   if(GAMELOOP_pausecnt==0 || GAMELOOP_pausecnt==1  )
      {
      POLY_FT4  polyft4;

      SetPolyFT4( &polyft4 );
      polyft4.u0  =  8<<1;   polyft4.v0  =  94;
      polyft4.u1  =  23<<1;  polyft4.v1  =  94;
      polyft4.u2  =  8<<1;   polyft4.v2  =  125;
      polyft4.u3  =  23<<1;  polyft4.v3  =  125;
      polyft4.tpage  =  GetTPage(1,0,712,350);
      polyft4.clut   =  GetClut(768,375);//8148;
      SetSemiTrans( &polyft4, 1 );

      polyft4.r0=228;
      polyft4.g0=102;
      polyft4.b0=102;

      polyft4.x0  =  -100;   polyft4.y0   =  -60;
      polyft4.x1  =   100;   polyft4.y1   =  -60;
      polyft4.x2  =  -100;   polyft4.y2   =   60;
      polyft4.x3  =   100;   polyft4.y3   =   60;

      GsSortPoly( &polyft4, ptrwot, 0 );
      }

   //sdenddraw
   DrawSync(0);               // wait for last frames drawing to be completed
   VSync(0);                 // Wait VSYNC 25/30 frames a second
   if(GAMELOOP_pausecnt==2)
      RENDER_dupbuf();

   ResetGraph(1); // new
   GsSwapDispBuff();            // Swap double buffer
	POSITION.offx=256;
	POSITION.offy=128;
	GsSetDrawBuffOffset();
   clip.x=POSITION.offx-256;
   clip.y=POSITION.offy-128;
   clip.w=512;
   clip.h=256;
   GsSetClip(&clip);
   GsDrawOt(ptrwot);

   //sdenddraw
   if( (SD_PadData[0].push&PAD_SEL) )
		{
      GAMELOOP_state=GLdebug;
      }

   GAMELOOP_pausecnt++;
	}

void	GAMELOOP_tweak()
	{
   SD_InitDraw();    // clear OT, reset GPU packet area pointer , set double buffer index
   SplitScreen=1;
   ptrwot  =  &Wotwin0[outbuf_idx];
   CAM_c=0;
   GPU_initdraw();

	TWEAK_tweak();
//RENDER_scanmodel2();

   if( SD_PadData[4].push&PAD_SEL)
		{
		GAMELOOP_state=GLgame;
		}
   RENDER_printmessages();
   SD_EndDraw();
	}

void  GAMELOOP_loadmenu()
   {
   SD_InitDraw();    // clear OT, reset GPU packet area pointer , set double buffer index
   SplitScreen=1;
   ptrwot  =  &Wotwin0[outbuf_idx];
   CAM_c=0;
   GPU_initdraw();
   LOAD_loadmenu();
   SD_EndDraw();
   }


void GAMELOOP_fadeouttogame()
	{
	if(G_cyc==2)
		RENDER_dupbuf();
	SD_InitDraw();    // clear OT, reset GPU packet area pointer , set double buffer index

	SplitScreen=1;

	//GPU_initdraw();
	//ptrwot  =  &Wotwin0[outbuf_idx];
	//CAM_c=0;

	RENDER_swirl();
	SD_EndDraw();

	if(G_cyc>300)
		{
		GAMELOOP_state = GLgame;

		printf("Inital State Flag == %d\n",arState);

//		if(arState==AR_PLAY)
//			arRestoreInitialState();
//		else
			arSaveInitialState();
		}
	}

void tbar(int tSt,int tFn,char *n,int p)
{
int y = (p*16)-80;
int len = (tFn - tSt) >> 1;
POLY_F4	pf4;

TEXT_x = -224;
TEXT_y = y;
M_TEXT_prstr(n,255,255,255);

SetPolyF4(&pf4);

pf4.x0 = -128;
pf4.y0 = y;
pf4.x1 = pf4.x0 + len;
pf4.y1 = pf4.y0;
pf4.x2 = pf4.x0;
pf4.y2 = pf4.y0 + 8;
pf4.x3 = pf4.x0 + len;
pf4.y3 = pf4.y0 + 10;

pf4.r0 = 148;
pf4.g0 = 118;
pf4.b0 = 118;

GsSortPoly(&pf4,MWotPtr,0);
}

void TBAR_draw(void)
	{
	// PAL: 314 scanlines per frame

	int i,n,d,p;
	int line[4] [2] [2];

	// Draw top bar

    d = vs_f_end;

	d = ((d+156)/157)*157;
 	if(d>maxd0)
		maxd0 = d;
	d = maxd0;

    n = (d+156)/157;
	p = (448*157)/d;

    TBAR_bar(32                         ,32+((vs_f_init*p)/157)    ,32+36+3,10,220,  0,  0);
    TBAR_bar(32+((vs_f_init*p)/157)    ,32+((vs_f_menu*p)/157)    ,32+36+3,10,  0,220,  0);
    TBAR_bar(32+((vs_f_menu*p)/157)    ,32+((vs_f_moveall*p)/157) ,32+36+3,10,  0,  0,220);
    TBAR_bar(32+((vs_f_moveall*p)/157) ,32+((vs_f_render*p)/157)  ,32+36+3,10,220,220,  0);
    TBAR_bar(32+((vs_f_render*p)/157)  ,32+((vs_f_weap*p)/157)    ,32+36+3,10,  0,220,220);
    TBAR_bar(32+((vs_f_weap*p)/157)    ,32+((vs_f_end*p)/157)     ,32+36+3,10,220,  0,220);

	// Draw frame marks under top bar

	for(i=0;i<n;i++)
        TBAR_line(32+(i*p),32+36,16,(i&1)?136:255,(i&1)?136:255,(i&1)?180:255);

    line[0] [0] [0] = 32+((vs_f_moveall*p)/157);
    line[0] [0] [1] = 32+36+16+8;
    line[1] [0] [0] = 32+((vs_f_render*p)/157);
    line[1] [0] [1] = 32+36+16+8;

	// Draw middle bar

    d = (vs_f_render-vs_f_moveall);

//	d = ((d+156)/157)*157;
 	if(d>maxd1)
		maxd1 = d;
	d = maxd1;

    n = (d+156)/157;
	p = (448*157)/d;

    TBAR_bar(32                                        ,32+(((vs_f_rend_cam-vs_f_moveall)*p)/157)  ,32+36+16+36+3,10,128,  0,  0);
    TBAR_bar(32+(((vs_f_rend_cam-vs_f_moveall)*p)/157) ,32+(((vs_f_rend_upd-vs_f_moveall)*p)/157)  ,32+36+16+36+3,10,  0,128,  0);
    TBAR_bar(32+(((vs_f_rend_upd-vs_f_moveall)*p)/157) ,32+(((vs_f_render  -vs_f_moveall)*p)/157)  ,32+36+16+36+3,10,  0,  0,128);

    line[0] [1] [0] = 32;
    line[0] [1] [1] = 32+36+16+36-8;
    line[1] [1] [0] = 32+(((vs_f_render  -vs_f_moveall)*p)/157);
    line[1] [1] [1] = 32+36+16+36-8;

    line[2] [0] [0] = 32+(((vs_f_rend_cam-vs_f_moveall)*p)/157);
    line[2] [0] [1] = 32+36+16+36+16+8;
    line[3] [0] [0] = 32+(((vs_f_rend_upd-vs_f_moveall)*p)/157);
    line[3] [0] [1] = 32+36+16+36+16+8;

	// Draw frame marks under middle bar

	for(i=0;i<n;i++)
        TBAR_line(32+(i*p),32+36+16+36,16,(i&1)?136:255,(i&1)?136:255,(i&1)?180:255);

	// Draw bottom bar

    d = (vs_f_rend_upd-vs_f_rend_cam);

//	d = ((d+156)/157)*157;
	if(d>maxd2)
		maxd2 = d;
	d = maxd2;

    n = (d+156)/157;
	p = (448*157)/d;

    TBAR_bar(32                                          ,32+(((vs_f_upd_track-vs_f_rend_cam)*p)/157),32+36+32+72+3,10,128,128,  0);
    TBAR_bar(32+(((vs_f_upd_track-vs_f_rend_cam)*p)/157) ,32+(((vs_f_upd_wake-vs_f_rend_cam)*p)/157) ,32+36+32+72+3,10,  0,128,128);
    TBAR_bar(32+(((vs_f_upd_wake-vs_f_rend_cam)*p)/157)  ,32+(((vs_f_upd_obj-vs_f_rend_cam)*p)/157)  ,32+36+32+72+3,10,128,  0,128);
    TBAR_bar(32+(((vs_f_upd_obj-vs_f_rend_cam)*p)/157)   ,32+(((vs_f_rend_upd-vs_f_rend_cam)*p)/157) ,32+36+32+72+3,10, 96, 96, 96);

	// Draw frame marks under bottom bar

	for(i=0;i<n;i++)
        TBAR_line(32+(i*p),32+36+32+72,16,(i&1)?136:255,(i&1)?136:255,(i&1)?180:255);

    line[2] [1] [0] = 32;
    line[2] [1] [1] = 32+36+16+36+16+36-8;
    line[3] [1] [0] = 32+(((vs_f_rend_upd-vs_f_rend_cam)*p)/157);
    line[3] [1] [1] = 32+36+16+36+16+36-8;

	for(i=0;i<4;i++)
		{
		GsLINE l;

	    setLineF2(&l);

        l.r = 224;
        l.g = 224;
        l.b = 224;
        l.x0 = line[i] [0] [0]-256;
        l.y0 = line[i] [0] [1]-128;
        l.x1 = line[i] [1] [0]-256;
        l.y1 = line[i] [1] [1]-128;

    	GsSortLine(&l,MWotPtr,0);
		}

    FntPrint("RT: %d\n",vs_f_rend_upd-vs_f_rend_cam);
    }

void TBAR_bar(int x0,int x1,int y,int h,int r,int g,int b)
	{
	POLY_F4	p;

    SetPolyF4(&p);

    p.r0 = r;
    p.g0 = g;
    p.b0 = b;

	p.x0 = x0-256;
	p.y0 = y-128;
	p.x1 = x1-256;
	p.y1 = y-128;
	p.x2 = x0-256;
	p.y2 = y-128+h;
	p.x3 = x1-256;
	p.y3 = y-128+h;

    GsSortPoly(&p,MWotPtr,0);
	}

void TBAR_line(int x,int y,int h,int r,int g,int b)
	{
	GsLINE l;

    setLineF2(&l);

	l.r = r;
	l.g = g;
	l.b = b;
	l.x0 = x-256;
	l.y0 = y-128;
	l.x1 = l.x0;
	l.y1 = l.y0 + h;

    GsSortLine(&l,MWotPtr,0);
	}
