// 36
#include "version.h"

#if N64
#include <ultra64.h>
#include <sched.h>
#endif

#define  TRUE     1
#define  FALSE    0
#define  ON       1
#define  OFF      0
#define  POSITIVE 1
#define  NEGATIVE -1
#define  NULLVAL  -1
//Set PAL or NTSC mode here->

#ifndef PAL

	#define  PAL   1
#endif

#ifndef NTSC

	#define  NTSC  0
#endif

//Sets the Time base for real time physics calculations, independent on PAL/NTSC modes
#if 	PAL
	#define	TIMEFRAME		0.04
#else
	#define	TIMEFRAME		0.03333333
#endif

//common #defs
#define  MAXNUMOBJS        200
#define	MAXNUMMESHOBJS		19
#define  MAXNUMMODELS      20
#define  MAXNUMPLAYERS     6

// PSX specific stuff
#if	PSX
   #define   print printf
   typedef signed char             s8;
	typedef unsigned char           u8;
	typedef unsigned short int      u16;
	typedef signed short int        s16;
	typedef unsigned long int       u32;
	typedef signed long int         s32;

#endif

// N64 specific stuff
#if	N64
	//#define	print robprint
#endif

// common global vars
extern   s32   deb0, deb1, deb2;       //global debug vars from main.c
extern   s32   deb3, deb4, deb5;       //from main.c
extern	s32	deb6, deb7, deb8, deb9; //from main.c
extern   u8    debbuf[256];               //from main.c
extern   s32   G_cyc;                  //from main.c

typedef struct
   {
   s16   vx;
   s16   vy;
   s16   vz;
   s16   pad;
   }vec16;

typedef struct
   {
   s32   vx;
   s32   vy;
   s32   vz;
   s32   pad;
   }vec32;

typedef struct
   {
   s16   m[3][3];
   s32   t[3];
   }mat16;

// sd stuff
typedef struct
   {
	vec16	a;
	vec16	b;
	vec16	c;
   }FACE_VERT;

typedef struct
   {
	vec16	a;
	vec16	b;
	vec16	c;
	vec16	d;
   }FACE_VERT4;

//Ian Tomkins #defines .

//For Weapons/Pickups
#define		MAXPICKUPS			15			//Maximum number of pickups a player can store.
#define		TVEL 				60000		//Velocity of a torpedo.
//#define		MVEL				65000		//Velocity of a missile.
#define		BVEL				100000		//Velocity of a bullets.
//#define		BSTVEL				1000
#define		FVEL				7000

//#def's for explosions
//#define		MAX_CTRL_STRUCTS	50

#define		KEEP				1
#define		LOSE				0

#define		UP					1
#define		DOWN				0

#define		DO_SCALE			1
#define		DONT_SCALE			0


#define		BOMB_RADIUS			5000


#define		MAX_OCTANES			10


//#define		TARGET_RANGE		(250 << 8)


#define		MAX_FLAMES			50
#define		MAX_FIRE_CTRL_STRUCTS	25

//#define		MAX_FLAME_SECTIONS	5

//#define		MAX_RIPPLE_SPLASHES	1
//#define		MAX_RIPPLE_CTRL_STRUCTS	1

#define		CANNON_ICON_INDEX	12
#define		MAX_ICONS			13
//#define		GRAVITY				(6 << 8)
//#define		MAX_ION_FRAGMENTS	25


#define		MAX_LENS_FLARES		12


//EXPLOSIONS

#define		MAX_EXPLOSIONS		25
#define     MAX_EXP_FLAMES    	250

#define		MAX_EXP_TIMS		26

#define		SHIP_COLLISION		0
#define		MESH_COLLISION		1
#define		OTHER_COLLISION		2

//END OF EXPLOSIONS

//SHIELD

//#define		SHIELD_LIFE			100
#define		MAX_SHIELD_STRENGTH	1000
#define		MAX_SHIELDS			15
#define		SHIELD_FACE_LENGTH	45000
#define		SHIELD_SEGMENT_WIDTH	6
#define		MAX_SHIELD_SIDES	8
#define		MAX_SHIELD_SEGMENTS	16

//END OF SHIELD

//PLASMA GUN

#define		MAX_PLASMAS				10

#define		POINT_DECAY				9
#define		MAX_PLASMA_PULSES		10

#define		MAX_PLASMA_SECTIONS		10
#define		MAX_PLASMA_LENGTH		750

#define		PLASMA_SECTION_LENGTH	 (MAX_PLASMA_LENGTH / MAX_PLASMA_SECTIONS)

//END OF PLASMA	GUN

//FLAMER

#define		MAX_FLAMER_FLAMES		150
#define		MAX_FLAMERS				10

//END OF FLAMER

//GAS CLOUD

#define		MAX_GAS_FLAMES			150
#define		MAX_GAS_CLOUDS			10

//END OF GAS CLOUD

//TORPEDO

#define		MAX_TORPEDO_WAKES		10
#define		TORPEDO_VELOCITY		350
#define		TORPEDO_ACCELERATION	10

//END OF TORPEDO

//MISSILE

#define		MISSILE_VELOCITY		350
#define		MISSILE_ACCELERATION	10

//END OF MISSILE

//ROCKETS

#define		MAX_ROCKET_TRAILS		50
#define		ROCKET_VELOCITY			350
#define		ROCKET_ACCELERATION		10

//END OF ROCKETS

//CANNON

#define		MAX_AMMO_LEVEL			5000
#define		BULLET_VELOCITY			350

//END OF CANNON

//FLARE

#define		FLARE_VELOCITY			235
#define		MAX_BURSTS				10
#define		BURST_FACE_LENGTH		10

//END OF FLARE

//SPLASH - 3D

#define		MAX_SPLASHES			10
#define		MAX_SPLASH_SEGMENTS		8
#define		MAX_SPLASH_FLOOR_SEGMENTS		16
#define		MAX_DROPLETS			20
#define		MAX_RIPPLES				50

//END OF SPLASH - 3D

//AI

//collision map
#define		MAX_AI_COLLISION_MAP_ENTRIES	2000
#define		MAX_AI_GRID_SECTIONS			16
#define		AI_GRID_WIDTH					(SquareRoot0(MAX_AI_GRID_SECTIONS))

//#define		MAX_SIGHT_LENGTH		7000
//#define		MAX_ANGLE				96


//END OF AI

//LENS FLARE

typedef struct
{
	short				vx;
	short				vz;

}PAIR_2D;


#define		MAX_SFX_CAMERA_RANGE			20000
