typedef unsigned long u32;
typedef signed long s32;

typedef struct {	// world type/tracknum 3 is arena/pos 1,2,3/actual num
char	HSNames[5][4][3][4];
u32   HSTimes[5][4][3];
char	HSNamesLap[4][3][3][4];	// no arenas needed in lap times!
u32   HSTimesLap[4][3][3];
}HSCORE;

// VARS FOR GAME AND MEM CARD

#define	Vs0 0
//1 ulong	- number of players in multi-player game
u32   *TheNumberOfPlayers=(u32 *)0x80010000+Vs0;
#define	Vs1 (Vs0+1)

//4 ulong	- craft each player has picked
u32   *ThePlayers=(u32 *)0x80010000+Vs1;
#define	Vs2 (Vs1+4)

//4 ulong	- pad index each player used
u32   *ThePads=(u32 *)0x80010000+Vs2;
#define	Vs3 (Vs2+4)

//1 ulong	- type of world.. water\ice\seabed\lava\jungle
u32   *WorldType=(u32 *)0x80010000+Vs3;
#define	Vs4 (Vs3+1)

//1 ulong   - track numb..0/1/2/3(arena)
u32   *TrackNum=(u32 *)0x80010000+Vs4;
#define	Vs5 (Vs4+1)

//1 ulong	- if 1 then on 1st run through
u32   *FIRST_RUN=(u32 *)0x80010000+Vs5;
#define	Vs6 (Vs5+1)

//1 ulong	- 0-Eng 1-Fre 2-Ger 3-Span 4-Ita 5-Swed
u32   *Language=(u32 *)0x80010000+Vs6;
#define	Vs7 (Vs6+1)

//1 ulong	- pad set up a/b/c
u32   *PadConfig=(u32 *)0x80010000+Vs7;
#define	Vs8 (Vs7+1)

//1 ulong	- what demo num are we on (even game/odd fmv)
u32   *DemoNum=(u32 *)0x80010000+Vs8;
#define	Vs9 (Vs8+1)

//1 ulong	- demo mode on if 1
u32   *DemoMode=(u32 *)0x80010000+Vs9;
#define	Vs10 (Vs9+1)

//4 ulong	- battle options
s32   *LROpt=(u32 *)0x80010000+Vs10;
#define	Vs11 (Vs10+4)

//1 ulong	- set to 1 to unhide car9
u32   *UnHideVehicle9=(u32 *)0x80010000+Vs11;
#define	Vs12 (Vs11+1)

// WHEN 1st load game if no mem card then this is what levels are playable
// if mem card save of game,  load over these vars with saved version
//5 ulong	- set to 1 if available to play
u32   *WorldAvailable=(u32 *)0x80010000+Vs12;
#define	Vs13 (Vs12+5)

//20 ulong	- set to 1 if available to play
u32   *TrackAvailable[5]={
(u32 *)0x80010000+Vs13+0,
(u32 *)0x80010000+Vs13+4,
(u32 *)0x80010000+Vs13+8,
(u32 *)0x80010000+Vs13+12,
(u32 *)0x80010000+Vs13+16};
#define	Vs14 (Vs13+20)

//192 ulong or 768 bytes	- high score table
HSCORE	*HighScore=(HSCORE *)(0x80010000+(Vs14*4));
#define	Vs15 (Vs14+(0x300/4))

//1 ulong	- what game mode are we in 0-battle 1-tourn 2-time 3-arcade
u32   *GameMode=(u32 *)0x80010000+Vs15;
#define	Vs16 (Vs15+1)


//1 ulong	- is rumble on/off 1 is on!
u32	*RumbleOn=(u32 *)0x80010000+Vs16;			 
#define	Vs17 (Vs16+1)

//1 ulong	- has data from mem card been loaded
u32	*MemCardDataLoaded=(u32 *)0x80010000+Vs17;			 
#define	Vs18 (Vs17+1)

//1 ulong	- arcade position loaded from mem card
u32	*ArcadePosLoaded=(u32 *)0x80010000+Vs18;			 
#define	Vs19 (Vs18+1)

//1 ulong	- just staring new arcade game if 1
u32	*NewArcadeGameNow=(u32 *)0x80010000+Vs19;			 
#define	Vs20 (Vs19+1)

//1 ulong	- set to 1 to unhide car6
u32	*UnHideVehicle6=(u32 *)0x80010000+Vs20;			 
#define	Vs21 (Vs20+1)

//1 ulong	- set to 1 if analog status on pad 0
u32	*PadAnalog0=(u32 *)0x80010000+Vs21;			 
#define	Vs22 (Vs21+1)

//1 ulong	- set to 1 if analog status on pad 1
u32	*PadAnalog1=(u32 *)0x80010000+Vs22;			 
#define	Vs23 (Vs22+1)

//1 ulong	- set to 1 if want to play completed game FMV
u32	*CompletedFMV=(u32 *)0x80010000+Vs23;			 
#define	Vs24 (Vs23+1)

u32	*ENDVARS=(u32 *)0x80010000+Vs24;
