#include <sys/types.h>
#include <stdio.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libcd.h>
#include <libds.h>
#include <libsn.h>
#include <libsnd.h>
#include <libspu.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include <libpad.h>
#include <libapi.h>
#include "frontend.h"
#include "sdlib\sdfunc.h"
#include "header.h"
#include "psx\mathpsx.h"
#include "render.h"
#include "psx\loadPSX.h"
#include "mesh.h"
#include "psx\soundPSX.h"
#include "state.h"
#include "gameloop.h"
#include "objects.h"
#include "pickups.h"
#include "psx\psx_pcks.h"
#include "psx\psx_expn.h"
#include "AI.h"
#include "version.h"
#include "collide.h"
#include "poon.h"
#include "memcard.h"
#include "cdlib.h"
#include "wake.h"
#include "action.h"
#include "loadit.h"
#include "camera.h"

// CDLib.c
extern u_char param[4];
extern u_char result[8];

#define H_SIZE 		2048
#define FORM1_SIZE	2048 				/* Size of an XA mode 1 form 1 sector. */
#define Sectors(x)	((x+FORM1_SIZE-1)/FORM1_SIZE) /* num sectrs from bytes */

int _read1(long,void *,int);
int cdload(char *,struct EXEC *);

#define speed  CdlModeSpeed 		/* dosnt work double speed !*/
//#define speed	0

struct	EXEC		exe;

u_char	readDone=0;
int		filesize=0;
int		frame=0;
int		left_to_load;
int		wait;
extern   int      i;


void	CdReadDoneF();
void 	LoadIntro();


void LoadIntro()
{

    mprintf("END GAME\n");

#if NEWPAD	// new pad stuff: todo: add stop pad stuff

PadStopCom();
#else
	StopTAP();
#endif
// Mat: 22/03/1999
//	DsReset();
//    VSync(0);
//    DsClose();
//    VSync(0);

	SsEnd();
	SsQuit();


// Mat: 22/03/1999
//	CdInit();
//	mprintf("MT_DEBUG: LoadIntro => CdInit\n");

// Mat: 22/03/1999
	CDLIB_Stop();		// stop current playback


	CdReadCallback((void *)CdReadDoneF);                  /* Set up read callback. */

	// Added by matty 16/03/1999
	param[0] = CdlModeRept|CdlModeDA|CdlModeSpeed;
	CdControlB(CdlSetmode, param, 0);

	cdload("\\LOADINTR.EXE;1",&exe);

//	SetDispMask(0);
	ResetCallback();
//	mprintf("MT_DEBUG: LoadIntro => CdInit [2]\n");
	CdInit();

// 	ResetGraph(0);

	StopRCnt(RCntCNT0);
	StopRCnt(RCntCNT1);
	StopRCnt(RCntCNT2);
	StopRCnt(RCntCNT3);

	ResetGraph(3);
//	PadStop();
	StopCallback();
  	exe.s_addr = 0x801fffff;
	exe.s_size = 0;
	EnterCriticalSection();
	Exec(&exe,1,0);

}





/* load exe file, ready for execution */

int
cdload(file,exep)

char *file;
struct EXEC *exep;
{
  CdlFILE	fp;			/* File location, size information */
  int	mode =speed;
  char hbuf[H_SIZE];			/* Buffer for EXE header */
  unsigned long offset;		/* Absolute sector location */
  int i;
  struct XF_HDR *head;

  for (i = 0; i < 10; i++) {	/* 10 times retrying */
    if (CdSearchFile(&fp, file) == 0)
      continue;



    /* Target position settng */
    CdControl(CdlSetloc, (u_char *)&(fp.pos), 0);
    left_to_load = _read1(H_SIZE,(void *)hbuf,mode);   /* EXE header reading */
    if(left_to_load)
      continue;

    head = (struct XF_HDR *)hbuf;
    memcpy((void *)exep, (void *)&head->exec, sizeof(struct EXEC));

    /* Convert the location information to the absolute sector.
      Increment it by 1 sector ( header of EXE file).
      Re-convert the sector to the loaction information.
    */
    offset = CdPosToInt(&fp.pos);
    offset++;
    CdIntToPos(offset,&fp.pos);

    /* Target position setting */
    CdControlB(CdlSetloc, (u_char *)&(fp.pos), 0);



    /* Program reading */
    left_to_load = _read1(exep->t_size, (void *)exep->t_addr, mode);

    /* Break if the normal end */

    if (left_to_load == 0)
    	return(0);	/* succeed */
  }

  return(-1);		/* fail */
}


int
_read1(byte,sectbuf,mode)

long byte;
void *sectbuf;
int mode;
{
  int nsector,left_to_load2;

  nsector = (byte+2047) / 2048;

  /* Starting to read */
  CdRead(nsector, sectbuf, mode);

  /* Normal processing can be performed in the background of reading. */
  /* Monitoring the number of left sectors until reading is completed. */



  while ((left_to_load2 = CdReadSync(1, 0)) > 0 )
	{
#if 0
/*	do_loading_disc(); 	   */

/*   VSync(0);  */

#if text
	ClearImage(&tc, 0, 0, 0);

	FntPrint(" loading %d",left_to_load2);
	FntFlush(-1);
#endif
#endif

#if debug
	pollhost();
#endif

	}

  return(left_to_load2);
}





/*+--------+----------+----------+----------+----------+----------+---------+*/

void CdReadDoneF()

/* This is the callback used in the asynchronous load example. It just sets  */
/* a flag to say that a read has finished.                                   */

  {
    readDone = 1;                                           /* Set the flag. */
  }

/*+--------+----------+----------+----------+----------+----------+---------+*/



