//
//  Memory card interface.
//
//  26/02/1999 : Created by Mathew Twigg.
//               init, stop, load, save, debug facility
//

#include <sys/types.h>
#include <kernel.h>	   
#include <libetc.h>	   
#include <libgte.h>	   
#include <libgpu.h>	   
#include <libgs.h>	   
#include <libsn.h>
#include <inline_c.h>
#include <libsnd.h>
#include <libspu.h>
#include <ctrller.h> 
#include <libmcrd.h>
#include <libapi.h>
#include <stdio.h>

#include "sdlib\sddemo.h"
#include "sdlib\sdtypes.h"

#include "header.h"
#include "memcard.h"

#define __DEBUG_MEMCARD	1


void MEMCARD_init(void)
	{
	#if __DEBUG_MEMCARD
	mprintf("MEMCARD:   MEMCARD_init()\n");
	#endif

    InitMemCardSystem();
    }

void MEMCARD_stop(void)
	{
	#if __DEBUG_MEMCARD
	mprintf("MEMCARD:   MEMCARD_stop()\n");
	#endif
	
    ExitMemCardSystem();
    }

void MEMCARD_save(register void *data,register u16 len)
	{
	#if __DEBUG_MEMCARD
	mprintf("MEMCARD:   MEMCARD_save()    (data==%p, len==%u)\n",data,len);
	#endif
	}

void MEMCARD_load(register void *data,register u16 len)
	{
	#if __DEBUG_MEMCARD
	mprintf("MEMCARD:   MEMCARD_load()    (data==%p, len==%u)\n",data,len);
	#endif
	}

void *MemCard_HandlerP;
volatile Uint32  MemCardResult;
volatile Uint32 MemCardFuncDone;

void InitMemCardSystem()
{
	ResetCallback();
	EnterCriticalSection();
	MemCardInit(0);				// Open Mem card lib.
	MemCardStart();				// Start mem card processing

	MemCard_HandlerP=MemCard_Handler;
	MemCardCallback(MemCard_HandlerP);	// Set up callbacks
	ExitCriticalSection();
}



void MemCard_Handler(unsigned long cmds, unsigned long result)
{
	switch (cmds)
	{
		case McFuncExist:
		{
			MemCardResult=result;
			MemCardFuncDone=1;
			break;
		}
		case McFuncAccept:
		{
			MemCardResult=result;
			MemCardFuncDone=1;
			break;
		}
		case McFuncReadFile:
		{
			MemCardResult=result;
			MemCardFuncDone=1;
			break;
		}
		case McFuncWriteFile:
		{
			MemCardResult=result;
			MemCardFuncDone=1;
			break;
		}
		case McFuncReadData:
		{
			MemCardResult=result;
			MemCardFuncDone=1;
			break;
		}
		case McFuncWriteData:
		{
			MemCardResult=result;
			MemCardFuncDone=1;
			break;
		}
	}
}




void ExitMemCardSystem()
{
	MemCardStop();				// Stop processing mem card operations
	MemCardEnd();				// Close mem card lib.

}



typedef struct {
	char	Magic[2];
	char	Type;
	char	BlockEntry;
	char	Title[64];
	char	reserve[28];
	char	Clut[32];
	char	Icon[3][128];
} _CARD;

//static _CARD HEAD;


/*
long SaveMemToCard(char *filename,void *data,long CardID,short NumBlocks)
{
	long err;
	int repeat=0;
	long chan=0;
	int RetryCount=0;

	MemCardAccept(0x00);
	MemCardSync(0,0,&err);

//	err=MemCardCreateFile(0x00,"TEST",15);
//	err=MemCardWriteFile(0x00,"TEST",data,0,128);
//	MemCardSync(0,0,&err);

	MemCardAccept(0x00);
	MemCardSync(0,0,&err);


	while (1)
	{
		if ((err=MemCardCreateFile(CardID,filename,NumBlocks))==McErrNone)
		{
			err=MemCardWriteFile(CardID,filename,data,0,NumBlocks*8192);
			MemCardSync(0,0,&err);
			if (err==McErrNone)
			{
				mprintf ("Game saved OK\n");
				return err;
			}
		}
		else if (err==McErrAlreadyExist)
		{
			//
			// Error creating file - file already exists.  Try to delete old file
			//

			mprintf ("File already exists - deleting\n");
			if ((err=MemCardDeleteFile(CardID,filename))!=McErrNone)
			{
				mprintf ("File deleted OK\n");
				return err;
			}
			//
			// If old file deleted OK then drop out to re-try save
			//
		}
		else if (err==McErrBlockFull)
		{
			//
			// Memory card full
			//

			//
			// SONY library problem (libmcrd)
			//
			// If file has been created but not written, further attempts to create file
			// will return McErrBlockFull and not McErrAlreadyExist
			// Therefore we need to delete this file and try again.
			//
			if (RetryCount++>5) return err;			// Break out if card really is full.

			mprintf ("Error - Block full : delete file and re-try\n");
			if ((err=MemCardDeleteFile(CardID,filename))!=McErrNone)
			{
				mprintf ("delete file returned %d\n",err);
			}
		}
		else
		{
			mprintf ("Unsupported error (%d) - abort\n",err);
			return err;			// Some other error creating file
		}
	}
}



long LoadMemFromCard(char *filename,void *data,long CardID,short NumBlocks)
{
	long err;
	int repeat=0;
	long chan=0;
	int RetryCount=0;

	MemCardAccept(0x00);
	MemCardSync(0,0,&err);


	while (1)
	{
		err=MemCardReadFile(CardID,filename,data,0,NumBlocks*8192);
		MemCardSync(0,0,&err);

		if (err==McErrNone)
		{
			return 0;
		}
		else if (err==McErrFileNotExist)
		{
			//
			// Error reading file - file does not exist
			//
			if (RetryCount<5)
			{
				RetryCount++;
			}
			else
			{
				return err;
			}
		}
	}
}
*/
