#define	MEMCARD_CAPACITY	(120*1024)
#define	MEMCARD_SECTORSIZE	128
#define	MEMCARD_BLOCKSIZE	8192

typedef struct
	{
	u8 magicNumber;				// Always 'B'
	u8 region;					// 'I' = Japan, 'E' = Europe, 'A' = America
	u8 productNumber[10];		// e.g. "SLPS-00001" no zero termination.
	u8 userDefined[9];			// zero terminated.
	}MEMCARDFILENAME;

typedef struct
	{
	u8 magicNumber[2];			// Always "SC" no zero termination.
	u8 type;					// Number of anim frames, 0x11 = 1, 0x12 = 2, 0x13 = 3
	u8 numBlocks;				// Number of blocks on card
	u16 name[32];				// Shift-JIS text format. zero terminated.
	u8 pad[28];					// Align struct to 512 bytes
	u16 clut[16];				// clut
	u8 icon[3] [128];			// 3 frames of anim, 16x16x4bit.
	}MEMCARDFILEHEADER;			// followed by multiples of 128 bytes user data.

void MEMCARD_init(void);
void MEMCARD_stop(void);
void MEMCARD_save(register void *,register u16);
void MEMCARD_load(register void *,register u16);

extern void *MemCard_HandlerP;
extern volatile Uint32  MemCardResult;
extern volatile Uint32  MemCardFuncDone;

void InitMemCardSystem();
void MemCard_Handler(unsigned long cmds, unsigned long result);
void ExitMemCardSystem();
long SaveMemToCard(char *filename,void *data,long CardID,short NumBlocks);
long LoadMemFromCard(char *filename,void *data,long CardID,short NumBlocks);
