#include "header.h"
#include "frontend.h"
#include "fade.h"
#include "render.h"
#include "camera.h"
#include "objects.h"
#include "collide.h"
#include <libsn.h>
#include "sdlib\sdtypes.h"
#include "sdlib\sdfunc.h"
#include "ctrller.h"
#include "gameloop.h"
#include "state.h"
#include "psx\psx_pcks.h"
#include "psx\psx_expn.h"
#include "ai.h"
#include "psx\textpsx.h"
#include "hue.h"
#include "menu.h"
#include "memcard.h"
#include "keys.h"
#include "loadit.h"
#include "savedata.h"
#include <libmcrd.h>
#include <stdio.h>
#include <libapi.h>
#include <libpad.h>
#include "psx\loadpsx.h"
#include "psx\soundpsx.h"
#include "psx\textpsx.h"
#include "psx\gpupsx.h"
#include "action.h"
#include <libcd.h>
#include "cdlib.h"
#include "screens.h"
#include "score.h"
#include "text.h"
#include "fade.h"

#define __DEBUG_MENU		0

extern u8    TEXT_r;
extern u8    TEXT_g;
extern u8    TEXT_b;
void  TEXT_prchr( u8 chr );

#if __DEBUG_MENU >= 2
void dumpHighScore(void);
#endif

//extern GsSPRITE sprite;
extern u8 textspritedef[];

#define MENUWOT		MWotPtr

extern GsOT *MWotPtr;

void gridBox2(int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,char *);

int menuState = MN_Disabled;//MN_Start;//MN_Times;//MN_Pause;
int writeState = MC_Disabled;
int frCount;
int mcCheckState;
int mcWriteState;
int mcCheckCount;
int padStopped = 0;

int mcUpdOption = 0;
int mcWrOption = 0;

int tmOption = 0;
int hScore = 0;

int execGame = 1;

/*
void menuBkGnd(u8,u8,u8,u16,u16,u16,u16);
void centralBox(u8,u8,u8,u8,u8,u8,u8);
*/
/*
void shadeTri(u8,u8,u8,u8,u8,u8);
void shadeQuad(u8,u8,u8,u8,u8,u8,u8);
*/

int wonFlag,cOption = 0,pOption = 0;

int thisLevel;
int levelFlag = 0;

int racePosition = 0;

/*
extern u_char hdr[20];
extern RECT rct;
extern u_short buf[512] [512];
*/

extern GsOT *ptrwot;

void M_TEXT_prstr(u8 *str,u8 r,u8 g,u8 b)
	{
	GsOT *oldptr = ptrwot;
	ptrwot = MWotPtr;
    TEXT_prstr(str,r,g,b);
	ptrwot = oldptr;
	}

void setSemiHW(u8 t)
	{
	// ft3 in dcache
	
	SetPolyFT3(&ft3);
	setSemiTrans(&ft3,1);
	
    ft3.x0 = -280;
	ft3.x1 = -278;
	ft3.x2 = -280;

    ft3.y0 = 0;
    ft3.y1 = 0;
    ft3.y2 = 5;
	
    ft3.tpage = GetTPage(0,t,0,0);
    ft3.clut = GetClut(0,0);

    GsSortPoly(&ft3,MENUWOT,1);
	}

/*
void semiBox(int w,int h)
	{
	POLY_G4	pg4;

    SetPolyG4(&pg4);
	setSemiTrans(&pg4,1);

    pg4.x0 = -(w/2);
    pg4.y0 = -(h/2);
    pg4.x1 = pg4.x0 + w;
    pg4.y1 = pg4.y0;
    pg4.x2 = pg4.x0;
    pg4.y2 = pg4.y0 + h;
    pg4.x3 = pg4.x0 + w;
    pg4.y3 = pg4.y0 + h;
	
    pg4.r0 = 255;
    pg4.g0 = 0;
    pg4.b0 = 0;
    pg4.r1 = 0;
    pg4.g1 = 255;
    pg4.b1 = 0;
    pg4.r2 = 0;
    pg4.g2 = 0;
    pg4.b2 = 255;
    pg4.r3 = 127;
    pg4.g3 = 127;
    pg4.b3 = 127;

    GsSortPoly(&pg4,MENUWOT,0);
	}
*/

int adjustX = 0;
int adjustY = 0;

int semiDarkness = 48;		//32

void semiBox(int w,int h)
	{
	static POLY_F4 pf4;

    SetPolyF4(&pf4);
	setSemiTrans(&pf4,1);

	w += adjustX;
	h += adjustY;

    pf4.x0 = -(w/2);
    pf4.y0 = -(h/2);
    pf4.x1 = pf4.x0 + w;
    pf4.y1 = pf4.y0;
    pf4.x2 = pf4.x0;
    pf4.y2 = pf4.y0 + h;
    pf4.x3 = pf4.x0 + w;
    pf4.y3 = pf4.y0 + h;
	
    pf4.r0 = semiDarkness;
    pf4.g0 = semiDarkness;
    pf4.b0 = semiDarkness;

    GsSortPoly(&pf4,MENUWOT,1);
	}

void semiBoxC(int w,int h,int y,int b)
	{
	static POLY_F4 pf4;

    SetPolyF4(&pf4);
	setSemiTrans(&pf4,1);

	w += adjustX;
	h += adjustY;

    pf4.x0 = -(w/2);
    pf4.y0 = y-(h/2);
    pf4.x1 = pf4.x0 + w;
    pf4.y1 = pf4.y0;
    pf4.x2 = pf4.x0;
    pf4.y2 = pf4.y0 + h;
    pf4.x3 = pf4.x0 + w;
    pf4.y3 = pf4.y0 + h;
	
    pf4.r0 = b;
    pf4.g0 = b;
    pf4.b0 = b;

    GsSortPoly(&pf4,MENUWOT,1);
	}

void box2(int x,int y,int w,int h,int r,int g,int b)
	{
	POLY_F4	pf4;

    SetPolyF4(&pf4);
//	setSemiTrans(&pf4,1);

    pf4.x0 = x;
    pf4.y0 = y;
    pf4.x1 = pf4.x0 + w;
    pf4.y1 = pf4.y0;
    pf4.x2 = pf4.x0;
    pf4.y2 = pf4.y0 + h;
    pf4.x3 = pf4.x0 + w;
    pf4.y3 = pf4.y0 + h;
	
    pf4.r0 = r;
    pf4.g0 = g;
    pf4.b0 = b;

    GsSortPoly(&pf4,MENUWOT,0);
	}

int trackForNum[17] = {0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,3,3};
int worldForNum[17] = {0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4};

//void testPoly(void);

int sndvols[11] =
	{
	(127*0)/10,
	(127*1)/10,
	(127*2)/10,
	(127*3)/10,
	(127*4)/10,
    (127*5)/10,
	(127*6)/10,
	(127*7)/10,
	(127*8)/10,
	(127*9)/10,
	(127*10)/10,
	};

int nmusVol = 5,nsfxVol = 7;
int musVol = (127*5)/10;
int sfxVol = (127*7)/10;

int menuEnableFlag = 1;

void menuUpdate(void)
	{	
/*
	// Temp, screen shots
	{
	static int scnum = 0;
	char fn[128];
	pollhost();
	if((G_cyc&0x0f)==0)
		{
	    mprintf("Dumping screen shot (%d)",scnum);
		rct.x = 0;	// not fb
		rct.y = 0;
		rct.w = 512;
		rct.h = 512;
		StoreImage(&rct,(u32 *)buf);
	    sprintf(fn,"z:\\360\\360_%04d.tim",scnum++);
	    writePCfile2(hdr,buf,fn,20,512*512*2);
	    mprintf(" - Completed.\n");
		}
	}
	*/
	
//	static int ph = 0;
//	ph+= 16;
//	fadeValue = (ph&0x100)?0x1ff-ph:ph;
	
	fade();
	
//	testPoly();

//	menuBkGnd(64,16,16, 224,112, 48,24);
//	menuBkGnd(192,112,112, 224,112, 24,12);
//	menuBkGnd(80,80,80, 224,112, 24,12);
//	menuBkGnd(80,80,80, 200,100, 24+96,12+48);
//	menuBkGnd(80,80,80, 0,0, 200,100);
//	menuBkGnd(0,0,0, 0,0, 200,100);
//	menuBkGnd(192,80,255, 224,112, 24,12);



//	menuBkGnd(192,80,255, 256,128, 0,0);

//	menuState = MN_Disabled;

    if(menuEnableFlag)
	switch(menuState)
		{
        case MN_Disabled:
		
			WTXT_test();
/*
			if(arState==AR_RECORD)
			if(arIndex==10)
				{
	            LOAD_level();
				STATE_initstatesonboot();
				arStart();
//	            GAMELOOP_state=GLfadeouttogame;
				}
		
			// Temp : somebody should do this properly
			if((STATE.mcurrlevel&0x03)==3)
				{
				for(i=0;i<STATE.wankers;i++)					
                    if(OBJ_players[i].stats.kills>10)
						{
						OBJ_players[i].stats.kills = 0;
                        menuState = MN_Start;
						}
				}
			else{
				for(i=0;i<STATE.wankers;i++)					
                    if(OBJ_players[i].stats.lap>10)
						{
						OBJ_players[i].stats.lap = 0;
                        menuState = MN_Start;
						}
				}
*/
			break;

		case MN_Pause:
			pauseScreen();
			break;

        case MN_Start:
		
			#if __DEBUG_MENU >= 2
			dumpHighScore();
			#endif
		
            menuState = MN_Times;

/*
			#if 1

			// Todo: collect actual race info at end.

            pStatNum = STATE.wankers;	// *TheNumberOfPlayers;
			pStatLevel = STATE.mcurrlevel & 0x03;
			pStatWorld = STATE.mcurrlevel >> 2;

			// LROpt[0] = num frags (0=1min,1=3min,2=5min,3=10,4=25,5=50,6=unlimited)

			for(i=0;i<pStatNum;i++)
				{
                pStat[i].ai = OBJ_players[i].computer&0x01;
				pStat[i].pnum = OBJ_players[i].plyrnum;
				pStat[i].vtype = OBJ_players[i].crafttype;
				pStat[i].frags = OBJ_players[i].stats.kills;

				if(pStatLevel==3)
					{
					if(pStat[i].frags>=10)
						pStat[i].fragTime = 0x00031523; // ???;
					else
						pStat[i].fragTime = 0xffffffff;
					}
				else
					pStat[i].fragTime = 0xffffffff;
              
				pStat[i].raceTime = 0x00050914; // ???;
				
				if(pStatLevel==3)
					pStat[i].lapTime = 0xffffffff;
				else
					pStat[i].lapTime = 0x00015208; // ???;
				}

//			pStatOrderRace[0] = 0;
//			pStatOrderRace[1] = 1;
//			pStatOrderLap[0] = 1;
//			pStatOrderLap[1] = 0;

			for(i=0;i<6;i++)
				{
				pStatOrderRace[i] = i;
				pStatOrderLap[i] = i;
				}

			#else

			// Battle or tourn (on a track)  (bodge)
			
			pStatNum = 2;
			pStatLevel = 0;
			pStatWorld = 0;
			pStatOrderRace[0] = 0;
			pStatOrderRace[1] = 1;
			pStatOrderLap[0] = 1;
			pStatOrderLap[1] = 0;
			pStat[0].raceTime = 0x074251;
			pStat[0].lapTime = 0x020143;
			pStat[0].frags = 2;
			pStat[0].fragTime = 0xffffffff;
			pStat[0].ai = 0;
			pStat[0].pnum = 0;
			pStat[0].vtype = 0;
			pStat[1].raceTime = 0x081242;
			pStat[1].lapTime = 0x014405;
			pStat[1].frags = 5;
            pStat[1].fragTime = 0xffffffff;
			pStat[1].ai = 0;
			pStat[1].pnum = 1;
			pStat[1].vtype = 1;

			pStat[0].raceTime = 0x004251;
			pStat[0].lapTime = 0x000743;
			pStat[1].raceTime = 0x011242;
			pStat[1].lapTime = 0x000505;
			
			#endif
*/

            *CompletedFMV = 0;

			tmOption = 0;
			frCount = 0;
			
			// Proceed to next level ?
			
			switch(*GameMode)
				{
				case 0:	// Battle
					break;
					
				case 1:	// Tournament
					// temp : dont proceed past arena
					if(trackForNum[STATE.mcurrlevel]!=3)
	                    STATE.mcurrlevel++;
					break;
					
				case 2:	// Time trial
					break;
					
				case 3:	// Arcade
                    if(trackForNum[thisLevel]==3)       // Arena
                        wonFlag = racePosition==0?1:0;
                    else
                        wonFlag = racePosition<3?1:0;
                    
                    if(!levelFlag)
                        {
                        thisLevel = *NewArcadeGameNow?0:*ArcadePosLoaded;
                        levelFlag = 1;						
                        }
                    if(wonFlag)
                        {
                        // fill in trackAvailability
                        WorldAvailable[worldForNum[thisLevel]] = 1;
                        TrackAvailable[worldForNum[thisLevel]] [trackForNum[thisLevel]] = 1;
						
                        thisLevel++;
						
                        mprintf("next level, level == %d\n",thisLevel);
						
						if(thisLevel>=17)
							{
                            *CompletedFMV = 1;
			                SOUND_setvol(0);
			                #if CDMASTER
			                LoadIntro();
			                #else
			                GAMELOOP_state = GLloadmenu;
			                #endif
                            }
                        }
					break;
				}
            break;

        case MN_Times:
			SCORE_menu();
//			mprintf("SCORE_menu() finished, %d %s\n",menuState,menuState==MN_Times?"MN_Times":"Arse");
			break;
			/*
			frCount++;
			
			switch(tmOption)
				{
				case 0:		// Displaying results
					
					if(pStatLevel==3)
						{
						// Arena

    	                for(i=0;i<STATE.wankers;i++)
							{
                            register int md = pStat[i].frags/10;
                            
                            txtMenuPlayerFrags[i] [0] = md + '0';
                            txtMenuPlayerFrags[i] [1] = pStat[i].frags - (10*md) + '0';
							
							if(pStat[i].frags>=10)
	                            txtMenuPlayerFTimes[i] [0] = 0;
							else{
                                txtMenuPlayerFTimes[i] [0] = (pStat[i].fragTime&0xf0000)>>16; // mins
                                txtMenuPlayerFTimes[i] [2] = (pStat[i].fragTime&0x0f000)>>12; // 10secs
                                txtMenuPlayerFTimes[i] [3] = (pStat[i].fragTime&0x00f00)>>8; // secs
                                txtMenuPlayerFTimes[i] [5] = (pStat[i].fragTime&0x000f0)>>4; // 10hsecs
                                txtMenuPlayerFTimes[i] [6] = (pStat[i].fragTime&0x0000f); // hsecs########
								}
//                            ########    { 45,-36,txtMenuPlayerFrags[0]},
							

							txtMenuArena[i].t =
								txtMenuPlayerName[(((OBJ_players[i].computer&0x01))?(2):(i))];
							}

                        for(i=0;txtMenuArena[i].t!=NULL;i++)
							{
                            TEXT_x = txtMenuArena[i].x;
                            TEXT_y = txtMenuArena[i].y;
                            M_TEXT_prstr(txtMenuArena[i].t,255,255,255);
                            }
						}
					else{
						// Track
						}
		
					// do after text so its printed first
					semiBox(256,128);
//#########		
					// set stp bit
					setSemiHW(0);

		            if((frCount==150)||((SD_PadData[0].push&K_MENU_PROGRESS)&&(frCount>=45)))
						{
						// score.c
						}
					
					break;
				
				case 1:		// Enter names

                 // gridBox2( cx, cy,nx,ny,sx,sy,gx,gy,bx,by,blr,blg,blb,bhr,bhg,bhb,bar,bag,bab,txr,txg,txb,thr,thg,thb,xh,yh,t)

                    gridBox2(  0,-50, 3, 1,30,15, 3, 2, 6, 3,192,192, 80, 64,192, 64, 96, 96, 96, 48, 64, 64,224, 64, 64,hsIndex,0,hsName);
                    gridBox2(  0, 25,12, 5,30,15, 3, 2, 6, 3,192,192, 80,
                        (newhue2rgb[(G_cyc*3)&0xff].r>>1)+64,
                        (newhue2rgb[(G_cyc*3)&0xff].g>>1)+64,
                        (newhue2rgb[(G_cyc*3)&0xff].b>>1)+64, 96, 96, 96, 48, 64, 64,224, 64, 64,chx,chy,hsTable);

//					semiBox(256,128);
//					setSemiHW(0);
					
					if(hsIndex==3)
						{
						chx = -1;
						chy = -1;
						}
					else{
	                    if((SD_PadData[0].push&K_HS_UP))
							if(chy>0) chy--;
	                    if((SD_PadData[0].push&K_HS_DOWN))
							if(chy<4) chy++;
        	            if((SD_PadData[0].push&K_HS_LEFT))
							if(chx>0) chx--;
                	    if((SD_PadData[0].push&K_HS_RIGHT))
							if(chx<11) chx++;
						}

					if((SD_PadData[0].push&K_HS_SELECT))
						{
						if(hsIndex<3)
							{
							if((chy*12)+chx==59)		// End
								hsIndex = 3;
							else
							if((chy*12)+chx==58)		// Del
								{
								if(hsIndex>0)
									hsIndex--;
								hsName[hsIndex] = ' ';
								}
							else
								hsName[hsIndex++] = hsTable[(chy*12)+chx];
							}
						if(hsIndex>=3)
							{
							// Fill in high score name
							
							#if __DEBUG_MENU >= 1
                            mprintf("spIndex == %d, Replacing (%p) %s with %s\n",spIndex,hScoreParam[spIndex].text,hScoreParam[spIndex].text,hsName);
                            #endif
							
                            *((u32 *)hScoreParam[spIndex].text) = *((u32 *)hsName);

							spIndex++;

							// Search for other high scores already named.
							
							j = 0;
							do	{
								if(spIndex<nHScore)
									{
									for(i=0;i<spIndex;i++)
									if(hScoreParam[i].p->pnum==hScoreParam[spIndex].p->pnum)
										{
                                        *((u32 *)hScoreParam[spIndex].text) =
	                                        *((u32 *)hScoreParam[i].text);
										j = 1;
										i = ++spIndex;
										}
									j ^= 1;
									}
								else
									j = 1;
								}while(j==0);
							
							if(spIndex<nHScore)
								{
//								chx = chy = 0;
								hsIndex = 0;
								hsName[0] = hsName[1] = hsName[2] = ' ';
								hsName[3] = 0;
								}
							else
								tmOption = 2;
							}
						}								
					
					break;
				
				case 2://######
					semiBox(256,128);
					setSemiHW(0);

		            if((frCount==150)||((SD_PadData[0].push&K_MENU_PROGRESS)&&(frCount>=45)))
						{
						#if __DEBUG_MENU >= 2
						dumpHighScore();
						#endif

						switch(*GameMode)
							{
							case 0:	// Battle
								menuState = MN_MainMenuInitBattle;
								break;
							case 1:	// Tournament
								menuState = MN_MainMenuInitTourn;
								break;
							case 2:	// Time trial
								menuState = MN_MainMenuInitTrial;
								break;
							case 3:	// Arcade
								menuState = MN_MainMenuInitArcade;
								break;
							}
								
						frCount = 0;
						}
					
					break;
				}
			break;
			*/

		case MN_MainMenuInitTrial:
			// run into MN_MenuTrial
            cOption = 0;
			menuState = MN_MenuTrial;

		case MN_MenuTrial:
			menuTrialScreen();
			break;

		case MN_MainMenuInitTourn:
			// run into MN_MenuTourn
            cOption = 0;
			menuState = MN_MenuTourn;

		case MN_MenuTourn:
			menuTournScreen();
			break;	

		case MN_MainMenuInitBattle:
			// run into MN_MenuBattle
            cOption = 0;
			menuState = MN_MenuBattle;

		case MN_MenuBattle:
			menuBattleScreen();
			break;

		case MN_MainMenuInitArcade:
			// run into MN_MainArcade
            cOption = 0;
			menuState = MN_MainArcade;

		case MN_MainArcade:
			menuArcadeScreen();
			break;

        case MN_EnterNames:
			SCORE_entername();
			break;

        case MN_UpdateMemCard:
			updateMemCardScreen();
			break;

		case MN_WriteMemCard:
			writeMemCardScreen();
            break;

		// #####################
		case MN_StartAction:
			semiBox(256,128);
			setSemiHW(0);
			break;
		}
	}

/*
void testPoly(void)
	{
	POLY_GT4 gt4;
	
	SetPolyGT4(&gt4);
	SetSemiTrans(&gt4,1);

	gt4.r0 = gt4.r1 = gt4.r2 = gt4.r3 = 127;
	gt4.g0 = gt4.g1 = gt4.g2 = gt4.g3 = 127;
	gt4.b0 = gt4.b1 = gt4.b2 = gt4.b3 = 127;

	gt4.tpage = GetTPage(1,1,704,256);
	gt4.clut = GetClut(768,375);

    gt4.u0 = 16;	gt4.v0 = 94;
    gt4.u1 = 16+31;	gt4.v1 = 94;
    gt4.u2 = 16;	gt4.v2 = 94+31;
    gt4.u3 = 16+31;	gt4.v3 = 94+31;

	gt4.x0 = -128;	gt4.y0 = 64;
	gt4.x1 = 128;	gt4.y1 = 64;
	gt4.x2 = -128;	gt4.y2 = -64;
	gt4.x3 = 128;	gt4.y3 = -64;

    GsSortPoly(&gt4,MENUWOT,0);
    }
*/

typedef struct
	{
	s16 x;
	s16 y;
	}C2D;

/*
C2D c[12];

void menuBkGnd(u8 r,u8 g,u8 b,u16 w,u16 h,u16 w2,u16 h2)
	{
//	r,g,b = Colour of central bit
//	w,h = width / height of central bit
//	w2,h2 = width / height of fade bits
	
	c[0].x = -(w>>1);		c[0].y = -(h>>1);
	c[1].x = c[0].x+w;		c[1].y = c[0].y;
	c[2].x = c[0].x;		c[2].y = c[0].y+h;
	c[3].x = c[0].x+w;		c[3].y = c[0].y+h;
	c[4].x = c[0].x - w2;	c[4].y = c[0].y;
	c[5].x = c[0].x;		c[5].y = c[0].y - h2;
	c[6].x = c[1].x;		c[6].y = c[1].y - h2;
	c[7].x = c[1].x + w2;	c[7].y = c[1].y;
	c[8].x = c[2].x;		c[8].y = c[2].y + h2;
	c[9].x = c[2].x - w2;	c[9].y = c[2].y;
	c[10].x = c[3].x + w2;	c[10].y = c[3].y;
	c[11].x = c[3].x;		c[11].y = c[3].y + h2;
	
	centralBox(r,g,b,0,1,2,3);
	
   	shadeTri(r,g,b,0,4,5);
   	shadeTri(r,g,b,1,6,7);
   	shadeTri(r,g,b,2,8,9);
   	shadeTri(r,g,b,3,10,11);

    shadeQuad(r,g,b,0,5,1,6);
    shadeQuad(r,g,b,1,7,3,10);
    shadeQuad(r,g,b,3,11,2,8);
    shadeQuad(r,g,b,2,9,0,4);
    
	// set stp bit
	setSemiHW(1);

    shadeTri(255,255,255,0,4,5);
    shadeTri(255,255,255,1,6,7);
    shadeTri(255,255,255,2,8,9);
    shadeTri(255,255,255,3,10,11);

    shadeQuad(255,255,255,0,5,1,6);
    shadeQuad(255,255,255,1,7,3,10);
    shadeQuad(255,255,255,3,11,2,8);
    shadeQuad(255,255,255,2,9,0,4);
    
	// set stp bit
	setSemiHW(2);
	}

void centralBox(u8 r,u8 g,u8 b,u8 v0,u8 v1,u8 v2,u8 v3)
	{
	POLY_F4	pf4;

    SetPolyF4(&pf4);

    pf4.x0 = c[v0].x;
    pf4.y0 = c[v0].y;
    pf4.x1 = c[v1].x;
    pf4.y1 = c[v1].y;
    pf4.x2 = c[v2].x;
    pf4.y2 = c[v2].y;
    pf4.x3 = c[v3].x;
    pf4.y3 = c[v3].y;
    
    pf4.r0 = r;
    pf4.g0 = g;
    pf4.b0 = b;

    GsSortPoly(&pf4,MENUWOT,0);
	}

void shadeTri(u8 r,u8 g,u8 b,u8 v0,u8 v1,u8 v2)
	{
	POLY_G3	pg3;

    SetPolyG3(&pg3);
	setSemiTrans(&pg3,1);

    pg3.x0 = c[v0].x;
    pg3.y0 = c[v0].y;
    pg3.x1 = c[v1].x;
    pg3.y1 = c[v1].y;
    pg3.x2 = c[v2].x;
    pg3.y2 = c[v2].y;
	
    pg3.r0 = r;
    pg3.g0 = g;
    pg3.b0 = b;
    pg3.r1 = 0;
    pg3.g1 = 0;
    pg3.b1 = 0;
    pg3.r2 = 0;
    pg3.g2 = 0;
    pg3.b2 = 0;
             
    GsSortPoly(&pg3,MENUWOT,0);
	}

void shadeQuad(u8 r,u8 g,u8 b,u8 v0,u8 v1,u8 v2,u8 v3)
	{
	POLY_G3	pg3;

    SetPolyG3(&pg3);
	setSemiTrans(&pg3,1);

    pg3.x0 = c[v0].x;
    pg3.y0 = c[v0].y;
    pg3.x1 = c[v1].x;
    pg3.y1 = c[v1].y;
    pg3.x2 = c[v3].x;
    pg3.y2 = c[v3].y;
	
    pg3.r0 = r;
    pg3.g0 = g;
    pg3.b0 = b;
    pg3.r1 = 0;
    pg3.g1 = 0;
    pg3.b1 = 0;
    pg3.r2 = 0;
    pg3.g2 = 0;
    pg3.b2 = 0;
             
    GsSortPoly(&pg3,MENUWOT,0);

    pg3.x0 = c[v3].x;
    pg3.y0 = c[v3].y;
    pg3.x1 = c[v2].x;
    pg3.y1 = c[v2].y;
    pg3.x2 = c[v0].x;
    pg3.y2 = c[v0].y;
	
    pg3.r0 = 0;
    pg3.g0 = 0;
    pg3.b0 = 0;
    pg3.r1 = r;
    pg3.g1 = g;
    pg3.b1 = b;
    pg3.r2 = r;
    pg3.g2 = g;
    pg3.b2 = b;
             
    GsSortPoly(&pg3,MENUWOT,0);
	}
*/

/*
C2D c[16];

void menuBkGnd(u8 r,u8 g,u8 b,u16 w,u16 h,u16 w2,u16 h2)
	{
	
//	r,g,b = Colour of central bit
//	w,h = width / height of central bit
//	w2,h2 = width / height of edge bits
	*
	
	c[0].x = -(w>>1);		c[0].y = -(h>>1);
	c[1].x = c[0].x + w;	c[1].y = c[0].y;
	c[2].x = c[0].x;		c[2].y = c[0].y + h;
	c[3].x = c[0].x + w;	c[3].y = c[0].y + h;
	c[4].x = c[0].x - w2;	c[4].y = c[0].y;
	c[5].x = c[0].x;		c[5].y = c[0].y - h2;
	c[6].x = c[1].x;		c[6].y = c[1].y - h2;
	c[7].x = c[1].x + w2;	c[7].y = c[1].y;
	c[8].x = c[2].x;		c[8].y = c[2].y + h2;
	c[9].x = c[2].x - w2;	c[9].y = c[2].y;
	c[10].x = c[3].x + w2;	c[10].y = c[3].y;
	c[11].x = c[3].x;		c[11].y = c[3].y + h2;
	c[12].x = c[0].x - w2;	c[12].y = c[0].y - h2;
	c[13].x = c[1].x + w2;	c[13].y = c[1].y - h2;
	c[14].x = c[2].x - w2;	c[14].y = c[2].y + h2;
	c[15].x = c[3].x + w2;	c[15].y = c[3].y + h2;
	
	centralBox(r,g,b,0,1,2,3);
	setSemiHW(0);
	}

void centralBox(u8 r,u8 g,u8 b,u8 v0,u8 v1,u8 v2,u8 v3)
	{
	POLY_F4	pf4;

    SetPolyF4(&pf4);
	setSemiTrans(&pf4,1);

    pf4.x0 = c[v0].x;
    pf4.y0 = c[v0].y;
    pf4.x1 = c[v1].x;
    pf4.y1 = c[v1].y;
    pf4.x2 = c[v2].x;
    pf4.y2 = c[v2].y;
    pf4.x3 = c[v3].x;
    pf4.y3 = c[v3].y;
    
    pf4.r0 = r;
    pf4.g0 = g;
    pf4.b0 = b;

    GsSortPoly(&pf4,MENUWOT,0);
	}
*/

#if 0

s8 gridHiLight[GRID_YRES] [GRID_XRES];
u8 gridOffset[GRID_YRES] [GRID_XRES];
u16 gridPhase = 0;
u8 gridInit = 0;

void gridUpdate(void)
	{
	register int x,y;
	
	if(!gridInit)
		{
		for(y=1;y<GRID_YRES-1;y++)
		for(x=1;x<GRID_XRES-1;x++)
			{
//			gridOffset[y] [x] = vroot32(( (x-(GRID_XRES/2)) * (x-(GRID_XRES/2)) ) + ( (y-(GRID_YRES/2)) * (y-(GRID_YRES/2)) )) << 4;
//			gridOffset[y] [x] = 0;

            gridOffset[y] [x] = ((GRID_XRES-x-1) + (GRID_YRES-y-1)) * 4;
            }

		for(x=0;x<GRID_XRES;x++)
			gridOffset[0] [x] = gridOffset[GRID_YRES-1] [x] = 0;

		for(y=0;y<GRID_YRES;y++)
			gridOffset[y] [0] = gridOffset[y] [GRID_XRES-1] = 0;

		for(x=0;x<GRID_XRES;x++)
			gridHiLight[0] [x] = gridHiLight[GRID_YRES-1] [x] = 0;
		for(y=0;y<GRID_YRES;y++)
			gridHiLight[y] [0] = gridHiLight[y] [GRID_XRES-1] = 0;
		
		gridInit = 1;
		}
	
	gridPhase -= 384;
	gridPhase &= 0xffff;
	
	for(y=1;y<GRID_YRES-1;y++)
	for(x=1;x<GRID_XRES-1;x++)
		{
		/*
		s16 s = rsin((x+y+gridPhase)<<8);
        gridHiLight[y] [x] = (s8)(s>>4);
		*/
		
		s16 s = rsin(((gridOffset[y] [x]<<6)+gridPhase));//8
		
		// 1.3.12
		
		gridHiLight[y] [x] = 96 + (s8)(s>>7);	// 1.3.5
		
//		gridHiLight[y] [x] = rand() & 0x3f;
		}
	}
	
void gridDraw(void)
	{
	register int x,y;

	POLY_G4	pg4;

    SetPolyG4(&pg4);
	setSemiTrans(&pg4,1);

	for(y=0;y<GRID_YRES-1;y++)
	for(x=0;x<GRID_XRES-1;x++)
		{
        pg4.r0 = pg4.g0 = pg4.b0 = gridHiLight[y] [x];
        pg4.r1 = pg4.g1 = pg4.b1 = gridHiLight[y] [x+1];
        pg4.r2 = pg4.g2 = pg4.b2 = gridHiLight[y+1] [x];
        pg4.r3 = pg4.g3 = pg4.b3 = gridHiLight[y+1] [x+1];

/*
		pg4.r0 >>= 1;
		pg4.r1 >>= 1;
		pg4.r2 >>= 1;
		pg4.r3 >>= 1;

		pg4.g0 >>= 1;
		pg4.g1 >>= 1;
		pg4.g2 >>= 1;
		pg4.g3 >>= 1;
*/
/*		Night vision
        pg4.r0 = 0xff;
        pg4.r1 = 0xff;
        pg4.r2 = 0xff;
        pg4.r3 = 0xff;
        pg4.b0 = 0xff;
        pg4.b1 = 0xff;
        pg4.b2 = 0xff;
        pg4.b3 = 0xff;
*/      
        pg4.b0 = 0;
        pg4.b1 = 0;
        pg4.b2 = 0;
        pg4.b3 = 0;

		pg4.x0 = GRID_BASEX + (x * GRID_DELTAX);
		pg4.y0 = GRID_BASEY + (y * GRID_DELTAY);

		pg4.x1 = GRID_BASEX + ((x+1) * GRID_DELTAX);
		pg4.y1 = GRID_BASEY + (y * GRID_DELTAY);

		pg4.x2 = GRID_BASEX + (x * GRID_DELTAX);
		pg4.y2 = GRID_BASEY + ((y+1) * GRID_DELTAY);

		pg4.x3 = GRID_BASEX + ((x+1) * GRID_DELTAX);
		pg4.y3 = GRID_BASEY + ((y+1) * GRID_DELTAY);

	    GsSortPoly(&pg4,MENUWOT,0);
		}

	setSemiHW(2);	// 1
	}
#endif


void gridBox2(int cx,int cy,int nx,int ny,int sx,int sy,int gx,int gy,int bx,int by,int blr,int blg,int blb,int bhr,int bhg,int bhb,int bar,int bag,int bab,int txr,int txg,int txb,int thr,int thg,int thb,int xh,int yh,char *t)
	{
	/*
	
    cx,cy : center coord of blocks
    nx,ny : number of blocks
    sx,sy : size of each block
    gx,gy : gap between each block
    bx,by : border around whole grid
	blr,blg,blb : block colour
	bhr,bhg,bhb : block hilight colour
    bar,bag,bab : background colour
	txr,txg,txb : text colour
	thr,thg,thb : text hilight colour
	xh,yh : hilight block
	t : letter for each block

    */
	
    int w;
    int h;

    int half_w;
    int half_h;
	
	int ix,iy;

	int tx;
	int ty;
	
	int bcx;
	int bcy;

    u8 *psp;

    w = (nx*sx)+((nx-1)*gx); //+(2*bx);
    h = (ny*sy)+((ny-1)*gy); //+(2*by);

	half_w = w >> 1;
	half_h = h >> 1;
                                   
    for(iy=0;iy<ny;iy++)
	for(ix=0;ix<nx;ix++)
		{
        tx = cx-half_w+(ix*(sx+gx));
        ty = cy-half_h+(iy*(sy+gy));
        
		bcx = tx + (sx>>1);
		bcy = ty + (sy>>1);

		psp = &textspritedef[(*t++)<<2];

        sprite.u = *psp++;
        sprite.v = *psp++;
        sprite.w = *psp++;
        sprite.h = *psp;

        sprite.x = bcx - (sprite.w>>1);
        sprite.y = bcy - (sprite.h>>1);
        
        if((ix==xh)&&(iy==yh))
			{
	        sprite.r = txr;
	        sprite.g = txg;
	        sprite.b = txb;
			}
		else{
	        sprite.r = thr;
    	    sprite.g = thg;
        	sprite.b = thb;
			}

        GsSortSprite(&sprite,MENUWOT,0);
		
        if((ix==xh)&&(iy==yh))
	        box2(tx,ty,sx,sy,bhr,bhg,bhb);
		else
	        box2(tx,ty,sx,sy,blr,blg,blb);
		}

    w += (2*bx);
    h += (2*by);

    half_w += bx;
    half_h += by;

	box2(cx-half_w,cy-half_h,w,h,bar,bag,bab);
	}
