#include <stdlib.h>
#include <stdio.h>

#include "header.h"
#include "objects.h"
#include "sim.h"
#include "weapons.h"
#include "mesh.h"
#include "pickups.h"
#include "collide.h"
#include "state.h"
#include "collide.h"
#include "psx\loadpsx.h"
#include "psx\psx_libs.h"
#include "psx\mathpsx.h"
#include "psx\psx_pcks.h"
#include "psx\psx_expn.h"
#include "psx\onscreen.h"
#include "sdlib\sdtypes.h"
#include "ai.h"
#include "action.h"
#include "render.h"
#include "version.h"
#include "loadit.h"

extern s32 handycam;
extern s32 fx_allowed;
///////////////////////////////////////////////////////////////////////////////////////////////
//		360 object control
///////////////////////////////////////////////////////////////////////////////////////////////
//		Started:		2/9/'98
//		Geeza:		J.coelho
//		PSX:			Yay
//		N64:			Yay?.
//    Notes:      Everything is poo. Bah humbug.
//                Boo yakka.
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// External Declarations
///////////////////////////////////////////////////////////////////////////////////////////////
extern   void  COL_funct_null();
extern   void  COL_funct_plyr();
extern   void  COL_funct_pkup();
extern   void  COL_funct_weap();
extern   void  COL_funct_gascloud();
extern   void  COL_funct_flam();
extern   void  COL_funct_plas();
extern   void  COL_funct_fog();
extern	APAD	SD_PadData[8];


int			steer_mode = TRUE;

///////////////////////////////////////////////////////////////////////////////////////////////
// Globals
///////////////////////////////////////////////////////////////////////////////////////////////

#if N64
vec32    LOAD_startpoints[4]={
   {3000,0,-9000},
   {-1700,0,16500},
   {-8000,0,-10800},
   {-600,0,14500}
   };
#endif

extern s32 power_up_table[10][5];

OBJ_PLAYERSTRUCT  OBJ_players[MAXNUMPLAYERS];
OBJ_STRUCT			OBJ_objects[MAXNUMOBJS];

//NOTE! change enum in  objects.h, if changing below!!
OBJ_TYPEINFO     OBJ_typeinfo[100]={
//   u8    rendertype;    // facing sprite or sdmodelNOTUSEDYET             RTfsprite
//   u8    renedermodel;  // index of sprite/modelNOTUSEDYET                RTeulemod
//   u16   mass;          // mass ( moved from OBJ_STRUCT)NOTUSEDYET        RTmatrmod
//   u16   colspheredim;  // size of collision sphereNOTUSEDYET             RTprecmat
//   u8    name[16];      // for debuggeringNOTUSEDYET
//       rentype  , mod,  mas,  dim,  name                plyr-colltype
/* 0*/{ RTmatrmod, 1,    200,   128, "craft",                 COL_funct_plyr    },
/* 1*/{ RTeulemod, 7,    200,   25, "pickup",                COL_funct_pkup    },
/*13*/{ RTeulemod, 7,    200,   100, "bullet",                COL_funct_null    },
/*14*/{ RTfsprite, 10,   200,   25,  "tracer",                COL_funct_null    },
/*15*/{ RTfsprite, 5,    200,   100, "rocket_set",            COL_funct_null    },
/*16*/{ RTfsprite, 5,    200,   50, "rocket",                COL_funct_weap    },
/*17*/{ RTeulemod, 3,    200,   100, "torpedo",               COL_funct_weap    },
/*18*/{ RTprecmat, 5,    200,   100, "high_octane",           COL_funct_null    },
/*19*/{ RTprecmat, 5,    200,   5, "missile",               COL_funct_weap    },
/*20*/{ RTprecmat, 5,    200,   300, "mine",                  COL_funct_weap    },
/*21*/{ RTprecmat, 5,    200,   100, "burst",                 COL_funct_null    },
/*22*/{ RTprecmat, 5,    200,   100, "shield",                COL_funct_null    },
/*23*/{ RTfsprite, 3,    200,   100, "shield_effect",         COL_funct_null    },
/*24*/{ RTeulemod, 3,    200,   100, "flame",                 COL_funct_null    },
/*25*/{ RTeulemod, 3,    200,   100, "cluster",               COL_funct_null    },
/*26*/{ RTeulemod, 5,    200,   300, "fragment",              COL_funct_weap    },
/*27*/{ RTfsprite, 5,    200,   100, "gas",                   COL_funct_null    },
/*28*/{ RTfsprite, 5,    200,  1000, "gas_cloud",             COL_funct_gascloud},
/*29*/{ RTfsprite, 5,    200,   100, "lightning",             COL_funct_null    },
/*30*/{ RTfsprite, 5,    200,   200, "ion",                   COL_funct_null    },
/*31*/{ RTfsprite, 5,    200,   100, "explosion_flame",       COL_funct_null    },
/*32*/{ RTfsprite, 5,    200,   100, "explosion_cluster",     COL_funct_null    },
/*33*/{ RTeulemod, 1,    200,   100, "explosion_gas",         COL_funct_null    },
/*34*/{ RTfsprite, 5,    200,   100, "explosion_lightning",   COL_funct_null    },
/*35*/{ RTfsprite, 5,    200,   100, "explosion_fire",        COL_funct_null    },
/*36*/{ RTfsprite, 5,    200,   100, "explosion",             COL_funct_null    },
/*37*/{ RTeulemod, 5,    200,   100, "fog",                   COL_funct_fog     },
/*38*/{ RTfsprite, 5,    200,   100, "smoke_fx",              COL_funct_null    }
 };


///////////////////////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////////////////////


void	OBJ_moveall()
	{
   s32   f;
//   s32 ian_timer;
//   s8	 steer_val;
//   AI_NAVIGATION	*ai_ptr;

   OBJ_STRUCT  *pobj = OBJ_objects ;

	if(arState==AR_PLAY)
		arPlay();
	else{
		#if IAN

        OBJ_players[0].SIM_input_id = SD_PadData[0].Id;
        OBJ_players[0].SIM_input_data = SD_PadData[0].data^0xffff;
        OBJ_players[0].SIM_input_push = SD_PadData[0].push;
        OBJ_players[0].SIM_input_an1x = SD_PadData[0].An1X;
        OBJ_players[0].SIM_input_an1y = SD_PadData[0].An1Y;
        OBJ_players[0].SIM_input_an2x = SD_PadData[0].An2X;
        OBJ_players[0].SIM_input_an2y = SD_PadData[0].An2Y;

		OBJ_players[1].SIM_input_push = SD_PadData[4].push;

		select_replay_mode(OBJ_players[1].SIM_input_push);

		if((OBJ_players[1].SIM_input_push&PAD_LU))
			steer_mode = !steer_mode;

		if(steer_mode)
			{
			for(f=1;f<MAXNUMPLAYERS;f++)
				AI_pilot_simulator(&AI_pilot[f],&OBJ_players[f]);
			}
		else{
            OBJ_players[1].SIM_input_id = SD_PadData[4].Id;
            OBJ_players[1].SIM_input_data = SD_PadData[4].data^0xffff;
            OBJ_players[1].SIM_input_push = SD_PadData[4].push;
            OBJ_players[1].SIM_input_an1x = SD_PadData[4].An1X;
            OBJ_players[1].SIM_input_an1y = SD_PadData[4].An1Y;
            OBJ_players[1].SIM_input_an2x = SD_PadData[4].An2X;
            OBJ_players[1].SIM_input_an2y = SD_PadData[4].An2Y;
			}
	
		#else
		
		for(f=0;f<MAXNUMPLAYERS;f++)
			{
//			OBJ_players[f].computer = 1;

			if(OBJ_players[f].computer)
				AI_pilot_simulator(&AI_pilot[f],&OBJ_players[f]);
			else{
                register int p = ThePads[f];
                OBJ_players[f].SIM_input_id = SD_PadData[p].Id;
                OBJ_players[f].SIM_input_data = SD_PadData[p].data^0xffff;
                OBJ_players[f].SIM_input_push = SD_PadData[p].push;
                OBJ_players[f].SIM_input_an1x = SD_PadData[p].An1X;
                OBJ_players[f].SIM_input_an1y = SD_PadData[p].An1Y;
                OBJ_players[f].SIM_input_an2x = SD_PadData[p].An2X;
                OBJ_players[f].SIM_input_an2y = SD_PadData[p].An2Y;
				}
			}
			
		#endif
		
  		arRecord();
		}

   ///////////////////////////

   arDebug();

   ///////////////////////////

   COL_clearoocolgrid();

   ///////////////////////////

   // move each object
   for( f=0;f<MAXNUMOBJS;f++, pobj++ )
		{
      //if( OBJ_objects[f].stat==ON )
      if( pobj->stat==ON )
         {
         // ooc object not linked yet
         pobj->link  =  NULL;
			// doobj
			switch( OBJ_objects[f].type )
            {
            case  OTcraft :
               {
               if (!handycam)
                  SIM_craft( f );
                  //SIM_craftcomp( f );
//               else
//                 {
//                  if (fx_allowed)
//                     {
//                     PCK_process_pickups(&OBJ_players[f], &OBJ_objects[OBJ_players[f].pobj->index]);
//                     WPN_process_weapon(&OBJ_players[f]);
//                     }
//                  }
					}
               break;
            case  OTtorpedo :
               if (fx_allowed)
                  PCK_process_torpedo(pobj);
               break;

//	   	    case  OTmissile :
//				if (fx_allowed)
//                PCK_process_missile(pobj);
//	   	         break;

	   	    case  OTburst :
				if (fx_allowed)
                  PCK_process_burst(pobj);
	   	         break;

//	   	    case  OThigh_octane :
//				if (fx_allowed)
//                  PCK_process_octane(pobj);
//	   	         break;

	   	    case  OTcluster :
				if (fx_allowed)
                  PCK_process_cluster(pobj);
	   	         break;

	   	    case  OTfragment :
				if (fx_allowed)
                  PCK_process_fragment(pobj);
	   	         break;

            case  OTion :
				if (fx_allowed)
                 PCK_process_ion_gun(pobj);
                 break;

            case  OTmine :
               //SIM_rock( pobj );
               break;
//            case  OTexplosion_fire  :
//                 PSX_process_fire(&OBJ_objects[f]); break;
            //case  OTgas_cloud :
            //if (fx_allowed)
              //   PSX_process_gas_cloud(&OBJ_objects[f]);
                // break;

            }
         // link (moved)object to coll grid
         if( (pobj->stat==ON) && (OBJ_typeinfo[pobj->type].COL_pfunct!=COL_funct_null))
         	COL_addoocobj( pobj );
         }
      }

   //COL_objobj();

   COL_objobj2();
   //COL_timespheres();

//   if (fx_allowed)
//      {
      // PSX_bullets();
//      PSX_fire_fx();
      // PSX_process_ripple_ctrls();
      // PSX_process_ripples();
//      }
	}

s32	OBJ_newobj(s16 type)    // use free list!!
   {
   s32  i;
   for (i=0;i<MAXNUMOBJS;i++)
      {
      if (OBJ_objects[i].stat==OFF)
         {
         //sprintf(debbuf,"Init obj: %s", OBJ_typeinfo[ type ].name );
         //RENDER_message(debbuf);
         OBJ_objects[i].stat  = ON;
         OBJ_objects[i].type  = type;

         OBJ_objects[i].link  = NULL;
         OBJ_objects[i].owner = -1;
         OBJ_objects[i].fx_id = NULLVAL;

         OBJ_objects[i].pkup_data.AI_index = NULLVAL;

			return i;
         }
      }

   // dam no more free object places, search for an exlposion to cookoo
   //ATTENTION!
   //for (i=0;i<MAXNUMOBJS;i++)
   //   {
   //   if ( OBJ_objects[i].stat==ON && OBJ_objects[i].type==OTexplosion_fire )
   //      {
   //      return i;
   //      }
   //   }
   sprintf(debbuf,"Could not init obj: %s", OBJ_typeinfo[ type ].name );
   RENDER_message(debbuf);
   return   NULLVAL;
   }

s16   delobjl[50];
s16   delobji;


void	OBJ_delobj( s32	n )
   {
	if (n > 32767)
		mprintf("on no\n");
			
	if (n < MAXNUMPLAYERS)
		mprintf("oh dear\n");

   delobjl[ delobji++ ]=n;
   if(delobji>50)
      mprintf( "tried to delete to many objects. Fucked" );
   }
/*
void  OBJ_delobj( s32   n)
	{
   if( OBJ_objects[n].stat!=0 )
      {
      OBJ_objects[ n ].stat   = OFF;
      OBJ_objects[ n ].type   = OFF;
      OBJ_objects[ n ].m0     = OFF;
      OBJ_objects[ n ].m1     = OFF;
      OBJ_objects[ n ].owner  = OFF;
      OBJ_objects[ n ].fx_id = NULLVAL;
      //      OBJ_objects[ n ].pkup_data.state = OFF;
      //      OBJ_objects[ n ].pkup_data.type = NULLVAL;
      //      OBJ_objects[ n ].pkup_data.quantity = OFF;

      if (OBJ_objects[ n ].pkup_data.AI_index != NULLVAL)
         AI_objects[OBJ_objects[ n ].pkup_data.AI_index].in_use = FALSE;
      }
	}
*/
void  OBJ_initobjlist()
   {
   delobji=0;
   }

void  OBJ_delobjs()
	{
   s16   i;
   s16   n;


   for(i=0;i<delobji;i++)
      {
      n  =  delobjl[i];

      if( OBJ_objects[n].stat!=0 )
         {
         OBJ_objects[ n ].stat   = OFF;
         OBJ_objects[ n ].type   = OFF;
         OBJ_objects[ n ].m0     = OFF;
         OBJ_objects[ n ].m1     = OFF;
         OBJ_objects[ n ].owner  = OFF;
         OBJ_objects[ n ].fx_id = NULLVAL;
         //      OBJ_objects[ n ].pkup_data.state = OFF;
         //      OBJ_objects[ n ].pkup_data.type = NULLVAL;
         //      OBJ_objects[ n ].pkup_data.quantity = OFF;

//         if (OBJ_objects[ n ].pkup_data.AI_index != NULLVAL)
//            AI_objects[OBJ_objects[ n ].pkup_data.AI_index].in_use = FALSE;

         }
      }
	}


// n=index into OBJ_objects[]
// initialise a player and alloc render OBJ

void  OBJ_initplayer( u16  n, u8 crtype, u8 computer )
	{
   s32   ob, i;
//   s32 f;
	OBJ_PLAYERSTRUCT *p;


   p  =  &OBJ_players[ n ]  ;

//	if (p->smoking)
//	PSX_expns[p->pobj->fx_id].release_total = PSX_expns[p->pobj->fx_id].total_flames;

   //ob  =  OBJ_newobj( OTcraft );
   ob=n;

   if( ob == -1 )mprintf( "shit!!!!!!!!!\n" );

   OBJ_objects[ ob ].owner  =  n;    //link OBJ to PLAYER

   p->plyrnum = n;
   //p->crafttype   =  crtype;
   p->crafttype   =  STATE.ctype[n];
   p->pobj  =  &OBJ_objects[ ob ];   //link PLAYER to OBJ
   p->timer = 0;

   mprintf(" playerinit %d , obj %ld\n", n, ob );
	// init player info
   p->SIM_objmat.m[0][0]=0x1000;    p->SIM_objmat.m[0][1]=0;      p->SIM_objmat.m[0][2]=0;
   p->SIM_objmat.m[1][0]=0;         p->SIM_objmat.m[1][1]=0x1000; p->SIM_objmat.m[1][2]=0;
   p->SIM_objmat.m[2][0]=0;         p->SIM_objmat.m[2][1]=0;      p->SIM_objmat.m[2][2]=0x1000;
   vequs( &p->wvect, 0,0,0 );
   p->compold  =0;
   p->firerep  =0;
   p->steerang =0;
   p->steervel =400;
   p->latgrip  =0;
   p->throttle =0;
   p->throttlevel=32;
   p->leno[0]  =0;
   p->leno[1]  =0;
   p->leno[2]  =0;
   p->leno[3]  =0;
   vequ( &p->oldp, 0, 0, 0 );
   p->SIM_input_data=0;
   p->stability   =  255;
   p->computer   =  computer;

   OBJ_objects[ob].p.vx  =  LOAD_startpoints[ob].vx<<8;
   OBJ_objects[ob].p.vy  =  LOAD_startpoints[ob].vy<<8;
   OBJ_objects[ob].p.vz  =  LOAD_startpoints[ob].vz<<8;

   OBJ_objects[ob].v.vx  =  0;
   OBJ_objects[ob].v.vy  =  0;
   OBJ_objects[ob].v.vz  =  0;

   OBJ_objects[ob].r.vx  =  0;
   OBJ_objects[ob].r.vy  =  0;
   OBJ_objects[ob].r.vz  =  0;

   OBJ_objects[ob].stat  =  ON;
   OBJ_objects[ob].type  =  OTcraft;

    p->shield_strength = 0;
    p->armour_level = 800;
	p->ammo = 0;

    p->weapon_level = 0;

    p->pickups.index = 0;
    p->pickups.current = NULLVAL;
    p->pickups.total = 0;

    for (i = 0; i < MAXPICKUPS; i++)
      {
      p->pickups.pickup_list[i] = NULLVAL;
      p->pickups.quantity[i] = 0;
      }
	p->flamer_in_use = FALSE;
	p->plasma_in_use = FALSE;
	p->smoking = FALSE;

//	p->frag_count = 0;
   p->mode360=-1;
   p->turbo=0;

   p->stats.lap   =  0;

	init_player_stats_struct(p);
   }

void  OBJ_re_initplayer( u16  n, u8 crtype, u8 computer )
	{
   s32   ob, i;
//   s32 f;
	OBJ_PLAYERSTRUCT *p;


   p  =  &OBJ_players[ n ]  ;

	if (p->smoking)
	PSX_expns[p->pobj->fx_id].release_total = PSX_expns[p->pobj->fx_id].total_flames;

   //ob  =  OBJ_newobj( OTcraft );
   ob=n;

   if( ob == -1 )mprintf( "shit!!!!!!!!!\n" );

   OBJ_objects[ ob ].owner  =  n;    //link OBJ to PLAYER

   p->plyrnum = n;
   //p->crafttype   =  crtype;
   p->crafttype   =  STATE.ctype[n];
   p->pobj  =  &OBJ_objects[ ob ];   //link PLAYER to OBJ

   p->timer = 0;

   mprintf(" playerinit %d , obj %ld\n", n, ob );
	// init player info
//   p->SIM_objmat.m[0][0]=0x1000;    p->SIM_objmat.m[0][1]=0;      p->SIM_objmat.m[0][2]=0;
//   p->SIM_objmat.m[1][0]=0;         p->SIM_objmat.m[1][1]=0x1000; p->SIM_objmat.m[1][2]=0;
//   p->SIM_objmat.m[2][0]=0;         p->SIM_objmat.m[2][1]=0;      p->SIM_objmat.m[2][2]=0x1000;
   vequs( &p->wvect, 0,0,0 );
   p->compold  =0;
   p->firerep  =0;
   p->steerang =0;
   p->steervel =400;
   p->latgrip  =0;
   p->throttle =0;
   p->throttlevel=32;
   p->leno[0]  =0;
   p->leno[1]  =0;
   p->leno[2]  =0;
   p->leno[3]  =0;
   vequ( &p->oldp, 0, 0, 0 );
   p->SIM_input_data=0;
   p->stability   =  255;
   p->computer   =  computer;

//   OBJ_objects[ob].p.vx  =  LOAD_startpoints[ob].vx<<8;
//   OBJ_objects[ob].p.vy  =  LOAD_startpoints[ob].vy<<8;
//   OBJ_objects[ob].p.vz  =  LOAD_startpoints[ob].vz<<8;

   OBJ_objects[ob].v.vx  =  0;
   OBJ_objects[ob].v.vy  =  0;
   OBJ_objects[ob].v.vz  =  0;

//   OBJ_objects[ob].r.vx  =  0;
//  OBJ_objects[ob].r.vy  =  0;
//   OBJ_objects[ob].r.vz  =  0;

   OBJ_objects[ob].stat  =  ON;
   OBJ_objects[ob].type  =  OTcraft;

    p->shield_strength = 0;
    p->armour_level = 800;
	p->ammo = 0;

    p->weapon_level = 0;

    p->pickups.index = 0;
    p->pickups.current = NULLVAL;
    p->pickups.total = 0;

    for (i = 0; i < MAXPICKUPS; i++)
      {
      p->pickups.pickup_list[i] = NULLVAL;
      p->pickups.quantity[i] = 0;
      }
	p->flamer_in_use = FALSE;
	p->plasma_in_use = FALSE;
	p->smoking = FALSE;

//	p->frag_count = 0;
   p->mode360=-1;
   p->turbo=0;


	init_player_stats_struct(p);
   }

void   OBJ_initobjarray()
   {
   s16   f;
   for(f=0;f<MAXNUMOBJS;f++)
      {
      OBJ_objects[ f ].index = f;
      OBJ_objects[ f ].type =
      OBJ_objects[ f ].stat =
      OBJ_objects[ f ].m0 =
      OBJ_objects[ f ].m1 =
      OBJ_objects[ f ].owner =   OFF;
      OBJ_objects[ f ].fx_id = NULLVAL;

     //OBJ_objects[ f ].pkup_data.state = OFF;
      OBJ_objects[ f ].pkup_data.type = NULLVAL;
      OBJ_objects[ f ].pkup_data.quantity = OFF;

      OBJ_objects[ f ].pkup_data.AI_index = NULLVAL;
      }
   }

void OBJ_damage_player(OBJ_PLAYERSTRUCT *plyr_ptr, OBJ_STRUCT *obj_ptr, s8 plasma)
{
	OBJ_STRUCT				*pobj;
	vec32					impact_vector;
	int						i;


	for(i = 0; i < delobji; i++)
 	{
		if (delobjl[i] == obj_ptr->index)
		{
			mprintf("fuck no!!\n");
		}
	}

  	pobj = plyr_ptr->pobj;

     if (plyr_ptr->shield_strength >= obj_ptr->pkup_data.power)
     {
        plyr_ptr->shield_strength -= obj_ptr->pkup_data.power;
        impact_vector.vx = pobj->p.vx;
        impact_vector.vy = pobj->p.vy;
        impact_vector.vz = pobj->p.vz;
        PSX_init_shield_effect(plyr_ptr, &impact_vector);
     }
   	else
   	{
		if (plyr_ptr->timer > 50)
		{
			if (plyr_ptr->shield_strength)
			{
				obj_ptr->pkup_data.power -= plyr_ptr->shield_strength;
				plyr_ptr->shield_strength = 0;
			}

	   		plyr_ptr->armour_level -= obj_ptr->pkup_data.power;
		}

		if ((plyr_ptr->armour_level < 500) && (!plyr_ptr->smoking))
		{
			plyr_ptr->smoking = TRUE;
 			PSX_init_new_explosion(plyr_ptr->pobj, smoke_fx, OTHER_COLLISION);
		}

      	if (plyr_ptr->armour_level <= 0)
        {
            if ((obj_ptr->owner > NULLVAL) && (obj_ptr->owner < MAXNUMPLAYERS))
               {
               OBJ_players[obj_ptr->owner].stats.kills ++;//=10;//++
			   if(obj_ptr->owner==0)
			   if((STATE.currlevel&0x03)==0x03)
			   if(OBJ_players[obj_ptr->owner].stats.kills>=( (LROpt[0]==3)?(10):( (LROpt[0]==4)?(25):( (LROpt[0]==5)?(50):(10 /* never here */) ) ) ))
					{
					// Finished ?

					// Need to implement time control
					// LROpt[0] = num frags (0=1min,1=3min,2=5min,3=10,4=25,5=50,6=unlimited)

				   	arStart();
					}
			   }

            PSX_init_new_explosion(plyr_ptr->pobj, craft_explosion, OTHER_COLLISION);

//            if (OBJ_objects[g].stat)
//               OBJ_delobj(g);

//			OBJ_delobj(OBJ_objects[f].index);
            mprintf("You're dead player %d!\n", plyr_ptr->plyrnum);
            FntPrint("You're dead!\n");
            OBJ_re_initplayer( plyr_ptr->plyrnum, plyr_ptr->crafttype, plyr_ptr->computer );
        }
    }

	if ((obj_ptr->owner > NULLVAL) && (obj_ptr->owner < MAXNUMPLAYERS))
	{
		if (obj_ptr->type == OTgas_cloud)
			return;

		if (OBJ_players[obj_ptr->owner].plasma_in_use)
			return;

		if (plasma == TRUE)
			return;
	}

	if ((obj_ptr->owner > 7) || (obj_ptr->owner < 0))
	   mprintf("help\n");

	if (obj_ptr->type != OTmine)
  	{
    	if (obj_ptr->type == OTtorpedo)
	    	PSX_init_splash(obj_ptr, torpedo_exp_splash);

     	PSX_init_new_explosion(obj_ptr, obj_ptr->pkup_data.type, SHIP_COLLISION);
  	}
  	else
  	{
    	if (obj_ptr->m1 == TRUE)
        	PSX_init_splash(obj_ptr, mine_exp_splash);
     	else
        	PSX_init_new_explosion(obj_ptr, obj_ptr->pkup_data.type, SHIP_COLLISION);
  	}

	if (obj_ptr->stat)
		OBJ_delobj(obj_ptr->index);

	return;
}
