//Pickups.c
//
//Author - Ian Tomkins
//
//This file stores all code for all pickups in game,
//guns, bombs etc...
//

#include "header.h"
#include "objects.h"
#include "pickups.h"
#include "collide.h"
#include "state.h"
#include "camera.h"
#if PSX
//	[...these pickups are never gonna do anythin...]
	#include "PSX\PSX_libs.h"
    #include "PSX\PSX_pcks.h"
    #include "PSX\PSX_expn.h"
	#include "psx\gpupsx.h"
	#include "sdlib\sdfunc.h"
	#include "psx\soundpsx.h"
#endif
#if N64
/*
	...yeah right matt,  fuck off, "if N64 indeed!", like what are the
	chances of YOU making this game ...???
*/
    #include "N64\N64_pcks.h"
    #include "n64core\sincos.h"
    #include "n64\mathn64.h"
#endif

#include "AI.h"
#include "version.h"
#include "rand.h"
#include "psx\mathpsx.h"
#include "libgte.h"
PAIR_2D					missile_collision_vector;
FLARE_POSITION			PCK_flares[MAX_BURSTS];

int rck_timer_on;
int	miss_timer_on;
int rck_timer_off;
int	miss_timer_off;

#if N64
7
s16 SDRAND(int i)
	{
    return rand()%i;
    }

s16 rand()
	{
    static int notVeryRand = 0;
    notVeryRand += 3;
    return notVeryRand;
    }

//What the hell is THIS!!!???!?!?! doing in my file!!!!!!?!?!?!?!?!

#endif
//SVECTOR			trail[1000];
int				index = 0;
int				total_flag = FALSE;
u8				timer_val = 0;
int				old_height;

extern GsOT		*ptrwot;

extern APAD SD_PadData[8];

int		sight_length_l = 4500;
int		sight_length_r = 4500;

//OCTANE_FX		PCK_octane[MAX_OCTANES];
//ROCKET_SET		PCK_rockets[MAX_ROCKET_SETS];

// Jon's pickup positions, used for initialising and resetting pickups
vec16 PCK_positions[20];
/*
s32 PCK_pickup_data_t1[12][3] =
{
   {12974, -57, 22591}, //torpedo
   {24077, 657, 24214}, //rockets
   {27232, 616, 13956}, //missile
   {13134, -30, 944},      //mine
   {16721, 270, -13620},   //shield
   {-6827, -30, -18612},   //cluster
   {-23962, -30, -10613},  //flamer
   {-18575, 376, 10170},   //ion
   {-1214, 1, 6468},    //plasma
   {8858, -54, 17283},     //flare
   {-8555, 1, 9769},    //pgas
   {-11951, 600, 22170} //turbo
};

s32 PCK_pickup_data_t2[12][3] =
{
	{20202, -129, 29161},	//torpedo
	{26938, -129, 15965},	//rockets
	{17090, -129, -8997},	//missile
	{-14826, -129, -27584},		//mine
	{-19345, -129, 2569},	//shield
	{-2902, -661, 25450},	//cluster
	{-10562, -98, 11756},	//flamer
	{8851, -98, 15466},	//ion
	{24675, -98, -1950},		//plasma
	{14482, -98, 5168},		//flare
	{7104, -98, -18420},		//pgas
	{18487, -98, -22867}	//turbo
};

s32 PCK_pickup_data_t3[12][3] =
{
	{-29432, -75, 26417},	//torpedo
	{3, -75, 22719},	//rockets
	{18160, -75, 12337},	//missile
	{28695, -75, -4513},		//mine
	{18070, -75, -15997},	//shield
	{28850, -75, 12985},	//cluster
	{2235, -75, 7509},	//flamer
	{-9244, -75, 912},	//ion
	{-11312, -75, -18091},		//plasma
	{-23294, -75, -16362},		//flare
	{-12322, -75, -2598},		//pgas
	{-22321, -75, 18344}	//turbo
};

s32 PCK_pickup_data_a[12][3] =
{
	{9561, -813, 16694},
	{13451, -750, 10628},
	{18961, 1562, 889},
	{26440, 219, -10375},
	{14454, -313, -14548},
	{10259, -313, -21443},
	{2449, -313, -21086},
	{3596, -594, -7048},
	{-6353, -781, 3610},
	{-7794, -875, 13839},
	{-9588, -875, -623},
	{-13219, 0, -20363}
};
*/
//Local Function Prototypes:

//pickup initialisers
s32 init_torpedo(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_missile(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_shield(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_mine(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_burst(OBJ_PLAYERSTRUCT *plyr_ptr);
//s32 init_high_octane(OBJ_PLAYERSTRUCT *plyr_ptr);
//s32 init_rocket_set(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_rocket(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_cluster(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_fragment(OBJ_STRUCT *obj_ptr, s32  angle);
s32 init_gas(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_plasma(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_flame_thrower(OBJ_PLAYERSTRUCT *plyr_ptr);
s32 init_ion_gun(OBJ_PLAYERSTRUCT *plyr_ptr);

void init_flare_pos(OBJ_STRUCT *obj_ptr);
void update_flare_pos(OBJ_STRUCT *obj_ptr);

//OCTANE_FX *init_octane_object(void);
//ROCKET_SET *init_rocket_set_object(void);

char PCK_missile_collision(short angle, PAIR_2D missile_position, OBJ_STRUCT *obj_ptr);

///////////////////////////////////////////////////////////////////////////
//                            Controller Function!                       //
//                                 17 Sept. 1998                         //
///////////////////////////////////////////////////////////////////////////


void PCK_process_pickups(OBJ_PLAYERSTRUCT *plyr_ptr, OBJ_STRUCT *obj_ptr)
//This function is the main controlling function for object interaction. It checks
//pad data for a particular player and checks to see if a weapon/pickup has either
//been used or changed. It either is true it perform a few simple tests and updates
//structures accordingly

//*plyr_ptr is a pointer to the current player structure bieng processed.
{
    s32             pad_data;
    OBJ_PICKUP      *pk_ptr;
    s32             success;
    vec32           impact_vector;
	s8				local_flag = FALSE;

//static   u8 w=16;//jof
   plyr_ptr->timer ++;


	if (plyr_ptr->flamer_in_use == TRUE)
	{
		icons[plyr_ptr->pobj->index].in_use = TRUE;
		icons[plyr_ptr->pobj->index].type = pck_flame;
	}

	if (plyr_ptr->plasma_in_use == TRUE)
	{
		icons[plyr_ptr->pobj->index].in_use = TRUE;
		icons[plyr_ptr->pobj->index].type = pck_plasma;
	}

#if PSX

	if (plyr_ptr->pobj->index == 0)
		display_backmarker(plyr_ptr);

	if (STATE.numscreens == 2)
	{
		if (plyr_ptr->pobj->index == 1)
			display_backmarker(plyr_ptr);
	}

#endif
	if ((plyr_ptr->flamer_in_use) || (plyr_ptr->plasma_in_use))
		return;

//	pad_data = plyr_ptr->SIM_input_push;
	pad_data = plyr_ptr->SIM_input_data;

//	if (plyr_ptr->plyrnum == 0)
//		printf("x = %d : y = %d : z = %d\n", plyr_ptr->pobj->p.vx >> 8, plyr_ptr->pobj->p.vy >> 8, plyr_ptr->pobj->p.vz >> 8);

//	pad_data = SD_PadData[(plyr_ptr->pobj->index * 4)].push;

//	if (pad_data & PAD_LD)
//		timer_val = 1;

//	if (timer_val > 0)
//	{
//		screen_flash(164, 128, 96, timer_val);
//
//		timer_val ++;

//		if (timer_val >= 8)
//			timer_val = 0;
//	}

    pk_ptr = &plyr_ptr->pickups;                            //assigns pointer to pickup data

	if (pk_ptr->current == 1)
	{
		if (pk_ptr->quantity[pk_ptr->index] == 8)
		{
			plyr_ptr->fx_timer = 0;
			local_flag = FALSE;
		}
		else
		{
			plyr_ptr->fx_timer ++;
			local_flag = TRUE;
		}
	}

    if (((local_flag == FALSE) && (pad_data & PAD_FRB)) || ((pk_ptr->current == 1) && (pk_ptr->quantity[pk_ptr->index] < 8) && (!(plyr_ptr->fx_timer % 3))))
    {
        if (pk_ptr->current != NULLVAL)     //checks to see if player has a pickup
        {
            switch (pk_ptr->current)        //Selects pickup to fire
            {
                case pck_cannon: //Torpedo
                {
					plyr_ptr->ammo = MAX_AMMO_LEVEL;
					success = TRUE;
					break;
				}

                case pck_torpedo: //Torpedo
                {
                    success = init_torpedo(plyr_ptr);

                    break;
                }

                case pck_missile: //Missile
                {
                    success = init_missile(plyr_ptr);

                    break;
                }

                case pck_shield: //Shield
                {
                SOUND_sfx(2);
               success = init_shield(plyr_ptr);


                    impact_vector.vx = plyr_ptr->pobj->p.vx - 75;
                    impact_vector.vy = plyr_ptr->pobj->p.vy;
                    impact_vector.vz = plyr_ptr->pobj->p.vz - 150;

//                    plyr_ptr->shield_timer = SHIELD_LIFE;
//                    plyr_ptr->shield_strength = MAX_SHIELD_STRENGTH;

//                    PSX_init_shield_effect(plyr_ptr, &impact_vector);

//                    success = TRUE;

                    break;
                }

                case pck_mine: //mine
                {
                    success = init_mine(plyr_ptr);

                    break;
                }

                case pck_flare: //flare
                {
                    success = init_burst(plyr_ptr);

                    break;
                }

                case pck_rocket: //flare
                {
//                    success = init_rocket_set(plyr_ptr);
                    success = init_rocket(plyr_ptr);

                    break;
                }

                case pck_cluster: //cluster
                {
                    success = init_cluster(plyr_ptr);

                    break;
                }

                case pck_gas: //Gas
                {
                    success = init_gas(plyr_ptr);

                    break;
                }

                case pck_plasma: //Lightning
                {

                    success = init_plasma(plyr_ptr);

                    break;
                }

                case pck_flame: //Lightning
                {
                    //success = PSX_init_flamer(plyr_ptr);
					
					PSX_init_flame_animation(plyr_ptr->pobj, pck_flame, SHIP_COLLISION);
					PSX_init_flame_animation(plyr_ptr->pobj, pck_flame, SHIP_COLLISION);

                    break;
                }

                case pck_ion: //Lightning
                {
                    success = init_ion_gun(plyr_ptr);

                    break;
				}

                case pck_turbo: //Lightning
                {
                    //success = init_high_octane(plyr_ptr);
                    plyr_ptr->turbo=30;
                    S2_sfxdynamic( 22, obj_ptr->p.vx>>8, obj_ptr->p.vz>>8, 0, 120, 4600 );

                    break;
				}

                default:
                {
                    success = FALSE;

                    break;
                }
            }

            if (!success)
                return;

            pk_ptr->quantity[pk_ptr->index] --;

            if (!pk_ptr->quantity[pk_ptr->index])
            {
                pk_ptr->pickup_list[pk_ptr->index] = NULLVAL;   //removes pickup from players collection
                pk_ptr->total--;                                //reduces their pickups total

                if (pk_ptr->total)
                {
                    while (pk_ptr->pickup_list[pk_ptr->index] == NULLVAL)   //increments index to next pickup
                    {
                        pk_ptr->index++;

                        if (pk_ptr->index == MAXPICKUPS)
                            pk_ptr->index = 0;
                    }

                    pk_ptr->current = pk_ptr->pickup_list[pk_ptr->index];   //sets the current pickup type
                }
                else
                {
                    pk_ptr->index = 0;            //if there is no pickups left, then flag this
                    pk_ptr->current = NULLVAL;
                }
            }
        }
    }

#if JON
        if (pad_data & PAD_FLB) //Checks for player changing weapon, if player has more than 1
        {                       //pickup then it selects the next pickup in their collection
            pk_ptr->index++;

            if (pk_ptr->index == MAXPICKUPS)
                pk_ptr->index = 0;

            while (pk_ptr->pickup_list[pk_ptr->index] == NULLVAL)
            {
                pk_ptr->index++;

                if (pk_ptr->index == MAXPICKUPS)
                    pk_ptr->index = 0;
            }

            pk_ptr->current = pk_ptr->pickup_list[pk_ptr->index];
        }
#endif

//	if (!pk_ptr->total)
//		allocate_player_pickups(plyr_ptr);

	switch (pk_ptr->current)
	{
		case pck_cannon:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_cannon;

			break;
		}

		case pck_torpedo:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_torpedo;

			break;
		}

		case pck_missile:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_missile;

			break;
		}

		case pck_flame:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_flame;

			break;
		}

		case pck_rocket:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_rocket;

			break;
		}

		case pck_mine:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_mine;

			break;
		}

		case pck_cluster:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_cluster;

			break;
		}

		case pck_plasma:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_plasma;

			break;
		}

		case pck_gas:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_gas;

			break;
		}

		case pck_ion:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_ion;

			break;
		}

		case pck_flare:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_flare;

			break;
		}

		case pck_shield:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_shield;

			break;
		}

		case pck_turbo:
		{
			icons[plyr_ptr->pobj->index].in_use = TRUE;
			icons[plyr_ptr->pobj->index].type = pck_turbo;

			break;
		}

		default:
		{
			icons[plyr_ptr->pobj->index].in_use = FALSE;

			break;
		}
	}

	return;
}

///////////////////////////////////////////////////////////////////////////
//                           Object Interaction!                         //
//                              17 Sept. 1998                            //
///////////////////////////////////////////////////////////////////////////

s32 PCK_collect_pickup(OBJ_STRUCT *obj_ptr, OBJ_PLAYERSTRUCT *plyr_ptr)
//This function assigns a pickup just collected this frame by a player to that
//players pickup list. If the game is the track section and the player allready
//has a pickup then nothing happens.

//*obj_ptr is a pointer to the object bieng picked up
//*plyr_ptr is a pointer to the player picking up the object

{
    OBJ_PICKUP      *pk_ptr;


	if (obj_ptr->pkup_data.type == NULLVAL)
		return TRUE;

    pk_ptr = &plyr_ptr->pickups;                            //assigns pointer to pickup data

//    switch (STATE.arena_mode)
//    {
//        case 0: //In track section
//        {
            if (pk_ptr->current != NULLVAL)     //does nothing if player allready has a pickup
                return TRUE;

            pk_ptr->pickup_list[pk_ptr->index] = obj_ptr->pkup_data.type;  //Sets the free space to
                                                                           //the pickup type
            pk_ptr->quantity[pk_ptr->index] = obj_ptr->pkup_data.quantity;
            pk_ptr->current = pk_ptr->pickup_list[pk_ptr->index];

            pk_ptr->total = 1;
            S2_sfxdynamic( 32, plyr_ptr->pobj->p.vx>>8, plyr_ptr->pobj->p.vz>>8, 0,120, 4600);
//            break;
//        }
/*
        case 1: //In arena section
        {

            if (pk_ptr->total < MAXPICKUPS)
            {
                pk_ptr->total++;

                while (pk_ptr->pickup_list[pk_ptr->index++] != NULLVAL)   //increments index to next free
                {                                                         //space in list
                    if (pk_ptr->index == MAXPICKUPS)
                        pk_ptr->index = 0;
                }

                pk_ptr->pickup_list[pk_ptr->index] = obj_ptr->pkup_data.type;  //Sets the free space to
                                                                               //the pickup type
                pk_ptr->quantity[pk_ptr->index] = obj_ptr->pkup_data.quantity;
            }

            break;
        }
    }
*/



    return FALSE;
}

s32 init_shield(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a missile. It sets the missile to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the missile.

//plyr_num is the player number currenly initialising (firing) a missile
{
    s32             index;
    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;


	if (plyr_ptr->shield_id != NULLVAL)
	{
	    plyr_ptr->shield_strength = 500;
		
		OBJ_objects[plyr_ptr->shield_id].pkup_data.timer = 0;

		return TRUE;
	}

    index = OBJ_newobj(OTshield);

    if (index == NULLVAL)
        return FALSE;

    obj_ptr = &OBJ_objects[index];
    plyr_obj_ptr = plyr_ptr->pobj;

    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets missile position and euler orientation to
    obj_ptr->p.vy = plyr_obj_ptr->p.vy;         //that of the owner ship
    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

    obj_ptr->r.vx = 0;
    obj_ptr->r.vy = 0;
    obj_ptr->r.vz = 0;

    obj_ptr->v.vx = 0;  // + speed increment to allow missile to fly off.
    obj_ptr->v.vy = 0;  // + speed increment to allow missile to fly off.
    obj_ptr->v.vz = 0; // + speed increment to allow missile to fly off.

    obj_ptr->owner = plyr_obj_ptr->index;       //Sets owner of missile
    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that missile is in
	obj_ptr->pkup_data.timer = 0;
    plyr_ptr->shield_strength = 500;

	plyr_ptr->shield_id = obj_ptr->index;

    return TRUE;
}
/*
s32 init_rocket_set(OBJ_PLAYERSTRUCT *plyr_ptr)
{
    s32             index;
    OBJ_STRUCT      *obj_ptr;
    ROCKET_SET      *ptr;


    index = OBJ_newobj(OTrocket_set);

    if (index == NULLVAL)
        return FALSE;                             //No more object structures.

    obj_ptr = &OBJ_objects[index];
    obj_ptr->owner = plyr_ptr->plyrnum;

    ptr = (ROCKET_SET *)init_rocket_set_object();

    if (ptr == NULL)
    {
        OBJ_delobj(index);
        return FALSE;
    }

    ptr->timer = 0;
    ptr->owner = plyr_ptr->plyrnum;

    ptr->rocket_count = 12;
    ptr->offset_vector = (64 << 8);

	obj_ptr->fx_id = ptr->index;

    return TRUE;
}

void PCK_process_rocket_set(OBJ_STRUCT *obj_ptr)
{
    s8                  success;
    ROCKET_SET          *fx_ptr;
    OBJ_STRUCT          *plyr_obj_ptr;


    fx_ptr = &PCK_rockets[obj_ptr->fx_id];
    plyr_obj_ptr = OBJ_players[obj_ptr->owner].pobj;

    if (!(fx_ptr->timer % 3))
    {
        success = init_rocket(plyr_obj_ptr, fx_ptr);

        if (success)
        {
            fx_ptr->rocket_count --;

            if (!fx_ptr->rocket_count)
            {
                PCK_rockets[obj_ptr->fx_id].in_use = FALSE;
                obj_ptr->type = NULLVAL;
                OBJ_delobj(obj_ptr->index);

                return;
            }
        }
        else
        {
            PCK_rockets[fx_ptr->index].in_use = FALSE;
            obj_ptr->type = NULLVAL;
            OBJ_delobj(obj_ptr->index);

            return;
        }
    }

    fx_ptr->timer ++;

    return;
}
*/
s32 init_rocket(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index;
    OBJ_STRUCT      *obj_ptr;
    s32             ang, x_vel, z_vel, angle, offset_vector, trail_idx;
    s16             ans1, ans2, angle_inc;


     index = OBJ_newobj(OTrocket);
    //SOUND_sfx_dynamic(5, 46 + (rand()&7) );

    if (index == NULLVAL)
        return FALSE;                             //No more object structures.

	obj_ptr = &OBJ_objects[index];

   	trail_idx = PSX_init_rocket_trail(obj_ptr);
//	trail_idx = NULLVAL;

	if (trail_idx == NULLVAL)
	{
		OBJ_delobj(index);

		return FALSE;
	}
	else
		obj_ptr->fx_id = trail_idx;	  

	offset_vector = (64 << 8);

    //SOUND_sfx_dynamic(5, index, 255 );
//   S2_sfxdynamic( 5,
//    obj_ptr = &OBJ_objects[index];
    obj_ptr->owner = plyr_ptr->plyrnum;

    if (!(plyr_ptr->pickups.quantity[plyr_ptr->pickups.index] % 2))
        angle_inc = -1024;
    else
        angle_inc = 1024;

	angle = (plyr_ptr->pobj->r.vy >> 4) + angle_inc;

    ans1 = (offset_vector * rsin(angle)) >> 12;
    ans2 = (offset_vector * rcos(angle)) >> 12;

    obj_ptr->p.vx = (plyr_ptr->pobj->p.vx) + ans1;
    obj_ptr->p.vz = (plyr_ptr->pobj->p.vz) + ans2;
    obj_ptr->p.vy = plyr_ptr->pobj->p.vy;

    obj_ptr->r.vx = 0;//plyr_ptr->pobj->r.vx - 300;                     //Not yet set by Jon

    if (!(plyr_ptr->pickups.quantity[plyr_ptr->pickups.index] % 2))
       {
       obj_ptr->r.vy = plyr_ptr->pobj->r.vy - 1024;    //Range is 0-65536
      S2_sfxdynamic( 5, obj_ptr->p.vx>>8, obj_ptr->p.vz>>8, 0, 120, 4100+(rand()&128) );
       }
    else
       {
       obj_ptr->r.vy = plyr_ptr->pobj->r.vy + 1024;    //Range is 0-65536
      S2_sfxdynamic( 5+64, obj_ptr->p.vx>>8, obj_ptr->p.vz>>8, 0, 120, 4100+(rand()&128) );
       }
    obj_ptr->r.vz = plyr_ptr->pobj->r.vz;                     //Not yet set by Jon

//   ang = obj_ptr->r.vy;              //obtain euler orientation of ship in PSX format from
                                           //OBJ_STRUCT for torpedo.

//    z_vel = (250 * rcos(ang)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
//    x_vel = (250 * rsin(ang)) >> 12;   //the scaler velocity of the torpedo and the crafts
                                        //euler orientation.
//	return TRUE;

    obj_ptr->v.vx = (plyr_ptr->pobj->v.vx);// + x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
    obj_ptr->v.vy = (plyr_ptr->pobj->v.vy);
    obj_ptr->v.vz = (plyr_ptr->pobj->v.vz);// + z_vel;

    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that torpedo is in

	obj_ptr->pkup_data.type = rocket_explosion;
	obj_ptr->pkup_data.power = 100;
	obj_ptr->pkup_data.timer = 0;

	obj_ptr->m0 = SquareRoot0(((obj_ptr->v.vx >> 8) * (obj_ptr->v.vx >> 8)) + ((obj_ptr->v.vy >> 8) * (obj_ptr->v.vy >> 8)) + ((obj_ptr->v.vz >> 8) * (obj_ptr->v.vz >> 8))) << 8;
	obj_ptr->m1 = 0;

    return TRUE;
}

void PCK_process_rocket(OBJ_STRUCT *obj_ptr)
//This function process's a torpedo for the current player this frame. It controls the movement
//of the object and handles collision with scenary.

//*obj_ptr is a pointer to the current object to be processed
//*plyr_ptr is a pointer to the curent player structure owning the torpedo.
{
    vec32           first_arg, second_arg, pos_craft;
    s32             i, coll_val, dist_to_craft, x_vel, z_vel, y_vel, temp_vel;
    s32             x_dist, z_dist, y_dist;
    s16             rot_ang, compare_ang, closest_distance;
	s32				bollocks, vector_distance, flare_flag, temp_dist;
	FLARE_POSITION	*flr_ptr;
	short			height_rot_ang, height_compare_ang;


	rck_timer_on = TRUE;

	for(i = 0; i < delobji; i++)
 	{
		if (delobjl[i] == obj_ptr->index)
		{
			printf("fuck no!!\n");
			return;
		}
	}

 // return;
//	for(i = 0; i < delobji; i++)
//	{
//		if (delobjl[i] == obj_ptr->index)
//			printf("fuck no rocket!!\n");
//	}

	obj_ptr->pkup_data.timer ++;

    first_arg.vx = obj_ptr->p.vx >> 8;
    first_arg.vy = obj_ptr->p.vy >> 8;
    first_arg.vz = obj_ptr->p.vz >> 8;

    obj_ptr->p.vx += obj_ptr->v.vx;
    obj_ptr->p.vy += obj_ptr->v.vy;
    obj_ptr->p.vz += obj_ptr->v.vz;

    second_arg.vx = obj_ptr->p.vx >> 8;
    second_arg.vy = obj_ptr->p.vy >> 8;
    second_arg.vz = obj_ptr->p.vz >> 8;

    coll_val = COL_test2(&first_arg, &second_arg); //Determines if the torpedo has hit the

    if ((coll_val > -1) /*|| (obj_ptr->pkup_data.timer > 750)*/)
	{
		COL_blast( &obj_ptr->p, 20 );
    
	  	if (obj_ptr->fx_id != NULLVAL)
			PSX_rocket_trail[obj_ptr->fx_id].in_use = FALSE;

		if (COL_surftype == 17)
		{
			PSX_init_splash(obj_ptr, torpedo_splash);
			OBJ_delobj(obj_ptr->index);
		}
		else
		{
	//		OPSX_init_new_explosion(obj_ptr, rocket_explosion, MESH_COLLISION);
			PSX_init_flame_ctrl(obj_ptr, rocket_explosion, MESH_COLLISION);

			if (obj_ptr->stat)
				OBJ_delobj(obj_ptr->index);
		}

		return;
      //SOUND_sfx_p( 14, 32+(rand()&7) );
	}

	if (obj_ptr->pkup_data.timer == 200)
	{
		if (obj_ptr->fx_id != NULLVAL)
		{
			PSX_rocket_trail[obj_ptr->fx_id].in_use = FALSE;
			OBJ_delobj(obj_ptr->index);

			return;
		}
	}

	flare_flag = FALSE;
	closest_distance = 8000;

	if (obj_ptr->pkup_data.timer > 3)
//	if (obj_ptr->pkup_data.timer > 0)
	{
		for (i = 0; i < MAX_BURSTS; i++)
		{
			if (!PCK_flares[i].in_use)
				continue;

			flr_ptr = &PCK_flares[i];

			x_dist = flr_ptr->position.vx - (obj_ptr->p.vx >> 8);
			y_dist = flr_ptr->position.vy - (obj_ptr->p.vy >> 8);
			z_dist = flr_ptr->position.vz - (obj_ptr->p.vz >> 8);

	        dist_to_craft = SquareRoot0(((x_dist * x_dist) + (z_dist * z_dist)));
			temp_dist = SquareRoot0((x_dist * x_dist) + (z_dist * z_dist));

//			obj_ptr->pkup_data.quantity = 1;

	        if (dist_to_craft < closest_distance)
	        {
				flare_flag = TRUE;

				closest_distance = dist_to_craft;

    	        height_rot_ang = ratan2(y_dist , temp_dist);
		        rot_ang = ratan2(x_dist , z_dist);
	
				compare_ang = vangdiff2(rot_ang, (obj_ptr->r.vy >> 4));
				height_compare_ang = vangdiff2(height_rot_ang, (obj_ptr->r.vx >> 4));

				if (abs(compare_ang) > 512)
					continue;
				else
		        {
		            if (compare_ang > 96)
			            obj_ptr->r.vy += (96 << 4);

		            if (compare_ang < -96)
			            obj_ptr->r.vy -= (96 << 4);

		            if ((compare_ang < 96) && (compare_ang > -96))
			            obj_ptr->r.vy += compare_ang << 4;

		   	   		obj_ptr->r.vx += (height_compare_ang << 4);
				}
			}
		}

		if (flare_flag != TRUE)
		{
		    for (i = 0; i <  STATE.wankers; i++)
		    {
		        if (obj_ptr->owner == i)
		            continue;

		        pos_craft.vx = OBJ_players[i].pobj->p.vx;
		        pos_craft.vy = OBJ_players[i].pobj->p.vy;
		        pos_craft.vz = OBJ_players[i].pobj->p.vz;

		        x_dist = (pos_craft.vx >> 8) - (obj_ptr->p.vx >> 8);
		        y_dist = (pos_craft.vy >> 8) - (obj_ptr->p.vy >> 8);
		        z_dist = (pos_craft.vz >> 8) - (obj_ptr->p.vz >> 8);

		        dist_to_craft = SquareRoot0(((x_dist * x_dist) + (y_dist * y_dist) + (z_dist * z_dist)));
				temp_dist = SquareRoot0((x_dist * x_dist) + (z_dist * z_dist));

		        if (dist_to_craft < closest_distance)
		        {
					closest_distance = dist_to_craft;

		            rot_ang = ratan2(x_dist , z_dist);
	    	        height_rot_ang = ratan2(y_dist , temp_dist);
	
					compare_ang = vangdiff2(rot_ang, (obj_ptr->r.vy >> 4));
					height_compare_ang = vangdiff2(height_rot_ang, (obj_ptr->r.vx >> 4));

					if (abs(compare_ang) > 512)
						continue;
					else
			        {
			            if (compare_ang > 96)
				            obj_ptr->r.vy += (96 << 4);

			            if (compare_ang < -96)
				            obj_ptr->r.vy -= (96 << 4);

			            if ((compare_ang < 96) && (compare_ang > -96))
				            obj_ptr->r.vy += compare_ang << 4;

	//					vector_distance = SquareRoot0(((x_dist * x_dist) + (z_dist * z_dist)));

	//		            obj_ptr->r.vy += compare_ang << 4;
	//		            rot_ang = ratan2(y_dist , vector_distance);
	//		            rot_ang = ratan2(y_dist , dist_to_craft);

			            obj_ptr->r.vx += height_compare_ang << 4;
					}

//		            break;
		        }
		    }
		}
	}

//	obj_ptr->r.vx += (SDRAND(64) - 32) << 4;
	obj_ptr->r.vy += (SDRAND(64) - 32) << 4;
	obj_ptr->r.vz += (SDRAND(64) - 32) << 4;

    y_vel = (obj_ptr->m0 * rsin(obj_ptr->r.vx >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
    temp_vel = (obj_ptr->m0 * rcos(obj_ptr->r.vx >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts

    x_vel = (temp_vel * rsin(obj_ptr->r.vy >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts
    z_vel = (temp_vel * rcos(obj_ptr->r.vy >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
                                       //euler orientation.
    obj_ptr->v.vx = x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
    obj_ptr->v.vy = y_vel;
    obj_ptr->v.vz = z_vel;

	if (obj_ptr->m0 < (ROCKET_VELOCITY << 8))
	{
		obj_ptr->m0 += obj_ptr->m1;
		obj_ptr->m1 += ((ROCKET_ACCELERATION * 4) << 8);
	}

	if (obj_ptr->fx_id != NULLVAL)
		PSX_process_rocket_trail(obj_ptr);

	rck_timer_on = TRUE;

    return;
}

///////////////////////////////////////////////////////////////////////////
//                               Torpedo Pickup!                         //
//                                 16 Sept. 1998                         //
///////////////////////////////////////////////////////////////////////////

s32 init_torpedo(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index;
    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;
    long            ang, x_vel, z_vel;


    index = OBJ_newobj(OTtorpedo);

    if (index == NULLVAL)
        return FALSE;                             //No more object structures.

    //SOUND_sfx_dynamic( 18, index, 255 );

    obj_ptr = &OBJ_objects[index];
    plyr_obj_ptr = plyr_ptr->pobj;

    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets torpedo position and euler orientation to
    obj_ptr->p.vy = plyr_obj_ptr->p.vy;                           //that of the owner ship
    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

    obj_ptr->r.vx = plyr_obj_ptr->r.vx;                     //Not yet set by Jon
    obj_ptr->r.vy = plyr_obj_ptr->r.vy;    //Range is 0-65536
    obj_ptr->r.vz = plyr_obj_ptr->r.vz;                     //Not yet set by Jon

//    ang = obj_ptr->r.vy;              //obtain euler orientation of ship in PSX format from
                                           //OBJ_STRUCT for torpedo.

//    z_vel = (200 * rcos(ang)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
//    x_vel = (200 * rsin(ang)) >> 12;   //the scaler velocity of the torpedo and the crafts
                                        //euler orientation.

    obj_ptr->v.vx = (plyr_obj_ptr->v.vx);// +x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
    obj_ptr->v.vy = -50 << 8;
    obj_ptr->v.vz = (plyr_obj_ptr->v.vz);// +z_vel;

    obj_ptr->owner = plyr_obj_ptr->owner;       //Sets owner of torpedo
    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that torpedo is in
	obj_ptr->pkup_data.type = torpedo_explosion;
	obj_ptr->pkup_data.power = 500;

	obj_ptr->pkup_data.timer = 0;

	obj_ptr->m0 = SquareRoot0((obj_ptr->v.vx * obj_ptr->v.vx) + (obj_ptr->v.vz * obj_ptr->v.vz));
	obj_ptr->m1 = 0;
	obj_ptr->pkup_data.quantity = 0;

//	PSX_init_torpedo_wake(obj_ptr);

   S2_sfxdynamic( 18, obj_ptr->v.vx>>8, obj_ptr->v.vz>>8, 0, 120, 4600 );

    return TRUE;
}

void PCK_process_torpedo(OBJ_STRUCT *obj_ptr)
//This function process's a torpedo for the current player this frame. It controls the movement
//of the object and handles collision with scenary.

//*obj_ptr is a pointer to the current object to be processed
//*plyr_ptr is a pointer to the curent player structure owning the torpedo.
{
    vec32           first_arg, second_arg, height_vector;
    s32             coll_val;
	s32				x_vel, z_vel, height;


	obj_ptr->pkup_data.timer ++;

	if (obj_ptr->pkup_data.timer > 500)
	{
	 	OBJ_delobj(obj_ptr->index);
		return;
	}

    first_arg.vx = obj_ptr->p.vx >> 8;
    first_arg.vz = obj_ptr->p.vz >> 8;

	if (obj_ptr->pkup_data.quantity == 0)
	    first_arg.vy = obj_ptr->p.vy >> 8;

	height_vector.vx = obj_ptr->p.vx;
	height_vector.vy = obj_ptr->p.vy;
	height_vector.vz = obj_ptr->p.vz;

	if (obj_ptr->pkup_data.quantity == 1)
	{
		obj_ptr->p.vy -= (200 << 8);
		height = find_height(obj_ptr);

		if (height == TRUE)
			obj_ptr->p.vy = (COL_inter.vy + 100) << 8;
	}

    obj_ptr->p.vx += obj_ptr->v.vx;
    obj_ptr->p.vy += obj_ptr->v.vy;
    obj_ptr->p.vz += obj_ptr->v.vz;

	z_vel = (obj_ptr->m0 * rcos(obj_ptr->r.vy >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
	x_vel = (obj_ptr->m0 * rsin(obj_ptr->r.vy >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts
	                                   //euler orientation.
	obj_ptr->v.vx = x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
	obj_ptr->v.vz = z_vel;

	if (obj_ptr->pkup_data.quantity == 0)
		obj_ptr->v.vy += (5 << 8);

	if (obj_ptr->m0 < (TORPEDO_VELOCITY << 8))
	{
		obj_ptr->m0 += obj_ptr->m1;
		obj_ptr->m1 += ((TORPEDO_ACCELERATION * 2) << 8);
	}

    second_arg.vx = obj_ptr->p.vx >> 8;
    second_arg.vz = obj_ptr->p.vz >> 8;

	if (obj_ptr->pkup_data.quantity == 0)
	    second_arg.vy = obj_ptr->p.vy >> 8;
    else
	{
	    first_arg.vy = (obj_ptr->p.vy >> 8) - 101;
	    second_arg.vy = (obj_ptr->p.vy >> 8) - 101;
	}

/*

	if (obj_ptr->p.vy > (100 << 8))
	{
		obj_ptr->p.vy = -obj_ptr->p.vy;

		height = find_height(obj_ptr);

		obj_ptr->p.vy = -obj_ptr->p.vy;

		obj_ptr->p.vy = (COL_inter.vy + 100) << 8;

//		obj_ptr->p.vy = (100 << 8);
		obj_ptr->v.vy = 0;

		PSX_init_splash(obj_ptr, torpedo_splash);
   SOUND_sfx(19);
   }

	if (obj_ptr->p.vy < (100 << 8))
	{
		obj_ptr->v.vy += (10 << 8);

		z_vel = (obj_ptr->m0 * rcos(obj_ptr->r.vy >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
		x_vel = (obj_ptr->m0 * rsin(obj_ptr->r.vy >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts
		                                   //euler orientation.
		obj_ptr->v.vx = x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
		obj_ptr->v.vz = z_vel;

		if (obj_ptr->m0 < ((TORPEDO_VELOCITY << 8) / 4))
		{
			obj_ptr->m0 += obj_ptr->m1;
			obj_ptr->m1 += (TORPEDO_ACCELERATION << 8);
		}
	}
*/
    coll_val = COL_test2(&first_arg, &second_arg); //Determines if the torpedo has hit the

    if (coll_val > -1)
	{
	   COL_blast( &obj_ptr->p, 20 );
#if PSX
		if (COL_surftype == 17)
		{
			if (obj_ptr->pkup_data.quantity != 1)
			{
				PSX_init_splash(obj_ptr, torpedo_splash);
				SOUND_sfx(19);
				obj_ptr->pkup_data.quantity = 1;
				obj_ptr->v.vy = 0;
			}
		}
		else
		{
			if (obj_ptr->pkup_data.quantity == 1)
			{
				if (COL_surftype == 17)
					PSX_init_splash(obj_ptr, torpedo_exp_splash);
				else
					PSX_init_flame_ctrl(obj_ptr, torpedo_explosion, MESH_COLLISION);
//					OPSX_init_new_explosion(obj_ptr, torpedo_explosion, MESH_COLLISION);

				if (obj_ptr->stat)
					OBJ_delobj(obj_ptr->index);

      			SOUND_sfx( 16 );
			}
			else
			{
//				PSX_init_splash(obj_ptr, torpedo_exp_splash);
				PSX_init_flame_ctrl(obj_ptr, torpedo_explosion, MESH_COLLISION);
//				OPSX_init_new_explosion(obj_ptr, torpedo_explosion, MESH_COLLISION);

				if (obj_ptr->stat)
					OBJ_delobj(obj_ptr->index);
			}
		}
#endif
	}
//	else
//		PSX_process_wake(&PSX_torpedo_wake[obj_ptr->fx_id], obj_ptr);

    return;
}

s32 init_plasma(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index, success;
//    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;

/*
    index = OBJ_newobj(OTlightning);

    if (index == NULLVAL)
        return FALSE;                             //No more object structures.

    obj_ptr = &OBJ_objects[index];
    plyr_obj_ptr = plyr_ptr->pobj;

    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets torpedo position and euler orientation to
    obj_ptr->p.vy = plyr_obj_ptr->p.vy;                           //that of the owner ship
    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

    obj_ptr->r.vx = plyr_obj_ptr->r.vx;                     //Not yet set by Jon
    obj_ptr->r.vy = plyr_obj_ptr->r.vy;    //Range is 0-65536
    obj_ptr->r.vz = plyr_obj_ptr->r.vz;                     //Not yet set by Jon

    obj_ptr->owner = plyr_ptr->plyrnum;       //Sets owner of torpedo
    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that torpedo is in

	obj_ptr->pkup_data.power = 25;
*/
    plyr_ptr->pobj->pkup_data.power = 25;

    success = PSX_init_plasma_weapon(plyr_ptr);

    if (!(success))
//    {
//        OBJ_delobj(obj_ptr->index);

        return FALSE;
//    }

    return TRUE;
}

s32 init_flame_thrower(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index, success;
    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;


//    index = OBJ_newobj(OTflame);

//    if (index == NULLVAL)
//        return FALSE;                             //No more object structures.

    obj_ptr = &OBJ_objects[index];
    plyr_obj_ptr = plyr_ptr->pobj;

    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets torpedo position and euler orientation to
    obj_ptr->p.vy = plyr_obj_ptr->p.vy;                           //that of the owner ship
    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

    obj_ptr->r.vx = 0;                     //Not yet set by Jon
    obj_ptr->r.vy = plyr_obj_ptr->r.vy;    //Range is 0-65536
    obj_ptr->r.vz = 0;                     //Not yet set by Jon

    obj_ptr->owner = plyr_ptr->plyrnum;
           //Sets owner of torpedo
    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that torpedo is in
	obj_ptr->pkup_data.power = 50;

    success = PSX_init_flamer(plyr_ptr);

//    if (!(success))
//    {
//        OBJ_delobj(obj_ptr->index);
//
//        return FALSE;
//    }

//	plyr_ptr->flamer_in_use = TRUE;

    return TRUE;
}

s32 init_ion_gun(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index;
    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;
	long			x_vel, y_vel, z_vel, temp_vel;


    plyr_obj_ptr = plyr_ptr->pobj;

//	for (i = 0; i < MAX_ION_FRAGMENTS; i++)
//	{
	    index = OBJ_newobj(OTion);

	    if (index == NULLVAL)
	    	return TRUE;

	    obj_ptr = &OBJ_objects[index];

	    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets torpedo position and euler orientation to
	    obj_ptr->p.vy = plyr_obj_ptr->p.vy;                           //that of the owner ship
	    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

	    obj_ptr->r.vx = (plyr_obj_ptr->r.vx);// - ((rand() % 50));                     //Not yet set by Jon
	    obj_ptr->r.vy = (plyr_obj_ptr->r.vy);// + ((rand() % (200 << 4)) - (100 >> 4));    //Range is 0-65536
	    obj_ptr->r.vz = 0;                     //Not yet set by Jon

	    y_vel = ((800 << 8) * rsin(obj_ptr->r.vx >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
	    temp_vel = ((800 << 8) * rcos(obj_ptr->r.vx >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts

	    z_vel = ((temp_vel) * rcos(obj_ptr->r.vy >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
	    x_vel = ((temp_vel) * rsin(obj_ptr->r.vy >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts
	                                        //euler orientation.

	    obj_ptr->v.vx = x_vel;//x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
	    obj_ptr->v.vy = 0;//y_vel;//((plyr_obj_ptr->v.vy >> 8) / 2);//y_vel;
	    obj_ptr->v.vz = z_vel;//z_vel;

	    obj_ptr->owner = plyr_obj_ptr->owner;       //Sets owner of torpedo
       //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that torpedo is in

		obj_ptr->pkup_data.timer = 0;
		obj_ptr->pkup_data.type = pck_ion;
		obj_ptr->pkup_data.power = 250;

//	}
      S2_sfxdynamic( 23, plyr_obj_ptr->p.vx, plyr_obj_ptr->p.vz, 0, 120, 4600 );

    return TRUE;
}

void PCK_process_ion_gun(OBJ_STRUCT *obj_ptr)
//This function process's a torpedo for the current player this frame. It controls the movement
//of the object and handles collision with scenary.

//*obj_ptr is a pointer to the current object to be processed
//*plyr_ptr is a pointer to the curent player structure owning the torpedo.
{
    vec32           first_arg, second_arg, impact_vector;
    s32             coll_val;
	OBJ_PLAYERSTRUCT	*plyr_ptr;


    obj_ptr->v.vx += 0;
    obj_ptr->v.vy += 0;//1;
    obj_ptr->v.vz += 0;

    first_arg.vx = obj_ptr->p.vx >> 8;
    first_arg.vy = obj_ptr->p.vy >> 8;
    first_arg.vz = obj_ptr->p.vz >> 8;

    obj_ptr->p.vx += obj_ptr->v.vx;
    obj_ptr->p.vy += obj_ptr->v.vy;
    obj_ptr->p.vz += obj_ptr->v.vz;

    second_arg.vx = obj_ptr->p.vx >> 8;
    second_arg.vy = obj_ptr->p.vy >> 8;
    second_arg.vz = obj_ptr->p.vz >> 8;

    // mongotron squirts here
    {
    vec32   v0, v1, cr, dif;
    s32     d, lensq;
    s16     i;
    s32     cp, dp;

    for(i=0;i< STATE.wankers;i++)
      {
      if( i==obj_ptr->owner )continue;
      if( (OBJ_objects[i].stat==ON) && (OBJ_objects[i].type==OTcraft) )
         {
         mov( dif, second_arg );
         sub( dif, first_arg );

         mov( cr, OBJ_objects[i].p );
         shr( cr, 8 );

         mov( v0, cr );
         sub( v0, first_arg );

         lensq    =  SquareRoot0(dif.vx*dif.vx + dif.vz*dif.vz);
         cp       =  (dif.vx*v0.vz - dif.vz*v0.vx)/lensq;
         dp       =  dif.vx*v0.vx + dif.vz*v0.vz;
         if( (cp<200) && (cp>-200) && (dp>=0) )
            {
            FntPrint("smeeeee bullet %d\n", cp);

            plyr_ptr = &OBJ_players[i];

			OBJ_damage_player(plyr_ptr, obj_ptr, FALSE);

			if (obj_ptr->stat)
				OBJ_delobj(obj_ptr->index);

//		   OPSX_init_new_explosion(obj_ptr, obj_ptr->pkup_data.type , SHIP_COLLISION);
			return;
            }
         }
      }
   }

    coll_val = COL_test2(&first_arg, &second_arg); //Determines if the torpedo has hit the

    if (coll_val > -1)
	{
//		PSX_init_new_explosion(obj_ptr, obj_ptr->pkup_data.type , MESH_COLLISION);
		PSX_init_flame_ctrl(obj_ptr, obj_ptr->pkup_data.type, MESH_COLLISION);
		if (obj_ptr->stat)
			OBJ_delobj(obj_ptr->index);

//		OBJ_delobj(obj_ptr->index);
		return;
	}

	obj_ptr->pkup_data.timer ++;

	if (obj_ptr->pkup_data.timer > 50)
	{
//		PSX_init_new_explosion(obj_ptr, obj_ptr->pkup_data.type , OTHER_COLLISION);
		PSX_init_flame_ctrl(obj_ptr, obj_ptr->pkup_data.type, OTHER_COLLISION);

		if (obj_ptr->stat)
			OBJ_delobj(obj_ptr->index);
//		OBJ_delobj(obj_ptr->index);
	}

    return;
}

s32 init_cluster(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index;
    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;
    s32             ang, x_vel, y_vel, z_vel;


    index = OBJ_newobj(OTcluster);

    if (index == NULLVAL)
        return FALSE;                             //No more object structures.

    obj_ptr = &OBJ_objects[index];
    plyr_obj_ptr = plyr_ptr->pobj;

    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets torpedo position and euler orientation to
    obj_ptr->p.vy = plyr_obj_ptr->p.vy;         //that of the owner ship
    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

    obj_ptr->r.vx = 0;                     //Not yet set by Jon
    obj_ptr->r.vy = 0;    //Range is 0-65536
    obj_ptr->r.vz = 0;                     //Not yet set by Jon

    obj_ptr->v.vx = plyr_obj_ptr->v.vx;                 //Set velocity of torpedo in all 3 planes respectively.
    obj_ptr->v.vy = -100 << 8;
    obj_ptr->v.vz = plyr_obj_ptr->v.vz;

    obj_ptr->owner = plyr_obj_ptr->owner;       //Sets owner of torpedo
    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that torpedo is in

	obj_ptr->pkup_data.type = cluster_explosion;
	obj_ptr->pkup_data.power = 250;
	obj_ptr->pkup_data.timer = 0;
	obj_ptr->pkup_data.quantity = 16;

	obj_ptr->m1 = 0;

   S2_sfxdynamic( 15, obj_ptr->p.vx>>8, obj_ptr->p.vx>>8, 0, 120, 4600 );

    return TRUE;
}

void PCK_process_cluster(OBJ_STRUCT *obj_ptr)
//This function process's a torpedo for the current player this frame. It controls the movement
//of the object and handles collision with scenary.

//*obj_ptr is a pointer to the current object to be processed
//*plyr_ptr is a pointer to the curent player structure owning the torpedo.
{
    vec32  	           first_arg, second_arg;
    s32     		   coll_val, success;
    s32                i, angle, angle_inc;


	if (obj_ptr->v.vy >= 0)
	{
//		OPSX_init_new_explosion(obj_ptr, cluster_explosion, OTHER_COLLISION);
		PSX_init_flame_ctrl(obj_ptr, torpedo_explosion, OTHER_COLLISION);

		obj_ptr->v.vx = 0;
		obj_ptr->v.vy = 0;
		obj_ptr->v.vz = 0;

		if (obj_ptr->pkup_data.quantity == 16)
		{
   //			OPSX_init_new_explosion(obj_ptr, cluster_explosion, OTHER_COLLISION);
			obj_ptr->pkup_data.quantity --;
   //			obj_ptr->stat = TRUE;
		}
		else
		{
			obj_ptr->pkup_data.timer ++;

			if (!(obj_ptr->pkup_data.timer % 2))
			{
			    success = init_fragment(obj_ptr, obj_ptr->m1);
				obj_ptr->pkup_data.quantity --;

		    	angle_inc = 256;
			    obj_ptr->m1 += angle_inc;

				if (obj_ptr->pkup_data.quantity == 0)
					OBJ_delobj(obj_ptr->index);
			}
		}
	}
	else
	{
		obj_ptr->p.vx += obj_ptr->v.vx;
		obj_ptr->p.vy += obj_ptr->v.vy;
		obj_ptr->p.vz += obj_ptr->v.vz;

		obj_ptr->v.vy += 10 << 8;
	}

    return;
}

s32 init_fragment(OBJ_STRUCT *obj_ptr, s32  angle)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index;
    OBJ_STRUCT      *ptr;
    s32             x_vel, z_vel;

    index = OBJ_newobj(OTfragment);

    if (index == NULLVAL)
        return FALSE;                             //No more object structures.

    ptr = &OBJ_objects[index];

    ptr->p.vx = obj_ptr->p.vx;         //Sets torpedo position and euler orientation to
    ptr->p.vy = obj_ptr->p.vy;         //that of the owner ship
    ptr->p.vz = obj_ptr->p.vz;

    ptr->r.vx = 0;                     //Not yet set by Jon
    ptr->r.vy = angle << 4;    //Range is 0-65536
    ptr->r.vz = 0;                     //Not yet set by Jon

    z_vel = ((75 << 8) * rcos(angle)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
    x_vel = ((75 << 8) * rsin(angle)) >> 12;   //the scaler velocity of the torpedo and the crafts
                                        //euler orientation.
    ptr->v.vx = x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
    ptr->v.vy = 0;
    ptr->v.vz = z_vel;

    ptr->owner = obj_ptr->owner;       //Sets owner of torpedo
    ptr->m0 = 0;       //Sets owner of torpedo
    //jofptr->sect = obj_ptr->sect;         //Sets current section of course that torpedo is in

	ptr->pkup_data.type = fragment_explosion;
	ptr->pkup_data.power = 150;

    return TRUE;
}

void PCK_process_fragment(OBJ_STRUCT *obj_ptr)
//This function process's a torpedo for the current player this frame. It controls the movement
//of the object and handles collision with scenary.

//*obj_ptr is a pointer to the current object to be processed
//*plyr_ptr is a pointer to the curent player structure owning the torpedo.
{
    vec32   	       first_arg, second_arg;
    s32   	    	   coll_val, success;


    obj_ptr->v.vy += 5 << 8;
    obj_ptr->m0 ++;

    first_arg.vx = obj_ptr->p.vx >> 8;
    first_arg.vy = obj_ptr->p.vy >> 8;
    first_arg.vz = obj_ptr->p.vz >> 8;

    obj_ptr->p.vx += obj_ptr->v.vx;
    obj_ptr->p.vy += obj_ptr->v.vy;
    obj_ptr->p.vz += obj_ptr->v.vz;

    second_arg.vx = obj_ptr->p.vx >> 8;
    second_arg.vy = obj_ptr->p.vy >> 8;
    second_arg.vz = obj_ptr->p.vz >> 8;

    coll_val = COL_test2(&first_arg, &second_arg); //Determines if the torpedo has hit the

    if (coll_val > -1)
    {
      COL_blast( &obj_ptr->p, 5 );

//		if (COL_surftype == 17)
//		{
//	    	SOUND_sfx( 19 );

//			PSX_init_splash(obj_ptr, mine_splash);
//		}
//		else
//		{
    		SOUND_sfx( 14 );

//		    OPSX_init_new_explosion(obj_ptr, fragment_explosion, MESH_COLLISION);
		    PSX_init_flame_ctrl(obj_ptr, rocket_explosion, MESH_COLLISION);
//		}

	  	if (obj_ptr->stat)
	  		OBJ_delobj(obj_ptr->index);
    }

	if (obj_ptr->m0 == 75)
  		OBJ_delobj(obj_ptr->index);

    return;
}

s32 init_gas(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index;
    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;
    s32             ang, x_vel, y_vel, z_vel;


    index = OBJ_newobj(OTgas);

    if (index == NULLVAL)
        return FALSE;                             //No more object structures.

    SOUND_sfx_dynamic( 21, index, 255 );

    obj_ptr = &OBJ_objects[index];
    plyr_obj_ptr = plyr_ptr->pobj;

    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets torpedo position and euler orientation to
    obj_ptr->p.vy = plyr_obj_ptr->p.vy;         //that of the owner ship
    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

    obj_ptr->r.vx = 0;                     //Not yet set by Jon
    obj_ptr->r.vy = plyr_obj_ptr->r.vy;    //Range is 0-65536
    obj_ptr->r.vz = 0;                     //Not yet set by Jon

    ang = obj_ptr->r.vy >> 4;              //obtain euler orientation of ship in PSX format from
                                           //OBJ_STRUCT for torpedo.

    z_vel = (BVEL * rcos(ang)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
    x_vel = (BVEL * rsin(ang)) >> 12;   //the scaler velocity of the torpedo and the crafts
                                        //euler orientation.
    y_vel = -5000;

    obj_ptr->v.vx = x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
    obj_ptr->v.vy = y_vel;
    obj_ptr->v.vz = z_vel;

    obj_ptr->owner = plyr_ptr->plyrnum;       //Sets owner of torpedo
    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that torpedo is in
	obj_ptr->pkup_data.power = 25;
	obj_ptr->pkup_data.type = pck_gas;

    return TRUE;
}

void PCK_process_gas(OBJ_STRUCT *obj_ptr)
//This function process's a torpedo for the current player this frame. It controls the movement
//of the object and handles collision with scenary.

//*obj_ptr is a pointer to the current object to be processed
//*plyr_ptr is a pointer to the curent player structure owning the torpedo.
{
    vec32           first_arg, second_arg;
    s32             coll_val;


    obj_ptr->v.vy += 450;

    first_arg.vx = (obj_ptr->p.vx >> 8);
    first_arg.vy = (obj_ptr->p.vy >> 8);
    first_arg.vz = (obj_ptr->p.vz >> 8);

//    obj_ptr->p.vx += obj_ptr->v.vx;
    obj_ptr->p.vy += obj_ptr->v.vy;
//    obj_ptr->p.vz += obj_ptr->v.vz;

    second_arg.vx = (obj_ptr->p.vx >> 8);
    second_arg.vy = (obj_ptr->p.vy >> 8);
    second_arg.vz = (obj_ptr->p.vz >> 8);

    coll_val = COL_test2(&first_arg, &second_arg); //Determines if the torpedo has hit the

    if (coll_val > -1)
//        PSX_init_gas_cloud(obj_ptr);              //If so, calls 'static explosion'.
        PSX_init_flame_ctrl(obj_ptr, obj_ptr->pkup_data.type, MESH_COLLISION);              //If so, calls 'static explosion'.

    return;
}

s32 init_burst(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index;
    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;
    long            ang, x_vel, z_vel;


    index = OBJ_newobj(OTburst);

    if (index == NULLVAL)
        return FALSE;                             //No more object structures.

    SOUND_sfx_dynamic( 15, index, 255 );

    obj_ptr = &OBJ_objects[index];
    plyr_obj_ptr = plyr_ptr->pobj;

    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets torpedo position and euler orientation to
    obj_ptr->p.vy = plyr_obj_ptr->p.vy;         //that of the owner ship
    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

    obj_ptr->r.vx = plyr_obj_ptr->r.vx;                     //Not yet set by Jon
    obj_ptr->r.vy = plyr_obj_ptr->r.vy;    //Range is 0-65536
    obj_ptr->r.vz = plyr_obj_ptr->r.vz;                     //Not yet set by Jon

    ang = obj_ptr->r.vy;              //obtain euler orientation of ship in PSX format from
                                           //OBJ_STRUCT for torpedo.

    z_vel = ((FLARE_VELOCITY << 8) * rcos(ang >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
    x_vel = ((FLARE_VELOCITY << 8) * rsin(ang >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts

    obj_ptr->v.vx = x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
    obj_ptr->v.vy = -30 << 8;
    obj_ptr->v.vz = z_vel;

    obj_ptr->owner = plyr_obj_ptr->owner;       //Sets owner of torpedo
    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that torpedo is in
	obj_ptr->pkup_data.type = flare_smoke;
	obj_ptr->pkup_data.timer = 0;

	obj_ptr->m0 = SquareRoot0((x_vel * x_vel) + (z_vel * z_vel));

//    PSX_init_burst_effect(obj_ptr);
//	PSX_init_new_explosion(obj_ptr, flare_trail, OTHER_COLLISION);
//	PSX_init_flame_ctrl(obj_ptr, obj_ptr->pkup_data.type, OTHER_COLLISION);
	init_flare_pos(obj_ptr);

    return TRUE;
}

void PCK_process_burst(OBJ_STRUCT *obj_ptr)
//This function process's a torpedo for the current player this frame. It controls the movement
//of the object and handles collision with scenary.

//*obj_ptr is a pointer to the current object to be processed
//*plyr_ptr is a pointer to the curent player structure owning the torpedo.
{
    vec32           first_arg, second_arg;
    s32             coll_val;


	obj_ptr->pkup_data.timer ++;

    first_arg.vx = obj_ptr->p.vx >> 8;
    first_arg.vy = obj_ptr->p.vy >> 8;
    first_arg.vz = obj_ptr->p.vz >> 8;

    obj_ptr->p.vx += obj_ptr->v.vx;
    obj_ptr->p.vy += obj_ptr->v.vy;
    obj_ptr->p.vz += obj_ptr->v.vz;

	obj_ptr->m0 -= (obj_ptr->m0 / 10);

    obj_ptr->v.vx = (obj_ptr->m0 * rsin(obj_ptr->r.vy >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
    obj_ptr->v.vz = (obj_ptr->m0 * rcos(obj_ptr->r.vy >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts
//    obj_ptr->v.vx -= (obj_ptr->v.vx / 20);
//    obj_ptr->v.vz -= (obj_ptr->v.vz / 20);

    obj_ptr->v.vy += 128;

    second_arg.vx = obj_ptr->p.vx >> 8;
    second_arg.vy = obj_ptr->p.vy >> 8;
    second_arg.vz = obj_ptr->p.vz >> 8;

    coll_val = COL_test2(&first_arg, &second_arg); //Determines if the torpedo has hit the

    if ((coll_val > -1) || (obj_ptr->pkup_data.timer > 750))
    {
		if (obj_ptr->fx_id > NULLVAL)
//			PSX_expns[obj_ptr->fx_id].release_total = PSX_expns[obj_ptr->fx_id].total_flames;
//        	PCK_bursts[obj_ptr->fx_id].in_use = FALSE;

		PCK_flares[obj_ptr->m1].in_use = FALSE;
    	OBJ_delobj(obj_ptr->index);
	}
    else
#if PSX
    {
        PSX_process_burst_effect(obj_ptr);
		
		PSX_init_flame_animation(obj_ptr, flare_trail, OTHER_COLLISION);

		if (obj_ptr->m1 != NULLVAL)
			update_flare_pos(obj_ptr);
	}
#endif
    return;
}

void init_flare_pos(OBJ_STRUCT *obj_ptr)
{
	int					i;


	for (i = 0; i < MAX_BURSTS; i++)
	{
		if (PCK_flares[i].in_use)
			continue;

		PCK_flares[i].in_use = TRUE;

		obj_ptr->m1 = i;

		return;
	}

	obj_ptr->m1 = NULLVAL;

	return;
}

void update_flare_pos(OBJ_STRUCT *obj_ptr)
{
	PCK_flares[obj_ptr->m1].position.vx = obj_ptr->p.vx >> 8;
	PCK_flares[obj_ptr->m1].position.vy = obj_ptr->p.vy >> 8;
	PCK_flares[obj_ptr->m1].position.vz = obj_ptr->p.vz >> 8;

	return;
}

///////////////////////////////////////////////////////////////////////////
//                               Missile Pickup!                         //
//                                 18 Sept. 1998                         //
///////////////////////////////////////////////////////////////////////////

s32 init_missile(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a torpedo. It sets the torpedo to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the torpedo.

//plyr_num is the player number currenly initialising (colleting) a torpedo
{
    s32             index;
    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;
    long            i, ang, x_vel, y_vel, z_vel;


    index = OBJ_newobj(OTmissile);

    if (index == NULLVAL)
        return FALSE;                             //No more object structures.

    SOUND_sfx_dynamic(5, index, 255);

    obj_ptr = &OBJ_objects[index];
    plyr_obj_ptr = plyr_ptr->pobj;

    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets torpedo position and euler orientation to
    obj_ptr->p.vy = plyr_obj_ptr->p.vy;         //that of the owner ship
    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

    obj_ptr->r.vx = plyr_obj_ptr->r.vx;                     //Not yet set by Jon
    obj_ptr->r.vy = plyr_obj_ptr->r.vy;    //Range is 0-65536
    obj_ptr->r.vz = plyr_obj_ptr->r.vz;                     //Not yet set by Jon

//    ang = obj_ptr->r.vy;              //obtain euler orientation of ship in PSX format from
                                          //OBJ_STRUCT for torpedo.
//    z_vel = (150 * rcos(ang)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
//    x_vel = (150 * rsin(ang)) >> 12;   //the scaler velocity of the torpedo and the crafts

    obj_ptr->v.vx = (plyr_obj_ptr->v.vx);// + x_vel;                 //Set velocity of torpedo in all 3 planes respectively.
    obj_ptr->v.vy = (plyr_obj_ptr->v.vy);
    obj_ptr->v.vz = (plyr_obj_ptr->v.vz);// + z_vel;

    obj_ptr->owner = plyr_ptr->plyrnum;       //Sets owner of torpedo
    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that torpedo is in

	obj_ptr->pkup_data.type = missile_trail;
	obj_ptr->pkup_data.power = 500;
	obj_ptr->pkup_data.timer = 0;
	obj_ptr->pkup_data.quantity = 0;

	x_vel = (obj_ptr->v.vx >> 8) * (obj_ptr->v.vx >> 8);
	y_vel = (obj_ptr->v.vy >> 8) * (obj_ptr->v.vy >> 8);
	z_vel = (obj_ptr->v.vz >> 8) * (obj_ptr->v.vz >> 8);

	obj_ptr->m0 = SquareRoot0((x_vel + y_vel + z_vel)) << 8;
	obj_ptr->m1 = 0;

	index = 0;

//	for (i = 0; i < 100; i ++)
//	{
//		trail[i].vx = 0;
//		trail[i].vy = 0;
//		trail[i].vz = 0;
//	}

//	OPSX_init_new_explosion(obj_ptr, missile_trail, OTHER_COLLISION);
	PSX_init_flame_ctrl(obj_ptr, missile_trail, OTHER_COLLISION);

	old_height = find_height(obj_ptr);

	return TRUE;
}

void PCK_process_missile(OBJ_STRUCT *obj_ptr)
{
	#define			MAX_HEIGHT					500
	#define			MISSILE_VIEWING_DISTANCE	6000

	char				result;
	int					height, coll_val, x_val, z_val, sight_length;
	short				angle, rotation, i;
	PAIR_2D				missile_position, left, right, front, target;
	SVECTOR				point, mis_pos;
    vec32           first_arg, second_arg, pos_craft;
    s32             dist_to_craft, x_vel, z_vel;
    s32             x_dist, y_dist, z_dist, y_val, temp_vel, closest_distance;
    s16             rot_ang, compare_ang, height_rot_ang, height_compare_ang;
	FLARE_POSITION	*flr_ptr;
	int				flare_flag, temp_dist;


	miss_timer_on = TRUE;

	for(i = 0; i < delobji; i++)
 	{
		if (delobjl[i] == obj_ptr->index)
		{
			printf("fuck no!!\n");
		}
	}

	mis_pos.vx = missile_position.vx = obj_ptr->p.vx >> 8;
	mis_pos.vz = missile_position.vz = obj_ptr->p.vz >> 8;
	mis_pos.vy = 0;

	obj_ptr->pkup_data.quantity = 0;

	result = PCK_missile_collision(0, missile_position, obj_ptr);

	if (result == 1)
	{
		front.vx = AI_inter.vx;
		front.vz = AI_inter.vz;

		x_val = (AI_inter.vx - missile_position.vx) * (AI_inter.vx - missile_position.vx);
		z_val = (AI_inter.vz - missile_position.vz) * (AI_inter.vz - missile_position.vz);

		sight_length = SquareRoot0(x_val + z_val);

		angle = (MISSILE_VIEWING_DISTANCE - sight_length) / 13;

		if (angle < 64)
			angle = 64;
	}
	else
	{
		front.vx = missile_collision_vector.vx;
		front.vz = missile_collision_vector.vz;

		sight_length = MISSILE_VIEWING_DISTANCE;
		angle = 64;
	}

	result = PCK_missile_collision(-angle, missile_position, obj_ptr);

	if (result == 1)
	{
		left.vx = AI_inter.vx;
		left.vz = AI_inter.vz;
	}
	else
	{
		left.vx = missile_collision_vector.vx;
		left.vz = missile_collision_vector.vz;
	}

	point.vx = left.vx;
	point.vz = left.vz;
	point.vy = 0;

//	display_vector(mis_pos, point, 255, 0, 0);

//	printf("left: x = %d z = %d\n", left.vx, left.vz);
	result = PCK_missile_collision(angle, missile_position, obj_ptr);

	if (result == 1)
	{
		right.vx = AI_inter.vx;
		right.vz = AI_inter.vz;
	}
	else
	{
		right.vx = missile_collision_vector.vx;
		right.vz = missile_collision_vector.vz;
	}

	point.vx = right.vx;
	point.vz = right.vz;
	point.vy = 0;

//	display_vector(mis_pos, point, 0, 0, 255);
//	printf("right: x = %d z = %d\n\n", right.vx, right.vz);

	target.vx = (right.vx - left.vx) / 2;
	target.vz = (right.vz - left.vz) / 2;

	target.vx += left.vx;
	target.vz += left.vz;

	x_val = target.vx - missile_position.vx;
	z_val = target.vz - missile_position.vz;

	point.vx = target.vx;
	point.vz = target.vz;
	point.vy = 0;

//	display_vector(mis_pos, point, 0, 255, 0);

	rotation = ratan2(x_val, z_val);

	closest_distance = sight_length;
	flare_flag = FALSE;

	for (i = 0; i < MAX_BURSTS; i++)
	{
		if (!PCK_flares[i].in_use)
			continue;

		flr_ptr = &PCK_flares[i];

		x_dist = flr_ptr->position.vx - (obj_ptr->p.vx >> 8);
		y_dist = flr_ptr->position.vy - (obj_ptr->p.vy >> 8);
		z_dist = flr_ptr->position.vz - (obj_ptr->p.vz >> 8);

        dist_to_craft = SquareRoot0(((x_dist * x_dist) + (y_dist * y_dist) + (z_dist * z_dist)));

        if (dist_to_craft < closest_distance)
        {
			flare_flag = TRUE;

			closest_distance = dist_to_craft;
			temp_dist = SquareRoot0((x_dist * x_dist) + (z_dist * z_dist));

            height_rot_ang = ratan2(y_dist , temp_dist);
            rot_ang = ratan2(x_dist , z_dist);

			compare_ang = vangdiff2(rot_ang, (obj_ptr->r.vy >> 4));
			height_compare_ang = vangdiff2(height_rot_ang, (obj_ptr->r.vx >> 4));

			obj_ptr->pkup_data.quantity = 1;

			if (abs(compare_ang) > 768)
				continue;
			else
	        {
	            if (compare_ang > 96)
		            obj_ptr->r.vy += (96 << 4);

	            if (compare_ang < -96)
		            obj_ptr->r.vy -= (96 << 4);

	            if ((compare_ang < 96) && (compare_ang > -96))
		            obj_ptr->r.vy += compare_ang << 4;

	   	   		obj_ptr->r.vx += (height_compare_ang << 4);
			}
		}
	}

	if (flare_flag != TRUE)
	{
	    for (i = 0; i <  STATE.wankers; i++)
	    {
	        if (obj_ptr->owner == i)
	            continue;

	        pos_craft.vx = OBJ_players[i].pobj->p.vx >> 8;
	        pos_craft.vy = OBJ_players[i].pobj->p.vy >> 8;
	        pos_craft.vz = OBJ_players[i].pobj->p.vz >> 8;

	        x_dist = pos_craft.vx - (obj_ptr->p.vx >> 8);
	        y_dist = pos_craft.vy - (obj_ptr->p.vy >> 8);
	        z_dist = pos_craft.vz - (obj_ptr->p.vz >> 8);

			temp_dist = SquareRoot0((x_dist * x_dist) + (z_dist * z_dist));

	        dist_to_craft = SquareRoot0((x_dist * x_dist) + (y_dist * y_dist) + (z_dist * z_dist));

	        if (dist_to_craft < closest_distance)
	        {
				closest_distance = dist_to_craft;

	            rot_ang = ratan2(x_dist , z_dist);

	            height_rot_ang = ratan2(y_dist , temp_dist);
	//	            compare_ang = rot_ang - obj_ptr->r.vy;
				compare_ang = vangdiff2(rot_ang, (obj_ptr->r.vy >> 4));
				
				height_compare_ang = vangdiff2(height_rot_ang, (obj_ptr->r.vx >> 4));

				if (abs(compare_ang) < 512)
		   	   	{
					if ((compare_ang > 64) && (compare_ang < 512))
						compare_ang = 64;

					if ((compare_ang < -64) && (compare_ang > -512))
						compare_ang = -64;

					obj_ptr->pkup_data.quantity = 1;

		   	   		obj_ptr->r.vx += (height_compare_ang << 4);

		   	   		obj_ptr->r.vy += (compare_ang << 4);
				}
	/*
	            if ((rot_ang > (obj_ptr->r.vy + (1024 << 4))) || (rot_ang < (obj_ptr->r.vy - (1024 << 4))))
	                continue;

	            if (compare_ang > (32 << 4))
	                rot_ang = obj_ptr->r.vy + (32 << 4);

	            if (compare_ang < (-32 << 4))
	                rot_ang = obj_ptr->r.vy + (-32 << 4);

	            obj_ptr->r.vy = rot_ang;

	*/
	        }
	    }
	}

	if (obj_ptr->pkup_data.quantity == 0)
		obj_ptr->r.vy = rotation << 4;

	y_val = (obj_ptr->m0 * rsin(obj_ptr->r.vx >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
	temp_vel = (obj_ptr->m0 * rcos(obj_ptr->r.vx >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts

	x_val = (temp_vel * rsin(obj_ptr->r.vy >> 4)) >> 12;   //the scaler velocity of the torpedo and the crafts
	z_val = (temp_vel * rcos(obj_ptr->r.vy >> 4)) >> 12;   //Obtain velocities in both x and z planes, using TVEL,
	                                   //euler orientation.
	obj_ptr->v.vx = x_val;                 //Set velocity of torpedo in all 3 planes respectively.
	obj_ptr->v.vy = y_val;
	obj_ptr->v.vz = z_val;

	height = find_height(obj_ptr);

	if (obj_ptr->m0 < (MISSILE_VELOCITY << 8))
	{
		obj_ptr->m0 += obj_ptr->m1;
		obj_ptr->m1 += (MISSILE_ACCELERATION << 8);

		if (obj_ptr->pkup_data.quantity == 0)
		{
			if (height == TRUE)
			{
				if ((obj_ptr->p.vy > (COL_inter.vy - 100) << 8))
				{
					obj_ptr->p.vy -= (7 << 8);
					obj_ptr->v.vy = 0;
				}
			}
		}
	}
	else
	{
		if (obj_ptr->pkup_data.quantity == 0)
		{
			if (height == TRUE)
			{
				obj_ptr->p.vy = (COL_inter.vy - 100) << 8;
				obj_ptr->v.vy = 0;
			}
		}
	}

// 	if (height != old_height)
//		obj_ptr->v.vy = (-(old_height - height)) << 8;
//	else
//		obj_ptr->v.vy = 0;

//	print("height = %d : old_height = %d\n", height, old_height);
//	old_height = height;

    first_arg.vx = obj_ptr->p.vx >> 8;
    first_arg.vy = obj_ptr->p.vy >> 8;
    first_arg.vz = obj_ptr->p.vz >> 8;

    obj_ptr->p.vx += obj_ptr->v.vx;
    obj_ptr->p.vy += obj_ptr->v.vy;
    obj_ptr->p.vz += obj_ptr->v.vz;

    second_arg.vx = obj_ptr->p.vx >> 8;
    second_arg.vy = obj_ptr->p.vy >> 8;
    second_arg.vz = obj_ptr->p.vz >> 8;

    coll_val = COL_test2(&first_arg, &second_arg); //Determines if the torpedo has hit the

	obj_ptr->pkup_data.timer++;

    if ((coll_val > -1) || (obj_ptr->pkup_data.timer > 500))
	{
		if (obj_ptr->fx_id != NULLVAL)
//			PSX_expns[obj_ptr->fx_id].release_total = PSX_expns[obj_ptr->fx_id].total_flames;
			PSX_flame_ctrls[obj_ptr->fx_id].used = PSX_flame_ctrls[obj_ptr->fx_id].total;

		PSX_init_flame_ctrl(obj_ptr, torpedo_explosion, OTHER_COLLISION);
		
		OBJ_delobj(obj_ptr->index);
	}
/*
	for (i = 99; i > 0; i--)
	{
		trail[i].vx = trail[i - 1].vx;
		trail[i].vy = trail[i - 1].vy;
		trail[i].vz = trail[i - 1].vz;
	}

	trail[0].vx = obj_ptr->p.vx >> 8;
	trail[0].vy = 0;//obj_ptr->p.vy;
	trail[0].vz = obj_ptr->p.vz >> 8;

	if (index < 100)
		index++;

	for (i = 1; i < 100; i++)
	{
		if (i >= index)
			break;

		display_vector(trail[i - 1], trail[i], 255, 255, 255);
	}
*/
	OBJ_objects[MAXNUMOBJS - 1].p.vx = obj_ptr->p.vx;
	OBJ_objects[MAXNUMOBJS - 1].p.vy = obj_ptr->p.vy;
	OBJ_objects[MAXNUMOBJS - 1].p.vz = obj_ptr->p.vz;

	OBJ_objects[MAXNUMOBJS - 1].v.vx = obj_ptr->v.vx;
	OBJ_objects[MAXNUMOBJS - 1].v.vy = obj_ptr->v.vy;
	OBJ_objects[MAXNUMOBJS - 1].v.vz = obj_ptr->v.vz;

	OBJ_objects[MAXNUMOBJS - 1].r.vx = obj_ptr->r.vx;// << 4;
	OBJ_objects[MAXNUMOBJS - 1].r.vy = obj_ptr->r.vy;// << 4;
	OBJ_objects[MAXNUMOBJS - 1].r.vz = obj_ptr->r.vz;// << 4;

	miss_timer_off = TRUE;
	return;
}



s32 init_mine(OBJ_PLAYERSTRUCT *plyr_ptr)
//This function initialises a missile. It sets the missile to the position and orientation
//of the owner ship and then fires it off. It creates a new object to store data for the missile.

//plyr_num is the player number currenly initialising (firing) a missile
{
    s32             index;
    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;


    index = OBJ_newobj(OTmine);

    if (index == NULLVAL)
        return FALSE;

    obj_ptr = &OBJ_objects[index];
    plyr_obj_ptr = plyr_ptr->pobj;

    obj_ptr->p.vx = plyr_obj_ptr->p.vx;         //Sets missile position and euler orientation to
    obj_ptr->p.vy = plyr_obj_ptr->p.vy + (50 << 8);         //that of the owner ship
    obj_ptr->p.vz = plyr_obj_ptr->p.vz;

    obj_ptr->r.vx = plyr_obj_ptr->r.vx;
    obj_ptr->r.vy = plyr_obj_ptr->r.vy;
    obj_ptr->r.vz = plyr_obj_ptr->r.vz;

    obj_ptr->v.vx = 0;  // + speed increment to allow missile to fly off.
    obj_ptr->v.vy = 0;//(-20 << 8);  // + speed increment to allow missile to fly off.
    obj_ptr->v.vz = 0; // + speed increment to allow missile to fly off.

    obj_ptr->owner = plyr_obj_ptr->owner;       //Sets owner of missile
    //jofobj_ptr->sect = plyr_obj_ptr->sect;         //Sets current section of course that missile is in

	obj_ptr->pkup_data.type = mine_explosion;
	obj_ptr->pkup_data.power = 500;
	obj_ptr->pkup_data.timer = 0;

	obj_ptr->m0 = TRUE;

    return TRUE;
}

void PCK_process_mine(OBJ_STRUCT *obj_ptr)
//This function process's a torpedo for the current player this frame. It controls the movement
//of the object and handles collision with scenary.

//*obj_ptr is a pointer to the current object to be processed
//*plyr_ptr is a pointer to the curent player structure owning the torpedo.
{
    vec32           first_arg, second_arg;
    s32             coll_val;
	s32				x_vel, z_vel;


	if (!obj_ptr->m0)
		return;

    first_arg.vx = obj_ptr->p.vx >> 8;
    first_arg.vy = obj_ptr->p.vy >> 8;
    first_arg.vz = obj_ptr->p.vz >> 8;

    obj_ptr->p.vx += obj_ptr->v.vx;
    obj_ptr->p.vy += obj_ptr->v.vy;
    obj_ptr->p.vz += obj_ptr->v.vz;

    second_arg.vx = obj_ptr->p.vx >> 8;
    second_arg.vy = obj_ptr->p.vy >> 8;
    second_arg.vz = obj_ptr->p.vz >> 8;

    coll_val = COL_test2(&first_arg, &second_arg); //Determines if the torpedo has hit the

	if (coll_val > -1)
	{
		obj_ptr->p.vx = COL_inter.vx << 8;
		obj_ptr->p.vy = COL_inter.vy << 8;
		obj_ptr->p.vz = COL_inter.vz << 8;

		if (COL_surftype == 17)
		{
			PSX_init_splash(obj_ptr, mine_splash);
			obj_ptr->m1 = TRUE;
		}
		else
			obj_ptr->m1 = FALSE;

		obj_ptr->v.vy = 0;

		obj_ptr->m0 = FALSE;
	}

	if (obj_ptr->m0)
	{
		obj_ptr->pkup_data.timer ++;

	    if (obj_ptr->pkup_data.timer == 100)
			OBJ_delobj(obj_ptr->index);

		obj_ptr->v.vy += (5 << 8);
	}

    return;
}
/*
s32 init_high_octane(OBJ_PLAYERSTRUCT *plyr_ptr)
{
    OCTANE_FX           *ptr;
    OBJ_STRUCT          *obj_ptr;
    s32                 index;


    index = OBJ_newobj(OThigh_octane);

    if (index == NULLVAL)
        return FALSE;

    SOUND_sfx_dynamic( 22, plyr_ptr->plyrnum, 255 );

    obj_ptr = &OBJ_objects[index];

    ptr = init_octane_object();

    if (ptr == NULL)
        return FALSE;

    obj_ptr->fx_id = ptr->index;
    obj_ptr->owner = plyr_ptr->plyrnum;

    ptr->timer = 0;

//    ptr->perspective = 152;
    ptr->perspective = 325;

    plyr_ptr->throttle = 1500;

    return TRUE;
}

void PCK_process_octane(OBJ_STRUCT *obj_ptr)
{
    OCTANE_FX           *fx_ptr;


    fx_ptr = &PCK_octane[obj_ptr->fx_id];

//    if (fx_ptr->timer < 10)
//    {
//        OBJ_players[obj_ptr->owner].pobj->v.vy = (-750 << 8);
//    }

    if (fx_ptr->timer < 10)
        fx_ptr->perspective -= (fx_ptr->timer * 2);
    else
        fx_ptr->perspective += ((19 - fx_ptr->timer) * 2);

    //GsSetProjection(fx_ptr->perspective);
    OBJ_players[obj_ptr->owner].throttle = 1500;

    if (fx_ptr->timer == 20)
    {
//        GsSetProjection(152);
    //GsSetProjection(325);

        PCK_octane[fx_ptr->index].in_use = FALSE;
        OBJ_delobj(obj_ptr->index);
    }

    fx_ptr->timer ++;

    return;
}
*/
///////////////////////////////////////////////////////////////////////////
//                               For test purposes only                  //
//                                 18 Sept. 1998                         //
///////////////////////////////////////////////////////////////////////////

void PCK_init_all()
{

OBJ_players[0].pickups.total = 0;
OBJ_players[0].pickups.current = NULLVAL;
OBJ_players[0].pickups.index = 0;

OBJ_players[0].pickups.pickup_list[0] = NULLVAL;
OBJ_players[0].pickups.quantity[0] = 0;

}
/*
OCTANE_FX *init_octane_object()
{
    s32             i;


    for (i = 0; i < MAX_OCTANES; i++)
    {
        if (!PCK_octane[i].in_use)
        {
            PCK_octane[i].in_use = TRUE;

            return &PCK_octane[i];
        }
    }

    return NULL;
}

void PCK_init_octane_structs()
{
    s32             i;


    for (i = 0; i < MAX_OCTANES; i++)
    {
        PCK_octane[i].in_use = FALSE;
        PCK_octane[i].index = i;
    }

    return;
}
*/
/*
ROCKET_SET *init_rocket_set_object()
{
    s32             i;


    for (i = 0; i < MAX_ROCKET_SETS; i++)
    {
        if (!PCK_rockets[i].in_use)
        {
            PCK_rockets[i].in_use = TRUE;

            return &PCK_rockets[i];
        }
    }

    return NULL;
}

void PCK_init_rocket_sets()
{
    s32             i;

    for (i = 0; i < MAX_ROCKET_SETS; i++)
    {
        PCK_rockets[i].in_use = FALSE;
        PCK_rockets[i].index = i;
    }

    return;
}
*/
/*
void PCK_init_pickup_object(s32 type)
{
	OBJ_STRUCT		*obj_ptr;
	s32				index, AI_index;


    index = OBJ_newobj(OTpickup);

    if (index == NULLVAL)
    	return;

    obj_ptr = &OBJ_objects[index];
	obj_ptr->pkup_data.type = type;

	switch (STATE.currlevel)
	{
		case 0:

			switch (type)
			{
				case pck_torpedo:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_missile:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_shield:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_rocket:

					obj_ptr->pkup_data.quantity = 8;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_turbo:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_ion:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_cluster:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_plasma:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_gas:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_flame:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_mine:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_flare:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t1[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t1[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t1[obj_ptr->pkup_data.type][2] << 8;

					break;
			}

			break;

		case 1:

			switch (type)
			{
				case pck_torpedo:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_missile:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_shield:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_rocket:

					obj_ptr->pkup_data.quantity = 8;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_turbo:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_ion:

					obj_ptr->pkup_data.quantity = 1;

   					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_cluster:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_plasma:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_gas:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_flame:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_mine:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
  					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_flare:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t2[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t2[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t2[obj_ptr->pkup_data.type][2] << 8;

					break;
			}

			break;

		case 2:

			switch (type)
			{
				case pck_torpedo:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_missile:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_shield:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_rocket:

					obj_ptr->pkup_data.quantity = 8;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_turbo:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_ion:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_cluster:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_plasma:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_gas:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_flame:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_mine:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_flare:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_t3[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_t3[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_t3[obj_ptr->pkup_data.type][2] << 8;

					break;
			}

			break;

		case 3:

			switch (type)
			{
				case pck_torpedo:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_missile:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
 					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_shield:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_rocket:

					obj_ptr->pkup_data.quantity = 8;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_turbo:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_ion:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_cluster:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_plasma:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_gas:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_flame:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_mine:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;

				case pck_flare:

					obj_ptr->pkup_data.quantity = 1;

					obj_ptr->p.vx = PCK_pickup_data_a[obj_ptr->pkup_data.type][0] << 8;
					obj_ptr->p.vy = PCK_pickup_data_a[obj_ptr->pkup_data.type][1] << 8;
					obj_ptr->p.vz = PCK_pickup_data_a[obj_ptr->pkup_data.type][2] << 8;

					break;
			}

			break;
	}

	return;
}
*/

s16   probability[13]=
{
// the probs must add up to 256
19,//pck_torpedo,
19,//pck_rocket,
19,//pck_missile,
19,//pck_mine,
19,//pck_shield,
19,//pck_cluster,
19,//pck_flame,
19,//pck_ion,
19,//pck_plasma,
19,//pck_flare,
19,//pck_gas,
19,//pck_turbo,
19,//pck_cannon
};

s32   PCK_totalnumpickups;
void PCK_360isfuckingshitbutinitallpickupsanyway(void)
{
   s16   i, j;
   s16   a, ran, AI_index;
   OBJ_STRUCT	*obj_ptr;

   if(STATE.gametype==2)//not for time trial
	return;
   for(i=0;i<PCK_totalnumpickups;i++)
   {
      a  =  OBJ_newobj(OTpickup);

   	  obj_ptr = &OBJ_objects[a];

      if(a>= STATE.wankers)
      {
         ran  =  rand()&255;
         for(j=0;j<13;j++)
         {
            if( ran < probability[j] )break;
            ran  -= probability[j];
         }
         if( j==13 )
         {
            printf("cunt probability\n");
            j=12;
         }

         OBJ_objects[a].pkup_data.type =  j;

         OBJ_objects[a].pkup_data.quantity = 1;

         if( OBJ_objects[a].pkup_data.type==pck_rocket )
            OBJ_objects[a].pkup_data.quantity = 8;

         if( OBJ_objects[a].pkup_data.type==pck_flame )
            OBJ_objects[a].pkup_data.quantity = 250;

         OBJ_objects[a].p.vx  =  PCK_positions[i].vx<<8;
         OBJ_objects[a].p.vy  =  PCK_positions[i].vy<<8;
         OBJ_objects[a].p.vz  =  PCK_positions[i].vz<<8;

         print("init pickup(%d) type(%d)\n", i, OBJ_objects[a].pkup_data.type );

#if IANORCDMASTER

		 AI_index = AI_init_pickup((obj_ptr->p.vx >> 8), (obj_ptr->p.vy >> 8), (obj_ptr->p.vz >> 8), obj_ptr->pkup_data.type);

		 if (AI_index != NULLVAL)
		 	obj_ptr->pkup_data.AI_index = AI_index;
#endif
      }
   }
}
/*
void PCK_init_pickups(void)
{
	PCK_init_pickup_object(pck_missile);
	PCK_init_pickup_object(pck_turbo);
	PCK_init_pickup_object(pck_rocket);
	PCK_init_pickup_object(pck_shield);
	PCK_init_pickup_object(pck_plasma);
	PCK_init_pickup_object(pck_flare);
	PCK_init_pickup_object(pck_gas);
	PCK_init_pickup_object(pck_ion);
	PCK_init_pickup_object(pck_cluster);
	PCK_init_pickup_object(pck_torpedo);
	PCK_init_pickup_object(pck_mine);
	PCK_init_pickup_object(pck_flame);

	return;
}
*/
char PCK_missile_collision(short angle, PAIR_2D missile_position, OBJ_STRUCT *obj_ptr)
{
	int						temp_x, temp_z;
	char 					result;


	angle += (obj_ptr->r.vy >> 4);

	if (angle > 4096)
		angle -= 4096;

	if (angle < -4096)
		angle += 4096;

	missile_collision_vector.vx = (MISSILE_VIEWING_DISTANCE * rsin(angle)) >> 12;
	missile_collision_vector.vz = (MISSILE_VIEWING_DISTANCE * rcos(angle)) >> 12;

	temp_x = missile_collision_vector.vx + missile_position.vx;
	temp_z = missile_collision_vector.vz + missile_position.vz;

	if (temp_x < MAX_NEGATIVE_POSITION)
		missile_collision_vector.vx = MAX_NEGATIVE_POSITION;
	else
	{
		if (temp_x > MAX_POSITIVE_POSITION)
			missile_collision_vector.vx = MAX_POSITIVE_POSITION;
		else
			missile_collision_vector.vx += missile_position.vx;
	}

	if (temp_z < MAX_NEGATIVE_POSITION)
		missile_collision_vector.vz = MAX_NEGATIVE_POSITION;
	else
	{
		if (temp_z > MAX_POSITIVE_POSITION)
			missile_collision_vector.vz = MAX_POSITIVE_POSITION;
		else
			missile_collision_vector.vz += missile_position.vz;
	}

	result = AI_check_point(&missile_position, &missile_collision_vector);

	return result;
}

void PCK_init_flares(void)
{
	int				i;


	for (i = 0; i < MAX_BURSTS; i++)
	{
		PCK_flares[i].in_use = FALSE;
		PCK_flares[i].index = i;
	}

	return;
}
