#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>
#include <inline_c.h>
#include <libmath.h>
#include <stdio.h>
#include "header.h"
#include "poon.h"
#include "psx\mathpsx.h"
//#include "mesh.h"
//#include "camera.h"
#include "objects.h"
#include "psx\textpsx.h"
//#include "collide.h"
//#include "pickups.h"
//#include "psx\mathpsx.h"
//#include "PSX\PSX_libs.h"
//#include "PSX\PSX_pcks.h"
//#include "PSX\PSX_expn.h"
//#include "PSX\soundPSX.h"
#include "state.h"
#include "action.h"
#include "score.h"

///////////////////////////////////////////////////////////////////////////////////////////////
//    360 racepoints
///////////////////////////////////////////////////////////////////////////////////////////////
//    Started:    23/3/99
//    Geeza:   Ma-shama-lo
//    PSX:        Yay
//    N64:
//    Notes: racepoint management. Position. Direction.
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// External Declarations
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Private Declarations
///////////////////////////////////////////////////////////////////////////////////////////////

vec16 RACE_points[MAXNUMRP];

s16   RACE_l0[MAXNUMRP];
s16   RACE_l1[MAXNUMRP];
s16   RACE_rpnum;
s32   rp[6];
s32   order[6]={0,1,2,3,4,5};
s32   position[6];
s32   d0[6];
s32   d1[6];
s32   d2[6];
u32   POON_laptimes[6][3];

///////////////////////////////////////////////////////////////////////////////////////////////
// Proto
///////////////////////////////////////////////////////////////////////////////////////////////

void  RACE_start( OBJ_STRUCT *pobj, OBJ_PLAYERSTRUCT *pplyr );
void  debugpoon( void );

///////////////////////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////////////////////

s16   RACE_findnearest( s16 x, s16 z )
   {
   s16   i;
   s32   mindis=0xeffffff;
   s32   d;
   s16   index=-1;

   for(i=0;i<RACE_rpnum;i++)
      {
      d  =  vqlen2( x-RACE_points[i].vx, z-RACE_points[i].vz );
      if( d<mindis )
         {
         mindis   =  d;
         index =  i;
         }
      }
   return   index;
   }

s16  wrongway0=0, wrongway1=0 ;

void  RACE_doracepoints()
   {
   s16   i;
//   s32   d;

   OBJ_STRUCT        *pobj    =  OBJ_objects;
   OBJ_PLAYERSTRUCT  *pplyr   =  OBJ_players;

   // see if we need to move to next rp
   for(i=0;i<STATE.wankers;i++, pobj++, pplyr++)
      {
      if( pobj->type!=OTcraft )continue;

      if( pplyr->rp0 == -1 )
         RACE_start( pobj, pplyr );

      d0[i]  =  vqlen2( (pobj->p.vx>>8)-RACE_points[pplyr->rp0].vx,
                        (pobj->p.vz>>8)-RACE_points[pplyr->rp0].vz );
      d1[i]  =  vqlen2( (pobj->p.vx>>8)-RACE_points[pplyr->rp1].vx,
                        (pobj->p.vz>>8)-RACE_points[pplyr->rp1].vz );
      d2[i]  =  vqlen2( (pobj->p.vx>>8)-RACE_points[pplyr->rp2].vx,
                        (pobj->p.vz>>8)-RACE_points[pplyr->rp2].vz );

      if( d0[i]<d1[i] )
         {
         // wrong way, prev rp
//RENDER_message("Wrong way! You are a cunt.");
      //TEXT_prstr("Wrong way! You are a cunt.",192,192,192);

         pplyr->rp0--;
         if( pplyr->rp0<0 )
            pplyr->rp0=RACE_rpnum-1;

         pplyr->rp1--;
         if( pplyr->rp1<0 )
            {
            //lap completed
            pplyr->rp1=RACE_rpnum-1;
            pplyr->stats.lap--;
            }

         pplyr->rp2--;
         if( pplyr->rp2<0 )
            pplyr->rp2=RACE_rpnum-1;
         }

      if( d2[i]<d1[i] )
         {
         // next rp
         pplyr->rp0++;
         if( pplyr->rp0==RACE_rpnum )
            pplyr->rp0=0;

         pplyr->rp1++;
         if( (pplyr->rp1==RACE_rpnum) )
            {
            //lap completed
            pplyr->rp1=0;

            if( (pplyr->stats.lap>=1) && (pplyr->stats.lap<=4) )
               POON_laptimes[i][pplyr->stats.lap]  =  pplyr->stats.total_time;


            pplyr->stats.lap++;
            if( (!STATE.demomode) && (pplyr->stats.lap!=1))
               SCORE_lapcomplete(i,pplyr->stats.lap,pplyr->stats.total_time);
//#if 0
//            if(pplyr->computer==0)
//         if( pplyr->stats.lap>=4 )     //4??
//               {
//               // race finished

//               arStart();
//            mprintf("pplyr->stats.lap == %d (i==%d)\n",pplyr->stats.lap,i);
//               }
//#endif
            }

         pplyr->rp2++;
         if( pplyr->rp2==RACE_rpnum )
            pplyr->rp2=0;
         }

      rp[i] =  pplyr->rp1   +  RACE_rpnum * pplyr->stats.lap;
      //if( rp[i] > maxrp[i] )maxrp[i]=rp[i];
      }

   // race order
   for( i=0;i<STATE.wankers-1;i++ )
      {
      if( rp[order[i]] < rp[order[i+1]] )
         {//swap
         s32   t;
         t  =  order[i];
         order[i]    =  order[i+1];
         order[i+1]  =  t;
         }

      if( rp[order[i]] == rp[order[i+1]] )
         if( d0[order[i]] < d0[order[i+1]] )
            {//swap
            s32   t;
            t  =  order[i];
            order[i]    =  order[i+1];
            order[i+1]  =  t;
            }
      }

   for( i=0;i<STATE.wankers;i++ )
      {
      position[ order[i] ]=i+1;
      }


   // dang 0
      {
      }

   // dang 1
      {
      }

   // direction 0
//      {
//      vec32 a,b;
//      a.vx  =  RACE_points[OBJ_players[0].rp2].vx -  RACE_points[OBJ_players[0].rp0].vx  ;
//      a.vz  =  RACE_points[OBJ_players[0].rp2].vz -  RACE_points[OBJ_players[0].rp0].vz  ;

//      b.vx  =  OBJ_objects[0].v.vx>>8;
//      b.vz  =  OBJ_objects[0].v.vz>>8;

//      if( ( a.vx*b.vx + a.vz*b.vz )<0 )
//         {
//         if( OBJ_players[0].speed>10 )
//            {
//            wrongway0++;
//            if(wrongway0>20)
//               {
//               TEXT_x=-20;
//               TEXT_y=-5;
//               TEXT_prstr("Wrong way!",255,70,70);
//               }
//            }
//         else
//            {
//            wrongway0=0;
//            }
//         }
//      }

   // direction 1
//      {
//      vec32 a,b;
//      a.vx  =  RACE_points[OBJ_players[1].rp2].vx -  RACE_points[OBJ_players[1].rp0].vx  ;
//      a.vz  =  RACE_points[OBJ_players[1].rp2].vz -  RACE_points[OBJ_players[1].rp0].vz  ;

//      b.vx  =  OBJ_objects[1].v.vx>>8;
//      b.vz  =  OBJ_objects[1].v.vz>>8;

//      if( ( a.vx*b.vx + a.vz*b.vz )<0 )
//         {
//         if( OBJ_players[1].speed>10 )
//            {
//            wrongway1++;
//            if(wrongway1>20)
//               {
//               TEXT_x=-20;
//               TEXT_y=-5;
//               TEXT_prstr("Wrong way!",255,70,70);
//               }
//            }
//         else
//            {
//            wrongway1=0;
//            }
//         }
//      }

	//one pass b-sortfor race positions

   for( i=0;i<STATE.wankers;i++ )
      OBJ_players[i].stats.position  =  position[i];
//	debugpoon();
	}

void  RACE_start( OBJ_STRUCT *pobj, OBJ_PLAYERSTRUCT *pplyr )
   {

   s32   c;
   c  =  RACE_findnearest( pobj->p.vx>>8, pobj->p.vz>>8 );
   pplyr->rp1   =  c;

   if( c==RACE_rpnum-1 )
      {
      pplyr->rp2   =  0;
      }
   else
      {
      pplyr->rp2   =  c+1;
      }

   if( c==0 )
      {
      pplyr->rp0   =  RACE_rpnum-1;
      }
   else
      {
      pplyr->rp0   =  c-1;
      }
   }
//         TEXT_x=-135;
//         TEXT_y=0;
//         TEXT_prstr("Wrong way! You are a cunt.",192,192,192);
//         //FntPrint("GO!\n",STATE.raceclock);

void  debugpoon(void)
   {
   s16   i;

//   for(i=0;i<6;i++)
//      {
//      FntPrint( "cr(%d) pos(%d) rp(%d)\n", i, position[i], rp[i] );
//      }

   for(i=0;i<6;i++)
      {
      FntPrint( "cr(%d), (%d),(%d),(%d)\n", i, POON_laptimes[i][0], POON_laptimes[i][1], POON_laptimes[i][2] );
      }
   }

void  POON_wrongway0()
   {
   s32   anga,angb, diff;
    if(!STATE.arena_mode)
      {
      anga  =  ratan2( RACE_points[OBJ_players[0].rp2].vx -  RACE_points[OBJ_players[0].rp0].vx,
                       RACE_points[OBJ_players[0].rp2].vz -  RACE_points[OBJ_players[0].rp0].vz
                     );

      angb  =  ratan2(OBJ_objects[0].v.vx, OBJ_objects[0].v.vz);

      diff  =  vangdiff2( anga, angb );
      //FntPrint("\n\n\n\n\n\n\n %d\n",  );
      if( OBJ_players[0].speed>20 )
      if( (diff>1500) || (diff<-1500) )
         {
         wrongway0++;
         if(wrongway0>20)
            {
            TEXT_x=-40;
            TEXT_y=-5;
            TEXT_prstr("Wrong way!",255,70,70);
            }
         }
      else
         {
         wrongway0=0;
         }
      }
   }

void  POON_wrongway1()
   {
      s32   anga,angb, diff;

    if(!STATE.arena_mode)
      {
      anga  =  ratan2( RACE_points[OBJ_players[1].rp2].vx -  RACE_points[OBJ_players[1].rp0].vx,
                       RACE_points[OBJ_players[1].rp2].vz -  RACE_points[OBJ_players[1].rp0].vz
                     );

      angb  =  ratan2(OBJ_objects[1].v.vx, OBJ_objects[1].v.vz);

      diff  =  vangdiff2( anga, angb );
      //FntPrint("\n\n\n\n\n\n\n %d\n",  );

      if( OBJ_players[1].speed>20 )
      if( (diff>1500) || (diff<-1500) )
         {
         wrongway1++;
         if(wrongway1>20)
            {
            TEXT_x=-40;
            TEXT_y=-5;
            TEXT_prstr("Wrong way!",255,70,70);
            }
         }
      else
         {
         wrongway1=0;
         }
      }
   }