#include <sys/types.h>
#include <libgte.h>
#include	<libmath.h>
#include "..\header.h"
#include "..\camera.h"
#include "mathPSX.h"
//#include "..\load.h"       // for testing

//N64 mat16 GTErotmat
//N64 vec32 GTEtrans

void  MATH_transform( vec16* v0, int *sx, int *sy, int *z )
	{
	s32 sxy, p, flag;
	vec16 vec, rot;

   vec.vx   =  (v0->vx  -  CAM_camp[CAM_c].vx);
   vec.vy   =  (v0->vy  -  CAM_camp[CAM_c].vy);
   vec.vz   =  (v0->vz  -  CAM_camp[CAM_c].vz);

   CAM_camm[CAM_c].t[0]=0;
   CAM_camm[CAM_c].t[1]=0;
   CAM_camm[CAM_c].t[2]=0;

   rot.vx =( CAM_came[CAM_c].vx )>>4;   // change 0x10000=360 to 0x1000=360
   rot.vy =( CAM_came[CAM_c].vy )>>4;
   rot.vz =( CAM_came[CAM_c].vz )>>4;
   //RotMatrix( (SVECTOR*)&rot, (MATRIX*)&CAM_camm[CAM_c] );//use constant. gte rtp
   RotMatrix_gte( (SVECTOR*)&rot, (MATRIX*)&CAM_camm[CAM_c] );//use constant. gte rtp

   SetTransMatrix( (MATRIX*)&CAM_camm[CAM_c] );
   SetRotMatrix(   (MATRIX*)&CAM_camm[CAM_c] );
   *z =  RotTransPers( (SVECTOR*)&vec, &sxy, &p, &flag )<<2;
	*sx	=	sxy&0xffff;
	*sy	=	sxy>>16;
   //N64
   /*
	s32 sxy, p, flag;
	vec16 vec, rot;

	vec.vx	=	(v0->vx	-	CAM_camp.vx);
	vec.vy	=	(v0->vy	-	CAM_camp.vy);
	vec.vz	=	(v0->vz	-	CAM_camp.vz);
	deb0	=	vec.vx;
	deb1	=	vec.vy;
	deb2	=	vec.vz;

	CAM_camm.t[0]=0;
	CAM_camm.t[1]=0;
	CAM_camm.t[2]=0;

	rot.vx =( CAM_came.vx )>>4;	// change 0x10000=360 to 0x1000=360
	rot.vy =( CAM_came.vy )>>4;
	rot.vz =( CAM_came.vz )>>4;
   RotMatrix( (SVECTOR*)&rot, (MATRIX*)&CAM_camm );//use constant. gte rtp

   SetTransMatrix( (MATRIX*)&CAM_camm );
   SetRotMatrix(   (MATRIX*)&CAM_camm );
   *z =  RotTransPers( (SVECTOR*)&vec, &sxy, &p, &flag )<<2;
	*sx	=	sxy&0xffff;
	*sy	=	sxy>>16;

    */
   }

void	vnormmat( mat16 *m, u8 n )
	{

   switch(n)
		{
      case  0     :  MatrixNormal  ( (MATRIX*)m, (MATRIX*)m );break;
      case  87    :  MatrixNormal_1( (MATRIX*)m, (MATRIX*)m );break;
      case  174   :  MatrixNormal_2( (MATRIX*)m, (MATRIX*)m );break;
		}

	}

s32   vatan2( s32 y, s32 x )
   {
   return   ratan2(  y, x );
   }

void  vmulmatrix2( mat16 *a, mat16 *b )
   {
   MulMatrix2( (MATRIX*)a, (MATRIX*)b );

   //N64ok
   /*
   u8    x,y;
   s32   t[3][3];

	for(x=0;x<3;x++)
		{
		for(y=0;y<3;y++)
			{
         //t[x][y] = a->m[0][y] * b->m[x][0] + a->m[1][y] * b->m[x][1] + a->m[2][y] * b->m[x][2];
         t[y][x] = a->m[y][0] * b->m[0][x] + a->m[y][1] * b->m[1][x] + a->m[y][2] * b->m[2][x];
			}
		}

	for(x=0;x<3;x++)
		{
		for(y=0;y<3;y++)
			{
         b->m[x][y] = t[x][y]>>12;
			}
		}
   */
   }

void  vmulmatrix( mat16 *a, mat16 *b )
   {
   MulMatrix( (MATRIX*)a, (MATRIX*)b );
   }

void  vscalematrix( mat16 *m, vec32 *s  )
   {
   ScaleMatrix( (MATRIX*)m, (VECTOR*)s );

   //N64?
   /*
   m->m[0][0]  *= s->vx>>12;
   m->m[0][1]  *= s->vx>>12;
   m->m[0][2]  *= s->vx>>12;

   m->m[1][0]  *= s->vy>>12;
   m->m[1][1]  *= s->vy>>12;
   m->m[1][2]  *= s->vy>>12;

   m->m[2][0]  *= s->vz>>12;
   m->m[2][1]  *= s->vz>>12;
   m->m[2][2]  *= s->vz>>12;
   */
   }

void  vsetrotmatrix( mat16 *objm)
   {
   SetRotMatrix( (MATRIX*)objm );
   }

void  vsettransmatrix( mat16 *objm)
   {
   SetTransMatrix( (MATRIX*)objm );
   }

void  vrotmatrix2( vec16 *a, mat16 *b )
	{
   RotMatrixZYX( (SVECTOR*)a, (MATRIX*)b );
   }

void	vrotmatrix( vec16 *a, mat16 *b )
	{
   RotMatrix( (SVECTOR*)a, (MATRIX*)b );
   /* U64   dont use z
   cx    =  rcos(-v.vx);   //12
   cy    =  rcos(v.vy);  //12
   cz    =  rcos(-v.vz);   //12
   sx    =  rsin(-v.vx);   //12
   sy    =  rsin(v.vy);    //12
   sz    =  rsin(-v.vz);    //12
   ss    =  (sy*sz)>>12;   //12
   cc    =  (cy*cz)>>12;    //12
   sc    =  (sy*cz)>>12;    //12
   cs    =  (cy*sz)>>12;    //12
   m1.m[i0][i0] =  cc - ((ss*sx)>>12);
   m1.m[i0][i1] =  (cx*sz)>>12;
   m1.m[i0][i2] =  sc + ((sx*cs)>>12);

   m1.m[i1][i0] =  ((-sc*sx)>>12) -cs;
   m1.m[i1][i1] =  (cx*cz)>>12;
   m1.m[i1][i2] =  ((cc*sx)>>12) -ss;

   m1.m[i2][i0] =  -(sy*cx)>>12;
   m1.m[i2][i1] =  -sx ;
   m1.m[i2][i2] =  (cy*cx)>>12;

   */
	}

void  vapplymatrix32( mat16 *a, vec32 *b, vec32 *c )
	{
   ApplyMatrixLV( (MATRIX*)a, (VECTOR*)b, (VECTOR*)c );
   //N64?
   //c->vx   =  ( b->vx * (s32)a->m[0][0] + b->vy * (s32)a->m[1][0] + b->vz * (s32)a->m[2][0] )>>12;
   //c->vy   =  ( b->vx * (s32)a->m[0][1] + b->vy * (s32)a->m[1][1] + b->vz * (s32)a->m[2][1] )>>12;
   //c->vz   =  ( b->vx * (s32)a->m[0][2] + b->vy * (s32)a->m[1][2] + b->vz * (s32)a->m[2][2] )>>12;
   }

void  vapplymatrix16( mat16 *a, vec16 *b, vec32 *c )
	{
   ApplyMatrix( (MATRIX*)a, (SVECTOR*)b, (VECTOR*)c );
   //N64?
   //c->vx   =  ( b->vx * (s32)a->m[0][0] + b->vy * (s32)a->m[0][1] + b->vz * (s32)a->m[0][2] )>>12;
   //c->vy   =  ( b->vx * (s32)a->m[1][0] + b->vy * (s32)a->m[1][1] + b->vz * (s32)a->m[1][2] )>>12;
   //c->vz   =  ( b->vx * (s32)a->m[2][0] + b->vy * (s32)a->m[2][1] + b->vz * (s32)a->m[2][2] )>>12;
	}

s32	vroot32( s32 a )
	{
	return	SquareRoot0( a );
	}

void	vsquare32( vec32 *a, vec32 *b )
	{
   Square0( (VECTOR*)a, (VECTOR*)b );
   //N64
   //b->vx  =  a->vx*a->vx;
   //b->vy  =  a->vy*a->vy;
   //b->vz  =  a->vz*a->vz;
   }

s32	vdot( vec32 *v0, vec32 *v1 )
	{
   // inner product
   return( v0->vx*v1->vx + v0->vy*v1->vy + v0->vz*v1->vz );
	}

void  vmov( vec32 *d, vec32 *s )
   {
   d->vx = s->vx;
   d->vy = s->vy;
   d->vz = s->vz;
   }

void	vadd( vec32* v0, vec32* v1 )
   {
	v0->vx = v0->vx + v1->vx;
	v0->vy = v0->vy + v1->vy;
	v0->vz = v0->vz + v1->vz;
	}

void	vsub( vec32* v0, vec32* v1 )
   {
	v0->vx = v0->vx - v1->vx;
	v0->vy = v0->vy - v1->vy;
	v0->vz = v0->vz - v1->vz;
	}

void  vequ( vec32* v0, long x, long y, long z )
	{
	v0->vx =	x;
	v0->vy = y;
	v0->vz = z;
	}

void	vcross( vec32 *vb, vec32 *va, vec32 *r )
	{
   //vec32 t;
	// fixed?GTE!
	//		  s16 * s16       -	 s16 * s16 = s32
   OuterProduct0(  (VECTOR*)va, (VECTOR*)vb, (VECTOR*)r );

   //t.vx = va->vy * vb->vz  -  va->vz * vb->vy;
   //t.vy = va->vz * vb->vx  -  va->vx * vb->vz;
   //t.vz = va->vx * vb->vy  -  va->vy * vb->vx;

   //r->vx =t.vx;
   //r->vy =t.vy;
   //r->vz =t.vz;
	}

// short versions
//void  vmovs( vec16 *d, vec16 *s )
//   {
//   d->vx = s->vx;
//   d->vy = s->vy;
//   d->vz = s->vz;
//   }

void	vadds( vec16* v0, vec16* v1 )
   {
	v0->vx = v0->vx + v1->vx;
	v0->vy = v0->vy + v1->vy;
	v0->vz = v0->vz + v1->vz;
	}

void	vsubs( vec16* v0, vec16* v1 )
   {
	v0->vx = v0->vx - v1->vx;
	v0->vy = v0->vy - v1->vy;
	v0->vz = v0->vz - v1->vz;
	}

void	vequs( vec16* v0, int x, int y, int z )
	{
	v0->vx =	x;
	v0->vy = y;
	v0->vz = z;
	}

void vcrosss( vec16 *vb, vec16 *va, vec32 *r )
	{
	vec32 t;
	// fixed?GTE!
	//		  s16 * s16       -	 s16 * s16 = s32
   //OuterProduct0(  va, vb, r );

   t.vx = va->vy * vb->vz  -  va->vz * vb->vy;
	t.vy = va->vz * vb->vx  -  va->vx * vb->vz;
	t.vz = va->vx * vb->vy  -  va->vy * vb->vx;

   //t.vx = dy0;
   //t.vy =  1;
   //t.vz = dy1;


	r->vx =t.vx;
	r->vy =t.vy;
	r->vz =t.vz;
	}

s16	vlens( vec16 *v0 )
	{
   //not called
	vec32	a, b;
	a.vx	=	(s32)v0->vx;
	a.vy	=	(s32)v0->vy;
	a.vz	=	(s32)v0->vz;

   Square0( (VECTOR*)&a, (VECTOR*)&b );
	return  SquareRoot0( b.vx + b.vy + b.vz );
	}

void	vunits( vec16 *v0, vec16 *v1 )
	{
   //not called
	// v0=16.0
	// v1=2.14
	s16 l;

	l=vlens( v0 );//l: 0-0xffff

	if(l==0)
		{
		v1->vx = 0;
		v1->vy = 0;
		v1->vz = 0;
		}
	else
		{
		v1->vx = (((s32)v0->vx << 16) / l)>>2;
		v1->vy = (((s32)v0->vy << 16) / l)>>2;
		v1->vz = (((s32)v0->vz << 16) / l)>>2;
		}
	}

s32	v2dcross( s32 x0, s32 y0, s32 x1, s32 y1 )
	{
	return( x0*y1 - x1*y0 );
	}

s16	vabss( s16	n )
	{
	if( n>0 )return	n;
	if( n<0 )return	-n;
	return	0;
	}

s32	vqlen (s32 ix,s32 iy,s32 iz)
  {
  s32		t;

  ix= (ix<0 ? -ix : ix);	// absolute values
  iy= (iy<0 ? -iy : iy);
  iz= (iz<0 ? -iz : iz);

  if(ix<iy)			// needs only two comparisons
   {
   ix=ix^iy;
   iy=ix^iy;
   ix=ix^iy;
  	}

  if(ix<iz)
   {
   ix=ix^iz;
   iz=ix^iz;
   ix=ix^iz;
  	}
  // now ix is the largest

  t = iy + iz;

  return (ix - (ix>>4) + (t>>2) + (t>>3));
  }

/*
s32 vqlen2 ( s32 ix, s32 iy )
   {
   s32 t;

   ix= (ix<0 ? -ix : ix);   // absolute values
   iy= (iy<0 ? -iy : iy);

   if(ix<iy)
      {
      ix=ix^iy;
      iy=ix^iy;
      ix=ix^iy;
      }

   t = iy + (iy>>1);

   return (ix - (ix>>5) - (ix>>7)  + (t>>2) + (t>>6));
   }
*/

s32 vqlen2 ( s32 ix, s32 iy )
   {
   s32 t;

   ix= (ix<0 ? -ix : ix);   // absolute values
   iy= (iy<0 ? -iy : iy);

   if(ix<iy)
      {
      ix=ix^iy;
      iy=ix^iy;
      ix=ix^iy;
      }

   t = iy + (iy>>1);

   return (ix - (ix>>5) - (ix>>7)  + (t>>2) + (t>>6));
   }

// misc
#define idxi   2
#define idxj   1
#define idxk   0

void mgeteuler( mat16 *M, vec16 *v )
	{
	//	yxz order. Change indices to change order
	s32 x,y,z, s;
	s32 x2, y2, z2;

	s	=	SquareRoot0( M->m[idxi][idxi]*M->m[idxi][idxi] + M->m[idxj][idxi]*M->m[idxj][idxi] );

	//if( M->m[idxk][idxk]==0 )deb6++;
	//if( M->m[idxi][idxi]==0 )deb6++;

	x	= ratan2(  M->m[idxk][idxj], M->m[idxk][idxk] ); // =  -sy*cx / cy*cx
	y	= ratan2( -M->m[idxk][idxi], s );
	z	= ratan2(  M->m[idxj][idxi], M->m[idxi][idxi] ); // =  cx*sz / cx*cz

	x2	=	-z;
	y2	=	-y;
	z2	=	-x;

	if( x2<-2047)x2+=4096;
	if( y2<-2047)y2+=4096;
	if( z2<-2047)z2+=4096;

	if( x2>2048)x2-=4096;
	if( y2>2048)y2-=4096;
	if( z2>2048)z2-=4096;

	v->vx	= 	x2;
	v->vy	= 	y2;
	v->vz	= 	z2;
	}
/*
	double cy = sqrt(M[i][i]*M[i][i] + M[j][i]*M[j][i]);
	if (cy > 16*FLT_EPSILON) {
	    ea.x = atan2(M[k][j], M[k][k]);
	    ea.y = atan2(-M[k][i], cy);
	    ea.z = atan2(M[j][i], M[i][i]);
*/
void mMmulM( mat16 *a, mat16 *b, mat16 *r )
	{
	u32		x,y, c;
	MATRIX	t;

	for(x=0;x<3;x++)
		{
		for(y=0;y<3;y++)
			{
			c	=	a->m[0][y] * b->m[x][0] + a->m[1][y] * b->m[x][1] + a->m[2][y] * b->m[x][2];
			t.m[x][y] = c>>12;//unroll me please
			}
		}

	for(x=0;x<3;x++)
		{
		for(y=0;y<3;y++)
			{
			r->m[x][y] = t.m[x][y];
			}
		}
	}

void msetmatrotvect( mat16 *m, vec16 *v )
	{
	// sets a rotation about an arbitary axis
	// w proportional to length of vector
	s32	x, y, z, w, len, s;
   s32	xs,  	ys, 	zs;
   s32	wx,  	wy,   wz;
   s32	xx,	xy, 	xz;
   s32	yy,	yz, 	zz;
	s32	fsin, fcos;
	vec32	sv;

	x	=	v->vx;	y	=	v->vy;	z	=	v->vz;
	sv.vx	=	x;		sv.vy	=	y;		sv.vz	=	z;
   Square0( (VECTOR*)&sv, (VECTOR*)&sv );
	len	=	SquareRoot0(sv.vx + sv.vy + sv.vz);

	if(len!=0)
		{
		x	=	( x<<14 )/len;   //x14
		y	=	( y<<14 )/len;   //y14
		z	=	( z<<14 )/len;   //z14

		w	=	len>>6;

		fsin	=	rsin( (w + 2048)>>1 )<<16;  //28
		fcos	=	rcos( (w + 2048)>>1 )<<2;   //14

//deb0	=	fsin;
//deb1	=	fcos;

		if( fcos ==0 )
			{
  			xs =	0; 	ys = 0;	zs = 0; // all 14
			w	=	0x4000;					  //carefull!
			}
		else
			{
			w	=	fsin/fcos; //w14
//deb2	=	w;
			s	=	( ( fcos*fcos )>>2); //s24
//deb3	=	s;
			xs = ( (x>>6)*s  )>>14; 	ys = (  (y>>6)*s  )>>14;	zs = ( (z>>6)*s  )>>14;// all 14
			}
//deb4	=	xs;
//deb5	=	ys;
//deb6	=	zs;

   	wx = ( (w>>1)*xs )>>20; 	wy = ( (w>>1)*ys )>>20;	wz = ( (w>>1)*zs )>>20;
   	xx = ( (x>>1)*xs )>>20; 	xy = ( (x>>1)*ys )>>20;	xz = ( (x>>1)*zs )>>20;
   	yy = ( (y>>1)*ys )>>20; 	yz = ( (y>>1)*zs )>>20;	zz = ( (z>>1)*zs )>>20;
		// all 12

		m->m[0][0] = 4096 - (yy + zz);
		m->m[0][1] = xy - wz;
		m->m[0][2] = xz + wy;
   	m->m[1][0] = xy + wz;
		m->m[1][1] = 4096 - (xx + zz);
		m->m[1][2] = yz - wx;
   	m->m[2][0] = xz - wy;
		m->m[2][1] = yz + wx;
		m->m[2][2] = 4096 - (xx + yy);
//deb8	= m->m[0][2];
		}
	else
		{
		// zero len,  return unit mat
		m->m[0][0] = 4096;
		m->m[0][1] = 0;
		m->m[0][2] = 0;
   	m->m[1][0] = 0;
		m->m[1][1] = 4096;
		m->m[1][2] = 0;
   	m->m[2][0] = 0;
		m->m[2][1] = 0;
		m->m[2][2] = 4096;
		}
	// all done 12muls, 3divs(mulrecip?) , gtesqr, gtesqrt, rsin, rcos
	}

s32	vangdiff( s32	a, s32	b )
	{// jof angles 0-ffff
	s32	c	=a-b+0xe000000;
	c			=c&0xffff;

	if(c<32768)	return	c;
	else			return   -(65536-c);
	}

s16	vangdiff2( s16	a, s16	b )
	{// ian angles 0-fff
	s32	c	=a-b+0xe000000;
	c			=c&0xfff;

	if(c<2048)	return	c;
	else			return   -(4096-c);
	}

void vreflect(vec32 *k, vec16 *n, vec32 *r)
	{
   //not used
	// k= incident vec32
	// n= UNIT normal
	// r= reflected
	// r= 2n(n.k) - k
	vec32 i;
	s32	dp;

	i.vx = -k->vx;
	i.vy = -k->vy;
	i.vz = -k->vz;

	dp = ((i.vx * n->vx) + (i.vy * n->vy) + (i.vz * n->vz))<<1;//14
	r->vx = (((n->vx * dp)) - i.vx);
	r->vy = (((n->vy * dp)) - i.vy);
	r->vz = (((n->vz * dp)) - i.vz);
	}

void vrot( s16 *a, s16 *b, s32 ang )
	{
	s32	aa, bb;
	s32	so, co;

	so	=	rsin( ang>>4 );//12
	co	=	rcos( ang>>4 );//12

	aa	=	((s32)*a * co) + ((s32)*b * so);//12
	bb =  ((s32)*a *-so) + ((s32)*b * co);//12
	*a	=	aa>>12;
	*b =	bb>>12;
	}

void vrot32( s32 *a, s32 *b, s32 ang )
	{
	s32	aa, bb;
	s32	so, co;

	so	=	rsin( ang>>4 );//12
	co	=	rcos( ang>>4 );//12

   aa =  (*a * co) + (*b * so);//12
   bb =  (*a *-so) + (*b * co);//12
	*a	=	aa>>12;
	*b =	bb>>12;
	}

u32	hue2rgb[256]={//lil endian!
16515072,
16318466,
16121861,
15925256,
15728651,
15532046,
15335441,
15138836,
14942231,
14745626,
14549021,
14352416,
14155811,
13959206,
13762601,
13565996,
13369391,
13172786,
12976181,
12779576,
12582971,
12386366,
12189761,
11993156,
11796551,
11599946,
11403341,
11206736,
11075667,
10879061,
10682456,
10485851,
10289246,
10092641,
9896036,
9699431,
9502826,
9306221,
9109616,
8913011,
8716406,
8519801,
8323196,
8126591,
7929986,
7733381,
7536776,
7340171,
7143566,
6946961,
6750356,
6553751,
6357146,
6160541,
5963936,
5767331,
5570726,
5439657,
5243051,
5046446,
4849841,
4653236,
4456631,
4260026,
4063421,
3866816,
3670211,
3473606,
3277001,
3080396,
2883791,
2687186,
2490581,
2293976,
2097371,
1900766,
1704161,
1507556,
1310951,
1114346,
917741,
721136,
524531,
327926,
131321,
252,
252,
761,
1526,
2291,
3056,
3821,
4586,
5351,
6116,
6881,
7646,
8411,
9176,
9941,
10706,
11471,
12236,
13001,
13766,
14531,
15296,
16061,
16826,
17591,
18356,
19121,
19886,
20651,
21417,
21926,
22691,
23456,
24221,
24986,
25751,
26516,
27281,
28046,
28811,
29576,
30341,
31106,
31871,
32636,
33401,
34166,
34931,
35696,
36461,
37226,
37991,
38756,
39521,
40286,
41051,
41816,
42581,
43347,
43856,
44621,
45386,
46151,
46916,
47681,
48446,
49211,
49976,
50741,
51506,
52271,
53036,
53801,
54566,
55331,
56096,
56861,
57626,
58391,
59156,
59921,
60686,
61451,
62216,
62981,
63746,
64512,
64512,
194816,
390656,
586496,
782336,
978176,
1174016,
1369856,
1565696,
1761536,
1957376,
2153216,
2349056,
2544896,
2740736,
2936576,
3132416,
3328256,
3524096,
3719936,
3915776,
4111616,
4307456,
4503296,
4699136,
4894976,
5090816,
5286656,
5482752,
5613056,
5808896,
6004736,
6200576,
6396416,
6592256,
6788096,
6983936,
7179776,
7375616,
7571456,
7767296,
7963136,
8158976,
8354816,
8550656,
8746496,
8942336,
9138176,
9334016,
9529856,
9725696,
9921536,
10117376,
10313216,
10509056,
10704896,
10900736,
11096832,
11227136,
11422976,
11618816,
11814656,
12010496,
12206336,
12402176,
12598016,
12793856,
12989696,
13185536,
13381376,
13577216,
13773056,
13968896,
14164736,
14360576,
14556416,
14752256,
14948096,
15143936,
15339776,
15535616,
15731456,
15927296,
16123136};

/*
s32 arctantab[32] = {  // MS 4 integral bits for radians
   297197971, 210828714, 124459457, 65760959, 33381290, 16755422,
   8385879, 4193963, 2097109, 1048571, 524287, 262144, 131072,
   65536, 32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64,
   32, 16, 8, 4, 2, 1, 0, 0,
   };

s32  MATH_atan2( s32 argx, s32 argy )
   {
   s32 theta = 0, yi, i;
   s32 x = argx, y = argy;
   s32 *arctanptr = arctantab;

   for (i = -1; i <= 28; i++)
      {
      if (y < 0)
         {      // Rotate positive
			yi = y + (x >> i);
			x  = x - (y >> i);
			y  = yi;
			theta -= *arctanptr++;
         }
      else
         {       // Rotate negative
			yi = y - (x >> i);
			x  = x + (y >> i);
			y  = yi;
			theta += *arctanptr++;
         }
      }
   return theta;
   }
*/

//u8 qatan2[256][256];

//u16 MATH_qreciptab[1024];
//void  MATH_qrecip()
//   {
//   }

void  MATH_init()
   {
//   s16   f,x, z, ang ;

   //MATH_qreciptab[0]=65535;
   //for(f=1;f<1024;f++)
   //      {
   //      MATH_qreciptab[f] =  (65536*64)/f;  //22
   //      }
   /*
   for(x=-127;x<=128;x++)
      for(z=-127;z<=128;z++)
         {
         ang   =  ratan2(x,z)>>4;

         if(ang>=0)
            qatan2[ (u8)x ][ (u8)z ] = ang;
         else
            qatan2[ (u8)x ][ (u8)z ] = ang+256;
         }
   */
   }



//OPZ = (SX1-SX0)(SY2-SY0) - (SX2-SX0)(SY1-SY0);
//= (SX0SY1+SX1SY2+SX2SY0)-(SX0SY2+SX1SY0+SX2SY1);
























