void  MATH_transform( vec16* v0, int *sx, int *sy, int *z );
void	vrotmatrix( vec16 *a, mat16 *b );
void  vrotmatrix2( vec16 *a, mat16 *b );
void	vapplymatrix32( mat16 *a, vec32 *b, vec32 *c );
void  vapplymatrix16( mat16 *a, vec16 *b, vec32 *c );
void	vsquare32( vec32 *a, vec32 *b );
void	vmulmatrix2( mat16 *a, mat16 *b );
void  vmulmatrix( mat16 *a, mat16 *b );
void  vsetrotmatrix( mat16 *objm);
void  vsettransmatrix( mat16 *objm);
void  vscalematrix( mat16 *m, vec32 *s  );
s32	vatan2( s32 y, s32 x);
void	vnormmat( mat16 *m, u8 n );



s32	vroot32( s32 a );
s32	vdot( vec32 *v0, vec32 *v1 );
void	vmov( vec32*  d, vec32* s );
void	vadd( vec32* v0, vec32* v1 );
void	vsub( vec32* v0, vec32* v1 );
void	vequ( vec32* v0, long x, long y, long z );
void	vcross( vec32 *vb, vec32 *va, vec32 *r );

// short versions ( just like me! )
void	vmovs( vec16*  d, vec16* s );
void	vadds( vec16* v0, vec16* v1 );
void	vsubs( vec16* v0, vec16* v1 );
void	vequs( vec16* v0, int x, int y, int z );
void	vcrosss( vec16 *vb, vec16 *va, vec32 *r );
s16	vlens( vec16 *v0 );
void	vunits( vec16 *v0, vec16 *v1 );
s32	v2dcross( s32 x0, s32 y0, s32 x1, s32 y1 );
s16	vabss( s16	n );
s32	vqlen (s32 ix,s32 iy,s32 iz);
s32   vqlen2 ( s32 ix, s32 iy );
// misc
void mgeteuler( mat16 *M, vec16 *v );
void mMmulM( mat16 *a, mat16 *b, mat16 *r );
void msetmatrotvect( mat16 *m, vec16 *v );
s32  vangdiff( s32	a, s32	b );
s16	vangdiff2( s16	a, s16	b );
void vreflect(vec32 *k, vec16 *n, vec32 *r);
void vrot( s16	*a, s16 *b, s32 ang );
void vrot32( s32 *a, s32 *b, s32 ang );

extern   u32   hue2rgb[256];
void  MATH_init();
extern   u8 qatan2[256][256];


#define  mov( a, b )                \
         (a).vx  =  (b).vx,         \
         (a).vy  =  (b).vy,         \
         (a).vz  =  (b).vz

#define  equ( v, a,b,c )            \
         (v).vx  =  (a),            \
         (v).vy  =  (b),            \
         (v).vz  =  (c)

#define  add( a, b )                \
         (a).vx   += (b).vx,        \
         (a).vy   += (b).vy,        \
         (a).vz   += (b).vz

#define  sub( a, b )                \
         (a).vx   -= (b).vx,        \
         (a).vy   -= (b).vy,        \
         (a).vz   -= (b).vz

#define  dot( a, b )               \
         ((a).vx*(b).vx + (a).vy*(b).vy + (a).vz*(b).vz)

#define  shr( a, b )             \
         (a).vx  >>= (b),        \
         (a).vy  >>= (b),        \
         (a).vz  >>= (b)

#define  shl( a, b )             \
         (a).vx  <<= (b),        \
         (a).vy  <<= (b),        \
         (a).vz  <<= (b)

#define  scale( a, b )          \
         (a).vx  *= (b),        \
         (a).vy  *= (b),        \
         (a).vz  *= (b)


#define  SORT3( a,b,c )       \
   {                          \
   if(a>b)                    \
      {                       \
      a=a^b; b=a^b; a=a^b;    \
      }                       \
   if(b>c)                    \
      {                       \
      b=b^c; c=b^c; b=b^c;    \
      }                       \
   if(a>b)                    \
      {                       \
      a=a^b; b=a^b; a=a^b;    \
      }                       \
   }

#define  SORT4( a,b,c,d )    \
   {                         \
   if(a>b)                   \
      {                      \
      a=a^b; b=a^b; a=a^b;   \
      }                      \
                             \
   if(c>d)                   \
      {                      \
      c=c^d; d=c^d; c=c^d;   \
      }                      \
                             \
   if(a>c)                   \
      {                      \
      a=a^c; c=a^c; a=a^c;   \
      }                      \
                             \
   if(b>d)                   \
      {                      \
      b=b^d; d=b^d; b=b^d;   \
      }                      \
   }

#define  sgn(x)   ( (x)<0?-1:1 )
//      ix=ix^iy; swap x,y
//      iy=ix^iy;
//      ix=ix^iy;