//onscreen.c
//On Screen display and players stats etc...
//Ian Tomkins
//27.1.99


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "..\header.h"
#include "..\objects.h"
#include "..\collide.h"
#include "..\pickups.h"
#include "..\weapons.h"
#include "..\render.h"
#include "..\camera.h"
#include "..\ctrller.h"
#include "..\sdlib\sdtypes.h"
#include "..\sdlib\sdfunc.h"
#include "..\state.h"
#include "MATHPSX.h"
#include "PSX_libs.h"
#include "PSX_pcks.h"
#include "PSX_expn.h"
#include "TEXTPSX.h"
#include "onscreen.h"
#include "..\menu.h"

//for display - OT stuff
extern GsOT     Wotwin0[2];
extern GsOT     Wotwin1[2];
extern int      outbuf_idx;
extern	GsOT	*ptrwot;
//end of for display - OT stuff


//void display_lines(void);

#define		MAX_LINE_SEGS		4

//LINE_F4				line[2][MAX_LINE_SEGS];


//STATS DISPLAY FUNCTIONS
void print_speed(OBJ_PLAYERSTRUCT *plyr_ptr);
void print_lap_information(OBJ_PLAYERSTRUCT *plyr_ptr, PLAYER_STAT *stats);
void print_position(OBJ_PLAYERSTRUCT *plyr_ptr);
void display_icon(OBJ_PLAYERSTRUCT *plyr_ptr);
void display_graphics(void);
void display_cannon_power_bar(OBJ_PLAYERSTRUCT *plyr_ptr);


void init_player_stats(void)
{
	int				i;
	PLAYER_STAT		*ptr;


	for (i = 0; i <  STATE.wankers; i++)
	{
		ptr = &OBJ_players[i].stats;

		ptr->in_use = FALSE;
		ptr->player_num = i;

		ptr->position =
		ptr->lap_time =
		ptr->total_time =
		ptr->kills = NULLVAL;
	}

	return;
}

void init_player_stats_struct(OBJ_PLAYERSTRUCT *plyr_ptr)
{
	PLAYER_STAT		*ptr;


	ptr = &plyr_ptr->stats;

	ptr->in_use = TRUE;
	ptr->player_num = plyr_ptr->plyrnum;

	// Added by mat 22/04/1999	 - FUCKOFF YOU HAMSTER-FUCK!
	ptr->kills = 0;
	ptr->lap_time = 0;
	ptr->total_time = 0;
   ptr->lap = 0;
	ptr->position = 0;

	return;
}

void SCRN_display_player_data(OBJ_PLAYERSTRUCT *plyr_ptr)
{
	int				i;

	if(execGame)

	for (i = 0; i <  STATE.wankers; i++)
	{
		OBJ_players[i].stats.lap_time ++;
		OBJ_players[i].stats.total_time ++;
	}

	print_speed(plyr_ptr);
	print_lap_information(plyr_ptr, &plyr_ptr->stats);
	print_position(plyr_ptr);

	display_graphics();

	if (plyr_ptr->pickups.current != NULLVAL)
		display_icon(plyr_ptr);

	display_cannon_power_bar(plyr_ptr);

	return;
}

void display_cannon_power_bar(OBJ_PLAYERSTRUCT *plyr_ptr)
{
	POLY_GT4				face;
//	u8 						text[10];
	s16						ammo_level, armour_level;


   if(STATE.gametype==2)//not for time trial
	return;

	ammo_level = plyr_ptr->ammo / 100;
	armour_level = plyr_ptr->armour_level / 16;
/*
    sprintf(text, "%d", plyr_ptr->weapon_level);

#if PAL

	TEXT_x = 208;
	TEXT_y = 83 / STATE.numscreens;
	TEXT_prstrbignum(text, 128, 128, 128);
#else

	TEXT_x = 208;
	TEXT_y = 53 / STATE.numscreens;
	TEXT_prstrbignum(text, 128, 128, 128);

#endif
*/
	SetPolyGT4(&face);
	SetSemiTrans(&face, 1);

	face.tpage = GetTPage(0, 1, 704, 256);
    face.clut = GetClut(704, 470);

	face.r0 = 255;
	face.g0 = ammo_level * 5;//255;
	face.b0 = 0;//255;

	face.r1 = 0;
	face.g1 = 0;
	face.b1 = 0;

	face.r2 = 255;
	face.g2 = ammo_level * 5;//255;
	face.b2 = 0;//255;

	face.r3 = 0;
	face.g3 = 0;
	face.b3 = 0;

    face.u0 = 42;
    face.v0 = 229;

    face.u1 = 43;
    face.v1 = 229;

    face.u2 = 42;
    face.v2 = 229;

    face.u3 = 43;
    face.v3 = 229;

#if PAL

	face.x0 = 180;
	face.y0 = 104 / STATE.numscreens;

	face.x1 = face.x0 + ammo_level;//230;
	face.y1 = 104 / STATE.numscreens;

	face.x2 = 180;
	face.y2 = 108 / STATE.numscreens;

	face.x3 = face.x2 + ammo_level;//230;
	face.y3 = 108 / STATE.numscreens;
#else

	face.x0 = 180;
	face.y0 = 84 / STATE.numscreens;

	face.x1 = face.x0 + ammo_level;//230;
	face.y1 = 84 / STATE.numscreens;

	face.x2 = 180;
	face.y2 = 88 / STATE.numscreens;

	face.x3 = face.x2 + ammo_level;//230;
	face.y3 = 88 / STATE.numscreens;

if (STATE.numscreens == 2)
{
	face.y3 += 10;
	face.y2 += 10;
	face.y1 += 10;
	face.y0 += 10;
}
#endif
	GsSortPoly(&face, ptrwot, 0);

// armour indicator bar
#if PAL

	face.x0 = 180;
	face.y0 = 84 / STATE.numscreens;

	face.x1 = face.x0 + armour_level;//230;
	face.y1 = 84 / STATE.numscreens;

	face.x2 = 180;
	face.y2 = 88 / STATE.numscreens;

	face.x3 = face.x2 + armour_level;//230;
	face.y3 = 88 / STATE.numscreens;
#else

	face.x0 = 180;
	face.y0 = 64 / STATE.numscreens;

	face.x1 = face.x0 + armour_level;//230;
	face.y1 = 64 / STATE.numscreens;

	face.x2 = 180;
	face.y2 = 68 / STATE.numscreens;

	face.x3 = face.x2 + armour_level;//230;
	face.y3 = 68 / STATE.numscreens;

if (STATE.numscreens == 2)
{
	face.y3 += 10;
	face.y2 += 10;
	face.y1 += 10;
	face.y0 += 10;
}
#endif

	face.r0 = 128;
	face.g0 = 0;
	face.b0 = armour_level * 5;//255;

	face.r1 = 0;
	face.g1 = 0;
	face.b1 = 0;

	face.r2 = 128;
	face.g2 = 0;//255;
	face.b2 = armour_level * 5;//255;

	face.r3 = 0;
	face.g3 = 0;
	face.b3 = 0;

	GsSortPoly(&face, ptrwot, 0);

	return;
}

void print_lap_information(OBJ_PLAYERSTRUCT *plyr_ptr, PLAYER_STAT *stats)
{
	u8 			text[10];
	s8			minutes;
	s8			seconds;
	s16			fraction;


	if (STATE.arena_mode == TRUE)
	{
		sprintf(text, "Frags %d", stats->kills);

		TEXT_x = -230;
		TEXT_y = -108 / STATE.numscreens;
		TEXT_prstr(text, 128, 128, 128);
	}
	else
	{
      if( stats->lap <= 0 )
         sprintf(text, "Lap %d", 1);

      else
      if( stats->lap >= 4 )
         sprintf(text, "Lap %d", 3);

      else
         sprintf(text, "Lap %d", stats->lap);

		TEXT_x = -230;
		TEXT_y = -108 / STATE.numscreens;
		TEXT_prstr(text, 128, 128, 128);
	}

	/*
	// Far too sloooow
	fraction = (stats->lap_time % 25) * 4;
	seconds = (stats->lap_time / 25) % 60;
	minutes = (stats->lap_time / 25) / 60;
	*/
	// opti-quick
	{
	register int i;
	register int j;
	i = stats->lap_time;
	j = i / 1500;
	minutes = j;
	i -= (j*1500);
	j = i / 25;
	seconds = j;
	i -= (j*25);
	fraction = i * 4;
	}

	if (minutes < 10)
		sprintf(text, "0%d:", minutes);
	else
		sprintf(text, "%d:", minutes);

	if (seconds < 10)
		sprintf(text, "%s0%d:", text, seconds);
	else
		sprintf(text, "%s%d:", text, seconds);

	if (fraction < 10)
		sprintf(text, "%s0%d", text, fraction);
	else
		sprintf(text, "%s%d", text, fraction);

	TEXT_x = -30;
	TEXT_y = -108 / STATE.numscreens;
	TEXT_prstr(text, 128, 128, 128);

	return;
}

void print_position(OBJ_PLAYERSTRUCT *plyr_ptr)
{
//	POLY_FT4			face;
	u8 					text[10];

   if(STATE.gametype==2)//not for time trial
	return;
/*
	if (STATE.arena_mode == FALSE)
	{
		SetPolyFT4(&face);
		SetSemiTrans(&face, 1);

		face.tpage = GetTPage(0, 1, 640, 256);
	    face.clut = GetClut(688, 347);

		face.r0 = 128;
		face.g0 = 128;
		face.b0 = 128;

		face.u0 = 224;
		face.v0 = 92;

		face.u1 = 255;
		face.v1 = 92;

		face.u2 = 224;
		face.v2 = 123;

		face.u3 = 255;
		face.v3 = 123;

	 	face.x0 = -235;
		face.x2 = -235;

		if (STATE.numscreens == 1)
		{
			face.x1 = face.x0 + ((31 * 25) >> 4);
			face.x3 = face.x0 + ((31 * 25) >> 4);

			face.y0 = -80;
			face.y1 = -80;
			face.y2 = -49;
			face.y3 = -49;
		}
		else
		{
		 	face.x1 = -214;
			face.x3 = -214;

			face.y0 = -25;
			face.y1 = -25;
			face.y2 = -9;
			face.y3 = -9;
		}

		GsSortPoly(&face, ptrwot, 0);

		sprintf(text, "%d", plyr_ptr->stats.kills);

		TEXT_x = -210;

		if (STATE.numscreens == 1)
			TEXT_y = -80;
		else
			TEXT_y = -25;

		TEXT_prstrbignum(text, 128, 128, 128);
	}
*/
	sprintf(text, "%d", plyr_ptr->stats.position);

	if (plyr_ptr->stats.position == 1)
		TEXT_x = -215;
	else
		TEXT_x = -230;

	if (STATE.numscreens == 1)
		TEXT_y = -95;
	else
		TEXT_y = -42;

	TEXT_prstrbignum(text, 128, 128, 128);

	sprintf(text, "/%d",  STATE.wankers);

	TEXT_x = -205;

	if (STATE.numscreens == 1)
		TEXT_y = -95;
	else
		TEXT_y = -42;

	TEXT_prstr(text, 128, 128, 128);

/*	sprintf(text, "Frags = %d", plyr_ptr->stats.kills);

	TEXT_x = -230;

	if (STATE.numscreens == 1)
		TEXT_y = -75;
	else
		TEXT_y = -32;

	TEXT_prstr(text, 128, 128, 128);
*/
	return;
}

void display_icon(OBJ_PLAYERSTRUCT *plyr_ptr)
{
	POLY_FT4			face;


    if(STATE.gametype==2)//not for time trial
	return;


	SetPolyFT4(&face);
	SetSemiTrans(&face, 1);

	face.tpage = GetTPage(0, 1, 704, 256);
    face.clut = GetClut(704, 447);

    face.r0 = icon_uv[plyr_ptr->pickups.current][4];
    face.g0 = icon_uv[plyr_ptr->pickups.current][5];
    face.b0 = icon_uv[plyr_ptr->pickups.current][6];

    face.u0 = icon_uv[icons[plyr_ptr->pobj->index].type][0];
    face.v0 = icon_uv[icons[plyr_ptr->pobj->index].type][1];

    face.u1 = icon_uv[icons[plyr_ptr->pobj->index].type][2];
    face.v1 = icon_uv[icons[plyr_ptr->pobj->index].type][1];

    face.u2 = icon_uv[icons[plyr_ptr->pobj->index].type][0];
    face.v2 = icon_uv[icons[plyr_ptr->pobj->index].type][3];

    face.u3 = icon_uv[icons[plyr_ptr->pobj->index].type][2];
    face.v3 = icon_uv[icons[plyr_ptr->pobj->index].type][3];

	face.x0 = 179;
	face.y0 = -112 / STATE.numscreens;

	face.x1 = 239;
	face.y1 = -112 / STATE.numscreens;

	face.x2 = 179;
	face.y2 = face.y0 + 32;

	face.x3 = 239;
	face.y3 = face.y1 + 32;

	GsSortPoly(&face, ptrwot, 0);

	return;
}

void display_graphics(void)
{
	POLY_FT4		face;
	POLY_G4			line;


// Horizontal Line

	SetPolyG4(&line);
	SetSemiTrans(&line, 1);

	line.r0 = 128;//192;
	line.g0 = 128;//96;
	line.b0 = 0;

	line.r1 = 0;
	line.g1 = 0;
	line.b1 = 0;

	line.r2 = 128;//192;
	line.g2 = 128;//96;
	line.b2 = 0;

	line.r3 = 0;
	line.g3 = 0;
	line.b3 = 0;

 	line.x0 = -227;
	line.y0 = -112 / STATE.numscreens;

	line.x1 = 240;
	line.y1 = -112 / STATE.numscreens;

	line.x2 = -227;
	line.y2 = -110 / STATE.numscreens;

	line.x3 = 240;
	line.y3 = -110 / STATE.numscreens;

	GsSortPoly(&line, ptrwot, 0);

//Vertical line
 	line.x0 = 238;
	line.y0 = 105 / STATE.numscreens;

	line.x1 = 238;
	line.y1 = -112 / STATE.numscreens;

	line.x2 = 240;
	line.y2 = 105 / STATE.numscreens;

	line.x3 = 240;
	line.y3 = -112 / STATE.numscreens;

	GsSortPoly(&line, ptrwot, 0);

//Second shorter horizontal line - by lap text

	line.r1 = line.r0;//128;
	line.g1 = line.g0;//128;
	line.b1 = line.b0;//128;

	line.r3 = line.r2;//128;
	line.g3 = line.g2;//128;
	line.b3 = line.b2;//128;

 	line.x0 = -227;
	line.x2 = -227;

	if (STATE.arena_mode == TRUE)
	{
		line.x1 = -150;
		line.x3 = -150;
	}
	else
	{
		line.x1 = -180;
		line.x3 = -180;
	}

	if (STATE.numscreens == 1)
	{
		line.y0 = -98;
		line.y1 = -98;
		line.y2 = -96;
		line.y3 = -96;
	}
	else
	{
		line.y0 = -46;
		line.y1 = -46;
		line.y2 = -45;
		line.y3 = -45;
	}

	GsSortPoly(&line, ptrwot, 0);

//Third horizontal line at bottom of screen	- cannon bar

 	line.x0 = 184;
	line.y0 = 110 / STATE.numscreens;

	line.x1 = 232;
	line.y1 = 110 / STATE.numscreens;

	line.x2 = 184;
	line.y2 = 112 / STATE.numscreens;

	line.x3 = 232;
	line.y3 = 112 / STATE.numscreens;

	GsSortPoly(&line, ptrwot, 0);

//Third horizontal line at bottom of screen - life indicator

 	line.x0 = 184;
	line.y0 = 90 / STATE.numscreens;

	line.x1 = 237;
	line.y1 = 90 / STATE.numscreens;

	line.x2 = 184;
	line.y2 = 92 / STATE.numscreens;

	line.x3 = 237;
	line.y3 = 92 / STATE.numscreens;

	GsSortPoly(&line, ptrwot, 0);

//Corner sections of lines

//bottom left corner of lap text outline.

	SetPolyFT4(&face);
	SetSemiTrans(&face, 1);

	face.tpage = GetTPage(0, 1, 704, 256);
    face.clut = GetClut(752, 445);

	face.r0 = 64;//128;//64;
	face.g0 = 64;//64;//64;
	face.b0 = 0;//64;

	face.u0 = 200;
	face.v0 = 176;

	face.u1 = 207;
	face.v1 = 176;

	face.u2 = 200;
	face.v2 = 184;

	face.u3 = 207;
	face.v3 = 184;

 	face.x0 = -235;
	face.x1 = -227;
	face.x2 = -235;
	face.x3 = -227;

	if (STATE.numscreens == 1)
	{
		face.y0 = -105;
		face.y1 = -105;
		face.y2 = -96;
		face.y3 = -96;
	}
	else
	{
		face.y0 = -50;
		face.y1 = -50;
		face.y2 = -45;
		face.y3 = -45;
	}

	GsSortPoly(&face, ptrwot, 0);

//Bottom left corner of cannon power bar

 	face.x0 = 174;
	face.y0 = 104 / STATE.numscreens;

	face.x1 = 184;
	face.y1 = 104 / STATE.numscreens;

	face.x2 = 174;
	face.y2 = 112 / STATE.numscreens;

	face.x3 = 184;
	face.y3 = 112 / STATE.numscreens;

	GsSortPoly(&face, ptrwot, 0);

//Bottom left corner of craft armour bar

 	face.x0 = 174;
	face.y0 = 84 / STATE.numscreens;

	face.x1 = 184;
	face.y1 = 84 / STATE.numscreens;

	face.x2 = 174;
	face.y2 = 92 / STATE.numscreens;

	face.x3 = 184;
	face.y3 = 92 / STATE.numscreens;

	GsSortPoly(&face, ptrwot, 0);

//top left corner of lap text outline.

	face.u0 = 200;
	face.v0 = 176;

	face.u1 = 207;
	face.v1 = 176;

	face.u2 = 200;
	face.v2 = 183;

	face.u3 = 207;
	face.v3 = 183;

 	face.x0 = -235;

	if (STATE.numscreens == 1)
	{
		face.y0 = -105;
		face.y1 = -105;
	}
	else
	{
		face.y0 = -50;
		face.y1 = -50;
	}

	face.x1 = -227;

	face.x2 = -235;
	face.y2 = -112 / STATE.numscreens;

	face.x3 = -227;
	face.y3 = -112 / STATE.numscreens;

 	GsSortPoly(&face, ptrwot, 0);

//bottom right corner of cannon power bar

	face.u0 = 207;
	face.v0 = 176;

	face.u1 = 207;
	face.v1 = 184;

	face.u2 = 199;
	face.v2 = 176;

	face.u3 = 199;
	face.v3 = 184;

 	face.x0 = 232;
	face.y0 = 105 / STATE.numscreens;

	face.x1 = 240;
	face.y1 = 105 / STATE.numscreens;

	face.x2 = 232;
	face.y2 = 112 / STATE.numscreens;

	face.x3 = 240;
	face.y3 = 112 / STATE.numscreens;

 	GsSortPoly(&face, ptrwot, 0);

//bottom right corner of craft armour bar
/*
	face.u0 = 207;
	face.v0 = 176;

	face.u1 = 207;
	face.v1 = 184;

	face.u2 = 199;
	face.v2 = 176;

	face.u3 = 199;
	face.v3 = 184;

 	face.x0 = 232;
	face.y0 = 85 / STATE.numscreens;

	face.x1 = 240;
	face.y1 = 85 / STATE.numscreens;

	face.x2 = 232;
	face.y2 = 92 / STATE.numscreens;

	face.x3 = 240;
	face.y3 = 92 / STATE.numscreens;

 	GsSortPoly(&face, ptrwot, 0);
*/
//bottom right corner of lap time text

	face.y0 = -103 / STATE.numscreens;
	face.y1 = -103 / STATE.numscreens;
	face.y2 = -96 / STATE.numscreens;
	face.y3 = -96 / STATE.numscreens;

	if (STATE.arena_mode == TRUE)
	{
	 	face.x0 = -150;
		face.x1 = -142;
		face.x2 = -150;
		face.x3 = -142;
	}
	else
	{
	 	face.x0 = -180;
		face.x1 = -172;
		face.x2 = -180;
		face.x3 = -172;
	}

	if (STATE.numscreens == 1)
	{
		face.y0 = -105;
		face.y1 = -105;
		face.y2 = -96;
		face.y3 = -96;
	}
	else
	{
		face.y0 = -50;
		face.y1 = -50;
		face.y2 = -45;
		face.y3 = -45;
	}
 	GsSortPoly(&face, ptrwot, 0);

	return;
}

void print_speed(OBJ_PLAYERSTRUCT *plyr_ptr)
{
	u8 		text[5];
	int		speed;


#if PAL
	speed = plyr_ptr->speed - (plyr_ptr->speed >> 2);
	
	sprintf(text, "%d", speed);

	TEXT_x = -240;
	TEXT_y = 100 / STATE.numscreens;
	TEXT_prstrbignum(text, 128, 128, 128);

	sprintf(text, "kph");

	TEXT_x = -160;
	TEXT_y = 100 / STATE.numscreens;
	TEXT_prstr(text, 128, 128, 128);

#else //ntsc

	sprintf(text, "%d", speed);

	TEXT_x = -240;
	TEXT_y = 70 / STATE.numscreens;
	TEXT_prstrbignum(text, 128, 128, 128);

	sprintf(text, "kph");

	TEXT_x = -160;
	TEXT_y = 70 / STATE.numscreens;
	TEXT_prstr(text, 128, 128, 128);

#endif
	return;
}
/*
void PSX_display_cannon_icon(OBJ_PLAYERSTRUCT *plyr_ptr)
{
	POLY_FT4				face;
	POLY_FT4				background;
	unsigned short			clut[256];
	int						i, keyd_out, power_level;


	power_level = plyr_ptr->ammo / 150;
	keyd_out = ((32 << 5) + 32) << 5;

	for (i = 0; i < (30 - power_level); i++)
		clut[i] = keyd_out;

	for (i = (30 - power_level); i < 30; i++)
		clut[i] = 32768 + ((31 - i) << 10) + ((31 - i) << 5) + (31 - i);;

	for (i = 30; i < 256; i++)
		clut[i] = keyd_out;

//	LoadClut((unsigned long *)&clut, 768, 374);

	SetPolyFT4(&face);
	SetSemiTrans(&face, 1);

	face.r0 = 64;
	face.g0 = 64;
	face.b0 = 64;

	face.tpage = GetTPage(1, 1, 640, 256);
	face.clut = GetClut(768, 374);

	face.u0 = 0;
	face.v0 = 223;

	face.u1 = 31;
	face.v1 = 223;

	face.u2 = 0;
	face.v2 = 255;

	face.u3 = 31;
	face.v3 = 255;

	face.x0 = 194;
	face.y0 = 80;

	face.x1 = 194 + ((31 * 25) >> 4);
	face.y1 = 80;

	face.x2 = 194;
	face.y2 = 111;

	face.x3 = 194 + ((31 * 25) >> 4);
	face.y3 = 111;

//	GsSortPoly(&face, ptrwot, 0);

//background

	SetPolyFT4(&background);
	SetSemiTrans(&background, 1);

	background.r0 = 164;//255;//128;//64;
	background.g0 = 164;//255;//128;//64;
	background.b0 = 164;//255;//128;//255;

	background.tpage = GetTPage(0, 2, 640, 256);
	background.clut = GetClut(752, 447);

	background.u0 = 64;
	background.v0 = 223;

	background.u1 = 96;
	background.v1 = 223;

	background.u2 = 64;
	background.v2 = 255;

	background.u3 = 96;
	background.v3 = 255;

	background.x0 = 194;
	background.y0 = 80;

	background.x1 = 194 + ((31 * 25) >> 4);
	background.y1 = 80;

	background.x2 = 194;
	background.y2 = 111;

	background.x3 = 194 + ((31 * 25) >> 4);
	background.y3 = 111;

//	GsSortPoly(&background, ptrwot, 0);

//	display_lines();

//	GsSortPoly(&face, ptrwot, 0);

	return;
}

void set_line(void)
{

	short				angle, angle_inc;
	int					i, j, radius;


	for (j = 0; j < 2; j++)
	{
		for (i = 0; i < MAX_LINE_SEGS; i++)
		{
			SetLineF4(&line[j][i]);
	//		SetSemiTrans(&line[i], 1);

			line[j][i].r0 = i * 30;
			line[j][i].g0 = i * 30;
			line[j][i].b0 = i * 30;
		}

		angle = 0;
		angle_inc = 4096 / (MAX_LINE_SEGS * 3);
		radius = 50;

		for (i = 0; i < MAX_LINE_SEGS; i++)
		{
			line[j][i].x0 = (radius * rsin(angle)) >> 12;
			line[j][i].y0 = (radius * rcos(angle)) >> 12;

			angle += angle_inc;

			line[j][i].x1 = (radius * rsin(angle)) >> 12;
			line[j][i].y1 = (radius * rcos(angle)) >> 12;

			angle += angle_inc;

			line[j][i].x2 = (radius * rsin(angle)) >> 12;
			line[j][i].y2 = (radius * rcos(angle)) >> 12;

			angle += angle_inc;

			line[j][i].x3 = (radius * rsin(angle)) >> 12;
			line[j][i].y3 = (radius * rcos(angle)) >> 12;
		}

		for (i = 0; i < MAX_LINE_SEGS; i++)
		{
			line[j][i].x0 = (line[j][i].x0 * 30) / 20;
			line[j][i].x1 = (line[j][i].x1 * 30) / 20;
			line[j][i].x2 = (line[j][i].x2 * 30) / 20;
			line[j][i].x3 = (line[j][i].x3 * 30) / 20;
		}
	}

	return;
}

void display_lines(void)
{
	int 			i;
	POLY_F4			face;


	SetPolyF4(&face);

	face.r0 = 64;
	face.g0 = 64;
	face.b0 = 255;

	face.x0 = -50;
	face.y0 = -50;

	face.x1 = face.x0 + (100 * 1.5);
	face.y1 = -50;

	face.x2 = -50;
	face.y2 = 50;

	face.x3 = face.x2 + (100 * 1.5);
	face.y3 = 50;

	GsSortPoly(&face, ptrwot, 0);

	for (i = 0; i < MAX_LINE_SEGS; i++)
		AddPrim(&zsorttable[outbuf_idx][0], &line[outbuf_idx][i]);

	return;
}




*/