//PSX_pcks.h 
//Ian Tomkins

//#include "PSX_libs.h"
/*
typedef struct 
{
	int			index;
	int			type;
	int			radius;
	int			offset;

}FLARE_POS;
*//*
typedef struct 
{
	int			type;
	int			scale;
	int			loc;
	
	char		r;
	char		g;
	char		b;


//	POLY_FT4	faces[MAX_LENS_FLARES];

//	SVECTOR		origin;
//	SVECTOR		lens_pos;

//	FLARE_POS	flares[MAX_LENS_FLARES];	

}LENS_FLARE;
*/
enum
{
	rainbow,
	flat, 
	diminishing,
	tiny, 
	light_source
};

typedef struct
{
	POLY_GT3	faces[MAX_SHIELD_SIDES];
	SVECTOR		coord[MAX_SHIELD_SIDES * 3];
			
	VECTOR		origin;
	SVECTOR		orientation;
	SVECTOR		craft_orientation;
	s32			vector_length;

	s8			index;
	s8			in_use;
	s32			owner;
	s32			object;
	s32			timer;

}SHIELD_FX;

/*typedef struct
{
	POLY_FT4	face;
	SVECTOR		coord[4];

	s8			in_use;
	s8			index;
	s32			owner;

}BURST_FX;
*/
typedef struct
{
	POLY_FT4	face;

	SVECTOR		origin;
	SVECTOR		pulse_origin;

	SVECTOR		rotation;

	s8			index;
	s8			in_use;

	s8			pulse_id;
	
	s8			in_use_x;
	s8			in_use_y;

	s16			position_x;
	s16			position_y;

	s32			velocity_x;
	s32			velocity_y;

	s8			dir_x;
	s8			dir_y;

	s16			length;

	SVECTOR		rot_vec;
	
}PLASMA_PKT;	

typedef struct
{
	s8			index;
	s8			in_use;

	s16			decay;
	s16			velocity;
	s16			amplitude;
	s8			direction;
	s16			origin;
	s16			position;

	s16			rotation;
	s16			rot_inc;

	s16			rot_val;
	s16			rot_inc_val;
	s16			rot_sign;

}PLASMA_PULSE;

typedef struct
{
	POLY_GT4		face;
	PLASMA_PKT		section[MAX_PLASMA_SECTIONS];
	PLASMA_PULSE	pulse[MAX_PLASMA_PULSES];

	vec16			origin;
	vec16			rotation;
	s8				in_use;
	s8				index;
	s16				flag;

}PLASMA_STREAM;

typedef struct {

	POLY_FT4		face;
	s32				radius;

}PLASMA_ORB;

typedef struct {

	s8				index;
	s8				in_use;
	s8				state;
	s8				pad;
	s32				owner;
	s32				target_id;

	s32				timer;	
	s16				transform_timer;
	s16				end_point;
		
	vec16			origin;
	vec16			offset;
	vec16			rotation;

	s32				velocity;

	PLASMA_ORB		orb;
	PLASMA_STREAM	stream[2];

}PLASMA_WEAPON;

typedef struct 
{
	s8		in_use;
	
	s8		type;
	s8		old_type;
	s8		player_no;
	s8		timer;

	s16		x_pos;
	s16		y_pos;

	s16		size;	

}ICON_STRUCT;

/*typedef struct
{
	POLY_GT4	face;
	s8		in_use;

	s8		valr;
	s8		valg;

	s8		flag;
	
	s8		player_no;
	s16		height;
	s16		ammo;
	s16		old_ammo;

}CANNON_ICON;
*/

typedef struct 
{
	POLY_FT4	trail[4];
	SVECTOR		coord[5];

	int			in_use;
	int			index;

	int			no_segs;
	int			timer;

}TRAIL_STRUCT;

enum {
	
//	missile_trail,
	flame,
	ion,
	flare_smoke,
	explosion,
	gas,
	cluster_exp

};

enum {

active,
tracking,
attack

};

enum	{

pck_torpedo,
pck_rocket,
pck_missile,
pck_mine,
pck_shield,
pck_cluster,
pck_flame,
pck_ion,
pck_plasma,
pck_flare,
pck_gas,
pck_turbo,
pck_cannon,
bullet_explosion,
craft_flames,
missile_trail,
cluster_explosion,
fragment_explosion,
mine_explosion,
rocket_explosion,
torpedo_explosion,
lava_steam,
flare_trail,
craft_explosion

};

extern	u8					icon_uv[MAX_ICONS][7];

extern	SVECTOR				shield_coord[MAX_SHIELD_SEGMENTS * 4];

extern	SHIELD_FX			PCK_shields[MAX_SHIELDS];
//extern	BURST_FX			PCK_bursts[MAX_BURSTS];
extern	PLASMA_WEAPON		PSX_plasma[MAX_PLASMAS];

extern  ICON_STRUCT			icons[MAXNUMPLAYERS];
//extern	CANNON_ICON			cannon_icons[MAXNUMPLAYERS];
//extern	LENS_FLARE			flare[MAX_LENS_FLARES];

extern TRAIL_STRUCT			PSX_rocket_trail[MAX_ROCKET_TRAILS];

void PSX_init_shield_effect(OBJ_PLAYERSTRUCT *plyr_ptr, vec32 *init_point);
void PSX_process_shield_effect(SHIELD_FX *fx_ptr);
//void PSX_init_burst_effect(OBJ_STRUCT *obj_ptr);
void PSX_process_burst_effect(OBJ_STRUCT *obj_ptr);
void PSX_process_plasma_stream(PLASMA_WEAPON *ptr, OBJ_STRUCT *obj_ptr);
s32 PSX_init_plasma_weapon(OBJ_PLAYERSTRUCT *obj_ptr);

//void PSX_init_gas_cloud(OBJ_STRUCT *obj_ptr);
//void PSX_process_gas_cloud(OBJ_STRUCT *obj_ptr);

void PSX_init_shield_structs(void);
void PSX_init_burst_structs(void);

//s8	 PSX_init_explosion(OBJ_STRUCT *obj_ptr, int flag, int scale_flag);
void PCK_process_ion_gun(OBJ_STRUCT *obj_ptr);
//void PSX_bullets(void);
void PSX_init_shield(void);
void PSX_process_shield(OBJ_STRUCT *obj_ptr);

void init_icon_struct(void);
//void display_cannon_power_level(OBJ_PLAYERSTRUCT *plyr_ptr);
//void display_pickup_icon(OBJ_PLAYERSTRUCT *plyr_ptr);
void display_backmarker(OBJ_PLAYERSTRUCT *plyr_ptr);

//void PSX_fire_fx(void);

//void PSX_display_lens_flare(void);
//void PSX_init_lens_flare(void);

s32 PSX_init_rocket_trail(OBJ_STRUCT *obj_ptr);
void PSX_process_rocket_trail(OBJ_STRUCT *obj_ptr);
void allocate_player_pickups(OBJ_PLAYERSTRUCT *plyr_ptr);

void PSX_process_tracer(OBJ_STRUCT *obj_ptr);



//void DEBUG_DrawFunction=0x300+PCTabIndex;

//FLAMER

typedef struct
{
	SVECTOR			origin;
	SVECTOR			current_pos;
	SVECTOR			rotation;

	s8				index;
	s8				in_use;
	s32				owner;

	s8				finished;

	s16				first_flame;
	s16				latest_flame;

	s16				fuel_level;
	
	s16				ang_diff;

}FLAMER_CTRL_STRUCT;

typedef struct
{
	SVECTOR			rotation;
	SVECTOR			position;
	SVECTOR			craft_vel;

	s32				velocity;

	s32				size_scaler;

	u8				r;
	u8				g;
	u8				b;

	s8				uv_index;

	s8				delay;
	s8				update;
	s8				increment;

	s32				timer;
	s8				end_point;
	s8				smoke_flag;

	s8				in_use;
	s32				index;

	s32				owner;

	s16				next_flame;
	s16				prev_flame;
	
}FLAMER_FLAME_ANIM;

extern	FLAMER_FLAME_ANIM   	PSX_flamer_flames[MAX_FLAMER_FLAMES];		  
extern	FLAMER_CTRL_STRUCT		PSX_flamers[MAX_FLAMERS];

s32 PSX_init_flamer(OBJ_PLAYERSTRUCT *plyr_ptr);
void PSX_process_flamer(FLAMER_CTRL_STRUCT *ctrl_ptr);

//END OF FLAMER

//GAS CLOUD

typedef struct
{
	SVECTOR			origin;
	SVECTOR			current_pos;
	SVECTOR			rotation;

	s8				index;
	s8				in_use;
	s32				owner;
	s32				obj_index;
	s16				timer;

	s8				finished;

	s16				first_flame;
	s16				latest_flame;

	s16				fuel_level;
	
	s16				ang_diff;

}GAS_CTRL_STRUCT;

typedef struct
{
	SVECTOR			rotation;
	SVECTOR			position;
	SVECTOR			craft_vel;

	s32				velocity;

	s32				size_scaler;

	u8				r;
	u8				g;
	u8				b;

	s8				uv_index;

	s8				delay;
	s8				update;
	s8				increment;

	s32				timer;
	s8				end_point;
	s8				smoke_flag;

	s8				in_use;
	s32				index;

	s32				owner;

	s16				next_flame;
	s16				prev_flame;
	
}GAS_FLAME_ANIM;

extern	GAS_FLAME_ANIM   	PSX_gas_flames[MAX_GAS_FLAMES];		  
extern	GAS_CTRL_STRUCT		PSX_gas[MAX_GAS_CLOUDS];

s32 PSX_init_gas_cloud(OBJ_STRUCT *plyr_ptr);
void PSX_process_gas_cloud(GAS_CTRL_STRUCT *ctrl_ptr);

//END OF GAS CLOUD

//TORPEDO WAKE

/*typedef struct
{
	SVECTOR				trail[6];

	s8					in_use;
	s8					index;

	s16					no_segs;
	s16					timer;
	
}WAKE_STRUCT;


extern WAKE_STRUCT				PSX_torpedo_wake[MAX_TORPEDO_WAKES];

void PSX_init_torpedo_wake(OBJ_STRUCT *obj_ptr);
void PSX_process_wake(WAKE_STRUCT *ptr, OBJ_STRUCT *obj_ptr);

*/
//END OF TORPEDO WAKE

//SPLASH - 3D

typedef struct 
{
	POLY_GT4		segs[MAX_SPLASH_SEGMENTS];
	SVECTOR			origin;

	int				type;
	short			in_use;
	short			index;

	int				inner_radius;
	int				outer_radius;

	int				timer;
	int				height;
	
	int 			direction;
	int				velocity;

	int				no_droplets;

	int				floor_index;
	int				inner_index;

}SPLASH_3D;

typedef struct 
{
	POLY_GT4		inner_segs[MAX_SPLASH_SEGMENTS];
	SVECTOR			origin;

	short			in_use;
	short			index;

	int				inner_radius;
	int				outer_radius;
	int				height;
	int 			direction;
	int				velocity;

	int				timer;

}INNER_SPLASH_3D;

typedef struct 
{
	POLY_GT4		floor_segs[MAX_SPLASH_FLOOR_SEGMENTS];
	SVECTOR			origin;

	short			in_use;
	short			index;

	int				timer;

	int				floor_radius;
	int				floor_height;
	int				floor_direction;

}FLOOR_SPLASH_3D;


typedef struct
{
	POLY_FT4		face;
	SVECTOR			position;
	SVECTOR			velocity;

	int				floor_height;			
	int				length;
	
	int				in_use;
	int				index;

}DROPLET_STRUCT;

typedef struct
{
	POLY_FT4		face;
	SVECTOR			position;
			
	int				length;
	int				length_inc;
	int				timer;

	int				in_use;
	int				index;

}RIPPLE_STRUCT;

enum
{
	torpedo_splash,
	torpedo_exp_splash,
	mine_splash,
	mine_exp_splash

};

enum
{
	water,
	fragment

};

extern SPLASH_3D				PSX_splash[MAX_SPLASHES];
extern INNER_SPLASH_3D			PSX_inner_splash[MAX_SPLASHES];
extern FLOOR_SPLASH_3D			PSX_floor_splash[MAX_SPLASHES];

extern DROPLET_STRUCT			PSX_droplet[MAX_DROPLETS];
extern RIPPLE_STRUCT			PSX_ripple[MAX_RIPPLES];

void PSX_init_splash(OBJ_STRUCT *obj_ptr, int type);

void PSX_process_splash(SPLASH_3D *ptr);
void PSX_process_inner_splash(INNER_SPLASH_3D *ptr);
void PSX_process_distortion(FLOOR_SPLASH_3D *ptr);

void PSX_init_droplet(SPLASH_3D *ptr, int type);
void PSX_process_droplet(DROPLET_STRUCT *ptr);

void PSX_init_ripple(DROPLET_STRUCT *ptr);
void PSX_process_ripple(RIPPLE_STRUCT *ptr);

//END OF SPLASH -3D	
		
//ON SCREEN GRAPHICS
//END OF ON SCREEN GRAPHICS
	
//PICKUP OBJECTS

void PSX_display_pickup_icon(OBJ_STRUCT *obj_ptr);

//END OF PICKUP OBJECTS
	

//void screen_flash(u8 r, u8 g, u8 b, u8 timer);

//DEBUGGING TOOL
void display_vector(SVECTOR before, SVECTOR after, u8 red, u8 green, u8 blue);
void display_direction(s8 pad_val);
s32	find_height(OBJ_STRUCT *obj_ptr);

s8 clip_point_short(vec16 *ptr, int index);
s8 clip_point_long(vec32 *ptr, int index);




void PSX_process_plasma_weapon(PLASMA_WEAPON *ptr, OBJ_STRUCT *obj_ptr);
