#include <sys/types.h>
#include <libsn.h>
#include <libsnd.h>
#include <libspu.h>
#include <libcd.h>
#include <libgte.h>
#include <libgpu.h>
#include <abs.h>
#include "..\header.h"
#include "..\objects.h"
#include "mathPSX.h"
#include "..\camera.h"
#include "soundPSX.h"
#include "..\state.h"
#include "..\cdlib.h"
#include "..\menu.h"

#if CDMASTER
#define  READCD   1
#define  READPC   0
#else
#define  READCD   0
#define  READPC   1
#endif

#if READPC
// !! This needs to be in a file without .c extension !!
#include "..\cdname.def"
#endif

#if READCD
#include "..\fileaddr.h"
#endif


///////////////////////////////////////////////////////////////////////////////////////////////
//    360 sound system MAXNUMSFXOBJ
///////////////////////////////////////////////////////////////////////////////////////////////
//    Started:    15/10/'98
//    Geeza:      Poomdakka-suk
//		PSX:			Yay
//    N64:        No.
//    Notes:      Doppler fx, stereo 3d delay(?),volume. Dynamic loudness management.
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Global
///////////////////////////////////////////////////////////////////////////////////////////////

extern   u8     *temp;             // for textures. use union to share
s32      SOUND_cdtrack=1;
s32      SOUND_tottracks;

///////////////////////////////////////////////////////////////////////////////////////////////
// Locals
///////////////////////////////////////////////////////////////////////////////////////////////

/** cd related **/
// Mat: 22/03/1999
/*
CdlLOC	loc[100];
u_char	param[4], result[8];
s32  		tracks, current_track;
u_char	p_com;			// previous command
*/
//////////////////
s16   vab1;    /* vab data id */

u8    status[24];
u8    chsfx[24];
vec32 ear;

#define  SFXTdoppler ( 1<<0 )
#define  SFX3dsound  ( 1<<1 )
#define  SFXrepeat   ( 1<<2 )
#define  SFXunique   ( 1<<3 )

//SFXINFOSTRUCT  sfxinfo[256]={
//   {"moo", 36,120, SFX3dsound+SFXTdoppler},   //engine
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 31,120, SFX3dsound},
//   {"moo", 48,120, SFX3dsound},
//   {"moo", 53,127, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound+SFXTdoppler},   //explosion
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, SFX3dsound},
//   {"moo", 36,120, 7},
//   {"moo", 36,120, 7},
//   {"moo", 36,120, 0},   {"moo", 36,120,7},   {"moo", 36,120,7},   {"moo", 36,120,7},
//   {"moo", 36,120, 7},   {"moo", 36,120,7},   {"moo", 36,120,7},   {"moo", 36,120,7},
//   {"moo", 36,120, 7},   {"moo", 36,120,7},   {"moo", 36,120,7},   {"moo", 36,120,7}
//};


//SFXOBJSTRUCT sfxobj[MAXNUMSFXOBJ];
//s32   SOUND_age[MAXNUMSFXOBJ];// -1 not in play, else the age in frames of sfx
                              //

///////////////////////////////////////////////////////////////////////////////////////////////
// functions
///////////////////////////////////////////////////////////////////////////////////////////////
s32   thr=0;
vec32 ear, earv;

void  SOUND_update()
   {
   /*
   s16   f, g;
   s32   thrpitch, ang, dist, voll, volr, wang, dop, unit256x, unit256z;
   vec32 v0,pos, diff;
   vec32 source, sourcev;

   // examine stat of all channels
   SpuGetAllKeysStatus( status );

   // set up ears position and velocity
   if( CAM_cammode[0]==5 )
      {
      // panning camera
      ear.vx =  CAM_camp[0].vx;
      ear.vz =  CAM_camp[0].vz;
      earv.vx=  0;
      earv.vz=  0;
      }
   else
      {
      // 3rd person camera
      ear.vx =  OBJ_objects[CAM_obj[0]].p.vx >> 8;//assuming obj[0]is you
      ear.vz =  OBJ_objects[CAM_obj[0]].p.vz >> 8;
      earv.vx=  OBJ_objects[CAM_obj[0]].v.vx >> 8;
      earv.vz=  OBJ_objects[CAM_obj[0]].v.vz >> 8;
      }

   // monitor each sound object
   for(f=0;f<MAXNUMSFXOBJ;f++)
      {
      if( sfxobj[f].stat==OFF )continue;

      // check distance
      if( sfxobj[f].ownerobj != -1 )
         {
         source.vx   =  OBJ_objects[ sfxobj[f].ownerobj ].p.vx >> 8;
         source.vz   =  OBJ_objects[ sfxobj[f].ownerobj ].p.vz >> 8;
         sourcev.vx  =  OBJ_objects[ sfxobj[f].ownerobj ].v.vx >> 8;
         sourcev.vz  =  OBJ_objects[ sfxobj[f].ownerobj ].v.vz >> 8;
         }
      else
         {
         source.vx   = sfxobj[f].px;
         source.vz   = sfxobj[f].pz;
         sourcev.vx   = 0;
         sourcev.vz   = 0;
         }

      pos.vx   =   source.vx - ear.vx;
      pos.vz   =   source.vz - ear.vz;
      dist  =  127-(vqlen2( pos.vx, pos.vz )>>7);
      sfxobj[f].dist =  dist;
      //dist=127;
      if( sfxobj[f].chan != -1 )
         {
         // temp sfxobj finished?
         if( status[ sfxobj[f].chan ]!=SPU_ON )
            {
            sfxobj[f].stat = OFF;
            //sprintf( debbuf, "sfx obj %d killed", f );
            //RENDER_message( debbuf );
            continue;
            }
         }

      if( dist>0)
         {
         // in range
         if( sfxobj[f].chan == -1 )
            {
            // does sfx exist?

            // No chan assigned. find free chan and start sample
            for(g=0;g<24;g++)if(status[g]!=SPU_ON)break;
            if( g==24 )
               {
               //RENDER_message( "chan search fail" );
               continue;
               }
            SsUtKeyOnV( g, vab1,sfxobj[f].sfxnum,0,36,0,10,10 );
            status[g]   =  ON;
            //sprintf( debbuf, "open chan %d, for obj %d", g, f );
            //RENDER_message( debbuf );
            sfxobj[f].chan = g;
            }

         // adjust L/R volume
         if( ( (pos.vx == 0) && (pos.vz == 0) ) ||
             ( (sfxinfo[ sfxobj[f].type ].typeflags&SFX3dsound)==0) )
            {
            voll = sfxobj[f].vol>>1;
            volr = sfxobj[f].vol>>1;
            //RENDER_message( "SFX in ear" );
            }
         else
            {
            wang  =  vatan2( pos.vx, pos.vz );// 0,0 ?
            ang   =  wang  +  (CAM_came[0].vy>>4);// ang rel to cam
            ang   += 16384;
            ang   =  ang&4095;// norm ang
            if(ang>2048)ang   =  ang-4096;
            if(ang>1024)ang   =  2048-ang;
            if(ang<-1024)ang  =  -2048-ang;

            voll  =  ((((64+(ang>>5))*dist)>>7)*sfxobj[f].vol)>>8;
            if(voll<=0)voll=0;
            if(voll>127)voll=127;//clamp

            volr  =  ((((64-(ang>>5))*dist)>>7)*sfxobj[f].vol)>>8;
            if(volr<=0)volr=0;
            if(volr>127)volr=127;//clamp
            }

         SsUtSetVVol( sfxobj[f].chan, voll, volr );

         // doppler
         if( sfxinfo[ sfxobj[f].type ].typeflags & SFXTdoppler )
            {
            diff.vx  =  sourcev.vx - earv.vx;
            diff.vz  =  sourcev.vz - earv.vz;
            unit256x =  -rsin( wang )>>4; //for delay/doppler
            unit256z =  -rcos( wang )>>4;
            dop   =  (unit256x*diff.vx  +  unit256z*diff.vz)>>9;
            if(dop<-64)dop=-64;
            if(dop>63)dop=63;
            SsUtPitchBend( sfxobj[f].chan, vab1, 0, 0, 64+dop);//if dopp
            }
         }
      else
         {
         // out of range
         // remove it ?
         if(   sfxinfo[ sfxobj[f].type ].typeflags&SFXrepeat ==0 )
               sfxobj[f].stat==OFF;
         }
      }

// sound for you ch0
   vmov( &v0, &OBJ_objects[0].v );
   v0.vx =  v0.vx>>3;
   v0.vy =  v0.vy>>3;
   v0.vz =  v0.vz>>3;
	vsquare32( &v0, &v0 );
   thrpitch  =  6144+ ((vroot32( v0.vx + v0.vy + v0.vz )) >>1 );
   if(thrpitch>7424)thrpitch=7424;
   if( thrpitch>thr )
      {
      thr+=80;
      if( thrpitch<thr )
         thr   =  thrpitch;
      }

   if( thrpitch<thr )
      {
      thr-=20;
      if( thrpitch>thr )
         thr   =  thrpitch;
      }

   //thr  =  OBJ_players[0].throttle<<5;
   //if( status[0]==0 )
   //   {//init repeating sound
   //   SsUtKeyOnV(0,vab1,0,0,26,0,60,60);
   //   }
   //SsUtChangePitch( 0, vab1, 0, 26,0, thr>>7, thr&127 );
   SsUtChangePitch( 0, vab1, 0, 36,0, thr>>7, thr&127 );
// sound for you ch1
   */
   }

s16  SOUND_exist( u8 sfxnum )
   {
   /*
   s16   f;

   for(f=0;f<24;f++)
      if( status[f]==1 )
         if( chsfx[f]==sfxnum )
            return 1;

   return 0;
   */

   return 0;
   }

s16  SOUND_sfx( u8 sfxnum )
   {
   //s16   a;
   //a  =SsUtKeyOn( vab1, sfxnum, 0,sfxinfo[sfxnum].pitch,0,sfxinfo[sfxnum].vol,sfxinfo[sfxnum].vol );
   //chsfx[a] =  sfxnum;
   //return a;

   return 0;
   }

s16  SOUND_sfx_p( u8 sfxnum, u8 p )
   {
   //s16   a;
   //a  =SsUtKeyOn( vab1, sfxnum, 0,p,0,sfxinfo[sfxnum].vol,sfxinfo[sfxnum].vol );
   //chsfx[a] =  sfxnum;
   //return a;

   return 0;
   }

s16  SOUND_sfx_dynamic( u8 sfxnum, u16 object, u8 vol )
   {
   /*
   s16   f;

   for(f=0;f<MAXNUMSFXOBJ;f++)if( sfxobj[f].stat!=ON)break;

   if( f==MAXNUMSFXOBJ )
      {
      //RENDER_message( "could not init dynamic SFX" );
      //return   -1;
      }
   else
      {
      //sprintf( debbuf, " sfx dynamic created obj %d",f  );
      //RENDER_message( debbuf );

      sfxobj[ f ].stat     =  ON;                  //ON/OFF
      sfxobj[ f ].sfxnum   =  sfxnum;              //prog from VAB
      sfxobj[ f ].pitchH   =  sfxinfo[ sfxnum ].pitch;   //pitch
      sfxobj[ f ].pitchL   =  0;
      sfxobj[ f ].vol      =  vol;
      sfxobj[ f ].type     =  sfxnum;
      sfxobj[ f ].ownerobj =  object;//where to get pos and vel -1 = see next
      sfxobj[ f ].px       =  0;//if not attached remember position
      sfxobj[ f ].pz       =  0;
      sfxobj[ f ].chan     =  -1;    //channelnum -1=none
      return   f;
      }
    */

   return 0;
   }

// initialise sound with 3d volume, then forget about it.
void  SOUND_sfx_static( u8 sfxnum, s16 x, s16 z, u8 vol )
   {
   /*
   s16   f;
   vec16 pos;
   s16   wang, ang, dist;
   s16   voll, volr, c;

   pos.vx   =  ( x - ear.vx );
   pos.vz   =  ( z - ear.vz );

   dist  =  127-(vqlen2( pos.vx, pos.vz )>>7);

   if( dist>0)
      {
      if( (pos.vx == 0) && (pos.vz == 0) )
         {
         voll=vol>>1;
         volr=vol>>1;
         RENDER_message( "SFX in ear" );
         }
      else
         {
         wang  =  vatan2( pos.vx, pos.vz );// 0,0 ?
         ang   =  wang  +  (CAM_came[0].vy>>4);// ang rel to cam
         ang   += 16384;
         ang   =  ang&4095;// norm ang
         if(ang>2048)ang   =  ang-4096;
         if(ang>1024)ang   =  2048-ang;
         if(ang<-1024)ang  =  -2048-ang;


         voll  =  ((((64+(ang>>5))*dist)>>7)*vol)>>8;
         if(voll<=0)voll=0;
         if(voll>127)voll=127;//clamp

         volr  =  ((((64-(ang>>5))*dist)>>7)*vol)>>8;
         if(volr<=0)volr=0;
         if(volr>127)volr=127;//clamp
         }
      // find free channel
      for(f=0;f<24;f++)if(status[f]==SPU_OFF)break;

      if(f==24)
         {
         RENDER_message( "could not init static SFX" );
         }
      else
         {
         SsUtKeyOnV( f, vab1,sfxnum,0,36,0,voll,volr );
            {
            sprintf( debbuf, "init static sfx on %d ", f );
            RENDER_message( debbuf );
            }
         }
      }
   else
      {
      RENDER_message( "out of range" );
      }
    */
   }

void SOUND_debug()
   {
   /*
   s16   f;
   //SpuGetAllKeysStatus( status );
   //for(f=0;f<24;)
   //   {
   //   FntPrint("ch%d st%d      ch%d st%d \n", f,status[f],f+1, status[f+1]);
   //   f++;
   //   f++;
   //   }

   for(f=0;f<MAXNUMSFXOBJ;f++)
      {
      if( sfxobj[f].stat==ON )
         {
         FntPrint("            SFXobj %d ch %d \n", f, sfxobj[f].chan );
         }
      }
    */
   }



     /*
// sound for you ch0
   vmov( &v0, &OBJ_objects[0].v );
   v0.vx =  v0.vx>>3;
   v0.vy =  v0.vy>>3;
   v0.vz =  v0.vz>>3;
	vsquare32( &v0, &v0 );
   thrpitch  =  2048+vroot32( v0.vx + v0.vy + v0.vz );
   if( thrpitch>thr )
      {
      thr+=80;
      if( thrpitch<thr )
         thr   =  thrpitch;
      }

   if( thrpitch<thr )
      {
      thr-=20;
      if( thrpitch>thr )
         thr   =  thrpitch;
      }

   //thr  =  OBJ_players[0].throttle<<5;
   if( status[0]==0 )
      {//init repeating sound
      SsUtKeyOnV(0,vab1,0,0,26,0,60,60);
      }
   SsUtChangePitch( 0, vab1, 0, 26,0, thr>>7, thr&127 );
// sound for you ch1

// sound for him ch1
   pos.vx   =  ( (OBJ_objects[1].p.vx>>8) - (ear.vx) );
   pos.vz   =  ( (OBJ_objects[1].p.vz>>8) - (ear.vz) );
   diff.vx  =  (OBJ_objects[1].v.vx>>8)-(earv.vx);
   diff.vz  =  (OBJ_objects[1].v.vz>>8)-(earv.vz);

   wang  =  vatan2( pos.vx, pos.vz );// 0,0 ?
   ang   =  wang  +  (CAM_came.vy>>4);// ang rel to cam
   ang   += 16384;
   ang   =  ang&4095;// norm ang
   if(ang>2048)ang   =  ang-4096;
   if(ang>1024)ang   =  2048-ang;
   if(ang<-1024)ang  =  -2048-ang;


   dist  =  127-(vqlen2( pos.vx, pos.vz )>>7);

   voll  =  ((64+(ang>>5))*dist)>>7;
   if(voll<=0)voll=0;
   if(voll>127)voll=127;//clamp

   volr  =  ((64-(ang>>5))*dist)>>7;
   if(volr<=0)volr=0;
   if(volr>127)volr=127;//clamp

// dopler
   unit256x =  -rsin( wang )>>4; //for delay/doppler
   unit256z =  -rcos( wang )>>4;
   dop   =  (unit256x*diff.vx  +  unit256z*diff.vz)>>9;
   if(dop<-64)dop=-64;
   if(dop>63)dop=63;
// dopler

   if(dist<=0)
      {
      SsUtKeyOffV( 1 );
      }
   else
      {
      if( status[1]==OFF )
         {//init repeating sound
         SsUtKeyOnV(1,vab1,0,0,45,0,voll,volr);
         }
      SsUtSetVVol(1,voll,volr);
      SsUtPitchBend( 1, vab1, 0, 0, 64+dop);
      }
   // sound for him ch2,3
   */

///////////////////////////////////////////////////////////////////////////////////////////////
// misc
///////////////////////////////////////////////////////////////////////////////////////////////

extern   s32 LOAD_readPCfile(void *m,char *f );
extern   u32      MESH_track[];

u8    SOUND_vabheader[1024*30];

void  SOUND_init()
   {
   s16   f;
   u8    *ptr0  = (u8*)&MESH_track[0];//((u32)temp&0xffff)+0x10000;

   /*
   SsUtSetReverbType( SS_REV_TYPE_SPACE );
   SsUtSetReverbDepth( 127,127 );
   SsUtSetReverbDelay( 64 );
   SsUtSetReverbFeedback( 127 );
   SsUtReverbOn();
   */
   //LOAD_readPCfile(ptr0,               "c:\\360\\data\\sound\\test.vb" );
   //LOAD_readPCfile(SOUND_vabheader,    "c:\\360\\data\\sound\\test.vh" );
   LOAD_nread(ptr0,               __CD_NAME_GEN("c:\\360\\data\\sound\\18_5_99.vb") );
   LOAD_nread(SOUND_vabheader,    __CD_NAME_GEN("c:\\360\\data\\sound\\18_5_99.vh") );

   SsEnd();
   SsQuit();
   SsInit();
   SsUtAllKeyOff(0);    // turn off all sfx
	SsSetMVol(127,127);		  // set main vol
    SsSetTickMode(SS_TICK50);

   vab1 = SsVabOpenHead (SOUND_vabheader, -1); // open samples hdr
   printf( "vab1 %d\n",vab1 );

   DrawSync(0);
   f=SsVabTransBody (ptr0, vab1);           // trans to sound mem
   SsVabTransCompleted (SS_WAIT_COMPLETED);        // wait till done
   printf( "transbody %d\n",f );
   DrawSync(0);

   SsStart2();                            // start sound
   SsSetSerialAttr(SS_SERIAL_A,SS_MIX,SS_SON);
	CDLIB_musvol(musVol);//   SsSetSerialVol(SS_SERIAL_A, 120,120);

//   for(f=0;f<MAXNUMSFXOBJ;f++)
//      {
//      sfxobj[f].stat=OFF;
//      sfxobj[f].sfxnum=0;  //prog from VAB
//      sfxobj[f].pitchH=36;  //pitch
//      sfxobj[f].pitchL=36;  //pitch
//      sfxobj[f].vol=100;
//      sfxobj[f].type=7;    //type (doppler, 3dvol, contantmonitor)
//      sfxobj[f].ownerobj=0;//where to get pos and vel
//      sfxobj[f].chan=-1;//where to get pos and vel
//      }

//   SsUtKeyOn(vab1,0,0,26,0,60,60);
//   SsUtKeyOn(vab1,5,0,26,0,60,60);
//   SsUtKeyOn(vab1,6,0,26,0,60,60);
//   SsUtKeyOn(vab1,7,0,26,0,60,60);

   SOUND_examinecd();
   }

void  SOUND_killobjects()
   {
   //s16 f;
   SsUtAllKeyOff(0);
   //for(f=0;f<MAXNUMSFXOBJ;f++)
   //   {
   //   sfxobj[f].stat=OFF;
   //   }
   }

void  SOUND_killobject( s16 obj )
   {
//   sfxobj[obj].stat=OFF;
//   SsUtKeyOffV(sfxobj[obj].chan);
   }

void  SOUND_examinecd()
   {// play cd track 1
//	printf("MT_DEBUG: SOUND_examinecd => CdInit\n");
// Mat: 22/03/1999
/*
   CdInit();
   param[0] = CdlModeRept|CdlModeDA;   // report ON / CD-DA ON
   CdControlB(CdlSetmode, param, 0);
   SOUND_tottracks = CdGetToc(loc);       // TOC
   CdSetDebug(0);
*/
   }

int SOUND_tracklist[17] =
	{
	2,4,5,6,			// water
	7,8,9,10,			// ice
	2,4,5,6,			// seabed
	7,8,9,10,			// lava
	3					// jungle
	};

void	SOUND_playcdtrack( )
   {
   //SOUND_cdtrack  = SOUND_tracklist[0];
   //CdControlB(CdlSetloc, (u_char *)&loc[SOUND_cdtrack], 0);  // seek to start of track 1
   //CdControlB((p_com = CdlPlay), 0, 0);          // play track 1

// Mat: 22/03/1999
/*
   CdPlay( 0, SOUND_tracklist, 0);
   CdPlay( 2, SOUND_tracklist, 0);
*/

	CDLIB_Play(SOUND_tracklist[STATE.currlevel]);
   }

void  SOUND_stopcdtrack( )
   {
// Mat: 22/03/1999
// CdPlay( 0, SOUND_tracklist, 0);
   }

void  SOUND_setvol(u8 v)
   {
   SsSetMVol(v,v);       // set main vol
   }

///////////////////////////////////////////////////////////////////////////////////////////
// 3D sound
///////////////////////////////////////////////////////////////////////////////////////////
/*
// SFX structure
//typedef struct {
//   s16 x;             // sound source location
//   s16 z;
//   u8   SfxNum;           // sfx number to trigger
//   u16  HearFromDist;     // can hear the sfx when this close to source
//   u8   SfxOn;            // being played or not
//   u8   IndexIntoList;    // index into SfxCList buffer
//   s16    Voice;            // the voice that sfx is playing on 0-23
//   u8   Repeat;           // if the sfx is auto repeating  set to 1
//   }CSFX_OBJ;

// array of SFX structures
CSFX_OBJ	SfxCObj[3];

// global vars needed
u8    SFXERROR;
u8    SfxCList[255];
u8    SfxCIndex;
char  status[24];

// set your ear position in world coords in these every frame!
s32   xpos,zpos;
s16   vab1;             // vab data id...
s16   lp;

//extern   u32   VabHeader[];
//extern   u32   VabBody[];

// first thing to do is call
// SetSound()
// and set up vab in sound memory

// example of initial setting up sfx structures
// you need one of these for each sfx that has auto adjusting stereo

   //SfxCObj[0].x=-12749;       // current position in world of object playing sfx
   //SfxCObj[0].z=20097;           // need to update these x,z coords each frame
   //SfxCObj[0].SfxNum=7;       // sfx number within vab
   //SfxCObj[0].HearFromDist=16384;   // this is distance sfx will be heard from
   //SfxCObj[0].SfxOn=0;           // flg will be set to 1 if sfx is playing
   //SfxCObj[0].IndexIntoList=0xff;   // index into SfxCList buffer (initialize as ff)
   //SfxCObj[0].Repeat=1;       // set this to 1 if the sfx is auto repeating


// clear buffer once at startup time
   //for(lp=0;lp<256;lp++) SfxCList[lp]=0xff;





// Example of switching on/off an auto repeating sfx.
// Up to you to switch on and off,
// but you could just switch all repeating sfx on once at startup time
// then update x,z pos in structure each frame
//   SfxCOn(num);         // num is number of sfx structure you want to switch on
// Will stay active untill SfxCOff is called
//   SfxCOff(num);
// Once you switch on...when your position is within HearFromDist value you will hear your sfx


// If you have a realtime adjustable stereo	sfx that dosnt auto repeat you can
// switch it on the same way as above ie.
//   SfxCOn(num);
// Once the sfx has played itself out it will automaticly switch itself off.
// Remember to update the x,z positions within the structure


// The other way to play a sfx is to simply trigger it from a x,z location.
// No need to update x,z position each frame, but whole sfx will come from triggerd z,x pos.
//   SfxOOn(x,z,VabSfxNum,HearFromDist);
// x,z is location of sound in world
// VabSfxNum is sfx num within vab
// HearFromDist is distance sfx can be heard from







// each frame call these
//      SpuGetAllKeysStatus(status);
//      SfxCMon();

// and update xpos,zpos with your ear position in world coordinates
// also update any x,z positions of sound sources into sfx structures


void  SfxCOn(u8 num)
{
   if (SfxCObj[num].IndexIntoList!=0xff) return;   // already on

	// set in list
	SfxCList[SfxCIndex]=num;
	SfxCObj[num].IndexIntoList=SfxCIndex;


	// find next available slot
	SfxCIndex++;
	SfxCIndex&=0xff;

	for (lp=0;lp<256;lp++)
	{
	if (SfxCList[SfxCIndex]==0xff) break;
	SfxCIndex++;
	SfxCIndex&=0xff;
	}
   if (lp==255) SFXERROR=1;      // no spaces left in buffer for sfx

}


void  SfxCOff(u8 num)
{
	if (SfxCObj[num].IndexIntoList==0xff) return;	// already off

	SsUtSetDetVVol(SfxCObj[num].Voice,0,0);	// set volume of sfx to 0
	SsUtKeyOffV(SfxCObj[num].Voice);	// sfx voice off

	SfxCList[SfxCObj[num].IndexIntoList]=0xff; 	// reset indexes
	SfxCObj[num].IndexIntoList=0xff;

}


void	SfxCMon()
{
u8   num;
s16 Voice;
s32  tempx,tempz,TempDist;

	for (lp=0;lp<256;lp++)
	{

	num=SfxCList[lp];

	if (num!=0xff)
		{
		// find distance between sfx source and you
		tempx=abs(xpos-SfxCObj[num].x);
		tempz=abs(zpos-SfxCObj[num].z);
		tempx=tempx*tempx;
		tempz=tempz*tempz;
		TempDist=SquareRoot0((tempx+tempz));

		// repeating sfx code
		if (SfxCObj[num].Repeat)
			{
				if (SfxCObj[num].SfxOn==0)	 // sfx is off
				{
					if (TempDist>SfxCObj[num].HearFromDist) continue;	// out of range
					else
						{	 // in range so try and turn on
						GetCVol(num);
						Voice=SsUtKeyOn(vab1,SfxCObj[num].SfxNum,0,0x24,0,0,0);
						if (Voice<0)	continue;	// no spare voice
						SsUtSetDetVVol(SfxCObj[num].Voice,MLVol,MRVol);	// set volume of sfx
						SfxCObj[num].Voice=Voice;
						SfxCObj[num].SfxOn=1;
						}

				}
				else	// already on so adjust vol or turn off if need be
				{
					if (TempDist>SfxCObj[num].HearFromDist)	// out of range... turn off
						{
						SsUtKeyOffV(SfxCObj[num].Voice);	// sfx voice off
						SfxCObj[num].SfxOn=0;
						}
					else   // within range so set vol
						{
						GetCVol(num);
						SsUtSetDetVVol(SfxCObj[num].Voice,MLVol,MRVol);	// set volume of sfx already on
						}

				}
			 }
		else		// one off sfx ,vol pan with auto switch off
			{
				if (SfxCObj[num].SfxOn==0)	 // sfx is off
				{
					if (TempDist<SfxCObj[num].HearFromDist)
						{	 // in range so try and turn on
						GetCVol(num);
						Voice=SsUtKeyOn(vab1,SfxCObj[num].SfxNum,0,0x24,0,0,0);
						if (Voice>=0)
							{
							SsUtSetDetVVol(SfxCObj[num].Voice,MLVol,MRVol);	// set volume of sfx
							SfxCObj[num].Voice=Voice;
							SfxCObj[num].SfxOn=1;
							}
							else
							{  // off ...no voice available
							SfxCList[SfxCObj[num].IndexIntoList]=0xff; 	// reset indexes
							SfxCObj[num].IndexIntoList=0xff;
							}
						}
						else // off ...out of range
						{
						SfxCList[SfxCObj[num].IndexIntoList]=0xff; 	// reset indexes
						SfxCObj[num].IndexIntoList=0xff;
						}

				}
				else	// already on so adjust vol or turn off if need be
				{
					if (status[SfxCObj[num].Voice]==0)	  // sfx finished ...turn off
						{
						SfxCObj[num].SfxOn=0;
						SfxCList[SfxCObj[num].IndexIntoList]=0xff; 	// reset indexes
						SfxCObj[num].IndexIntoList=0xff;
						}
					else   // within range so set vol
						{
						GetCVol(num);
						SsUtSetDetVVol(SfxCObj[num].Voice,MLVol,MRVol);	// set volume of sfx already on
						}

				}

			}

		}
	}


}



void  GetCVol(u8 num)
{
	// find angle between sfx source and you
	bx=SfxCObj[num].x-xpos;
	bz=SfxCObj[num].z-zpos;
	TempAng=ratan2(bx,bz);

	bx=view.vrx-xpos;
	bz=view.vrz-zpos;
	CamAng=ratan2(bx,bz);
	DiffAng=TempAng-CamAng;


	// find L+R vol depending on angle
	LVol=-csin(DiffAng);
	RVol=csin(DiffAng);

	LVol=(LVol+4096)<<1;  // make vol 0-16383
	RVol=(RVol+4096)<<1;


	// set cut off point for sound and make scale value for over all volume
	if (TempDist<(SfxCObj[num].HearFromDist-1))	CTempDist=SfxCObj[num].HearFromDist-TempDist;
	else	CTempDist=0;

	MLVol=(LVol*CTempDist)/SfxCObj[num].HearFromDist;
	MRVol=(RVol*CTempDist)/SfxCObj[num].HearFromDist;
}





void SfxOOn(s16 x, s16 z, u8 num, u16 HearFromDist)
{

s16 Voice;
s32  tempx,tempz;

	// find distance between sfx source and you
	tempx=abs(xpos-x);
	tempz=abs(zpos-z);
	tempx=tempx*tempx;
	tempz=tempz*tempz;
	TempDist=SquareRoot0((tempx+tempz));

	if (TempDist>HearFromDist)	return;

	// find angle between sfx source and you
	bx=x-xpos;
	bz=z-zpos;
	TempAng=ratan2(bx,bz);

	bx=view.vrx-xpos;
	bz=view.vrz-zpos;
	CamAng=ratan2(bx,bz);
	DiffAng=TempAng-CamAng;

	// find L+R vol depending on angle
	LVol=-csin(DiffAng);
	RVol=csin(DiffAng);

	LVol=(LVol+4096)<<1;  // make vol 0-16383
	RVol=(RVol+4096)<<1;

	// set cut off point for sound and make scale value for over all volume
	if (TempDist<(HearFromDist-1))	CTempDist=HearFromDist-TempDist;
	else	CTempDist=0;

	MLVol=(LVol*CTempDist)/HearFromDist;
	MRVol=(RVol*CTempDist)/HearFromDist;

	Voice=SsUtKeyOn(vab1,num,0,0x24,0,0,0);
	if (Voice<0)	return;			// no spare voice
	SsUtSetDetVVol(Voice,MLVol,MRVol);	// set volume of sfx


}


void	SetSound()
{
	SsInit();  										// reset sound

#if pal
	SsSetTickMode(SS_TICK50);
#else
	SsSetTickMode(SS_TICK60);	  					// set tick mode
#endif


   vab1 = SsVabOpenHead ((u8 *)VabHeader, -1); // open samples hdr
   SsVabTransBody ((u8*)VabBody, vab1);     // trans to sound mem
	SsVabTransCompleted (SS_WAIT_COMPLETED);		// wait till done


	SsStart2();										// start sound

	SsSetMVol(127,127);								// main vol

	SsSetSerialAttr(SS_SERIAL_A,SS_MIX,SS_SON);
	CDLIB_musvol(musVol);//   SsSetSerialVol(SS_SERIAL_A, 127,127);
}

 types:
   one off.
   dynamic L/R/dist


 Sound Engine.
   reberberation level dependant on prox to wall/statuslib. L/R direction
   Volume-distance.
   L/R Volume/delay-position.
   Doppler FX.
   Reverb modulation( For tunnels etc )
   Prioritisation of sounds.

 Sounds.
   Craft engine noise.( dynamic pitch )
   Collision:
      player-player.
      player-scenery.
      explode.
      splash.
   Get pickup.
 Ambient:
      water, waterfall, noise.( stereo? )
 Weapons:( launch, in flight and termination )
      torpedo.
      missile.
      high octane.
      shield.
      star burst.
      trip mine.
      cluster bomb.
      flame thrower.
      lightning.
      gas canister.
 Ignition.

*/