#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>

#include "../header.h"
#include "../render.h"
#include "textPSX.h"
#include "gpupsx.h"

///////////////////////////////////////////////////////////////////////////////////////////////
// External Declarations
///////////////////////////////////////////////////////////////////////////////////////////////
extern   GsOT        *ptrwot;//jof

///////////////////////////////////////////////////////////////////////////////////////////////
// Private Declarations
///////////////////////////////////////////////////////////////////////////////////////////////

s16   TEXT_x=0, TEXT_y=0;
u8    TEXT_r;
u8    TEXT_g;
u8    TEXT_b;

void  TEXT_prchr( u8 chr );
void  TEXT_prchr_BIG( u8 chr );

///////////////////////////////////////////////////////////////////////////////////////////////
// Definitions
///////////////////////////////////////////////////////////////////////////////////////////////



u8 textspritedef[]={
0,0,0,0,		//0
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,		//15
0,0,0,0,		//16
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,		//31
0,150,6,1,			//space32
16,168,2,9,			//!
0,0,0,0,		//"
104,168,13,9,		//#
0,0,0,0,		//$
24,168,10,9,		//%
40,168,11,9,		//&
96,168,2,9,		//'
72,168,4,9,		//(
80,168,4,9,		//)
56,168,10,9,		//*
0,0,0,0,		//+
128,168,2,9,		//,
166,168,9,9,    //-
120,168,2,9,		//.
175,168,9,8,      // /  47
120,159,11,9,		//0		48
136,159,2,9,		//1
144,159,11,9,		//2
160,159,11,9,		//3
176,159,11,9,     //4
192,159,11,9,     //5
208,159,11,9,     //6
224,159,11,9,     //7
240,159,11,9,     //8
0,168,11,8,		//9
88,168,2,9,		//:
0,0,0,0,		//;
136,168,9,9,		//<
0,0,0,0,		//=
152,168,9,9,		//>
176,168,9,9,		//?		63
0,0,0,0,		//@		64
0,150,11,9,			//A
16,150,11,9,		//B
32,150,11,9,		//C
48,150,11,9,		//D
64,150,11,9,		//E
80,150,6,9,			//F
88,150,11,9,		//G
104,150,11,9,		//H
120,150,2,9,		//I
128,150,6,9,		//J
136,150,11,9,		//K
152,150,2,9,		//L
160,150,16,9,		//M
176,150,11,9,		//N
192,150,11,9,		//O 79
208,150,11,9,		//P 80
224,150,11,9,		//Q
240,150,6,9,		//R
0,159,11,9,			//S
16,159,7,9,			//T
24,159,11,9,	 	//U
40,159,11,9,	 	//V
56,159,13,9,	 	//W
72,159,11,9,			//X
88,159,11,9,	 	//Y
104,159,11,9,		//Z
0,0,0,0,		//[
0,0,0,0,		//
0,0,0,0,		//]
0,0,0,0,		//^
0,0,0,0,		//_		95
0,0,0,0,		//`		96
0,177,34,24,		//a		X
32,177,32,24,		//b		Circle
64,177,32,24,		//c		Square
96,177,32,24,		//d		Triangle
128,177,64,24,		//e		start button
0,179,24,24,		//f		L1
24,179,24,24,		//g		L2
48,179,24,24,		//h		R1
72,179,24,24,		//i		R2
96,179,16,24,		//j		< flash arrow
112,179,16,24,		//k		> flash arrow
// numbers
 0,176,24,16,    //108  '0'
26,176,6,16,     //109  '1'
34,176,23,16,    //110  '2'
60,176,20,16,    //111  '3'
82,176,25,16,    //112  '4'
112,176,25,16,   //113  '5'
144,176,25,16,   //     '6'
174,176,25,16,   //     '7'
200,176,24,16,   //     '8'
224,176,25,16,   //     '9'
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,
0,0,0,0,		//z
0,0,0,0,		//{
0,0,0,0,		//|
0,0,0,0,		//}
0,0,0,0,		//~
0,0,0,0			//127
};

///////////////////////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////////////////////

void RENDER_rtext()
   {  // u8    txt[]="360 360 360 JON jon";
   TEXT_x=-200;
   TEXT_y=-100;
   //TEXT_prstr( txt );
   }

void  TEXT_cursor( s16 x, s16 y )
   {
   TEXT_x = x;
   TEXT_y = y;
   }

void  TEXT_prstr( u8 *str, u8 r, u8 g, u8 b )
   {
   u8    *ptr  =  str;
   s16   deb=0;
   u8    c;

   TEXT_r   =  r;
   TEXT_g   =  g;
   TEXT_b   =  b;

   while( (*ptr !=0) && deb<256 )
      {
      c  =  *ptr;
      if( c>=97 )c   -= 32;// lower to upper case
      TEXT_prchr( c );
      ptr++;
      deb++;
      }

   TEXT_x=-236;
   TEXT_y+=9;
   }

void  TEXT_prstrbignum( u8 *str, u8 r, u8 g, u8 b )
   {
   u8    *ptr  =  str;
   s16   deb=0;
   u8    c;

   TEXT_r   =  r;
   TEXT_g   =  g;
   TEXT_b   =  b;

   while( (*ptr !=0) && deb<256 )
      {
      c  =  *ptr;
      //if( (c>=48) && (c<=58) )
      c+=60;// numeric font
      TEXT_prchr( c );
      ptr++;
      deb++;
      }

   TEXT_x=-236;
   TEXT_y+=9;
   }

/*
void  TEXT_prchr( u8 chr )
   {
   GsSPRITE sprite;
   u8 *psp  =  &textspritedef[(chr)<<2];

   sprite.attribute =(1<<28) | (0<<24) | (1<<30);
   sprite.x   =TEXT_x;
   sprite.y   =TEXT_y;
   sprite.w   =*(psp+2);
   sprite.h   =*(psp+3);
   sprite.tpage=26;
   sprite.u   =*(psp+0);
   sprite.v   =*(psp+1);
   sprite.cx  =704;
   sprite.cy  =511;
   sprite.r   =TEXT_r;
   sprite.g   =TEXT_g;
   sprite.b   =TEXT_b;
   sprite.mx  =0;
   sprite.my  =0;
   sprite.scalex =4096;
   sprite.scaley =4096;
   sprite.rotate =0;
   GsSortSprite( &sprite, ptrwot,0 );

   TEXT_x+=2+*(psp+2);
   if(TEXT_x>230)
      {
      TEXT_x=-236;
      TEXT_y+=9;
      }
   }
*/

void  TEXT_prchr( u8 chr )
   {
   u8 *psp  =  &textspritedef[(chr)<<2];

   sprite.x   =TEXT_x;
   sprite.y   =TEXT_y;
   sprite.w   =*(psp+2);
   sprite.h   =*(psp+3);
   sprite.u   =*(psp+0);
   sprite.v   =*(psp+1);
   sprite.r   =TEXT_r;
   sprite.g   =TEXT_g;
   sprite.b   =TEXT_b;
   GsSortSprite( &sprite, ptrwot,0 );

   TEXT_x+=2+*(psp+2);
   if(TEXT_x>230)
      {
      TEXT_x=-236;
      TEXT_y+=9;
      }
   }

//BIG NUMBERS TEXT PRINTING STUFF

void  TEXT_prstr_BIG( u8 *str, u8 r, u8 g, u8 b )
   {
   u8    *ptr  =  str;
   s16   deb=0;
   u8    c;

   TEXT_r   =  r;
   TEXT_g   =  g;
   TEXT_b   =  b;

   while( (*ptr !=0) && deb<256 )
      {
      c  =  *ptr;
      if( c>=97 )c   -= 32;// lower to upper case

      TEXT_prchr( c );
      ptr++;
      deb++;
      }

   TEXT_x=-236;
   TEXT_y+=9;
   }

void  TEXT_prchr_BIG( u8 chr )
   {
   GsSPRITE sprite;
   u8 *psp  =  &textspritedef[(chr)<<2];

   sprite.attribute =(0<<28) | (0<<24) ;
   sprite.x   =TEXT_x;
   sprite.y   =TEXT_y;
   sprite.w   =*(psp+2);
   sprite.h   =*(psp+3);
   sprite.tpage=26;
   sprite.u   =*(psp+0);
   sprite.v   =*(psp+1);
   sprite.cx  =752;
   sprite.cy  =442;
   sprite.r   =TEXT_r;
   sprite.g   =TEXT_g;
   sprite.b   =TEXT_b;
   sprite.mx  =0;
   sprite.my  =0;
   sprite.scalex =(4096 * 4);
   sprite.scaley =(4096 * 4);
   sprite.rotate =0;
   GsSortSprite( &sprite, ptrwot,0 );

   TEXT_x+=2+*(psp+2);
   if(TEXT_x>230)
     {
     TEXT_x=-236;
     TEXT_y+=9;
     }
   }

extern   GsOT     MWot[2];                // OT header
extern int      outbuf_idx;

void  TEXT_intro( u8 chr, u32 size )
   {
   GsSPRITE sprite;
   u8 *psp  =  &textspritedef[(chr)<<2];

   sprite.attribute =(1<<28) | (0<<24) | (1<<30);
   sprite.tpage=26;
   sprite.cx  =752;
   sprite.cy  =442;
   sprite.mx  =0;
   sprite.my  =0;
   sprite.scalex =size;
   sprite.scaley =size;
   sprite.rotate =0;
   sprite.x   =TEXT_x;
   sprite.y   =TEXT_y;
   sprite.w   =*(psp+2);
   sprite.h   =*(psp+3);
   sprite.u   =*(psp+0);
   sprite.v   =*(psp+1);
   sprite.r   =TEXT_r;
   sprite.g   =TEXT_g;
   sprite.b   =TEXT_b;
   GsSortSprite( &sprite, &MWot[outbuf_idx],0 );

   }