#include <sys/types.h>
#include <libsn.h>
#include <libsnd.h>
#include <libspu.h>
#include <libcd.h>
#include <libgte.h>
#include <libgpu.h>
#include <abs.h>
#include "header.h"
#include "objects.h"
#include "psx\mathPSX.h"
#include "camera.h"
#include "state.h"
#include "psx\soundPSX.h"
#include "menu.h"
#include "cdlib.h"

///////////////////////////////////////////////////////////////////////////////////////////////
//    360 sound system (non poon version)
///////////////////////////////////////////////////////////////////////////////////////////////
//    Started:    12/3/99
//
//    Author.  nunk-humper
//		PSX:			Yay
//    Notes:      Cha-maaf baby mouse. I'll huff, I'll puff, and I'll blow you..
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Extern
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Global
///////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////
// Locals
///////////////////////////////////////////////////////////////////////////////////////////////
#define     S2looping      (1<<0)
#define     S2unique       (1<<1)
#define     S2doppler      (1<<2)
#define     S23d           (1<<3)

typedef struct
   {
   s16   stype;   //
   s16   sfx;     //VAB sfx num-1 == OFF
   s8    updated; //looping sound updated this frame?
   s16   obj;     //creator object
   s16   vol;     //0-127 vol of sfx
   }CHINFO;

u8       chstat[24]; //status of all PSX sound channels
CHINFO   chinfo[24];

///////////////////////////////////////////////////////////////////////////////////////////////
// protoceratypes
///////////////////////////////////////////////////////////////////////////////////////////////

void  S2_debug();
void  S2_engines();
void  s2_miscnastyfx();
void  S2_waterfall();
extern   vec32    LOAD_startpoints[8];

///////////////////////////////////////////////////////////////////////////////////////////////
// functions
///////////////////////////////////////////////////////////////////////////////////////////////

// called  eof frame
void  S2_update()
   {
   s16   i;
 S2_waterfall();

   // examine stat of all channels
   for(i=0;i<16;i++)
      {
      if( chstat[i]==1 )
         {
         // if looping sfx not updated then kill
         if( (chinfo[i].sfx==1) ||
             (chinfo[i].sfx==17) ||
             (chinfo[i].sfx==20) )
            {
            if(chinfo[i].updated==0)
               {
               SsUtKeyOffV( i );
               }
            }
         else
            {
            chinfo[i].vol-=2;
            if(chinfo[i].vol<0)
               chinfo[i].vol=0;
            }
         chinfo[i].updated=0;
         }
      }

   S2_engines();
   SpuGetAllKeysStatus( chstat );

   //S2_debug();
   }


// initialise sound fx
//          (sfx, x>>8, z>>8, obji, vol, pitch)
s8 S2_sfxdynamic( u8 Sfx, s16 x, s16 z, s16 Obji, u8  Vol, s32 Pitch )
   {
   s16   i, f;
   vec16 pos;
   s16   vol0, vol1;

// jon doesnt know anything
// jon's butt is covered in monkey cum

//	Vol = (Vol*sfxVol)/100;

   if( STATE.numscreens==1 )
      {
      //single screen
      pos.vx   =  ( x - CAM_camp[0].vx  );
      pos.vz   =  ( z - CAM_camp[0].vz  );
      vol0   =  255-(vqlen2( pos.vx, pos.vz )>>6);
      vol0   =  (vol0*Vol)>>8;
      if(vol0<0)vol0=0;
      }
   else
      {
      // split screen
      pos.vx   =  ( x - CAM_camp[0].vx  );
      pos.vz   =  ( z - CAM_camp[0].vz  );
      vol0   =  255-(vqlen2( pos.vx, pos.vz )>>6);
      vol0   =  (vol0*Vol)>>8;
      if(vol0<0)vol0=0;


      pos.vx   =  ( x - CAM_camp[1].vx  );
      pos.vz   =  ( z - CAM_camp[1].vz  );
      vol1   =  255-(vqlen2( pos.vx, pos.vz )>>6);
      vol1   =  (vol1*Vol)>>8;
      if(vol1<0)vol1=0;

      if(vol1>vol0)vol0=vol1;
      }


   // allready exist?
   for(i=0;i<16;i++)
      {
      if( (chinfo[i].sfx==Sfx) && (chstat[i]==1) )
         break;
      }

   if(i==16)
       {
      // does not exist create new one
      f  =  SsUtKeyOn( vab1, Sfx&63, 0, Pitch>>7, Pitch&127, (vol0*sfxVol)>>7, (vol0*sfxVol)>>7 );
      if(f!=-1)
         {
         chinfo[f].sfx     =  Sfx;
         chstat[f]=1;
         chinfo[f].vol=vol0;
         chinfo[f].updated =  1;
         }
      }
   else
      {
      // overwrite existing if vol near
      if( vol0 >= chinfo[i].vol )
         {
         chinfo[i].updated =  1;
         if( (Sfx!=20) && (Sfx!=1) && (Sfx!=17) )//apart from owned flame
            {
            SsUtKeyOnV( i, vab1, Sfx&63,0, Pitch>>7, Pitch&128, (vol0*sfxVol)>>7, (vol0*sfxVol)>>7 );
            chinfo[i].vol=vol0;
            }
         }
      }
   return 1;
   }

// only player1
void  S2_waterfall()
   {
   vec16 pos;
   s16   vol;
   if(STATE.currlevel==0)
      {
      pos.vx   =  ( -3425 - CAM_camp[0].vx  );
      pos.vz   =  ( 6142  - CAM_camp[0].vz  );
      vol   =  255-(vqlen2( pos.vx, pos.vz )>>5);
      if(vol<0)vol=0;

      if( chstat[22]!=1 )
         {
         SsUtKeyOnV( 22, vab1, 33,0,36,0,0,0 );
         }

      SsUtSetVVol( 22, (vol*sfxVol)>>7, (vol*sfxVol)>>7 );
      }
   }

void  S2_engines()
   {
   static   s32   epitch[8]={0,0,0,0,0,0,0,0};
   s16   i, o;

   vec16 pos;
   s16   vol;
   s32   p;

   if( STATE.numscreens==1 )
      {
      //single screen
      for(i=16,o=0;i<16+MAXNUMPLAYERS;i++,o++)
         {
         if( OBJ_objects[o].stat==ON )
            {
            if( chstat[i]!=1 )
               {
               SsUtKeyOnV( i, vab1, 0,0,36,0,0,0 );
               }
            pos.vx   =  ( (OBJ_objects[o].p.vx>>8) - CAM_camp[0].vx  );
            pos.vz   =  ( (OBJ_objects[o].p.vz>>8) - CAM_camp[0].vz  );
            vol   =  255-(vqlen2( pos.vx, pos.vz )>>6);
            //vol   =  (vol*64)>>8;
            vol   =  (vol*44)>>8;
            if(vol<0)vol=0;
            SsUtSetVVol( i, (vol*sfxVol)>>7, (vol*sfxVol)>>7 );

            p  =  OBJ_players[o].speed<<5;
            if(p<3000)p=3000;

            if( epitch[o] < p )epitch[o]+=140;
            if( epitch[o] > p )epitch[o]-=80;

            SsUtChangePitch( i, vab1, 0, 36,0, epitch[o]>>7, epitch[o]&127 );
            //FntPrint("ph %d\n", p>>7);
            }
         else
            {
            SsUtKeyOffV( i );
            }
         }
      }
   else
      {
      //split screen
      for(i=16,o=0;i<16+2;i++,o++)
         {
         if( OBJ_objects[o].stat==ON )
            {
            if( chstat[i]!=1 )
               {
               SsUtKeyOnV( i, vab1, 0,0,36,0,0,0 );
               }
            pos.vx   =  ( (OBJ_objects[o].p.vx>>8) - CAM_camp[o].vx  );
            pos.vz   =  ( (OBJ_objects[o].p.vz>>8) - CAM_camp[o].vz  );
            vol   =  255-(vqlen2( pos.vx, pos.vz )>>6);
            //vol   =  (vol*64)>>8;
            vol   =  (vol*44)>>8;
            if(vol<0)vol=0;
            SsUtSetVVol( i, (vol*sfxVol)>>7, (vol*sfxVol)>>7 );

            p  =  OBJ_players[o].speed<<5;
            if(p<3000)p=3000;

            if( epitch[o] < p )epitch[o]+=140;
            if( epitch[o] > p )epitch[o]-=80;

            SsUtChangePitch( i, vab1, 0, 36,0, epitch[o]>>7, epitch[o]&127 );
            //FntPrint("ph %d\n", p>>7);
            }
         else
            {
            SsUtKeyOffV( i );
            }
         }
      }
   }

void s2_miscnastyfx()
   {
   }


// initialise sound fx
s8 S2_sfxstatic( u8 Sfx, u8 Vol )
   {
   return 0;
   }
// no 3d sound for split screen
// all common explo sounds non 3d for now

void  S2_debug()
   {
   s16   i, a=0;
   for(i=0;i<24;i++)
      {
      FntPrint( "%d:%d %d %d \n", i, chinfo[i].sfx, chstat[i], chinfo[i].vol  );
      if(chstat[i]==1)a++;
      }
   FntPrint( "playing %d\n", a );
   }

//
//  0
//  1
//  2
//  3
//  4
//  5
//  6
//  7
//  8
//  9
// 10
// 11
// 12
// 13
// 14
// 15
// 16 engin
// 17 engin
// 18 engin
// 19 engin
// 20 engin
// 21 engin
// 22 waterfall
// 23