#define MPLAYER		MAXNUMPLAYERS

typedef struct
	{
	// Common
	s32 finished;
	s32 active;
	s32 needFinish;
	s32 position;
	s32 raceTime;				// BCD
	
    // Track
	s32 lapTimePoint[3];		// Time in frames (25fps)
	s32 lapTime[3];				// BCD:xxMMSSHH
	s32 fastestLap;				// BCD
	
    // Arena
	s32 frags;
	s32 frag10time;
	}HISCORE_S;

extern HISCORE_S hiScore[MPLAYER];
extern int gameFrags;

extern int finishPlace[6];
extern int finishIndex;

void SCORE_reset(void);
void SCORE_lapcomplete(u8 player,u8 lap,u32 time);
void SCORE_frag(u8 player,u32 time);
void SCORE_checkComplete(void);
s32 SCORE_frame2bcd(s32 frame);
void SCORE_menu(void);
void SCORE_startmenu(void);
void SCORE_doHighScoreStats(void);

void SCORE_drawArenaScore(void);
void SCORE_drawTrackScore(void);

void SCORE_startmainmenu(void);

void SCORE_initnames(void);
void SCORE_calcnames(void);
void SCORE_entername(void);
void SCORE_updatename(void);

char *SCORE_checkracetime(u32);
char *SCORE_checkfasttime(u32);
char *SCORE_checkfragtime(u32);

