#include "header.h"
#include "frontend.h"
#include "fade.h"
#include "render.h"
#include "camera.h"
#include "objects.h"
#include "collide.h"
#include <libsn.h>
#include "sdlib\sdtypes.h"
#include "sdlib\sdfunc.h"
#include "ctrller.h"
#include "gameloop.h"
#include "state.h"
#include "psx\psx_pcks.h"
#include "psx\psx_expn.h"
#include "ai.h"
#include "psx\textpsx.h"
#include "hue.h"
#include "menu.h"
#include "memcard.h"
#include "keys.h"
#include "loadit.h"
#include "savedata.h"
#include <libmcrd.h>
#include <stdio.h>
#include <libapi.h>
#include <libpad.h>
#include "psx\loadpsx.h"
#include "psx\soundpsx.h"
#include "psx\textpsx.h"
#include "action.h"
#include <libcd.h>
#include "cdlib.h"
#include "screens.h"
#include "score.h"
#include "text.h"

#define __DEBUG_MENU		0

extern GsOT *MWotPtr;

XYADJ adj_pause[6] = {{0,16},{0,16},{0,16},{112,16},{48,16},{0,16}};
XYADJ adj_checkcard[6] = {{-110,0},{-110,0},{-110,0},{-110,0},{-110,0},{-110,0}};
XYADJ adj_nocard[6] = {{-100,0},{-40,0},{-64,0},{-32,0},{64,0},{-100,0}};
XYADJ adj_badcard[6] = {{-32,-64},{0,-64},{16,-64},{8,-64},{48,-64},{48,-64}};
XYADJ adj_fullcard[6] = {{-64,-64},{16,-64},{-32,-64},{32,-64},{-48,-64},{-32,-64}};
XYADJ adj_unformat[6] = {{-16,-64},{32,-64},{32,-64},{48,-64},{48,-64},{-32,-64}};
XYADJ adj_writeq[6] = {{-120,0},{-120,0},{-120,0},{-110,0},{-100,0},{-120,0}};
XYADJ adj_writing[6] = {{-128,0},{-64,0},{-80,0},{-32,0},{0,0},{-128,0}};
XYADJ adj_donewrite[6] = {{-128,0},{-64,0},{-16,0},{-32,0},{-40,0},{-110,0}};
XYADJ adj_update[6] = {{-120,0},{-100,0},{-64,0},{-80,0},{-100,0},{-8,0}};
XYADJ adj_menutrial[6] = {{-48,-16},{100,-16},{0,-16},{64,-16},{64,-16},{96,-16}};
XYADJ adj_menutourn[6] = {{0,-64},{16,-64},{32,-64},{0,-64},{24,-64},{100,-64}};
XYADJ adj_menubattle[6] = {{-64,-48},{128,-48},{0,-48},{64,-48},{64,-48},{100,-48}};
XYADJ adj_mainmenuwon[6] = {{0,0},{90,0},{44,0},{90,0},{80,0},{100,0}};
XYADJ adj_mainmenulost[6] = {{-80,0},{0,0},{0,0},{16,0},{0,0},{20,0}};

/*
XYADJ adj_pause[6] = {{0,0},{24,0},{0,0},{112,0},{64,0},{32,0}};
XYADJ adj_checkcard[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_nocard[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_badcard[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_fullcard[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_unformat[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_writeq[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_writing[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_donewrite[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_update[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_menutrial[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_menutourn[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_menubattle[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_mainmenuwon[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
XYADJ adj_mainmenulost[6] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
*/
// ------------------------------------------------ Pause

int vol,volt;

char *geezaTracks[10] =
	{
    "\01retro",
    "\01junmungle",
    "\01synthzone",
    "\01datalife",
    "\01digital man",
    "\01oddysee",
    "\01""27hz",
    "\01attenuation",
    "\01bite beat",
    "\01random"
/*
    "T1 dark_moon",
    "T2 junmungle",
    "T3 lake_synth",
    "T4 rising_sun",
    "T5 kam_digital2",
    "T6 new",
    "T7 subit_2",
    "T8 timpani_rules",
    "T9 mishmash",
	"Random"
*/
	};

WTXT txtPause[11] =
    {//26  18
    {3,2,2,1,   0,-62-4,{"\02player  1  paused","\02joueur n\23  1  arr\24t\05","\02spieler  1  pausiert","\02jugador  1  en pausa","\02giocatore  1  pausa","\02paus f\15r spelare  1"}},
    {0,2,2,1,   0,-36-8,{"\01return to race","\01revenir \20 la course","\01zuruck zum rennen","\01volver a la carrera","\01rientro in corsa","\01aterg\14 till loppet"}},
    {0,2,0,1,-134,-10-8,{"\01vibration feature","\01vibrations","\01vibrations modus","\01caracter\12stica de vibraci\13n","\01funzione di vibrazione","\01vibrationsfunktion"}},
    {0,2,0,1,-134,  8-8,{"\01music volume","\01volume de la musique","\01musiklautst\07rke","\01volumen de la m\10sica","\01volume musica","\01musikvolym"}},
    {0,2,0,1,-134, 26-8,{"\01effects volume","\01effets sonores","\01soundlautst\07rke","\01volumen de los efectos de sonido","\01volume effetti sonori","\01effektvolym"}},

    {0,2,0,1,-134,44-8,{"\01audio track","\01bande son","\01audio track","\01pista de audio","\01colonna sonora","\01ljudsp\14r"}},
    {0,2,2,1,   0,70-8,{"\01abandon game","\01abandonner le jeu","\01spiel verlassen","\01abandonar el juego","\01abbandona il gioco","\01avbryt spel"}},

    {0,2,1,1,134,-10-8,{NULL,NULL,NULL,NULL,NULL,NULL}},
    {0,2,1,1,134,8-8,  {"\01xb","\01xb","\01xb","\01xb","\01xb","\01xb"}},
    {0,2,1,1,134,26-8, {"\01xc","\01xc","\01xc","\01xc","\01xc","\01xc"}},
    {0,2,1,1,134,44-8, {NULL,NULL,NULL,NULL,NULL,NULL}}
    };

char *txt_on[6] = {"\01on","\01activ\05","\01an","\01on","\01acceso","\01p\14"};
char *txt_off[6] = {"\01off","\01d\05sactiv\05","\01aus","\01off","\01spento","\01av"};
char *txt_random[6] = {"\01random","\01mode al\05atoire","\01beliebig","\01aleatorio","\01casuale","\01slumpm\07ssigt"};

void pauseScreen(void)
	{
	register int i;
	
	execGame = 0;
//	PutText(0,MPos,BShk,0,-100,0);

//	gridUpdate();
//  gridDraw();

    // Fill in cd audio track
	// ATTN! : LANG
	txtPause[10].txt[*Language] = (cTrack==-1)?txt_random[*Language]:geezaTracks[(cTrack-2)];
	txtPause[7].txt[*Language] = (*RumbleOn)?txt_on[*Language]:txt_off[*Language];

    vol = nmusVol;
    volt = vol/10;
    vol -= 10*volt;
    txtPause[8].txt[*Language] [1] = nmusVol>=10?volt + '0':' ';
    txtPause[8].txt[*Language] [2] = vol + '0';

    vol = nsfxVol;
    volt = vol/10;
    vol -= 10*volt;
    txtPause[9].txt[*Language] [1] = nsfxVol>=10?volt + '0':' ';
    txtPause[9].txt[*Language] [2] = vol + '0';

    wTxtColour[2].r = (newhue2rgb[(G_cyc*3)&0xff].r>>1)+64;
    wTxtColour[2].g = (newhue2rgb[(G_cyc*3)&0xff].g>>1)+64;
    wTxtColour[2].b = (newhue2rgb[(G_cyc*3)&0xff].b>>1)+64;

    for(i=0;i<11;i++)
		{
		if((i>=1)&&(i<=6))
			{
			txtPause[i].cIndex = i-1==pOption?1:0;
			txtPause[i].wobble = i-1==pOption?1:3;
			if((i!=1)&&(i!=6))
	            txtPause[i].x = -134 - (adj_pause[*Language].x>>1);
			}
		if((i>=7)&&(i<=10))
			{
			txtPause[i].cIndex = i-6==pOption?1:0;
			txtPause[i].wobble = i-6==pOption?1:3;
            txtPause[i].x = 134 + (adj_pause[*Language].x>>1);
            }
		WTXT_print(&txtPause[i]);
		}

    switch(pOption)
        {
        case 0:     // Continue game
            if((SD_PadData[0].push&K_MENU_PROGRESS))
                {
                menuState = MN_Disabled;
                execGame = 1;
                }
            break;

        case 1:     // Vibration on/off
            if((SD_PadData[0].push&K_MENU_VIBRATE))
                (*RumbleOn) ^= 1;
            break;

        case 2:     // Music volume
            if((SD_PadData[0].push&K_MENU_VOLUP))
                {
                nmusVol++;
                if(nmusVol>10)
                    nmusVol = 0;
                musVol = sndvols[nmusVol];
                CDLIB_musvol((nmusVol*127)/10);
                }
            if((SD_PadData[0].push&K_MENU_VOLDOWN))
                {
                nmusVol--;
                if(nmusVol<0)
                    nmusVol = 10;
                musVol = sndvols[nmusVol];
                CDLIB_musvol((nmusVol*127)/10);
                }
            break;

        case 3:     // Effects volume
            if((SD_PadData[0].push&K_MENU_VOLUP))
                {
                nsfxVol++;
                if(nsfxVol>10)
                    nsfxVol = 0;
                sfxVol = sndvols[nsfxVol];
                }
            if((SD_PadData[0].push&K_MENU_VOLDOWN))
                {
                nsfxVol--;
                if(nsfxVol<0)
                    nsfxVol = 10;
                sfxVol = sndvols[nsfxVol];
                }
            break;

        case 4:     // Audio track
            if((SD_PadData[0].push&K_MENU_AUDIOTUP))
                {
                if(cTrack==-1)
                    {
                    cTrack = 2;
                    }
                else{
                    cTrack++;
                    if(!WorldAvailable[4])
                    if(cTrack==3)
                        {
                        printf("No junmungle today\n");
                        cTrack++;
                        }
                    if(cTrack>=11)
                        cTrack = -1;
                    }
                CDLIB_Play(cTrack);
                }
            if((SD_PadData[0].push&K_MENU_AUDIOTDOWN))
                {
                if(cTrack==-1)
                    {
                    cTrack = 10;
                    }
                else{
                    cTrack--;
                    if(!WorldAvailable[4])
                    if(cTrack==3)
                        {
                        printf("No junmungle today\n");
                        cTrack--;
                        }
                    if(cTrack<=1)
                        cTrack = -1;
                    CDLIB_Play(cTrack);
                    }
                CDLIB_Play(cTrack);
                }
            break;

        case 5:     // Abandon game
            if((SD_PadData[0].push&K_MENU_PROGRESS))
                {
                #if CDMASTER
                LoadIntro();
                #else
                GAMELOOP_state = GLloadmenu;
                #endif
                menuState = MN_Disabled;
                execGame = 1;
                }
            break;
        }

    if((SD_PadData[0].push&K_MENU_MENUUP))
        {
        if(pOption)
            pOption--;
        }
    else
    if((SD_PadData[0].push&K_MENU_MENUDOWN))
        {
        if(pOption<5)
            pOption++;
        }

	// do after text so its printed first
    semiBox(300+adj_pause[*Language].x,144+adj_pause[*Language].y);
    setSemiHW(0);
	}


// ------------------------------------------------ Write to memory card

WTXT txtCheckCard[2] =
	{
    {3,2,2,1,0,-18,{"\02checking memory card","\02v\05rification de la carte","\02\17berpr\17fe memory card","\02comprobando la tarjeta","\02controllo della scheda","\02kontrollerar minneskortet"}},
    {3,2,2,1,0, 18,{"\02in slot 1","\02m\05moire dans la fente 1","\02in steckplatz 1","\02de memoria de la ranura 1","\02memoria nell'unit\20 1 in corso","\02i uttag 1"}}
    };

WTXT txtNoCard[2] =
	{										// n'y
    {3,2,2,1,0,-18,{"\02no memory card","\02il ny a pas de carte","\02keine memory card","\02sin tarjerta de memoria","\02nell'unit\20 1 non \06","\02inget minneskort"}},
    {3,2,2,1,0, 18,{"\02in slot 1","\02m\05moire dans la fente 1","\02in steckplatz 1","\02en la ranura 1","\02stata inserita una scheda memoria","\02i uttag 1"}}
    };

WTXT txtBadCard[2] =
	{
    {3,2,2,1,0,-18,{"\02faulty memory card","\02la carte m\05moire de la","\02fchlerhafte memory card","\02tarjeta de memoria de la","\02la scheda memoria nell'unit\20","\02fel p\14 minneskortet"}},
    {3,2,2,1,0, 18,{"\02in slot 1","\02fente 1 est d\05fectueuse","\02in steckplatz 1","\02ranura 1 defectuosa","\021 \06 difettosa","\02i uttag 1"}}
    };

WTXT txtFullCard[2] =
	{
    {3,2,2,1,0,-18,{"\02memory card in","\02la carte m\05moire dans la","\02memory card in","\02la tarjeta de memoria de la","\02la scheda memoria","\02minneskortet i uttag"}},
    {3,2,2,1,0, 18,{"\02slot 1 is full","\02fente 1 est pleine","\02steckplatz 1 ist voll","\02ranura 1 est\11 llena","\02nell'unit\20 1 \06 piena","\02""1 \07r fullt"}}
    };

WTXT txtUnformattedCard[2] =
	{
    {3,2,2,1,0,-18,{"\02memory card in slot 1","\02la carte m\05moire dans la","\02memory card in steckplatz","\02debe formatearse la tarjeta","\02la scheda memoria nell'unit\20","\02minneskortet i uttag"}},
    {3,2,2,1,0, 18,{"\02needs formatting","\02fente 1 n'est pas format\05e","\021 mub formaticrt werden","\02de memoria de la ranura 1","\02""1 deve essere formattata","\02""1 m\14ste formateras"}}
    };

WTXT txtDoneWrite[2] =
	{
    {3,2,2,1,0,-18,{"\02completed writing to","\02transfert vers la carte","\02speicherung auf memory card in","\02registro completa en la","\02scrittura sulla scheda","\02slutf\15rt skrivning"}},
    {3,2,2,1,0, 18,{"\02memory card in slot 1","\02m\05moire de la fente 1 termin\05","\02steckplatz 1 abgeschlossen","\02tarjeta de memoria de la ranura 1","\02memoria nell'unit\20 1 completata","\02till minneskortet i uttag 1"}}
    };

WTXT txtWriting[2] =
	{
    {3,2,2,1,0,-18,{"\02updating memory card","\02mise \20 jour de la carte m\05moire","\02memory card wird aktualisiert","\02actualizando la tarjeta de memoria","\02aggiornamento della scheda memoria","\02uppdaterar minneskortet"}},
    {3,2,2,1,0, 18,{"\02do not remove","\02en cours ne pas la retirer","\02bitte nicht entfernen","\02de la ranura 1: no retirar","\02in corso non estrarre la scheda","\02ta inte ut det"}}
    };

char *txt_yes[6] = {"\01yes","\01oui","\01ja","\01s\12","\01s\22","\01ja"};
char *txt_no[6] = {"\01no","\01non","\01nein","\01no","\01no","\01nej"};

WTXT txtWriteQ[5] =
	{
    {3,2,2,1,0,-18-25,{"\02write to memory card","\02transf\05rer sur la carte","\02auf memory card in","\02""\16registrar en la tarjeta","\02vuoi scrivere sulla scheda","\02skriva till minneskortet"}},
    {3,2,2,1,0,  0-25,{"\02in slot 1 ?","\02m\05moire de la fente 1 ?","\02steckplatz 1 speichern","\02de memoria de la ranura 1?","\02memoria nell'unit\20 1?","\02i uttag 1?"}},
    {0,2,2,1,0, 32-25,{NULL,NULL,NULL,NULL,NULL,NULL}},
    {0,2,2,1,0, 50-25,{NULL,NULL,NULL,NULL,NULL,NULL}},
    {4,2,2,1,0, 68-25,{"\01X button to select","\01selection : touche X","\01X-taste zum w\07hlen","\01bot\13n X para selec.","\01tasto X per selezionare","\01tryck pa X-knappen f\15r att v\07lja"}}
    };

SaveDataStruct SaveData=
{
	// Header
	{'S','C'},	// Magic Number
	0x11,	// Type (single image)
	1,		// No. of Slots
//	"3-SIXTY",		// Name
	{
		0x82,0x52,0x81,0x7c,0x82,0x72,0x82,0x68,0x82,0x77,0x82,0x73,0x82,0x78,			// U B I K ????????????????
		0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	},{},		// Pad

	// Icon data
	{0x0008,0x2808,0x4408,0x56a8,0x0015,0x5415},		// CLUT
	{
		0x0000,0x0222,0x0001,0x0000,
		0x2100,0x0012,0x0000,0x0000,
		0x1210,0x2210,0x0122,0x0000,
		0x1210,0x0122,0x2210,0x0000,
		0x2021,0x0001,0x1000,0x0002,
		0x2112,0x0000,0x0000,0x0012,
		0x1202,0x0000,0x0000,0x0021,
		0x0222,0x0000,0x0000,0x1020,
		0x0000,0x0000,0x0000,0x2020,
		0x0002,0x0000,0x0000,0x2021,
		0x0012,0x0000,0x0000,0x2112,
		0x0021,0x0000,0x1000,0x1202,
		0x0120,0x0000,0x2210,0x0210,
		0x1210,0x1000,0x0122,0x0121,
		0x2100,0x0012,0x2100,0x0012,
		0x0000,0x2221,0x1222,0x0000,
	},		// Image 1

	{},		// SHighScore

	0,		// UnHideVehicle9;	
	0,		// UnHideVehicle6;
	0,		// PadConfig;	
	{},		// WorldAvailable[5];	
	{},		// TrackAvailable[4][4];	
	0,		// arcade pos


	// my data
	{}

	
};

// temp
char *filename = "BESLPS-12345X360";
void *data = &SaveData;
long CardID = 0x00;
short NumBlocks = 1;
	
void writeMemCardScreen(void)
	{
	register int i;
	
    switch(writeState)
        {
        case MC_Disabled:
            printf("Error: Should not have got to here.\n");
            break;

        case MC_Start:
            // Init variables used to save to card.

            writeState = MC_CheckCard;
            frCount = 0;
            mcCheckState = 0;
            mcCheckCount = 0;

			//tangent
            //PadStopCom();
            //VSync(0);
            //VSync(0);
            //padStopped = 1;

            // run into MC_CheckCard

        case MC_CheckCard:

            switch(mcCheckState)
                {
                case 0:     // Issue memcardaccept
                    MemCardFuncDone = 0;
                    MemCardAccept(0x00);
                    mcCheckState = 1;
                    break;

                case 1:     // Wait until MemCardAccept completed
                    if(MemCardFuncDone)
                        {
                        // Check result

                        if(MemCardResult==0)
                            {
                            writeState = MC_Write;
                            mcWrOption = 0;
                            mcWriteState = 0;
                            }
                        else{
                            if(MemCardResult==3)
                                {
                                mcCheckState = 0;
                                mcCheckCount++;
                                }
                            else{
                                if(mcCheckCount<10)
                                    {
                                    mcCheckState = 0;
                                    mcCheckCount++;
                                    }
                                else{
                                    if(MemCardResult==1)     // Not connected
                                        writeState = MC_NoCard;
                                    if(MemCardResult==2)     // Bad card
                                        writeState = MC_BadCard;
                                    if(MemCardResult==4)     // Unformatted card
                                        writeState = MC_UnformattedCard;
                                    }
                                }
                            }
                        }

                    frCount = 0;

                    break;
                }

            for(i=0;i<2;i++)
				WTXT_print(&txtCheckCard[i]);

            // do after text so its printed first
            semiBox(416+adj_checkcard[*Language].x,64+adj_checkcard[*Language].y);

            // set stp bit
            setSemiHW(0);

            frCount++;

            break;

        case MC_NoCard:
            if(padStopped)
                {
                PadStartCom();
                padStopped = 0;
                for(i=0;i<8;i++)
                    SD_PadData[i].actAligned = 0;
                }

            for(i=0;i<2;i++)
				WTXT_print(&txtNoCard[i]);

            // do after text so its printed first
            semiBox(300+adj_nocard[*Language].x,76+adj_nocard[*Language].y);

            // set stp bit
            setSemiHW(0);

            frCount++;
            if((frCount==150)||(SD_PadData[0].push&K_MENU_PROGRESS))
                {
                menuState = MN_UpdateMemCard;
                mcUpdOption = 0;
                frCount = 0;

//              menuState = MN_Disabled;
//              frCount = 0;
                }
            break;

        case MC_BadCard:
			if(padStopped)
            	{
                PadStartCom();
                padStopped = 0;
                for(i=0;i<8;i++)
                    SD_PadData[i].actAligned = 0;
                }

			for(i=0;i<2;i++)
				WTXT_print(&txtBadCard[i]);

            // do after text so its printed first
            semiBox(256+adj_badcard[*Language].x,128+adj_badcard[*Language].y);

            // set stp bit
            setSemiHW(0);

            frCount++;
            if((frCount==150)||(SD_PadData[0].push&K_MENU_PROGRESS))
                {
//              menuState = MN_Disabled;

                menuState = MN_UpdateMemCard;
                mcUpdOption = 0;
/*
                switch(*GameMode)
                    {
                    case 0: // Battle
                        menuState = MN_MainMenuInitBattle;
                        break;
                    case 1: // Tournament
                        menuState = MN_MainMenuInitTourn;
                        break;
                    case 2: // Time trial
                        menuState = MN_MainMenuInitTrial;
                        break;
                    case 3: // Arcade
                        menuState = MN_MainMenuInitArcade;
                        break;
                    }
*/
                frCount = 0;
                }
            break;

        case MC_FullCard:
            if(padStopped)
                {
                PadStartCom();
                padStopped = 0;
                for(i=0;i<8;i++)
                    SD_PadData[i].actAligned = 0;
                }

            for(i=0;i<2;i++)
				WTXT_print(&txtFullCard[i]);

            // do after text so its printed first
            semiBox(256+adj_fullcard[*Language].x,128+adj_fullcard[*Language].y);

            // set stp bit
            setSemiHW(0);

            frCount++;
            if((frCount==150)||(SD_PadData[0].push&K_MENU_PROGRESS))
                {
//              menuState = MN_Disabled;

/*
                switch(*GameMode)
                    {
                    case 0: // Battle
                        menuState = MN_MainMenuInitBattle;
                        break;
                    case 1: // Tournament
                        menuState = MN_MainMenuInitTourn;
                        break;
                    case 2: // Time trial
                        menuState = MN_MainMenuInitTrial;
                        break;
                    case 3: // Arcade
                        menuState = MN_MainMenuInitArcade;
                        break;
                    }
*/

                menuState = MN_UpdateMemCard;
                mcUpdOption = 0;

                frCount = 0;
                }
            break;

        case MC_UnformattedCard:
            if(padStopped)
                {
                PadStartCom();
                padStopped = 0;
                for(i=0;i<8;i++)
                    SD_PadData[i].actAligned = 0;
                }

            for(i=0;i<2;i++)
                WTXT_print(&txtUnformattedCard[i]);

            // do after text so its printed first
            semiBox(256+adj_unformat[*Language].x,128+adj_unformat[*Language].y);

            // set stp bit
            setSemiHW(0);

            frCount++;
            if((frCount==150)||(SD_PadData[0].push&K_MENU_PROGRESS))
                {
//              menuState = MN_Disabled;
                frCount = 0;
/*
                switch(*GameMode)
                    {
                    case 0: // Battle
                        menuState = MN_MainMenuInitBattle;
                        break;
                    case 1: // Tournament
                        menuState = MN_MainMenuInitTourn;
                        break;
                    case 2: // Time trial
                        menuState = MN_MainMenuInitTrial;
                        break;
                    case 3: // Arcade
                        menuState = MN_MainMenuInitArcade;
                        break;
                    }
*/
                menuState = MN_UpdateMemCard;
                mcUpdOption = 0;
                }
            break;

        case MC_Write:
            switch(mcWriteState)
                {
                case 0:         // Ask continue write ?
                    if(padStopped)
                        {
                        PadStartCom();
                        padStopped = 0;
                        for(i=0;i<8;i++)
                            SD_PadData[i].actAligned = 0;
                        }

					txtWriteQ[2].txt[*Language] = txt_yes[*Language];
					txtWriteQ[3].txt[*Language] = txt_no[*Language];

					for(i=0;i<5;i++)
                        {
                        if((i==2)||(i==3))
							{
							txtWriteQ[i].cIndex = (i-2)==mcWrOption?1:0;
							txtWriteQ[i].wobble = (i-2)==mcWrOption?1:3;
							}
						WTXT_print(&txtWriteQ[i]);
						}

                    // do after text so its printed first
                    semiBox(256+128+adj_writeq[*Language].x,128-10+adj_writeq[*Language].y);

                    // set stp bit
                    setSemiHW(0);

                    if((SD_PadData[0].push&K_MENU_MENUUP))
                        mcWrOption ^= 1;
                    if((SD_PadData[0].push&K_MENU_MENUDOWN))
                        mcWrOption ^= 1;
                    if((SD_PadData[0].push&K_MENU_ABORT))
                        {
                        frCount = 0;

                        if(padStopped)
                            {
                            PadStartCom();
                            padStopped = 0;
                            for(i=0;i<8;i++)
                                SD_PadData[i].actAligned = 0;
                            }

                        switch(*GameMode)
                            {
                            case 0: // Battle
                                menuState = MN_MainMenuInitBattle;
                                break;
                            case 1: // Tournament
                                menuState = MN_MainMenuInitTourn;
                                break;
                            case 2: // Time trial
                                menuState = MN_MainMenuInitTrial;
                                break;
                            case 3: // Arcade
                                menuState = MN_MainMenuInitArcade;
                                break;
                            }
                        }
                    if((SD_PadData[0].push&K_MENU_PROGRESS))
                        {
                        switch(mcWrOption)
                            {
                            case 0:
                                frCount = 0;
                                mcWriteState = 1;
                                break;
                            case 1:
//                              mcWriteState = 3;

                                frCount = 0;

                                if(padStopped)
                                    {
                                    PadStartCom();
                                    padStopped = 0;
                                    for(i=0;i<8;i++)
                                        SD_PadData[i].actAligned = 0;
                                    }

                                switch(*GameMode)
                                    {
                                    case 0: // Battle
                                        menuState = MN_MainMenuInitBattle;
                                        break;
                                    case 1: // Tournament
                                        menuState = MN_MainMenuInitTourn;
                                        break;
                                    case 2: // Time trial
                                        menuState = MN_MainMenuInitTrial;
                                        break;
                                    case 3: // Arcade
                                        menuState = MN_MainMenuInitArcade;
                                        break;
                                    }

                                break;
                            }
                        }
                    break;

                case 1:         // Write
                    if(!padStopped)
                        {
                        PadStopCom();
                        VSync(0);
                        VSync(0);
                        padStopped = 1;
                        }

	        	    for(i=0;i<2;i++)
                        WTXT_print(&txtWriting[i]);

                    // do after text so its printed first
                    semiBox(256+160+adj_writing[*Language].x,128-56+adj_writing[*Language].y);

                    // set stp bit
                    setSemiHW(0);

                    frCount++;

                    // temp : freeze game while writing
                    // do write
                    if(frCount>=3)
                        {
                        int err;
                        int errCount = 0;
                        int lp;

                        *ArcadePosLoaded = thisLevel;
                        NewArcadeGameNow = 0;

                        SaveData.ArcadePos = *ArcadePosLoaded;
                        SaveData.SHighScore = *HighScore;
                        SaveData.UnHideVehicle9 = *UnHideVehicle9;
                        SaveData.UnHideVehicle6 = *UnHideVehicle6;
                        SaveData.PadConfig = *PadConfig;

                        for (lp=0;lp<5;lp++)
                            SaveData.WorldAvailable[lp] = WorldAvailable[lp];
                        for (lp=0;lp<4;lp++)
                            {
                            SaveData.TrackAvailable[0] [lp] = TrackAvailable[0] [lp];
                            SaveData.TrackAvailable[1] [lp] = TrackAvailable[1] [lp];
                            SaveData.TrackAvailable[2] [lp] = TrackAvailable[2] [lp];
                            SaveData.TrackAvailable[3] [lp] = TrackAvailable[3] [lp];
                            }

                        MemCardAccept(0x00);
                        MemCardSync(0,0,(long *)&err);

                        MemCardAccept(0x00);
                        MemCardSync(0,0,(long *)&err);

                        retryCreate:

                        err = MemCardCreateFile(CardID,filename,NumBlocks);
                        switch(err)
                            {
                            case McErrNone:
                                break;

                            case McErrAlreadyExist:
                                err = MemCardDeleteFile(CardID,filename);
                                errCount++;
                                printf("(%d times so far)   Error delete\n",errCount);
                                goto retryCreate;

                            case McErrBlockFull:
                                err = MemCardDeleteFile(CardID,filename);
                                errCount++;
                                printf("(%d times so far)   Error delete\n",errCount);
                                if(errCount>=3)
                                    {
                                    writeState = MC_FullCard;
                                    return;
                                    }
                                else
                                    goto retryCreate;

                            default:
                                // unknown error
                                printf("MemCardCreateFile: %04X\n",err);
                                break;
                            }

                        // will possibly fuckup if unknown error at the moment
                        err = MemCardWriteFile(CardID,filename,data,0,NumBlocks*8192);
                        MemCardSync(0,0,(long *)&err);
                        if(err!=McErrNone)
                            {
                            errCount++;
                            printf("(%d times so far)   Error write\n",errCount);
                            if(errCount>=3)
                                {
                                if(err==1)     // Not connected
                                    writeState = MC_NoCard;
                                if(err==2)     // Bad card
                                    writeState = MC_BadCard;
                                if(err==4)     // Unformatted card
                                    writeState = MC_UnformattedCard;

                                return;
                                }

                            goto retryCreate;
                            }

                        printf("Game saved OK\n");

                        // proceed to next screen
                        mcWriteState = 2;
                        frCount = 0;
                        }
/*
                    if(frCount==150)
                        {
                        mcWriteState = 2;
                        frCount = 0;
                        }
*/
                    break;

                case 2:         // Display completed msg
                    if(padStopped)
                        {
                        PadStartCom();
                        padStopped = 0;
                        for(i=0;i<8;i++)
                            SD_PadData[i].actAligned = 0;
                        }

	        	    for(i=0;i<2;i++)
    		            WTXT_print(&txtDoneWrite[i]);

                    // do after text so its printed first
                    semiBox(256+120+adj_donewrite[*Language].x,128-64+adj_donewrite[*Language].y);

                    // set stp bit
                    setSemiHW(0);

                    frCount++;
                    if(frCount==150)
                        {
                        mcWriteState = 3;
                        frCount = 0;
                        }
                    break;

                case 3:         // Restore pads
                    if(padStopped)
                        {
                        PadStartCom();
                        padStopped = 0;
                        for(i=0;i<8;i++)
                            SD_PadData[i].actAligned = 0;
                        }

                    switch(*GameMode)
                        {
                        case 0: // Battle
                            menuState = MN_MainMenuInitBattle;
                            break;
                        case 1: // Tournament
                            menuState = MN_MainMenuInitTourn;
                            break;
                        case 2: // Time trial
                            menuState = MN_MainMenuInitTrial;
                            break;
                        case 3: // Arcade
                            menuState = MN_MainMenuInitArcade;
                            break;
                        }
                    break;
                }

            break;
/*
            frCount++;
            menuState = MN_MainMenuInitArcade;
            frCount = 0;
            break;
*/
        }
	}


// ------------------------------------------------ Update memory card

WTXT txtUpdate[5] =
	{
    {3,2,2,1,0,-48,{"\02update memory card","\02mettre la carte m\05moire","\02memory card in steckplatz 1","\02""\16actualizar la tarjeta","\02vuoi aggiornare la scheda","\02uppdatera minneskortet"}},
    {3,2,2,1,0,-30,{"\02in slot 1 ?","\02de la fente 1 \20 jour ?","\02aktualisieren ?","\02de memoria de la ranura 1?","\02memoria nell'unit\20 1?","\02i uttag 1?"}},
    {0,2,2,1,0,  2,{NULL,NULL,NULL,NULL,NULL,NULL}},
    {0,2,2,1,0, 20,{NULL,NULL,NULL,NULL,NULL,NULL}},
    {4,2,2,1,0, 48,{"\01X button to select","\01selection : touche X","\01X-taste zum w\07hlen","\01bot\13n X para selec.","\01tasto X per selezionare","\01tryck pa X-knappen f\15r att v\07lja"}}
    };

void updateMemCardScreen(void)
	{
	register int i;

	txtUpdate[2].txt[*Language] = txt_yes[*Language];
	txtUpdate[3].txt[*Language] = txt_no[*Language];
	
	for(i=0;i<5;i++)
		{
		if((i==2)||(i==3))
			{
			txtUpdate[i].cIndex = (i-2)==mcUpdOption?1:0;
			txtUpdate[i].wobble = (i-2)==mcUpdOption?1:3;
			}
		WTXT_print(&txtUpdate[i]);
		}
	/*
    for(i=0;txtUpdate[i].t!=NULL;i++)
        {
        TEXT_x = txtUpdate[i].x;
        TEXT_y = txtUpdate[i].y;
        M_TEXT_prstr(txtUpdate[i].t,(i-2)==mcUpdOption?220:192,(i-2)==mcUpdOption?220:192,(i-2)==mcUpdOption?0:192);
        }
	*/
	
    // do after text so its printed first
    semiBox(384+adj_update[*Language].x,118+adj_update[*Language].y);
    setSemiHW(0);

    frCount++;
/*
    if((SD_PadData[0].push&K_MENU_UPDATEYES))
        {
        menuState = MN_WriteMemCard;
        writeState = MC_Start;
        frCount = 0;
        }
    else
    if((SD_PadData[0].push&K_MENU_UPDATENO))
        {
        // Presume won.
        menuState = MN_MainMenuInitArcade;
        frCount = 0;
        }
*/
    if((SD_PadData[0].push&K_MENU_MENUUP))
        mcUpdOption ^= 1;
    if((SD_PadData[0].push&K_MENU_MENUDOWN))
        mcUpdOption ^= 1;
    if((SD_PadData[0].push&K_MENU_PROGRESS))
        {
        switch(mcUpdOption)
            {
            case 0:
                menuState = MN_WriteMemCard;
                writeState = MC_Start;
                frCount = 0;
                break;
            case 1:
                switch(*GameMode)
                    {
                    case 0: // Battle
                        menuState = MN_MainMenuInitBattle;
                        break;
                    case 1: // Tournament
                        menuState = MN_MainMenuInitTourn;
                        break;
                    case 2: // Time trial
                        menuState = MN_MainMenuInitTrial;
                        break;
                    case 3: // Arcade
                        menuState = MN_MainMenuInitArcade;
                        break;
                    }
                frCount = 0;
                break;
            }
        }
    if((SD_PadData[0].push&K_MENU_ABORT))
        {
        switch(*GameMode)
            {
            case 0: // Battle
                menuState = MN_MainMenuInitBattle;
                break;
            case 1: // Tournament
                menuState = MN_MainMenuInitTourn;
                break;
            case 2: // Time trial
                menuState = MN_MainMenuInitTrial;
                break;
            case 3: // Arcade
                menuState = MN_MainMenuInitArcade;
                break;
            }
        frCount = 0;
        }
	}


// ------------------------------------------------ Main menu (trial)

WTXT txtMenuTrial[3] =
	{
    {0,2,2,1,0,-32,{"\01try this level again","\01r\05essayer ce niveau","\01level noch einmal","\01intenta este nivel otra vez","\01riprova questo livello","\01prova denna niv\14 p\14 nytt"}},
    {0,2,2,1,0, -8,{"\01quit time trial","\01quitter la course contre la montre","\01versuchen","\01salir de la prueba contrareloj","\01abbandona la prova a tempo","\01avsluta tr\07ning"}},
    {4,2,2,1,0, 32,{"\01X button to select","\01selection : touche X","\01X-taste zum w\07hlen","\01bot\13n X para selec.","\01tasto X per selezionare","\01tryck pa X-knappen f\15r att v\07lja"}}
    };

void menuTrialScreen(void)
	{
	register int i;
	
	for(i=0;i<3;i++)
        {
		if(i<2)
			{
			txtMenuTrial[i].cIndex = (i)==cOption?1:0;
			txtMenuTrial[i].wobble = (i)==cOption?1:3;
			}
		
        WTXT_print(&txtMenuTrial[i]);
		}

    // do after text so its printed first
    semiBox(256+adj_menutrial[*Language].x,128+adj_menutrial[*Language].y);

    // set stp bit
    setSemiHW(0);

    frCount++;
    if((SD_PadData[0].push&K_MENU_PROGRESS))
        {
        switch(cOption)
            {
            case 0:     // Retry level
                menuState = MN_Disabled;
                LOAD_level();
                STATE_initstatesonboot();
                GAMELOOP_state = GLfadeouttogame;
                break;

            case 1:     // Quit
                SOUND_setvol(0);
                #if CDMASTER
                LoadIntro();
                #else
                GAMELOOP_state = GLloadmenu;
                #endif
                menuState = MN_Disabled;
                break;
            }
        }
    else
    if((SD_PadData[0].push&K_MENU_MENUUP))
        {
        if(cOption)
            cOption--;
        }
    else
    if((SD_PadData[0].push&K_MENU_MENUDOWN))
        {
        if(cOption<1)
            cOption++;
        }
	}


// ------------------------------------------------ Main menu (tourn)

WTXT txtMenuTourn[3] =
	{
    {0,2,2,1,0,-18,{"\01proceed to next level","\01passer au niveau suivant","\01weiter zum n\07chsten level","\01avanza al nivel siguiente","\01avanza al prossimo livello","\01g\14 vidare till n\07sta niv\14"}},
    {0,2,2,1,0,  0,{"\01quit tournament","\01quitter le tournoi","\01turnicrmodus verlassen","\01salir del torneo","\01abbandona il torneo","\01avsluta turnering"}},
    {4,2,2,1,0, 18,{"\01X button to select","\01selection : touche X","\01X-taste zum w\07hlen","\01bot\13n X para selec.","\01tasto X per selezionare","\01tryck pa X-knappen f\15r att v\07lja"}}
    };

void menuTournScreen(void)
	{
	register int i;
	
	for(i=0;i<3;i++)
        {
		if(i<2)
			{
            txtMenuTourn[i].cIndex = (i-2)==cOption?1:0;
            txtMenuTourn[i].wobble = (i-2)==cOption?1:3;
			}
        
		WTXT_print(&txtMenuTourn[i]);
		}

    // do after text so its printed first
    semiBox(256+adj_menutourn[*Language].x,128+adj_menutourn[*Language].y);

    // set stp bit
    setSemiHW(0);

    frCount++;
    if((SD_PadData[0].push&K_MENU_PROGRESS))
        {
        switch(cOption)
            {
            case 0:     // Next level
                menuState = MN_Disabled;
                LOAD_level();
                STATE_initstatesonboot();
                GAMELOOP_state = GLfadeouttogame;
                break;

            case 1:     // Quit
                SOUND_setvol(0);
                #if CDMASTER
                LoadIntro();
                #else
                GAMELOOP_state = GLloadmenu;
                #endif
                menuState = MN_Disabled;
                break;
            }
        }
    else
    if((SD_PadData[0].push&K_MENU_MENUUP))
        {
        if(cOption)
            cOption--;
        }
    else
    if((SD_PadData[0].push&K_MENU_MENUDOWN))
        {
        if(cOption<1)
            cOption++;
        }
	}


// ------------------------------------------------ Main menu (battle)

WTXT txtMenuBattle[3] =
	{
    {0,2,2,1,0, 18,{"\01repeat this level","\01recommencer avec le m\24me niveau","\01level noch einmal spielen","\01repite este nivel","\01ripeti questo livello","\01upprepa denna niv\14"}},
    {0,2,2,1,0,  0,{"\01quit battle mode","\01quitter le mode 1 contre 1","\01kampfmodus verlassen","\01salir del modo de competici\13n","\01abbandona la modalit\20 di lotta","\01avsluta envig"}},
    {4,2,2,1,0,-18,{"\01X button to select","\01selection : touche X","\01X-taste zum w\07hlen","\01bot\13n X para selec.","\01tasto X per selezionare","\01tryck pa X-knappen f\15r att v\07lja"}}
    };

void menuBattleScreen(void)
	{
	register int i;

	for(i=0;i<3;i++)
        {
		if(i<2)
			{
            txtMenuBattle[i].cIndex = (i-2)==cOption?1:0;
            txtMenuBattle[i].wobble = (i-2)==cOption?1:3;
			}
        
		WTXT_print(&txtMenuBattle[i]);
		}

    // do after text so its printed first
    semiBox(256+adj_menubattle[*Language].x,128+adj_menubattle[*Language].y);

    // set stp bit
    setSemiHW(0);

    frCount++;
    if((SD_PadData[0].push&K_MENU_PROGRESS))
        {
        switch(cOption)
            {
            case 0:     // Retry level
                menuState = MN_Disabled;
                LOAD_level();
                STATE_initstatesonboot();
                GAMELOOP_state = GLfadeouttogame;
                break;

            case 1:     // Quit
                SOUND_setvol(0);
                #if CDMASTER
                LoadIntro();
                #else
                GAMELOOP_state = GLloadmenu;
                #endif
                menuState = MN_Disabled;
                break;
            }
        }
    else
    if((SD_PadData[0].push&K_MENU_MENUUP))
        {
        if(cOption)
            cOption--;
        }
    else
    if((SD_PadData[0].push&K_MENU_MENUDOWN))
        {
        if(cOption<1)
            cOption++;
        }
	}


// ------------------------------------------------ Main menu (arcade)

WTXT txtMainMenuWon[4] =
	{
    {0,2,2,1,0,-30,{"\01continue to next level","\01continuer avec le niveau suivant","\01weiter zum n\07chsten level","\01contin\10a en el nivel siguiente","\01prosegui al prossimo livello","\01forts\07tt till n\07sta niv\14"}},
    {0,2,2,1,0,-12,{"\01save to memory card","\01enregistrer sur la carte m\05moire","\01speichere auf memory card","\01guardar en la tarjeta de memoria","\01salva sulla scheda memoria","\01spara till minneskortet"}},
    {0,2,2,1,0,  6,{"\01quit arcade","\01quitter le mode par niveaux","\01arcade verlassen","\01salir del modo por niveles","\01abbandona il gioco progressivo","\01avsluta serie"}},
    {4,2,2,1,0, 30,{"\01X button to select","\01selection : touche X","\01X-taste zum w\07hlen","\01bot\13n X para selec.","\01tasto X per selezionare","\01tryck pa X-knappen f\15r att v\07lja"}}
    };

WTXT txtMainMenuLost[6] =
	{
    {3,2,2,1,0,-52,{"\02you failed to finish","\02vous ne faites pas partie","\02sie haben keine der crsten","\02has fallado al acabar las","\02non hai conseguito uno","\02du kom inte p\14 en av"}},
    {3,2,2,1,0,-35,{"\02in top 3 positions","\02des 3 premiers coureurs","\02""3 positionen erreicht","\02tres posiciones m\11ximas","\02delle prime tre posizioni","\02de tre f\15rsta platserna"}},
    {0,2,2,1,0, -8,{"\01retry this level","\01r\05essayer le m\24me niveau","\01level noch einmal spielen","\01vuelve a intentar este nivel","\01ritenta questo livello","\01f\15rs\15k igen p\14 denna niv\14"}},
    {0,2,2,1,0, 10,{"\01save to memory card","\01enregistrer sur la carte m\05moire","\01speichere auf memory card","\01guardar en la tarjeta de memoria","\01salva sulla scheda memoria","\01spara till minneskortet"}},
    {0,2,2,1,0, 28,{"\01quit arcade","\01quitter le mode par niveaux","\01arcade verlassen","\01salir del modo por niveles","\01abbandona il gioco progressivo","\01avsluta serie"}},
    {4,2,2,1,0, 52,{"\01X button to select","\01selection : touche X","\01X-taste zum w\07hlen","\01bot\13n X para selec.","\01tasto X per selezionare","\01tryck pa X-knappen f\15r att v\07lja"}}
    };

void menuArcadeScreen(void)
	{
	register int i;

	if(wonFlag==1)
		{
		// ATTN! : LANG

	    for(i=0;i<4;i++)
			{
			if(i!=3)
	            {
				txtMainMenuWon[i].cIndex = i==cOption?1:0;
	            txtMainMenuWon[i].wobble = i==cOption?1:3;
				}
            WTXT_print(&txtMainMenuWon[i]);
            }
		
	    // do after text so its printed first
        semiBox(252+adj_mainmenuwon[*Language].x,92+adj_mainmenuwon[*Language].y);
        setSemiHW(0);
		}
	else{
        for(i=0;i<6;i++)
            {
			if((i>=2)&&(i<=4))
				{
				txtMainMenuLost[i].cIndex = i-2==cOption?1:0;
				txtMainMenuLost[i].wobble = i-2==cOption?1:3;
				}
			WTXT_print(&txtMainMenuLost[i]);
            }
    
        // do after text so its printed first
        semiBox(334+adj_mainmenulost[*Language].x,132+adj_mainmenulost[*Language].y);
        setSemiHW(0);
		}

    frCount++;
    if((SD_PadData[0].push&K_MENU_PROGRESS))
        {
        switch(cOption)
            {
            case 0:     // Contine if won, Retry if lost.
                menuState = MN_Disabled;
                STATE.currlevel = thisLevel;
				STATE.mcurrlevel = STATE.currlevel;
				if(STATE.mcurrlevel==16)
					STATE.mcurrlevel = 19;
                LOAD_level();
                STATE_initstatesonboot();
                GAMELOOP_state = GLfadeouttogame;
                break;

            case 1:     // Save
                menuState = MN_UpdateMemCard;
                mcUpdOption = 0;
                frCount = 0;
                break;

            case 2:     // Quit
                SOUND_setvol(0);
                #if CDMASTER
                LoadIntro();
                #else
                GAMELOOP_state = GLloadmenu;
                #endif
                menuState = MN_Disabled;
                break;
            }
        }
    else
    if((SD_PadData[0].push&K_MENU_MENUUP))
        {
        if(cOption)
            cOption--;
        }
    else
    if((SD_PadData[0].push&K_MENU_MENUDOWN))
        {
        if(cOption<2)
            cOption++;
        }
	}
