#include <sys/types.h>
#include <libetc.h>		/* for Control Pad */
#include <libgte.h>		/* LIBGS uses libgte */
#include <libgpu.h>		/* LIBGS uses libgpu */
#include <libgs.h>		/* for LIBGS */

#include <inline_c.h>

#include "sddemo.h"

#if 1
void  SdOldMapFile(u_long *MemPointer);    // maps a Sd file into mem
void	SdModelPrint(u_long *MemPointer,u_char md,GsOT *OT,u_char idx,u_long Sort);	// print Sd model
#endif

typedef struct {
	SVECTOR	a;
	SVECTOR	b;
	SVECTOR	c;
}FACE_VERT;

typedef struct {
	SVECTOR	a;
	SVECTOR	b;
	SVECTOR	c;
	SVECTOR	d;
}FACE_VERT4;

#if 1
FACE_VERT   *PMod1Vert;
extern   POLY_F3     *PMod1A_F;
extern   int         PC_Mod1A_F;
extern   POLY_F3     *PMod1A_FD;
extern   int         PC_Mod1A_FD;
extern   POLY_FT3 *PMod1A_T;
extern   int         PC_Mod1A_T;
extern   POLY_FT3 *PMod1A_TD;
extern   int         PC_Mod1A_TD;

extern   POLY_G3     *PMod1A_G;
extern   int         PC_Mod1A_G;
extern   POLY_G3     *PMod1A_GD;
extern   int         PC_Mod1A_GD;
extern   POLY_GT3 *PMod1A_GT;
extern   int         PC_Mod1A_GT;
extern   POLY_GT3 *PMod1A_GTD;
extern   int         PC_Mod1A_GTD;

FACE_VERT4  *PMod1Vert4;
extern   POLY_F4     *PMod1F_F;
extern   int         PC_Mod1F_F;
extern   POLY_F4     *PMod1F_FD;
extern   int         PC_Mod1F_FD;
extern   POLY_FT4 *PMod1F_T;
extern   int         PC_Mod1F_T;
extern   POLY_FT4 *PMod1F_TD;
extern   int         PC_Mod1F_TD;

extern   POLY_G4     *PMod1F_G;
extern   int         PC_Mod1F_G;
extern   POLY_G4     *PMod1F_GD;
extern   int         PC_Mod1F_GD;
extern   POLY_GT4 *PMod1F_GT;
extern   int         PC_Mod1F_GT;
extern   POLY_GT4 *PMod1F_GTD;
extern   int         PC_Mod1F_GTD;

extern   long  otz       ;
extern   long  flag      ;
extern   u_long   sz3[3] ;
extern   u_long   minz   ;
extern   u_long   maxz   ;
extern   short minx      ;
extern   short maxx      ;
extern   short miny      ;
extern   short maxy      ;
//int		md	   __attribute__ ((section("cachedata"))) =0;

extern	int		outbuf_idx;
extern	GsOT		Wot[2];		/* Handler of OT */




/* ------------------------ */

#define minmax3(x1,x2,x3,x4,x5)    x1>x2?(x5=x1,x4=x2):(x4=x1,x5=x2),\
                                   x3>x5?x5=x3:x3<x4?x4=x3:0

#define max3(x1,x2,x3,x4)    	x1>x2?	(x4=x1):(x4=x2),	x3>x4?	(x4=x3):0

#define min3(x1,x2,x3,x4)    	x1>x2?	(x4=x2):(x4=x1),	x3<x4?	(x4=x3):0


//#define half_width	160		/* half size of screen. for edge clip */
//#define half_height	120

// MemPointer	- Sd model format data in memory
// md			- model within that data
// OT			- which order table to sort faces to
// idx 			- current double buffer index 0/1
// Sort			- sort point for each face in model 0-average 1-near 2-far

void SdModelPrint(u_long *MemPointer,u_char md,GsOT *OT,u_char idx,u_long Sort)
{

register	long 		*tag;
register	int			lp;
register	GsOT_TAG	*WOT;

register	POLY_FT4	*PPMod1F_T;
register	POLY_FT4	*PPMod1F_T_L1;
register	POLY_FT4	*PPMod1F_T_L2;

register	POLY_F4		*PPMod1F_F;
register	POLY_F4		*PPMod1F_F_L1;
register	POLY_F4		*PPMod1F_F_L2;

// NEW
register	POLY_GT4	*PPMod1F_GT;
register	POLY_GT4	*PPMod1F_GT_L1;
register	POLY_GT4	*PPMod1F_GT_L2;

register	POLY_G4		*PPMod1F_G;
register	POLY_G4		*PPMod1F_G_L1;
register	POLY_G4		*PPMod1F_G_L2;
//

register	FACE_VERT4	*PPMod1Vert4;
register	FACE_VERT4	*PPMod1Vert4_C1;
register	FACE_VERT4	*PPMod1Vert4_C2;

register	FACE_VERT	*PPMod1Vert;
register	POLY_F3		*PPMod1A_F;
register	POLY_FT3	*PPMod1A_T;

// NEW
register	POLY_G3		*PPMod1A_G;
register	POLY_GT3	*PPMod1A_GT;
//

register	u_long		OTSHIFT;

u_long		Maped;
u_long		PolyBufferSize;
u_long		PolyBufferOffset;


//	if ((md==0)||(md==3))	Sort=0;
//	else Sort=md;

#define xyclip 0

//	AAAAA_GoGoGadgetAnalyzer=1;


	WOT=OT[idx].org;   // set ot and size
	OTSHIFT=14-OT[idx].length;


	MemPointer++;				  // get past num objects in file
	PolyBufferSize=*MemPointer++; // size of all face packet info in 1 buffer
	Maped=*MemPointer++;		  // is data maped to mem
	if (Maped)
	{
	MemPointer+=(md*34);		// move pointer to corect model header within data

	PolyBufferOffset=(idx*PolyBufferSize);	// set what buffer we are working on 0/1

	PMod1Vert=(FACE_VERT *)*MemPointer++;
	PMod1A_F=(POLY_F3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_F=*MemPointer++;
	PMod1A_FD=(POLY_F3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_FD=*MemPointer++;
	PMod1A_T=(POLY_FT3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_T=*MemPointer++;
	PMod1A_TD=(POLY_FT3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_TD=*MemPointer++;

// NEW
	PMod1A_G=(POLY_G3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_G=*MemPointer++;
	PMod1A_GD=(POLY_G3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_GD=*MemPointer++;
	PMod1A_GT=(POLY_GT3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_GT=*MemPointer++;
	PMod1A_GTD=(POLY_GT3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_GTD=*MemPointer++;
//

	PMod1Vert4=(FACE_VERT4 *)*MemPointer++;
	PMod1F_F=(POLY_F4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_F=*MemPointer++;
	PMod1F_FD=(POLY_F4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_FD=*MemPointer++;
	PMod1F_T=(POLY_FT4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_T=*MemPointer++;
	PMod1F_TD=(POLY_FT4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_TD=*MemPointer++;

// NEW
	PMod1F_G=(POLY_G4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_G=*MemPointer++;
	PMod1F_GD=(POLY_G4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_GD=*MemPointer++;
	PMod1F_GT=(POLY_GT4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_GT=*MemPointer++;
	PMod1F_GTD=(POLY_GT4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_GTD=*MemPointer++;
//
	}

	/* ------------ tri faces first ------------- */


	PPMod1Vert=&PMod1Vert[0];  // set tri vert pointer

	/************/
	/* flat rgb */
	/************/

	PPMod1A_F=&PMod1A_F[0];		// set tri face pointer to... rgb

	for (lp=0;lp<PC_Mod1A_F;PPMod1A_F++,lp++)
	{
//	gte_ldv3(&PPMod1Vert->a ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert->b ,
//			 &PPMod1Vert->c);

	gte_ldv3c(&PPMod1Vert->a);		/* new load gte with 3 continuous xyz's of face */


	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue;

	gte_nclip();				// back face clip
	gte_stopz(&otz);
	if (otz <=0) continue;

	gte_stsxy3_f3(PPMod1A_F);	  // store screen xy's

#if xyclip
	/* x's 2d virtices off edge of screen ? */
	minmax3(Mod1A_F[md][outbuf_idx][lp].x0,
			Mod1A_F[md][outbuf_idx][lp].x1,
			Mod1A_F[md][outbuf_idx][lp].x2,minx,maxx);

	if((maxx<-half_width) || (minx>half_width)) /* W clip */
    continue;											  /* whole poly is off screen */

	/* y's ? */
	minmax3(Mod1A_F[md][outbuf_idx][lp].y0,
			Mod1A_F[md][outbuf_idx][lp].y1,
			Mod1A_F[md][outbuf_idx][lp].y2,miny,maxy);

 	if((maxy<-half_height) || (miny>half_height)) /* H clip */
    continue;
#endif

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


	// put tag in ot
 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_F->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
 	*tag = ((u_long) (PPMod1A_F) & 0x00ffffff);
	}



	/************/
	/* flat rgb, double sided */
	/************/

	PPMod1A_F=&PMod1A_FD[0];	// set tri face pointer to... rgb double

	for (lp=0;lp<PC_Mod1A_FD;PPMod1A_F++,lp++)
	{
//	gte_ldv3(&PPMod1Vert->a ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert->b ,
//			 &PPMod1Vert->c);

	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert++;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_stsxy3_f3(PPMod1A_F);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_F->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
 	*tag = ((u_long) (PPMod1A_F) & 0x00ffffff);
	}





	/************/
	/* textured */
	/************/

	PPMod1A_T=&PMod1A_T[0];		// set tri face pointer to... tex

	for (lp=0;lp<PC_Mod1A_T;PPMod1A_T++,lp++)
	{
//	gte_ldv3(&PPMod1Vert->a ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert->b ,
//			 &PPMod1Vert->c);

	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_nclip();
	gte_stopz(&otz);
	if (otz <=0) continue;

	gte_stsxy3_ft3(PPMod1A_T);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_T->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
 	*tag = ((u_long) (PPMod1A_T) & 0x00ffffff);
	}




	/************/
	/* textured, double sided */
	/************/

	PPMod1A_T=&PMod1A_TD[0];	// set tri face pointer to... tex double

	for (lp=0;lp<PC_Mod1A_TD;PPMod1A_T++,lp++)
	{
//	gte_ldv3(&PPMod1Vert->a ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert->b ,
//			 &PPMod1Vert->c);

	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_stsxy3_ft3(PPMod1A_T);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_T->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
 	*tag = ((u_long) (PPMod1A_T) & 0x00ffffff);
	}

// NEW GOURAUD FACES

	/************/
	/* GOURAUD rgb */
	/************/

	PPMod1A_G=&PMod1A_G[0];		// set tri face pointer to... rgb

	for (lp=0;lp<PC_Mod1A_G;PPMod1A_G++,lp++)
	{
	gte_ldv3c(&PPMod1Vert->a);		/* new load gte with 3 continuous xyz's of face */


	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue;

	gte_nclip();				// back face clip
	gte_stopz(&otz);
	if (otz <=0) continue;

	gte_stsxy3_g3(PPMod1A_G);	  // store screen xy's

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

	// put tag in ot
 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_G->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
 	*tag = ((u_long) (PPMod1A_G) & 0x00ffffff);
	}



	/************/
	/* GOURAUD rgb, double sided */
	/************/

	PPMod1A_G=&PMod1A_GD[0];	// set tri face pointer to... rgb double

	for (lp=0;lp<PC_Mod1A_GD;PPMod1A_G++,lp++)
	{
	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert++;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_stsxy3_g3(PPMod1A_G);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_G->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
 	*tag = ((u_long) (PPMod1A_G) & 0x00ffffff);
	}



	/************/
	/* GOURAUD textured */
	/************/

	PPMod1A_GT=&PMod1A_GT[0];		// set tri face pointer to... tex

	for (lp=0;lp<PC_Mod1A_GT;PPMod1A_GT++,lp++)
	{
	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_nclip();
	gte_stopz(&otz);
	if (otz <=0) continue;

	gte_stsxy3_gt3(PPMod1A_GT);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_GT->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1A_GT) & 0x00ffffff);
	}




	/************/
	/* GOURAUD textured, double sided */
	/************/

	PPMod1A_GT=&PMod1A_GTD[0];	// set tri face pointer to... tex double

	for (lp=0;lp<PC_Mod1A_GTD;PPMod1A_GT++,lp++)
	{
	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_stsxy3_gt3(PPMod1A_GT);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_GT->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1A_GT) & 0x00ffffff);
	}

// END NEW GOURAUD FACES



	/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
	/* ------------ quad faces next ------------- */
	/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */


	PPMod1Vert4=&PMod1Vert4[0];			// set the three quad vert pointers
	PPMod1Vert4_C1=&PMod1Vert4[1];		// to 1st 3 verts
	PPMod1Vert4_C2=&PMod1Vert4[2];


	/************/
	/* flat rgb */
	/************/

	PPMod1F_F=&PMod1F_F[0];				// set the three quad face pointers
	PPMod1F_F_L1=&PMod1F_F[1];			// to the 1st 3 rgb faces
	PPMod1F_F_L2=&PMod1F_F[2];

//	for (lp=0;lp<PC_Mod1F_F;lp+=3,PPMod1F_F+=3,PPMod1F_F_L1+=3,PPMod1F_F_L2+=3)
	for (lp=0;lp<PC_Mod1F_F;PPMod1F_F_L2+=3)
	{
	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
			 &PPMod1Vert4_C1->d ,
			 &PPMod1Vert4_C2->d);

	gte_rtpt();								/* do rot trans pers */
	lp+=3;
	gte_stsxy3(	&PPMod1F_F->x3,
			   	&PPMod1F_F_L1->x3,
			   	&PPMod1F_F_L2->x3);


	gte_ldv3c(&PPMod1Vert4->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PF2; /* */

	gte_stsxy3_f4(PPMod1F_F);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto okf1;
//	if (otz <=0) goto PF2;

//	gte_stsxy3_f4(PPMod1F_F);
	gte_ldsxy0(*(long *)&PPMod1F_F->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PF2;

okf1:

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F) & 0x00ffffff);

PF2:

	gte_ldv3c(&PPMod1Vert4_C1->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_F+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PF3; /* */

	gte_stsxy3_f4(PPMod1F_F_L1);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto okf2;
//	if (otz <=0) goto PF3;

	gte_ldsxy0(*(long *)&PPMod1F_F_L1->x3);

//	gte_stsxy3_f4(PPMod1F_F_L1);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PF3;

okf2:

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F_L1) & 0x00ffffff);

PF3:
	gte_ldv3c(&PPMod1Vert4_C2->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_F_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PF4; /* */

	gte_stsxy3_f4(PPMod1F_F_L2);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto okf3;
//	if (otz <=0) goto PF4;

//	gte_stsxy3_f4(PPMod1F_F_L2);

	gte_ldsxy0(*(long *)&PPMod1F_F_L2->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PF4;

okf3:

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F_L2) & 0x00ffffff);

PF4:	  // now do extra vertex from each quad !
//	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert4_C1->d ,
//			 &PPMod1Vert4_C2->d);


//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_F->x3,
//			   	&PPMod1F_F_L1->x3,
//			   	&PPMod1F_F_L2->x3);
	}


	/************/
	/* flat rgb, double sided */
	/************/

	PPMod1F_F=&PMod1F_FD[0];		// set the three quad face pointers
	PPMod1F_F_L1=&PMod1F_FD[1];		// to the 1st 3 rgb double faces
	PPMod1F_F_L2=&PMod1F_FD[2];

	for (lp=0;lp<PC_Mod1F_FD;PPMod1F_F_L2+=3)
	{

	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
			 &PPMod1Vert4_C1->d ,
			 &PPMod1Vert4_C2->d);

	gte_rtpt();
	lp+=3;


	gte_stsxy3(	&PPMod1F_F->x3,
			   	&PPMod1F_F_L1->x3,
			   	&PPMod1F_F_L2->x3);


	gte_ldv3c(&PPMod1Vert4->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PFD2; /* */

	gte_stsxy3_f4(PPMod1F_F);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F) & 0x00ffffff);

PFD2:
	gte_ldv3c(&PPMod1Vert4_C1->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_F+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PFD3; /* */

	gte_stsxy3_f4(PPMod1F_F_L1);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F_L1) & 0x00ffffff);

PFD3:

	gte_ldv3c(&PPMod1Vert4_C2->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_F_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PFD4; /* */

	gte_stsxy3_f4(PPMod1F_F_L2);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F_L2) & 0x00ffffff);

PFD4:	  // now do extra vertex from each quad !
//	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
 //			 &PPMod1Vert4_C1->d ,
//			 &PPMod1Vert4_C2->d);

//	gte_rtpt();
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_F->x3,
//			   	&PPMod1F_F_L1->x3,
//			   	&PPMod1F_F_L2->x3);
	}


	/************/
	/* NEW textured */
	/************/

	PPMod1F_T=&PMod1F_T[0];			// set the three quad face pointers
	PPMod1F_T_L1=&PMod1F_T[1];		// to the 1st 3 tex faces
	PPMod1F_T_L2=&PMod1F_T[2];

//	for (lp=0;lp<PC_Mod1F_T;lp+=3,PPMod1F_T+=3,PPMod1F_T_L1+=3,PPMod1F_T_L2+=3)
	for (lp=0;lp<PC_Mod1F_T;PPMod1F_T_L2+=3)
	{
	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
			  &(PPMod1Vert4_C1->d) ,
			  &(PPMod1Vert4_C2->d) );

	gte_rtpt();								/* do rot trans pers */
	lp+=3;

	gte_stsxy3(	&PPMod1F_T->x3,
			   	&PPMod1F_T_L1->x3,
			   	&PPMod1F_T_L2->x3);

#if XYCLIPON
	// new clip
	if 	((	( (*(short *)&PPMod1F_T->x3) <200 )&&
			( (*(short *)&PPMod1F_T->x3) >-200 ) )
		 &&
	 	 (	( (*(short *)&PPMod1F_T->y3) <100 )&&
			( (*(short *)&PPMod1F_T->y3) >-100 ) )
		) goto c1;
	PPMod1Vert4+=3;
	goto PT2;
#endif

c1:	gte_ldv3c(&(PPMod1Vert4->a));	  // new 3 continuous svector vertices

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PT2; /* */

	// new pos
	gte_stsxy3_ft4(PPMod1F_T);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto ok1;
	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_T->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT2;


ok1:
//	gte_stsxy3_ft4(PPMod1F_T);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T) & 0x00ffffff);

PT2:
#if XYCLIPON
	// new clip
	if	((	( (*(short *)&PPMod1F_T_L1->x3) <200 )&&
			( (*(short *)&PPMod1F_T_L1->x3) >-200 ) )
		 &&
		 (	( (*(short *)&PPMod1F_T_L1->y3) <100 )&&
			( (*(short *)&PPMod1F_T_L1->y3) >-100 ) )
		) goto c2;
	PPMod1Vert4_C1+=3;
	PPMod1F_T+=3;
	goto PT3;
#endif

c2:	gte_ldv3c( &(PPMod1Vert4_C1->a));		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_T+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PT3; /* */

	// new pos
	gte_stsxy3_ft4(PPMod1F_T_L1);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto ok2;

	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_T_L1->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT3;

ok2:
//	gte_stsxy3_ft4(PPMod1F_T_L1);


	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T_L1) & 0x00ffffff);

PT3:
#if XYCLIPON
	// new clip
	if	((	( (*(short *)&PPMod1F_T_L2->x3) <200 )&&
			( (*(short *)&PPMod1F_T_L2->x3) >-200 ) )
		 &&
		 (	( (*(short *)&PPMod1F_T_L2->y3) <100 )&&
			( (*(short *)&PPMod1F_T_L2->y3) >-100 ) )
		) goto c3;
	PPMod1Vert4_C2+=3;
	PPMod1F_T_L1+=3;
	goto PT4;
#endif

c3:	gte_ldv3c( &(PPMod1Vert4_C2->a));		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_T_L1+=3;

	gte_stflg(&flag);						/* store flag */
 	if (flag & 0x80000000) goto PT4; /* */

	// new pos
	gte_stsxy3_ft4(PPMod1F_T_L2);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto ok3;

	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_T_L2->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT4;

ok3:
//	gte_stsxy3_ft4(PPMod1F_T_L2);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T_L2) & 0x00ffffff);

PT4:	  // now do extra vertex from each quad !
//	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
//			  &(PPMod1Vert4_C1->d) ,
//			  &(PPMod1Vert4_C2->d) );

//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_T->x3,
//			   	&PPMod1F_T_L1->x3,
//			   	&PPMod1F_T_L2->x3);

	}




	/************/
	/* textured, double sided */
	/************/

	PPMod1F_T=&PMod1F_TD[0];		// set the three quad face pointers
	PPMod1F_T_L1=&PMod1F_TD[1];		// to the 1st 3 tex double faces
	PPMod1F_T_L2=&PMod1F_TD[2];

//	for (lp=0;lp<PC_Mod1F_TD;lp+=3,PPMod1F_T+=3,PPMod1F_T_L1+=3,PPMod1F_T_L2+=3)
	for (lp=0;lp<PC_Mod1F_TD;PPMod1F_T_L2+=3)
	{
	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
			  &(PPMod1Vert4_C1->d) ,
			  &(PPMod1Vert4_C2->d) );


	gte_rtpt();								/* do rot trans pers */
	lp+=3;


	gte_stsxy3(	&PPMod1F_T->x3,
			   	&PPMod1F_T_L1->x3,
			   	&PPMod1F_T_L2->x3);


	gte_ldv3c( &PPMod1Vert4->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PTD2; /* */

	gte_stsxy3_ft4(PPMod1F_T);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T) & 0x00ffffff);

PTD2:
	gte_ldv3c( &(PPMod1Vert4_C1->a) );		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_T+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PTD3; /* */

	gte_stsxy3_ft4(PPMod1F_T_L1);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T_L1) & 0x00ffffff);

PTD3:
	gte_ldv3c( &(PPMod1Vert4_C2->a) );		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_T_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PTD4; /* */

	gte_stsxy3_ft4(PPMod1F_T_L2);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T_L2) & 0x00ffffff);

PTD4:	  // now do extra vertex from each quad !
//	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
//			  &(PPMod1Vert4_C1->d) ,
//			  &(PPMod1Vert4_C2->d) );


//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_T->x3,
//			   	&PPMod1F_T_L1->x3,
//			   	&PPMod1F_T_L2->x3);
	}




// NEW GOURAUD 4

	/************/
	/* GOURAUD rgb */
	/************/

	PPMod1F_G=&PMod1F_G[0];				// set the three quad face pointers
	PPMod1F_G_L1=&PMod1F_G[1];			// to the 1st 3 rgb faces
	PPMod1F_G_L2=&PMod1F_G[2];

//	for (lp=0;lp<PC_Mod1F_G;lp+=3,PPMod1F_G+=3,PPMod1F_G_L1+=3,PPMod1F_G_L2+=3)
	for (lp=0;lp<PC_Mod1F_G;PPMod1F_G_L2+=3)
	{
	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
			 &PPMod1Vert4_C1->d ,
			 &PPMod1Vert4_C2->d);

	gte_rtpt();								/* do rot trans pers */
	lp+=3;

	gte_stsxy3(	&PPMod1F_G->x3,
			   	&PPMod1F_G_L1->x3,
			   	&PPMod1F_G_L2->x3);


	gte_ldv3c(&PPMod1Vert4->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PG2; /* */

	gte_stsxy3_g4(PPMod1F_G);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto okg1;
//	if (otz <=0) goto PG2;

//	gte_stsxy3_g4(PPMod1F_G);

	gte_ldsxy0(*(long *)&PPMod1F_G->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PG2;

okg1:

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


//	OTSkip[(otz>>7)]=1;

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G) & 0x00ffffff);

PG2:
	gte_ldv3c(&PPMod1Vert4_C1->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_G+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PG3; /* */

	gte_stsxy3_g4(PPMod1F_G_L1);

	gte_nclip();
	gte_stopz(&otz);
//	if (otz <=0) goto PG3;
	if (otz >0) goto okg2;

//	gte_stsxy3_g4(PPMod1F_G_L1);
	gte_ldsxy0(*(long *)&PPMod1F_G_L1->x3);

	gte_nclip();
	gte_stopz(&otz);
//	if (otz <=0) goto PG3;
	if (otz >0) goto PG3;

okg2:

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

//	OTSkip[(otz>>7)]=1;

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G_L1) & 0x00ffffff);

PG3:
	gte_ldv3c(&PPMod1Vert4_C2->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_G_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PG4; /* */

	gte_stsxy3_g4(PPMod1F_G_L2);

	gte_nclip();
	gte_stopz(&otz);
//	if (otz <=0) goto PG4;
	if (otz >0) goto okg3;

//	gte_stsxy3_g4(PPMod1F_G_L2);

	gte_ldsxy0(*(long *)&PPMod1F_G_L2->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PG4;

okg3:

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

//	OTSkip[(otz>>7)]=1;

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G_L2) & 0x00ffffff);

PG4:	  // now do extra vertex from each quad !
//	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert4_C1->d ,
//			 &PPMod1Vert4_C2->d);


//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_G->x3,
//			   	&PPMod1F_G_L1->x3,
//			   	&PPMod1F_G_L2->x3);
	}



	/************/
	/* GOURAUD rgb, double sided */
	/************/

	PPMod1F_G=&PMod1F_GD[0];		// set the three quad face pointers
	PPMod1F_G_L1=&PMod1F_GD[1];		// to the 1st 3 rgb double faces
	PPMod1F_G_L2=&PMod1F_GD[2];

//	for (lp=0;lp<PC_Mod1F_GD;lp+=3,PPMod1F_G+=3,PPMod1F_G_L1+=3,PPMod1F_G_L2+=3)
	for (lp=0;lp<PC_Mod1F_GD;PPMod1F_G_L2+=3)
	{
	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
			 &PPMod1Vert4_C1->d ,
			 &PPMod1Vert4_C2->d);

	gte_rtpt();
	lp+=3;


	gte_stsxy3(	&PPMod1F_G->x3,
			   	&PPMod1F_G_L1->x3,
			   	&PPMod1F_G_L2->x3);


	gte_ldv3c(&PPMod1Vert4->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGD2; /* */

	gte_stsxy3_g4(PPMod1F_G);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G) & 0x00ffffff);

PGD2:
	gte_ldv3c(&PPMod1Vert4_C1->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_G+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGD3; /* */

	gte_stsxy3_g4(PPMod1F_G_L1);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G_L1) & 0x00ffffff);

PGD3:
	gte_ldv3c(&PPMod1Vert4_C2->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_G_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGD4; /* */

	gte_stsxy3_g4(PPMod1F_G_L2);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G_L2) & 0x00ffffff);

PGD4:	  // now do extra vertex from each quad !
//	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert4_C1->d ,
//			 &PPMod1Vert4_C2->d);

//	gte_rtpt();
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_G->x3,
//			   	&PPMod1F_G_L1->x3,
//			   	&PPMod1F_G_L2->x3);
	}


	// GOURAUD!
	/************/
	/* NEW textured */
	/************/

	PPMod1F_GT=&PMod1F_GT[0];			// set the three quad face pointers
	PPMod1F_GT_L1=&PMod1F_GT[1];		// to the 1st 3 tex faces
	PPMod1F_GT_L2=&PMod1F_GT[2];

	for (lp=0;lp<PC_Mod1F_GT;PPMod1F_GT_L2+=3)
	{
	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
			  &(PPMod1Vert4_C1->d) ,
			  &(PPMod1Vert4_C2->d) );

	gte_rtpt();								/* do rot trans pers */
	lp+=3;

	gte_stsxy3(	&PPMod1F_GT->x3,
			   	&PPMod1F_GT_L1->x3,
			   	&PPMod1F_GT_L2->x3);


	gte_ldv3c(&(PPMod1Vert4->a));	  // new 3 continuous svector vertices

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGT2; /* */

	// new pos
	gte_stsxy3_gt4(PPMod1F_GT);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok1;
	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_GT->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT2;

Gok1:
//	gte_stsxy3_ft4(PPMod1F_T);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT) & 0x00ffffff);

PGT2:
	gte_ldv3c( &(PPMod1Vert4_C1->a));		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_GT+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGT3; /* */

	// new pos
	gte_stsxy3_gt4(PPMod1F_GT_L1);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok2;

	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_GT_L1->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT3;

Gok2:
//	gte_stsxy3_ft4(PPMod1F_T_L1);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT_L1) & 0x00ffffff);

PGT3:
	gte_ldv3c( &(PPMod1Vert4_C2->a));		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_GT_L1+=3;

	gte_stflg(&flag);						/* store flag */
 	if (flag & 0x80000000) goto PGT4; /* */

	// new pos
	gte_stsxy3_gt4(PPMod1F_GT_L2);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok3;

	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_GT_L2->x3);


	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT4;

Gok3:
//	gte_stsxy3_ft4(PPMod1F_T_L2);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT_L2) & 0x00ffffff);

PGT4:	  // now do extra vertex from each quad !
//	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
//			  &(PPMod1Vert4_C1->d) ,
//			  &(PPMod1Vert4_C2->d) );

//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_T->x3,
//			   	&PPMod1F_T_L1->x3,
//			   	&PPMod1F_T_L2->x3);

	}



	/************/
	/* GOURAUD textured, double sided */
	/************/

	PPMod1F_GT=&PMod1F_GTD[0];		// set the three quad face pointers
	PPMod1F_GT_L1=&PMod1F_GTD[1];		// to the 1st 3 tex double faces
	PPMod1F_GT_L2=&PMod1F_GTD[2];

//	for (lp=0;lp<PC_Mod1F_GTD;lp+=3,PPMod1F_GT+=3,PPMod1F_GT_L1+=3,PPMod1F_GT_L2+=3)
	for (lp=0;lp<PC_Mod1F_GTD;PPMod1F_GT_L2+=3)
	{
	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
			  &(PPMod1Vert4_C1->d) ,
			  &(PPMod1Vert4_C2->d) );


	gte_rtpt();								/* do rot trans pers */
	lp+=3;


	gte_stsxy3(	&PPMod1F_GT->x3,
			   	&PPMod1F_GT_L1->x3,
			   	&PPMod1F_GT_L2->x3);

	gte_ldv3c( &PPMod1Vert4->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGTD2; /* */

	gte_stsxy3_gt4(PPMod1F_GT);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT) & 0x00ffffff);

PGTD2:
	gte_ldv3c( &(PPMod1Vert4_C1->a) );		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_GT+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGTD3; /* */

	gte_stsxy3_gt4(PPMod1F_GT_L1);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT_L1) & 0x00ffffff);

PGTD3:
	gte_ldv3c( &(PPMod1Vert4_C2->a) );		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_GT_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGTD4; /* */

	gte_stsxy3_gt4(PPMod1F_GT_L2);

	switch (Sort)
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far  sort
 	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT_L2) & 0x00ffffff);

PGTD4:	  // now do extra vertex from each quad !
//	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
//			  &(PPMod1Vert4_C1->d) ,
//			  &(PPMod1Vert4_C2->d) );


//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_GT->x3,
//			   	&PPMod1F_GT_L1->x3,
//			   	&PPMod1F_GT_L2->x3);
	}

// END GOURAUD 4


}





#if 0	// take out old print
		// new one above does multiple sort points 0-average 1-near 2-far

/*
 ** SdModelPrint
 *
 *  FILENAME: c:\ps\sdlib\gtefile.c
 *
 *  PARAMETERS: pointer to sd file, what model within data, current double buffer
 *
 *  DESCRIPTION: sort model to WOT ready for printing, using current WS matrix
 *
 *  RETURNS:
 *
 */
void SdModelPrint(u_long *MemPointer,u_char md,GsOT *OT,u_char idx)
{

register	long 		*tag;
register	int			lp;
register	GsOT_TAG	*WOT;

register	POLY_FT4	*PPMod1F_T;
register	POLY_FT4	*PPMod1F_T_L1;
register	POLY_FT4	*PPMod1F_T_L2;

register	POLY_F4		*PPMod1F_F;
register	POLY_F4		*PPMod1F_F_L1;
register	POLY_F4		*PPMod1F_F_L2;

// NEW
register	POLY_GT4	*PPMod1F_GT;
register	POLY_GT4	*PPMod1F_GT_L1;
register	POLY_GT4	*PPMod1F_GT_L2;

register	POLY_G4		*PPMod1F_G;
register	POLY_G4		*PPMod1F_G_L1;
register	POLY_G4		*PPMod1F_G_L2;
//

register	FACE_VERT4	*PPMod1Vert4;
register	FACE_VERT4	*PPMod1Vert4_C1;
register	FACE_VERT4	*PPMod1Vert4_C2;

register	FACE_VERT	*PPMod1Vert;
register	POLY_F3		*PPMod1A_F;
register	POLY_FT3	*PPMod1A_T;

// NEW
register	POLY_G3		*PPMod1A_G;
register	POLY_GT3	*PPMod1A_GT;
//

register	u_long		OTSHIFT;

u_long		Maped;
u_long		PolyBufferSize;
u_long		PolyBufferOffset;


#define xyclip 0


	WOT=OT[idx].org;   // set ot and size
	OTSHIFT=14-OT[idx].length;


	MemPointer++;				  // get past num objects in file
	PolyBufferSize=*MemPointer++; // size of all face packet info in 1 buffer
	Maped=*MemPointer++;		  // is data maped to mem
	if (Maped)
	{
//	MemPointer+=(md*18);		// move pointer to corect model header within data
	MemPointer+=(md*34);		// move pointer to corect model header within data

	PolyBufferOffset=(idx*PolyBufferSize);	// set what buffer we are working on 0/1

	PMod1Vert=(FACE_VERT *)*MemPointer++;
	PMod1A_F=(POLY_F3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_F=*MemPointer++;
	PMod1A_FD=(POLY_F3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_FD=*MemPointer++;
	PMod1A_T=(POLY_FT3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_T=*MemPointer++;
	PMod1A_TD=(POLY_FT3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_TD=*MemPointer++;

// NEW
	PMod1A_G=(POLY_G3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_G=*MemPointer++;
	PMod1A_GD=(POLY_G3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_GD=*MemPointer++;
	PMod1A_GT=(POLY_GT3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_GT=*MemPointer++;
	PMod1A_GTD=(POLY_GT3 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1A_GTD=*MemPointer++;
//

	PMod1Vert4=(FACE_VERT4 *)*MemPointer++;
	PMod1F_F=(POLY_F4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_F=*MemPointer++;
	PMod1F_FD=(POLY_F4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_FD=*MemPointer++;
	PMod1F_T=(POLY_FT4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_T=*MemPointer++;
	PMod1F_TD=(POLY_FT4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_TD=*MemPointer++;

// NEW
	PMod1F_G=(POLY_G4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_G=*MemPointer++;
	PMod1F_GD=(POLY_G4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_GD=*MemPointer++;
	PMod1F_GT=(POLY_GT4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_GT=*MemPointer++;
	PMod1F_GTD=(POLY_GT4 *)(u_long)((*MemPointer++)+PolyBufferOffset);
	PC_Mod1F_GTD=*MemPointer++;
//
	}


	/* ------------ tri faces first ------------- */


	PPMod1Vert=&PMod1Vert[0];  // set tri vert pointer

	/************/
	/* flat rgb */
	/************/

	PPMod1A_F=&PMod1A_F[0];		// set tri face pointer to... rgb

	for (lp=0;lp<PC_Mod1A_F;PPMod1A_F++,lp++)
	{
//	gte_ldv3(&PPMod1Vert->a ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert->b ,
//			 &PPMod1Vert->c);

	gte_ldv3c(&PPMod1Vert->a);		/* new load gte with 3 continuous xyz's of face */


	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue;

	gte_nclip();				// back face clip
	gte_stopz(&otz);
	if (otz <=0) continue;

	gte_stsxy3_f3(PPMod1A_F);	  // store screen xy's

#if xyclip
	/* x's 2d virtices off edge of screen ? */
	minmax3(Mod1A_F[md][outbuf_idx][lp].x0,
			Mod1A_F[md][outbuf_idx][lp].x1,
			Mod1A_F[md][outbuf_idx][lp].x2,minx,maxx);

	if((maxx<-half_width) || (minx>half_width)) /* W clip */
    continue;											  /* whole poly is off screen */

	/* y's ? */
	minmax3(Mod1A_F[md][outbuf_idx][lp].y0,
			Mod1A_F[md][outbuf_idx][lp].y1,
			Mod1A_F[md][outbuf_idx][lp].y2,miny,maxy);

 	if((maxy<-half_height) || (miny>half_height)) /* H clip */
    continue;
#endif

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

#if 0		/* this is sort by min or max z point */
 	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);
 	minmax3(sz3[0],sz3[1],sz3[2],minz,otz);
	otz=minz>>2;
#endif

	// put tag in ot
 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_F->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
 	*tag = ((u_long) (PPMod1A_F) & 0x00ffffff);
	}



	/************/
	/* flat rgb, double sided */
	/************/

	PPMod1A_F=&PMod1A_FD[0];	// set tri face pointer to... rgb double

	for (lp=0;lp<PC_Mod1A_FD;PPMod1A_F++,lp++)
	{
//	gte_ldv3(&PPMod1Vert->a ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert->b ,
//			 &PPMod1Vert->c);

	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert++;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_stsxy3_f3(PPMod1A_F);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_F->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
 	*tag = ((u_long) (PPMod1A_F) & 0x00ffffff);
	}





	/************/
	/* textured */
	/************/

	PPMod1A_T=&PMod1A_T[0];		// set tri face pointer to... tex

	for (lp=0;lp<PC_Mod1A_T;PPMod1A_T++,lp++)
	{
//	gte_ldv3(&PPMod1Vert->a ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert->b ,
//			 &PPMod1Vert->c);

	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_nclip();
	gte_stopz(&otz);
	if (otz <=0) continue;

	gte_stsxy3_ft3(PPMod1A_T);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_T->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
 	*tag = ((u_long) (PPMod1A_T) & 0x00ffffff);
	}




	/************/
	/* textured, double sided */
	/************/

	PPMod1A_T=&PMod1A_TD[0];	// set tri face pointer to... tex double

	for (lp=0;lp<PC_Mod1A_TD;PPMod1A_T++,lp++)
	{
//	gte_ldv3(&PPMod1Vert->a ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert->b ,
//			 &PPMod1Vert->c);

	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_stsxy3_ft3(PPMod1A_T);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_T->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
 	*tag = ((u_long) (PPMod1A_T) & 0x00ffffff);
	}

// NEW GOURAUD FACES

	/************/
	/* GOURAUD rgb */
	/************/

	PPMod1A_G=&PMod1A_G[0];		// set tri face pointer to... rgb

	for (lp=0;lp<PC_Mod1A_G;PPMod1A_G++,lp++)
	{
	gte_ldv3c(&PPMod1Vert->a);		/* new load gte with 3 continuous xyz's of face */


	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue;

	gte_nclip();				// back face clip
	gte_stopz(&otz);
	if (otz <=0) continue;

	gte_stsxy3_g3(PPMod1A_G);	  // store screen xy's

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

	// put tag in ot
 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_G->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
 	*tag = ((u_long) (PPMod1A_G) & 0x00ffffff);
	}



	/************/
	/* GOURAUD rgb, double sided */
	/************/

	PPMod1A_G=&PMod1A_GD[0];	// set tri face pointer to... rgb double

	for (lp=0;lp<PC_Mod1A_GD;PPMod1A_G++,lp++)
	{
	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert++;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_stsxy3_g3(PPMod1A_G);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_G->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
 	*tag = ((u_long) (PPMod1A_G) & 0x00ffffff);
	}



	/************/
	/* GOURAUD textured */
	/************/

	PPMod1A_GT=&PMod1A_GT[0];		// set tri face pointer to... tex

	for (lp=0;lp<PC_Mod1A_GT;PPMod1A_GT++,lp++)
	{
	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_nclip();
	gte_stopz(&otz);
	if (otz <=0) continue;

	gte_stsxy3_gt3(PPMod1A_GT);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_GT->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1A_GT) & 0x00ffffff);
	}




	/************/
	/* GOURAUD textured, double sided */
	/************/

	PPMod1A_GT=&PMod1A_GTD[0];	// set tri face pointer to... tex double

	for (lp=0;lp<PC_Mod1A_GTD;PPMod1A_GT++,lp++)
	{
	gte_ldv3c(&PPMod1Vert->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();
	PPMod1Vert++;					/* do rot trans pers */

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) continue; /* */

	gte_stsxy3_gt3(PPMod1A_GT);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1A_GT->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1A_GT) & 0x00ffffff);
	}

// END NEW GOURAUD FACES



	/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
	/* ------------ quad faces next ------------- */
	/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */


	PPMod1Vert4=&PMod1Vert4[0];			// set the three quad vert pointers
	PPMod1Vert4_C1=&PMod1Vert4[1];		// to 1st 3 verts
	PPMod1Vert4_C2=&PMod1Vert4[2];


	/************/
	/* flat rgb */
	/************/

	PPMod1F_F=&PMod1F_F[0];				// set the three quad face pointers
	PPMod1F_F_L1=&PMod1F_F[1];			// to the 1st 3 rgb faces
	PPMod1F_F_L2=&PMod1F_F[2];

//	for (lp=0;lp<PC_Mod1F_F;lp+=3,PPMod1F_F+=3,PPMod1F_F_L1+=3,PPMod1F_F_L2+=3)
	for (lp=0;lp<PC_Mod1F_F;PPMod1F_F_L2+=3)
	{
	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
			 &PPMod1Vert4_C1->d ,
			 &PPMod1Vert4_C2->d);

	gte_rtpt();								/* do rot trans pers */
	lp+=3;
	gte_stsxy3(	&PPMod1F_F->x3,
			   	&PPMod1F_F_L1->x3,
			   	&PPMod1F_F_L2->x3);


	gte_ldv3c(&PPMod1Vert4->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PF2; /* */

	gte_stsxy3_f4(PPMod1F_F);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto okf1;
//	if (otz <=0) goto PF2;

//	gte_stsxy3_f4(PPMod1F_F);
	gte_ldsxy0(*(long *)&PPMod1F_F->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PF2;

okf1:
	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F) & 0x00ffffff);

PF2:

	gte_ldv3c(&PPMod1Vert4_C1->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_F+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PF3; /* */

	gte_stsxy3_f4(PPMod1F_F_L1);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto okf2;
//	if (otz <=0) goto PF3;

	gte_ldsxy0(*(long *)&PPMod1F_F_L1->x3);

//	gte_stsxy3_f4(PPMod1F_F_L1);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PF3;

okf2:
	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz); 	   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F_L1) & 0x00ffffff);

PF3:
	gte_ldv3c(&PPMod1Vert4_C2->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_F_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PF4; /* */

	gte_stsxy3_f4(PPMod1F_F_L2);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto okf3;
//	if (otz <=0) goto PF4;

//	gte_stsxy3_f4(PPMod1F_F_L2);

	gte_ldsxy0(*(long *)&PPMod1F_F_L2->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PF4;

okf3:
	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz); 	   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F_L2) & 0x00ffffff);

PF4:	  // now do extra vertex from each quad !
//	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert4_C1->d ,
//			 &PPMod1Vert4_C2->d);


//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_F->x3,
//			   	&PPMod1F_F_L1->x3,
//			   	&PPMod1F_F_L2->x3);
	}


	/************/
	/* flat rgb, double sided */
	/************/

	PPMod1F_F=&PMod1F_FD[0];		// set the three quad face pointers
	PPMod1F_F_L1=&PMod1F_FD[1];		// to the 1st 3 rgb double faces
	PPMod1F_F_L2=&PMod1F_FD[2];

//	for (lp=0;lp<PC_Mod1F_FD;lp+=3,PPMod1F_F+=3,PPMod1F_F_L1+=3,PPMod1F_F_L2+=3)
	for (lp=0;lp<PC_Mod1F_FD;PPMod1F_F_L2+=3)
	{

	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
			 &PPMod1Vert4_C1->d ,
			 &PPMod1Vert4_C2->d);

	gte_rtpt();
	lp+=3;


	gte_stsxy3(	&PPMod1F_F->x3,
			   	&PPMod1F_F_L1->x3,
			   	&PPMod1F_F_L2->x3);


	gte_ldv3c(&PPMod1Vert4->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PFD2; /* */

	gte_stsxy3_f4(PPMod1F_F);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F) & 0x00ffffff);

PFD2:
	gte_ldv3c(&PPMod1Vert4_C1->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_F+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PFD3; /* */

	gte_stsxy3_f4(PPMod1F_F_L1);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F_L1) & 0x00ffffff);

PFD3:

	gte_ldv3c(&PPMod1Vert4_C2->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_F_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PFD4; /* */

	gte_stsxy3_f4(PPMod1F_F_L2);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_F_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
 	*tag = ((u_long) (PPMod1F_F_L2) & 0x00ffffff);

PFD4:	  // now do extra vertex from each quad !
//	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
 //			 &PPMod1Vert4_C1->d ,
//			 &PPMod1Vert4_C2->d);

//	gte_rtpt();
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_F->x3,
//			   	&PPMod1F_F_L1->x3,
//			   	&PPMod1F_F_L2->x3);
	}


	/************/
	/* NEW textured */
	/************/

	PPMod1F_T=&PMod1F_T[0];			// set the three quad face pointers
	PPMod1F_T_L1=&PMod1F_T[1];		// to the 1st 3 tex faces
	PPMod1F_T_L2=&PMod1F_T[2];

//	for (lp=0;lp<PC_Mod1F_T;lp+=3,PPMod1F_T+=3,PPMod1F_T_L1+=3,PPMod1F_T_L2+=3)
	for (lp=0;lp<PC_Mod1F_T;PPMod1F_T_L2+=3)
	{
	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
			  &(PPMod1Vert4_C1->d) ,
			  &(PPMod1Vert4_C2->d) );

	gte_rtpt();								/* do rot trans pers */
	lp+=3;

	gte_stsxy3(	&PPMod1F_T->x3,
			   	&PPMod1F_T_L1->x3,
			   	&PPMod1F_T_L2->x3);


	gte_ldv3c(&(PPMod1Vert4->a));	  // new 3 continuous svector vertices

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PT2; /* */

	// new pos
	gte_stsxy3_ft4(PPMod1F_T);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto ok1;
	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_T->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT2;


ok1:
//	gte_stsxy3_ft4(PPMod1F_T);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T) & 0x00ffffff);

PT2:
	gte_ldv3c( &(PPMod1Vert4_C1->a));		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_T+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PT3; /* */

	// new pos
	gte_stsxy3_ft4(PPMod1F_T_L1);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto ok2;

	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_T_L1->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT3;

ok2:
//	gte_stsxy3_ft4(PPMod1F_T_L1);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T_L1) & 0x00ffffff);

PT3:
	gte_ldv3c( &(PPMod1Vert4_C2->a));		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_T_L1+=3;

	gte_stflg(&flag);						/* store flag */
 	if (flag & 0x80000000) goto PT4; /* */

	// new pos
	gte_stsxy3_ft4(PPMod1F_T_L2);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto ok3;

	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_T_L2->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT4;

ok3:
//	gte_stsxy3_ft4(PPMod1F_T_L2);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T_L2) & 0x00ffffff);

PT4:	  // now do extra vertex from each quad !
//	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
//			  &(PPMod1Vert4_C1->d) ,
//			  &(PPMod1Vert4_C2->d) );

//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_T->x3,
//			   	&PPMod1F_T_L1->x3,
//			   	&PPMod1F_T_L2->x3);

	}




	/************/
	/* textured, double sided */
	/************/

	PPMod1F_T=&PMod1F_TD[0];		// set the three quad face pointers
	PPMod1F_T_L1=&PMod1F_TD[1];		// to the 1st 3 tex double faces
	PPMod1F_T_L2=&PMod1F_TD[2];

//	for (lp=0;lp<PC_Mod1F_TD;lp+=3,PPMod1F_T+=3,PPMod1F_T_L1+=3,PPMod1F_T_L2+=3)
	for (lp=0;lp<PC_Mod1F_TD;PPMod1F_T_L2+=3)
	{
	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
			  &(PPMod1Vert4_C1->d) ,
			  &(PPMod1Vert4_C2->d) );


	gte_rtpt();								/* do rot trans pers */
	lp+=3;


	gte_stsxy3(	&PPMod1F_T->x3,
			   	&PPMod1F_T_L1->x3,
			   	&PPMod1F_T_L2->x3);


	gte_ldv3c( &PPMod1Vert4->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PTD2; /* */

	gte_stsxy3_ft4(PPMod1F_T);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T) & 0x00ffffff);

PTD2:
	gte_ldv3c( &(PPMod1Vert4_C1->a) );		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_T+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PTD3; /* */

	gte_stsxy3_ft4(PPMod1F_T_L1);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T_L1) & 0x00ffffff);

PTD3:
	gte_ldv3c( &(PPMod1Vert4_C2->a) );		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_T_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PTD4; /* */

	gte_stsxy3_ft4(PPMod1F_T_L2);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_T_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
 	*tag = ((u_long) (PPMod1F_T_L2) & 0x00ffffff);

PTD4:	  // now do extra vertex from each quad !
//	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
//			  &(PPMod1Vert4_C1->d) ,
//			  &(PPMod1Vert4_C2->d) );


//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_T->x3,
//			   	&PPMod1F_T_L1->x3,
//			   	&PPMod1F_T_L2->x3);
	}




// NEW GOURAUD 4

	/************/
	/* GOURAUD rgb */
	/************/

	PPMod1F_G=&PMod1F_G[0];				// set the three quad face pointers
	PPMod1F_G_L1=&PMod1F_G[1];			// to the 1st 3 rgb faces
	PPMod1F_G_L2=&PMod1F_G[2];

//	for (lp=0;lp<PC_Mod1F_G;lp+=3,PPMod1F_G+=3,PPMod1F_G_L1+=3,PPMod1F_G_L2+=3)
	for (lp=0;lp<PC_Mod1F_G;PPMod1F_G_L2+=3)
	{
	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
			 &PPMod1Vert4_C1->d ,
			 &PPMod1Vert4_C2->d);

	gte_rtpt();								/* do rot trans pers */
	lp+=3;

	gte_stsxy3(	&PPMod1F_G->x3,
			   	&PPMod1F_G_L1->x3,
			   	&PPMod1F_G_L2->x3);


	gte_ldv3c(&PPMod1Vert4->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PG2; /* */

	gte_stsxy3_g4(PPMod1F_G);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto okg1;
//	if (otz <=0) goto PG2;

//	gte_stsxy3_g4(PPMod1F_G);

	gte_ldsxy0(*(long *)&PPMod1F_G->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PG2;

okg1:
	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G) & 0x00ffffff);

PG2:
	gte_ldv3c(&PPMod1Vert4_C1->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_G+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PG3; /* */

	gte_stsxy3_g4(PPMod1F_G_L1);

	gte_nclip();
	gte_stopz(&otz);
//	if (otz <=0) goto PG3;
	if (otz >0) goto okg2;

//	gte_stsxy3_g4(PPMod1F_G_L1);
	gte_ldsxy0(*(long *)&PPMod1F_G_L1->x3);

	gte_nclip();
	gte_stopz(&otz);
//	if (otz <=0) goto PG3;
	if (otz >0) goto PG3;

okg2:
	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz); 	   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G_L1) & 0x00ffffff);

PG3:
	gte_ldv3c(&PPMod1Vert4_C2->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_G_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PG4; /* */

	gte_stsxy3_g4(PPMod1F_G_L2);

	gte_nclip();
	gte_stopz(&otz);
//	if (otz <=0) goto PG4;
	if (otz >0) goto okg3;

//	gte_stsxy3_g4(PPMod1F_G_L2);

	gte_ldsxy0(*(long *)&PPMod1F_G_L2->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PG4;

okg3:
	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz); 	   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G_L2) & 0x00ffffff);

PG4:	  // now do extra vertex from each quad !
//	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert4_C1->d ,
//			 &PPMod1Vert4_C2->d);


//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_G->x3,
//			   	&PPMod1F_G_L1->x3,
//			   	&PPMod1F_G_L2->x3);
	}


	/************/
	/* GOURAUD rgb, double sided */
	/************/

	PPMod1F_G=&PMod1F_GD[0];		// set the three quad face pointers
	PPMod1F_G_L1=&PMod1F_GD[1];		// to the 1st 3 rgb double faces
	PPMod1F_G_L2=&PMod1F_GD[2];

//	for (lp=0;lp<PC_Mod1F_GD;lp+=3,PPMod1F_G+=3,PPMod1F_G_L1+=3,PPMod1F_G_L2+=3)
	for (lp=0;lp<PC_Mod1F_GD;PPMod1F_G_L2+=3)
	{
	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
			 &PPMod1Vert4_C1->d ,
			 &PPMod1Vert4_C2->d);

	gte_rtpt();
	lp+=3;


	gte_stsxy3(	&PPMod1F_G->x3,
			   	&PPMod1F_G_L1->x3,
			   	&PPMod1F_G_L2->x3);


	gte_ldv3c(&PPMod1Vert4->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGD2; /* */

	gte_stsxy3_g4(PPMod1F_G);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G) & 0x00ffffff);

PGD2:
	gte_ldv3c(&PPMod1Vert4_C1->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_G+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGD3; /* */

	gte_stsxy3_g4(PPMod1F_G_L1);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G_L1) & 0x00ffffff);

PGD3:
	gte_ldv3c(&PPMod1Vert4_C2->a);		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_G_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGD4; /* */

	gte_stsxy3_g4(PPMod1F_G_L2);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);   /* t */

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_G_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
 	*tag = ((u_long) (PPMod1F_G_L2) & 0x00ffffff);

PGD4:	  // now do extra vertex from each quad !
//	gte_ldv3(&PPMod1Vert4->d ,		/* load gte with 3 xyz's of face */
//			 &PPMod1Vert4_C1->d ,
//			 &PPMod1Vert4_C2->d);

//	gte_rtpt();
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_G->x3,
//			   	&PPMod1F_G_L1->x3,
//			   	&PPMod1F_G_L2->x3);
	}


	// GOURAUD!
	/************/
	/* NEW textured */
	/************/

	PPMod1F_GT=&PMod1F_GT[0];			// set the three quad face pointers
	PPMod1F_GT_L1=&PMod1F_GT[1];		// to the 1st 3 tex faces
	PPMod1F_GT_L2=&PMod1F_GT[2];

	for (lp=0;lp<PC_Mod1F_GT;PPMod1F_GT_L2+=3)
	{
	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
			  &(PPMod1Vert4_C1->d) ,
			  &(PPMod1Vert4_C2->d) );

	gte_rtpt();								/* do rot trans pers */
	lp+=3;

	gte_stsxy3(	&PPMod1F_GT->x3,
			   	&PPMod1F_GT_L1->x3,
			   	&PPMod1F_GT_L2->x3);


	gte_ldv3c(&(PPMod1Vert4->a));	  // new 3 continuous svector vertices

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGT2; /* */

	// new pos
	gte_stsxy3_gt4(PPMod1F_GT);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok1;
	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_GT->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT2;

Gok1:
//	gte_stsxy3_ft4(PPMod1F_T);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT) & 0x00ffffff);

PGT2:
	gte_ldv3c( &(PPMod1Vert4_C1->a));		/* load gte with 3 xyz's of face */


	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_GT+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGT3; /* */

	// new pos
	gte_stsxy3_gt4(PPMod1F_GT_L1);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok2;

	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_GT_L1->x3);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT3;

Gok2:
//	gte_stsxy3_ft4(PPMod1F_T_L1);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT_L1) & 0x00ffffff);

PGT3:
	gte_ldv3c( &(PPMod1Vert4_C2->a));		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_GT_L1+=3;

	gte_stflg(&flag);						/* store flag */
 	if (flag & 0x80000000) goto PGT4; /* */

	// new pos
	gte_stsxy3_gt4(PPMod1F_GT_L2);

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok3;

	// failed 1st nclip...check 2nd

	gte_ldsxy0(*(long *)&PPMod1F_GT_L2->x3);


	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT4;

Gok3:
//	gte_stsxy3_ft4(PPMod1F_T_L2);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);


 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT_L2) & 0x00ffffff);

PGT4:	  // now do extra vertex from each quad !
//	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
//			  &(PPMod1Vert4_C1->d) ,
//			  &(PPMod1Vert4_C2->d) );

//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_T->x3,
//			   	&PPMod1F_T_L1->x3,
//			   	&PPMod1F_T_L2->x3);

	}



	/************/
	/* GOURAUD textured, double sided */
	/************/

	PPMod1F_GT=&PMod1F_GTD[0];		// set the three quad face pointers
	PPMod1F_GT_L1=&PMod1F_GTD[1];		// to the 1st 3 tex double faces
	PPMod1F_GT_L2=&PMod1F_GTD[2];

//	for (lp=0;lp<PC_Mod1F_GTD;lp+=3,PPMod1F_GT+=3,PPMod1F_GT_L1+=3,PPMod1F_GT_L2+=3)
	for (lp=0;lp<PC_Mod1F_GTD;PPMod1F_GT_L2+=3)
	{
	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
			  &(PPMod1Vert4_C1->d) ,
			  &(PPMod1Vert4_C2->d) );


	gte_rtpt();								/* do rot trans pers */
	lp+=3;


	gte_stsxy3(	&PPMod1F_GT->x3,
			   	&PPMod1F_GT_L1->x3,
			   	&PPMod1F_GT_L2->x3);

	gte_ldv3c( &PPMod1Vert4->a);		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGTD2; /* */

	gte_stsxy3_gt4(PPMod1F_GT);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT) & 0x00ffffff);

PGTD2:
	gte_ldv3c( &(PPMod1Vert4_C1->a) );		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C1+=3;
	PPMod1F_GT+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGTD3; /* */

	gte_stsxy3_gt4(PPMod1F_GT_L1);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT_L1) & 0x00ffffff);

PGTD3:
	gte_ldv3c( &(PPMod1Vert4_C2->a) );		/* load gte with 3 xyz's of face */

	gte_rtpt();								/* do rot trans pers */
	PPMod1Vert4_C2+=3;
	PPMod1F_GT_L1+=3;

	gte_stflg(&flag);						/* store flag */
	if (flag & 0x80000000) goto PGTD4; /* */

	gte_stsxy3_gt4(PPMod1F_GT_L2);

	gte_avsz3();	  		/* average z point sort */
	gte_stotz(&otz);

 	tag = (u_long *) (WOT + (otz >> OTSHIFT));
 	PPMod1F_GT_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x0C000000);
 	*tag = ((u_long) (PPMod1F_GT_L2) & 0x00ffffff);

PGTD4:	  // now do extra vertex from each quad !
//	gte_ldv3( &(PPMod1Vert4->d) ,		/* load gte with 3 xyz's of face */
//			  &(PPMod1Vert4_C1->d) ,
//			  &(PPMod1Vert4_C2->d) );


//	gte_rtpt();								/* do rot trans pers */
//	PPMod1Vert4+=3;
//	PPMod1Vert4_C1+=3;
//	PPMod1Vert4_C2+=3;

//	gte_stsxy3(	&PPMod1F_GT->x3,
//			   	&PPMod1F_GT_L1->x3,
//			   	&PPMod1F_GT_L2->x3);
	}

// END GOURAUD 4



}
#endif








/*
 ** SdMapFile
 *
 *  FILENAME: c:\ps\sdlib\gtefile.c
 *
 *  PARAMETERS:	pointer to Sd file in memory
 *
 *  DESCRIPTION: change offsets in header to actual memory locations and copy 2nd buffer from 1st
 *
 *  RETURNS:
 *
 */
#endif

void SdOldMapFile(u_long *MemPointer)
{

u_long	VertSize;
u_long	PolySize;
u_long	Maped;
u_long	NumberObjects;
u_long	HeaderOffset;
u_long	BaseAddr;
u_long	Flat3;
u_long	Tex3;
u_long	Flat4;
u_long	Tex4;
u_long	Gour3;
u_long	GourT3;
u_long	Gour4;
u_long	GourT4;
u_long	PolyBufferSize;
u_long	PolyAddr;
u_long	*MemPointer2;
u_long	lp;

	NumberObjects=*MemPointer++;
	PolyBufferSize=*MemPointer++;
	Maped=*MemPointer;

	if (Maped==0)
	{
		*MemPointer=1;
		MemPointer++;

//		HeaderOffset=(NumberObjects*72);		// 18 longs for each objects header
		HeaderOffset=(NumberObjects*136);		// 34 longs for each objects header
		BaseAddr=(u_long)MemPointer+HeaderOffset;

		Flat3=	// not used yet !
		Tex3=
		Flat4=
		Tex4=
		Gour3=
		GourT3=
		Gour4=
		GourT4=0;

		for (lp=0;lp<NumberObjects;lp++)
		{
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		*MemPointer=(u_long)((*MemPointer)+BaseAddr);
		if (lp==0) PolyAddr=*MemPointer++;			// set start of poly buffer
		else MemPointer++;
		Flat3+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Flat3+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Tex3+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Tex3+=*MemPointer++;

		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Gour3+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Gour3+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		GourT3+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		GourT3+=*MemPointer++;

		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Flat4+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Flat4+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Tex4+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Tex4+=*MemPointer++;

		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Gour4+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		Gour4+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		GourT4+=*MemPointer++;
		*MemPointer=(u_long)((*MemPointer++)+BaseAddr);
		GourT4+=*MemPointer++;
		}

		MemPointer=(u_long *)PolyAddr;
		MemPointer2=MemPointer+(PolyBufferSize/4);
		for (lp=0;lp<(PolyBufferSize/4);lp++)
		{
		*MemPointer2=*MemPointer;
		MemPointer++;
		MemPointer2++;
		}

	}

}








