/*******************************************************************
 *
 *    DESCRIPTION: This file contains functions written for PlayStation Only
 *					and global vars that are playstation specific
 *
 *******************************************************************/

#include <sys/types.h>
#include <libetc.h>		/* for Control Pad */
#include <libgte.h>		/* LIBGS uses libgte */
#include <libgpu.h>		/* LIBGS uses libgpu */
#include <libgs.h>		/* for LIBGS */
#include <ctrller.h>

#include "sddemo.h"


// PlayStation specific global vars
GsOT        *ptrwot;//jof

GsOT        Wotwin0[2];    // OT header for screen0
GsOT        Wotwin1[2];    // OT header for screen1
//GsOT        Wotwin2[2];    // OT header for screen2
//GsOT        Wotwin3[2];    // OT header for screen3
//GsOT        Wotref[2];    // OT header for reflection
GsOT        Wot2[2];                // OT header

GsOT		MWot[2];	// OT header for mats onscreen stuff
GsOT_TAG	mzsorttable[2] [1<<M_OT_LENGTH];
GsOT		*MWotPtr;

GsOT_TAG    zsorttable[2][(1<<OT_LENGTH)+100];
GsOT_TAG    zsorttable2[2][1<<OT_LENGTH2];
//GsOT_TAG    zsorttableref[2][1<<6];

GsRVIEW2  		view;							// View Point Handler
PACKET         out_packet[2][PACKETMEM];        // GPU PACKETS AREA
int				outbuf_idx __attribute__ ((section("dscachedata"))) =0;	// double buffer index
GsCOORDINATE2   DWorld;  						// link all coordinates to this world coord
SVECTOR         PWorld;
GsCOORDINATE2   PSObj[10]; 						// structure for object    >PS specific structure
ControllerPacket	buffer1,buffer2;			// PS pad buffers



void 	texture_init(u_long addr);
u_short Get_Tap_Pad(u_char i,u_char *Analog,u_char *PadIn,u_char *Id);


/*
 ** texture_init
 *
 *  FILENAME: c:\ps\sdlib\psx_only.c
 *
 *  PARAMETERS:	address of TIM in mem
 *
 *  DESCRIPTION: uplds tim gfx to video memory ,including pallete ,position is in tim header
 *
 *  RETURNS:
 *
 */
void texture_init(u_long addr)
{
  RECT rect1;
  GsIMAGE tim1;

  /* Get texture information of TIM FORMAT */

  GsGetTimInfo((u_long *)(addr+4),&tim1);

  rect1.x=tim1.px;		/* X point of image data on VRAM */

  rect1.y=tim1.py;		/* Y point of image data on VRAM */

  rect1.w=tim1.pw;		/* Width of image */
  rect1.h=tim1.ph;		/* Height of image */

  /* Load texture to VRAM  */
  LoadImage(&rect1,tim1.pixel);

  if((tim1.pmode>>3)&0x01)
    {
      rect1.x=tim1.cx;		/* X point of CLUT data on VRAM */

      rect1.y=tim1.cy;		/* Y point of CLUT data on VRAM */

      rect1.w=tim1.cw;		/* Width of CLUT 	*/
      rect1.h=tim1.ch;		/* Height of CLUT */

      /* Load CULT data to VRAM */
      LoadImage(&rect1,tim1.clut);
    }
}




u_short Get_Tap_Pad(u_char i,u_char *Analog,u_char *PadIn,u_char *Id)
{
	*PadIn=1;	// flag that this pad is plugged in..if not then set 0 below

	if (i<4)
	{
		if (buffer1.transStatus!=0) {*PadIn=0; return 0xffff;}
		if (buffer1.dataFormat>>4==4) {*Id=4; return buffer1.data.pad;}
		else if (buffer1.dataFormat>>4==7)	{*Id=7;
											 Analog[2]=buffer1.data.negcon.centralTwist;
											 Analog[3]=buffer1.data.negcon.buttonI;
											 Analog[0]=buffer1.data.negcon.buttonII;
											 Analog[1]=buffer1.data.negcon.topLeft;
											 return buffer1.data.pad;
											}
		else
			if (buffer1.dataFormat>>4==8)
				{ if (buffer1.data.tap.ctrllers[i].transStatus!=0) {PadIn=0; return 0xffff;}
					if (buffer1.data.tap.ctrllers[i].dataFormat>>4==4)
										 {*Id=4; return buffer1.data.tap.ctrllers[i].data.pad;}
					else if (buffer1.data.tap.ctrllers[i].dataFormat>>4==7)
					  {
					  *Id=7;
					  Analog[2]=buffer1.data.tap.ctrllers[i].data.negcon.centralTwist;
					  Analog[3]=buffer1.data.tap.ctrllers[i].data.negcon.buttonI;
					  Analog[0]=buffer1.data.tap.ctrllers[i].data.negcon.buttonII;
					  Analog[1]=buffer1.data.tap.ctrllers[i].data.negcon.topLeft;
					  return buffer1.data.tap.ctrllers[i].data.pad;
					  }
					else { if (i==0) /*NonStandardPad=1;*/ return 0xffff;}
				}
				else { if (i==0) /*NonStandardPad=1;*/ return 0xffff; }
	}
	else if (i<8)
	{
		if (buffer2.transStatus!=0) {*PadIn=0; return 0xffff;}
		if (buffer2.dataFormat>>4==4) {*Id=4; return buffer2.data.pad;}
		else if (buffer2.dataFormat>>4==7)	{*Id=7;
											 Analog[2]=buffer2.data.negcon.centralTwist;
											 Analog[3]=buffer2.data.negcon.buttonI;
											 Analog[0]=buffer2.data.negcon.buttonII;
											 Analog[1]=buffer2.data.negcon.topLeft;
											 return buffer2.data.pad;
											}
		else
			if (buffer2.dataFormat>>4==8)
				{ if (buffer2.data.tap.ctrllers[i-4].transStatus!=0) {PadIn=0; return 0xffff;}
					if (buffer2.data.tap.ctrllers[i-4].dataFormat>>4==4)
										 {*Id=4; return buffer2.data.tap.ctrllers[i-4].data.pad;}
					else if (buffer2.data.tap.ctrllers[i-4].dataFormat>>4==7)
					  {
					  *Id=7;
					  Analog[2]=buffer2.data.tap.ctrllers[i-4].data.negcon.centralTwist;
					  Analog[3]=buffer2.data.tap.ctrllers[i-4].data.negcon.buttonI;
					  Analog[0]=buffer2.data.tap.ctrllers[i-4].data.negcon.buttonII;
					  Analog[1]=buffer2.data.tap.ctrllers[i-4].data.negcon.topLeft;
					  return buffer2.data.tap.ctrllers[i-4].data.pad;
					  }
						else {if (i==0) /*NonStandardPad=1;*/ return 0xffff;}
				}
				else { if (i==0) /*NonStandardPad=1;*/ return 0xffff; }
	}
	else return 0xffff;

return 0;
}
