#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <inline_c.h>
#include <libsnd.h>
#include <libspu.h>
#include <ctrller.h>

#include "sddemo.h"
#include "sdtypes.h"	// header file of number types
#include "subdiv.h"

void	UpldTextures(Uint32 *TextureAddr);
void	UserView();
extern	GsRVIEW2  		view;							// View Point Handler
extern GsLINE	ClipedLine;
void GetNorm(SVECTOR *VertPointer1,SVECTOR *VertPointer2,SVECTOR *VertPointer3);

u_long	GoGoAnalyser;
u_long	EndAnalyser;

SVECTOR *VertPointer1;
SVECTOR *VertPointer2;
SVECTOR *VertPointer3;
SVECTOR *VertPointer4;
Uint32	Type;
SVECTOR Mid;
SVECTOR TheNorm;
SVECTOR TheNormal;

// view volume vars
GsRVIEW2	sview;
Sint32		viewvolLX;
Sint32		viewvolLZ;
Sint32		viewvolRX;
Sint32		viewvolRZ;
Sint32		volang=0x14;
Uint16		viewblocks=6;

VECTOR	ViewVol[4];
Uint8	SectionInView[20][20];
Sint32	VectDot(SVECTOR	*A,SVECTOR	*B);

extern	POLY_F3		Corner;
extern	Sint32	half_width;
extern	Sint32	half_height;
extern	Uint32	SplitScreen;


// playstation specific vars
extern GsOT				Wot[2];		 	// OT header
extern int				outbuf_idx;		// double buffer index
extern GsCOORDINATE2	DWorld;  		// link all coordinates to this world coord
extern SVECTOR			PWorld;
extern GsCOORDINATE2	PSObj[10]; 		// structure for object    >PS specific structure

Uint32   TestSDF[];
Uint32   TestBTM[];
Sint32   TestMAP[1][1];
extern	Uint32	NumberOfObjects;
Uint32	TopViewMode;
Uint32	GridOn;
Uint32	SGridOn;
//Uint32   ViewAll;
Sint32	TVX;
Sint32	TVZ;
Sint32	TVY=-32768;

// user view vars ... temp
float	ylookat=-700;
float	x,z;
//long	xpos;
//long	zpos=-8000;
//long	ypos=-700;
long	xpos=-5085;
long	zpos=-8000;
long	ypos=-700;
long	Theypos;
int		vx,vz,vx2,vz2;
Uint16	DSang=32768;
Uint16	ang2;
Uint8	UserViewTog=0;
Uint8	UserViewTog2=0;
Uint8	view1st;
int 	pr=512;
int		DispObjects;





// work vars
int				lp,i,Time;
ANGLE			TestAng;
FIXED			TestSqr;

// graphic files
extern	u_long	tim[];		// gfx data file

extern	u_long	TestSd[];	// Sd model file

// demo vars
OBJ_PRS			ObjInf[10];		// position,rotation,scale >SDlib structure
extern   APAD        SD_PadData[8]; // pad structure >SDLib structure

// demo functions
void 	SetLights();		// init flat lights , if any
void 	SetGraphics();		// upld graphics to vid mem
void 	MoveMiddleObject();
signed short	DoCollisionOn(unsigned long	*MemPointer,unsigned short md,signed short xpos,signed short ypos,signed short zpos);


/*
main()
{
#if PAL
	SD_Init(MODE_PAL,512,256);				// pal,640*256
#else
	SD_Init(MODE_NTSC,512,240);				// ntsc,640*256
#endif

	SD_ViewInit(0,0,-2000,0,0,1900,512);	// camera at 0,0,-2000,looking at 0,0,1900,lens 804

	SetLights();		// init flat lights , if any

	SetGraphics();		// upld graphics to vid mem	and set PS vars


#if debug
	// upld debug fnt
	FntLoad(960, 256);
	SetDumpFnt(FntOpen(-140, -120, 230, 100, 0, 512));
#endif


	while(1)			// main loop
	{
#if debug
	pollhost();			// debug call

	FntPrint("max  objs = %d\n",NumberOfObjects);
	FntPrint("disp objs = %d\n",DispObjects);

//	FntPrint("time = %d\n",Time);
//	FntPrint("angle = %d\n",(TestAng/ONEDEG));
//	FntPrint("squarert = %0x\n",TestSqr);
#endif

	SD_GetPadData(&SD_PadData);	// gets all data from pads hardware and puts in this structure

	UserView();
	GsSetRefView2(&view);  	// Calculate World-Screen Matrix from viewing paramter

	SD_InitDraw();		// clear OT, reset GPU packet area pointer , set double buffer index

	MoveMiddleObject();	// move an object up and down and around in the middle of the world

#if debug
	GsClearVcount();
#endif

	GoGoAnalyser=999999;

	SD_PrintModel(TestSDF,0,&ObjInf[0],&Wot,&PSObj[0],outbuf_idx,0);

	EndAnalyser=999999;



#if debug
	SortClipBox();
	if ((GridOn&3)) SortGridBox();
	Time=GsGetVcount();
#endif

	SD_EndDraw();		// wait for vsync and then start drawing OT
	}



}


  */


/*
void SetLights()				// init flat lights , if any
{
	// no lights at moment
	GsSetAmbient(1000,1000,1000);
	GsSetLightMode(0);
}
*/
/*
void SetGraphics()		// upld graphics to vid mem and set PS vars
{
//	SdMapFile(TestSd);	// map Sd model file to memory

   //MapModelData(TestSDF);

   SplitScreen=SplitScreenF;

   switch (SplitScreen)
	{
	case 1:
	half_width=256;
	#if PAL
	half_height=128;
	#else
	half_height=120;
	#endif
	break;

	case 2:
	half_width=256;
	#if PAL
	half_height=64;
	#else
	half_height=60;
	#endif
	break;

	case 3:
	case 4:
	half_width=128;
	#if PAL
	half_height=64;
	#else
	half_height=60;
	#endif
	break;
	}


	SetPolyF3(&Corner );			// temp test tri !!
	setSemiTrans(&Corner,1);


	PWorld.vx=			// clear world parent
	PWorld.vy=
	PWorld.vz=
	DWorld.coord.t[0]=
  	DWorld.coord.t[1]=
	DWorld.coord.t[2]=0;
	GsInitCoordinate2(WORLD,&DWorld);

	GsInitCoordinate2(&DWorld,&PSObj[0]);	// link object to world

//	texture_init(tim);						//texture load

   //UpldTextures(TestBTM);

}
 */



/*
void MoveMiddleObject()
{
static	ANGLE	ang;
FIXED	nvx;
FIXED	NewX;
FIXED	nvy;
FIXED	NewY;
FIXED	TempX;
FIXED	TempY;


	if (SD_PadData[0].Id==7)			// if analog pad
	// test analog pad
	{

	if (abs(SD_PadData[0].An1X)>15)
	{
	TempX=ObjInf[0].xpos+toFIXED((SD_PadData[0].An1X)/4);
	if ((TempX<toFIXED(650)) && (TempX>toFIXED(-650)))
		ObjInf[0].xpos+=toFIXED((SD_PadData[0].An1X)/4);
	}

	if (abs(SD_PadData[0].An1Y)>15)
	{
	TempY=ObjInf[0].ypos+toFIXED((SD_PadData[0].An1Y)/4);
	if ((TempY<toFIXED(550)) && (TempY>toFIXED(-550)))
		ObjInf[0].ypos+=toFIXED((SD_PadData[0].An1Y)/4);
	}

	ObjInf[0].zpos=toFIXED(0);

	ObjInf[0].xrot=(SD_PadData[0].An2Y*(ONEDEG*1.41));
	ObjInf[0].yrot=0;
	ObjInf[0].zrot=(SD_PadData[0].An2X*(ONEDEG*1.41));

	ObjInf[0].xscl=toFIXED(1.0);
	ObjInf[0].yscl=toFIXED(1.0);
	ObjInf[0].zscl=toFIXED(1.2);
	}
	else
	{
	// test fixed point sin/cos/multiply
	ang+=ONEDEG*5;						// digital pad
	nvy=SD_Sin(ang);
   //NewY=SD_Mul(toFIXED(100),nvy);

	nvx=SD_Cos(ang);
   //NewX=SD_Mul(toFIXED(300),nvx);

#if 0
	ObjInf[0].xpos=NewX;				// set pos,rot,scl of object
	ObjInf[0].ypos=NewY;
	ObjInf[0].zpos=toFIXED(0);
	ObjInf[0].xrot+=ONEDEG;
	ObjInf[0].yrot+=ONEDEG*2;
	ObjInf[0].zrot+=ONEDEG*3;
	ObjInf[0].xscl=toFIXED(1.0);
	ObjInf[0].yscl=toFIXED(0.8);
	ObjInf[0].zscl=toFIXED(1.2);
#endif

#if 1
	ObjInf[0].xpos=0;				// set pos,rot,scl of object
	ObjInf[0].ypos=0;
	ObjInf[0].zpos=0;
	ObjInf[0].xrot=0;
	ObjInf[0].yrot=0;
	ObjInf[0].zrot=0;
	ObjInf[0].xscl=
	ObjInf[0].yscl=
	ObjInf[0].zscl=toFIXED(1.0);
#endif
   }


}
  */






/*
void	UpldTextures(Uint32 *TextureAddr)
{
Uint32	NumTextures;
Uint8	llp;
Uint32	*ActualAddr;
Uint32	*BaseAddr;

	NumTextures=*TextureAddr++;
	BaseAddr=TextureAddr;
	for (llp=0;llp<NumTextures;llp++)
	{
	ActualAddr=((Uint32 *) ( ((Uint32)BaseAddr) +(NumTextures*4)+ (*TextureAddr++) ) );
	texture_init(ActualAddr);
	}

}
*/

void	UserView()
{
}

Sint32	VectDot(SVECTOR	*A,SVECTOR	*B)
{
Sint32	Dot;

	Dot=(A->vx*B->vx)+(A->vy*B->vy)+(A->vz*B->vz);

	return Dot;
}




