#include <sys/types.h>
#include <stdio.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <inline_c.h>
#include <libsnd.h>
#include <libspu.h>
#include <ctrller.h>
#include <libpad.h>
#include <libapi.h>

#include "..\header.h"
#include "..\gameloop.h"
#include "..\state.h"
#include "screen.h"
#include "..\loadit.h"

#include "..\pal_ntsc.h"

/*******************************************************************
 *
 *    DESCRIPTION: Smart Dog PSX lib
 *
 *    AUTHOR: D.Saunders
 *
 *    HISTORY: started Mon Jan 5 1998
 *
 *******************************************************************/



static unsigned long randnum;

/*
short	midx=256;
short	midy=128;
*/

//int y_off = 24;
RECT *disp;

extern  unsigned long   NumberOfObjects;
extern	int		DispObjects;

#include "sdfunc.h"
#include "subdiv.h"
#include "sddemo.h"		// only for PAL


//Packet memory overflow watch variables - do not remove!
	PACKET *CurrentPacket;
	u_char PacketOverFlow;
	PACKET *LastPacketAddr;
	int		FreePacketSpace, UsedPacketSpace;
	int     minFreePacketSpace = 1048576;
//End of packet memory watch variables


extern	Sint32		TestMAP[GrdZ][GrdX];
extern	Uint8		SectionInView[GrdZ][GrdX];
extern	Uint32		TopViewMode;

extern	Sint32	half_width;
extern	Sint32	half_height;
Uint32   SplitScreen=2;
Uint32	ViewAll;

extern   GsOT        Wotwin0[2];                    // OT header
extern   GsOT        Wotwin1[2];                    // OT header
//extern   GsOT        Wotref[2];                    // OT header
extern   GsOT_TAG    zsorttable[2][(1<<OT_LENGTH)+100];  // Area of OT
//extern   GsOT_TAG    zsorttableref[2][1<<6];  // Area of OT

extern   GsOT        *ptrwot;//jof


extern GsOT_TAG mzsorttable[2] [1<<M_OT_LENGTH];
extern GsOT MWot[2];
extern GsOT *MWotPtr;

void padInit(void);

 /*
 ** SD_Init
 *
 *  FILENAME: c:\ps\sdlib\sdfunc.c
 *
 *  PARAMETERS:	NTSC/PAL,ScreenX,ScreenY
 *
 *  DESCRIPTION: Set up system,screen,pads
 *
 *  RETURNS:
 *
 */
void SD_Init(unsigned char Mode,unsigned short ResX,unsigned short ResY)
{
	ResetCallback();

	SetVideoMode(Mode);		// 0-ntsc/1-pal

   ResetGraph(3);       // Reset GPU

#if NEWPAD // new pad stuff
padInit();
#else
	InitTAP(&buffer1,MAX_CONTROLLER_BYTES,			// initialise multi-tap
			&buffer2,MAX_CONTROLLER_BYTES);		// or just pads
	VSync(0);
	StartTAP();
#endif
	VSync(0);

   GsInitGraph(ResX,ResY,GsRESET3|GsNONINTER|GsOFSGPU,0,0);    // set screen resolution
   GsDefDispBuff(0,0,0,256);                    // Double buffer setting

	GsInit3D();				// Init 3D system

  /*
   Wotwin0[0].length=OT_LENGTH;   // Set bit length of OT handler
   Wotwin0[0].org=zsorttable[0];  // Set Top address of OT Area to OT handler
   Wotwin0[1].length=OT_LENGTH;
   Wotwin0[1].org=zsorttable[1];

   Wotwin1[0].length=OT_LENGTH;   // Set bit length of OT handler
   Wotwin1[0].org=zsorttable[0];  // Set Top address of OT Area to OT handler
   Wotwin1[1].length=OT_LENGTH;
   Wotwin1[1].org=zsorttable[1];
  */

	Wot2[0].length=OT_LENGTH2;	// Set bit length of OT handler
	Wot2[0].org=zsorttable2[0];	// Set Top address of OT Area to OT handler
	Wot2[1].length=OT_LENGTH2;
	Wot2[1].org=zsorttable2[1];

    MWot[0].length = M_OT_LENGTH;
    MWot[0].org = mzsorttable[0];
    MWot[1].length = M_OT_LENGTH;
    MWot[1].org = mzsorttable[1];

   //GsSetNearClip(0);
   //GsSetFarClip(48);

}





/*
 ** SD_ViewInit
 *
 *  FILENAME: c:\ps\sdlib\sdfunc.c
 *
 *  PARAMETERS:	x,y,z positions  ,x,y,z refpoint,  lens angle
 *
 *  DESCRIPTION: set view
 *
 *  RETURNS:
 *
 */
void SD_ViewInit(short xpos,short ypos,short zpos,
				 short xref,short yref,short zref,
				 unsigned short pr)
{
	GsSetProjection(pr);	// Set projection

  	view.vpx = xpos;		// setting camera location
  	view.vpy = ypos;
  	view.vpz = zpos;
  	view.vrx = xref;		// Setting focus point location
  	view.vry = yref;
  	view.vrz = zref;

  	view.rz=0;  			// Setting rotation of screen along z axis

	view.super = WORLD;  	// Setting parent of viewing coordinate

	GsSetRefView2(&view);  	// Calculate World-Screen Matrix from viewing paramter
}







/*
 ** SD_InitDraw
 *
 *  FILENAME: c:\ps\sdlib\sdfunc.c
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION: call once at top of main loop to set drawing variables and buffers
 *
 *  RETURNS:
 *
 */
s32   ansdinitdraw;
void SD_InitDraw()
{
ansdinitdraw=999;
	outbuf_idx=GsGetActiveBuff();		// Get double buffer index

    // Set top address of Packet Area for output of GPU PACKETS
    GsSetWorkBase((PACKET*)out_packet[outbuf_idx]);

    switch( STATE.numscreens )
      {
      case 1:
         {
         GsClearOt(0,0,&Wotwin0[outbuf_idx]);   // Clear OT
         //GsClearOt(0,0,&Wotref[outbuf_idx]);   // Clear reflection OT
         }
         break;
      case 2:
         {
         GsClearOt(0,0,&Wotwin0[outbuf_idx]);   // Clear OT
         GsClearOt(0,0,&Wotwin1[outbuf_idx]);   // Clear OT
         }
         break;
      }
    //GsClearOt(0,0,&Wot[outbuf_idx]);   // Clear OT
    GsClearOt(0,0,&Wot2[outbuf_idx]);  // Clear OT
   	ptrwot  =  &Wotwin0[outbuf_idx];


	GsClearOt(0,0,&MWot[outbuf_idx]);  // Clear OT
	MWotPtr = &MWot[outbuf_idx];
//	mprintf("MWotPtr = %p  ",MWotPtr);
	}






/*
 ** SD_EndDraw
 *
 *  FILENAME: c:\ps\sdlib\sdfunc.c
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION: wait for vsync and set drawing going
 *
 *  RETURNS:
 *
 */

//	GsDRAWENV.dfe=0;
//	GsDefDispBuff(0,0,0,256);	/* Double buffer setting */
//	POSITION.offx=xres/2;
//	POSITION.offy=120;
//	offy=0;
//	GsSetDrawBuffOffset();
extern u8 RUMBLE[];

extern	APAD	SD_PadData[8];

extern u32   GPU_vsync[10];
s32   ansdenddraw;
  u32  lastvs=0;

void SD_EndDraw()
{
RECT	clip;

//register int nOt;
//register int nOtt;
//static int fr  = 0;
static int lt = -1;
int t;
// changed by matty
// old:   DrawSync(0);               // wait for last frames drwaing to be completed

// begin new

/*
	nOtt = nOt = DrawSync(1);

	while(nOt>8)
		{
		}nOt = DrawSync(1);

	fr++;
	if((fr&0x3f)==0)
		mprintf("nOtt = %d\n",nOtt);
*/
	DrawSync(0);
   ansdenddraw=999;
// end new

   GPU_vsync[0]=VSync(1);

//   if(STATE.vsync)VSync(0);                 // Wait VSYNC 25/30 frames a second

//VSync(0);		// scee trc sez VSync(2)

#if SCREENSHOT
	screenshot();
#endif

#if !CDMASTER
#if MAT
	pollhost();
#endif
#endif

	ResetGraph(1);	// new

#if 1
if(lt==-1)
	{
	VSync(0);
	lt = VSync(-1);
	}
else{
	t = VSync(-1);
	while(t<=lt+1)
		t = VSync(-1);
	lt = t;
	}
#endif
    GsSwapDispBuff();				// Swap double buffer
   //if( (SplitScreen==2) || (GAMELOOP_state!=GLgame) )
   if( (GAMELOOP_state!=GLgame) )
       GsSortClear(00,50,100,&Wot2[outbuf_idx]); // add clear screen packet to ot2

	//

	// temp
	switch (SplitScreen)
	{
	case 1:
      if(STATE.res==0)
      {
      half_width=256;
      //half_width=160;
      #if PAL
      half_height=128;
      #else
      half_height=120;
      #endif
      }
   else
      {
      half_width=192;
      //half_width=160;
      #if PAL
      half_height=128;
      #else
      half_height=120;
      #endif
      }
	break;

	case 2:
	half_width=256;
	#if PAL
   half_height=63;
	#else
	half_height=60;
	#endif
	break;

	case 3:
	case 4:
	half_width=128;
	#if PAL
	half_height=64;
	#else
	half_height=60;
	#endif
	break;
	}

disp = &GsDISPENV.disp;

	//16 pixel missing at bottom of screen fix
#if NTSC
    GsDISPENV.screen.y = 8;
    GsDISPENV.screen.h = 240;
#else
    GsDISPENV.screen.y = 12;		// 24
	GsDISPENV.screen.h = 256;
#endif

	switch (SplitScreen)  //split screen
	{
	case 1:							// 1 player
      if(STATE.res==0)
         POSITION.offx=256;
      else
         POSITION.offx=192;
	#if PAL
	POSITION.offy=128;
	#else
	POSITION.offy=120;
	#endif
	GsSetDrawBuffOffset();
	clip.x=POSITION.offx-half_width;
	clip.y=POSITION.offy-half_height;
	clip.w=half_width*2;
	clip.h=half_height*2;
	GsSetClip(&clip);

   GsDrawOt(&Wot2[outbuf_idx]);    // clear screen ot
   //GsDrawOt(&Wotref[outbuf_idx]);
   GsDrawOt(&Wotwin0[outbuf_idx]);
	break;

	case 2:							// 2 player
	POSITION.offx=256;		// p0
	#if PAL
	POSITION.offy=64;
	#else
	POSITION.offy=60;
	#endif
	GsSetDrawBuffOffset();
	clip.x=POSITION.offx-half_width;
	clip.y=POSITION.offy-half_height;
	clip.w=half_width*2;
	clip.h=half_height*2;
	GsSetClip(&clip);
    GsDrawOt(&Wot2[outbuf_idx]);
    GsDrawOt(&Wotwin0[outbuf_idx]);

	POSITION.offx=256;		// p1
	#if PAL
	POSITION.offy=192;
	#else
	POSITION.offy=180;
	#endif
	GsSetDrawBuffOffset();
	clip.x=POSITION.offx-half_width;
	clip.y=POSITION.offy-half_height;
	clip.w=half_width*2;
	clip.h=half_height*2;
	GsSetClip(&clip);
    GsDrawOt(&Wotwin1[outbuf_idx]);
	break;

	case 3:							// 3 or 4 player
   /*
   case 4:
	POSITION.offx=128;		// p0 top left
	#if PAL
	POSITION.offy=64;
	#else
	POSITION.offy=60;
	#endif
	GsSetDrawBuffOffset();
	clip.x=POSITION.offx-half_width;
	clip.y=POSITION.offy-half_height;
	clip.w=half_width*2;
	clip.h=half_height*2;
	GsSetClip(&clip);
    GsDrawOt(&Wot2[outbuf_idx]);
    GsDrawOt(&Wot[outbuf_idx]);

	POSITION.offx=384;		// p1 top right
	#if PAL
	POSITION.offy=64;
	#else
	POSITION.offy=60;
	#endif
	GsSetDrawBuffOffset();
	clip.x=POSITION.offx-half_width;
	clip.y=POSITION.offy-half_height;
	GsSetClip(&clip);
    GsDrawOt(&Wot[outbuf_idx]);

	POSITION.offx=128;		// p2 bot left
	#if PAL
	POSITION.offy=192;
	#else
	POSITION.offy=180;
	#endif
	GsSetDrawBuffOffset();
	clip.x=POSITION.offx-half_width;
	clip.y=POSITION.offy-half_height;
	GsSetClip(&clip);
    GsDrawOt(&Wot[outbuf_idx]);

	if (SplitScreen==4)
		{
		POSITION.offx=384;		// p3 bot right
		#if PAL
		POSITION.offy=192;
		#else
		POSITION.offy=180;
		#endif
		GsSetDrawBuffOffset();
		clip.x=POSITION.offx-half_width;
		clip.y=POSITION.offy-half_height;
		GsSetClip(&clip);
   		GsDrawOt(&Wot[outbuf_idx]);
		}
	break;
    */
	}

#if PAL

POSITION.offy = 128;
POSITION.offx = 256;
GsSetDrawBuffOffset();
clip.x = 0;
clip.y = 0;
clip.w = 512;
clip.h = 256;
GsSetClip(&clip);
GsDrawOt(&MWot[outbuf_idx]);

#else

POSITION.offy = 120;
POSITION.offx = 256;
GsSetDrawBuffOffset();
clip.x = 0;
clip.y = 0;
clip.w = 512;
clip.h = 240;
GsSetClip(&clip);
GsDrawOt(&MWot[outbuf_idx]);

#endif


	FntFlush(-1);					// print debug text
}



/*
 ** SD_PrintModel
 *
 *  FILENAME: c:\ps\sdlib\sdfunc.c
 *
 *  PARAMETERS:	pointer to sd file ,which model within sd file,
 				x,y,zpos,x,y,zrot,order table,buffer0/1
 *
 *  DESCRIPTION: sort model to order table at this position and this rotation
 *
 *  RETURNS:
 *
 */
#if 0    // Mat: 15th May 1999,  This aint used anyware.
 void SD_PrintModel(	unsigned long	*MemPointer,
               int  md,
					OBJ_PRS			*ObjInf,
					GsOT			*OT,
					GsCOORDINATE2   *PSObj,
					unsigned char 	idx,
					unsigned long	Sort)
{
SVECTOR 		rot;
VECTOR 			scl;
MATRIX			tmp1;
MATRIX			tmplsx;		// work matrix
//int lp,lpp;

	rot.vx=(ObjInf->xrot)>>4;		// change 0x10000=360 to 0x1000=360
	rot.vy=(ObjInf->yrot)>>4;
	rot.vz=(ObjInf->zrot)>>4;

	scl.vx=(ObjInf->xscl)>>4;		// change 0x10000=1.0 to 0x1000=1.0
	scl.vy=(ObjInf->yscl)>>4;
	scl.vz=(ObjInf->zscl)>>4;

	tmp1   = GsIDMATRIX;			// start from unit matrix
   tmp1.t[0] =F2L(ObjInf->xpos);   // change fixed to longs
	tmp1.t[1] =F2L(ObjInf->ypos);
	tmp1.t[2] =F2L(ObjInf->zpos);

	RotMatrix(&rot,&tmp1);

	ScaleMatrix(&tmp1,&scl);

	PSObj->coord = tmp1;		// Set Matrix to Coordinate
	PSObj->flg = 0;  			// Clear flag becase of changing parameter

	GsGetLs(PSObj,&tmplsx);
	GsSetLsMatrix(&tmplsx);


/*
	if ( (ViewAll&1)&&(TopViewMode&1) )
    {
	// all!
	for (lp=0;lp<NumberOfObjects;lp++)
	PrintModel(MemPointer,lp,OT,idx);
	}
	else	  // only print objects in view volume
	{
	DispObjects=0;
	for (lp=0;lp<GrdZ;lp++)
		for (lpp=0;lpp<GrdX;lpp++)
			if (SectionInView[lp][lpp])
				if (TestMAP[lp][lpp]!=0xffffffff)
					{
					PrintModel(MemPointer,TestMAP[lp][lpp],OT,idx);
					DispObjects++;
					}
	}
 */
}
#endif

#if NEWPAD		// new dual-shock enabled pad stuff


#define	__DEBUG_PAD		0

APAD SD_PadData[8];

#if __DEBUG_PAD

char *padTypeDesc[16] =
	{
    /*  0 */ "No pad connected",
    /*  1 */ "Mouse",
    /*  2 */ "Namco analog controller",
    /*  3 */ "Konami analog controller",
    /*  4 */ "Standard digital pad",
    /*  5 */ "Analog joystick",
    /*  6 */ "Gun controller",
    /*  7 */ "Analog controller",
    /*  8 */ "Unknown",
    /*  9 */ "Unknown",
    /* 10 */ "Unknown",
    /* 11 */ "Unknown",
    /* 12 */ "Unknown",
    /* 13 */ "Unknown",
    /* 14 */ "Unknown",
    /* 15 */ "Unknown"
    };

#endif

// offset within data of each actuators parameters
u8 align[6] = {0,1,0xFF,0xFF,0xFF,0xFF};
u8 padMotor[8] [2];

u8 padBuffer[2] [34];
u8 *padDataDirect[2] = {&padBuffer[0] [0],&padBuffer[1] [0]};
u8 *padDataMulti[2] [4] =
	{
		{&padBuffer[0] [2],&padBuffer[0] [10],&padBuffer[0] [18],&padBuffer[0] [26]},
		{&padBuffer[1] [2],&padBuffer[1] [10],&padBuffer[1] [18],&padBuffer[1] [26]}
	};

u8 *padMap[8];
u8 dummyPad[2] = {0xff,0x00};
u8 nAct[8];

u8 padId4Num[8] = {0x00,0x01,0x02,0x03,0x10,0x11,0x12,0x13};

void padInit(void)
	{
	int i,p;

	InitCARD(0);
	StartCARD();
	_bu_init();

	VSync(0);
	VSync(0);

	PadInitMtap(padBuffer[0],padBuffer[1]);

	VSync(0);
	VSync(0);

	PadStartCom();

	VSync(0);
	VSync(0);

	for(p=0;p<8;p++)
	for(i=0;i<2;i++)
		padMotor[p] [i] = 0;

	// Zero SD_Pad array

	p = sizeof(APAD)*2;		// sizeof(APAD)*8 /4
	for(i=0;i<p;i++)
		((u32 *)SD_PadData)[i] = 0;

	// Test.
	ChangeClearPAD(0);
	}

void padRefresh(void)
	{
    int p,i;
	static int fr = 0;
    static int setMainMode = 0;

	for(p=0;p<2;p++)
		{
		if(padDataDirect[p] [0]!=0x00)
			{
			// Failed to recieve data

			for(i=0;i<4;i++)
				padMap[(p<<2)+i] = dummyPad;
			continue;
			}

		switch(padDataDirect[p] [1]&0xf0)
			{
			case 0x80:
				// Multi-tap
				for(i=0;i<4;i++)
					padMap[(p<<2)+i] = (padDataMulti[p] [i] [1]&0xf0)==0?dummyPad:padDataMulti[p] [i];
				break;
			default:
				padMap[p<<2] = padDataDirect[p];
				for(i=1;i<4;i++)
					padMap[(p<<2)+i] = dummyPad;
				break;
			}
		}

#if __DEBUG_PAD
	mprintf("\n\r");
#endif

#if __DEBUG_PAD
	for(p=0;p<2;p++)
		{
		mprintf("padBuffer[%d]\n\r",p);
		for(i=0;i<34;i++)
			mprintf("  %02X",padBuffer[p] [i]);
		mprintf("\n\r\n\r");
		}
#endif

	for(p=0;p<8;p++)
		nAct[p] = 0;

	for(p=0;p<8;)
		{
		if(padMap[p]==dummyPad)
			{
#if __DEBUG_PAD
			mprintf("pad %d, no pad\n\r",p);
#endif
			SD_PadData[p].actAligned = 0;
			p++;
			continue;
			}

#if __DEBUG_PAD
		mprintf("PadGetState(%02X) p=%d\n\r",padId4Num[p],p);
#endif
        switch(PadGetState(padId4Num[p]))
			{
			case PadStateDiscon:
#if __DEBUG_PAD
				mprintf("pad %d disconnected\n\r",p);
#endif
//				while(1);
				padMap[p] = dummyPad;
				SD_PadData[p].actAligned = 0;
				p++;
				break;
			case PadStateFindPad:
#if __DEBUG_PAD
				mprintf("pad %d... hardware checking state.\n\r",p);
#endif
				break;
			case PadStateFindCTP1:
#if __DEBUG_PAD
                mprintf("pad %d found type CTP1.\n\r",p);
#endif
                SD_PadData[p].actAligned = 0;
				p++;
				break;
			case PadStateFindCTP2:
#if __DEBUG_PAD
                mprintf("pad %d found type CTP2.\n\r",p);
#endif
                SD_PadData[p].actAligned = 0;
				p++;
				break;
			case PadStateReqInfo:
#if __DEBUG_PAD
                mprintf("pad %d... hardware is checking actuator state.\n\r",p);
#endif
                break;
            case PadStateExecCmd:
#if __DEBUG_PAD
                mprintf("pad %d... hardware is communicating with pad.\n\r",p);
#endif
				break;
			case PadStateStable:
#if __DEBUG_PAD
                mprintf("pad %d... actuator information retrieved.\n\r",p);
				mprintf("      Querying actuator info.\n\r");
#endif
				nAct[p] = PadInfoAct(padId4Num[p],-1,0);

                if(!SD_PadData[p].actAligned)
                    {
                    SD_PadData[p].actAligned = 1;
					
					if(PadSetActAlign(padId4Num[p],align)!=1)
						{
	                    SD_PadData[p].actAligned = 0;
#if __DEBUG_PAD
						mprintf("Actuator align failed!!\n");
#endif
						continue;
						}
					else{
						if(p==0)
							{
							if(!setMainMode)
                            if(!PadSetMainMode(padId4Num[p],1,(*PadAnalog0)?(2):(0)))
                                SD_PadData[p].actAligned = 0;
							
							}
						if(p==4)
							{
							if(!setMainMode)
                            if(!PadSetMainMode(padId4Num[p],1,(*PadAnalog1)?(2):(0)))
                                SD_PadData[p].actAligned = 0;
							
							}
						}
					}

#if __DEBUG_PAD
				for(i=0;i<nAct[p];i++)
					{
					mprintf("\tMotor %d    ",i);

					mprintf("Func:%d  ",PadInfoAct(padId4Num[p],i,InfoActFunc));
		            mprintf("Sub:%d  ",PadInfoAct(padId4Num[p],i,InfoActSub));
		            mprintf("Size:%d  ",PadInfoAct(padId4Num[p],i,InfoActSize));
		            mprintf("Curr:%d  ",PadInfoAct(padId4Num[p],i,InfoActCurr));
		            mprintf("Sign:%d\n\r",PadInfoAct(padId4Num[p],i,InfoActSign));
					}
#endif
				p++;
				break;
            }
		}

#if __DEBUG_PAD
	mprintf("Completed\n\r");
	for(p=0;p<8;p++)
        mprintf("pad %d is %s  (%d actuators)\n\r",p,padTypeDesc[padMap[p] [1]>>4],nAct[p]);
#endif

	// Fill in APAD structures
	for(p=0;p<8;p++)
		{
		if(padMap[p]==dummyPad)
			{
			SD_PadData[p].In = 0;

			// Just to please d.s. , he dont check the flags. Doh !

            SD_PadData[p].old = 0x0000;
            SD_PadData[p].data = 0xffff;
            SD_PadData[p].push = 0x0000;
            SD_PadData[p].push2 = 0xffff;
            SD_PadData[p].pull = 0x0000;

			continue;
			}

		// digital - analog flic
        if(SD_PadData[p].Id!=(padMap[p] [1]&0xf0)>>4)
			SD_PadData[p].actAligned = 0;

		SD_PadData[p].In = 1;
        SD_PadData[p].Id = (padMap[p] [1]&0xf0)>>4;

		switch(SD_PadData[p].Id)
			{
            case 0x7:      // Analog controller

				SD_PadData[p].An1X = (s8)((padMap[p] [6]+0x80)&0xff);
				SD_PadData[p].An1Y = (s8)((padMap[p] [7]+0x80)&0xff);
				SD_PadData[p].An2X = (s8)((padMap[p] [4]+0x80)&0xff);
				SD_PadData[p].An2Y = (s8)((padMap[p] [5]+0x80)&0xff);//?????

				// Allow to run into digital button code

			case 0x4:		// Standard digital controller

                SD_PadData[p].old = SD_PadData[p].data;
				SD_PadData[p].data = ((u16 *)padMap[p])[1];

				// Generate push, push2, pull

/*
				SD_PadData[p].push = SD_PadData[p].old&(SD_PadData[p].data^~0);
				SD_PadData[p].push2 = SD_PadData[p].push^~0;
				SD_PadData[p].pull = SD_PadData[0].data&(SD_PadData[0].old^~0);
*/
                SD_PadData[p].push = (SD_PadData[p].data^SD_PadData[p].old)&SD_PadData[p].old;
				SD_PadData[p].push2 = ~SD_PadData[p].push;
                SD_PadData[p].pull = (SD_PadData[p].data^SD_PadData[p].old)&SD_PadData[p].data;

				// JT Uses .old for his own debouncer
				SD_PadData[p].old = ~SD_PadData[p].old;

				break;

            case 0x0:      // No pad, should never get here
            case 0x1:      // Mouse
            case 0x2:      // Namco analog controller
            case 0x3:      // Konami analog controller
            case 0x5:      // Analog joystick
            case 0x6:      // Gun controller
            case 0x8:      // Unknown
            case 0x9:      // Unknown
            case 0xa:      // Unknown
            case 0xb:      // Unknown
            case 0xc:      // Unknown
            case 0xd:      // Unknown
            case 0xe:      // Unknown
            case 0xf:      // Unknown
			default:
				SD_PadData[p].In = 0;

				// Just to please d.s. , he dont check the flags. Doh !

    	        SD_PadData[p].old = 0x0000;
	            SD_PadData[p].data = 0xffff;
	            SD_PadData[p].push = 0x0000;
	            SD_PadData[p].push2 = 0xffff;
	            SD_PadData[p].pull = 0x0000;
				break;
			}

		if(!SD_PadData[p].In)
			continue;
		}

/*
	for(p=0;p<8;p++)
	for(i=0;i<2;i++)
// Library will impose limit on 60 units of current
		padMotor[p] [i] = SD_PadData[p].rumble[i];
// Step each motor as if 8 players.
//		padMotor[p] [i] = ((p>=((fr&0x03)<<1))&&(p<((fr&0x03)<<1)+2))?SD_PadData[p].rumble[i]:0;
*/

	if((*RumbleOn)&&(!STATE.demomode))
	for(p=0;p<8;p++)
		{
		// Library will impose limit on 60 units of current across all 8 pads
		padMotor[p] [0] = SD_PadData[p].rumble[0]==0?0:1;
        padMotor[p] [1] = SD_PadData[p].rumble[1]>255?255:SD_PadData[p].rumble[1];
		}
	else
	for(p=0;p<8;p++)
		{
        padMotor[p] [0] = 0;
        padMotor[p] [1] = 0;
		}


#if 0
	for(p=0;p<8;p++)
		{
		if(nAct[p]==0)
			continue;

		/*
		if(PadSetActAlign(padId4Num[p],align)!=1)
			{
			mprintf("Actuator align failed!!\n");
			continue;
			}
		*/

		PadSetAct(padId4Num[p],padMotor[p],2);
		}
#endif

/*
	for(p=0;p<8;p++)
        mprintf("%c",((p>=((fr&0x03)<<1))&&(p<((fr&0x03)<<1)+2))?'x':'-');
    mprintf("\n");
*/

	for(p=0;p<8;p++)
//  for(p=(fr&0x03)<<1;p<((fr&0x03)<<1)+2;p++)
        {
		if(nAct[p]==0)
			continue;

		/*
		if(PadSetActAlign(padId4Num[p],align)!=1)
			{
			mprintf("Actuator align failed!!\n");
			continue;
			}
		*/

		PadSetAct(padId4Num[p],padMotor[p],2);
		}

	// pad rumble decay
	for(p=0;p<8;p++)
		{
        if(SD_PadData[p].rumble[1]>0)
			{
	        if(SD_PadData[p].rumble[1]>13)
	            SD_PadData[p].rumble[1] -= SD_PadData[p].rumble[1]>128?28:14;
	        else
	            SD_PadData[p].rumble[1] = 0;
			}

        if(SD_PadData[p].rumble[0]>0)
			{
	        if(SD_PadData[p].rumble[0]>31)
	            SD_PadData[p].rumble[0] -= 32;	// 32
	        else
	            SD_PadData[p].rumble[0] = 0;
			}
		}

	fr++;
	setMainMode = 1;
    }

void 	SD_GetPadData(APAD	*SD_PadData)
	{
	padRefresh();
	}

#else


/*
 ** Sd_GetPadData
 *
 *  FILENAME: c:\ps\sdlib\sdfunc.c
 *
 *  PARAMETERS:	pointer to array of SD_PadData structures
 *
 *  DESCRIPTION: get up to 8 pads data
 *
 *  RETURNS: all data in SD_PadData structures
 *
 */
void 	SD_GetPadData(APAD	*SD_PadData)
{
u_char 	i;
u_char	type;
u_char	Analog[4];
u_char	PadIn;
u_char	Id;

#if 0
 if ((buffer1.transStatus!=0) && (buffer2.transStatus!=0)) NoPadsConnected=1;
#endif

	type=buffer1.dataFormat>>4;

	SD_PadData[0].old=(SD_PadData[0].data);		/* get push */
	SD_PadData[0].data=Get_Tap_Pad(0,&Analog,&PadIn,&Id);
	SD_PadData[0].Id=Id;
	SD_PadData[0].An1X=(signed char)(Analog[0]+0x80)&0xff;
	SD_PadData[0].An1Y=(signed char)(Analog[1]+0x80)&0xff;
	SD_PadData[0].An2X=(signed char)(Analog[2]+0x80)&0xff;
	SD_PadData[0].An2Y=(signed char)(Analog[3]+0x80)&0xff;

	if (PadIn) { SD_PadData[0].InCount=0; SD_PadData[0].In=1; }
		if (PadIn==0)
		{ if (SD_PadData[0].InCount<5) SD_PadData[0].InCount++;
		  else SD_PadData[0].In=0;
		}

	SD_PadData[0].push=(SD_PadData[0].old&(SD_PadData[0].data^-1));
	SD_PadData[0].push2=0xffff-SD_PadData[0].push;

	SD_PadData[0].old=(SD_PadData[0].old ^-1);	/* get pull */
	SD_PadData[0].pull=(SD_PadData[0].data & SD_PadData[0].old);



	if (type==8)
	{
	for (i=1;i<4;i++)
		{
	SD_PadData[i].old=(SD_PadData[i].data);	/* get push */
	SD_PadData[i].data=Get_Tap_Pad(i,&Analog,&PadIn,&Id);
	SD_PadData[i].Id=Id;
	SD_PadData[i].An1X=(signed char)(Analog[0]+0x80)&0xff;
	SD_PadData[i].An1Y=(signed char)(Analog[1]+0x80)&0xff;
	SD_PadData[i].An2X=(signed char)(Analog[2]+0x80)&0xff;
	SD_PadData[i].An2Y=(signed char)(Analog[3]+0x80)&0xff;

	if (PadIn) { SD_PadData[i].InCount=0; SD_PadData[i].In=1; }
		if (PadIn==0)
		{ if (SD_PadData[i].InCount<5) SD_PadData[i].InCount++;
		  else SD_PadData[i].In=0;
		}

	SD_PadData[i].push=(SD_PadData[i].old&(SD_PadData[i].data^-1));
	SD_PadData[i].push2=0xffff-SD_PadData[i].push;

	SD_PadData[i].old=(SD_PadData[i].old ^-1);	/* get pull */
	SD_PadData[i].pull=(SD_PadData[i].data & SD_PadData[i].old);

		}
	}
	else { SD_PadData[1].data=0xffff; SD_PadData[2].data=0xffff;
														 SD_PadData[3].data=0xffff; }


	type=buffer2.dataFormat>>4;

	SD_PadData[4].old=(SD_PadData[4].data);		/* get push */
	SD_PadData[4].data=Get_Tap_Pad(4,&Analog,&PadIn,&Id);
	SD_PadData[4].Id=Id;
	SD_PadData[4].An1X=(signed char)(Analog[0]+0x80)&0xff;
	SD_PadData[4].An1Y=(signed char)(Analog[1]+0x80)&0xff;
	SD_PadData[4].An2X=(signed char)(Analog[2]+0x80)&0xff;
	SD_PadData[4].An2Y=(signed char)(Analog[3]+0x80)&0xff;

	if (PadIn) { SD_PadData[4].InCount=0; SD_PadData[4].In=1; }
		if (PadIn==0)
		{ if (SD_PadData[4].InCount<5) SD_PadData[4].InCount++;
		  else SD_PadData[4].In=0;
		}

	SD_PadData[4].push=(SD_PadData[4].old&(SD_PadData[4].data^-1));
	SD_PadData[4].push2=0xffff-SD_PadData[4].push;

	SD_PadData[4].old=(SD_PadData[4].old ^-1);	/* get pull */
	SD_PadData[4].pull=(SD_PadData[4].data & SD_PadData[4].old);


	if (type==8)
	{
	for (i=5;i<8;i++)
		{
	SD_PadData[i].old=(SD_PadData[i].data);	/* get push */
	SD_PadData[i].data=Get_Tap_Pad(i,&Analog,&PadIn,&Id);
	SD_PadData[i].Id=Id;
	SD_PadData[i].An1X=(signed char)(Analog[0]+0x80)&0xff;
	SD_PadData[i].An1Y=(signed char)(Analog[1]+0x80)&0xff;
	SD_PadData[i].An2X=(signed char)(Analog[2]+0x80)&0xff;
	SD_PadData[i].An2Y=(signed char)(Analog[3]+0x80)&0xff;

	if (PadIn) { SD_PadData[i].InCount=0; SD_PadData[i].In=1; }
		if (PadIn==0)
		{ if (SD_PadData[i].InCount<5) SD_PadData[i].InCount++;
		  else SD_PadData[i].In=0;
		}
	SD_PadData[i].push=(SD_PadData[i].old&(SD_PadData[i].data^-1));
	SD_PadData[i].push2=0xffff-SD_PadData[i].push;

	SD_PadData[i].old=(SD_PadData[i].old ^-1);	/* get pull */
	SD_PadData[i].pull=(SD_PadData[i].data & SD_PadData[i].old);

		}
	}
	else { SD_PadData[5].data=0xffff; SD_PadData[6].data=0xffff;
													 SD_PadData[7].data=0xffff; }



}

#endif

/*
 ** SD_Random, SD_Randomize - By Rob D.
 *
 *  FILENAME: C:\Work\n64dev\frontend\sdfunc64.c
 *
 *  DESCRIPTION: Random number generator.
 *
 *  RETURNS: Returns a psuedo random number.  SD_Randomize can
 *		be called with, say a time, to initialise the seed.
 *
 */


unsigned int SD_Rand(void)
{
	randnum=randnum*1103515245 + 12345;
	return (unsigned int)(randnum/65536)%32768;
}

void SD_Randomize(unsigned int x)
{
	randnum=x;
}

void SD_test_packet_area(void)
{

//	CurrentPacket = GsGetWorkBase();
	CurrentPacket = GsOUT_PACKET_P;
	LastPacketAddr = (PACKET *)&out_packet[1 + outbuf_idx];
	FreePacketSpace = LastPacketAddr - CurrentPacket;
	UsedPacketSpace = CurrentPacket - (PACKET *)&out_packet[outbuf_idx];
	if (FreePacketSpace < 0)
	{
		PacketOverFlow = 1;

		mprintf("Out of packet memory\n");
		mprintf("Out of packet memory\n");
		mprintf("Out of packet memory\n");
		mprintf("Out of packet memory\n");
		mprintf("Out of packet memory\n");
		mprintf("Out of packet memory\n");
		mprintf("Out of packet memory\n");
		mprintf("Out of packet memory\n");
		asm(".word 0x65e97045");
	}

minFreePacketSpace = minFreePacketSpace>FreePacketSpace?FreePacketSpace:minFreePacketSpace;
//mprintf("%-8d %-8d\n",minFreePacketSpace,FreePacketSpace);
}

#if NEWPAD
void startRumble(int p,int r)
{
/*
if(r>SD_PadData[p].rumble[1])
	SD_PadData[p].rumble[1] = r;
else
*/
SD_PadData[p].rumble[1] += r;//>>1;
if(SD_PadData[p].rumble[1]>320)
   SD_PadData[p].rumble[1] = 320;

if(r>200)
	SD_PadData[p].rumble[0] = r;
}
#endif
