/*******************************************************************
 *
 *    DESCRIPTION: Smart Dog PSX lib header
 *
 *    AUTHOR: D.Saunders
 *
 *    HISTORY: started Mon Jan 5 1998
 *
 *******************************************************************/

#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <inline_c.h>
#include <libsnd.h>
#include <libspu.h>
#include <ctrller.h>

#include "sdtypes.h"	// header file of number types
#include "sddemo.h"		// header file for this demo


// PlayStation specific Global vars that SD functions use
extern	GsOT		Wot[2];							// OT header
extern   GsOT_TAG zsorttable[2][(1<<OT_LENGTH)+100];  // Area of OT
extern	GsOT		Wot2[2];						// OT header
extern	GsOT_TAG	zsorttable2[2][1<<OT_LENGTH2]; 	// Area of OT
extern	GsRVIEW2  	view;							// View Point Handler
extern	PACKET		out_packet[2][PACKETMEM];  		// GPU PACKETS AREA
extern	int			outbuf_idx;						// double buffer index
extern	ControllerPacket	buffer1,buffer2;		// PS pad buffers



// functions
void 	SD_Init(unsigned char Mode,unsigned short ResX,unsigned short ResY);
void 	SD_ViewInit(short xpos,short ypos,short zpos,
					short xref,short yref,short zref,
					unsigned short pr);
void 	SD_InitDraw();
void 	SD_EndDraw();
/*
void 	SD_PrintModel(unsigned long	*MemPointer,
               int  md,
					OBJ_PRS			*ObjInf,
					GsOT			*OT,
					GsCOORDINATE2   *PSObj,
					unsigned char 	idx,
					unsigned long	Sort);
*/
void 	SD_GetPadData(APAD	*SD_PadData);

// random number generator functions - by Rob D. DO NOT REMOVE!!!!!!!!!!
unsigned int SD_Rand(void);
void SD_Randomize(unsigned int);
#define SDRAND(x) (SD_Rand() % (x))

//PSX packet memory testing function (for overflow)
void SD_test_packet_area(void);

void padRefresh();

