#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>
#include <inline_c.h>
#include	<libmath.h>
#include "frontend.h"
#include "sdlib\sdfunc.h"
#include "rand.h"
#include	"header.h"
#include "psx\soundPSX.h"                   /////////////////
#include "psx\mathpsx.h"                    //             //
#include "render.h"                         // SSS EEE XXX //
#include "objects.h"                        //   S E   X X //
#include "sim.h"                            // SSS EEE X X //
#include "collide.h"                        //   S E E X X //
#include "weapons.h"                        // SSS EEE XXX //
#include "mesh.h"                           //             //
#include "camera.h"                         /////////////////
#include "pickups.h"
#include "ctrller.h"
#include "state.h"
#include "craftdef.h"
#include "version.h"
#include "psx\loadpsx.h"                    //             //
#include "poon.h"

///////////////////////////////////////////////////////////////////////////////////////////////
// FILE:    sim.c
// AUTHOR:  Spunk Pumper
// NOTES:   soapy tit wank. Cease and desist.  is an arse tit
///////////////////////////////////////////////////////////////////////////////////////////////

extern   APAD     SD_PadData[8];
extern   vec32    LOAD_startpoints[];

s32   ansimhumanstart;
s32   ansimhumanend;
s32   ansimaistart;
s32   ansimaiend;

//vec16 SIM_rp[50];
//s16   SIM_numrp=0;

s32   SIM_p0mod=6;
///////////////////////////////////////////////////////////////////////////////////////////////
// internal f()
///////////////////////////////////////////////////////////////////////////////////////////////
void	SIM_startsim();
void  SIM_computer( s32 ob );
void	SIM_debsim();
void  SIM_reinterpretanalogue( s16 plyr );
s32   SIM_reflectvel( vec32 *v, vec16 *norm, u8 bounce );

void  SIM_craft1( s32 ob );
void  SIM_craft2( s32 ob );

///////////////////////////////////////////////////////////////////////////////////////////////
// internal vars
///////////////////////////////////////////////////////////////////////////////////////////////
extern   s16   sdrag[];
extern   s16   gravmod[];

mat16    wmat, rmat;

vec32    vforward    __attribute__ ((section("cachedata"))) ={0};
vec32    vup         __attribute__ ((section("cachedata"))) ={0};
vec32    vside       __attribute__ ((section("cachedata"))) ={0};
vec16    sp0_16[4]   __attribute__ ((section("cachedata"))) ={{0}};
vec16    sp1_16[4]   __attribute__ ((section("cachedata"))) ={{0}};
vec32    sp0_32[4]   __attribute__ ((section("cachedata"))) ={{0}};
vec32    sp1_32[4]   __attribute__ ((section("cachedata"))) ={{0}};
OBJ_STRUCT        *obj      __attribute__ ((section("cachedata"))) ={0};
s32                plyr     __attribute__ ((section("cachedata"))) ={0};
OBJ_PLAYERSTRUCT  *pplyr    __attribute__ ((section("cachedata"))) ={0};
SIM_crafttype     *craft    __attribute__ ((section("cachedata"))) ={0};

#if 0
RECT rct;
//u_short buf[1024] [512];
int doScreen = 0;
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////
// The big momma function
///////////////////////////////////////////////////////////////////////////////////////////////////
s32   simtime;


void  SIM_craft( s32 ob )
   {
   if(STATE.numplayers==1)
      {
      // single player
      if(ob==0)
         SIM_craft1( ob );
      else
         SIM_craft2( ob );
      }
   else
      {
      // two
      SIM_craft1( ob );
      }
   }

void  SIM_craft1( s32 ob )// 2/7/'98
	{
   vec32    v0, v1;
   vec32    cl[4];
   s32      a, c, latvel;
	s32		f, grip;
	vec32  	oprc;		//ObjPosRelrendereng
   s32      sb =  0;
   s32      slip,dig;
   s32      speed;
   s32      totforce=0;
   u32      nullflag;
   s16      drag  =0 ;

   simtime=VSync(1);
   ansimhumanstart=999;

   obj     =  &OBJ_objects[ ob ];
   plyr    =  obj->owner;
   pplyr   =  &OBJ_players[ plyr ];
   craft   =  &crafts[pplyr->crafttype];

   // killed re-start
   if( pplyr->timer <20 )
      pplyr->throttle   =  0;

//   if( pplyr->SIM_input_data & PAD_RD )
//      RENDER_swirl();

//   if( pplyr->SIM_input_push & PAD_FRB )
//      {
//      COL_blast( &obj->p, 20 );
//      }

//if(ob==0)
//   {
//   s32   f;
//   f  =  LOAD_findheight( obj->p.vx>>8, obj->p.vz>>8  );
//   FntPrint("H %d\n", f);
//   }

   SetRotMatrix( &pplyr->SIM_objmat );
   SetTransMatrix( &pplyr->SIM_objmat );

   vside.vx   =  pplyr->SIM_objmat.m[0][0] <<4 ;
   vside.vy   =  pplyr->SIM_objmat.m[1][0] <<4 ;
   vside.vz   =  pplyr->SIM_objmat.m[2][0] <<4 ;

   vup.vx   =  -pplyr->SIM_objmat.m[0][1] <<4 ;
   vup.vy   =  -pplyr->SIM_objmat.m[1][1] <<4 ;
   vup.vz   =  -pplyr->SIM_objmat.m[2][1] <<4 ;

   vforward.vx   =  pplyr->SIM_objmat.m[0][2] <<4 ;
   vforward.vy   =  pplyr->SIM_objmat.m[1][2] <<4 ;
   vforward.vz   =  pplyr->SIM_objmat.m[2][2] <<4 ;

   mov( pplyr->oldp, obj->p );

   //vequs( &wvect, 0,0,0 );
	oprc.vx	=	obj->p.vx>>8;
	oprc.vy	=	obj->p.vy>>8;
	oprc.vz	=	obj->p.vz>>8;

   equ( sp0_16[0], -craft->susspringtopdim, craft->susspringtop, +craft->susspringtopdim );
   equ( sp0_16[1], +craft->susspringtopdim, craft->susspringtop, +craft->susspringtopdim );
   equ( sp0_16[2], +craft->susspringtopdim, craft->susspringtop, -craft->susspringtopdim );
   equ( sp0_16[3], -craft->susspringtopdim, craft->susspringtop, -craft->susspringtopdim );

   equ( sp1_16[0], -craft->susspringbotdim, craft->susspringbot, +craft->susspringbotdim );
   equ( sp1_16[1], +craft->susspringbotdim, craft->susspringbot, +craft->susspringbotdim );
   equ( sp1_16[2], +craft->susspringbotdim, craft->susspringbot, -craft->susspringbotdim );
   equ( sp1_16[3], -craft->susspringbotdim, craft->susspringbot, -craft->susspringbotdim );


   // turbo
   if(pplyr->turbo)
      {
//      if(G_cyc&1)
//         RENDER_swirl();
      pplyr->turbo--;
      //FntPrint("turbo");
      }
   /////////////////
   //             //
   // SSS EEE XXX //
   //   S E   X X //
   // SSS EEE X X //
   //   S E E X X //
   // SSS EEE XXX //
   //             //
   /////////////////

   // enter 360 mode
   if( pplyr->SIM_input_push & PAD_FLB )
      {
      pplyr->mode360= 2;
      pplyr->crossx360=0;
      }

   // leave 360 mode
   if( !(pplyr->SIM_input_data & PAD_FLB) )
      {
      pplyr->mode360= -1;
      }

//      switch(pplyr->mode360)
//         {
//         case -1:

//                  ;
//                  //pplyr->computer=1;
//                  break;
//         case  1: pplyr->mode360= 2;
//                  pplyr->crossx360=0;
//                  CAM_came[CAM_c].vy+=1000;
//                  //pplyr->computer=1;
//                  break;
//         case  2: pplyr->mode360= -1;
//                  //pplyr->computer=0;
//                  break;
//         case  3: pplyr->mode360= -1;
//                  //pplyr->computer=0;
//                  break;
//         }
//   }

//   if(pplyr->mode360 != -1)
//      {
//      vec32 c0={0,0,-1500};//mike inversion on z
//      vec32 cl={-500,0,-1500};
//      vec32 cr={ 500,0,-1500};
//      vec32 cf={ 0,0,-2000};

//      vapplymatrix32( &pplyr->SIM_objmat, &c0, &c0 );
//      vapplymatrix32( &pplyr->SIM_objmat, &cl, &cl );
//      vapplymatrix32( &pplyr->SIM_objmat, &cr, &cr );
//      vapplymatrix32( &pplyr->SIM_objmat, &cf, &cf );


//      c0.vx +=  ( oprc.vx );
//      c0.vy  =  ( oprc.vy );
//      c0.vz +=  ( oprc.vz );

//      cl.vx +=  ( oprc.vx );
//      cl.vy  =  ( oprc.vy );
//      cl.vz +=  ( oprc.vz );

//      cr.vx +=  ( oprc.vx );
//      cr.vy  =  ( oprc.vy );
//      cr.vz +=  ( oprc.vz );

//      cf.vx +=  ( oprc.vx );
//      cf.vy  =  ( oprc.vy );
//      cf.vz +=  ( oprc.vz );

//      c  =  COL_test2( &cr, &cl );
//      if(c>0)
//         {
//         c = 3*(2000-vqlen( cl.vx-COL_inter.vx, 0, cl.vz-COL_inter.vz ));
//         //sprintf(debbuf,"cl");
//         //RENDER_message(debbuf);
//         pplyr->wvect.vy     +=  c;
//         }

//      c  =  COL_test2( &cl, &cr );
//      if(c>0)
//         {
//         c = 3*(2000-vqlen( cr.vx-COL_inter.vx, 0, cr.vz-COL_inter.vz ));
//         //sprintf(debbuf,"cr");
//         //RENDER_message(debbuf);
//         pplyr->wvect.vy     +=  -c;
//         }

//      c  =  COL_test2( &c0, &cf );
//      if(c>0)
//         {
//         pplyr->mode360 =- 1;
//         }
//      }
///////////////////////////////////////////////////////////////////////////////////////////////

   // speed
   mov( v0, obj->v );
	v0.vx	=	v0.vx>>8;
	v0.vy	=	v0.vy>>8;
	v0.vz	=	v0.vz>>8;
	vsquare32( &v0, &v0 );
   pplyr->speed = speed =  vroot32( v0.vx + v0.vy + v0.vz );


//   if((speed<70)&&(pplyr->throttle<10))
//      {
//      obj->v.vx   =(obj->v.vx*220)>>8;
//      obj->v.vy   =(obj->v.vy*220)>>8;
//      obj->v.vz   =(obj->v.vz*220)>>8;
//      }
   //sub( obj->v, v0 );
	/////////////////


   dig=0;
   // shoulder dig
   if( ((pplyr->SIM_input_data & PAD_FRT)&&!(pplyr->SIM_input_data & PAD_FLT)) ||
       ((pplyr->SIM_input_data & PAD_LR) && (pplyr->SIM_input_data & PAD_LD)) ||
       ((pplyr->SIM_input_an1x >40) && (pplyr->SIM_input_data&2)))
		{
      pplyr->wvect.vy     =  -6000;
      dig=1;
		}

   if( ((pplyr->SIM_input_data & PAD_FLT)&&!(pplyr->SIM_input_data & PAD_FRT)) ||
       ((pplyr->SIM_input_data & PAD_LL) && (pplyr->SIM_input_data & PAD_LD)) ||
       ((pplyr->SIM_input_an1x <-40) && (pplyr->SIM_input_data&2)))
		{
      pplyr->wvect.vy     = 6000;
      dig=1;
//      pplyr->timer=0;
      }

	///////////////
   totforce=0;

	// side force
	v0.vx	=	vside.vx>>8;//8
	v0.vy	=	0;
	v0.vz	=	vside.vz>>8;//8

	v1.vx	=  obj->v.vx;//0
	v1.vy	=  0;
	v1.vz	=  obj->v.vz;

   latvel   =  slip  =  vdot( &v0, &v1 ); //16

	grip	=	craft->grip;
   //if( pplyr->turbo )grip<<=3;
   grip  =  (grip* pplyr->stability)>>8;
   //if(dig)grip<<=1;
   if(pplyr->throttle>128)
      grip  =  (grip*(255-(pplyr->throttle-128)))>>8;

   if(grip<0)grip=0;

   pplyr->latgrip  =  abs(grip);
   pplyr->latslip  =  abs(slip);

   if( slip> grip )slip =   grip;
   if( slip<-grip )slip =  -grip;

   v0.vx *= slip;
   v0.vz *= slip;
	obj->v.vx	-=	v0.vx>>16;
	obj->v.vz	-=	v0.vz>>16;
   /////////////

///////////////////////////////////////////////////////////////////////////////////////////////
   // steer analogue
   if( pplyr->SIM_input_id==7 )
      {
      a = pplyr->SIM_input_an1x;

      if(pplyr->computer==0)  //dead zone for human
         if( a>-40 && a<40 )a=0;

      if(pplyr->mode360==2)
         {
         if(a>50)
            pplyr->crossx360+=20;
         if(a<-50)
            pplyr->crossx360-=20;
         }
      else
         {
         pplyr->wvect.vy  -= ( 255*a*100*craft->steerrate )>>15;
         }
      }
///////////////////////////////////////////////////////////////////////////////////////////////
   // steer digital
   else
      {
      if(pplyr->mode360==2)
         {
         if(pplyr->SIM_input_data & PAD_LR)
            pplyr->crossx360+=20;
         if(pplyr->SIM_input_data & PAD_LL)
            pplyr->crossx360-=20;
         }
      else
         {
         if( pplyr->SIM_input_data & PAD_LL )
            {
            pplyr->steerang  += pplyr->steervel;
            if( pplyr->steerang > 255 )pplyr->steerang =  255;
            }
         else
            if( pplyr->SIM_input_data & PAD_LR )
               {
               pplyr->steerang  -= pplyr->steervel;
               if( pplyr->steerang < -255 )pplyr->steerang   =  -255;
               }
            else
               { // no input
               if( pplyr->steerang > pplyr->steervel)
                  {
                  pplyr->steerang -= pplyr->steervel;
                  }
               else
                  if( pplyr->steerang < -pplyr->steervel)
                     {
                     pplyr->steerang += pplyr->steervel;
                     }
                  else
                     {
                     pplyr->steerang=0;
                     }
               }

         pplyr->wvect.vy  += (  pplyr->steerang*
                                       100*
                                       craft->steerrate*
                                       255/*pplyr->stability*/ )>>16;
         }
      }
	////////
///////////////////////////////////////////////////////////////////////////////////////////////
	// throttle
   if( pplyr->SIM_input_data & PAD_RD )
		{
      pplyr->throttle  += pplyr->throttlevel;
      if( pplyr->throttle > 255 )pplyr->throttle =  255;
      a  =  (10*pplyr->throttle)>>8;
      sp1_16[2].vy   += a;//  suspension tip
      sp1_16[3].vy   += a;
		}
	else
      if( pplyr->SIM_input_data & PAD_RL )
			{
         pplyr->throttle  -= pplyr->throttlevel;
         if( pplyr->throttle < -255 )pplyr->throttle   =  -255;
			}
		else
			{ // no input
         a  =  (10*pplyr->throttle)>>8;
         sp1_16[2].vy   += a;//  suspension tip
         sp1_16[3].vy   += a;

         if( pplyr->throttle > pplyr->throttlevel )
				{
            pplyr->throttle -= pplyr->throttlevel>>1;
				}
			else
            if( pplyr->throttle < -pplyr->throttlevel )
					{
               pplyr->throttle += pplyr->throttlevel;
					}
				else
					{
               pplyr->throttle=0;
					}
			}

   {// limit thrust
    // do lim only in app dir
   s32   lim, top;
   //s32   dot;
   //dot   =  (vforward.vx)*pobj->v.vx  *  (vforward.vz)*pobj->v.vz;
   //if(dot<0)dot=-dot;
   if(pplyr->turbo)
      pplyr->throttle=255;

   // catch up if behind
   if( STATE.gametype!=2 )//not time trial
      {
      top   =  128   +    5*pplyr->stats.position;
      }
   else
      {
      top   =  128;
      }

//   FntPrint("\n\n\n\n\n\n %d\n", top );
   lim   =  top - ((speed*craft->imax)>>8);
   //lim   =  9345/(speed+73);
   if(lim<0)lim=0;
      //FntPrint("forwards %d", speed);
      {
      if(pplyr->throttle>=0)
         {
         if(pplyr->turbo)
            {
            lim   += 52;
            lim   =  180 - ((speed*craft->imax)>>8);
            if(lim<0)lim=0;
            obj->v.vx += (((craft->thrust*(( vforward.vx * 255 )>>14))>>8)*lim)>>8;
            obj->v.vz += (((craft->thrust*(( vforward.vz * 255 )>>14))>>8)*lim)>>8;
            }
         else
            {
            obj->v.vx += (((craft->thrust*(( vforward.vx * pplyr->throttle )>>14))>>8)*lim)>>8;
            obj->v.vz += (((craft->thrust*(( vforward.vz * pplyr->throttle )>>14))>>8)*lim)>>8;
            }
         }
      //else
      // brakes
      if( pplyr->SIM_input_data & PAD_RL )
         {
         s32   spmod =  500;

         if( ((obj->v.vx>>8)*vforward.vx + (obj->v.vz>>8)*vforward.vz) >0  )
            {
            obj->v.vx += (-spmod*(600*( vforward.vx >>7))>>8)>>8;
            obj->v.vz += (-spmod*(600*( vforward.vz >>7))>>8)>>8;
            }
         else
            {
            //FntPrint("backwards");
            //obj->v.vx += (spmod*(600*( vforward.vx >>7)) >>8 ) >>8;
            //obj->v.vz += (spmod*(600*( vforward.vz >>7)) >>8 ) >>8;
            if(speed<100)
               {
               obj->v.vx += (-spmod*(600*( vforward.vx >>7))>>8)>>8;
               obj->v.vz += (-spmod*(600*( vforward.vz >>7))>>8)>>8;
               }
            }
         }
      }
   }

///////////////////////////////////////////////////////////////////////////////////////////////

	// stability control;
   if( pplyr->stability<256 )
		{
      pplyr->stability += 5;
      if( pplyr->stability>256 )
         pplyr->stability =  255;
		}

	if( sb == 1 )
		{
      sp1_16[0].vy   >>=  1;
      sp1_16[3].vy   >>=  1;
		}
	if( sb == 2 )
		{
      sp1_16[1].vy   >>=  1;
      sp1_16[2].vy   >>=  1;
		}
	if( sb == 3 )
		{
      sp1_16[0].vy   =  36;
      sp1_16[1].vy   =  36;
		}

   // adjust suspension points for roll
   if(latvel>1000)
      {
      sp1_16[0].vy   -=  latvel>>17;
      sp1_16[3].vy   -=  latvel>>17;
      }
   else
      if(latvel<1000)
         {
         sp1_16[1].vy   -=  -latvel>>17;
         sp1_16[2].vy   -=  -latvel>>17;
         }

   /////////////

   RotTransSV( &sp0_16[0], &sp0_16[0], &nullflag );
   RotTransSV( &sp1_16[0], &sp1_16[0], &nullflag );
   RotTransSV( &sp0_16[1], &sp0_16[1], &nullflag );
   RotTransSV( &sp1_16[1], &sp1_16[1], &nullflag );
   RotTransSV( &sp0_16[2], &sp0_16[2], &nullflag );
   RotTransSV( &sp1_16[2], &sp1_16[2], &nullflag );
   RotTransSV( &sp0_16[3], &sp0_16[3], &nullflag );
   RotTransSV( &sp1_16[3], &sp1_16[3], &nullflag );

   mov( sp0_32[0], sp0_16[0] );                mov( sp1_32[0], sp1_16[0] );
   mov( sp0_32[1], sp0_16[1] );                mov( sp1_32[1], sp1_16[1] );
   mov( sp0_32[2], sp0_16[2] );                mov( sp1_32[2], sp1_16[2] );
   mov( sp0_32[3], sp0_16[3] );                mov( sp1_32[3], sp1_16[3] );
   add( sp0_32[0], oprc );                     add( sp1_32[0], oprc );
   add( sp0_32[1], oprc );                     add( sp1_32[1], oprc );
   add( sp0_32[2], oprc );                     add( sp1_32[2], oprc );
   add( sp0_32[3], oprc );                     add( sp1_32[3], oprc );

   if( (pplyr->SIM_input_push & PAD_RU) )
		{
      CAM_cammode[plyr]++;

	  #if IAN
      	if( CAM_cammode[plyr] ==6 )CAM_cammode[plyr]=0;
      #else
	    if( CAM_cammode[plyr] ==3 )CAM_cammode[plyr]=0;
	  #endif
//      switch( CAM_cammode[plyr] )
//         {
//         case  0:RENDER_message("norm camera");break;
//         case  1:RENDER_message("near camera");break;
//         case  2:RENDER_message("first person camera");break;
//         case  3:RENDER_message("heli camera");break;
//         case  4:RENDER_message("top-down camera");break;
//         case  5:RENDER_message("Panning camera");break;
//         }
		}

	////////////////

	// springs,dampers
	for(f=0;f<4;f++)
		{
      c  =  COL_test2( &sp0_32[f], &sp1_32[f] );
		if( c>=0 )
			{
         vec16 norm={0,-4096,0};
         vec32   imp, up;
			vec32	r, nv;
			s32	len;

         drag+=sdrag[ COL_surftype ];
         //FntPrint( "%s\n" , COL_stypename[ COL_surftype ]);
         mov( norm, COL_norm );

         up.vx = up.vy = up.vz = 0;

         len   =((sp1_32[f].vy - COL_inter.vy)*400)>>8   ; // spring
         //len   =  len   +  (((len-pplyr->leno[f])*500)>>8); //damp
         len   =  len   +  (((len-pplyr->leno[f])*750)>>8); //damp

         pplyr->leno[f]   =  sp1_32[f].vy - COL_inter.vy;
         //pplyr->leno[f]   =  len2;

         mov( r, oprc );
         sub( r, COL_inter );
			up.vy=-len;
			vcross( &up, &r, &imp );
			imp.vx	>>=	3;
			imp.vy	>>=	3;
			imp.vz	>>=	3;

			nv.vx	=	norm.vx * (len<<4);
			nv.vy	=	norm.vy * (len<<4);
			nv.vz	=	norm.vz * (len<<4);

			nv.vx>>=14;
			nv.vy>>=14;
			nv.vz>>=14;

         obj->v.vx   += (nv.vx*gravmod[COL_surftype])>>8;
         obj->v.vy   += nv.vy;
         obj->v.vz   += (nv.vz*gravmod[COL_surftype])>>8;

         pplyr->wvect.vx  += imp.vx>>1;
         pplyr->wvect.vy  += imp.vy>>1;
         pplyr->wvect.vz  += imp.vz>>1;
			}
      else
         {
         //pplyr->leno[f]   =  sp1[f].vy-sp0[f].vy;
         }
//GPU_bar(pplyr->leno[f], f);

		}
   //////////////////

   // surface drag
   mov( v0, obj->v );
   shr( v0, 8);
   v0.vx =  (drag*speed*v0.vx)>>8;
   v0.vy =  (drag*speed*v0.vy)>>8;
   v0.vz =  (drag*speed*v0.vz)>>8;
   sub(obj->v, v0);

	// grav
   //obj->v.vy   +=1400;
   obj->v.vy   +=1600;
	///////


	// clamp yvel
   //if( obj->v.vy < -5000 )obj->v.vy =  -5000;
	/////////////

	// clamp ypos via vel
	/*
	if( obj->p.vy < -245000 && obj->v.vy<0 )
		{
		obj->v.vy	-=	obj->v.vy>>1;
		obj->v.vx	-=	obj->v.vx>>3;
		obj->v.vz	-=	obj->v.vz>>3;

		if( obj->p.vy < -247000 )obj->v.vy	=0;
		}
	*/

   // only allow thrust if race has started and not finished, else brake
   if( (STATE.raceclock<0)  )/*|| pplyr->stats.lap>3) )*/
      {
      equ( obj->v, 0,0,0 );
      }

	// add vels
   add( obj->p, obj->v );
	///////////

	// upright
   equ( v0, 0,-1,0);
   //v1.vx =  vup.vx>>8;
   //v1.vy =  vup.vy>>8;
   //v1.vz =  vup.vz>>8;
   v1.vx =  vup.vx>>6;
   v1.vy =  vup.vy>>6;
   v1.vz =  vup.vz>>6;

	vcross( &v1, &v0, &v1 );//8
	//v1.vx*20;
	//v1.vz*20;
   pplyr->wvect.vx  += v1.vx;
   pplyr->wvect.vz  += v1.vz;
	// upright


   // ang damp
   pplyr->wvect.vx  -= 255/*pplyr->stability*/*(pplyr->wvect.vx>>4)>>8;
   pplyr->wvect.vy  -= 255/*pplyr->stability*/*((craft->ywdamp*(pplyr->wvect.vy>>2))>>8)>>8;
   pplyr->wvect.vz  -= 255/*pplyr->stability*/*(pplyr->wvect.vz>>4)>>8;
	///////////


   // add w

   msetmatrotvect( &wmat, &pplyr->wvect );
   vmulmatrix2( &wmat, &pplyr->SIM_objmat );
	// remove compounded inaccuraccy in matrix
   vnormmat( &pplyr->SIM_objmat, (u8)(G_cyc+ob)&255 );

// christmas collision
   {
   s32   gamma[4];
   s32   cres[4];// coll result
   vec32 colp[4];// coll inter
   vec16 norm[4];// norm of collinter face
   vec32 cv0[4];
   vec32 cv1[4];
   u8    idx;
   s32   mingam;

   equ( cl[0], 0,    -0,  130 );
   equ( cl[1], 0,    -0, -130 );
   equ( cl[2],  130, -0,    0 );
   equ( cl[3], -130, -0,    0 );

   for(f=0;f<4;f++)
      {
      // test 4 coll vectors, store result
      cv0[f].vx =  (pplyr->oldp.vx >> 8)  +  cl[f].vx;
      cv0[f].vy =  (pplyr->oldp.vy >> 8)  +  cl[f].vy;
      cv0[f].vz =  (pplyr->oldp.vz >> 8)  +  cl[f].vz;

      cv1[f].vx =  (obj->p.vx >> 8)  +  cl[f].vx;
      cv1[f].vy =  (obj->p.vy >> 8)  +  cl[f].vy;
      cv1[f].vz =  (obj->p.vz >> 8)  +  cl[f].vz;

      cres[f]  =  COL_test2( &cv0[f], &cv1[f] );
      if( cres[f]>=0 )
         {
         colp[f].vx  =  COL_inter.vx;
         colp[f].vy  =  COL_inter.vy;
         colp[f].vz  =  COL_inter.vz;
         norm[f].vx  =  COL_norm.vx;
         norm[f].vy  =  COL_norm.vy;
         norm[f].vz  =  COL_norm.vz;
         gamma[f]    =  COL_gamma16;
         }
      }

   // find idx of the first(nearest) collision
   mingam=100000;
   for(f=0;f<4;f++)
      {
      if( cres[f]>=0 )
      if( gamma[f]<mingam )
         {
         idx=f;
         mingam   =  gamma[f];
         }
      }

   if( (cres[0]>=0) || (cres[1]>=0) || (cres[2]>=0) || (cres[3]>=0) )
      {
	  s32 r;

      //move pos to hit point
      mov( v0, cv1[0] );
      sub( v0, cv0[0] );

      //gamma[idx]-=2000;
      //if(gamma[idx]<0)gamma[idx]=0;

      v0.vx =  (v0.vx*gamma[idx])>>8;
      v0.vy =  (v0.vy*gamma[idx])>>8;
      v0.vz =  (v0.vz*gamma[idx])>>8;

      obj->p.vx   = pplyr->oldp.vx + v0.vx;
      obj->p.vy   = pplyr->oldp.vy + v0.vy;
      obj->p.vz   = pplyr->oldp.vz + v0.vz;

      // bounce
      r = SIM_reflectvel( &obj->v, &norm[idx], 170 );

#if NEWPAD
		// mats collison rumble
		{
		if(r<0)
			r = -r;

		r >>= 7;

		if(r>255)
			r = 255;

		if(ob==0)
		if(STATE.numplayers>=1)
		    startRumble(0,r);
		if(ob==1)
		if(!steer_mode)					// iant botch
//		if(STATE.numplayers>=2)			// maximum of 2 players ??
		    startRumble(4,r);
		}
#endif
      S2_sfxdynamic( 28 + (rand()&3), obj->p.vx>>8, obj->p.vz>>8, 0, r>>1, 4200+(rand()&255) );

      if(norm[idx].vy<=0)
         {
         obj->p.vx   += norm[idx].vx>>2;
         obj->p.vy   += norm[idx].vy>>2;
         obj->p.vz   += norm[idx].vz>>2;
         }
      else
         {
         obj->p.vx   += norm[idx].vx;
         obj->p.vz   += norm[idx].vz;
         }
      // calc new pos
      mov(pplyr->oldp, obj->p );

      mov(v0,obj->v);
      gamma[idx]  =  65536 -  gamma[idx];
      if(gamma[idx]<0)gamma[idx]=0;
      gamma[idx]>>=8;
      v0.vx =  (v0.vx*gamma[idx])>>8;
      v0.vy =  (v0.vy*gamma[idx])>>8;
      v0.vz =  (v0.vz*gamma[idx])>>8;
      add( obj->p, v0 );
      }
// christmas collision^^

// easter collision
   if( (cres[0]>=0) || (cres[1]>=0) || (cres[2]>=0) || (cres[3]>=0) )
      {
      for(f=0;f<4;f++)
         {
         // test 4 coll vectors, store result
         cv0[f].vx =  (pplyr->oldp.vx >> 8)  +  cl[f].vx;
         cv0[f].vy =  (pplyr->oldp.vy >> 8)  +  cl[f].vy;
         cv0[f].vz =  (pplyr->oldp.vz >> 8)  +  cl[f].vz;

         cv1[f].vx =  (obj->p.vx >> 8)  +  cl[f].vx;
         cv1[f].vy =  (obj->p.vy >> 8)  +  cl[f].vy;
         cv1[f].vz =  (obj->p.vz >> 8)  +  cl[f].vz;

         cres[f]  =  COL_test2( &cv0[f], &cv1[f] );
         if( cres[f]>=0 )
            {
            colp[f].vx  =  COL_inter.vx;
            colp[f].vy  =  COL_inter.vy;
            colp[f].vz  =  COL_inter.vz;
            norm[f].vx  =  COL_norm.vx;
            norm[f].vy  =  COL_norm.vy;
            norm[f].vz  =  COL_norm.vz;
            gamma[f]    =  COL_gamma16;
            }
         }

      mingam=100000;
      for(f=0;f<4;f++)
         {
         if( cres[f]>=0 )
         if( gamma[f]<mingam )
            {
            idx=f;
            mingam   =  gamma[f];
            }
         }
      if( (cres[0]>=0) || (cres[1]>=0) || (cres[2]>=0) || (cres[3]>=0) )
         {
         //move pos to hit point
         mov( v0, cv1[0] );
         sub( v0, cv0[0] );

         //gamma[idx]-=2000;
         //if(gamma[idx]<0)gamma[idx]=0;

         v0.vx =  (v0.vx*gamma[idx])>>8;
         v0.vy =  (v0.vy*gamma[idx])>>8;
         v0.vz =  (v0.vz*gamma[idx])>>8;

         obj->p.vx   = pplyr->oldp.vx + v0.vx;
         obj->p.vy   = pplyr->oldp.vy + v0.vy;
         obj->p.vz   = pplyr->oldp.vz + v0.vz;

         // bounce
         SIM_reflectvel( &obj->v, &norm[idx], 170 );

         if(norm[idx].vy<=0)
            {
            obj->p.vx   += norm[idx].vx>>2;
            obj->p.vy   += norm[idx].vy>>2;
            obj->p.vz   += norm[idx].vz>>2;
            }
         else
            {
            obj->p.vx   += norm[idx].vx;
            obj->p.vz   += norm[idx].vz;
            }
         }
//    easter collision^^
      if(obj->v.vy<-10000)obj->v.vy=-10000;

      }
   }

	// fall off world restart
   if( obj->p.vy > (4600<<8) )
		{
      SIM_startsim( ob );
      //sprintf(debbuf, "Player %d fell off world", plyr);
      //RENDER_message(debbuf);
      }

   a  =  vatan2( vforward.vx, vforward.vz )<<4;
   obj->r.vy  = a;
   if(pplyr->mode360 != -1)obj->r.vy += (2048<<4) + (pplyr->crossx360<<7);

   vrot32( &vup.vx, &vup.vz, -a );
   a  =  vatan2( vup.vx, -vup.vy )<<4;
   obj->r.vz  = a;

   a  =  vatan2( vup.vz, -vup.vy )<<4;
   obj->r.vx  = a;

   simtime  =  VSync(1) -  simtime;
   //FntPrint( "simtime %d\n", simtime );
   ansimhumanend=999;


   }

s32  SIM_reflectvel( vec32 *v, vec16 *norm, u8 bounce )
   {
   s32   dp;
   vec32 v0,v2;

   v0.vx =  norm->vx >> 5; //7
   v0.vy =  norm->vy >> 5;
   v0.vz =  norm->vz >> 5;

   dp = (( v->vx >>7 )*( v0.vx ) +
         ( v->vy >>7 )*( v0.vy ) +
         ( v->vz >>7 )*( v0.vz ) );   //0

   v2.vx =  (v0.vx)*dp;//7
   v2.vy =  (v0.vy)*dp;//
   v2.vz =  (v0.vz)*dp;//

   // no bounce downwards
   if( norm->vy <=0 )
      {
      v->vx   -= ((v2.vx >> 6)*bounce)>>8;
      v->vy   -= ((v2.vy >> 6)*bounce)>>8;
      v->vz   -= ((v2.vz >> 6)*bounce)>>8;
      }
   else
      {
      v->vx   -= ((v2.vx >> 6)*bounce)>>8;
      v->vy    =  0;
      v->vz   -= ((v2.vz >> 6)*bounce)>>8;
      }
   // damp vel if low norm.y
   if( norm->vy > -2500 )
      {
      //FntPrint("low norm!(%d)\n", norm->vy );
      v->vx   >>=0;
      v->vy   >>=3;
      v->vz   >>=0;
      }
   return dp;
   }

void	SIM_startsim( s32	ob )
	{
   vec16 rot;
   s16   c;

   printf("yrot (%d)\n", LOAD_startrots[ ob ]);
   rot.vx=0;
   rot.vy=LOAD_startrots[ ob ];
   rot.vz=0;

   vequ( &OBJ_objects[ ob ].v, 0,0,0 );
	vequs( &OBJ_players[ ob ].wvect, 0,0,0 );

   vrotmatrix( &rot,&OBJ_players[ ob ].SIM_objmat );

//   OBJ_players[ ob ].SIM_objmat.m[0][0]=4096;
//   OBJ_players[ ob ].SIM_objmat.m[0][1]=0;
//   OBJ_players[ ob ].SIM_objmat.m[0][2]=0;

//   OBJ_players[ ob ].SIM_objmat.m[1][0]=0;
//   OBJ_players[ ob ].SIM_objmat.m[1][1]=4096;
//   OBJ_players[ ob ].SIM_objmat.m[1][2]=0;

//   OBJ_players[ ob ].SIM_objmat.m[2][0]=0;
//   OBJ_players[ ob ].SIM_objmat.m[2][1]=0;
//   OBJ_players[ ob ].SIM_objmat.m[2][2]=4096;

   OBJ_objects[ ob ].p.vx  =  LOAD_startpoints[5-ob].vx<<8;
   OBJ_objects[ ob ].p.vy  =  LOAD_startpoints[5-ob].vy<<8;
   OBJ_objects[ ob ].p.vz  =  LOAD_startpoints[5-ob].vz<<8;

	vmov( &OBJ_players[ ob ].oldp, &OBJ_objects[ob].p );

   OBJ_players[ ob ].rp0=OBJ_players[ ob ].rp1=OBJ_players[ ob ].rp2=-1;

   //printf("rp0%d\n", OBJ_players[ ob ].rp0 );
   //printf("rp1%d\n", OBJ_players[ ob ].rp1 );
   //printf("rp2%d\n", OBJ_players[ ob ].rp2 );
   }



// simple object sim
// NEED friction to stop ,bounce, turn off
void  SIM_rock( OBJ_STRUCT* obj )
   {
   vec32   op, v, p, c0, c1;
   s32     c;

   mov( op, obj->p );
   c0.vx =  obj->p.vx;
   c0.vy =  obj->p.vy;
   c0.vz =  obj->p.vz;

   obj->v.vy   +=1;
   add( obj->p, obj->v );

   c1.vx =  obj->p.vx;
   c1.vy =  obj->p.vy;
   c1.vz =  obj->p.vz;

   c  =  COL_test2( &c0, &c1 );

   if(c>0)
      {
      sprintf(debbuf,"MINE: ouch");
      RENDER_message(debbuf);
      //vmov( &obj->p, &op );
      //obj->v.vx   *=-1;
      obj->v.vy   *=-1;
      //obj->v.vz   *=-1;
      }

   }
//       m00 m01 m02
//       m10 m11 m12
//       m20 m21 m22
// 0,0,1

s16   sdrag[20]={
 0,//,   NA"},
20,//,   brick"},
10,//,   concrete"},
10,//,   crazy p"},
 1,//,   dry ash"},
 5,//,   foliage"},
10,//,   grass"},
 0,//,   ice"},
 1,//,   lava"},
 1,//,   magma"},
10,//,   metal"},
 5,//,   mud"},
 1,//,   rock"},
 4,//,   sand"},
20,//,   snow"},
 4,//,   stone"},
20,//,   trees"},
 0,//,   water"},
10,//,   waterfall"},
10};//,   wood"}};

s16   gravmod[20]={
2000,//,   NA"},
6000,//,   brick"},
 100,//,   concrete"},
 100,//,   crazy p"},
 300,//,   dry ash"},
 100,//,   foliage"},
 500,//,   grass"},
 300,//,   ice"},
 100,//,   lava"},
 100,//,   magma"},
 100,//,   metal"},
 100,//,   mud"},
 100,//,   rock"},
 100,//,   sand"},
6000,//,   snow"},
 100,//,   stone"},
2000,//,   trees"},
100,//,   water"},
2000,//,   waterfall"},
};//,   wood"}};

void  SIM_craft2( s32 ob )// 2/7/'98
	{
	vec32		c0, c1, v, v0, v1, v2;
   vec32    cl[4];
   s32      a, c, latvel;
	s32		f, grip;
	vec32  	oprc;		//ObjPosRelrendereng
   s32      sb =  0;
   s32      slip,dig;
   s32      speed;
   s32      totforce=0;
   vec32    nullv={0,0,0};
   u32      nullflag;
   s16      drag  =0 ;
   vec32    rollv;

   simtime=VSync(1);
   ansimaistart=999;

   obj     =  &OBJ_objects[ ob ];
   plyr    =  obj->owner;
   pplyr   =  &OBJ_players[ plyr ];
   //craft   =  &crafts[pplyr->crafttype];
   craft   =  &crafts[1];

   if( pplyr->timer <20 )
      pplyr->throttle   =  0;

   if( (pplyr->SIM_input_push & PAD_RU) )
		{
      CAM_cammode[plyr]++;

	  #if IAN
      	if( CAM_cammode[plyr] ==6 )CAM_cammode[plyr]=0;
      #else
	    if( CAM_cammode[plyr] ==3 )CAM_cammode[plyr]=0;
	  #endif
//      switch( CAM_cammode[plyr] )
//         {
//         case  0:RENDER_message("norm camera");break;
//         case  1:RENDER_message("near camera");break;
//         case  2:RENDER_message("first person camera");break;
//         case  3:RENDER_message("heli camera");break;
//         case  4:RENDER_message("top-down camera");break;
//         case  5:RENDER_message("Panning camera");break;
//         }
		}

   // only allow thrust if race has started and not finished, else brake
   if( (STATE.raceclock<0)  )/*|| (pplyr->stats.lap>3) )*/
      {
      pplyr->SIM_input_data   =0;
      }

   SetRotMatrix( &pplyr->SIM_objmat );
   SetTransMatrix( &pplyr->SIM_objmat );

   vside.vx   =  pplyr->SIM_objmat.m[0][0] <<4 ;
   vside.vy   =  pplyr->SIM_objmat.m[1][0] <<4 ;
   vside.vz   =  pplyr->SIM_objmat.m[2][0] <<4 ;

   vup.vx   =  -pplyr->SIM_objmat.m[0][1] <<4 ;
   vup.vy   =  -pplyr->SIM_objmat.m[1][1] <<4 ;
   vup.vz   =  -pplyr->SIM_objmat.m[2][1] <<4 ;

   vforward.vx   =  pplyr->SIM_objmat.m[0][2] <<4 ;
   vforward.vy   =  pplyr->SIM_objmat.m[1][2] <<4 ;
   vforward.vz   =  pplyr->SIM_objmat.m[2][2] <<4 ;

   mov( pplyr->oldp, obj->p );

   //vequs( &wvect, 0,0,0 );
	oprc.vx	=	obj->p.vx>>8;
	oprc.vy	=	obj->p.vy>>8;
	oprc.vz	=	obj->p.vz>>8;


   // turbo
   if(pplyr->turbo)
      {
      pplyr->turbo--;
      //FntPrint("turbo");
      }
   /////////////////
   //             //
   // SSS EEE XXX //
   //   S E   X X //
   // SSS EEE X X //
   //   S E E X X //
   // SSS EEE XXX //
   //             //
   /////////////////

//   if( pplyr->SIM_input_push & PAD_FLB )
//      {
//      SOUND_sfx(4);
//      switch(pplyr->mode360)
//         {
//         case -1: pplyr->mode360= 2;
//                  pplyr->crossx360=0;
//                  CAM_came[CAM_c].vy+=1000;
//                  break;
//         case  1: pplyr->mode360= 2;
//                  pplyr->crossx360=0;
//                  CAM_came[CAM_c].vy+=1000;
//                  break;
//         case  2: pplyr->mode360= -1;
//                  break;
//         case  3: pplyr->mode360= -1;
//                  break;
//         }
//      }

   if( pplyr->SIM_input_data & PAD_FLB )
      {
      pplyr->mode360= 2;
      pplyr->crossx360=0;
      }
   else
      {
      pplyr->mode360= -1;
      }

   if(pplyr->mode360 != -1)
      {
      vec32 c0={0,0,-1500};//mike inversion on z
      vec32 cl={-500,0,-1500};
      vec32 cr={ 500,0,-1500};
      vec32 cf={ 0,0,-2000};

      vapplymatrix32( &pplyr->SIM_objmat, &c0, &c0 );
      vapplymatrix32( &pplyr->SIM_objmat, &cl, &cl );
      vapplymatrix32( &pplyr->SIM_objmat, &cr, &cr );
      vapplymatrix32( &pplyr->SIM_objmat, &cf, &cf );


      c0.vx +=  ( oprc.vx );
      c0.vy  =  ( oprc.vy );
      c0.vz +=  ( oprc.vz );

      cl.vx +=  ( oprc.vx );
      cl.vy  =  ( oprc.vy );
      cl.vz +=  ( oprc.vz );

      cr.vx +=  ( oprc.vx );
      cr.vy  =  ( oprc.vy );
      cr.vz +=  ( oprc.vz );

      cf.vx +=  ( oprc.vx );
      cf.vy  =  ( oprc.vy );
      cf.vz +=  ( oprc.vz );

      c  =  COL_test2( &cr, &cl );
      if(c>0)
         {
         c = 3*(2000-vqlen( cl.vx-COL_inter.vx, 0, cl.vz-COL_inter.vz ));
         //sprintf(debbuf,"cl");
         //RENDER_message(debbuf);
         pplyr->wvect.vy     +=  c;
         }

      c  =  COL_test2( &cl, &cr );
      if(c>0)
         {
         c = 3*(2000-vqlen( cr.vx-COL_inter.vx, 0, cr.vz-COL_inter.vz ));
         //sprintf(debbuf,"cr");
         //RENDER_message(debbuf);
         pplyr->wvect.vy     +=  -c;
         }

      c  =  COL_test2( &c0, &cf );
      if(c>0)
         {
         pplyr->mode360 =- 1;
         }
      }
///////////////////////////////////////////////////////////////////////////////////////////////

   // speed
   mov( v0, obj->v );
	v0.vx	=	v0.vx>>8;
	v0.vy	=	v0.vy>>8;
	v0.vz	=	v0.vz>>8;
	vsquare32( &v0, &v0 );
   pplyr->speed = speed =  vroot32( v0.vx + v0.vy + v0.vz );


//   if((speed<70)&&(pplyr->throttle<10))
//      {
//      obj->v.vx   =(obj->v.vx*220)>>8;
//      obj->v.vy   =(obj->v.vy*220)>>8;
//      obj->v.vz   =(obj->v.vz*220)>>8;
//      }
   //sub( obj->v, v0 );
	/////////////////


   dig=0;
   // shoulder dig
   if( (pplyr->SIM_input_data & PAD_FRT) ||
       ((pplyr->SIM_input_data & PAD_LR) && (pplyr->SIM_input_data & PAD_LD)) ||
       ((pplyr->SIM_input_an1x >40) && (pplyr->SIM_input_data&2)))
		{
      pplyr->wvect.vy     =  -7000;
      dig=1;
		}

   if( (pplyr->SIM_input_data & PAD_FLT) ||
       ((pplyr->SIM_input_data & PAD_LL) && (pplyr->SIM_input_data & PAD_LD)) ||
       ((pplyr->SIM_input_an1x <-40) && (pplyr->SIM_input_data&2)))
		{
      pplyr->wvect.vy     = 7000;
      dig=1;
		}

	///////////////
   totforce=0;

	// side force
	v0.vx	=	vside.vx>>8;//8
	v0.vy	=	0;
	v0.vz	=	vside.vz>>8;//8

	v1.vx	=  obj->v.vx;//0
	v1.vy	=  0;
	v1.vz	=  obj->v.vz;

   latvel   =  slip  =  vdot( &v0, &v1 ); //16

	grip	=	craft->grip;
   //if( pplyr->turbo )grip<<=3;
   grip  =  (grip* pplyr->stability)>>8;
   //if(dig)grip<<=1;
   if(pplyr->throttle>128)
      grip  =  (grip*(255-(pplyr->throttle-128)))>>8;

   if(grip<0)grip=0;

   pplyr->latgrip  =  abs(grip);
   pplyr->latslip  =  abs(slip);

   if( slip> grip )slip =   grip;
   if( slip<-grip )slip =  -grip;

   v0.vx *= slip;
   v0.vz *= slip;
	obj->v.vx	-=	v0.vx>>16;
	obj->v.vz	-=	v0.vz>>16;
   /////////////

///////////////////////////////////////////////////////////////////////////////////////////////
   // steer analogue
   if( pplyr->SIM_input_id==7 )
      {
      a = pplyr->SIM_input_an1x;

      if(pplyr->computer==0)  //dead zone for human
         if( a>-40 && a<40 )a=0;

      if(pplyr->mode360==2)
         {
         if(a>50)
            pplyr->crossx360+=20;
         if(a<-50)
            pplyr->crossx360-=20;
         }
      else
         {
         pplyr->wvect.vy  -= ( 255*a*100*craft->steerrate )>>15;
         }
      }
///////////////////////////////////////////////////////////////////////////////////////////////
   // steer digital
   else
      {
      if(pplyr->mode360==2)
         {
         if(pplyr->SIM_input_data & PAD_LR)
            pplyr->crossx360+=20;
         if(pplyr->SIM_input_data & PAD_LL)
            pplyr->crossx360-=20;
         }
      else
         {
         if( pplyr->SIM_input_data & PAD_LL )
            {
            pplyr->steerang  += pplyr->steervel;
            if( pplyr->steerang > 255 )pplyr->steerang =  255;
            }
         else
            if( pplyr->SIM_input_data & PAD_LR )
               {
               pplyr->steerang  -= pplyr->steervel;
               if( pplyr->steerang < -255 )pplyr->steerang   =  -255;
               }
            else
               { // no input
               if( pplyr->steerang > pplyr->steervel)
                  {
                  pplyr->steerang -= pplyr->steervel;
                  }
               else
                  if( pplyr->steerang < -pplyr->steervel)
                     {
                     pplyr->steerang += pplyr->steervel;
                     }
                  else
                     {
                     pplyr->steerang=0;
                     }
               }

         pplyr->wvect.vy  += (  pplyr->steerang*
                                       100*
                                       craft->steerrate*
                                       255/*pplyr->stability*/ )>>16;
         }
      }
	////////
///////////////////////////////////////////////////////////////////////////////////////////////
	// throttle
   if( pplyr->SIM_input_data & PAD_RD )
		{
      pplyr->throttle  += pplyr->throttlevel;
      if( pplyr->throttle > 255 )pplyr->throttle =  255;
      a  =  (10*pplyr->throttle)>>8;
      sp1_16[2].vy   += a;//  suspension tip
      sp1_16[3].vy   += a;
		}
	else
      if( pplyr->SIM_input_data & PAD_RL )
			{
         pplyr->throttle  -= pplyr->throttlevel;
         if( pplyr->throttle < -255 )pplyr->throttle   =  -255;
			}
		else
			{ // no input
         a  =  (10*pplyr->throttle)>>8;
         sp1_16[2].vy   += a;//  suspension tip
         sp1_16[3].vy   += a;

         if( pplyr->throttle > pplyr->throttlevel )
				{
            pplyr->throttle -= pplyr->throttlevel>>1;
				}
			else
            if( pplyr->throttle < -pplyr->throttlevel )
					{
               pplyr->throttle += pplyr->throttlevel;
					}
				else
					{
               pplyr->throttle=0;
					}
			}

   {// limit thrust
    // do lim only in app dir
   s32   lim;
   //s32   dot;
   //dot   =  (vforward.vx)*pobj->v.vx  *  (vforward.vz)*pobj->v.vz;
   //if(dot<0)dot=-dot;
   if(pplyr->turbo)
      pplyr->throttle=255;

   lim   =  128 - ((speed*craft->imax)>>8);
   //lim   =  9345/(speed+73);
   if(lim<0)lim=0;

            //FntPrint("forwards %d", speed);

   // only allow thrust if race has started and not finished
      {
      if(pplyr->throttle>=0)
         {
         if(pplyr->turbo)
            {
            lim   =  180 - ((speed*craft->imax)>>8);
            if(lim<0)lim=0;
            obj->v.vx += (((craft->thrust*(( vforward.vx * 255 )>>14))>>8)*lim)>>8;
            obj->v.vz += (((craft->thrust*(( vforward.vz * 255 )>>14))>>8)*lim)>>8;
            }
         else
            {
            obj->v.vx += (((craft->thrust*(( vforward.vx * pplyr->throttle )>>14))>>8)*lim)>>8;
            obj->v.vz += (((craft->thrust*(( vforward.vz * pplyr->throttle )>>14))>>8)*lim)>>8;
            }
         }
      //else
    // brakes
      if( pplyr->SIM_input_data & PAD_RL )
         {
         s32   spmod =  500;

         if( ((obj->v.vx>>8)*vforward.vx + (obj->v.vz>>8)*vforward.vz) >0  )
            {
            obj->v.vx += (-spmod*(600*( vforward.vx >>7))>>8)>>8;
            obj->v.vz += (-spmod*(600*( vforward.vz >>7))>>8)>>8;
            }
         else
            {
            //FntPrint("backwards");
            //obj->v.vx += (spmoDd*(600*( vforward.vx >>7)) >>8 ) >>8;
            //obj->v.vz += (spmod*(600*( vforward.vz >>7)) >>8 ) >>8;
            if(speed<100)
               {
               obj->v.vx += (-spmod*(600*( vforward.vx >>7))>>8)>>8;
               obj->v.vz += (-spmod*(600*( vforward.vz >>7))>>8)>>8;
               }
            }
         }
      }
   }

///////////////////////////////////////////////////////////////////////////////////////////////

	// stability control;
   if( pplyr->stability<256 )
		{
      pplyr->stability += 5;
      if( pplyr->stability>256 )
         pplyr->stability =  255;
		}

   equ( rollv, 0,0,0 );
   // adjust suspension points for roll
   if(latvel>1000)
      {
      //sp1_16[0].vy   -=  latvel>>17;

      }
   else
      if(latvel<1000)
         {
         //sp1_16[0].vy   -=  latvel>>17;
         }

	// springs,dampers
   equ( sp0_32[0], 0,-60,0 );
   equ( sp1_32[0], 0,120,0 );
   add( sp0_32[0], oprc );
   add( sp1_32[0], oprc );

   c  =  COL_test2( &sp0_32[0], &sp1_32[0] );
   if( c>=0 )
      {
      vec16 norm={0,-4096,0};
      vec32   imp, up;
      vec32 r, nv;
      s32   len;
      // reached here if on ground  ian
	  pplyr->collision_flag = TRUE;

      drag=sdrag[ COL_surftype ]<<2;
      //FntPrint( "%s\n" , COL_stypename[ COL_surftype ]);
      mov( norm, COL_norm );

      up.vx = up.vy = up.vz = 0;

      len   =((sp1_32[0].vy - COL_inter.vy)*400)>>8   ; // spring
      len   =  len   +  (((len-pplyr->leno[0])*500)>>8); //damp
      //if(len>100)len=100;
      pplyr->leno[0]   =  sp1_32[0].vy - COL_inter.vy;

      mov( r, oprc );
      sub( r, COL_inter );
      up.vy=-len;
      vcross( &up, &r, &imp );
      imp.vx   >>=   3;
      imp.vy   >>=   3;
      imp.vz   >>=   3;

      nv.vx =  norm.vx * (len<<4);
      nv.vy =  norm.vy * (len<<4);
      nv.vz =  norm.vz * (len<<4);

      nv.vx>>=14;
      nv.vy>>=14;
      nv.vz>>=14;

      obj->v.vx   += (nv.vx*gravmod[COL_surftype])>>6;
      obj->v.vy   += nv.vy<<2;
      obj->v.vz   += (nv.vz*gravmod[COL_surftype])>>6;

      pplyr->wvect.vx  += imp.vx<<2;
      pplyr->wvect.vy  += imp.vy<<2;
      pplyr->wvect.vz  += imp.vz<<2;
      }
	  else
		 pplyr->collision_flag = FALSE;

   //////////////////

   // surface drag
   mov( v0, obj->v );
   shr( v0, 8);
   v0.vx =  (drag*speed*v0.vx)>>8;
   v0.vy =  (drag*speed*v0.vy)>>8;
   v0.vz =  (drag*speed*v0.vz)>>8;
   sub(obj->v, v0);

	// grav
   obj->v.vy   +=1600;
	///////


	// clamp yvel
   //if( obj->v.vy < -5000 )obj->v.vy =  -5000;
	/////////////

	// clamp ypos via vel
	/*
	if( obj->p.vy < -245000 && obj->v.vy<0 )
		{
		obj->v.vy	-=	obj->v.vy>>1;
		obj->v.vx	-=	obj->v.vx>>3;
		obj->v.vz	-=	obj->v.vz>>3;

		if( obj->p.vy < -247000 )obj->v.vy	=0;
		}
	*/

   // only allow thrust if race has started and not finished, else brake
   if( (STATE.raceclock<0)  )/*|| pplyr->stats.lap>3) )*/
      {
      equ( obj->v, 0,0,0 );
      }

	// add vels
   add( obj->p, obj->v );
	///////////

	// upright
//   equ( v0, 0,-1,0);
//   v1.vx =  vup.vx>>6;
//   v1.vy =  vup.vy>>6;
//   v1.vz =  vup.vz>>6;

//   vcross( &v1, &v0, &v1 );//8
//   pplyr->wvect.vx  += v1.vx;
//   pplyr->wvect.vz  += v1.vz;
//   // upright

	// upright
   if(c>=0)
     mov( v0, COL_norm );
   else
     equ( v0, 0,-4096,0);

   v1.vx =  vup.vx>>6;
   v1.vy =  vup.vy>>6;
   v1.vz =  vup.vz>>6;

   vcross( &v1, &v0, &v1 );//8
   shr( v1, 12 );
   pplyr->wvect.vx  += v1.vx;
   pplyr->wvect.vz  += v1.vz;
   // upright


   // ang damp
   pplyr->wvect.vx  -= 255/*pplyr->stability*/*(pplyr->wvect.vx>>4)>>8;
   pplyr->wvect.vy  -= 255/*pplyr->stability*/*((craft->ywdamp*(pplyr->wvect.vy>>2))>>8)>>8;
   pplyr->wvect.vz  -= 255/*pplyr->stability*/*(pplyr->wvect.vz>>4)>>8;
	///////////

   // add w

   msetmatrotvect( &wmat, &pplyr->wvect );
   vmulmatrix2( &wmat, &pplyr->SIM_objmat );
	// remove compounded inaccuraccy in matrix
   vnormmat( &pplyr->SIM_objmat, (u8)(G_cyc+ob)&255 );

// christmas collision
   {
   s32   gamma;
   s32   cres;// coll result
   vec32 colp;// coll inter
   vec16 norm;// norm of collinter face
   vec32 cv0;
   vec32 cv1;
   u8    idx;
   s32   mingam;

   equ( cl[0], 0,    50,  0 );

      // test 4 coll vectors, store result
      cv0.vx =  (pplyr->oldp.vx >> 8)  +  cl[0].vx;
      cv0.vy =  (pplyr->oldp.vy >> 8)  +  cl[0].vy;
      cv0.vz =  (pplyr->oldp.vz >> 8)  +  cl[0].vz;

      cv1.vx =  (obj->p.vx >> 8)  +  cl[0].vx;
      cv1.vy =  (obj->p.vy >> 8)  +  cl[0].vy;
      cv1.vz =  (obj->p.vz >> 8)  +  cl[0].vz;

      cres  =  COL_test2( &cv0, &cv1 );
      if( cres>=0 )
         {
         // collided!

//		 pplyr->collision_flag = TRUE;

         colp.vx  =  COL_inter.vx;
         colp.vy  =  COL_inter.vy;
         colp.vz  =  COL_inter.vz;
         norm.vx  =  COL_norm.vx;
         norm.vy  =  COL_norm.vy;
         norm.vz  =  COL_norm.vz;
         gamma    =  COL_gamma16;
         }
//		 else
//			 pplyr->collision_flag = FALSE;

   // find idx of the first(nearest) collision
         idx=0;
         mingam   =  gamma;

   if( (cres>=0)  )
      {
	  s32 r;

      //move pos to hit point
      mov( v0, cv1 );
      sub( v0, cv0 );

      //gamma[idx]-=2000;
      //if(gamma[idx]<0)gamma[idx]=0;

      v0.vx =  (v0.vx*gamma)>>8;
      v0.vy =  (v0.vy*gamma)>>8;
      v0.vz =  (v0.vz*gamma)>>8;

      obj->p.vx   = pplyr->oldp.vx + v0.vx;
      obj->p.vy   = pplyr->oldp.vy + v0.vy;
      obj->p.vz   = pplyr->oldp.vz + v0.vz;

      // bounce
      r = SIM_reflectvel( &obj->v, &norm, 170 );

      obj->p.vx   += norm.vx>>2;
      obj->p.vy   += norm.vy>>2;
      obj->p.vz   += norm.vz>>2;

      // calc new pos
      mov(pplyr->oldp, obj->p );

      mov(v0,obj->v);
      gamma  =  65536 -  gamma;
      if(gamma<0)gamma=0;
      gamma>>=8;
      v0.vx =  (v0.vx*gamma)>>8;
      v0.vy =  (v0.vy*gamma)>>8;
      v0.vz =  (v0.vz*gamma)>>8;
      add( obj->p, v0 );
      }
// christmas collision^^

// easter collision
   if( (cres>=0) )
      {
         {
         // test 4 coll vectors, store result
         cv0.vx =  (pplyr->oldp.vx >> 8)  +  cl[0].vx;
         cv0.vy =  (pplyr->oldp.vy >> 8)  +  cl[0].vy;
         cv0.vz =  (pplyr->oldp.vz >> 8)  +  cl[0].vz;

         cv1.vx =  (obj->p.vx >> 8)  +  cl[0].vx;
         cv1.vy =  (obj->p.vy >> 8)  +  cl[0].vy;
         cv1.vz =  (obj->p.vz >> 8)  +  cl[0].vz;

         cres  =  COL_test2( &cv0, &cv1 );
         if( cres>=0 )
            {
            colp.vx  =  COL_inter.vx;
            colp.vy  =  COL_inter.vy;
            colp.vz  =  COL_inter.vz;
            norm.vx  =  COL_norm.vx;
            norm.vy  =  COL_norm.vy;
            norm.vz  =  COL_norm.vz;
            gamma    =  COL_gamma16;
            }
         }

         idx=0;
         mingam   =  gamma;
         }
      if( (cres>=0) )
         {
         //move pos to hit point
         mov( v0, cv1 );
         sub( v0, cv0 );

         //gamma[idx]-=2000;
         //if(gamma[idx]<0)gamma[idx]=0;

         v0.vx =  (v0.vx*gamma)>>8;
         v0.vy =  (v0.vy*gamma)>>8;
         v0.vz =  (v0.vz*gamma)>>8;

         obj->p.vx   = pplyr->oldp.vx + v0.vx;
         obj->p.vy   = pplyr->oldp.vy + v0.vy;
         obj->p.vz   = pplyr->oldp.vz + v0.vz;

         // bounce
         SIM_reflectvel( &obj->v, &norm, 170 );

         obj->p.vx   += norm.vx>>2;
         obj->p.vy   += norm.vy>>2;
         obj->p.vz   += norm.vz>>2;
         }
//    easter collision^^
      if(obj->v.vy<-10000)obj->v.vy=-10000;


   }

	// fall off world restart
   if( obj->p.vy > (4600<<8) )
		{
      SIM_startsim( ob );
      //sprintf(debbuf, "Player %d fell off world", plyr);
      //RENDER_message(debbuf);
      }

   a  =  vatan2( vforward.vx, vforward.vz )<<4;
   obj->r.vy  = a;
   if(pplyr->mode360 != -1)obj->r.vy += (2048<<4) + (pplyr->crossx360<<7);

   vrot32( &vup.vx, &vup.vz, -a );
   a  =  vatan2( vup.vx, -vup.vy )<<4;
   obj->r.vz  = a;

   a  =  vatan2( vup.vz, -vup.vy )<<4;
   obj->r.vx  = a;

   simtime  =  VSync(1) -  simtime;
   //FntPrint( "simtime %d\n", simtime );
   ansimaiend=999;

   }