#ifndef __WAKE_H
#define __WAKE_H

#define __DEBUG_WAKE	0

#define	NPLAYER			(STATE.wankers)
#define NPLAYERMAX      6
#define	NSWAKE			4

typedef struct
	{
	s32 vx;
	s32 vy;
	s32 vz;
	s32 surf;
    }colvec;

typedef struct SWAKE
	{
    colvec p[6];       	// 96
    VECTOR forward;          // 16
    VECTOR right;            // 16
    int cycle;              // 4
    struct SWAKE *prev;            // 4
	s32 height;			// 4
	
#if __DEBUG_WAKE
	vec32 test;//+4
#endif
	
    }SWAKE;					// Total: 140Bytes   (144 if debug)

void WAKE_init(void);
void WAKE_process(void);
void WAKE_draw(void);

void WAKE_decay(register SWAKE *);
void WAKE_sdraw(register SWAKE *);
void WAKE_create(int,register SWAKE *);

#if __DEBUG_WAKE
void WAKE_debugline(u8 r,u8 g,u8 b);
#endif

s32 WAKE_veclen(register VECTOR *);
void WAKE_ptri(colvec *v0,colvec *v1,colvec *v2);
void WAKE_pquad(colvec *v0,colvec *v1,colvec *v2,colvec *v3);

extern int globalWakeDisable;

#endif // __WAKE_H
