typedef struct
	{
	// Valid coords ?
	int valid[3];
	
	// Wake (world) coords for this bit
	vec32 coord[3];
	
	// Wake (screen) coords for this bit
	vec32 screen[3];

	// Brightness
	int br;
	}TRWAKE;

typedef struct
	{
	// - -- --- ---- Ship info ---- --- -- -
	// This instance initialised ?
	int inited;
	
	// Vector that has been rotated about ship rot matrix
	vec32 rotPoint[3];
	
	// Ship position
	vec32 shipPos[3];
	
	// Ship collision check vector
	vec32 shipCol[3];
	
	// Height each transformed point is above water
    int shipRideHeight[3];
	
	// Floor collision point.
	vec32 wakePos[3];
	
	// Surface type, 17 is water, 0 is no collision.
	int floorType[3];
	
	// - -- --- ---- Wake info ---- --- -- -
	// Trailing collision points
	TRWAKE trail[10];
	}PLWAKE;

void initWake(int);
void doWake(register int);
 
extern int globalWakeDisable; 
