#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <gtemac.h>
#include <inline_c.h>
#include <ctrller.h>
#include <libmath.h>
#include <stdio.h>

#include "version.h"
#include "frontend.h"
#include "rand.h"
#include "sdlib\sdfunc.h"
#include "header.h"
#include "render.h"
#include "frontend.h"
#include "psx\mathpsx.h"
#include "psx\gpuPSX.h"
#include "gameloop.h"
#include "objects.h"
#include "sim.h"
#include "mesh.h"
#include "camera.h"
#include "collide.h" 
#include "state.h"
#include "hue.h"
#include "psx\textPSX.h"
#include "water.h"

#define __DEBUG_WATERFALL	0

#define __BODGE_OUT_AWATER	1

/*
//#define fproc(x,y)
#define cproc(x)
//#define cproc2(x)
//#define cproc3(x)
*/

//#define fproc(x,y)
#define cproc(x)
#define cproc2(x)
#define cproc3(x)

#define FGTEST	0

#if FGTEST
void rgbTriTest(u32 *rgb0,u32 *rgb1,u32 *rgb2);
void rgbQuadTest(u32 *rgb0,u32 *rgb1,u32 *rgb2,u32 *rgb3);
#endif

typedef struct
	{
	u32 *primPtr;
	u16 nF3;	u16 nFD3;
	u16 nT3;	u16 nTD3;
	u16 nGF3;	u16 nGFD3;
	u16 nGT3;	u16 nGTD3;
	u16 nF4;	u16 nFD4;
	u16 nT4;	u16 nTD4;
	u16 nGF4;	u16 nGFD4;
	u16 nGT4;	u16 nGTD4;
	u32 *colPtr;
	u16 nTriCol;
	u16 nQuadCol;
	u16 nBentQuadCol;
	u16 pad;
	}OBJHDR;

int nWaterPolys;
u32 waterPolyType[MAXWATERPOLYS];
u32 *waterPoly[MAXWATERPOLYS];

#if !__BODGE_OUT_AWATER
int nAWaterPolys;
u32 awaterPolyType[MAXAWATERPOLYS];
u32 *awaterPoly[MAXAWATERPOLYS];
#endif

int nWaterCodes;
int nWaterUVs;
u16 waterPolyOrigUV[MAXWATERUV];
u16 *waterPolyUVptr[MAXWATERUV];
u16 *waterPolyCODEptr[MAXWATERCODES];

#ifndef fproc
void fproc(register u32 *,int);
#endif
#ifndef cproc
void cproc(register u32 *);
#endif
#ifndef cproc2
void cproc2(register u32 *);
#endif
#ifndef cproc3
void cproc3(register u16 *);
#endif

s16 wPhase = 0;

//                    w1 w2 w3 wa i1 i2 i3 ia s1 s2 s3 sa l1 l2 l3 la ja
s16 wPhaseLoop[17] = {31,47,31,63, 0, 0, 0, 0, 0, 0, 0,31,47,47,47, 0,63};
s16 wPhaseAdd[17] =  { 5,-7,-1,-5, 0, 0, 0, 0, 0, 0, 0,-5,-3,-3,-3, 0,-3};

/*
s16 wPhaseLoop[17] = {31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,31,47,47,47,47,63};
s16 wPhaseAdd[17] =  { 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-5,-3,-3,-3,-3,-3};
*/

void waterFallAnimate(void)
	{
	register u32 i;
    register u32 nUVs = nWaterUVs;
	register u16 uvOffset = wPhase << 8;

	for(i=0;i<nUVs;i++)
		*waterPolyUVptr[i] = waterPolyOrigUV[i] + uvOffset;

#if 0
	for(i=0;i<nUVs;i++)
		{
		register int v = ((waterPolyOrigUV[i]&0xff00)>>8) + (uvOffset>>8);
		if(v>255)
			{
			mprintf("Fucking dumbass\n");
			mprintf("waterPolyOrigUV[%ld] == %04X, uvOffset == %04X\n",i,waterPolyOrigUV[i],uvOffset);
//			while(1) pollhost();
			i = nUVs;
			}
		}
#endif
	
#if 1
    wPhase += wPhaseAdd[STATE.currlevel];
	if(wPhase>=wPhaseLoop[STATE.currlevel])
		wPhase -= wPhaseLoop[STATE.currlevel];
	if(wPhase<0)
		wPhase += wPhaseLoop[STATE.currlevel];
#endif
	}
	
void waterFallInit(void)
	{
	// Scan through MESH_track, build list of waterfall polys
	
	register u32 *obj = MESH_track;
	register u32 i;
	register u32 j;
	register u32 k;
	register u32 nObject;
	register OBJHDR *objHdr;
	
    u32 *vPtr;
    u32 *nPtr;
    u32 vNum;
    u32 nNum;

	wPhase = 0;

	nWaterPolys = 0;
#if !__BODGE_OUT_AWATER
	nAWaterPolys = 0;
#endif
	
	obj++;	// mapped flag
	nObject = *obj++;	// num objects
    vPtr = (u32 *)*obj++;       // vertexes ptr
	vNum = *obj++;		// num vertexes
    nPtr = (u32 *)*obj++;      // normals ptr
    nNum = *obj++;      // num normals
	
#if __DEBUG_WATERFALL >= 1
	mprintf("numObjects: %ld\n",nObject);
	mprintf("%ld vertices at %p\n",vNum,vPtr);
	mprintf("%ld normals at %p\n",nNum,nPtr);
#endif

	objHdr = (OBJHDR *)obj;

	for(i=0;i<nObject;i++,objHdr++)
		{
		/*register*/ u32 *colPtr;
	
#if __DEBUG_WATERFALL >= 2
		mprintf("Object %ld\n",i);
		mprintf("    primPtr : %p\n",objHdr->primPtr);
		mprintf("    colPtr : %p\n",objHdr->colPtr);
		mprintf("    nTriCol : %d\n",objHdr->nTriCol);
		mprintf("    nQuadCol : %d\n",objHdr->nQuadCol);
		mprintf("    nBentQuadCol : %d\n",objHdr->nBentQuadCol);
#endif

		colPtr = objHdr->colPtr;

		for(j=0;j<objHdr->nTriCol;j++)
			{
			register u32 colFace = *colPtr++;	// Face ptr, inc surf type
			
#if !__BODGE_OUT_AWATER
			if(STATE.numplayers==2)
			if((colFace>>24)==17)
				awaterPoly[nAWaterPolys++] = (u32 *)((colFace&0xffffff)|0x80000000);
#endif
			if((colFace>>24)==18)
				waterPoly[nWaterPolys++] = (u32 *)((colFace&0xffffff)|0x80000000);
			colPtr++;							// Normal ptr
			}

		for(j=0;j<objHdr->nQuadCol;j++)
			{
			register u32 colFace = *colPtr++;	// Face ptr, inc surf type
			
#if !__BODGE_OUT_AWATER
			if(STATE.numplayers==2)
			if((colFace>>24)==17)
				awaterPoly[nAWaterPolys++] = (u32 *)((colFace&0xffffff)|0x80000000);
#endif
			if((colFace>>24)==18)
				waterPoly[nWaterPolys++] = (u32 *)((colFace&0xffffff)|0x80000000);
			colPtr++;							// Normal ptr
			}

		for(j=0;j<objHdr->nBentQuadCol;j++)
			{
			register u32 colFace = *colPtr++;	// Face ptr, inc surf type
			
#if !__BODGE_OUT_AWATER
			if(STATE.numplayers==2)
			if((colFace>>24)==17)
				awaterPoly[nAWaterPolys++] = (u32 *)((colFace&0xffffff)|0x80000000);
#endif
			if((colFace>>24)==18)
				waterPoly[nWaterPolys++] = (u32 *)((colFace&0xffffff)|0x80000000);
			colPtr++;							// Normal ptr
			colPtr++;							// Normal ptr
			}			
		}

#if __DEBUG_WATERFALL >= 1
    mprintf("Number of waterfall polys : %d\n",nWaterPolys);
#if !__BODGE_OUT_AWATER
    mprintf("Number of awaterfall polys : %d\n",nAWaterPolys);
#endif
//	for(i=0;i<nWaterPolys;i++)
//		mprintf("     %lu - %p\n",i,waterPoly[i]);
#endif

	// Remove any duplicated entries (overlapping collision check)
	// [*] This piece of code has never been checked.
	for(i=0;i<nWaterPolys;i++)
		for(j=i;j<nWaterPolys;j++)
			if(i!=j)
				if(waterPoly[i]==waterPoly[j])
					{
					nWaterPolys--;
					for(k=j;k<nWaterPolys;k++)
						waterPoly[k] = waterPoly[k+1];
					}

#if !__BODGE_OUT_AWATER
//	mprintf("nAWaterPolys (0) = %d\n",nAWaterPolys);

	for(i=0;i<nAWaterPolys;i++)
		for(j=i;j<nAWaterPolys;j++)
			if(i!=j)
				if(awaterPoly[i]==awaterPoly[j])
					{
					nAWaterPolys--;
					for(k=j;k<nAWaterPolys;k++)
						awaterPoly[k] = awaterPoly[k+1];
					}

//	mprintf("nAWaterPolys (1) = %d\n",nAWaterPolys);
#endif


#if __DEBUG_WATERFALL >= 1
    mprintf("Number of waterfall polys : %d (post duplicate check)\n",nWaterPolys);
#if !__BODGE_OUT_AWATER
    mprintf("Number of awaterfall polys : %d (post duplicate check)\n",nAWaterPolys);
#endif
//	for(i=0;i<nWaterPolys;i++)
//		mprintf("     %lu - %p\n",i,waterPoly[i]);
#endif
	
	// Cross reference collision with poly lists, need to find what
	// type of poly they are.

	objHdr = (OBJHDR *)obj;

	for(i=0;i<nObject;i++,objHdr++)
		{
		register u32 *primPtr;
	
#if __DEBUG_WATERFALL >= 2
		mprintf("(2) Object %ld\n",i);
		mprintf("    primPtr : %p\n",objHdr->primPtr);
		mprintf("    colPtr : %p\n",objHdr->colPtr);
		mprintf("    nTriCol : %d\n",objHdr->nTriCol);
		mprintf("    nQuadCol : %d\n",objHdr->nQuadCol);
		mprintf("    nBentQuadCol : %d\n",objHdr->nBentQuadCol);
#endif

        primPtr = objHdr->primPtr;
        for(j=0;j<(objHdr->nF3+objHdr->nFD3);j++,primPtr+=3)
			fproc(primPtr,0);
        for(j=0;j<(objHdr->nT3+objHdr->nTD3);j++,primPtr+=6)
			fproc(primPtr,1);
        for(j=0;j<(objHdr->nGF3+objHdr->nGFD3);j++,primPtr+=5)
			fproc(primPtr,2);
        for(j=0;j<(objHdr->nGT3+objHdr->nGTD3);j++,primPtr+=8)
			fproc(primPtr,3);
        for(j=0;j<(objHdr->nF4+objHdr->nFD4);j++,primPtr+=4)
			fproc(primPtr,4);
        for(j=0;j<(objHdr->nT4+objHdr->nTD4);j++,primPtr+=7)
			fproc(primPtr,5);
        for(j=0;j<(objHdr->nGF4+objHdr->nGFD4);j++,primPtr+=7)
			fproc(primPtr,6);
        for(j=0;j<(objHdr->nGT4+objHdr->nGTD4);j++,primPtr+=10)
			fproc(primPtr,7);
		}
	
#if __DEBUG_WATERFALL >= 1
//	mprintf("Cross referenced polys : %d\n",test);
//	if(test!=nWaterPolys)
//		{
//		mprintf("Cross reference failed to function properly.\n");
//		mprintf("Model file is possibly fucked up.\n");
//		}

    mprintf("Number of waterfall polys : %d (post duplicate check)\n",nWaterPolys);
//	for(i=0;i<nWaterPolys;i++)
//		mprintf("     %lu - %p   (Type = %lu)\n",i,waterPoly[i],waterPolyType[i]);
#endif


	// only types 3 + 7  (GT3 + GT4) used

	nWaterUVs = 0;
	nWaterCodes = 0;
	
	for(i=0;i<nWaterPolys;i++)
		{
		register u16 *polyPtr = (u16 *)waterPoly[i];
		
		switch(waterPolyType[i])
			{
			case 1:	// T3
			case 3:	// GT3
				waterPolyCODEptr[nWaterCodes++] = &polyPtr[11];
				waterPolyUVptr[nWaterUVs++] = &polyPtr[4];
				waterPolyUVptr[nWaterUVs++] = &polyPtr[6];
				waterPolyUVptr[nWaterUVs++] = &polyPtr[8];
				break;
				
			case 5:	// T4
			case 7:	// GT4
				waterPolyCODEptr[nWaterCodes++] = &polyPtr[13];
				waterPolyUVptr[nWaterUVs++] = &polyPtr[4];
				waterPolyUVptr[nWaterUVs++] = &polyPtr[6];
				waterPolyUVptr[nWaterUVs++] = &polyPtr[8];
				waterPolyUVptr[nWaterUVs++] = &polyPtr[10];
				break;
				
			default:
#if __DEBUG_WATERFALL >= 1
//              mprintf("!! -------------------------------- !!\n");
                mprintf("!! New waterfall surface type used. !!\n");
//              mprintf("!! -------------------------------- !!\n");
#endif
				break;
			}
		}

#if __DEBUG_WATERFALL >= 1
    mprintf("%d water uvs\n",nWaterUVs);
#endif

	for(i=0;i<nWaterUVs;i++)
		waterPolyOrigUV[i] = *waterPolyUVptr[i];

	// Hacked to shit
	// restore semi flag for water fall surfaces !!!
//	for(i=0;i<nWaterCodes;i++)
//		(*waterPolyCODEptr[i]) |= 0x0200;

#if !__BODGE_OUT_AWATER
	// Fucking mother fucker

	for(i=0;i<nAWaterPolys;i++)
		{
		register u16 *polyPtr = (u16 *)awaterPoly[i];
		
		switch(awaterPolyType[i])
			{
			case 1:	// T3
				polyPtr[3] &= ~0x0400;
// 				polyPtr[3] |= 0x0400;
				polyPtr[11] &= ~0x0200;
//				mprintf("T3 ");
				break;
			case 5:	// T4
				polyPtr[9] &= ~0x0400;
//				polyPtr[9] |= 0x0400;
				polyPtr[13] &= ~0x0200;
//				mprintf("T4 ");
				break;
			case 3:	// GT3
				polyPtr[3] &= ~0x0400;
//				polyPtr[3] |= 0x0400;
				polyPtr[11] &= ~0x0200;
//				mprintf("GT3 ");
				break;
			case 7:	// GT4
				polyPtr[9] &= ~0x0400;
//				polyPtr[9] |= 0x0400;
				polyPtr[13] &= ~0x0200;
//				mprintf("GT4 ");
				break;
				
			default:
//#if __DEBUG_WATERFALL >= 1
//                mprintf("!! ---------------------------- !!\n");
                  mprintf("!! New water surface type used. !!   %ld\n",awaterPolyType[i]);
//                mprintf("!! ---------------------------- !!\n");
//#endif
				break;
			}
		}
#endif
	
/*
	{
	int x = 952;
	int y = 64;
	RECT rct = {950,0,8,32};
    MoveImage(&rct,x,y);
	}
*/

	mprintf("------------------------------\n");
    mprintf("nWaterPolys == %d\n",nWaterPolys);
#if !__BODGE_OUT_AWATER
    mprintf("nAWaterPolys == %d\n",nAWaterPolys);
#endif
    mprintf("nWaterCodes == %d\n",nWaterCodes);
    mprintf("nWaterUVs == %d\n",nWaterUVs);
	mprintf("------------------------------\n");
	}

typedef struct
	{
	u8 r;
	u8 g;
	u8 b;
	u8 code;
	}rgbp;

#ifndef cproc2

void cproc2(register u32 *rgb)
{
register rgbp *p = (rgbp *)rgb;
p->code &= ~0x02;
}

#endif

#ifndef cproc3

void cproc3(register u16 *info)
{
// (*info) |= 0x0400;
(*info) &= ~0x0400;
}

#endif

#ifndef cproc

void cproc(register u32 *rgb)
{
register rgbp *col = (rgbp *)rgb;

static u8 cols[8] [3] =
	{
	{255,0,0},
	{0,255,0},
	{0,0,255},
	{255,255,0},
	{0,255,255},
	{255,0,255},
	{255,255,255},
	{0,0,0}
	};

static u8 ph = 0;

//col->r >>= 2;
//col->g >>= 0;
//col->b >>= 2;

//col->r = 255 - col->r;
//col->g = 255 - col->g;
//col->b = 255 - col->b;

col->r = cols[ph] [0];
col->g = cols[ph] [1];
col->b = cols[ph] [2];

ph++;
if(ph>7)
	ph = 0;
}

#endif

#ifndef fproc

void fproc(register u32 *p,int t)
{
register int k;

for(k=0;k<nWaterPolys;k++)
if(p==waterPoly[k])
    waterPolyType[k] = t;

#if !__BODGE_OUT_AWATER
for(k=0;k<nAWaterPolys;k++)
if(p==awaterPoly[k])
    awaterPolyType[k] = t;
#endif

/*
if(STATE.numplayers!=2)
	return;

switch(t)
	{
	case 0://F3
		cproc(p+2);
		cproc2(p+2);
		cproc3(&((u16 *)p)[3]);
		break;
	case 1://T3
		cproc(p+5);
		cproc2(p+5);
		cproc3(&((u16 *)p)[3]);
		break;
	case 2://GF3
		cproc(p+2);
		cproc(p+3);
		cproc(p+4);
		cproc2(p+2);
		cproc3(&((u16 *)p)[3]);
		break;
	case 3://GT3
		cproc(p+5);
		cproc(p+6);
		cproc(p+7);
		cproc2(p+5);
		cproc3(&((u16 *)p)[3]);
		break;
	case 4://F4
		cproc(p+2);
		cproc2(p+2);
		cproc3(&((u16 *)p)[6]);
		break;
	case 5://T4
		cproc(p+6);
		cproc2(p+6);
		cproc3(&((u16 *)p)[9]);
		break;
	case 6://GF4
        cproc(p+2);
        cproc(p+3);
        cproc(p+4);
        cproc(p+5);
		cproc2(p+2);
		cproc3(&((u16 *)p)[12]);
		break;
	case 7://GT4
        cproc(p+6);
        cproc(p+7);
        cproc(p+8);
        cproc(p+9);
		cproc2(p+6);
		cproc3(&((u16 *)p)[9]);
		break;
	
	default:
		break;
	}
*/

#if FGTEST
switch(t)
	{
	case 2://GF3
		rgbTriTest(p+2,p+3,p+4);
		break;
	case 3://GT3
		rgbTriTest(p+5,p+6,p+7);
		break;
	case 6://GF4
		rgbQuadTest(p+2,p+3,p+4,p+5);
		break;
	case 7://GT4
		rgbQuadTest(p+6,p+7,p+8,p+9);
		break;
	
	default:
		break;
	}
#endif
}
#endif

#if FGTEST
int nTriQ = 0;
int nQuadQ = 0;

void rgbTriTest(u32 *rgb0,u32 *rgb1,u32 *rgb2)
{
register rgbp *c0 = (rgbp *)rgb0;
register rgbp *c1 = (rgbp *)rgb1;
register rgbp *c2 = (rgbp *)rgb2;

int same = 1;

if(c0->r!=c1->r)	same = 0;
if(c0->r!=c2->r)	same = 0;
if(c1->r!=c2->r)	same = 0;

if(c0->g!=c1->g)	same = 0;
if(c0->g!=c2->g)	same = 0;
if(c1->g!=c2->g)	same = 0;

if(c0->b!=c1->b)	same = 0;
if(c0->b!=c2->b)	same = 0;
if(c1->b!=c2->b)	same = 0;

if(same)
	nTriQ++;
}

void rgbQuadTest(u32 *rgb0,u32 *rgb1,u32 *rgb2,u32 *rgb3)
{
register rgbp *c0 = (rgbp *)rgb0;
register rgbp *c1 = (rgbp *)rgb1;
register rgbp *c2 = (rgbp *)rgb2;
register rgbp *c3 = (rgbp *)rgb3;

int same = 1;

if(c0->r!=c1->r)	same = 0;
if(c0->r!=c2->r)	same = 0;
if(c0->r!=c3->r)	same = 0;
if(c1->r!=c2->r)	same = 0;
if(c1->r!=c3->r)	same = 0;
if(c2->r!=c3->r)	same = 0;

if(c0->g!=c1->g)	same = 0;
if(c0->g!=c2->g)	same = 0;
if(c0->g!=c3->g)	same = 0;
if(c1->g!=c2->g)	same = 0;
if(c1->g!=c3->g)	same = 0;
if(c2->g!=c3->g)	same = 0;

if(c0->b!=c1->b)	same = 0;
if(c0->b!=c2->b)	same = 0;
if(c0->b!=c3->b)	same = 0;
if(c1->b!=c2->b)	same = 0;
if(c1->b!=c3->b)	same = 0;
if(c2->b!=c3->b)	same = 0;

if(same)
	nQuadQ++;
}
#endif
