#include "header.h"
#include "frontend.h"
#include "fade.h"
#include "render.h"
#include "camera.h"
#include "objects.h"
#include "collide.h"
#include <libsn.h>
#include "sdlib\sdtypes.h"
#include "sdlib\sdfunc.h"
#include "ctrller.h"
#include "gameloop.h"
#include "state.h"
#include "psx\psx_pcks.h"
#include "psx\psx_expn.h"
#include "ai.h"
#include "psx\textpsx.h"
#include "hue.h"
#include "menu.h"
#include "memcard.h"
#include "keys.h"
#include "loadit.h"
#include "savedata.h"
#include <libmcrd.h>
#include <stdio.h>
#include <libapi.h>
#include <libpad.h>
#include "psx\loadpsx.h"
#include "psx\soundpsx.h"
#include "psx\textpsx.h"
#include "action.h"
#include <libcd.h>
#include "cdlib.h"
#include "screens.h"
#include "score.h"
#include "text.h"

int ssssss = 7;

#define __DEBUG_SCORE		1

extern GsSPRITE sprite;

HISCORE_S hiScore[MPLAYER];
int gameFrags;
int finishPlace[6];
int finishIndex;

void charLine(int i,int off,int idx,int db);

/*
int pStatLevel;
int pStatWorld;

int place;

int chx,chy;
int hsIndex;
char hsName[4];
int nHScore;
int spIndex;

char hsTable[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 !#%&'()*,-./:;<=>?abcde"; // "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!\"$%^&*()-=_+[]#@<>,.?~";

void gridBox2(int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,char *);
*/

extern int maxd0;
extern int maxd1;
extern int maxd2;

extern GsOT *MWotPtr;

typedef struct
	{
	char *text;
	int type;	// 0=lap time, 1=race time (level), 2=race time (arena)
	int hiNum;
	HISCORE_S *hi;
	}hsparam;

hsparam hScoreParam[4];

// POON.C
extern s32 position[8];

#if __DEBUG_SCORE >= 2
void dumpHighScore(void);
#endif

void SCORE_reset(void)
	{
	register int i;
	for(i=0;i<MPLAYER;i++)
		{		
        hiScore[i].lapTimePoint[0] = -1;
        hiScore[i].lapTimePoint[1] = -1;
        hiScore[i].lapTimePoint[2] = -1;
        hiScore[i].lapTime[0] = -1;
        hiScore[i].lapTime[1] = -1;
        hiScore[i].lapTime[2] = -1;
        hiScore[i].fastestLap = -1;
        hiScore[i].frag10time = -1;
        hiScore[i].raceTime = -1;
        hiScore[i].finished = 0;
        hiScore[i].active = (i<STATE.wankers)?1:0;
		hiScore[i].frags = 0;
		hiScore[i].needFinish = hiScore[i].active?(~OBJ_players[i].computer&0x01):0;
		hiScore[i].position = -1;

		#if __DEBUG_SCORE
		mprintf("SCORE_reset(), player %d, active == %ld\n",i,hiScore[i].active);
		#endif
        }

	finishIndex = 0;
	
    gameFrags = (LROpt[0]==3)?(10):((LROpt[0]==4)?(25):(50));
//	gameFrags = 2;
	#if __DEBUG_SCORE
	if((STATE.mcurrlevel&0x03)==3)
		mprintf("Frags for this arena == %d\n",gameFrags);
	#endif

	// Shouldnt be here, what the hell
    maxd0 = 0;
    maxd1 = 0;
    maxd2 = 0;
    }

void SCORE_lapcomplete(u8 player,u8 lap,u32 time)
	{
    // Lap = 2 when lap 1 complete
	
	if(*DemoMode)
		return;
	
//	if(STATE.finishedLevel)
//		return;
    
	// Should not even be called in arenas, but...
	if((STATE.mcurrlevel&0x03)==3)
		return;
	
	// Should never happen
	if(!hiScore[player].active)
		{
		#if __DEBUG_SCORE
		mprintf("SCORE_lapcomplete, player==%d, !active",player);
		#endif
		return;
		}

	if(hiScore[player].finished)
		return;

	#if __DEBUG_SCORE
	mprintf("SCORE_lapcomplete(player==%d,lap==%d,time==%lu)\n",player,lap,time);
	#endif
	
	// No need for laps in arenas
	if((STATE.mcurrlevel&0x03)==3)
		return;
	
	if(lap==4)
		{
		hiScore[player].finished = 1;
		if(hiScore[player].lapTimePoint[lap-2]==-1)
			hiScore[player].lapTimePoint[lap-2] = (s32)time;

		// End of race for this player
		if(hiScore[player].raceTime==-1)
			{
			#if __DEBUG_SCORE
			mprintf("End of race P%d Time=%ld\n",player,time);
			#endif
			
            hiScore[player].raceTime = SCORE_frame2bcd(time);
            hiScore[player].lapTime[2] = SCORE_frame2bcd(time-hiScore[player].lapTimePoint[1]);
			if(hiScore[player].fastestLap==-1)
				hiScore[player].fastestLap = 2;
			else
				if(hiScore[player].lapTime[2]<hiScore[player].lapTime[hiScore[player].fastestLap])
					hiScore[player].fastestLap = 2;
			}
		
		// Set this player to AI (half speed cruise mode)
		OBJ_players[player].computer |= 0x02;

		// Record finishing position
		hiScore[player].position = finishIndex;
		
		finishPlace[finishIndex++] = player;
		
		SCORE_checkComplete();
		}
	else{
		if(hiScore[player].lapTimePoint[lap-2]==-1)
			{
			hiScore[player].lapTimePoint[lap-2] = (s32)time;
			if(lap==2)
				{
				#if __DEBUG_SCORE
				mprintf("End of first lap P%d\n",player);
				#endif
				hiScore[player].lapTime[0] = SCORE_frame2bcd(time);
				if(hiScore[player].fastestLap==-1)
					hiScore[player].fastestLap = 0;
				else
					if(hiScore[player].lapTime[0]<hiScore[player].lapTime[hiScore[player].fastestLap])
						hiScore[player].fastestLap = 0;
				}
			else{
				#if __DEBUG_SCORE
				mprintf("End of lap %d P%d\n",lap-2,player);
				#endif
				
				hiScore[player].lapTime[lap-2] =
					SCORE_frame2bcd(hiScore[player].lapTimePoint[lap-2]-
									hiScore[player].lapTimePoint[lap-3]);
				if(hiScore[player].fastestLap==-1)
					hiScore[player].fastestLap = lap-2;
				else
					if(hiScore[player].lapTime[lap-2]<hiScore[player].lapTime[hiScore[player].fastestLap])
						hiScore[player].fastestLap = lap-2;
				}
			}
		}
	}

void SCORE_frag(u8 player,u32 time)
	{
	if(*DemoMode)
		return;
		
	// Should never happen
	if(!hiScore[player].active)
		{
		#if __DEBUG_SCORE
		mprintf("SCORE_frag, player==%d, !active",player);
		#endif
		return;
		}

	// No need for frags on tracks	
	if((STATE.mcurrlevel&0x03)!=3)
		{
		#if __DEBUG_SCORE
		mprintf("SCORE_frag(player=%d,time=%lu)  (not needed in track)\n",player,time);
		#endif
		return;
		}

	#if __DEBUG_SCORE
	mprintf("SCORE_frag(player==%d,time==%lu)  (nFrags==%ld)\n",player,time,hiScore[player].frags);
	#endif
	
	hiScore[player].frags++;
	if(hiScore[player].frags==10)
        hiScore[player].frag10time = SCORE_frame2bcd(time);
    
	if(!hiScore[player].finished)
    if(hiScore[player].frags==gameFrags)
		{
		// Set this player to AI (half speed cruise mode)
		OBJ_players[player].computer |= 0x02;

		// Record finishing position
		hiScore[player].position = finishIndex;
		finishPlace[finishIndex++] = player;

        hiScore[player].raceTime = SCORE_frame2bcd(time);
        hiScore[player].finished = 1;
		
		SCORE_checkComplete();
		}
    }

void SCORE_checkComplete(void)
	{
	register int i;
	register int complete = 1;

	for(i=0;i<MPLAYER;i++)
		if(hiScore[i].active)
			if(hiScore[i].needFinish)
				if(!hiScore[i].finished)
					complete = 0;
	
	if(complete)
		{
		// Temp thingy
		
		mprintf("SCORE_checkComplete()\n");
		mprintf("Everybody who needs to has finished. (finishIndex==%d)\n",finishIndex);
		
//		arStart();
		
		SCORE_startmenu();
		}
	}

s32 SCORE_frame2bcd(s32 frame)
	{
	s32 bcd;
	s32 t_hun,t_ten,t_sec,t_10sec,t_min,t_10min;
	register s32 d;
	
	d = frame*4;
	t_10min = d / 60000; //(10*60*100);
    d -= t_10min*60000;
	t_min = d / 6000; //(60*100);
	d -= t_min*6000;
	t_10sec = d / 1000; //(10*100);
    d -= t_10sec*1000;
	t_sec = d / (100);
    d -= t_sec*100;
	t_ten = d / (10);
    d -= t_ten*10;
    t_hun = d;
	
	bcd = (t_10min<<20) + 
		  (t_min<<16) + 
		  (t_10sec<<12) + 
		  (t_sec<<8) + 
		  (t_ten<<4) + 
		  (t_hun);

//	mprintf("%ld -> %lX\n",frame,bcd);
	
	return bcd;
	}

void SCORE_startmenu(void)
	{
	register int i;
	
	if(STATE.finishedLevel)
		return;
	
    STATE.finishedLevel = 1;

	for(i=0;i<STATE.wankers;i++)
		OBJ_players[i].computer |= 0x02;

	menuState = MN_Start;
	GAMELOOP_state = GLgame;

	for(i=0;i<MPLAYER;i++)
		{
		if(!hiScore[i].active)
			continue;
		
		if(hiScore[i].finished)
			continue;
			
		hiScore[i].position = position[i];
		}

	SCORE_initnames();
	}

void SCORE_menu(void)
	{
	#if __DEBUG_SCORE
	register int i;
	static int printedScore = 0;
	if(!printedScore)
        {
		for(i=0;i<MPLAYER;i++)
			{
			if(!hiScore[i].active)
				continue;
			
			mprintf("Player %d\n",i);
			
			mprintf("\tLap times (point) %ld %ld %ld\n",
				hiScore[i].lapTimePoint[0],
				hiScore[i].lapTimePoint[1],
				hiScore[i].lapTimePoint[2]);
			mprintf("\tLap times (bcd) %lX %lX %lX, fastest==%ld (%lX)\n",
				hiScore[i].lapTime[0],
				hiScore[i].lapTime[1],
				hiScore[i].lapTime[2],
				hiScore[i].fastestLap,
				hiScore[i].lapTime[hiScore[i].fastestLap]);
			mprintf("\tTotal race time %lX\n",
				hiScore[i].raceTime);
			mprintf("\tfinished==%ld, active==%ld, needFinish==%ld.\n",
				hiScore[i].finished,
				hiScore[i].active,
				hiScore[i].needFinish);
			mprintf("\n");
			}
		printedScore = 1;
		}
	#endif // __DEBUG_SCORE

	if((STATE.mcurrlevel&0x03)==3)
		SCORE_drawArenaScore();
	else
		SCORE_drawTrackScore();
		
	if((frCount==20*25)||((SD_PadData[0].push&K_MENU_PROGRESS)&&(frCount>=5*25)))
		SCORE_calcnames();
	
	frCount++;
	
//	mprintf("*");
	}

char *txtMenuPlayerName[3] =
	{
	"Player 1",
	"Player 2",
	"CPU"
	};

char txtMenuPlayerFrags[6] [4] =
	{
	"xxx",	"xxx",
	"xxx",	"xxx",
	"xxx",	"xxx"
	};

char txtMenuPlayerTimes[6] [9] =
	{
	"xx:xx:xx",	"xx:xx:xx",
	"xx:xx:xx",	"xx:xx:xx",
	"xx:xx:xx",	"xx:xx:xx"
	};

char txtMenuPlayerFTimes[6] [9] =
	{
    "xx:xx:xx", "xx:xx:xx",
	"xx:xx:xx",	"xx:xx:xx",
	"xx:xx:xx",	"xx:xx:xx"
	};

TXT txtStatsTrack[] =
	{
    {-180,-36,NULL}, // player name
    {-180,-24,NULL},
    {-180,-12,NULL},
    {-180,  0,NULL},
    {-180, 12,NULL},
    {-180, 24,NULL},

    {-55,-36,NULL}, // race time
    {-55,-24,NULL},
    {-55,-12,NULL},
    {-55,  0,NULL},
    {-55, 12,NULL},
    {-55, 24,NULL},

    { 75,-36,NULL}, // fastest lap
    { 75,-24,NULL},
    { 75,-12,NULL},
    { 75,  0,NULL},
    { 75, 12,NULL},
    { 75, 24,NULL},
    
	{-55,-60,"Race Time"},
	{ 75,-60,"Fastest Lap"},
	
	{0,0,NULL}
    };

TXT txtStatsArena[] =
	{
    {-180,-36,NULL}, // player name
    {-180,-24,NULL},
    {-180,-12,NULL},
    {-180,  0,NULL},
    {-180, 12,NULL},
    {-180, 24,NULL},

    {-55,-36,NULL}, // num frags
    {-55,-24,NULL},
    {-55,-12,NULL},
    {-55,  0,NULL},
    {-55, 12,NULL},
    {-55, 24,NULL},

    { 75,-36,NULL}, // 10 frag time
    { 75,-24,NULL},
    { 75,-12,NULL},
    { 75,  0,NULL},
    { 75, 12,NULL},
    { 75, 24,NULL},
    
	{-55,-60,"Frags"},
    { 75,-60,"10 Frags time"},
	
	{0,0,NULL}
    };

void SCORE_drawArenaScore(void)
	{	
	/*register*/ int i;
	/*register*/ int j;
	int k;
	int m;
		
	for(k=0;k<finishIndex;k++)
		{
		i = finishPlace[k];
		
        txtStatsArena[k].t =
			txtMenuPlayerName[(((OBJ_players[i].computer&0x01))?(2):(i))];
		
        j = hiScore[i].frags;
        txtStatsArena[k+6].t = txtMenuPlayerFrags[k];
        
		m = j/100;
		txtMenuPlayerFrags[k] [0] = m+'0';
		j -= m*100;
		m = j/10;
		txtMenuPlayerFrags[k] [1] = m+'0';
		j -= m*10;
		txtMenuPlayerFrags[k] [2] = j+'0';
		if(txtMenuPlayerFrags[k] [0]=='0')
			{
			txtMenuPlayerFrags[k] [0] = ' ';
			if(txtMenuPlayerFrags[k] [1]=='0')
				txtMenuPlayerFrags[k] [1] = ' ';
			}

        j = hiScore[i].frag10time;
		if(j==-1)
            txtStatsArena[k+12].t = "--:--.--";
        else
            txtStatsArena[k+12].t = txtMenuPlayerFTimes[k];

        txtMenuPlayerFTimes[k] [0] = ((j>>20)&0x0f)+'0';
        txtMenuPlayerFTimes[k] [1] = ((j>>16)&0x0f)+'0';
        txtMenuPlayerFTimes[k] [3] = ((j>>12)&0x0f)+'0';
        txtMenuPlayerFTimes[k] [4] = ((j>>8)&0x0f)+'0';
        txtMenuPlayerFTimes[k] [6] = ((j>>4)&0x0f)+'0';
		txtMenuPlayerFTimes[k] [7] = (j&0x0f)+'0';
        }

	for(;k<STATE.wankers;k++)
		{
        txtStatsArena[k].t = txtMenuPlayerName[2];
        txtStatsArena[k+6].t = "--";
        txtStatsArena[k+12].t = "--:--.--";
        }
	
    for(i=0;txtStatsArena[i].t!=NULL;i++)
        {
        TEXT_x = txtStatsArena[i].x;
        TEXT_y = txtStatsArena[i].y;
        M_TEXT_prstr(txtStatsArena[i].t,255,255,255);
        }

	semiBox(420,160);
	setSemiHW(0);
	}

void SCORE_drawTrackScore(void)
	{
	/*register*/ int i;
	/*register*/ int j;
	int k;
		
	for(k=0;k<finishIndex;k++)
		{
		i = finishPlace[k];
		
		/*
		if(!hiScore[i].active)
			{
            txtStatsTrack[k].t =
			txtStatsTrack[k+6].t =
			txtStatsTrack[k+12].t = "";
			continue;
			}
		*/
		
        txtStatsTrack[k].t =
			txtMenuPlayerName[(((OBJ_players[i].computer&0x01))?(2):(i))];
		
        j = hiScore[i].raceTime;
		if(j==-1)
            txtStatsTrack[k+6].t = "--:--.--";
        else
            txtStatsTrack[k+6].t = txtMenuPlayerTimes[k];
        
        txtMenuPlayerTimes[k] [0] = ((j>>20)&0x0f)+'0';
        txtMenuPlayerTimes[k] [1] = ((j>>16)&0x0f)+'0';
        txtMenuPlayerTimes[k] [3] = ((j>>12)&0x0f)+'0';
        txtMenuPlayerTimes[k] [4] = ((j>>8)&0x0f)+'0';
        txtMenuPlayerTimes[k] [6] = ((j>>4)&0x0f)+'0';
		txtMenuPlayerTimes[k] [7] = (j&0x0f)+'0';

        j = hiScore[i].fastestLap;
		if(j==-1)
            txtStatsTrack[k+12].t = "--:--.--";
        else
            txtStatsTrack[k+12].t = txtMenuPlayerFTimes[k];

		j = hiScore[i].lapTime[j];

        txtMenuPlayerFTimes[k] [0] = ((j>>20)&0x0f)+'0';
        txtMenuPlayerFTimes[k] [1] = ((j>>16)&0x0f)+'0';
        txtMenuPlayerFTimes[k] [3] = ((j>>12)&0x0f)+'0';
        txtMenuPlayerFTimes[k] [4] = ((j>>8)&0x0f)+'0';
        txtMenuPlayerFTimes[k] [6] = ((j>>4)&0x0f)+'0';
		txtMenuPlayerFTimes[k] [7] = (j&0x0f)+'0';
        }

	for(;k<STATE.wankers;k++)
		{
        txtStatsTrack[k].t = txtMenuPlayerName[2];
		txtStatsTrack[k+6].t = 
        txtStatsTrack[k+12].t = "--:--.--";
        }
	
	for(i=0;txtStatsTrack[i].t!=NULL;i++)
		{
        TEXT_x = txtStatsTrack[i].x;
        TEXT_y = txtStatsTrack[i].y;
        M_TEXT_prstr(txtStatsTrack[i].t,255,255,255);
        }

	semiBox(420,160);
	setSemiHW(0);
	}


TXT txtMenuArena[] =
	{
    {-100,-36,NULL},
    {-100,-24,NULL},
    {-100,-12,NULL},
    {-100,  0,NULL},
    {-100, 12,NULL},
    {-100, 24,NULL},

    { 25,-36,txtMenuPlayerFrags[0]},
    { 25,-24,txtMenuPlayerFrags[1]},
    { 25,-12,txtMenuPlayerFrags[2]},
    { 25,  0,txtMenuPlayerFrags[3]},
    { 25, 12,txtMenuPlayerFrags[4]},
    { 25, 24,txtMenuPlayerFrags[5]},

    { 95,-36,txtMenuPlayerFTimes[0]},
    { 95,-24,txtMenuPlayerFTimes[1]},
    { 95,-12,txtMenuPlayerFTimes[2]},
    { 95,  0,txtMenuPlayerFTimes[3]},
    { 95, 12,txtMenuPlayerFTimes[4]},
    { 95, 24,txtMenuPlayerFTimes[5]},
    
    {-110,-20,"Frags"},
    {-110,20,"Time to 10 laps"},
	
	{0,0,NULL}
    };

void SCORE_startmainmenu(void)
	{
	switch(*GameMode)
	    {
	    case 0: // Battle
	        menuState = MN_MainMenuInitBattle;
	        break;
	    case 1: // Tournament
	        menuState = MN_MainMenuInitTourn;
	        break;
	    case 2: // Time trial
	        menuState = MN_MainMenuInitTrial;
	        break;
	    case 3: // Arcade
	        menuState = MN_MainMenuInitArcade;
	        break;
	    }
	}

#if __DEBUG_SCORE >= 2
void dumpHighScore(void)
	{
	int w,l,p;

	mprintf("Race times:\n");
	
	for(w=0;w<5;w++)
	for(l=0;l<4;l++)
	for(p=0;p<3;p++)
		{
		if((w==4)&&(l!=3))
			continue;
		
		mprintf("w==%d, l==%d, p==%d, Name: %s Time: %02X:%02X.%02X\n",
			w,l,p,
			HighScore->HSNames[w] [l] [p],
            (int)((HighScore->HSTimes[w] [l] [p]&0x00ff0000)>>16),
            (int)((HighScore->HSTimes[w] [l] [p]&0x0000ff00)>>8),
            (int)((HighScore->HSTimes[w] [l] [p]&0x000000ff)));
        }

	mprintf("\nLap times:\n");

	for(w=0;w<4;w++)
	for(l=0;l<3;l++)
	for(p=0;p<3;p++)
		{
		if((w==4)&&(l!=3))
			continue;
			
		mprintf("w==%d, l==%d, p==%d, Name: %s Time: %02X:%02X.%02X\n",
			w,l,p,
            HighScore->HSNamesLap[w] [l] [p],
            (int)((HighScore->HSTimesLap[w] [l] [p]&0x00ff0000)>>16),
            (int)((HighScore->HSTimesLap[w] [l] [p]&0x0000ff00)>>8),
            (int)((HighScore->HSTimesLap[w] [l] [p]&0x000000ff)));
        }

	mprintf("\n");
	}
#endif

#if 0
void SCORE_initnames(void)
    {
	int i,j,p;
	
	#if __DEBUG_SCORE
	mprintf("----------------------\n");
    mprintf("SCORE_doHighScoreStats\n");
	mprintf("----------------------\n");
    #endif
	
	pStatLevel = STATE.mcurrlevel & 0x03;
	pStatWorld = STATE.mcurrlevel >> 2;
			
    nHScore = 0;

    // Track
    if(pStatLevel!=3)
        {
        for(p=0;p<MPLAYER;p++)
            {
			if(!hiScore[p].active)
				continue;
			if(!hiScore[p].needFinish)
				continue;
			
            i = finishPlace[p];

#####
            place = -1;
            for(j=2;j>=0;j--)
                if(HighScore->HSTimes[pStatWorld] [pStatLevel] [j]>hiScore[i].raceTime)
                    place = j;

            if(place==-1)       // Didnt make the grade
                continue;

            hScoreParam[nHScore].text = HighScore->HSNames[pStatWorld] [pStatLevel] [place];
            hScoreParam[nHScore].type = 1;
            hScoreParam[nHScore].hi = &hiScore[i];
			hScoreParam[nHScore].hiNum = i;
            nHScore++;

            for(j=2;j>place;j--)
                {
                #if __DEBUG_SCORE >= 1
                mprintf("[TR] (j==%d) %s (%02lX:%02lX.%02lX) ==> %s (%02lX:%02lX.%02lX)\n",j,
                    HighScore->HSNames[pStatWorld] [pStatLevel] [j-1],
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1]&0x00ff0000)>>16,
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1]&0x0000ff00)>>8,
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1]&0x000000ff),
                    HighScore->HSNames[pStatWorld] [pStatLevel] [j],
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j]&0x00ff0000)>>16,
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j]&0x0000ff00)>>8,
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j]&0x000000ff));
                #endif

                HighScore->HSTimes[pStatWorld] [pStatLevel] [j] =
                    HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1];
                *((u32 *)(HighScore->HSNames[pStatWorld] [pStatLevel] [j])) =
                    *((u32 *)(HighScore->HSNames[pStatWorld] [pStatLevel] [j-1]));
                }

            HighScore->HSTimes[pStatWorld] [pStatLevel] [place] = hiScore[i].raceTime;
            }

        // Work out if new high score (lap times)
        for(p=0;p<STATE.numscreens;p++)
            {
			if(STATE.numscreens==1)
				i = 0;
			else{
				i = p;
                if(hiScore[0].lapTime[hiScore[0].fastestLap]>
                    hiScore[1].lapTime[hiScore[1].fastestLap])
					i ^= 1;
                }

            place = -1;
            for(j=2;j>=0;j--)
                if(HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j]>hiScore[i].lapTime[hiScore[i].fastestLap])
                    place = j;

            if(place==-1)       // Didnt make the grade
                continue;

            hScoreParam[nHScore].text = HighScore->HSNamesLap[pStatWorld] [pStatLevel] [place];
            hScoreParam[nHScore].type = 0;
            hScoreParam[nHScore].hi = &hiScore[i];
			hScoreParam[nHScore].hiNum = i;
            nHScore++;

            for(j=2;j>place;j--)
                {
                #if __DEBUG_SCORE >= 1
                mprintf("[LP] (j==%d) %s (%02lX:%02lX.%02lX) ==> %s (%02lX:%02lX.%02lX)\n",j,
                    HighScore->HSNamesLap[pStatWorld] [pStatLevel] [j-1],
                    (HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j-1]&0x00ff0000)>>16,
                    (HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j-1]&0x0000ff00)>>8,
                    (HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j-1]&0x000000ff),
                    HighScore->HSNamesLap[pStatWorld] [pStatLevel] [j],
                    (HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j]&0x00ff0000)>>16,
                    (HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j]&0x0000ff00)>>8,
                    (HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j]&0x000000ff));
                #endif

                HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j] =
                    HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j-1];
                *((u32 *)(HighScore->HSNamesLap[pStatWorld] [pStatLevel] [j])) =
                    *((u32 *)(HighScore->HSNamesLap[pStatWorld] [pStatLevel] [j-1]));
                }

            HighScore->HSTimesLap[pStatWorld] [pStatLevel] [place] = hiScore[i].lapTime[hiScore[i].fastestLap];
            }
		}
    else{
        /*
		// Arena

        for(p=0;p<pStatNum;p++)
            {
            i = pStatOrderRace[p];

            if(pStat[i].ai)
                continue;

            place = -1;
            for(j=2;j>=0;j--)
                if(HighScore->HSTimes[pStatWorld] [pStatLevel] [j]>pStat[i].fragName)
                    place = j;

            if(place==-1)       // Didnt make the grade
                continue;

            hScoreParam[nHScore].text = HighScore->HSNamesLap[pStatWorld] [pStatLevel] [place];
            hScoreParam[nHScore].type = 2;
            hScoreParam[nHScore].p = &pStat[i];
            nHScore++;

            for(j=2;j>place;j--)
                {
                #if __DEBUG_SCORE >= 1
                mprintf("[FR] (j==%d) %s (%02lX:%02lX.%02lX) ==> %s (%02lX:%02lX.%02lX)\n",j,
                    HighScore->HSNames[pStatWorld] [pStatLevel] [j-1],
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1]&0x00ff0000)>>16,
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1]&0x0000ff00)>>8,
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1]&0x000000ff),
                    HighScore->HSNames[pStatWorld] [pStatLevel] [j],
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j]&0x00ff0000)>>16,
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j]&0x0000ff00)>>8,
                    (HighScore->HSTimes[pStatWorld] [pStatLevel] [j]&0x000000ff));
                #endif

                HighScore->HSTimes[pStatWorld] [pStatLevel] [j] =
                    HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1];
                *(u32 *)(HighScore->HSNames[pStatWorld] [pStatLevel] [j]) =
                    *(u32 *)(HighScore->HSNames[pStatWorld] [pStatLevel] [j-1]);
                }

            HighScore->HSTimes[pStatWorld] [pStatLevel] [place] = pStat[i].fragName;
            }
        */
		}

    spIndex = 0;

    #if __DEBUG_SCORE >= 1

    for(i=0;i<nHScore;i++)
        mprintf("%lu: Player %lu, hi == %p, Type == %lu, Text == %p\n",
            (u32)i,(u32)hScoreParam[i].hiNum,hScoreParam[i].hi,(u32)hScoreParam[i].type,hScoreParam[i].text);

    #endif

    #if __DEBUG_SCORE >= 2
    dumpHighScore();
    #endif
	}
#endif
#if 0
    if(spIndex<nHScore)
        {
        chx = chy = 0;
        hsIndex = 0;
        hsName[0] = hsName[1] = hsName[2] = ' ';
        hsName[3] = 0;

        tmOption = 1;
        }
    else{
        }
	}
#endif

#if 0
void SCORE_entername(void)
	{
	int i,j;
	
    gridBox2(  0,-50, 3, 1,30,15, 3, 2, 6, 3,192,192, 80, 64,192, 64, 96, 96, 96, 48, 64, 64,224, 64, 64,hsIndex,0,hsName);
    gridBox2(  0, 25,12, 5,30,15, 3, 2, 6, 3,192,192, 80,
		(newhue2rgb[(G_cyc*3)&0xff].r>>1)+64,
		(newhue2rgb[(G_cyc*3)&0xff].g>>1)+64,
		(newhue2rgb[(G_cyc*3)&0xff].b>>1)+64, 96, 96, 96, 48, 64, 64,224, 64, 64,chx,chy,hsTable);
					
	if(hsIndex==3)
		{
		chx = -1;
		chy = -1;
		}
	else{
        if((SD_PadData[0].push&K_HS_UP))
			if(chy>0) chy--;
        if((SD_PadData[0].push&K_HS_DOWN))
            if(chy<4) chy++;
        if((SD_PadData[0].push&K_HS_LEFT))
            if(chx>0) chx--;
        if((SD_PadData[0].push&K_HS_RIGHT))
            if(chx<11) chx++;
        }

	if((SD_PadData[0].push&K_HS_SELECT))
        {
        if(hsIndex<3)
            {
            if((chy*12)+chx==59)        // End
                hsIndex = 3;
            else
            if((chy*12)+chx==58)        // Del
                {
                if(hsIndex>0)
                    hsIndex--;
                hsName[hsIndex] = ' ';
                }
            else
                hsName[hsIndex++] = hsTable[(chy*12)+chx];
            }
        if(hsIndex>=3)
            {
            // Fill in high score name

            #if __DEBUG_MENU >= 1
            mprintf("spIndex == %d, Replacing (%p) %s with %s\n",spIndex,hScoreParam[spIndex].text,hScoreParam[spIndex].text,hsName);
            #endif

            *((u32 *)hScoreParam[spIndex].text) = *((u32 *)hsName);

            spIndex++;

            // Search for other high scores already named.

            j = 0;
            do  {
                if(spIndex<nHScore)
                    {
                    for(i=0;i<spIndex;i++)
                    if(hScoreParam[i].hiNum==hScoreParam[spIndex].hiNum)
                        {
                        *((u32 *)hScoreParam[spIndex].text) =
                            *((u32 *)hScoreParam[i].text);
                        j = 1;
                        i = ++spIndex;
                        }
                    j ^= 1;
                    }
                else
                    j = 1;
                }while(j==0);

            if(spIndex<nHScore)
				{
				chx = chy = 0;
				hsIndex = 0;
				hsName[0] = hsName[1] = hsName[2] = ' ';
				hsName[3] = 0;
				}
			else
				SCORE_startmainmenu();
			}								
		}
	}
#endif

typedef struct
	{
	int pnum;
	char *raceName;
	char *fastName;
	char *fragName;
	}hsEntry_t;

hsEntry_t hsEntry[2];

int SCORE_cplayer;

void SCORE_initnames(void)
	{
    switch(STATE.numscreens)
		{
		case 1:
            hsEntry[0].pnum = 0;
			hsEntry[1].pnum = -1;
			
			// Search for player 0 high scores
			if((STATE.mcurrlevel&0x03)==3)
				{
				// Arena
				if(hiScore[0].frags>=10)
					hsEntry[0].fragName = SCORE_checkfragtime(hiScore[0].frag10time);
				else
					hsEntry[1].fragName = NULL;
				
				hsEntry[0].raceName = NULL;
				hsEntry[0].fastName = NULL;
				}
			else{
				// Track
				hsEntry[0].raceName = SCORE_checkracetime(hiScore[0].raceTime);
				hsEntry[0].fastName = SCORE_checkfasttime(hiScore[0].lapTime[hiScore[0].fastestLap]);
				hsEntry[0].fragName = NULL;
				}
			break;
		case 2:
			// Search for player 0 high scores
			if((STATE.mcurrlevel&0x03)==3)
				{
				// Arena

				hsEntry[0].raceName = NULL;
				hsEntry[0].fastName = NULL;
				hsEntry[1].raceName = NULL;
				hsEntry[1].fastName = NULL;

                if(hiScore[0].frag10time<=hiScore[1].frag10time)
					{
	                hsEntry[0].pnum = 0;
    	            hsEntry[1].pnum = 1;
					
                    hsEntry[0].fragName = SCORE_checkfragtime(hiScore[0].frag10time);
                    hsEntry[1].fragName = SCORE_checkfragtime(hiScore[1].frag10time);
                    }
				else{
	                hsEntry[0].pnum = 1;
    	            hsEntry[1].pnum = 0;

                    hsEntry[0].fragName = SCORE_checkfragtime(hiScore[1].frag10time);
                    hsEntry[1].fragName = SCORE_checkfragtime(hiScore[0].frag10time);
					}
				}
			else{
				// Track
				
                hsEntry[0].fragName = NULL;
                hsEntry[1].fragName = NULL;
				
				if(hiScore[0].raceTime<=hiScore[1].raceTime)
					{
	                hsEntry[0].pnum = 0;
    	            hsEntry[1].pnum = 1;
					
					hsEntry[0].raceName = SCORE_checkracetime(hiScore[0].raceTime);
					hsEntry[1].raceName = SCORE_checkracetime(hiScore[1].raceTime);
					}
				else{
	                hsEntry[0].pnum = 1;
    	            hsEntry[1].pnum = 0;

					hsEntry[0].raceName = SCORE_checkracetime(hiScore[1].raceTime);
					hsEntry[1].raceName = SCORE_checkracetime(hiScore[0].raceTime);
					}
				
                if(hiScore[hsEntry[0].pnum].lapTime[hiScore[0].fastestLap]<=hiScore[hsEntry[1].pnum].lapTime[hiScore[1].fastestLap])
                    {
                    hsEntry[hsEntry[0].pnum].fastName = SCORE_checkfasttime(hiScore[hsEntry[0].pnum].lapTime[hiScore[hsEntry[0].pnum].fastestLap]);
                    hsEntry[hsEntry[1].pnum].fastName = SCORE_checkfasttime(hiScore[hsEntry[1].pnum].lapTime[hiScore[hsEntry[1].pnum].fastestLap]);
                    }
                else{
                    hsEntry[hsEntry[1].pnum].fastName = SCORE_checkfasttime(hiScore[hsEntry[1].pnum].lapTime[hiScore[hsEntry[1].pnum].fastestLap]);
                    hsEntry[hsEntry[0].pnum].fastName = SCORE_checkfasttime(hiScore[hsEntry[0].pnum].lapTime[hiScore[hsEntry[0].pnum].fastestLap]);
                    }
				}
            break;
		}

	#if __DEBUG_SCORE
	
	for(SCORE_cplayer=0;SCORE_cplayer<2;SCORE_cplayer++)
		{
		mprintf("hsEntry[%d].pnum == %d\n",SCORE_cplayer,hsEntry[SCORE_cplayer].pnum);
		mprintf("\traceName == %p\n",hsEntry[SCORE_cplayer].raceName);
		mprintf("\tfastName == %p\n",hsEntry[SCORE_cplayer].fastName);
		mprintf("\tfragName == %p\n",hsEntry[SCORE_cplayer].fragName);
		}
	
	#endif
    
	SCORE_cplayer = -1;
	}

int hiNameOffset;
char hiName[4];
char hiNameH[4];

void SCORE_calcnames(void)
	{
	// decide if to call SCORE_entername or SCORE_startmainmenu
	
	while(1)
		{
		SCORE_cplayer++;
		if(SCORE_cplayer>=2)
			{
			SCORE_startmainmenu();
			return;
			}
		
		if(hsEntry[SCORE_cplayer].pnum!=-1)
        if((hsEntry[SCORE_cplayer].raceName!=NULL)||(hsEntry[SCORE_cplayer].fastName!=NULL)||(hsEntry[SCORE_cplayer].fragName!=NULL))
            {
	        menuState = MN_EnterNames;
			
			// Initialise variables used in SCORE_entername
            hiNameOffset =
			hiName[0] = hiName[1] = hiName[2] = hiName[3] =
			hiNameH[0] = hiNameH[1] = hiNameH[2] = hiNameH[3] = 0;
			
	        SCORE_entername();
			
			return;
			}
		}
	}

// 30 letters + \0
char nameTable[31] = "abcdefghijklmnopqrstuvwxyz.!\25\26";

// Params that are gonna change (5yr garantee with that)
int backBarWidth = 512;
int backBarHeight = 128;
int nameBarWidth = 180;
int nameBarHeight = 40;
int nameBarYcenter = -32;
int letterBarHeight = 36;
int letterBarYcenter = 32;
//int letterGap = 32;
int mainLetterGap = 64;
int mainLetterYcenter = 32;
int mainLetterHeight = 46;

void SCORE_entername(void)
	{
	int i;
	// Draw screen --------------------
	
	// Name letters
	
	// Letters inc main selected letter
	for(i=(-backBarWidth>>1);i<(backBarWidth>>1);i++)
		{
		register int adj;
		register int idx;
		register int off;
		
		if(i<(-mainLetterGap>>1))
			{
			// Left of central letter
            adj = i + hiNameOffset + 32;
            idx = adj >> 5;         // / 32
            off = adj & 0x1f;
			if(idx<0)
				idx += 30;
			if(idx>=30)
				idx -= 30;
            
			// print v-line [off] of letter nameTable[idx] at screen v-line 'i'		
			charLine(i,off,idx,1);
			}
		else
		if(i<=(mainLetterGap>>1))
			{
			// Central letter

            adj = (i>>1) + hiNameOffset + 16;
            idx = adj >> 5;         // / 32
            off = adj & 0x1f;
			if(idx<0)
				idx += 30;
			if(idx>=30)
				idx -= 30;
            
			// print v-line [off] of letter nameTable[idx] at screen v-line 'i'
			charLine(i,off,idx,2);
			}
		else{
			// Right of central letter

            adj = i + hiNameOffset;
            idx = adj >> 5;         // / 32
            off = adj & 0x1f;
			if(idx<0)
				idx += 30;
			if(idx>=30)
				idx -= 30;
            
			// print v-line [off] of letter nameTable[idx] at screen v-line 'i'
			charLine(i,off,idx,1);
			}
		}
	
	// Semi main letter bit
	semiBoxC(mainLetterGap,mainLetterHeight,mainLetterYcenter,48);
    setSemiHW(1);
	
	// Semi name bit
	semiBoxC(nameBarWidth,nameBarHeight,nameBarYcenter,48);
    setSemiHW(1);
    
	// Semi letters bit
	semiBoxC(backBarWidth,letterBarHeight,letterBarYcenter,48);
    setSemiHW(1);
    
	// Semi back bit
    semiBoxC(backBarWidth,backBarHeight,0,0/*48*/);
    setSemiHW(0);
    
	// --------------------------------
	
    hiNameOffset += ssssss;
	if(hiNameOffset>(30*32))
		hiNameOffset -= (30*32);

	if(hiNameOffset>(30*16))
		{
		SCORE_updatename();
		SCORE_calcnames();
		}

//    if(1)//finishedNameEnter)
//		{
//		SCORE_updatename();
//		SCORE_calcnames();
//		}

	}

// print v-line [off] of letter nameTable[idx] at screen v-line 'i'
void charLine(int i,int off,int idx,int db)
	{
	/*
    GsLINE l;
    setLineF2(&l);
    l.r = 224;    l.g = 96;    l.b = 96;
    l.x0 = i;
    l.y0 = 48;
    l.x1 = i;
    l.y1 = 48 + off;
    GsSortLine(&l,MWotPtr,0);
    l.y0 = -96;
    l.y1 = -96 + (idx<<1);
    GsSortLine(&l,MWotPtr,0);
	*/

	register const int c = (int)wTxtTableLg[nameTable[idx]];
    register const int w = wTxtChar[c].w;
	register const int lg = (32 - w)>>1;

//    |<         32          >|
//    |< lg >|<   w   >|      |

	if(off<lg)
		return;
	if(off>=lg+w)
		return;

	sprite.w = 1;
	sprite.h = wTxtChar[c].h;
	sprite.u = wTxtChar[c].u + off - lg;
	sprite.v = wTxtChar[c].v;
    sprite.r = 48;
    sprite.g = 48;
    sprite.b = 48;
	sprite.x = i;
    sprite.y = letterBarYcenter - ((sprite.h-1)>>1);
	if((c>=95)&&(c<113))
	    sprite.y--;
	if(db==1)
		{
        GsSortFastSprite(&sprite,MWotPtr,0);
		}
	else{
        sprite.y -= 8;
        sprite.scaley = 8192;
		GsSortSprite(&sprite,MWotPtr,0);
        sprite.scaley = 4096;
		}
	}

void SCORE_updatename(void)
	{
//	int i;
	printf("SCORE_updatename() hsEntry[%d], pnum = %d\n",SCORE_cplayer,hsEntry[SCORE_cplayer].pnum);
	if(hsEntry[SCORE_cplayer].raceName)
		{
        *((u32 *)hsEntry[SCORE_cplayer].raceName) = *((u32 *)hiNameH);
        mprintf("    raceTime (%p)\n",hsEntry[SCORE_cplayer].raceName);
        }
	if(hsEntry[SCORE_cplayer].fastName)
		{
        *((u32 *)hsEntry[SCORE_cplayer].fastName) = *((u32 *)hiNameH);
        mprintf("    fastTime (%p)\n",hsEntry[SCORE_cplayer].fastName);
        }
	if(hsEntry[SCORE_cplayer].fragName)
		{
        *((u32 *)hsEntry[SCORE_cplayer].fragName) = *((u32 *)hiNameH);
        mprintf("    fragTime (%p)\n",hsEntry[SCORE_cplayer].fragName);
        }
	}

#define	pStatWorld		(STATE.mcurrlevel>>2)
#define	pStatLevel		(STATE.mcurrlevel&0x03)

char *SCORE_checkracetime(u32 t)
	{
	int place;
	int j;
	
	place = -1;
	for(j=2;j>=0;j--)
	if(HighScore->HSTimes[pStatWorld] [pStatLevel] [j]>t)
		place = j;

	if(place==-1)       // Didnt make the grade
		return NULL;

	for(j=2;j>place;j--)
		{
		HighScore->HSTimes[pStatWorld] [pStatLevel] [j] =
		    HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1];
		*((u32 *)(HighScore->HSNames[pStatWorld] [pStatLevel] [j])) =
		    *((u32 *)(HighScore->HSNames[pStatWorld] [pStatLevel] [j-1]));
		}

	HighScore->HSTimes[pStatWorld] [pStatLevel] [place] = t;
	return HighScore->HSNames[pStatWorld] [pStatLevel] [place];
    }
	
char *SCORE_checkfasttime(u32 t)
	{
	int place;
	int j;
	
	place = -1;
	for(j=2;j>=0;j--)
	if(HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j]>t)
		place = j;

	if(place==-1)       // Didnt make the grade
		return NULL;

	for(j=2;j>place;j--)
		{
		HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j] =
		    HighScore->HSTimesLap[pStatWorld] [pStatLevel] [j-1];
		*((u32 *)(HighScore->HSNamesLap[pStatWorld] [pStatLevel] [j])) =
		    *((u32 *)(HighScore->HSNamesLap[pStatWorld] [pStatLevel] [j-1]));
		}

	HighScore->HSTimesLap[pStatWorld] [pStatLevel] [place] = t;
	return HighScore->HSNamesLap[pStatWorld] [pStatLevel] [place];
	}
	
char *SCORE_checkfragtime(u32 t)
	{
	int place;
	int j;
	
	place = -1;
	for(j=2;j>=0;j--)
	if(HighScore->HSTimes[pStatWorld] [pStatLevel] [j]>t)
		place = j;

	if(place==-1)       // Didnt make the grade
		return NULL;

	for(j=2;j>place;j--)
		{
		HighScore->HSTimes[pStatWorld] [pStatLevel] [j] =
		    HighScore->HSTimes[pStatWorld] [pStatLevel] [j-1];
		*((u32 *)(HighScore->HSNames[pStatWorld] [pStatLevel] [j])) =
		    *((u32 *)(HighScore->HSNames[pStatWorld] [pStatLevel] [j-1]));
		}

	HighScore->HSTimes[pStatWorld] [pStatLevel] [place] = t;
	return HighScore->HSNames[pStatWorld] [pStatLevel] [place];
	}
