#include <stdio.h>
#include <sys/types.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libsn.h>
#include <libsn.h>
#include <inline_c.h>
#include <gtemac.h>

#include "header.h"
#include "state.h"
#include "objects.h"
#include "collide.h"

// #include "render.h"
// #include "camera.h"
// #include "sdlib\sdtypes.h"
// #include "sdlib\sdfunc.h"
// #include "ctrller.h"
// #include "gameloop.h"
// #include "state.h"
// #include "psx\mathpsx.h"

#include "wake.h"

int globalWakeDisable = 0;

SWAKE wake[NPLAYERMAX*(NSWAKE+1)];
SWAKE *lWake[NPLAYERMAX];

extern GsOT *ptrwot;

SVECTOR szVector = {0,0,4096};
VECTOR nyVector = {0,-4096,0};

#if __DEBUG_WAKE
SVECTOR ln[2];
#endif

s16 WAKE_shipoffset[8] [6] [2] =
	{
    {{-160,-30},{ -80,-30},{   0,-30},{  80,-30},{ 160,-30},{   0, 50}},
    {{-160,-30},{ -80,-30},{   0,-30},{  80,-30},{ 160,-30},{   0, 50}},
    {{-160,-30},{ -80,-30},{   0,-30},{  80,-30},{ 160,-30},{   0, 50}},
    {{-160,-30},{ -80,-30},{   0,-30},{  80,-30},{ 160,-30},{   0, 50}},
    {{-160,-30},{ -80,-30},{   0,-30},{  80,-30},{ 160,-30},{   0, 50}},
    {{-160,-30},{ -80,-30},{   0,-30},{  80,-30},{ 160,-30},{   0, 50}},
    {{-160,-30},{ -80,-30},{   0,-30},{  80,-30},{ 160,-30},{   0, 50}},
    {{-160,-30},{ -80,-30},{   0,-30},{  80,-30},{ 160,-30},{   0, 50}}
	};

void WAKE_init(void)
	{
	// initialize SWAKE's + lWake
	
	int i,j;
	s32 *ptr;
	
	#if __DEBUG_WAKE
	mprintf("WAKE_init()\n");
	#endif
	
	ptr = (s32 *)wake;
	j = NPLAYERMAX * (NSWAKE+1) * sizeof(SWAKE)>>2;
	for(i=0;i<j;i++)
		*ptr++ = -1;
	
	for(i=0;i<NPLAYER;i++)
		{
		lWake[i] = &wake[i];
		wake[i].cycle = NSWAKE-1;
		wake[i].prev = &wake[i];
		}
	}

void WAKE_process(void)
	{
	// Process all active SWAKE's
	// Create a new SWAKE for each ship
	
	register int i;
	register SWAKE *w;
	register int j;
	
	return;
	
	// Decay all existing wakes
	w = wake;
    for(i=0;i<NPLAYERMAX*(NSWAKE+1);i++,w++)
	if(w->cycle!=-1)
		WAKE_decay(w);
    
	for(i=0;i<NPLAYER;i++)
		{
		// Find first empty slot in wake array
		for(j=0;wake[j].cycle!=-1;j++);
		WAKE_create(i,&wake[j]);
		}
	}

void WAKE_draw(void)
	{
	// Draw all active SWAKE's
	
	register int i;
	register SWAKE *w;

	return;
	
	// Draw all existing wakes
	w = wake;
    for(i=0;i<NPLAYERMAX*(NSWAKE+1);i++,w++)
	if(w->cycle!=-1)
	if(w->cycle!=0)
		WAKE_sdraw(w);
	}

void WAKE_create(int pl,register SWAKE *w)
	{
	// Create a new SWAKE

	register OBJ_STRUCT *objs;
	register OBJ_PLAYERSTRUCT *objp;
	s32 vLen;
	int i;
	VECTOR cOffset;
	VECTOR v0,v1;
	int collret;

	return;

	objp = &OBJ_players[pl];
	objs = objp->pobj;
	
	w->cycle = NSWAKE-1;
	w->prev = lWake[pl];
	lWake[pl] = w;

	#if __DEBUG_WAKE	
	w->test.pad = 1;
    w->test.vx = objs->p.vx >> 8;
    w->test.vy = objs->p.vy >> 8;
    w->test.vz = objs->p.vz >> 8;
    #endif
	
	// Attain unit vector for the velocity of the ship
	vLen = WAKE_veclen((VECTOR *)&objs->v);
	if(vLen<50)
		{
		// Just use ship direction as forward vector
		// velocity vector is to inacurate, we are not moving. (or very slow)
	    ApplyMatrix((MATRIX *)&objp->SIM_objmat,&szVector,&w->forward);
		}
	else{
		// Use velocity for direction (could be sliding etc.)
        w->forward.vx = (objs->v.vx<<8)/vLen;		// fwd is 1.3.12
        w->forward.vy = 0;//(objs->v.vy<<8)/vLen;		// ATTN! mul recip ?
        w->forward.vz = (objs->v.vz<<8)/vLen;
        }
	
	// Attain right vector by crossing [0,-1,0] with forward
    OuterProduct12(&w->forward,&nyVector,&w->right);

	// Do the 6 collision checks
	w->height = 0;
	for(i=0;i<6;i++)
		{
		// shipoffsets are not <<8, so its <<8 >>12 == >>4
		
        cOffset.vx = ((WAKE_shipoffset[objp->crafttype] [i] [0] * w->right.vx)+
                      (WAKE_shipoffset[objp->crafttype] [i] [1] * w->forward.vx))>>4;
        cOffset.vz = ((WAKE_shipoffset[objp->crafttype] [i] [0] * w->right.vz)+
                      (WAKE_shipoffset[objp->crafttype] [i] [1] * w->forward.vz))>>4;
        
		v0.vx = v1.vx = (objs->p.vx + cOffset.vx) >> 8;
		v0.vz = v1.vz = (objs->p.vz + cOffset.vz) >> 8;
        v0.vy = (objs->p.vy>>8) - 80;
		v1.vy = (objs->p.vy>>8) + 150;
		
/*
		// Print collision lines
		#if __DEBUG_WAKE
		if(pl==0) if(i==0)
			FntPrint("%d,%d,%d -> %d,%d,%d",v0.vx,v0.vy,v0.vz,v1.vx,v1.vy,v1.vz);
        ln[0].vx = v0.vx;	ln[0].vy = v0.vy;	ln[0].vz = v0.vz;
        ln[1].vx = v1.vx;	ln[1].vy = v1.vy;	ln[1].vz = v1.vz;
        WAKE_debugline(255,255,255);
		#endif
*/
		
        collret = COL_test2((vec32 *)&v0,(vec32 *)&v1);
		
		w->p[i].vx = v0.vx;
		w->p[i].vy = COL_inter.vy;
		w->p[i].vz = v0.vz;
		w->p[i].surf = collret;

		w->height += COL_inter.vy - (objs->p.vy>>8);
		}

	w->height /= 6;
	}

#if __DEBUG_WAKE
void WAKE_debugline(u8 r,u8 g,u8 b)
	{
	GsLINE deb;
    s32 otz,opz,flag;
	
    setLineF2(&deb);
	
    gte_ldv0(&ln[0]);
    gte_ldv1(&ln[1]);
    gte_ldv2(&ln[1]);
    gte_rtpt();
    gte_stsxy0(&deb.x0);
    gte_stsxy1(&deb.x1);
	gte_stflg(&flag);
	
    if((flag&0x80000000))
		return;
		
	gte_nclip();
    gte_stopz(&opz);
	gte_stszotz(&otz);

    if(otz<0)
		return;
		
	deb.r = r;
	deb.g = g;
	deb.b = b;

    GsSortLine(&deb,ptrwot,otz>>(14-ptrwot->length));
//  GsSortLine(&deb,ptrwot,0);
    }
#endif

s32 WAKE_veclen(register VECTOR *v)
	{
    // calculate length of vector, nasty C style code.
	
	// special 2d vector length function, ignores y component
	
	// input is 1.23.8
	// output is 1.23.8
	
    register s32 x = v->vx >> 4;
//    register s32 y = v->vy >> 4;
    register s32 z = v->vz >> 4;
    
	x *= x;		/*y *= y;*/		z *= z;
	
    return SquareRoot0(x+ /* y+ */ z);
	}

void WAKE_decay(register SWAKE *w)
	{
	// Move collision points 
	//
	//             x
	//       x   x x x   x
	//
	//            
	//
	//             x
	//      <=   > x <   =>
	
	w->p[0].vx -= w->right.vx>>6;
	w->p[0].vz -= w->right.vz>>6;
	w->p[1].vx += w->right.vx>>7;
	w->p[1].vz += w->right.vz>>7;
	w->p[3].vx -= w->right.vx>>7;
	w->p[3].vz -= w->right.vz>>7;
	w->p[4].vx += w->right.vx>>6;
	w->p[4].vz += w->right.vz>>6;
	
	w->cycle--;
	}

void WAKE_sdraw(register SWAKE *w)
	{
	// Draw this SWAKE
	
#if __DEBUG_WAKE
	int i;

	if(w->test.pad!=1)	return;
	if(w->prev->test.pad!=1)	return;
    ln[0].vx = w->test.vx;
    ln[0].vy = w->test.vy;
    ln[0].vz = w->test.vz;
    ln[1].vx = w->prev->test.vx;
    ln[1].vy = w->prev->test.vy;
    ln[1].vz = w->prev->test.vz;
	WAKE_debugline(255,255,255);
	
	if(w->cycle==NSWAKE-1)
		{
	    ln[0].vx = w->test.vx;
	    ln[0].vy = w->test.vy;
	    ln[0].vz = w->test.vz;
        ln[1].vx = w->test.vx + (w->forward.vx>>5);
        ln[1].vy = w->test.vy + (w->forward.vy>>5);
        ln[1].vz = w->test.vz + (w->forward.vz>>5);
        WAKE_debugline(255,80,80);
        ln[1].vx = w->test.vx + (w->right.vx>>5);
        ln[1].vy = w->test.vy + (w->right.vy>>5);
        ln[1].vz = w->test.vz + (w->right.vz>>5);
	    WAKE_debugline(80,255,80);
        ln[1].vx = w->test.vx;
        ln[1].vy = w->test.vy + (-4096>>5);
        ln[1].vz = w->test.vz;
	    WAKE_debugline(80,80,255);
		}

	for(i=0;i<6;i++)
		{
        ln[0].vx = w->p[i].vx;
        ln[0].vy = w->p[i].vy;
        ln[0].vz = w->p[i].vz;
        ln[1].vx = w->p[i].vx;
        ln[1].vy = w->p[i].vy - w->height;     // + (-4096>>5);
        ln[1].vz = w->p[i].vz;
		if(w->p[i].surf!=-1)
	        WAKE_debugline(224,224,80);
		}
#endif

	return;

	if(w->cycle==NSWAKE-1)
		{
        WAKE_ptri(&w->p[2],&w->p[1],&w->p[5]);
        WAKE_ptri(&w->p[2],&w->p[5],&w->p[3]);
        }
	
    WAKE_pquad(&w->p[0],&w->p[1],&w->prev->p[0],&w->prev->p[1]);
    WAKE_pquad(&w->p[4],&w->prev->p[4],&w->p[3],&w->prev->p[3]);
    WAKE_pquad(&w->p[2],&w->prev->p[2],&w->p[1],&w->prev->p[1]);
    WAKE_pquad(&w->p[2],&w->p[3],&w->prev->p[2],&w->prev->p[3]);
    }

void WAKE_ptri(colvec *v0,colvec *v1,colvec *v2)
	{
	register int otshift;
    s32 otz,opz,flag;
	POLY_F3 pf3;
	SVECTOR vec[3];

	if(v0->surf==-1)	return;
	if(v1->surf==-1)	return;
	if(v2->surf==-1)	return;
	
	// ATTN !     put the fucking stack on dcache
	// ATTN !     do in asm for better load
	// ATTN !     make otshift global
	// ATTN !     write own inline macros or try gte_stsxy3_f3 ??	
	// ATTN !     rewrite gte_ldv3 for loading from array with one param
	
    vec[0].vx = v0->vx;
    vec[0].vy = v0->vy;
    vec[0].vz = v0->vz;
    vec[1].vx = v1->vx;
    vec[1].vy = v1->vy;
    vec[1].vz = v1->vz;
    vec[2].vx = v2->vx;
    vec[2].vy = v2->vy;
    vec[2].vz = v2->vz;
    
    setPolyF3(&pf3);
    
    pf3.r0 =
    pf3.g0 =
	pf3.b0 = 128;
	
    gte_ldv3(&vec[0],&vec[1],&vec[2]);
    gte_rtpt();
    gte_stsxy3(&pf3.x0,&pf3.x1,&pf3.x2);
    gte_stflg(&flag);
	
    if((flag&0x80000000))
		return;
	
	gte_nclip();
    gte_stopz(&opz);
	gte_stszotz(&otz);

    if(otz<0)
		return;

	otshift = 14 - ptrwot->length;
	GsSortPoly(&pf3,ptrwot,otz>>otshift);
	}

void WAKE_pquad(colvec *v0,colvec *v1,colvec *v2,colvec *v3)
	{
	// ATTN !  : Temporary
	WAKE_ptri(v0,v1,v2);
	WAKE_ptri(v3,v2,v1);
	}

