//PSX_pcks.c  This is the file thats hold all graphical code for pickups
//Ian Tomkins

#include "..\header.h"
#include "..\objects.h"
#include "..\collide.h"
#include "..\pickups.h"
#include "..\weapons.h"
#include "..\render.h"
#include "..\camera.h"
#include "..\ctrller.h"
#include "..\sdlib\sdtypes.h"
#include "..\sdlib\sdfunc.h"
#include "..\state.h"
#include "MATHPSX.h"
#include "PSX_libs.h"
#include "PSX_pcks.h"
#include "PSX_expn.h"

#include "..\AI.h"
#include "..\version.h"
#include "soundpsx.h"

SVECTOR				rot_vec, rot_val;
s16					rot_inc;


//PLASMA

PLASMA_WEAPON    PSX_plasma[MAX_PLASMAS];

void init_plasma_orb(PLASMA_WEAPON *ctrl_ptr, PLASMA_ORB *ptr);
void init_plasma_stream(PLASMA_STREAM *ptr, PLASMA_WEAPON *ctrl_ptr, OBJ_PLAYERSTRUCT *plyr_ptr, OBJ_STRUCT *obj_ptr);
PLASMA_WEAPON   *init_plasma_weapon(void);

void process_plasma_stream(PLASMA_WEAPON *ptr, PLASMA_STREAM *str_ptr, OBJ_STRUCT *obj_ptr);
void process_plasma_packet(PLASMA_WEAPON *wpn_ptr, PLASMA_STREAM *fx_ptr, PLASMA_PKT *ptr);
void process_plasma_pulse(PLASMA_WEAPON *wpn_ptr, PLASMA_STREAM *str_ptr, PLASMA_PULSE *ptr);
void process_plasma_orb(PLASMA_WEAPON *ptr, PLASMA_ORB *orb_ptr);
void init_pulse(PLASMA_WEAPON *wpn_ptr, PLASMA_STREAM *fx_ptr, int rot, int amp);

int proximity_check(PLASMA_WEAPON *ptr, OBJ_STRUCT *obj_ptr);
void reverse_stream(PLASMA_WEAPON *ptr, PLASMA_STREAM *str_ptr);

void display_plasma_stream(PLASMA_WEAPON *ptr, PLASMA_STREAM *str_ptr, OBJ_STRUCT *obj_ptr, char index);

//END OF PLASMA


//FLAMER

FLAMER_FLAME_ANIM   PSX_flamer_flames[MAX_FLAMER_FLAMES];
FLAMER_CTRL_STRUCT	PSX_flamers[MAX_FLAMERS];

void update_flamer_flame(FLAMER_FLAME_ANIM *ptr, FLAMER_CTRL_STRUCT *ctrl_ptr);
s32 init_new_flamer_flame(FLAMER_CTRL_STRUCT *ctrl_ptr);

FLAMER_CTRL_STRUCT  *init_flamer_ctrl_struct(void);
FLAMER_FLAME_ANIM   *init_flamer_flame_object(void);

//END OF FLAMER


//GAS CLOUD

GAS_FLAME_ANIM  	PSX_gas_flames[MAX_GAS_FLAMES];
GAS_CTRL_STRUCT		PSX_gas[MAX_GAS_CLOUDS];

void update_gas_flame(GAS_FLAME_ANIM *ptr, GAS_CTRL_STRUCT *ctrl_ptr);
s32 init_new_gas_flame(GAS_CTRL_STRUCT *ctrl_ptr);

GAS_CTRL_STRUCT  	*init_gas_ctrl_struct(void);
GAS_FLAME_ANIM   	*init_gas_flame_object(void);

//END OF GAS CLOUD


//TORPEDO WAKE

//WAKE_STRUCT			PSX_torpedo_wake[MAX_TORPEDO_WAKES];

//WAKE_STRUCT   		*init_new_torpedo_wake_struct(void);

//END OF ORPEDO WAKE


//SPLASH - 3D

SPLASH_3D			PSX_splash[MAX_SPLASHES];
INNER_SPLASH_3D		PSX_inner_splash[MAX_SPLASHES];
FLOOR_SPLASH_3D		PSX_floor_splash[MAX_SPLASHES];

void init_inner_splash(OBJ_STRUCT *obj_ptr, SPLASH_3D *splash_ptr);
void init_floor_splash(OBJ_STRUCT *obj_ptr, SPLASH_3D *splash_ptr);

SPLASH_3D			*init_new_splash_struct(void);
INNER_SPLASH_3D	  	*init_new_inner_splash_struct(void);
FLOOR_SPLASH_3D	  	*init_new_floor_splash_struct(void);

DROPLET_STRUCT		PSX_droplet[MAX_DROPLETS];
RIPPLE_STRUCT		PSX_ripple[MAX_RIPPLES];

DROPLET_STRUCT 		*init_new_droplet_struct(void);
RIPPLE_STRUCT 		*init_new_ripple_struct(void);

//END OF SPLASH - 3D


//Declarations of PSX effects structures.
SHIELD_FX           PCK_shields[MAX_SHIELDS];
//BURST_FX            PCK_bursts[MAX_BURSTS];

extern s16 	    	EXP_fire_uv_table[MAX_EXP_TIMS][7];
extern s32 			power_up_table[10][5];

SVECTOR	  			shield_coord[MAX_SHIELD_SEGMENTS * 4];
ICON_STRUCT	  		icons[MAXNUMPLAYERS];
//CANNON_ICON			cannon_icons[MAXNUMPLAYERS];
//LENS_FLARE			flare[MAX_LENS_FLARES];
TRAIL_STRUCT  		PSX_rocket_trail[MAX_ROCKET_TRAILS];


/*LENS_FLARE lens_flare_table[MAX_LENS_FLARES][6] = {

	{NULLVAL, 100, 30, 0, 0, 255},
	{NULLVAL, 100, 20, 0, 255, 0},
	{NULLVAL, 100, 25, 255, 0, 0},
	{2, 130, 4, 0, 0, 153},
	{3, 100, 10, 0, 0, 102},
	{1, 50, 20, 0, 0, 77},
	{3, 20, 5, 0, 0, 77},
	{0, 0, 4, 0, 0, 77},
	{5, -25, 7, 0, 0, 128},
	{5, -40, 2, 0, 0, 153},
	{5, -60, 4, 0, 0, 102},
	{5, -100, 3, 0, 0, 51}

};
*/
u8					icon_uv[MAX_ICONS][7] =
{
	{64, 192, 95, 223, 90, 91, 255},
	{96, 192, 127, 223, 0, 255, 255},
	{128, 192, 159, 223, 255, 0, 0},
	{160, 192, 191, 223, 41, 120, 208},
	{192, 192, 223, 223, 10, 213, 0},
	{224, 192, 255, 223, 204, 0, 255},
	{64, 224, 95, 255, 255, 150, 0},
	{96, 224, 127, 255, 63, 20, 255},
	{160, 224, 191, 255, 226, 0, 85},
	{192, 224, 223, 255, 255, 81, 147},
	{224, 224, 255, 255, 89, 172, 85},
	{128, 94, 159, 125, 230, 115, 58},
	{128, 224, 159, 255, 255, 249, 73}
};


extern GsOT     Wotwin0[2];
extern GsOT     Wotwin1[2];
extern int      outbuf_idx;
extern	GsOT	*ptrwot;

//Local function prototypes
SHIELD_FX   *init_shield_object(void);
//BURST_FX   *init_burst_object(void);

TRAIL_STRUCT	*init_trail_struct(OBJ_STRUCT *obj_ptr);


void PSX_display_pickup_icon(OBJ_STRUCT *obj_ptr)
{
	POLY_FT4				face;
	POLY_GT4				face1;
	SVECTOR					coord[4], cam_rot, local;
	int						i, height, display_loop, in_range, ian_timer;
	long					z_position, p, flag, x_val, z_val;
	MATRIX					rot_matrix;
	GsOT					*ot_ptr;
	short					angle, rot_diff;
   	s16   					j, a, ran;


	AI_pickups[obj_ptr->pkup_data.AI_index].type = obj_ptr->pkup_data.type;
	
	if (obj_ptr->pkup_data.type == NULLVAL)
	{
		obj_ptr->pkup_data.timer ++;

		if (obj_ptr->pkup_data.timer == 75)
		{
			a = obj_ptr->index;
			 ran  =  rand()&255;
			 for(j=0;j<13;j++)
			 {
			    if( ran < probability[j] )break;
			    ran  -= probability[j];
			 }
			 if( j==13 )
			 {
			    printf("cunt probability\n");
			    j=12;
			 }

			 OBJ_objects[a].pkup_data.type =  j;

	         OBJ_objects[a].pkup_data.quantity = 1;

	         if( OBJ_objects[a].pkup_data.type==pck_rocket )
	            OBJ_objects[a].pkup_data.quantity = 8;

	         if( OBJ_objects[a].pkup_data.type==pck_flame )
	            OBJ_objects[a].pkup_data.quantity = 250;
	 	}

		return;
	}

	height = 50;

	obj_ptr->r.vy += (44 << 4);

    SetPolyFT4(&face);
    SetSemiTrans(&face, 1);

    face.r0 = icon_uv[obj_ptr->pkup_data.type][4];
    face.g0 = icon_uv[obj_ptr->pkup_data.type][5];
    face.b0 = icon_uv[obj_ptr->pkup_data.type][6];

    face.tpage = GetTPage(0, 1, 704, 256);
    face.clut = GetClut(704, 447);

    face.u0 = icon_uv[obj_ptr->pkup_data.type][0];
    face.v0 = icon_uv[obj_ptr->pkup_data.type][1];

    face.u1 = icon_uv[obj_ptr->pkup_data.type][2];
    face.v1 = icon_uv[obj_ptr->pkup_data.type][1];

    face.u2 = icon_uv[obj_ptr->pkup_data.type][0];
    face.v2 = icon_uv[obj_ptr->pkup_data.type][3];

    face.u3 = icon_uv[obj_ptr->pkup_data.type][2];
    face.v3 = icon_uv[obj_ptr->pkup_data.type][3];

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_long(&obj_ptr->p, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		local.vx = (obj_ptr->p.vx >> 8) - CAM_camp[display_loop].vx;
		local.vy = (obj_ptr->p.vy >> 8) - CAM_camp[display_loop].vy;
		local.vz = (obj_ptr->p.vz >> 8) - CAM_camp[display_loop].vz;

		cam_rot.vx = CAM_came[display_loop].vx >> 4;
		cam_rot.vy = CAM_came[display_loop].vy >> 4;
		cam_rot.vz = CAM_came[display_loop].vz >> 4;

		RotMatrix(&cam_rot, &rot_matrix);
		ApplyMatrixSV(&rot_matrix, &local, &local);

		coord[0].vx = -height;
		coord[0].vy = -4 * height;
		coord[0].vz = 0;

		coord[1].vx = height;
		coord[1].vy = -4 * height;
		coord[1].vz = 0;

		coord[2].vx = -height;
		coord[2].vy = -2 * height;
		coord[2].vz = 0;

		coord[3].vx = height;
		coord[3].vy = -2 * height;
		coord[3].vz = 0;

		for (i = 0; i < 4; i++)
		{
			coord[i].vx += local.vx;
			coord[i].vy += local.vy;
			coord[i].vz += local.vz;
		}

		SetTransMatrix(&IDENTITY_MATRIX);
		SetRotMatrix(&IDENTITY_MATRIX);

	    z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
	                    &coord[3], (long *)&face.x0, (long *)&face.x1,
	                    (long *)&face.x2, (long *)&face.x3, &p, &flag);

	   	GsSortPoly(&face, ot_ptr, z_position >> otzshift);

	    SetPolyGT4(&face1);
	    SetSemiTrans(&face1, 1);

	    face1.r0 = 0;//face.r0;
	    face1.g0 = 0;//face.g0;
	    face1.b0 = 0;//face.b0;

	    face1.r1 = 0;
	    face1.g1 = 0;
	    face1.b1 = 0;

	    face1.r2 = face.r0;
	    face1.g2 = face.g0;
	    face1.b2 = face.b0;

	    face1.r3 = face.r0;
	    face1.g3 = face.g0;
	    face1.b3 = face.b0;

	    face1.tpage = GetTPage(0, 3, 704, 256);
//	    face1.clut = GetClut(736, 445);
	    face1.clut = GetClut(704, 470);

	    face1.u0 = 24;//160;
	    face1.v0 = 224;//174;

	    face1.u1 = 39;//191;
	    face1.v1 = 224;//174;

	    face1.u2 = 24;//160;
	    face1.v2 = 239;//188;

	    face1.u3 = 24;//191;
	    face1.v3 = 239;//188;

		coord[0].vx = -height * 2;
		coord[0].vy = -5 * height;
		coord[0].vz = 0;

		coord[1].vx = height * 2;
		coord[1].vy = -5 * height;
		coord[1].vz = 0;

		coord[2].vx = -height / 3;
		coord[2].vy = -height - 10;
		coord[2].vz = 0;

		coord[3].vx = height / 3;
		coord[3].vy = -height - 10;
		coord[3].vz = 0;

		for (i = 0; i < 4; i++)
		{
			coord[i].vx += local.vx;
			coord[i].vy += local.vy;
			coord[i].vz += local.vz;
		}

	    z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
	                    &coord[3], (long *)&face1.x0, (long *)&face1.x1,
	                    (long *)&face1.x2, (long *)&face1.x3, &p, &flag);

	   	GsSortPoly(&face1, ot_ptr, z_position >> otzshift);

		ot_ptr = &Wotwin1[outbuf_idx];
	}

	return;
}

void PSX_init_splash(OBJ_STRUCT *obj_ptr, int type)
{
	SPLASH_3D				*ptr;
	int						i;

	
	if (COL_surftype != 17)
		printf("Splash! Collision_surface_type = %d\n", COL_surftype);

   S2_sfxdynamic( 16, obj_ptr->p.vx>>8, obj_ptr->p.vz>>8, 0, 127, 4600 );
	switch (type)
	{
		case torpedo_splash:
		case mine_splash:
		{
			ptr = (SPLASH_3D *)init_new_splash_struct();

			if (ptr == NULL)
				return;

			ptr->floor_index = NULLVAL;
			ptr->inner_index = NULLVAL;

			for (i = 0; i < MAX_SPLASH_SEGMENTS; i++)
			{
				SetPolyGT4(&ptr->segs[i]);
				SetSemiTrans(&ptr->segs[i], 1);

				ptr->segs[i].r0 =
				ptr->segs[i].g0 =
				ptr->segs[i].b0 = 255;

				ptr->segs[i].r1 =
				ptr->segs[i].g1 =
				ptr->segs[i].b1 = 0;

				ptr->segs[i].r2 =
				ptr->segs[i].g2 =
				ptr->segs[i].b2 = 255;

				ptr->segs[i].r3 =
				ptr->segs[i].g3 =
				ptr->segs[i].b3 = 0;

				ptr->segs[i].tpage = GetTPage(0, 3, 704, 256);
				ptr->segs[i].clut = GetClut(720, 446);

				ptr->segs[i].u0 = 143;
				ptr->segs[i].v0 = 150;

				ptr->segs[i].u1 = 143;
				ptr->segs[i].v1 = 181;

				ptr->segs[i].u2 = 128;
				ptr->segs[i].v2 = 150;

				ptr->segs[i].u3 = 128;
				ptr->segs[i].v3 = 181;
			}

			ptr->timer = 0;
			ptr->type = type;

			if (obj_ptr->type == OTrocket)
			{
				ptr->inner_radius = 100;
				ptr->outer_radius = 200;
			}
			else
			{
				ptr->inner_radius = abs(obj_ptr->v.vy >> 8);
				ptr->outer_radius = abs(obj_ptr->v.vy >> 8) * 2;
			}

			ptr->height = 0;
			ptr->velocity = 70;

			ptr->direction = UP;
			ptr->no_droplets = 10;

			ptr->origin.vx = obj_ptr->p.vx >> 8;
			ptr->origin.vy = obj_ptr->p.vy >> 8;
			ptr->origin.vz = obj_ptr->p.vz >> 8;

			break;
		}

		case torpedo_exp_splash:
		case mine_exp_splash:
		{
			ptr = (SPLASH_3D *)init_new_splash_struct();

			if (ptr == NULL)
				return;

			init_inner_splash(obj_ptr, ptr);
			init_floor_splash(obj_ptr, ptr);

			for (i = 0; i < MAX_SPLASH_SEGMENTS; i++)
			{
				SetPolyGT4(&ptr->segs[i]);
				SetSemiTrans(&ptr->segs[i], 1);

				ptr->segs[i].r0 =
				ptr->segs[i].g0 =
				ptr->segs[i].b0 = 255;

				ptr->segs[i].r1 =
				ptr->segs[i].g1 =
				ptr->segs[i].b1 = 0;

				ptr->segs[i].r2 =
				ptr->segs[i].g2 =
				ptr->segs[i].b2 = 255;

				ptr->segs[i].r3 =
				ptr->segs[i].g3 =
				ptr->segs[i].b3 = 0;

				ptr->segs[i].tpage = GetTPage(0, 3, 704, 256);
				ptr->segs[i].clut = GetClut(720, 446);

				ptr->segs[i].u0 = 143;
				ptr->segs[i].v0 = 150;

				ptr->segs[i].u1 = 143;
				ptr->segs[i].v1 = 181;

				ptr->segs[i].u2 = 128;
				ptr->segs[i].v2 = 150;

				ptr->segs[i].u3 = 128;
				ptr->segs[i].v3 = 181;
			}

			ptr->timer = 0;
			ptr->type = type;

			ptr->inner_radius = 0;

			ptr->outer_radius = abs(obj_ptr->v.vy >> 8) * 2;

			ptr->height = 0;
			ptr->velocity = 110;

			ptr->direction = UP;
			ptr->no_droplets = 10;

			ptr->origin.vx = obj_ptr->p.vx >> 8;

			if (obj_ptr->type == OTtorpedo)
				ptr->origin.vy = (obj_ptr->p.vy >> 8);// - 100;
			else
				ptr->origin.vy = obj_ptr->p.vy >> 8;

			ptr->origin.vz = obj_ptr->p.vz >> 8;

			break;
		}

		default:
			break;
	}



	return;
}

void init_inner_splash(OBJ_STRUCT *obj_ptr, SPLASH_3D *splash_ptr)
{
	INNER_SPLASH_3D			*ptr;
	int						i;


	ptr = (INNER_SPLASH_3D *)init_new_inner_splash_struct();

	if (ptr == NULL)
		return;

	splash_ptr->inner_index = ptr->index;

	ptr->inner_radius = 0;

	ptr->outer_radius = abs(obj_ptr->v.vy >> 8) * 2;

	ptr->height = 0;
	ptr->velocity = 110;

	ptr->direction = UP;

	ptr->origin.vx = obj_ptr->p.vx >> 8;

	if (obj_ptr->type == OTtorpedo)
		ptr->origin.vy = (obj_ptr->p.vy >> 8);// - 100;
	else
		ptr->origin.vy = obj_ptr->p.vy >> 8;

//	ptr->origin.vy = obj_ptr->p.vx >> 8;
	ptr->origin.vz = obj_ptr->p.vz >> 8;

	for (i = 0; i < MAX_SPLASH_SEGMENTS; i++)
	{
		SetPolyGT4(&ptr->inner_segs[i]);
		SetSemiTrans(&ptr->inner_segs[i], 1);

		ptr->inner_segs[i].r0 =
		ptr->inner_segs[i].g0 =
		ptr->inner_segs[i].b0 = 255;//128;

		ptr->inner_segs[i].r1 =
		ptr->inner_segs[i].g1 =
		ptr->inner_segs[i].b1 = 255;//128;

		ptr->inner_segs[i].r2 =
		ptr->inner_segs[i].g2 =
		ptr->inner_segs[i].b2 = 255;//128;

		ptr->inner_segs[i].r3 =
		ptr->inner_segs[i].g3 =
		ptr->inner_segs[i].b3 = 255;//128;

		ptr->inner_segs[i].tpage = GetTPage(0, 3, 704, 256);
		ptr->inner_segs[i].clut = GetClut(720, 447);

		ptr->inner_segs[i].u0 = 159;
		ptr->inner_segs[i].v0 = 150;

		ptr->inner_segs[i].u1 = 159;
		ptr->inner_segs[i].v1 = 181;

		ptr->inner_segs[i].u2 = 144;
		ptr->inner_segs[i].v2 = 150;

		ptr->inner_segs[i].u3 = 144;
		ptr->inner_segs[i].v3 = 181;
	}

	return;
}

void init_floor_splash(OBJ_STRUCT *obj_ptr, SPLASH_3D *splash_ptr)
{
	FLOOR_SPLASH_3D	 		*ptr;
	int						i;


	ptr = (FLOOR_SPLASH_3D *)init_new_floor_splash_struct();

	if (ptr == NULL)
		return;

	splash_ptr->floor_index = ptr->index;

	ptr->timer = 0;

	ptr->floor_radius = 350;
	ptr->floor_height = 0;
	ptr->floor_direction = UP;

	ptr->origin.vx = obj_ptr->p.vx >> 8;

//	ptr->origin.vy = obj_ptr->p.vx >> 8;

	if (obj_ptr->type == OTtorpedo)
		ptr->origin.vy = (obj_ptr->p.vy >> 8);// - 100;
	else
		ptr->origin.vy = obj_ptr->p.vy >> 8;

	ptr->origin.vz = obj_ptr->p.vz >> 8;

	for (i = 0; i < MAX_SPLASH_FLOOR_SEGMENTS; i++)
	{
		SetPolyGT4(&ptr->floor_segs[i]);
		SetSemiTrans(&ptr->floor_segs[i], 1);

		ptr->floor_segs[i].r0 =
		ptr->floor_segs[i].g0 =
		ptr->floor_segs[i].b0 = 255;

		ptr->floor_segs[i].r1 =
		ptr->floor_segs[i].g1 =
		ptr->floor_segs[i].b1 = 255;

		ptr->floor_segs[i].r2 =
		ptr->floor_segs[i].g2 =
		ptr->floor_segs[i].b2 = 255;

		ptr->floor_segs[i].r3 =
		ptr->floor_segs[i].g3 =
		ptr->floor_segs[i].b3 = 255;

		ptr->floor_segs[i].tpage = GetTPage(0, 3, 704, 256);
		ptr->floor_segs[i].clut = GetClut(752, 446);

		ptr->floor_segs[i].u0 = 239;
		ptr->floor_segs[i].v0 = 94;

		ptr->floor_segs[i].u1 = 239;
		ptr->floor_segs[i].v1 = 125;

		ptr->floor_segs[i].u2 = 224;
		ptr->floor_segs[i].v2 = 94;

		ptr->floor_segs[i].u3 = 224;
		ptr->floor_segs[i].v3 = 125;
	}

	return;
}

void PSX_process_splash(SPLASH_3D *ptr)
{
	SVECTOR			coord[MAX_SPLASH_SEGMENTS * 4];
	SVECTOR			local_position, camera_orientation;
	GsOT			*ot_ptr;
	long			z_position, flag, p;
	int				i, j, angle, angle_inc, display_loop, in_range;
	MATRIX			rot_matrix;


//	ptr->inner_radius += 25;
	ptr->inner_radius += 15;

	ptr->height -= ptr->velocity;

	if (ptr->height > -10)
		return;

	ptr->velocity -= 10;

	if (ptr->velocity <= 0)
		ptr->direction = DOWN;

	angle = 0;
	angle_inc = 4096 / MAX_SPLASH_SEGMENTS;

	for (i = 0; i < MAX_SPLASH_SEGMENTS * 4; i += 4)
	{
		coord[i].vx = (ptr->inner_radius * rsin(angle)) >> 12;
		coord[i].vz = (ptr->inner_radius * rcos(angle)) >> 12;

		coord[i + 1].vx = (ptr->outer_radius * rsin(angle)) >> 12;
		coord[i + 1].vz = (ptr->outer_radius * rcos(angle)) >> 12;

		angle += angle_inc;

		coord[i + 2].vx = (ptr->inner_radius * rsin(angle)) >> 12;
		coord[i + 2].vz = (ptr->inner_radius * rcos(angle)) >> 12;

		coord[i + 3].vx = (ptr->outer_radius * rsin(angle)) >> 12;
		coord[i + 3].vz = (ptr->outer_radius * rcos(angle)) >> 12;

		coord[i].vy = ptr->height;
		coord[i + 2].vy = ptr->height;

		coord[i + 1].vy = 0;
		coord[i + 3].vy = 0;
	}

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_short(&ptr->origin, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;
	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

		local_position.vx = ptr->origin.vx - (CAM_camp[display_loop].vx);
		local_position.vy = ptr->origin.vy - (CAM_camp[display_loop].vy);
		local_position.vz = ptr->origin.vz - (CAM_camp[display_loop].vz);

	    ApplyMatrixSV(&CAM_camm[display_loop], &local_position, &local_position);

//		if (local_position.vz < 0)
//		{
//			ot_ptr = &Wotwin1[outbuf_idx];
//			continue;
//		}

//		CAM_camm[display_loop].t[0] = local_position.vx;
//		CAM_camm[display_loop].t[1] = local_position.vy;
//		CAM_camm[display_loop].t[2] = local_position.vz;

//		rot_val.vx = 0;
//		rot_val.vy -= 88;
//		rot_val.vz = 0;

//	    RotMatrix(&rot_val, &rot_matrix);

//		for (i = 0; i < MAX_SPLASH_SEGMENTS * 4; i++)
//		    ApplyMatrixSV(&rot_matrix, &coord[i], &coord[i]);

//		SetTransMatrix(&CAM_camm[display_loop]);
		SetRotMatrix(&IDENTITY_MATRIX);
		SetTransMatrix(&IDENTITY_MATRIX);
//		SetRotMatrix(&rot_matrix);

		for (i = 0, j = 0; i < MAX_SPLASH_SEGMENTS * 4; i += 4, j++)
//		for (i = 0, j = 0; i <  4; i += 4, j++)
		{
//			if (ptr->direction == DOWN)
//			{
//				ptr->segs[j].r0 =
//				ptr->segs[j].g0 =
//				ptr->segs[j].b0 += 20;

//				ptr->segs[j].r1 =
//				ptr->segs[j].g1 =
//				ptr->segs[j].b1 -= 10;

//				ptr->segs[j].r2 =
//				ptr->segs[j].g2 =
//				ptr->segs[j].b2 += 20;

//				ptr->segs[j].r3 =
//				ptr->segs[j].g3 =
//				ptr->segs[j].b3 -= 10;
//			}
			coord[i].vx += local_position.vx;
			coord[i].vy += local_position.vy;
			coord[i].vz += local_position.vz;

			coord[i + 1].vx += local_position.vx;
			coord[i + 1].vy += local_position.vy;
			coord[i + 1].vz += local_position.vz;

			coord[i + 2].vx += local_position.vx;
			coord[i + 2].vy += local_position.vy;
			coord[i + 2].vz += local_position.vz;

			coord[i + 3].vx += local_position.vx;
			coord[i + 3].vy += local_position.vy;
			coord[i + 3].vz += local_position.vz;

			z_position = RotTransPers4(&coord[i], &coord[i + 1], &coord[i + 2],
            			&coord[i + 3], (long *)&ptr->segs[j].x0, (long *)&ptr->segs[j].x1,
                    	(long *)&ptr->segs[j].x2, (long *)&ptr->segs[j].x3, &p, &flag);

 	      	GsSortPoly(&ptr->segs[j], ot_ptr, z_position >> otzshift);
		}

		ot_ptr = &Wotwin1[outbuf_idx];
	}
/*
	ot_ptr = &Wotwin0[outbuf_idx];

	ptr->segs[0].x0 = -100;
	ptr->segs[0].y0 = -100;

	ptr->segs[0].x1 = 100;
	ptr->segs[0].y1 = -100;

	ptr->segs[0].x2 = -100;
	ptr->segs[0].y2 = 100;

	ptr->segs[0].x3 = 100;
	ptr->segs[0].y3 = 100;

   	GsSortPoly(&ptr->segs[0], ot_ptr, 1);//z_position >> otzshift);
*/
	return;
}

void PSX_process_inner_splash(INNER_SPLASH_3D *ptr)
{
	SVECTOR			coord[MAX_SPLASH_SEGMENTS * 4];
	SVECTOR			local_position, camera_orientation;
	GsOT			*ot_ptr;
	long			z_position, flag, p;
	int				i, j, angle, angle_inc, display_loop, in_range;
	MATRIX			rot_matrix;


//	ptr->timer ++;

//	if (ptr->direction == DOWN)
//		ptr->inner_radius += 25;//ian_val;
		ptr->inner_radius += 15;//ian_val;


//	ian_val -= 5;
//	ptr->outer_radius -= 10;

//	if (ptr->outer_radius <= 0)

//	if (ptr->outer_radius < ptr->inner_radius)
//		ptr->direction = DOWN;

	ptr->height -= ptr->velocity;

	if (ptr->height > -10)
	{
//		ptr->in_use = FALSE;

		return;
	}

	ptr->velocity -= 10;

	if (ptr->velocity <= 0)
		ptr->direction = DOWN;

	angle = 0;
	angle_inc = 4096 / MAX_SPLASH_SEGMENTS;

	for (i = 0; i < MAX_SPLASH_SEGMENTS * 4; i += 4)
	{
		coord[i].vx = (ptr->inner_radius * rsin(angle)) >> 12;
		coord[i].vz = (ptr->inner_radius * rcos(angle)) >> 12;

		coord[i + 1].vx = (ptr->outer_radius * rsin(angle)) >> 12;
		coord[i + 1].vz = (ptr->outer_radius * rcos(angle)) >> 12;

		angle += angle_inc;

		coord[i + 2].vx = (ptr->inner_radius * rsin(angle)) >> 12;
		coord[i + 2].vz = (ptr->inner_radius * rcos(angle)) >> 12;

		coord[i + 3].vx = (ptr->outer_radius * rsin(angle)) >> 12;
		coord[i + 3].vz = (ptr->outer_radius * rcos(angle)) >> 12;

		coord[i].vy = ptr->height;
		coord[i + 2].vy = ptr->height;

		coord[i + 1].vy = 0;
		coord[i + 3].vy = 0;
	}

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_short(&ptr->origin, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

		local_position.vx = ptr->origin.vx - (CAM_camp[display_loop].vx);
		local_position.vy = ptr->origin.vy - (CAM_camp[display_loop].vy);
		local_position.vz = ptr->origin.vz - (CAM_camp[display_loop].vz);

	    ApplyMatrixSV(&CAM_camm[display_loop], &local_position, &local_position);

//		if (local_position.vz < 0)
//		{
//			ot_ptr = &Wotwin1[outbuf_idx];
//			continue;
//		}


//		CAM_camm[display_loop].t[0] = local_position.vx;
//		CAM_camm[display_loop].t[1] = local_position.vy;
//		CAM_camm[display_loop].t[2] = local_position.vz;

//		rot_val.vx = 0;
//		rot_val.vy -= 88;
//		rot_val.vz = 0;

//	    RotMatrix(&rot_val, &rot_matrix);

//		for (i = 0; i < MAX_SPLASH_SEGMENTS * 4; i++)
//		    ApplyMatrixSV(&rot_matrix, &coord[i], &coord[i]);

//		SetTransMatrix(&CAM_camm[display_loop]);
		SetRotMatrix(&IDENTITY_MATRIX);
		SetTransMatrix(&IDENTITY_MATRIX);
//		SetRotMatrix(&rot_matrix);

		for (i = 0, j = 0; i < MAX_SPLASH_SEGMENTS * 4; i += 4, j++)
//		for (i = 0, j = 0; i <  4; i += 4, j++)
		{
//			if (ptr->direction == DOWN)
//			{
				ptr->inner_segs[j].r0 =
				ptr->inner_segs[j].g0 =
				ptr->inner_segs[j].b0 -= 8;

				ptr->inner_segs[j].r1 =
				ptr->inner_segs[j].g1 =
				ptr->inner_segs[j].b1 -= 8;

				ptr->inner_segs[j].r2 =
				ptr->inner_segs[j].g2 =
				ptr->inner_segs[j].b2 -= 8;

				ptr->inner_segs[j].r3 =
				ptr->inner_segs[j].g3 =
				ptr->inner_segs[j].b3 -= 8;
//			}
			coord[i].vx += local_position.vx;
			coord[i].vy += local_position.vy;
			coord[i].vz += local_position.vz;

			coord[i + 1].vx += local_position.vx;
			coord[i + 1].vy += local_position.vy;
			coord[i + 1].vz += local_position.vz;

			coord[i + 2].vx += local_position.vx;
			coord[i + 2].vy += local_position.vy;
			coord[i + 2].vz += local_position.vz;

			coord[i + 3].vx += local_position.vx;
			coord[i + 3].vy += local_position.vy;
			coord[i + 3].vz += local_position.vz;

			z_position = RotTransPers4(&coord[i], &coord[i + 1], &coord[i + 2],
            			&coord[i + 3], (long *)&ptr->inner_segs[j].x0, (long *)&ptr->inner_segs[j].x1,
                    	(long *)&ptr->inner_segs[j].x2, (long *)&ptr->inner_segs[j].x3, &p, &flag);

 	      	GsSortPoly(&ptr->inner_segs[j], ot_ptr, z_position >> otzshift);
		}

		ot_ptr = &Wotwin1[outbuf_idx];
	}
/*
	ot_ptr = &Wotwin0[outbuf_idx];

	ptr->floor_segs[0].x0 = -100;
	ptr->floor_segs[0].y0 = -100;

	ptr->floor_segs[0].x1 = 100;
	ptr->floor_segs[0].y1 = -100;

	ptr->floor_segs[0].x2 = -100;
	ptr->floor_segs[0].y2 = 100;

	ptr->floor_segs[0].x3 = 100;
	ptr->floor_segs[0].y3 = 100;

   	GsSortPoly(&ptr->floor_segs[0], ot_ptr, 1);//z_position >> otzshift);
*/
	return;
}

void PSX_process_distortion(FLOOR_SPLASH_3D *ptr)
{
	int 			i, j, display_loop, z_position, p, flag;
	int				angle, angle_inc, in_range;
	SVECTOR			camera_orientation, local_position;
	SVECTOR			coord[MAX_SPLASH_FLOOR_SEGMENTS * 4];
	GsOT			*ot_ptr;


	ptr->timer++;

	if (ptr->floor_direction == UP)
		ptr->floor_height -= 10;
	else
	{
		ptr->floor_height += 2;
//		ptr->floor_radius += 20;
		ptr->floor_radius += 10;
	}

	if (ptr->timer == 10)
		ptr->floor_direction = DOWN;

	angle = 0;
	angle_inc = 4096 / MAX_SPLASH_FLOOR_SEGMENTS;

	for (i = 0; i < MAX_SPLASH_FLOOR_SEGMENTS * 4; i += 4)
	{
		coord[i].vx = 0;
		coord[i].vz = 0;

		coord[i + 1].vx = (ptr->floor_radius * rsin(angle)) >> 12;
		coord[i + 1].vz = (ptr->floor_radius * rcos(angle)) >> 12;

		angle += angle_inc;

		coord[i + 2].vx = 0;
		coord[i + 2].vz = 0;

		coord[i + 3].vx = (ptr->floor_radius * rsin(angle)) >> 12;
		coord[i + 3].vz = (ptr->floor_radius * rcos(angle)) >> 12;

		coord[i].vy = ptr->floor_height;
		coord[i + 2].vy = ptr->floor_height;

		coord[i + 1].vy = 0;
		coord[i + 3].vy = 0;
	}

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_short(&ptr->origin, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

		local_position.vx = ptr->origin.vx - (CAM_camp[display_loop].vx);
		local_position.vy = ptr->origin.vy - (CAM_camp[display_loop].vy);
		local_position.vz = ptr->origin.vz - (CAM_camp[display_loop].vz);

 //	    ApplyMatrixSV(&CAM_camm[display_loop], &local_position, &local_position);

//		if (local_position.vz < 0)
//		{
//			ot_ptr = &Wotwin1[outbuf_idx];
//			continue;
//		}


//		CAM_camm[display_loop].t[0] = local_position.vx;
//		CAM_camm[display_loop].t[1] = local_position.vy;
//		CAM_camm[display_loop].t[2] = local_position.vz;

//		SetTransMatrix(&CAM_camm[display_loop]);
		for (i = 0, j = 0; i < MAX_SPLASH_FLOOR_SEGMENTS * 4; i += 4, j++)
		{
			if (ptr->timer >= 30)
			{
				ptr->floor_segs[j].r1 -= 24;
				ptr->floor_segs[j].g1 -= 24;
				ptr->floor_segs[j].b1 -= 24;

				ptr->floor_segs[j].r3 -= 24;
				ptr->floor_segs[j].g3 -= 24;
				ptr->floor_segs[j].b3 -= 24;

				ptr->floor_segs[j].r0 -= 24;
				ptr->floor_segs[j].g0 -= 24;
				ptr->floor_segs[j].b0 -= 24;

				ptr->floor_segs[j].r2 -= 24;
				ptr->floor_segs[j].g2 -= 24;
				ptr->floor_segs[j].b2 -= 24;
			}

			coord[i].vx += local_position.vx;
			coord[i].vy += local_position.vy;
			coord[i].vz += local_position.vz;

			coord[i + 1].vx += local_position.vx;
			coord[i + 1].vy += local_position.vy;
			coord[i + 1].vz += local_position.vz;

			coord[i + 2].vx += local_position.vx;
			coord[i + 2].vy += local_position.vy;
			coord[i + 2].vz += local_position.vz;

			coord[i + 3].vx += local_position.vx;
			coord[i + 3].vy += local_position.vy;
			coord[i + 3].vz += local_position.vz;

    		ApplyMatrixSV(&CAM_camm[display_loop], &coord[i], &coord[i]);
    		ApplyMatrixSV(&CAM_camm[display_loop], &coord[i + 1], &coord[i + 1]);
    		ApplyMatrixSV(&CAM_camm[display_loop], &coord[i + 2], &coord[i + 2]);
    		ApplyMatrixSV(&CAM_camm[display_loop], &coord[i + 3], &coord[i + 3]);
				
			SetRotMatrix(&IDENTITY_MATRIX);
			SetTransMatrix(&IDENTITY_MATRIX);

			z_position = RotTransPers4(&coord[i], &coord[i + 1], &coord[i + 2],
            			&coord[i + 3], (long *)&ptr->floor_segs[j].x0, (long *)&ptr->floor_segs[j].x1,
                    	(long *)&ptr->floor_segs[j].x2, (long *)&ptr->floor_segs[j].x3, &p, &flag);

 	      	GsSortPoly(&ptr->floor_segs[j], ot_ptr, z_position >> otzshift);
		}

		ot_ptr = &Wotwin1[outbuf_idx];
	}

	return;
}

void PSX_init_droplet(SPLASH_3D *ptr, int type)
{
	DROPLET_STRUCT			*drop_ptr;

	drop_ptr = (DROPLET_STRUCT *)init_new_droplet_struct();

	if (drop_ptr == NULL)
		return;

	drop_ptr->position.vx = ptr->origin.vx;
	drop_ptr->position.vy = ptr->origin.vy;
	drop_ptr->position.vz = ptr->origin.vz;

	drop_ptr->floor_height = ptr->origin.vy;

	drop_ptr->velocity.vx = SDRAND(100) - 50;
	drop_ptr->velocity.vy = -(SDRAND(75) + 50);
	drop_ptr->velocity.vz = SDRAND(100) - 50;

	drop_ptr->length = SDRAND(10) + 10;

	SetPolyFT4(&drop_ptr->face);
//	SetSemiTrans(&drop_ptr->face, 1);

	switch (type)
	{
		case water:
		{
			SetSemiTrans(&drop_ptr->face, 1);

			drop_ptr->face.r0 = 128;
			drop_ptr->face.g0 = 128;
			drop_ptr->face.b0 = 128;

			drop_ptr->face.tpage = GetTPage(0, 1, 704, 256);
			drop_ptr->face.clut = GetClut(736, 446);

			drop_ptr->face.u0 = 128;
			drop_ptr->face.v0 = 126;

			drop_ptr->face.u1 = 135;
			drop_ptr->face.v1 = 126;

			drop_ptr->face.u2 = 128;
			drop_ptr->face.v2 = 133;

			drop_ptr->face.u3 = 135;
			drop_ptr->face.v3 = 133;

			break;
		}

		case fragment:
		{
			drop_ptr->face.r0 = 32;
			drop_ptr->face.g0 = 32;
			drop_ptr->face.b0 = 32;

			drop_ptr->face.tpage = GetTPage(0, 0, 704, 256);
			drop_ptr->face.clut = GetClut(704, 471);

			drop_ptr->face.u0 = 128;
			drop_ptr->face.v0 = 134;

			drop_ptr->face.u1 = 135;
			drop_ptr->face.v1 = 134;

			drop_ptr->face.u2 = 128;
			drop_ptr->face.v2 = 149;

			drop_ptr->face.u3 = 135;
			drop_ptr->face.v3 = 149;

			break;
		}

		default:
			break;
	}

	return;
}

void PSX_process_droplet(DROPLET_STRUCT *ptr)
{
	long				display_loop, z_position, p, flag, in_range;
	GsOT	 			*ot_ptr;
	SVECTOR	 			camera_orientation, local_position;
	SVECTOR				coord[4];


	ptr->velocity.vy += 8;

	ptr->position.vx += ptr->velocity.vx;
	ptr->position.vy += ptr->velocity.vy;
	ptr->position.vz += ptr->velocity.vz;

	if (ptr->position.vy >= ptr->floor_height)
	{
		PSX_init_ripple(ptr);
//		PSX_init_ripple(ptr);
//		PSX_init_ripple(ptr);

		ptr->in_use = FALSE;

		return;
	}

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_short(&ptr->position, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

		local_position.vx = ptr->position.vx - (CAM_camp[display_loop].vx);
		local_position.vy = ptr->position.vy - (CAM_camp[display_loop].vy);
		local_position.vz = ptr->position.vz - (CAM_camp[display_loop].vz);

	    ApplyMatrixSV(&CAM_camm[display_loop], &local_position, &local_position);

//		if (local_position.vz < 0)
//		{
//			ot_ptr = &Wotwin1[outbuf_idx];
//			continue;
//		}


		SetTransMatrix(&IDENTITY_MATRIX);
		SetRotMatrix(&IDENTITY_MATRIX);

		coord[0].vx = local_position.vx - ptr->length;
		coord[0].vy = local_position.vy - ptr->length;
		coord[0].vz = local_position.vz;

		coord[1].vx = local_position.vx + ptr->length;
		coord[1].vy = local_position.vy - ptr->length;
		coord[1].vz = local_position.vz;

		coord[2].vx = local_position.vx - ptr->length;
		coord[2].vy = local_position.vy + ptr->length;
		coord[2].vz = local_position.vz;

		coord[3].vx = local_position.vx + ptr->length;
		coord[3].vy = local_position.vy + ptr->length;
		coord[3].vz = local_position.vz;

		z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
        			&coord[3], (long *)&ptr->face.x0, (long *)&ptr->face.x1,
                	(long *)&ptr->face.x2, (long *)&ptr->face.x3, &p, &flag);

      	GsSortPoly(&ptr->face, ot_ptr, z_position >> otzshift);

		ot_ptr = &Wotwin1[outbuf_idx];
	}

	return;
}

void PSX_init_ripple(DROPLET_STRUCT *ptr)
{
	RIPPLE_STRUCT			*rip_ptr;

	rip_ptr = (RIPPLE_STRUCT *)init_new_ripple_struct();

	if (rip_ptr == NULL)
		return;

	rip_ptr->position.vx = ptr->position.vx;
	rip_ptr->position.vy = ptr->position.vy;
	rip_ptr->position.vz = ptr->position.vz;

//	rip_ptr->position.vx += SDRAND(50) - 25;
//	rip_ptr->position.vz += SDRAND(50) - 25;

	rip_ptr->length = 0;
	rip_ptr->length_inc = ptr->length / 4;
	rip_ptr->timer = 0;

	SetPolyFT4(&rip_ptr->face);
	SetSemiTrans(&rip_ptr->face, 1);

	rip_ptr->face.r0 = 75;
	rip_ptr->face.g0 = 75;
	rip_ptr->face.b0 = 75;

	rip_ptr->face.tpage = GetTPage(0, 1, 704, 256);
/*	rip_ptr->face.clut = GetClut(736, 446);

	rip_ptr->face.u0 = 128;
	rip_ptr->face.v0 = 126;

	rip_ptr->face.u1 = 135;
	rip_ptr->face.v1 = 126;

	rip_ptr->face.u2 = 128;
	rip_ptr->face.v2 = 133;

	rip_ptr->face.u3 = 135;
	rip_ptr->face.v3 = 133;
*/
	rip_ptr->face.clut = GetClut(704, 473);

	rip_ptr->face.u0 = 96;
	rip_ptr->face.v0 = 94;

	rip_ptr->face.u1 = 127;
	rip_ptr->face.v1 = 94;

	rip_ptr->face.u2 = 96;
	rip_ptr->face.v2 = 125;

	rip_ptr->face.u3 = 127;
	rip_ptr->face.v3 = 125;

	return;
}

void PSX_process_ripple(RIPPLE_STRUCT *ptr)
{
	long				display_loop, z_position, p, flag, in_range;
	GsOT	 			*ot_ptr;
	SVECTOR	 			camera_orientation, local_position;
	SVECTOR				coord[4];


	ptr->timer ++;

	if (ptr->timer == 35)
	{
		ptr->in_use = FALSE;

		return;
	}

	ptr->face.r0 =
	ptr->face.g0 =
	ptr->face.b0 -= 2;

	ptr->length += ptr->length_inc;
	ptr->length_inc -= ptr->length_inc / 5;

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
 	{
		in_range = clip_point_short(&ptr->position, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

		local_position.vx = ptr->position.vx - (CAM_camp[display_loop].vx);
		local_position.vy = ptr->position.vy - (CAM_camp[display_loop].vy);
		local_position.vz = ptr->position.vz - (CAM_camp[display_loop].vz);

	    ApplyMatrixSV(&CAM_camm[display_loop], &local_position, &local_position);

//		if (local_position.vz < 0)
//		{
//			ot_ptr = &Wotwin1[outbuf_idx];
//			continue;
//		}


		coord[0].vx = local_position.vx - ptr->length;
		coord[0].vy = local_position.vy;
		coord[0].vz = local_position.vz + ptr->length;

		coord[1].vx = local_position.vx + ptr->length;
		coord[1].vy = local_position.vy;
		coord[1].vz = local_position.vz + ptr->length;

		coord[2].vx = local_position.vx - ptr->length;
		coord[2].vy = local_position.vy;
		coord[2].vz = local_position.vz - ptr->length;

		coord[3].vx = local_position.vx + ptr->length;
		coord[3].vy = local_position.vy;
		coord[3].vz = local_position.vz - ptr->length;

		SetTransMatrix(&IDENTITY_MATRIX);
		SetRotMatrix(&IDENTITY_MATRIX);

		z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
        			&coord[3], (long *)&ptr->face.x0, (long *)&ptr->face.x1,
                	(long *)&ptr->face.x2, (long *)&ptr->face.x3, &p, &flag);

      	GsSortPoly(&ptr->face, ot_ptr, z_position >> otzshift);

		ot_ptr = &Wotwin1[outbuf_idx];
	}

	return;
}
/*
void screen_flash(u8 r, u8 g, u8 b, u8 timer)
{
	POLY_F4			face;


	SetPolyF4(&face);
	SetSemiTrans(&face, 1);

/*
	face.tpage = GetTPage(0, 3, 704, 256);
	face.clut = GetClut(704, 461);

	face.u0 = 10;
	face.v0 = 205;

	face.u1 = 10;
	face.v1 = 205;

	face.u2 = 10;
	face.v2 = 205;

	face.u3 = 10;
	face.v3 = 205;
*/
/*	face.x0 = -320;
	face.y0 = -128;

	face.x1 = 320;
	face.y1 = -128;

	face.x2 = -320;
	face.y2 = 128;

	face.x3 = 320;
	face.y3 = 128;

	face.r0 = r / timer;
	face.g0 = g / timer;
	face.b0 = b / timer;

	GsSortPoly(&face, ptrwot, 0);

	return;
}
/*
void PSX_init_torpedo_wake(OBJ_STRUCT *obj_ptr)
{
	WAKE_STRUCT			*ptr;
	int					i;

	 return;
	ptr = (WAKE_STRUCT *)init_new_torpedo_wake_struct();

	if (ptr == NULL)
		return;

	for (i = 0; i < 6; i++)
	{
		ptr->trail[i].vx = 0;
		ptr->trail[i].vy = 0;
		ptr->trail[i].vz = 0;
	}

	ptr->no_segs = 0;
	ptr->timer = 0;

	obj_ptr->fx_id = ptr->index;

	return;
}

void PSX_process_wake(WAKE_STRUCT *ptr, OBJ_STRUCT *obj_ptr)
{
	POLY_FT3				tri_face;
	POLY_FT4				quad_face;
	SVECTOR					local_position, camera_orientation;
	GsOT					*ot_ptr;
	SVECTOR					coord[4];
	long					i, j, z_position, p, flag, display_loop;
	int						width, x_offset;

	return;
	SetPolyFT4(&quad_face);
	SetSemiTrans(&quad_face, 1);

    quad_face.r0 = 192;//32;
    quad_face.g0 = 192;//32;
    quad_face.b0 = 192;//128;

    quad_face.tpage = GetTPage(1, 1, 704, 256);
	quad_face.clut = GetClut(768, 375);

    quad_face.v0 = 94;
    quad_face.v1 = 125;
    quad_face.v2 = 94;
    quad_face.v3 = 125;

    quad_face.u0 = 31;
    quad_face.u1 = 31;
    quad_face.u2 = 16;
    quad_face.u3 = 16;

	SetPolyFT4(&tri_face);
	SetSemiTrans(&tri_face, 1);

    tri_face.r0 = 192;//32;
    tri_face.g0 = 192;//32;
    tri_face.b0 = 192;//128;

    tri_face.tpage = GetTPage(1, 1, 704, 256);
	tri_face.clut = GetClut(768, 375);

    tri_face.v0 = 94;
    tri_face.v1 = 125;
    tri_face.v2 = 94;

    tri_face.u0 = 31;
    tri_face.u1 = 31;
    tri_face.u2 = 16;

	if (!(ptr->timer % 1))
	{
		for (i = ptr->no_segs; i > 0; i--)
		{
			ptr->trail[i].vx = ptr->trail[i - 1].vx;
			ptr->trail[i].vy = ptr->trail[i - 1].vy;
			ptr->trail[i].vz = ptr->trail[i - 1].vz;
		}
	}

	ptr->trail[0].vx = obj_ptr->p.vx;
	ptr->trail[0].vy = -250;//obj_ptr->p.vy;
	ptr->trail[0].vz = obj_ptr->p.vz;

	ptr->timer ++;

	if (ptr->no_segs < 5)
		ptr->no_segs++;

	width = 30;

	x_offset = 0;

	if (ptr->no_segs > 1)
	{
		ot_ptr = &Wotwin0[outbuf_idx];

		for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
		{
			camera_orientation.vx = CAM_came[display_loop].vx >> 4;
			camera_orientation.vy = CAM_came[display_loop].vy >> 4;
			camera_orientation.vz = CAM_came[display_loop].vz >> 4;

			for (j = 0; j < 2; j++)
			{
				for (i = 1; i < ptr->no_segs - 2; i++)
				{
					local_position.vx = ptr->trail[i].vx - CAM_camp[display_loop].vx;
					local_position.vy = ptr->trail[i].vy - CAM_camp[display_loop].vy;
					local_position.vz = ptr->trail[i].vz - CAM_camp[display_loop].vz;

				    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);
			    	ApplyMatrixSV(&CAM_camm[display_loop], &local_position, &local_position);

					coord[0].vx = local_position.vx - width - x_offset;
					coord[0].vy = local_position.vy;
					coord[0].vz = local_position.vz;

					coord[1].vx = local_position.vx + width - x_offset;
					coord[1].vy = local_position.vy;
					coord[1].vz = local_position.vz;

					local_position.vx = ptr->trail[i + 1].vx - CAM_camp[display_loop].vx;
					local_position.vy = ptr->trail[i + 1].vy - CAM_camp[display_loop].vy;
					local_position.vz = ptr->trail[i + 1].vz - CAM_camp[display_loop].vz;

				    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);
			    	ApplyMatrixSV(&CAM_camm[display_loop], &local_position, &local_position);

					width -= 10;

					if (j == 0)
						x_offset -= 25;
					else
						x_offset += 25;

					coord[2].vx = local_position.vx - width - x_offset;
					coord[2].vy = local_position.vy;
					coord[2].vz = local_position.vz;

					coord[3].vx = local_position.vx + width - x_offset;
					coord[3].vy = local_position.vy;
					coord[3].vz = local_position.vz;

					SetTransMatrix(&IDENTITY_MATRIX);
					SetRotMatrix(&IDENTITY_MATRIX);

				    z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
		        		            &coord[3], (long *)&quad_face.x0, (long *)&quad_face.x1,
		                		    (long *)&quad_face.x2, (long *)&quad_face.x3, &p, &flag);

				   	GsSortPoly(&quad_face, ot_ptr, z_position >> otzshift);
				}

				x_offset = 0;
				width = 30;
			}

			ot_ptr = &Wotwin1[outbuf_idx];
		}
	}

	return;
}
*/
void PSX_process_tracer(OBJ_STRUCT *obj_ptr)
{
	POLY_FT4				face;
	SVECTOR					coord[4], cam_rot, local, rot_vec;
	int						i, height, length, weapon_level;
	long					z_position, p, flag, display_loop;
	char					in_range;
	MATRIX					cam_matrix, rot_matrix;
	GsOT					*ot_ptr;


	weapon_level = OBJ_players[obj_ptr->owner].weapon_level;

    SetPolyFT4(&face);
    SetSemiTrans(&face, 1);

    face.r0 = 255;
    face.g0 = 32;
    face.b0 = 16;

    face.tpage = GetTPage(0, 1, 704, 256);
    face.clut = GetClut(736, 447);

    face.u0 = 144;
    face.v0 = 134;

    face.u1 = 151;
    face.v1 = 134;

    face.u2 = 144;
    face.v2 = 149;

    face.u3 = 151;
    face.v3 = 149;

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_long(&obj_ptr->p, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		local.vx = (obj_ptr->p.vx >> 8) - CAM_camp[CAM_c].vx;
		local.vy = (obj_ptr->p.vy >> 8) - CAM_camp[CAM_c].vy;
		local.vz = (obj_ptr->p.vz >> 8) - CAM_camp[CAM_c].vz;

		cam_rot.vx = CAM_came[CAM_c].vx >> 4;
		cam_rot.vy = CAM_came[CAM_c].vy >> 4;
		cam_rot.vz = CAM_came[CAM_c].vz >> 4;

		RotMatrix(&cam_rot, &cam_matrix);

		length = power_up_table[weapon_level][tracer_size] * 100;
		height = power_up_table[weapon_level][tracer_size] * 5;

		coord[0].vx = -height;
		coord[0].vy = 0;
		coord[0].vz = 3 * length;

		coord[1].vx = height;
		coord[1].vy = 0;
		coord[1].vz = 3 * length;

		coord[2].vx = -height / 2;
		coord[2].vy = 0;
		coord[2].vz = 0;

		coord[3].vx = height / 2;
		coord[3].vy = 0;
		coord[3].vz = 0;

		rot_vec.vx = obj_ptr->r.vx >> 4;
		rot_vec.vy = obj_ptr->r.vy >> 4;
		rot_vec.vz = obj_ptr->r.vz >> 4;

		RotMatrix(&rot_vec, &rot_matrix);

		for (i = 0; i < 4; i++)
		{
			ApplyMatrixSV(&rot_matrix, &coord[i], &coord[i]);

			coord[i].vx += local.vx;
			coord[i].vy += local.vy;
			coord[i].vz += local.vz;

			ApplyMatrixSV(&cam_matrix, &coord[i], &coord[i]);
		}

		SetTransMatrix(&IDENTITY_MATRIX);
		SetRotMatrix(&IDENTITY_MATRIX);

	    z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
	                    &coord[3], (long *)&face.x0, (long *)&face.x1,
	                    (long *)&face.x2, (long *)&face.x3, &p, &flag);

	   	GsSortPoly(&face, ptrwot, z_position >> otzshift);

		ot_ptr = &Wotwin1[outbuf_idx];
	}

	return;
}

s32 PSX_init_rocket_trail(OBJ_STRUCT *obj_ptr)
{
	TRAIL_STRUCT		*ptr;
	int					i;


	ptr = init_trail_struct(obj_ptr);

	if (ptr == NULL)
		return NULLVAL;

	for (i = 0; i < 4; i++)
	{
		SetPolyFT4(&ptr->trail[i]);
		SetSemiTrans(&ptr->trail[i], 1);

	    ptr->trail[i].r0 = 96;//64;//192;//32;
	    ptr->trail[i].g0 = 96;//64;//192;//32;
	    ptr->trail[i].b0 = 96;//64;//192;//128;

	    ptr->trail[i].tpage = GetTPage(1, 3, 704, 256);
	    ptr->trail[i].clut = GetClut(768, 375);

	    ptr->trail[i].v0 = 94;
	    ptr->trail[i].v1 = 125;
	    ptr->trail[i].v2 = 94;
	    ptr->trail[i].v3 = 125;

	    ptr->trail[i].u0 = 31;
	    ptr->trail[i].u1 = 31;
	    ptr->trail[i].u2 = 16;
	    ptr->trail[i].u3 = 16;

		ptr->coord[i].vx = 0;
		ptr->coord[i].vy = 0;
		ptr->coord[i].vz = 0;
	}

	for (i = 0; i < 5; i++)
	{
		ptr->coord[i].vx = 0;
		ptr->coord[i].vy = 0;
		ptr->coord[i].vz = 0;
	}

	ptr->no_segs = 0;
	ptr->timer = 0;

//	obj_ptr->fx_id = ptr->index;

	return ptr->index;
}

void PSX_process_rocket_trail(OBJ_STRUCT *obj_ptr)
{
	TRAIL_STRUCT		*ptr;
	POLY_FT4			face;
	SVECTOR				coord[10], camera_orientation;
	long				i, j, k, p, flag, z_position, width, x_width, y_width;
	long				display_loop, in_range, first_screen, screen_1;
	GsOT				*ot_ptr;
	vec16				cam_origin, object_orientation;
	MATRIX				object_mtx;


	SetPolyFT4(&face);
	SetSemiTrans(&face, 1);

	face.tpage = GetTPage(0, 1, 704, 256);
	face.clut = GetClut(704, 449);
/*
	face.r0 = 24;
	face.g0 = 24;
	face.b0 = 128;
*/
	face.r0 = thr_r[OBJ_players[obj_ptr->owner].crafttype];
	face.g0 = thr_g[OBJ_players[obj_ptr->owner].crafttype];
	face.b0 = thr_b[OBJ_players[obj_ptr->owner].crafttype];

	face.u0 = 64;
	face.v0 = 126;

	face.u1 = 127;
	face.v1 = 126;

	face.u2 = 64;
	face.v2 = 189;

	face.u3 = 127;
	face.v3 = 189;

	width = 70;

	ot_ptr = &Wotwin0[outbuf_idx];

	object_orientation.vx = obj_ptr->r.vx >> 4;
	object_orientation.vy = obj_ptr->r.vy >> 4;
	object_orientation.vz = obj_ptr->r.vz >> 4;

    RotMatrix(&object_orientation, &object_mtx);

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_long(&obj_ptr->p, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

		cam_origin.vx = (obj_ptr->p.vx >> 8) - CAM_camp[display_loop].vx;
		cam_origin.vy = (obj_ptr->p.vy >> 8) - CAM_camp[display_loop].vy;
		cam_origin.vz = (obj_ptr->p.vz >> 8) - CAM_camp[display_loop].vz;

    	ApplyMatrixSV(&CAM_camm[display_loop], &cam_origin, &cam_origin);

		for (i = 0; i < 4; i++)
		{
		    coord[i].vx = cam_origin.vx;
		    coord[i].vy = cam_origin.vy;
		    coord[i].vz = cam_origin.vz;
		}

		coord[0].vx -= width;
		coord[0].vy -= width;

		coord[1].vx += width;
		coord[1].vy -= width;

		coord[2].vx -= width;
		coord[2].vy += width;

		coord[3].vx += width;
		coord[3].vy += width;

		SetTransMatrix(&IDENTITY_MATRIX);
		SetRotMatrix(&IDENTITY_MATRIX);

	    z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
	                    &coord[3], (long *)&face.x0, (long *)&face.x1,
	                    (long *)&face.x2, (long *)&face.x3, &p, &flag);

	   	GsSortPoly(&face, ot_ptr, z_position >> otzshift);

		ot_ptr = &Wotwin1[outbuf_idx];
	}

//Trail Section

	if (obj_ptr->fx_id != NULLVAL)
		ptr = &PSX_rocket_trail[obj_ptr->fx_id];
	else
		return;

	for (i = 4; i > 0; i--)
	{
		ptr->coord[i].vx = ptr->coord[i - 1].vx;
		ptr->coord[i].vy = ptr->coord[i - 1].vy;
		ptr->coord[i].vz = ptr->coord[i - 1].vz;
	}

	ptr->coord[0].vx = obj_ptr->p.vx >> 8;
	ptr->coord[0].vy = obj_ptr->p.vy >> 8;
	ptr->coord[0].vz = obj_ptr->p.vz >> 8;

	if (ptr->no_segs > 0)
	{
		ot_ptr = &Wotwin0[outbuf_idx];

		for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
		{
//			width = 80;

			camera_orientation.vx = CAM_came[display_loop].vx >> 4;
			camera_orientation.vy = CAM_came[display_loop].vy >> 4;
			camera_orientation.vz = CAM_came[display_loop].vz >> 4;

		    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

			for (i = 0; i < 2; i++)
			{
				for (j = 0, k = 2; j < ptr->no_segs; k += 2, j++)
				{
					if (j == 0)
					{
						cam_origin.vx = ptr->coord[0].vx - CAM_camp[display_loop].vx;
						cam_origin.vy = ptr->coord[0].vy - CAM_camp[display_loop].vy;
						cam_origin.vz = ptr->coord[0].vz - CAM_camp[display_loop].vz;

		//				ApplyMatrixSV(&CAM_camm[display_loop], &cam_origin, &cam_origin);

						if (i == 0)
						{
							x_width = 80;
							y_width = 0;
						}
						else
						{
							x_width = 0;
							y_width = 80;
						}

						coord[0].vx = -x_width;
						coord[0].vy = -y_width;
						coord[0].vz = 0;

						coord[1].vx = x_width;
						coord[1].vy = y_width;
						coord[1].vz = 0;

						ApplyMatrixSV(&object_mtx, &coord[0], &coord[0]);
						ApplyMatrixSV(&object_mtx, &coord[1], &coord[1]);

						coord[0].vx += cam_origin.vx;
						coord[0].vy += cam_origin.vy;
						coord[0].vz += cam_origin.vz;

						coord[1].vx += cam_origin.vx;
						coord[1].vy += cam_origin.vy;
						coord[1].vz += cam_origin.vz;

						ApplyMatrixSV(&CAM_camm[display_loop], &coord[0], &coord[0]);
						ApplyMatrixSV(&CAM_camm[display_loop], &coord[1], &coord[1]);
					}

					cam_origin.vx = ptr->coord[j].vx - CAM_camp[display_loop].vx;
					cam_origin.vy = ptr->coord[j].vy - CAM_camp[display_loop].vy;
					cam_origin.vz = ptr->coord[j].vz - CAM_camp[display_loop].vz;

//					ApplyMatrixSV(&CAM_camm[display_loop], &cam_origin, &cam_origin);

					if (i == 0)
					{
						x_width -= 20;
						y_width = 0;
					}
					else
					{
						x_width = 0;
						y_width -= 20;
					}

					coord[k].vx = -x_width;
					coord[k].vy = -y_width;
					coord[k].vz = 0;

					coord[k + 1].vx = x_width;
					coord[k + 1].vy = y_width;
					coord[k + 1].vz = 0;

					ApplyMatrixSV(&object_mtx, &coord[k], &coord[k]);
					ApplyMatrixSV(&object_mtx, &coord[k + 1], &coord[k + 1]);

					coord[k].vx += cam_origin.vx;
					coord[k].vy += cam_origin.vy;
					coord[k].vz += cam_origin.vz;

					coord[k + 1].vx += cam_origin.vx;
					coord[k + 1].vy += cam_origin.vy;
					coord[k + 1].vz += cam_origin.vz;

					ApplyMatrixSV(&CAM_camm[display_loop], &coord[k], &coord[k]);
					ApplyMatrixSV(&CAM_camm[display_loop], &coord[k + 1], &coord[k + 1]);

					SetTransMatrix(&IDENTITY_MATRIX);
					SetRotMatrix(&IDENTITY_MATRIX);
//					SetRotMatrix(&CAM_camm[display_loop]);

				    z_position = RotTransPers4(&coord[k - 2], &coord[k - 1], &coord[k],
		        		            &coord[k + 1], (long *)&ptr->trail[j].x0, (long *)&ptr->trail[j].x1,
		                		    (long *)&ptr->trail[j].x2, (long *)&ptr->trail[j].x3, &p, &flag);

				   	GsSortPoly(&ptr->trail[j], ot_ptr, z_position >> otzshift);

				}
			}

			ot_ptr = &Wotwin1[outbuf_idx];
		}
	}

	ptr->timer ++;

	if (ptr->no_segs < 4)
		ptr->no_segs++;

	return;
}
/*
void PSX_init_lens_flare(void)
{
//	LENS_FLARE			*ptr;
//	int					i;


//	for (i = 0; i < MAX_LENS_FLARES; i++)
//	{
//		ptr = &flare[i];

//		ptr->type = lens_flare_table[i][0];
//		ptr->loc = lens_flare_table[i][1];
//		ptr->scale = lens_flare_table[i][2];

//		ptr->r = lens_flare_table[i][3];
//		ptr->b = lens_flare_table[i][4];
//		ptr->g = lens_flare_table[i][5];
//	}

	return;

/*	LENS_FLARE		*ptr;
	int				i;


	ptr = &screen_lens_flare;

//Rainbow flare, appears at front and back of effect

	for (i = 0; i < 2; i++)
	{
		ptr->faces[i].r0 = 128;
		ptr->faces[i].g0 = 128;
		ptr->faces[i].b0 = 128;

		ptr->faces[i].tpage = GetTPage(0, 1, 704, 256);
		ptr->faces[i].clut = GetClut(704, 446);

		ptr->faces[i].u0 = 0;
		ptr->faces[i].v0 = 126;

		ptr->faces[i].u1 = 63;
		ptr->faces[i].v1 = 126;

		ptr->faces[i].u2 = 0;
		ptr->faces[i].v2 = 189;

		ptr->faces[i].u3 = 63;
		ptr->faces[i].v3 = 189;
	}

//Solid flare, most common - flat

	for (i = 0; i < 7; i++)
	{
		ptr->faces[i].r0 = 128;
		ptr->faces[i].g0 = 64;
		ptr->faces[i].b0 = 32;

		ptr->faces[i].tpage = GetTPage(0, 1, 704, 256);
		ptr->faces[i].clut = GetClut(704, 448);

		ptr->faces[i].u0 = 160;
		ptr->faces[i].v0 = 144;

		ptr->faces[i].u1 = 199;
		ptr->faces[i].v1 = 144;

		ptr->faces[i].u2 = 160;
		ptr->faces[i].v2 = 175;

		ptr->faces[i].u3 = 199;
		ptr->faces[i].v3 = 175;
	}

//Flare that diminishes towards it's centre

	for (i = 0; i < 3; i++)
	{
		ptr->faces[i].r0 = 128;
		ptr->faces[i].g0 = 64;
		ptr->faces[i].b0 = 32;

		ptr->faces[i].tpage = GetTPage(0, 1, 704, 256);
		ptr->faces[i].clut = GetClut(704, 448);

		ptr->faces[i].u0 = 160;
		ptr->faces[i].v0 = 94;

		ptr->faces[i].u1 = 204;
		ptr->faces[i].v1 = 94;

		ptr->faces[i].u2 = 160;
		ptr->faces[i].v2 = 124;

		ptr->faces[i].u3 = 204;
		ptr->faces[i].v3 = 124;
	}

//Tiny flare

	for (i = 0; i < 2; i++)
	{
		ptr->faces[i].r0 = 128;
		ptr->faces[i].g0 = 64;
		ptr->faces[i].b0 = 32;

		ptr->faces[i].tpage = GetTPage(0, 1, 704, 256);
		ptr->faces[i].clut = GetClut(704, 448);

		ptr->faces[i].u0 = 184;
		ptr->faces[i].v0 = 94;

		ptr->faces[i].u1 = 199;
		ptr->faces[i].v1 = 94;

		ptr->faces[i].u2 = 184;
		ptr->faces[i].v2 = 109;

		ptr->faces[i].u3 = 199;
		ptr->faces[i].v3 = 109;
	}

//Light Source

	ptr->faces[i].r0 = 255;
	ptr->faces[i].g0 = 255;
	ptr->faces[i].b0 = 128;

	ptr->faces[i].tpage = GetTPage(0, 1, 704, 256);
	ptr->faces[i].clut = GetClut(704, 449);

	ptr->faces[i].u0 = 64;
	ptr->faces[i].v0 = 126;

	ptr->faces[i].u1 = 123;
	ptr->faces[i].v1 = 126;

	ptr->faces[i].u2 = 64;
	ptr->faces[i].v2 = 189;

	ptr->faces[i].u3 = 123;
	ptr->faces[i].v3 = 189;

	ptr->origin.vx = 0;//-32768;
	ptr->origin.vy = -100;
	ptr->origin.vz = 1000;//-32768;

	for (i = 0; i < MAX_LENS_FLARES; i++)
	{
		SetPolyFT4(&ptr->faces[i]);
		SetSemiTrans(&ptr->faces[i], 1);

		ptr->flares[i].index = i;
	}

	ptr->flares[0].type = 5;
	ptr->flares[0].radius = 50;
	ptr->flares[0].offset = -1;

	ptr->flares[1].type = 1;
	ptr->flares[1].radius = 15;
	ptr->flares[1].offset = 700;

	ptr->flares[2].type = 2;
	ptr->flares[2].radius = 100;
	ptr->flares[2].offset = 650;

	ptr->flares[3].type = 3;
	ptr->flares[3].radius = 20;
	ptr->flares[3].offset = 600;

	ptr->flares[4].type = 3;
	ptr->flares[4].radius = 15;
	ptr->flares[4].offset = 550;

	ptr->flares[5].type = 2;
	ptr->flares[5].radius = 10;
	ptr->flares[5].offset = 500;

	ptr->flares[6].type = 4;
	ptr->flares[6].radius = 5;
	ptr->flares[6].offset = 450;

	ptr->flares[7].type = 4;
	ptr->flares[7].radius = 5;
	ptr->flares[7].offset = 400;

	ptr->flares[8].type = 2;
	ptr->flares[8].radius = 10;
	ptr->flares[8].offset = 350;

	ptr->flares[9].type = 2;
	ptr->flares[9].radius = 15;
	ptr->flares[9].offset = 300;

	ptr->flares[10].type = 2;
	ptr->flares[10].radius = 25;
	ptr->flares[10].offset = 250;

	ptr->flares[11].type = 2;
	ptr->flares[11].radius = 15;
	ptr->flares[11].offset = 200;

	ptr->flares[12].type = 2;
	ptr->flares[12].radius = 10;
	ptr->flares[12].offset = 150;

	ptr->flares[13].type = 3;
	ptr->flares[13].radius = 40;
	ptr->flares[13].offset = 100;

	ptr->flares[14].type = 1;
	ptr->flares[14].radius = 75;
	ptr->flares[14].offset = 50;

	return;
*//*}

void PSX_display_lens_flare(void)
{
/*
	LENS_FLARE		*ptr;
	SVECTOR			local[MAX_LENS_FLARES], coord[4];
	SVECTOR			camera_orientation;
	long			i, temp, z_position, flag, p;
	int				x_diff, y_diff, z_diff;
	short			x_rot, y_rot;


	ptr = &screen_lens_flare;

	ptr->lens_pos.vx = CAM_camp[0].vx;
	ptr->lens_pos.vy = CAM_camp[0].vy;
	ptr->lens_pos.vz = CAM_camp[0].vz;

	x_diff = ptr->origin.vx - ptr->lens_pos.vx;
	y_diff = ptr->origin.vy - ptr->lens_pos.vy;
	z_diff = ptr->origin.vz - ptr->lens_pos.vz;

	x_rot = ratan2(y_diff, z_diff);
	y_rot = ratan2(x_diff, z_diff);

	if (((OBJ_objects[0].r.vy >> 4) > 1024) || ((OBJ_objects[0].r.vy >> 4) < -1024))
		return;

	camera_orientation.vx = CAM_came[0].vx >> 4;
	camera_orientation.vy = CAM_came[0].vy >> 4;
	camera_orientation.vz = CAM_came[0].vz >> 4;

    RotMatrix(&camera_orientation, &CAM_camm[0]);

	SetTransMatrix(&IDENTITY_MATRIX);
	SetRotMatrix(&CAM_camm[0]);

	for (i = 1; i < MAX_LENS_FLARES; i++)
	{
		local[i].vy = (ptr->flares[i].offset * rsin(x_rot)) >> 12;
		temp = (ptr->flares[i].offset * rcos(x_rot)) >> 12;

		local[i].vx = (temp * rsin(y_rot)) >> 12;
		local[i].vz = (temp * rcos(y_rot)) >> 12;

		local[i].vx += CAM_camp[0].vx;
		local[i].vy += CAM_camp[0].vy;
		local[i].vz += CAM_camp[0].vz;

		coord[0].vx = (local[i].vx - CAM_camp[0].vx) - ptr->flares[i].radius;
		coord[0].vy = (local[i].vy - CAM_camp[0].vy) - ptr->flares[i].radius;
		coord[0].vz = local[i].vz - CAM_camp[0].vz;

		coord[1].vx = (local[i].vx - CAM_camp[0].vx) + ptr->flares[i].radius;
		coord[1].vy = (local[i].vy - CAM_camp[0].vy) - ptr->flares[i].radius;
		coord[1].vz = local[i].vz - CAM_camp[0].vz;

		coord[2].vx = (local[i].vx - CAM_camp[0].vx) - ptr->flares[i].radius;
		coord[2].vy = (local[i].vy - CAM_camp[0].vy) + ptr->flares[i].radius;
		coord[2].vz = local[i].vz - CAM_camp[0].vz;

		coord[3].vx = (local[i].vx - CAM_camp[0].vx) + ptr->flares[i].radius;
		coord[3].vy = (local[i].vy - CAM_camp[0].vy) + ptr->flares[i].radius;
		coord[3].vz = local[i].vz - CAM_camp[0].vz;

	    z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
	                    &coord[3], (long *)&ptr->faces[i].x0, (long *)&ptr->faces[i].x1,
	                    (long *)&ptr->faces[i].x2, (long *)&ptr->faces[i].x3, &p, &flag);

	   	GsSortPoly(&ptr->faces[i], ptrwot, z_position >> otzshift);
	}

	coord[0].vx = ptr->origin.vx;// - ptr->flares[0].radius;
	coord[0].vy = ptr->origin.vy;// - ptr->flares[0].radius;
	coord[0].vz = ptr->origin.vz;

	coord[1].vx = ptr->origin.vx;// + ptr->flares[0].radius;
	coord[1].vy = ptr->origin.vy;// - ptr->flares[0].radius;
	coord[1].vz = ptr->origin.vz;

	coord[2].vx = ptr->origin.vx;// - ptr->flares[0].radius;
	coord[2].vy = ptr->origin.vy;// + ptr->flares[0].radius;
	coord[2].vz = ptr->origin.vz;

	coord[3].vx = ptr->origin.vx;// + ptr->flares[0].radius;
	coord[3].vy = ptr->origin.vy;// + ptr->flares[0].radius;
	coord[3].vz = ptr->origin.vz;

	camera_orientation.vx = CAM_came[0].vx >> 4;
	camera_orientation.vy = CAM_came[0].vy >> 4;
	camera_orientation.vz = CAM_came[0].vz >> 4;

    RotMatrix(&camera_orientation, &CAM_camm[0]);

	for (i = 0; i < 4; i++)
		ApplyMatrixSV(&CAM_camm[0], &coord[i], &coord[i]);

	coord[0].vx -= ptr->flare[0].radius;
	coord[0].vy -= ptr->flare[0].radius;

	coord[1].vx += ptr->flares[0].radius;
	coord[1].vy -= ptr->flares[0].radius;

	coord[2].vx -= ptr->flares[0].radius;
	coord[2].vy += ptr->flares[0].radius;

	coord[3].vx += ptr->flares[0].radius;
	coord[3].vy += ptr->flares[0].radius;

	SetRotMatrix(&IDENTITY_MATRIX);

    z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
                    &coord[3], (long *)&ptr->faces[0].x0, (long *)&ptr->faces[0].x1,
                    (long *)&ptr->faces[0].x2, (long *)&ptr->faces[0].x3, &p, &flag);

   	GsSortPoly(&ptr->faces[0], ptrwot, z_position >> otzshift);
*/
/*	return;
}

*/

void init_icon_struct(void)
{
	int				i;


	for (i = 0; i < MAXNUMPLAYERS; i++)
	{
		icons[i].in_use = FALSE;

		icons[i].type = NULLVAL;
		icons[i].player_no = i;

		icons[i].timer = 0;
		icons[i].size = 100;

		icons[i].x_pos = -50;
		icons[i].y_pos = -50;

//		cannon_icons[i].height = 0;
//		cannon_icons[i].in_use = FALSE;
//		cannon_icons[i].player_no = i;
	}

	return;
}

void display_backmarker(OBJ_PLAYERSTRUCT *plyr_ptr)
{
	OBJ_STRUCT		*obj_ptr;
	POLY_F3			face;
	MATRIX			rot_matrix;
	SVECTOR			plyr_pos, new_pos, plyr_rot, obj_pos, offset;
	int				i;
	int				x_sqr, z_sqr;
	int				angle, distance, max_distance, final_angle;
	int				screen_x_pos;
	GsOT			*ot_ptr;
	short			rotation;


	plyr_pos.vx = plyr_ptr->pobj->p.vx >> 8;
	plyr_pos.vy = plyr_ptr->pobj->p.vy >> 8;
	plyr_pos.vz = plyr_ptr->pobj->p.vz >> 8;

    SetPolyF3(&face);

	for (i = 0; i <  STATE.wankers; i++)
	{
		if (i == plyr_ptr->pobj->index)
			continue;

		obj_ptr = &OBJ_objects[i];

		obj_pos.vx = obj_ptr->p.vx >> 8;
		obj_pos.vz = obj_ptr->p.vz >> 8;

		offset.vx = obj_pos.vx - plyr_pos.vx;
		offset.vz = obj_pos.vz - plyr_pos.vz;

		angle = ratan2(offset.vx , offset.vz);
		rotation = vangdiff2(angle, (plyr_ptr->pobj->r.vy >> 4));

		if (((rotation > -1536) && (rotation < 0)) || ((rotation < 1536) && (rotation > 0)))
			continue;

		x_sqr = offset.vx * offset.vx;
		z_sqr = offset.vz * offset.vz;

		distance = SquareRoot0((x_sqr + z_sqr));

		if (distance > 10000)
			continue;
		else
		{
			final_angle = rotation;
			max_distance = distance;

			if (final_angle < 0)
				screen_x_pos = (-2048 - final_angle) / 2;
			else
				screen_x_pos = (2048 - final_angle) / 2;

			face.r0 = thr_r[OBJ_players[obj_ptr->owner].crafttype];
			face.g0 = thr_g[OBJ_players[obj_ptr->owner].crafttype];
			face.b0 = thr_b[OBJ_players[obj_ptr->owner].crafttype];

			face.x0 = screen_x_pos;
			face.x1 = face.x0 + 10;
			face.x2 = face.x0 + 20;

			if (STATE.numscreens == 1)
			{
				face.y0 = 120;
				face.y1 = 120 - ((10000 - max_distance) / 800);
				face.y2 = 120;

			   	GsSortPoly(&face, ptrwot, 0);
			}
			else
			{
				face.y0 = 60;
				face.y1 = 60 - ((10000 - max_distance) / 800);
				face.y2 = 60;

				if (plyr_ptr->plyrnum == 0)
				{
					ot_ptr = &Wotwin0[outbuf_idx];
				   	GsSortPoly(&face, ot_ptr, 0);
				}

				if (plyr_ptr->plyrnum == 1)
				{
					ot_ptr = &Wotwin1[outbuf_idx];
				   	GsSortPoly(&face, ot_ptr, 0);
				}
			}
		}
	}

	if (!max_distance)
		return;

//    SetSemiTrans(&face, 1);


	return;
}
/*
void display_cannon_power_level(OBJ_PLAYERSTRUCT *plyr_ptr)
{
//	POLY_GT4		face;
	CANNON_ICON		*icon_ptr;
	GsOT			*ot_ptr;


	icon_ptr = &cannon_icons[plyr_ptr->pobj->index];

    icon_ptr->height = plyr_ptr->ammo / 160;
	icon_ptr->ammo = plyr_ptr->ammo;

    SetPolyGT4(&icon_ptr->face);
//    SetSemiTrans(&icon_ptr->face, 1);

//    face.tpage = GetTPage(0, 1, 704, 256);
//    face.clut = GetClut(704, 450);

    icon_ptr->face.tpage = GetTPage(0, 1, 704, 256);
    icon_ptr->face.clut = GetClut(704, 447);

	if (icon_ptr->old_ammo > icon_ptr->ammo)
	{
		icon_ptr->flag = TRUE;

		icon_ptr->face.r0 = 128;//(256 - (8 * icon_ptr->height));//0;
		icon_ptr->face.g0 = 128;//(4 * icon_ptr->height);//128;
		icon_ptr->face.b0 = 128;

		icon_ptr->face.r1 = 128;//(256 - (8 * icon_ptr->height));//0;
		icon_ptr->face.g1 = 128;//(4 * icon_ptr->height);//128;
		icon_ptr->face.b1 = 128;
	}
	else
	{
		if (icon_ptr->flag)
		{
			icon_ptr->valr = (128 - (255 - (8 * icon_ptr->height))) / 5;
			icon_ptr->valg = (128 - (4 * icon_ptr->height)) / 5;

			icon_ptr->flag = FALSE;
		}

		if (icon_ptr->face.g0 > (4 * icon_ptr->height))
		{
			icon_ptr->face.r0 -= icon_ptr->valr;
			icon_ptr->face.g0 -= icon_ptr->valg;

			icon_ptr->face.r1 -= icon_ptr->valr;
			icon_ptr->face.g1 -= icon_ptr->valg;
		}
		else
		{
			icon_ptr->face.r0 = (255 - (8 * icon_ptr->height));//0;
			icon_ptr->face.g0 = (4 * icon_ptr->height);//128;
			icon_ptr->face.b0 = 0;

			icon_ptr->face.r1 = (255 - (8 * icon_ptr->height));//0;
			icon_ptr->face.g1 = (4 * icon_ptr->height);//128;
			icon_ptr->face.b1 = 0;
		}
	}

	icon_ptr->face.r2 = (96 - (3 * icon_ptr->height));//0;
	icon_ptr->face.g2 = 2 * icon_ptr->height;//32;
	icon_ptr->face.b2 = 0;

	icon_ptr->face.r3 = (96 - (3 * icon_ptr->height));//0;
	icon_ptr->face.g3 = 2 * icon_ptr->height;//32;
	icon_ptr->face.b3 = 0;

	icon_ptr->old_ammo = icon_ptr->ammo;

    icon_ptr->face.u0 = icon_uv[CANNON_ICON_INDEX][0];
    icon_ptr->face.v0 = icon_uv[CANNON_ICON_INDEX][3] - icon_ptr->height;

    icon_ptr->face.u1 = icon_uv[CANNON_ICON_INDEX][2];
    icon_ptr->face.v1 = icon_uv[CANNON_ICON_INDEX][3] - icon_ptr->height;

    icon_ptr->face.u2 = icon_uv[CANNON_ICON_INDEX][0];
    icon_ptr->face.v2 = icon_uv[CANNON_ICON_INDEX][3];// - icon_ptr->height;

    icon_ptr->face.u3 = icon_uv[CANNON_ICON_INDEX][2];
    icon_ptr->face.v3 = icon_uv[CANNON_ICON_INDEX][3];// - icon_ptr->height;
/*
	face.r0 = 128;
	face.g0 = 128;
	face.b0 = 128;

    face.u0 = 10;
    face.v0 = 199;

    face.u1 = 10;
    face.v1 = 199;

    face.u2 = 10;
    face.v2 = 199;

    face.u3 = 10;
    face.v3 = 199;

	face.x0 = 150;
	face.x1 = 165;
	face.x2 = 150;
	face.x3 = 165;
*//*
	icon_ptr->face.x0 = 250;
	icon_ptr->face.x1 = 220;
	icon_ptr->face.x2 = 250;
	icon_ptr->face.x3 = 220;

	if (STATE.numscreens == 1)
	{
		icon_ptr->face.y0 = 127 - icon_ptr->height;
		icon_ptr->face.y1 = 127 - icon_ptr->height;
		icon_ptr->face.y2 = 127;
		icon_ptr->face.y3 = 127;

	   	GsSortPoly(&icon_ptr->face, ptrwot, 1);
	}
	else
	{
		if (plyr_ptr->pobj->index)
		{
			icon_ptr->face.y0 = 60 - (icon_ptr->height / 2);
			icon_ptr->face.y1 = 60 - (icon_ptr->height / 2);
			icon_ptr->face.y2 = 60;
			icon_ptr->face.y3 = 60;

			ot_ptr = &Wotwin1[outbuf_idx];

		   	GsSortPoly(&icon_ptr->face, ot_ptr, 1);
		}
		else
		{
			icon_ptr->face.y0 = 60 - (icon_ptr->height / 2);
			icon_ptr->face.y1 = 60 - (icon_ptr->height / 2);
			icon_ptr->face.y2 = 60;
			icon_ptr->face.y3 = 60;

			ot_ptr = &Wotwin0[outbuf_idx];

		   	GsSortPoly(&icon_ptr->face, ot_ptr, 1);
		}
	}

	return;
}

void display_pickup_icon(OBJ_PLAYERSTRUCT *plyr_ptr)
{
	POLY_GT4		face;
	GsOT			*ot_ptr;


	if (icons[plyr_ptr->pobj->index].type != icons[plyr_ptr->pobj->index].old_type)
	{
		icons[plyr_ptr->pobj->index].size = 100;
		icons[plyr_ptr->pobj->index].x_pos = -50;
		icons[plyr_ptr->pobj->index].y_pos = -50;
		icons[plyr_ptr->pobj->index].timer = 0;

		icons[plyr_ptr->pobj->index].old_type = icons[plyr_ptr->pobj->index].type;
	}
	else
	{
		if (icons[plyr_ptr->pobj->index].timer && (icons[plyr_ptr->pobj->index].timer < 11))
		{
			icons[plyr_ptr->pobj->index].size -= (1 * (11 - icons[plyr_ptr->pobj->index].timer));

			icons[plyr_ptr->pobj->index].x_pos += (3 * (11 - icons[plyr_ptr->pobj->index].timer));
			icons[plyr_ptr->pobj->index].y_pos -= (1 * (11 - icons[plyr_ptr->pobj->index].timer));
		}

		if (icons[plyr_ptr->pobj->index].timer < 11)
			icons[plyr_ptr->pobj->index].timer ++;
	}

    SetPolyGT4(&face);
    SetSemiTrans(&face, 1);

    face.tpage = GetTPage(0, 1, 704, 256);
    face.clut = GetClut(704, 447);

	face.r0 = 255;//0;
	face.g0 = 0;//64;
	face.b0 = 0;//32;

	face.r1 = 0;
	face.g1 = 255;//64;
	face.b1 = 0;//32;

	face.r2 = 0;
	face.g2 = 0;//64;
	face.b2 = 255;//32;

	face.r3 = 255;//0;
	face.g3 = 255;//64;
	face.b3 = 32;

    face.u0 = icon_uv[icons[plyr_ptr->pobj->index].type][0];
    face.v0 = icon_uv[icons[plyr_ptr->pobj->index].type][1];

    face.u1 = icon_uv[icons[plyr_ptr->pobj->index].type][2];
    face.v1 = icon_uv[icons[plyr_ptr->pobj->index].type][1];

    face.u2 = icon_uv[icons[plyr_ptr->pobj->index].type][0];
    face.v2 = icon_uv[icons[plyr_ptr->pobj->index].type][3];

    face.u3 = icon_uv[icons[plyr_ptr->pobj->index].type][2];
    face.v3 = icon_uv[icons[plyr_ptr->pobj->index].type][3];

	if (STATE.numscreens == 1)
	{
		face.x0 = (icons[plyr_ptr->pobj->index].x_pos * 25) >> 4;
		face.x1 = ((icons[plyr_ptr->pobj->index].x_pos + icons[plyr_ptr->pobj->index].size) * 25) >> 4;
		face.x2 = (icons[plyr_ptr->pobj->index].x_pos * 25) >> 4;
		face.x3 = ((icons[plyr_ptr->pobj->index].x_pos + icons[plyr_ptr->pobj->index].size) * 25) >> 4;

		face.y0 = icons[plyr_ptr->pobj->index].y_pos;
		face.y1 = icons[plyr_ptr->pobj->index].y_pos;
		face.y2 = icons[plyr_ptr->pobj->index].y_pos + icons[plyr_ptr->pobj->index].size;
		face.y3 = icons[plyr_ptr->pobj->index].y_pos + icons[plyr_ptr->pobj->index].size;

	   	GsSortPoly(&face, ptrwot, 1);
	}
	else
	{
		if (plyr_ptr->pobj->index)
		{
			face.x0 = (icons[plyr_ptr->pobj->index].x_pos * 25) >> 4;
			face.x1 = ((icons[plyr_ptr->pobj->index].x_pos + (icons[plyr_ptr->pobj->index].size / 2)) * 25) >> 4;
			face.x2 = (icons[plyr_ptr->pobj->index].x_pos * 25) >> 4;
			face.x3 = ((icons[plyr_ptr->pobj->index].x_pos + (icons[plyr_ptr->pobj->index].size / 2)) * 25) >> 4;

			face.y0 = (icons[plyr_ptr->pobj->index].y_pos / 2);
			face.y1 = (icons[plyr_ptr->pobj->index].y_pos / 2);
			face.y2 = (icons[plyr_ptr->pobj->index].y_pos / 2) + (icons[plyr_ptr->pobj->index].size / 2);
			face.y3 = (icons[plyr_ptr->pobj->index].y_pos / 2) + (icons[plyr_ptr->pobj->index].size / 2);

			ot_ptr = &Wotwin1[outbuf_idx];

		   	GsSortPoly(&face, ot_ptr, 1);
		}
		else
		{
			face.x0 = (icons[plyr_ptr->pobj->index].x_pos * 25) >> 4;
			face.x1 = ((icons[plyr_ptr->pobj->index].x_pos + (icons[plyr_ptr->pobj->index].size / 2)) * 25) >> 4;
			face.x2 = (icons[plyr_ptr->pobj->index].x_pos * 25) >> 4;
			face.x3 = ((icons[plyr_ptr->pobj->index].x_pos + (icons[plyr_ptr->pobj->index].size / 2)) * 25) >> 4;

			face.y0 = (icons[plyr_ptr->pobj->index].y_pos / 2);
			face.y1 = (icons[plyr_ptr->pobj->index].y_pos / 2);
			face.y2 = (icons[plyr_ptr->pobj->index].y_pos / 2) + (icons[plyr_ptr->pobj->index].size / 2);
			face.y3 = (icons[plyr_ptr->pobj->index].y_pos / 2) + (icons[plyr_ptr->pobj->index].size / 2);

			ot_ptr = &Wotwin0[outbuf_idx];

		   	GsSortPoly(&face, ot_ptr, 1);
		}
	}

	return;
}
*/
void PSX_init_shield(void)
{
	int				i, angle, ang_inc, radius, depth, max_depth;


	angle = 0;
	ang_inc = 4096 / MAX_SHIELD_SEGMENTS;
	radius = 125;
	max_depth = 35;

	for (i = 0; i < (MAX_SHIELD_SEGMENTS * 4); i += 4)
	{
		shield_coord[i].vx = (radius * rsin(angle)) >> 12;
		shield_coord[i].vy = (radius * rcos(angle)) >> 12;

		shield_coord[i + 2].vx = shield_coord[i].vx;
		shield_coord[i + 2].vy = shield_coord[i].vy;

		angle += ang_inc;
	}

	for (i = 1; i < ((MAX_SHIELD_SEGMENTS * 4) - 4); i += 4)
	{
		shield_coord[i].vx = shield_coord[i + 3].vx;
		shield_coord[i].vy = shield_coord[i + 3].vy;

		shield_coord[i + 2].vx = shield_coord[i].vx;
		shield_coord[i + 2].vy = shield_coord[i].vy;
	}

	shield_coord[(MAX_SHIELD_SEGMENTS * 4) - 1].vx = shield_coord[0].vx;
	shield_coord[(MAX_SHIELD_SEGMENTS * 4) - 1].vy = shield_coord[0].vy;

	shield_coord[(MAX_SHIELD_SEGMENTS * 4) - 3].vx = shield_coord[2].vx;
	shield_coord[(MAX_SHIELD_SEGMENTS * 4) - 3].vy = shield_coord[2].vy;

	for (i = 0; i < (MAX_SHIELD_SEGMENTS * 4); i += 4)
	{
		depth = (max_depth * rsin(angle)) >> 12;

		shield_coord[i].vz = depth;
		shield_coord[i + 2].vz = -depth;

		angle += ang_inc;
	}

	for (i = 1; i < ((MAX_SHIELD_SEGMENTS * 4) - 4); i += 2)
		shield_coord[i].vz = shield_coord[i + 3].vz;

	shield_coord[(MAX_SHIELD_SEGMENTS * 4) - 3].vz = shield_coord[0].vz;
	shield_coord[(MAX_SHIELD_SEGMENTS * 4) - 1].vz = shield_coord[2].vz;

	return;
}

void PSX_process_shield(OBJ_STRUCT *obj_ptr)
{
    MATRIX          cloud_matrix;
    VECTOR          cloud_origin;
    VECTOR          cloud_pos;
    SVECTOR         camera_orientation, cloud_orientation;
	POLY_FT4		face;
	long			i, z_position, p, flag, display_loop, in_range;
	GsOT			*ot_ptr;
		

	if (obj_ptr->pkup_data.timer == 250)
	{
		OBJ_players[obj_ptr->owner].shield_strength = 0;
		OBJ_players[obj_ptr->owner].shield_id = NULLVAL;
		
		OBJ_delobj(obj_ptr->index);

		return;
	}

	obj_ptr->pkup_data.timer ++;

   	S2_sfxdynamic( 1, obj_ptr->p.vx>>8, obj_ptr->p.vz>>8, -1, 20, 5000 );

	obj_ptr->r.vx -= (88 << 4);
	obj_ptr->r.vy += (122 << 4);

	if (obj_ptr->r.vx <= (-4096 << 4))
		obj_ptr->r.vx += (4096 << 4);

	if (obj_ptr->r.vy >= (4096 << 4))
		obj_ptr->r.vy -= (4096 << 4);

	obj_ptr->p.vx = OBJ_objects[obj_ptr->owner].p.vx;
	obj_ptr->p.vy = OBJ_objects[obj_ptr->owner].p.vy;
	obj_ptr->p.vz = OBJ_objects[obj_ptr->owner].p.vz;

    SetPolyFT4(&face);
    SetSemiTrans(&face, 1);		  

	if (CAM_cammode[CAM_c] == 2)
		face.tpage = GetTPage(0, 3, 704, 256);
	else
		face.tpage = GetTPage(0, 3, 704, 256);

    face.clut = GetClut(704, 470);

	face.r0 = 255 - (OBJ_players[obj_ptr->owner].shield_strength / 2);//128;//0;
	face.g0 = 64;//64;//125;
	face.b0 = (OBJ_players[obj_ptr->owner].shield_strength / 2);//0;//250;

    face.u0 = 24;
    face.v0 = 224;

    face.u1 = 39;
    face.v1 = 224;

    face.u2 = 24;
    face.v2 = 239;

    face.u3 = 39;
    face.v3 = 239;

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop ++)
	{
		in_range = clip_point_long(&obj_ptr->p, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

	    cloud_origin.vx = obj_ptr->p.vx >> 8;
	    cloud_origin.vy = obj_ptr->p.vy >> 8;
	    cloud_origin.vz = obj_ptr->p.vz >> 8;

		cloud_origin.vx -= CAM_camp[display_loop].vx;
		cloud_origin.vy -= CAM_camp[display_loop].vy;
		cloud_origin.vz -= CAM_camp[display_loop].vz;

	    ApplyMatrixLV(&CAM_camm[display_loop], &cloud_origin, &cloud_pos);
	    cloud_pos.vx = (cloud_pos.vx * 25) >> 4;

		cloud_orientation.vx = obj_ptr->r.vx >> 4;//-CAM_came[display_loop].vx >> 4;//OBJ_players[0].pobj->r.vx; //ctrl_ptr->r.vx >> 4;		// change 0x10000=360 to 0x1000=360
		cloud_orientation.vy = 0;//obj_ptr->r.vy;//obj_ptr->r.vy;//-CAM_came[display_loop].vy >> 4;//OBJ_players[0].pobj->r.vy >> 4; //obj_ptr->rotation.vy >> 4;
		cloud_orientation.vz = 1024;//obj_ptr->r.vz;//-CAM_came[display_loop].vz >> 4;//OBJ_players[0].pobj->r.vz; //ctrl_ptr->r.vz >> 4;

	    RotMatrix(&cloud_orientation, &cloud_matrix);

	  	cloud_matrix.m[0][0] = (cloud_matrix.m[0][0] * 25) >> 4;//aspect fix
	    cloud_matrix.m[0][1] = (cloud_matrix.m[0][1] * 25) >> 4;//aspect fix
	    cloud_matrix.m[0][2] = (cloud_matrix.m[0][2] * 25) >> 4;//aspect fix

	    cloud_matrix.t[0] = cloud_pos.vx;
	    cloud_matrix.t[1] = cloud_pos.vy;
	    cloud_matrix.t[2] = cloud_pos.vz;

	    SetTransMatrix(&cloud_matrix);
	    SetRotMatrix(&cloud_matrix);

		for (i = 0; i < (MAX_SHIELD_SEGMENTS * 4); i += 4)
		{
			if (CAM_cammode[CAM_c] == 2)
			{
				if (obj_ptr->r.vx > (-2048 << 4))
				{
					if (i < (MAX_SHIELD_SEGMENTS * 2))
						continue;
//					if ((shield_coord[i].vz <= 0) && (shield_coord[i + 1].vz <= 0))
//						continue;
				}
				else
				{
					if (i >= (MAX_SHIELD_SEGMENTS * 2))
						continue;
				}

			}

		    z_position = RotTransPers4(&shield_coord[i], &shield_coord[i + 1],
		    			&shield_coord[i + 2], &shield_coord[i + 3],
		    			(long *)&face.x0, (long *)&face.x1, (long *)&face.x2,
		    			(long *)&face.x3, &p, &flag);

			if (z_position >= 0)
			{
				if (CAM_cammode[CAM_c] == 2)
				   	GsSortPoly(&face, ot_ptr, z_position >> otzshift);//1);
				else
				   	GsSortPoly(&face, ot_ptr, z_position >> otzshift);
			}
		}

		cloud_orientation.vx = 0;//obj_ptr->r.vx;//-CAM_came[display_loop].vx >> 4;//OBJ_players[0].pobj->r.vx; //ctrl_ptr->r.vx >> 4;		// change 0x10000=360 to 0x1000=360
		cloud_orientation.vy = obj_ptr->r.vy >> 4;//obj_ptr->r.vy;//-CAM_came[display_loop].vy >> 4;//OBJ_players[0].pobj->r.vy >> 4; //obj_ptr->rotation.vy >> 4;
		cloud_orientation.vz = 0;//obj_ptr->r.vx;//-CAM_came[display_loop].vz >> 4;//OBJ_players[0].pobj->r.vz; //ctrl_ptr->r.vz >> 4;

	    RotMatrix(&cloud_orientation, &cloud_matrix);

	  	cloud_matrix.m[0][0] = (cloud_matrix.m[0][0] * 25) >> 4;//aspect fix
	    cloud_matrix.m[0][1] = (cloud_matrix.m[0][1] * 25) >> 4;//aspect fix
	    cloud_matrix.m[0][2] = (cloud_matrix.m[0][2] * 25) >> 4;//aspect fix

	    SetRotMatrix(&cloud_matrix);

//		face.r0 = 0;
//		face.g0 = 64;//175;
//		face.b0 = 128;//250;

		for (i = 0; i < (MAX_SHIELD_SEGMENTS * 4); i += 4)
		{
//			if (CAM_cammode[CAM_c] == 2)
//			{
//				if ((shield_coord[i].vz <= 0) && (shield_coord[i + 1].vz <= 0))
//					continue;
//			}
			if (CAM_cammode[CAM_c] == 2)
			{
				if (obj_ptr->r.vy < (2048 << 4))
				{
					if (i < (MAX_SHIELD_SEGMENTS * 2))
						continue;
//					if ((shield_coord[i].vz <= 0) && (shield_coord[i + 1].vz <= 0))
//						continue;
				}
				else
				{
					if (i >= (MAX_SHIELD_SEGMENTS * 2))
						continue;
				}

			}

		    z_position = RotTransPers4(&shield_coord[i], &shield_coord[i + 1],
		    			&shield_coord[i + 2], &shield_coord[i + 3],
		    			(long *)&face.x0, (long *)&face.x1, (long *)&face.x2,
		    			(long *)&face.x3, &p, &flag);

			if (z_position >= 0)
			{
				if (CAM_cammode[CAM_c] == 2)
				   	GsSortPoly(&face, ot_ptr, z_position >> otzshift);//0);
				else
				   	GsSortPoly(&face, ot_ptr, z_position >> otzshift);
			}
		}

		ot_ptr = &Wotwin1[outbuf_idx];
	}

	return;
}

void PSX_init_shield_effect(OBJ_PLAYERSTRUCT *plyr_ptr, vec32 *init_point)
{
	MATRIX			rot_matrix;
	SVECTOR			plyr_pos, new_pos, plyr_rot, obj_pos, offset;
	int				x_sqr, z_sqr;

    OBJ_STRUCT      *obj_ptr, *plyr_obj_ptr;
    SHIELD_FX       *ptr;
   	s32 			i;


    ptr = init_shield_object();
    if (ptr == NULL)
        return;

    ptr->object = OBJ_newobj(OTshield_effect);
    if (ptr->object == NULLVAL)
        return;                             //No more object structures.

    plyr_obj_ptr = (OBJ_STRUCT *)plyr_ptr->pobj;
    obj_ptr = &OBJ_objects[ptr->object];

    obj_ptr->owner = plyr_obj_ptr->owner;
    ptr->owner = plyr_obj_ptr->index;

    obj_ptr->fx_id = ptr->index;

    for (i = 0; i < (MAX_SHIELD_SIDES); i++)
    {
        SetPolyGT3(&ptr->faces[i]);
        SetSemiTrans(&ptr->faces[i], 1);

        ptr->faces[i].r0 = 0;
        ptr->faces[i].g0 = 0;
        ptr->faces[i].b0 = 0;

        ptr->faces[i].r1 = 0;
        ptr->faces[i].g1 = 128;
        ptr->faces[i].b1 = 255;

        ptr->faces[i].r2 = 0;
        ptr->faces[i].g2 = 0;
        ptr->faces[i].b2 = 0;

        ptr->faces[i].tpage = GetTPage(0, 1, 704, 256);
        ptr->faces[i].clut = GetClut(704, 472);

        ptr->faces[i].u0 = 0;
        ptr->faces[i].v0 = 125;

        ptr->faces[i].u1 = 16;
        ptr->faces[i].v1 = 114;

        ptr->faces[i].u2 = 31;
        ptr->faces[i].v2 = 125;
    }

    for (i = 1; i < 24; i += 3)
    {
        ptr->coord[i].vx = 0;
        ptr->coord[i].vy = 0;
        ptr->coord[i].vz = 0;
    }

    ptr->coord[0].vx = 0;
    ptr->coord[0].vy = 137;
    ptr->coord[0].vz = -100;

    ptr->coord[2].vx = 97;
    ptr->coord[2].vy = 97;
    ptr->coord[2].vz = -100;

    ptr->coord[5].vx = 137;
    ptr->coord[5].vy = 0;
    ptr->coord[5].vz = -100;

    ptr->coord[8].vx = 97;
    ptr->coord[8].vy = -97;
    ptr->coord[8].vz = -100;

    ptr->coord[11].vx = 0;
    ptr->coord[11].vy = -137;
    ptr->coord[11].vz = -100;

    ptr->coord[14].vx = -97;
    ptr->coord[14].vy = -97;
    ptr->coord[14].vz = -100;

    ptr->coord[17].vx = -137;
    ptr->coord[17].vy = 0;
    ptr->coord[17].vz = -100;

    ptr->coord[20].vx = -97;
    ptr->coord[20].vy = 97;
    ptr->coord[20].vz = -100;

    ptr->coord[23].vx = 0;
    ptr->coord[23].vy = 137;
    ptr->coord[23].vz = -100;

    for (i = 3; i < 24; i += 3)
    {
        ptr->coord[i].vx = ptr->coord[i - 1].vx;
        ptr->coord[i].vy = ptr->coord[i - 1].vy;
        ptr->coord[i].vz = ptr->coord[i - 1].vz;
    }

	plyr_pos.vx = plyr_ptr->pobj->p.vx >> 8;
	plyr_pos.vy = plyr_ptr->pobj->p.vy >> 8;
	plyr_pos.vz = plyr_ptr->pobj->p.vz >> 8;

	plyr_rot.vx = -plyr_ptr->pobj->r.vx >> 4;
	plyr_rot.vy = -plyr_ptr->pobj->r.vy >> 4;
	plyr_rot.vz = -plyr_ptr->pobj->r.vz >> 4;

    RotMatrix(&plyr_rot, &rot_matrix);

	obj_pos.vx = init_point->vx >> 8;
	obj_pos.vy = init_point->vy >> 8;
	obj_pos.vz = init_point->vz >> 8;

	offset.vx = obj_pos.vx - plyr_pos.vx;
	offset.vy = obj_pos.vy - plyr_pos.vy;
	offset.vz = obj_pos.vz - plyr_pos.vz;

    ApplyMatrixSV(&rot_matrix, &offset, &new_pos);

	ptr->craft_orientation.vy = ratan2(new_pos.vx , new_pos.vz);

	x_sqr = new_pos.vx * new_pos.vx;
	z_sqr = new_pos.vz * new_pos.vz;

	ptr->vector_length = SquareRoot0((x_sqr + z_sqr));

    return;
}

void PSX_process_shield_effect(SHIELD_FX *fx_ptr)
{
    OBJ_PLAYERSTRUCT      *plyr_ptr;
    OBJ_STRUCT            *plyr_obj_ptr;
    MATRIX                shield_matrix;
    VECTOR                shield_origin;
    VECTOR                shield_pos;
    SVECTOR               camera_orientation, shield_orientation;
    long                  i, j, z_position, p, flag;
    s16                   ans1, ans2;
    s32                   ans3, ans4;
	int						display_loop, in_range;
	GsOT			*ot_ptr;


    plyr_obj_ptr = &OBJ_objects[fx_ptr->owner];
    plyr_ptr = &OBJ_players[plyr_obj_ptr->owner];

    ans1 = rsin(((plyr_obj_ptr->r.vy >> 4) + fx_ptr->craft_orientation.vy));
    ans2 = rcos(((plyr_obj_ptr->r.vy >> 4) + fx_ptr->craft_orientation.vy));

    ans3 = (ans1 * fx_ptr->vector_length) >> 12;
    ans4 = (ans2 * fx_ptr->vector_length) >> 12;

    fx_ptr->origin.vx = (plyr_obj_ptr->p.vx >> 8) + ans3;
    fx_ptr->origin.vz = (plyr_obj_ptr->p.vz >> 8) + ans4;
    fx_ptr->origin.vy = (plyr_obj_ptr->p.vy >> 8);

    fx_ptr->orientation.vy = (plyr_obj_ptr->r.vy >> 4) + fx_ptr->craft_orientation.vy;

	for (j = 0; j < MAX_SHIELD_SIDES; j++)
	{
	    fx_ptr->faces[j].v0 -= 2;
	    fx_ptr->faces[j].v1 -= 2;
	    fx_ptr->faces[j].v2 -= 2;

	//        fx_ptr->faces[j].b1 -= 12;

	    if (fx_ptr->faces[j].v1 == 94)
	    {
	        fx_ptr->in_use = FALSE;
	        OBJ_delobj(OBJ_objects[fx_ptr->object].index);

			return;
	    }
	}

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop ++)
	{
		in_range = clip_point_short(&fx_ptr->origin, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

	    shield_origin.vx = fx_ptr->origin.vx;
	    shield_origin.vy = fx_ptr->origin.vy;
	    shield_origin.vz = fx_ptr->origin.vz;

		shield_origin.vx -= CAM_camp[display_loop].vx;
		shield_origin.vy -= CAM_camp[display_loop].vy;
		shield_origin.vz -= CAM_camp[display_loop].vz;

	    ApplyMatrixLV(&CAM_camm[display_loop], &shield_origin, &shield_pos);
	    shield_pos.vx = (shield_pos.vx * 25) >> 4;

		shield_orientation.vx = 0;//fx_ptr->orientation.vx;		// change 0x10000=360 to 0x1000=360
		shield_orientation.vy = fx_ptr->orientation.vy;
		shield_orientation.vz = 0;//fx_ptr->orientation.vz;

	    RotMatrix(&shield_orientation, &shield_matrix);
		MulMatrix(&shield_matrix, &CAM_camm[display_loop]);

	  	shield_matrix.m[0][0] = (shield_matrix.m[0][0] * 25) >> 4;//aspect fix
	    shield_matrix.m[0][1] = (shield_matrix.m[0][1] * 25) >> 4;//aspect fix
	    shield_matrix.m[0][2] = (shield_matrix.m[0][2] * 25) >> 4;//aspect fix

	    shield_matrix.t[0] = shield_pos.vx;
	    shield_matrix.t[1] = shield_pos.vy;
	    shield_matrix.t[2] = shield_pos.vz;

	    SetTransMatrix(&shield_matrix);
	    SetRotMatrix(&shield_matrix);

	    for (i = 0, j = 0; j < MAX_SHIELD_SIDES; i += 3, j++)
	    {
	        z_position = RotTransPers3(&fx_ptr->coord[i], &fx_ptr->coord[i + 1], &fx_ptr->coord[i + 2],
	                    (long *)&fx_ptr->faces[j].x0, (long *)&fx_ptr->faces[j].x1, (long *)&fx_ptr->faces[j].x2,
	                    &p, &flag);

	       	GsSortPoly(&fx_ptr->faces[j], ot_ptr, z_position >> otzshift);
	    }

		ot_ptr = &Wotwin1[outbuf_idx];
	}

    return;
}
/*
void PSX_init_burst_effect(OBJ_STRUCT *obj_ptr)
{
    BURST_FX            *ptr;


    ptr = init_burst_object();

    if (ptr == NULL)
        return;

    SetPolyFT4(&ptr->face);
    SetSemiTrans(&ptr->face, 1);

    ptr->face.r0 = 0;
    ptr->face.g0 = 128;
    ptr->face.b0 = 0;

    ptr->face.tpage = GetTPage(0, 1, 704, 256);
    ptr->face.clut = GetClut(704, 449);

    ptr->face.u0 = 64;
    ptr->face.v0 = 126;

    ptr->face.u1 = 123;
    ptr->face.v1 = 126;

    ptr->face.u2 = 64;
    ptr->face.v2 = 189;

    ptr->face.u3 = 123;
    ptr->face.v3 = 189;

    return;
}
*/
void PSX_process_burst_effect(OBJ_STRUCT *obj_ptr)
{
	POLY_FT4			face;
    MATRIX                burst_matrix;
    SVECTOR               burst_origin;
    SVECTOR               burst_pos, coord[4];
    SVECTOR               camera_orientation;
    long                  z_position, p, flag, in_range, display_loop;
	GsOT   				  *ot_ptr;


    SetPolyFT4(&face);
    SetSemiTrans(&face, 1);

    face.r0 = 128;
    face.g0 = 128;
    face.b0 = 0;

    face.tpage = GetTPage(0, 1, 704, 256);
    face.clut = GetClut(704, 449);

    face.u0 = 64;
    face.v0 = 126;

    face.u1 = 123;
    face.v1 = 126;

    face.u2 = 64;
    face.v2 = 189;

    face.u3 = 123;
    face.v3 = 189;

//	PSX_init_explosion(obj_ptr, KEEP, DONT_SCALE);


    coord[0].vx = -30;
    coord[0].vy = -30;
    coord[0].vz = 0;

    coord[1].vx = 30;
    coord[1].vy = -30;
    coord[1].vz = 0;

    coord[2].vx = -30;
    coord[2].vy = 30;
    coord[2].vz = 0;

    coord[3].vx = 30;
    coord[3].vy = 30;
    coord[3].vz = 0;

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_long(&obj_ptr->p, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

	    burst_origin.vx = obj_ptr->p.vx >> 8;
	    burst_origin.vy = obj_ptr->p.vy >> 8;
	    burst_origin.vz = obj_ptr->p.vz >> 8;

		burst_origin.vx -= CAM_camp[display_loop].vx;
		burst_origin.vy -= CAM_camp[display_loop].vy;
		burst_origin.vz -= CAM_camp[display_loop].vz;

	    ApplyMatrixSV(&CAM_camm[display_loop], &burst_origin, &burst_pos);
	    burst_pos.vx = (burst_pos.vx * 25) >> 4;

	    burst_matrix.t[0] = burst_pos.vx;
	    burst_matrix.t[1] = burst_pos.vy;
	    burst_matrix.t[2] = burst_pos.vz;

	    SetTransMatrix(&burst_matrix);
	    SetRotMatrix(&IDENTITY_MATRIX);

	    z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
	                    &coord[3], (long *)&face.x0, (long *)&face.x1,
	                    (long *)&face.x2, (long *)&face.x3, &p, &flag);

	   	GsSortPoly(&face, ot_ptr, z_position >> otzshift);

		ot_ptr = &Wotwin1[outbuf_idx];
	}

    return;
}

s32 PSX_init_flamer(OBJ_PLAYERSTRUCT *plyr_ptr)
{
    FLAMER_CTRL_STRUCT   *ctrl_ptr;


    ctrl_ptr = (FLAMER_CTRL_STRUCT *)init_flamer_ctrl_struct();
    if (ctrl_ptr == NULL)
        return FALSE;

	ctrl_ptr->fuel_level = 100;

    ctrl_ptr->owner = plyr_ptr->plyrnum;

	ctrl_ptr->first_flame = NULLVAL;
	ctrl_ptr->latest_flame = NULLVAL;

    ctrl_ptr->finished = FALSE;

	ctrl_ptr->origin.vx = plyr_ptr->pobj->p.vx >> 8;
	ctrl_ptr->origin.vy = plyr_ptr->pobj->p.vy >> 8;
	ctrl_ptr->origin.vz = plyr_ptr->pobj->p.vz >> 8;

    plyr_ptr->flamer_in_use = TRUE;


    return TRUE;//because we want flamer on a button press until used up
}

s32 flamegrilled=-1;

void PSX_process_flamer(FLAMER_CTRL_STRUCT *ctrl_ptr)
{
    FLAMER_FLAME_ANIM   	*ptr;
    OBJ_PICKUP		        *pk_ptr;
	OBJ_PLAYERSTRUCT		*plyr_ptr;
	s32						pad_data, success, ian;

//	GsClearVcount();


	plyr_ptr = &OBJ_players[ctrl_ptr->owner];

	ctrl_ptr->current_pos.vx = plyr_ptr->pobj->p.vx >> 8;
	ctrl_ptr->current_pos.vy = plyr_ptr->pobj->p.vy >> 8;
	ctrl_ptr->current_pos.vz = plyr_ptr->pobj->p.vz >> 8;

	ctrl_ptr->ang_diff = abs((-CAM_came[CAM_c].vy >> 4) - ctrl_ptr->rotation.vy);

	ctrl_ptr->rotation.vx = plyr_ptr->pobj->r.vx >> 4;
	ctrl_ptr->rotation.vy = plyr_ptr->pobj->r.vy >> 4;
	ctrl_ptr->rotation.vz = plyr_ptr->pobj->r.vz >> 4;

	if (ctrl_ptr->first_flame != NULLVAL)
	{
		ptr = &PSX_flamer_flames[ctrl_ptr->first_flame];

		update_flamer_flame(ptr, ctrl_ptr);

		while (ptr->next_flame != NULLVAL)
		{
			ptr = &PSX_flamer_flames[ptr->next_flame];

			update_flamer_flame(ptr, ctrl_ptr);
		}
	}

   pad_data = plyr_ptr->SIM_input_data;

	if ((pad_data & PAD_FRB) && (ctrl_ptr->fuel_level > 0))
	{
        success = init_new_flamer_flame(ctrl_ptr);
//      if( (flamegrilled == -1) && (ctrl_ptr->owner==0) )
//         {
//         //flamegrilled   =  SOUND_sfx(17);
//         flamegrilled=S2_sfxdynamic( 17, plyr_ptr->pobj->p.vx >> 8, plyr_ptr->pobj->p.vz >> 8, 0, 100, 4600 );
//         }

      S2_sfxdynamic( 17, plyr_ptr->pobj->p.vx >> 8, plyr_ptr->pobj->p.vz >> 8, ctrl_ptr->owner, 100, 4600 );

		if (success)
			ctrl_ptr->fuel_level --;

		if (ctrl_ptr->fuel_level <= 0)
         {
			OBJ_players[ctrl_ptr->owner].flamer_in_use = FALSE;
         //SsUtKeyOffV(flamegrilled);
         }
	}
   else
   {// if fire not pressed then extinnguish sfx
      if( (flamegrilled > -1) && (ctrl_ptr->owner==0) )
       {
       SsUtKeyOffV(flamegrilled);
       flamegrilled=-1;
       }
   }
//	ian = GsGetVcount();
//	FntPrint("flamer = %d\n", ian);

	return;
}

void update_flamer_flame(FLAMER_FLAME_ANIM *ptr, FLAMER_CTRL_STRUCT *ctrl_ptr)
{
    s32             x_vel, y_vel, z_vel, temp_vel;
    POLY_FT4       	face;
    SVECTOR        	coord[4], local_position, camera_orientation;
    long           	i, z_position, p, flag, success;
	long	  		display_loop, in_range;
	GsOT	  		*ot_ptr;
	FLAMER_FLAME_ANIM	*last_ptr, *next_ptr;


	ptr->timer ++;

	if (!(ptr->timer % ptr->delay))
	{
		ptr->uv_index += ptr->increment;

		if (ptr->uv_index >= ptr->end_point)
		{
			if (ptr->next_flame != NULLVAL)
			{
				if (ptr->prev_flame != NULLVAL)
				{
					last_ptr = &PSX_flamer_flames[ptr->prev_flame];
					last_ptr->next_flame = ptr->next_flame;

					next_ptr = &PSX_flamer_flames[ptr->next_flame];
					next_ptr->prev_flame = ptr->prev_flame;
				}
				else
				{
					next_ptr = &PSX_flamer_flames[ptr->next_flame];
					next_ptr->prev_flame = NULLVAL;

					PSX_flamers[ptr->owner].first_flame = ptr->next_flame;
				}
			}
			else
			{
				if (ptr->prev_flame != NULLVAL)
				{
					last_ptr = &PSX_flamer_flames[ptr->prev_flame];

					last_ptr->next_flame = NULLVAL;
				}
				else
				{
					PSX_flamers[ptr->owner].first_flame = NULLVAL;
					PSX_flamers[ptr->owner].latest_flame = NULLVAL;

					if (ctrl_ptr->fuel_level <= 0)
						PSX_flamers[ptr->owner].in_use = FALSE;
				}
			}

			ptr->in_use = FALSE;

			return;
		}

		if ((ctrl_ptr->ang_diff > 128) && (!ptr->smoke_flag))
		{
			if (ctrl_ptr->ang_diff > 128)
				ctrl_ptr->ang_diff = 128;

			ptr->r = ctrl_ptr->ang_diff;
			ptr->g = ctrl_ptr->ang_diff;
			ptr->b = ctrl_ptr->ang_diff;
		}
		else
		{
		    ptr->r =
		    ptr->g =
		    ptr->b = 16 + SDRAND(32);//56;
		}

		if (ptr->uv_index > 14)
			ptr->size_scaler = 6;

		if (ptr->uv_index == 18)
		{
			ptr->smoke_flag = TRUE;

		    ptr->r = 32;
			ptr->g = 64;
		    ptr->b = 64;

			ptr->size_scaler = 5;
		}
	}

    ptr->velocity += (ptr->velocity / 20);

    y_vel = (ptr->velocity * rsin(ptr->rotation.vx) >> 12);
    temp_vel = (ptr->velocity * rcos(ptr->rotation.vx) >> 12);

    x_vel = (temp_vel * rsin(ptr->rotation.vy) >> 12);
    z_vel = (temp_vel * rcos(ptr->rotation.vy) >> 12);

    ptr->position.vx += x_vel;
    ptr->position.vy += y_vel;
    ptr->position.vz += z_vel;

	ptr->craft_vel.vx = OBJ_players[ctrl_ptr->owner].pobj->v.vx >> 8;
	ptr->craft_vel.vy = OBJ_players[ctrl_ptr->owner].pobj->v.vy >> 8;
	ptr->craft_vel.vz = OBJ_players[ctrl_ptr->owner].pobj->v.vz >> 8;

	ptr->position.vx += ptr->craft_vel.vx;
	ptr->position.vy += ptr->craft_vel.vy;
	ptr->position.vz += ptr->craft_vel.vz;

    SetPolyFT4(&face);
    SetSemiTrans(&face, 1);

	SetTransMatrix(&IDENTITY_MATRIX);

	if (ptr->smoke_flag)
	{
	    face.tpage = GetTPage(0, 2, 704, 256);
		face.clut = GetClut(704, 465);
	}
	else
	{
	    face.tpage = GetTPage(0, 1, 704, 256);
		face.clut = GetClut(704, 462);
	}

    face.r0 = ptr->r;
    face.g0 = ptr->g;
    face.b0 = ptr->b;

    face.u0 = EXP_fire_uv_table[ptr->uv_index][0];
    face.v0 = EXP_fire_uv_table[ptr->uv_index][1];

    face.u1 = EXP_fire_uv_table[ptr->uv_index][2];
    face.v1 = EXP_fire_uv_table[ptr->uv_index][1];

    face.u2 = EXP_fire_uv_table[ptr->uv_index][0];
    face.v2 = EXP_fire_uv_table[ptr->uv_index][3];

    face.u3 = EXP_fire_uv_table[ptr->uv_index][2];
    face.v3 = EXP_fire_uv_table[ptr->uv_index][3];

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_short(&ptr->position, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

		local_position.vx = ptr->position.vx - (CAM_camp[display_loop].vx);
		local_position.vy = ptr->position.vy - (CAM_camp[display_loop].vy);
		local_position.vz = ptr->position.vz - (CAM_camp[display_loop].vz);

	    ApplyMatrixSV(&CAM_camm[display_loop], &local_position, &local_position);

        coord[0].vx = local_position.vx + ((ptr->size_scaler + 1) * (-EXP_fire_uv_table[ptr->uv_index][4] / 2));
        coord[0].vy = local_position.vy + (ptr->size_scaler * (-EXP_fire_uv_table[ptr->uv_index][5] / 2));
        coord[0].vz = local_position.vz;

        coord[1].vx = local_position.vx + ((ptr->size_scaler + 1) * (EXP_fire_uv_table[ptr->uv_index][4] / 2));
        coord[1].vy = local_position.vy + (ptr->size_scaler * (-EXP_fire_uv_table[ptr->uv_index][5] / 2));
        coord[1].vz = local_position.vz;

        coord[2].vx = local_position.vx + ((ptr->size_scaler + 1) * (-EXP_fire_uv_table[ptr->uv_index][4] / 2));
        coord[2].vy = local_position.vy + (ptr->size_scaler * (EXP_fire_uv_table[ptr->uv_index][5] / 2));
        coord[2].vz = local_position.vz;

        coord[3].vx = local_position.vx + ((ptr->size_scaler + 1) * (EXP_fire_uv_table[ptr->uv_index][4] / 2));
        coord[3].vy = local_position.vy + (ptr->size_scaler * (EXP_fire_uv_table[ptr->uv_index][5] / 2));
        coord[3].vz = local_position.vz;

		SetRotMatrix(&IDENTITY_MATRIX);

        z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
                    &coord[3], (long *)&face.x0, (long *)&face.x1,
                    (long *)&face.x2, (long *)&face.x3, &p, &flag);

       	GsSortPoly(&face, ot_ptr, z_position >> otzshift);

		ot_ptr = &Wotwin1[outbuf_idx];
	}

    return;
}

s32 init_new_flamer_flame(FLAMER_CTRL_STRUCT *ctrl_ptr)
{
    FLAMER_FLAME_ANIM       *anim_ptr;
	MATRIX					l2w_matrix;


    anim_ptr = (FLAMER_FLAME_ANIM *)init_flamer_flame_object();

    if (anim_ptr == NULL)
        return FALSE;

    anim_ptr->owner = ctrl_ptr->index;

    anim_ptr->uv_index = 0;
    anim_ptr->timer = 0;
	anim_ptr->smoke_flag = FALSE;
	anim_ptr->size_scaler = 4;
	anim_ptr->increment = 1;
	anim_ptr->delay = 1;
	anim_ptr->update = 1;
	anim_ptr->end_point = MAX_EXP_TIMS;

	anim_ptr->next_flame = NULLVAL;
	anim_ptr->prev_flame = ctrl_ptr->latest_flame;

	if (ctrl_ptr->latest_flame == NULLVAL)
		ctrl_ptr->first_flame = anim_ptr->index;
	else
		PSX_flamer_flames[ctrl_ptr->latest_flame].next_flame = anim_ptr->index;

	ctrl_ptr->latest_flame = anim_ptr->index;

//	if ((ctrl_ptr->ang_diff > 128) && (!anim_ptr->smoke_flag))
//	{
//		if (ctrl_ptr->ang_diff > 128)
//			ctrl_ptr->ang_diff = 128;

//		anim_ptr->r = ctrl_ptr->ang_diff;
//		anim_ptr->g = ctrl_ptr->ang_diff;
//		anim_ptr->b = ctrl_ptr->ang_diff;
//	}
//	else
//	{
	    anim_ptr->r =
	    anim_ptr->g =
	    anim_ptr->b = 8 + (rand() % 16);//56;
//	}

    anim_ptr->rotation.vx = ctrl_ptr->rotation.vx;//- 1024;//940;// + ((rand() % 50) - 25);
    anim_ptr->rotation.vy = ctrl_ptr->rotation.vy;// + ((rand() % 50) - 25);
    anim_ptr->rotation.vz = 0;//ctrl_ptr->rotation.vz;// + 1024;

	anim_ptr->position.vx = 0;
	anim_ptr->position.vy = -35;
 	anim_ptr->position.vz = 125;

    RotMatrix(&anim_ptr->rotation, &l2w_matrix);
    ApplyMatrixSV(&l2w_matrix, &anim_ptr->position, &anim_ptr->position);

 	anim_ptr->velocity = 25 + (rand() % 35);

    anim_ptr->position.vx += ctrl_ptr->current_pos.vx;
    anim_ptr->position.vy += ctrl_ptr->current_pos.vy;
    anim_ptr->position.vz += ctrl_ptr->current_pos.vz;

	anim_ptr->craft_vel.vx = OBJ_players[ctrl_ptr->owner].pobj->v.vx >> 8;
	anim_ptr->craft_vel.vy = OBJ_players[ctrl_ptr->owner].pobj->v.vy >> 8;
	anim_ptr->craft_vel.vz = OBJ_players[ctrl_ptr->owner].pobj->v.vz >> 8;

    return TRUE;
}

s32 PSX_init_plasma_weapon(OBJ_PLAYERSTRUCT *plyr_ptr)
{
    PLASMA_WEAPON           *ptr;
	int						i;


    ptr = (PLASMA_WEAPON *)init_plasma_weapon();

    if (ptr == NULL)
        return FALSE;

	ptr->owner = plyr_ptr->plyrnum;
	ptr->pad = 0;
    ptr->timer = 0;
    ptr->end_point = 150;

	plyr_ptr->plasma_in_use = TRUE;

	ptr->state = active;
	ptr->target_id = NULLVAL;

	ptr->offset.vx = 0;
	ptr->offset.vy = 0;
	ptr->offset.vz = 200;

	init_plasma_orb(ptr, &ptr->orb);

	for (i = 0; i < 2; i++)
	{
		ptr->stream[i].index = i;
		init_plasma_stream(&ptr->stream[i], ptr, plyr_ptr, plyr_ptr->pobj);
	}

	return TRUE;
}

void init_plasma_orb(PLASMA_WEAPON *ctrl_ptr, PLASMA_ORB *ptr)
{
	SetPolyFT4(&ptr->face);
	SetSemiTrans(&ptr->face, 1);

	ptr->face.tpage = GetTPage(0, 3, 704, 256);
	ptr->face.clut = GetClut(704, 449);

	ptr->face.r0 = 128;
	ptr->face.g0 = 128;
	ptr->face.b0 = 255;

	ptr->face.u0 = 64;
	ptr->face.v0 = 126;

	ptr->face.u1 = 127;
	ptr->face.v1 = 126;

	ptr->face.u2 = 64;
	ptr->face.v2 = 189;

	ptr->face.u3 = 127;
	ptr->face.v3 = 189;

	ptr->radius = 100;

	return;
}

void init_plasma_stream(PLASMA_STREAM *ptr, PLASMA_WEAPON *ctrl_ptr, OBJ_PLAYERSTRUCT *plyr_ptr, OBJ_STRUCT *obj_ptr)
{
    s32                     i, j, temp_origin;


	SetPolyGT4(&ptr->face);
	SetSemiTrans(&ptr->face, 1);

	ptr->face.tpage = GetTPage(1, 1, 704, 256);
	ptr->face.clut = GetClut(768, 375);

	ptr->face.u0 = 16;
	ptr->face.v0 = 125;

	ptr->face.u1 = 16;
	ptr->face.v1 = 94;

	ptr->face.u2 = 47;
	ptr->face.v2 = 125;

	ptr->face.u3 = 47;
	ptr->face.v3 = 94;

	ptr->face.r0 = 0;
	ptr->face.g0 = 0;
	ptr->face.b0 = 0;

	ptr->face.r1 = 0;
	ptr->face.g1 = 0;
	ptr->face.b1 = 0;

	if (ptr->index == 0)
	{
		ptr->face.r2 = 24;
		ptr->face.g2 = 48;
		ptr->face.b2 = 164;

		ptr->face.r3 = 24;
		ptr->face.g3 = 48;
		ptr->face.b3 = 164;
	}
	else
	{
		ptr->face.r2 = 164;
		ptr->face.g2 = 48;
		ptr->face.b2 = 24;

		ptr->face.r3 = 164;
		ptr->face.g3 = 48;
		ptr->face.b3 = 24;
	}

    for (i = 0; i < MAX_PLASMA_SECTIONS; i++)
    {
        ptr->section[i].index = i;
	    ptr->section[i].in_use = FALSE;

        ptr->section[i].in_use_x = FALSE;
        ptr->section[i].in_use_y = FALSE;

        ptr->section[i].velocity_x = 0;
        ptr->section[i].velocity_y = 0;

        ptr->section[i].length = PLASMA_SECTION_LENGTH;

        ptr->section[i].position_x = 0;
        ptr->section[i].position_y = 0;

        ptr->section[i].pulse_origin.vx = 0;
        ptr->section[i].pulse_origin.vy = 0;
        ptr->section[i].pulse_origin.vz = 0;

        ptr->section[i].dir_x = FALSE;
        ptr->section[i].dir_y = FALSE;

		ptr->section[i].rotation.vx = obj_ptr->r.vx >> 4;
		ptr->section[i].rotation.vy = obj_ptr->r.vy >> 4;
		ptr->section[i].rotation.vz = obj_ptr->r.vz >> 4;

		if (i == 0)
		{
			ptr->section[i].origin.vx = obj_ptr->p.vx >> 8;
			ptr->section[i].origin.vy = obj_ptr->p.vy >> 8;
			ptr->section[i].origin.vz = obj_ptr->p.vz >> 8;
		}
		else
		{
			ptr->section[i].origin.vy = (obj_ptr->p.vy >> 8) + ((ptr->section[i].length * rsin(ptr->section[i].rotation.vx)) >> 12);
			temp_origin = (ptr->section[i].length * rcos(ptr->section[i].rotation.vx)) >> 12;

			ptr->section[i].origin.vx = (obj_ptr->p.vx >> 8) + ((temp_origin * rsin(ptr->section[i].rotation.vy)) >> 12);
			ptr->section[i].origin.vz = (obj_ptr->p.vz >> 8) + ((temp_origin * rcos(ptr->section[i].rotation.vy)) >> 12);
		}

		ptr->section[i].rot_vec.vx = 0;
		ptr->section[i].rot_vec.vy = 0;
		ptr->section[i].rot_vec.vz = 0;

		ptr->section[i].pulse_id = NULLVAL;

		SetPolyFT4(&ptr->section[i].face);
		SetSemiTrans(&ptr->section[i].face, 1);

		ptr->section[i].face.tpage = GetTPage(1, 1, 704, 256);
		ptr->section[i].face.clut = GetClut(768, 375);

		ptr->section[i].face.u0 = 16;
		ptr->section[i].face.v0 = 125;

		ptr->section[i].face.u1 = 16;
		ptr->section[i].face.v1 = 94;

		ptr->section[i].face.u2 = 47;
		ptr->section[i].face.v2 = 125;

		ptr->section[i].face.u3 = 47;
		ptr->section[i].face.v3 = 94;

		if (ptr->index == 0)
		{
			ptr->section[i].face.r0 = 24;
			ptr->section[i].face.g0 = 48;
			ptr->section[i].face.b0 = 164;
		}
		else
		{
			ptr->section[i].face.r0 = 164;
			ptr->section[i].face.g0 = 48;
			ptr->section[i].face.b0 = 24;
		}
	}

    for (i = 0; i < MAX_PLASMA_PULSES; i++)
    {
        ptr->pulse[i].index = i;
        ptr->pulse[i].in_use = FALSE;

        ptr->pulse[i].velocity = 0;
        ptr->pulse[i].origin = 0;
        ptr->pulse[i].direction = TRUE; //fowards;
        ptr->pulse[i].amplitude = 0;
        ptr->pulse[i].decay = 0;
        ptr->pulse[i].position = ptr->pulse[i].origin;

        ptr->pulse[i].rotation = 0;
        ptr->pulse[i].rot_inc = 0;
    }

    return;
}


s16   plassfxchan=-1;

void PSX_process_plasma_weapon(PLASMA_WEAPON *ptr, OBJ_STRUCT *obj_ptr)
{
	#define						MAX_ROT_ANG				64

	OBJ_STRUCT					*target_ptr;
	PLASMA_STREAM				*str_ptr;
	SVECTOR						cft_orientation;
	MATRIX						cft_matrix;
	int							i, j, x_val, y_val, z_val;
	int							distance, two_d_velocity;
	short						angle, rotation;
	char						result;


	ptr->timer ++;

    if (ptr->timer == ptr->end_point)       //Needs changing, as there are now 3 streams
    {
		ptr->in_use = FALSE;

		OBJ_players[obj_ptr->index].plasma_in_use = FALSE;
	    OBJ_players[obj_ptr->index].pobj->pkup_data.power = 0;

//        //moooo
//        if(obj_ptr->owner==0)
//        {
//         SsUtKeyOffV(plassfxchan);
//            plassfxchan=-1;
//        }

		return;
    }

	if (CAM_cammode[CAM_c] == 2)
	{
		ptr->rotation.vx = (obj_ptr->r.vx >> 4);// - 256;

		ptr->offset.vx = 0;
		ptr->offset.vy = 200;
		ptr->offset.vz = 100;
	}
	else
	{
		ptr->rotation.vx = obj_ptr->r.vx >> 4;

		ptr->offset.vx = 0;
		ptr->offset.vy = 0;
		ptr->offset.vz = 100;
	}

	cft_orientation.vx = ptr->rotation.vx;
	cft_orientation.vy = ptr->rotation.vy;
	cft_orientation.vz = ptr->rotation.vz;

    RotMatrix(&cft_orientation, &cft_matrix);

	cft_matrix.t[0] = 0;
	cft_matrix.t[1] = 0;
	cft_matrix.t[2] = 0;

	ApplyMatrixSV(&cft_matrix, &ptr->offset, &ptr->offset);

	ptr->origin.vx = ptr->offset.vx;
	ptr->origin.vy = ptr->offset.vy;
	ptr->origin.vz = ptr->offset.vz;

	switch (ptr->state)
	{
		case active:

			result = proximity_check(ptr, obj_ptr);

//			if (result == TRUE)
//				break;

 //			if (angle != (obj_ptr->r.vy >> 4))
//			{
//				rotation = vangdiff2(angle, ptr->rotation.vy);
//
//				if (rotation < -MAX_ROT_ANG)
//					ptr->rotation.vy -= MAX_ROT_ANG;
//
//				if (rotation > MAX_ROT_ANG)
//					ptr->rotation.vy += MAX_ROT_ANG;
//
//				if ((rotation < MAX_ROT_ANG) && (rotation > -MAX_ROT_ANG))
//					ptr->rotation.vy = rotation;
//			}
//			else

			if (!result)
				ptr->rotation.vy = obj_ptr->r.vy >> 4;

			ptr->rotation.vz = obj_ptr->r.vz >> 4;

			ptr->origin.vx = obj_ptr->p.vx >> 8;
			ptr->origin.vy = obj_ptr->p.vy >> 8;
			ptr->origin.vz = obj_ptr->p.vz >> 8;

			for (i = 0; i < 2; i++)
			{
				ptr->stream[i].origin.vx = ptr->origin.vx;
				ptr->stream[i].origin.vy = ptr->origin.vy;
				ptr->stream[i].origin.vz = ptr->origin.vz;

				ptr->stream[i].rotation.vx = ptr->rotation.vx;
				ptr->stream[i].rotation.vy = ptr->rotation.vy;
				ptr->stream[i].rotation.vz = ptr->rotation.vz;
			}

			break;

		case tracking:

			target_ptr = &OBJ_objects[ptr->target_id];

			ptr->rotation.vy = obj_ptr->r.vy >> 4;
			ptr->rotation.vz = obj_ptr->r.vz >> 4;

			ptr->origin.vx = obj_ptr->p.vx >> 8;
			ptr->origin.vy = obj_ptr->p.vy >> 8;
			ptr->origin.vz = obj_ptr->p.vz >> 8;

			for (i = 0; i < 2; i++)
			{
				x_val = ((target_ptr->p.vx >> 8) - ptr->stream[i].origin.vx);
				z_val = ((target_ptr->p.vz >> 8) - ptr->stream[i].origin.vz);
				y_val = (((target_ptr->p.vy >> 8) + (50 - (i * 100))) - ptr->stream[i].origin.vy);

				ptr->stream[i].rotation.vx = ratan2(y_val, z_val);
				ptr->stream[i].rotation.vy = ratan2(x_val, z_val);
				ptr->stream[i].rotation.vz = 0;
			}

			for (i = 0; i < 2; i++)
			{
				ptr->stream[i].origin.vy -= (ptr->velocity * rsin(ptr->stream[i].rotation.vx)) >> 12;
				two_d_velocity = (ptr->velocity * rcos(ptr->stream[i].rotation.vx)) >> 12;

				ptr->stream[i].origin.vx -= (two_d_velocity * rsin(ptr->stream[i].rotation.vy)) >> 12;
				ptr->stream[i].origin.vz -= (two_d_velocity * rcos(ptr->stream[i].rotation.vy)) >> 12;
			}

			distance = SquareRoot0((x_val * x_val) + (z_val * z_val));

			if (distance < (2 * ptr->velocity))
				ptr->state = attack;

			break;

		case attack:
			break;

		default:
			break;
	}

	process_plasma_orb(ptr, &ptr->orb);

	for (i = 0; i < 2; i++)
	{
		str_ptr = &ptr->stream[i];

		process_plasma_stream(ptr, str_ptr, obj_ptr);
	}

	for (i = 0; i < 2; i++)
	{
		str_ptr = &ptr->stream[i];

		display_plasma_stream(ptr, str_ptr, obj_ptr, i);
	}

   S2_sfxdynamic( 20, obj_ptr->p.vx>>8, obj_ptr->p.vz>>8 , obj_ptr->index, 120, 4600 );

	return;
}

void process_plasma_stream(PLASMA_WEAPON *ptr, PLASMA_STREAM *str_ptr, OBJ_STRUCT *obj_ptr)
{
	short				rotation;
	int					i, temp_length;



	switch (ptr->state)
	{
		case active:

		for (i = MAX_PLASMA_SECTIONS - 1; i > 0; i --)
//		for (i = 1; i < MAX_PLASMA_SECTIONS; i ++)
		{
//			rotation = vangdiff2(str_ptr->section[i - 1].rotation.vy, str_ptr->section[i].rotation.vy);

//			if (rotation < -MAX_ROT_ANG)
//				str_ptr->section[i].rotation.vy = str_ptr->section[i - 1].rotation.vy + MAX_ROT_ANG;

//			if (rotation > MAX_ROT_ANG)
//				str_ptr->section[i].rotation.vy = str_ptr->section[i - 1].rotation.vy - MAX_ROT_ANG;

//			if ((rotation < MAX_ROT_ANG) && (rotation > -MAX_ROT_ANG))
				str_ptr->section[i].rotation.vy = str_ptr->section[i - 1].rotation.vy;

			str_ptr->section[i].rotation.vx = str_ptr->section[i - 1].rotation.vx;
			str_ptr->section[i].rotation.vz = str_ptr->section[i - 1].rotation.vz;
		}

//		rotation = vangdiff2(str_ptr->rotation.vy, str_ptr->section[0].rotation.vy);

//		if (rotation < -MAX_ROT_ANG)
//			str_ptr->section[0].rotation.vy -= MAX_ROT_ANG;

//		if (rotation > MAX_ROT_ANG)
//			str_ptr->section[0].rotation.vy += MAX_ROT_ANG;

//		if ((rotation < MAX_ROT_ANG) && (rotation > -MAX_ROT_ANG))

		str_ptr->section[0].rotation.vy = str_ptr->rotation.vy;
		str_ptr->section[0].rotation.vx = str_ptr->rotation.vx;
		str_ptr->section[0].rotation.vz = str_ptr->rotation.vz;

		str_ptr->section[0].origin.vy = str_ptr->origin.vy + ((str_ptr->section[0].length * rsin(str_ptr->section[0].rotation.vx)) >> 12);
		temp_length = (str_ptr->section[0].length * rcos(str_ptr->section[0].rotation.vx)) >> 12;

		str_ptr->section[0].origin.vx = str_ptr->origin.vx + ((temp_length * rsin(str_ptr->section[0].rotation.vy)) >> 12);
		str_ptr->section[0].origin.vz = str_ptr->origin.vz + ((temp_length * rcos(str_ptr->section[0].rotation.vy)) >> 12);

		for (i = 1; i < MAX_PLASMA_SECTIONS; i++)
		{
			str_ptr->section[i].origin.vy = str_ptr->section[i - 1].origin.vy + ((str_ptr->section[i].length * rsin(str_ptr->section[i].rotation.vx)) >> 12);
			temp_length = (str_ptr->section[i].length * rcos(str_ptr->section[i].rotation.vx)) >> 12;

			str_ptr->section[i].origin.vx = str_ptr->section[i - 1].origin.vx + ((temp_length * rsin(str_ptr->section[i].rotation.vy)) >> 12);
			str_ptr->section[i].origin.vz = str_ptr->section[i - 1].origin.vz + ((temp_length * rcos(str_ptr->section[i].rotation.vy)) >> 12);
		}

		break;

		case tracking:

//			for (i = MAX_PLASMA_SECTIONS - 1; i > 0; i --)
			for (i = 0; i < (MAX_PLASMA_SECTIONS - 1); i ++)
			{
//				if (str_ptr->section[i - 1].rotation.vy > 0)
//					rotation = vangdiff2((4096 - str_ptr->section[i - 1].rotation.vy), str_ptr->section[i].rotation.vy);
//				else
//					rotation = vangdiff2((4096 + str_ptr->section[i - 1].rotation.vy), str_ptr->section[i].rotation.vy);

//				if (rotation < -MAX_ROT_ANG)
//					str_ptr->section[i].rotation.vy -= rotation;

//				if (rotation > MAX_ROT_ANG)
//					str_ptr->section[i].rotation.vy += rotation;

//				if ((rotation < MAX_ROT_ANG) && (rotation > -MAX_ROT_ANG))
//				str_ptr->section[i].rotation.vy = str_ptr->section[i - 1].rotation.vy;
//				str_ptr->section[i].rotation.vx = str_ptr->section[i - 1].rotation.vx;
//				str_ptr->section[i].rotation.vz = str_ptr->section[i - 1].rotation.vz;
				str_ptr->section[i].rotation.vy = str_ptr->section[i + 1].rotation.vy;
				str_ptr->section[i].rotation.vx = str_ptr->section[i + 1].rotation.vx;
				str_ptr->section[i].rotation.vz = str_ptr->section[i + 1].rotation.vz;

			}

//			if (str_ptr->section[i - 1].rotation.vy > 0)
//				rotation = vangdiff2((4096 - str_ptr->rotation.vy), str_ptr->section[0].rotation.vy);
//			else
//				rotation = vangdiff2((4096 + str_ptr->rotation.vy), str_ptr->section[0].rotation.vy);

//			if (rotation < -MAX_ROT_ANG)
//				str_ptr->section[0].rotation.vy -= rotation;

//			if (rotation > MAX_ROT_ANG)
//				str_ptr->section[0].rotation.vy += rotation;

//			if ((rotation < MAX_ROT_ANG) && (rotation > -MAX_ROT_ANG))
//			str_ptr->section[0].rotation.vy = str_ptr->rotation.vy;
//			str_ptr->section[0].rotation.vx = str_ptr->rotation.vx;
//			str_ptr->section[0].rotation.vz = str_ptr->rotation.vz;
			str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].rotation.vy = str_ptr->rotation.vy;
			str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].rotation.vx = str_ptr->rotation.vx;
			str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].rotation.vz = str_ptr->rotation.vz;

			str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].origin.vy = str_ptr->origin.vy - ((str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].length * rsin(str_ptr->section[0].rotation.vx)) >> 12);
			temp_length = (str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].length * rcos(str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].rotation.vx)) >> 12;

			str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].origin.vx = str_ptr->origin.vx - ((temp_length * rsin(str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].rotation.vy)) >> 12);
			str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].origin.vz = str_ptr->origin.vz - ((temp_length * rcos(str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].rotation.vy)) >> 12);

			for (i = (MAX_PLASMA_SECTIONS - 1); i > 0; i --)
			{
				str_ptr->section[i - 1].origin.vy = str_ptr->section[i].origin.vy - ((str_ptr->section[i - 1].length * rsin(str_ptr->section[i].rotation.vx)) >> 12);
				temp_length = (str_ptr->section[i].length * rcos(str_ptr->section[i - 1].rotation.vx)) >> 12;

				str_ptr->section[i - 1].origin.vx = str_ptr->section[i].origin.vx - ((temp_length * rsin(str_ptr->section[i - 1].rotation.vy)) >> 12);
				str_ptr->section[i - 1].origin.vz = str_ptr->section[i].origin.vz - ((temp_length * rcos(str_ptr->section[i - 1].rotation.vy)) >> 12);
			}

			break;

		default:
			break;
	}

	if (!(ptr->timer % 8))
    {
		if (!(ptr->timer % 16))
		{
            if (str_ptr->index == 0)
                init_pulse(ptr, str_ptr, 512, 50);

            if (str_ptr->index == 1)
                init_pulse(ptr, str_ptr, -512, 50);
		}
		else
		{
		    if (str_ptr->index == 0)	//2
                init_pulse(ptr, str_ptr, -1536, 50);

            if (str_ptr->index == 1)	//3
                init_pulse(ptr, str_ptr, 1536, 50);
		}

    }

    for (i = 0; i < MAX_PLASMA_PULSES; i++)
    {
       if (str_ptr->pulse[i].in_use)
           process_plasma_pulse(ptr, str_ptr, &str_ptr->pulse[i]);
    }

    for (i = 0; i < MAX_PLASMA_SECTIONS; i++)
    {
        if (str_ptr->section[i].in_use)
            process_plasma_packet(ptr, str_ptr, &str_ptr->section[i]);
    }

	return;
}

void display_plasma_stream(PLASMA_WEAPON *ptr, PLASMA_STREAM *str_ptr, OBJ_STRUCT *obj_ptr, char index)
{
	int							display_loop, i, j, k;
	char						in_range;
	SVECTOR						coord[(MAX_PLASMA_SECTIONS * 2) + 2];
	SVECTOR						diff, camera_orientation, cam_origin;
	GsOT						*ot_ptr;
	int							x_offset, y_offset;
	long						z_position, p, flag;


	ot_ptr = &Wotwin0[outbuf_idx];
/*
	for (i = 0; i < MAX_PLASMA_SECTIONS; i++)
	{
	    str_ptr->section[i].face.u0 += 3;
	    str_ptr->section[i].face.u1 += 3;
	    str_ptr->section[i].face.u2 += 3;
	    str_ptr->section[i].face.u3 += 3;

	    if (str_ptr->section[i].face.u0 == 49)
	    {
	        str_ptr->section[i].face.u0 = 31;
	        str_ptr->section[i].face.u1 = 31;
	        str_ptr->section[i].face.u2 = 16;
	        str_ptr->section[i].face.u3 = 16;
	    }
	}

    str_ptr->face.u0 += 3;
    str_ptr->face.u1 += 3;
    str_ptr->face.u2 += 3;
    str_ptr->face.u3 += 3;

    if (str_ptr->face.u0 == 49)
    {
        str_ptr->face.u0 = 31;
        str_ptr->face.u1 = 31;
        str_ptr->face.u2 = 16;
        str_ptr->face.u3 = 16;
    }
*/
	for (display_loop = 0; display_loop < STATE.numscreens; display_loop ++)
	{
		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

		for (index = 0; index < 2; index++)	   //as stream is cross faced
		{
	        for (i = 2, j = 0; j < MAX_PLASMA_SECTIONS; i += 2, j++)
	        {
				if (j == 0)
				{
					in_range = clip_point_short(&str_ptr->origin, display_loop);

					if (!in_range)
						continue;

					cam_origin.vx = str_ptr->origin.vx - CAM_camp[display_loop].vx;
					cam_origin.vy = str_ptr->origin.vy - CAM_camp[display_loop].vy;
					cam_origin.vz = str_ptr->origin.vz - CAM_camp[display_loop].vz;

					ApplyMatrixSV(&CAM_camm[display_loop], &cam_origin, &cam_origin);

					if (index == 0)
					{
						x_offset = 35;// - (transform_timer * 5);
						y_offset = 0;
					}
					else
					{
						x_offset = 0;
						y_offset = 35;// - (transform_timer * 5);
					}

			 		coord[0].vx = cam_origin.vx + x_offset;
			        coord[0].vy = cam_origin.vy + y_offset;
			        coord[0].vz = cam_origin.vz;

			        coord[1].vx = cam_origin.vx - x_offset;
			        coord[1].vy = cam_origin.vy - y_offset;
			        coord[1].vz = cam_origin.vz;
				}

				in_range = clip_point_short(&str_ptr->section[j].origin, display_loop);

				if (!in_range)
					continue;

				cam_origin.vx = str_ptr->section[j].origin.vx - CAM_camp[display_loop].vx;
				cam_origin.vy = str_ptr->section[j].origin.vy - CAM_camp[display_loop].vy;
				cam_origin.vz = str_ptr->section[j].origin.vz - CAM_camp[display_loop].vz;

				ApplyMatrixSV(&CAM_camm[display_loop], &cam_origin, &cam_origin);

				diff.vx = str_ptr->section[j].position_x;
				diff.vy = str_ptr->section[j].position_y;
				diff.vz = 0;

				if (index == 0)
				{
					x_offset = (35 - (j * 3));
					y_offset = 0;
				}
				else
				{
					x_offset = 0;
					y_offset = (35 - (j * 3));
				}

		   		coord[i].vx = (cam_origin.vx + diff.vx) + x_offset;
	            coord[i].vy = (cam_origin.vy + diff.vy) + y_offset;
	            coord[i].vz = cam_origin.vz;

	            coord[i + 1].vx = (cam_origin.vx + diff.vx) - x_offset;
	            coord[i + 1].vy = (cam_origin.vy + diff.vy) - y_offset;
	            coord[i + 1].vz = cam_origin.vz;

				SetRotMatrix(&IDENTITY_MATRIX);
				SetTransMatrix(&IDENTITY_MATRIX);

				if (j == 0)
				{
			        z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
			                     &coord[3], (long *)&str_ptr->face.x0,
			                     (long *)&str_ptr->face.x1,
			                     (long *)&str_ptr->face.x2,
			                     (long *)&str_ptr->face.x3, &p, &flag);

					if (!((flag & 0x80000000) == 1))
			       		GsSortPoly(&str_ptr->face, ot_ptr, z_position >> otzshift);
				}
				else
				{
			        z_position = RotTransPers4(&coord[i - 2], &coord[i - 1], &coord[i],
			                        &coord[i + 1], (long *)&str_ptr->section[j].face.x0,
			                        (long *)&str_ptr->section[j].face.x1,
			                        (long *)&str_ptr->section[j].face.x2,
			                        (long *)&str_ptr->section[j].face.x3, &p, &flag);

					if (!((flag & 0x80000000) == 1))
			    	   	GsSortPoly(&str_ptr->section[j].face, ot_ptr, z_position >> otzshift);
				}
	        }
		}

		ot_ptr = &Wotwin1[outbuf_idx];
	}

	return;
}

void process_plasma_orb(PLASMA_WEAPON *ptr, PLASMA_ORB *orb_ptr)
{
	GsOT					*ot_ptr;
	SVECTOR					coord[4];
	SVECTOR					camera_orientation, cam_origin;
	int						i, display_loop, width;
	long					z_position, flag, p;
	char					in_range;


	if (ptr->state == tracking)
	{
		if (orb_ptr->face.r0 == 0)
			return;
		else
		{
			orb_ptr->face.r0 -=	4;
			orb_ptr->face.g0 -=	4;
			orb_ptr->face.b0 -=	8;
		}
	}

	orb_ptr->radius = 100;

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_short(&ptr->origin, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

  		cam_origin.vx = ptr->origin.vx - CAM_camp[display_loop].vx;
	    cam_origin.vy = ptr->origin.vy - CAM_camp[display_loop].vy;
	    cam_origin.vz = ptr->origin.vz - CAM_camp[display_loop].vz;

    	ApplyMatrixSV(&CAM_camm[display_loop], &cam_origin, &cam_origin);

		for (i = 0; i < 4; i++)
		{
	  		coord[i].vx = cam_origin.vx;
		    coord[i].vy = cam_origin.vy;
		    coord[i].vz = cam_origin.vz;
		}

		coord[0].vx -= orb_ptr->radius;
		coord[0].vy -= orb_ptr->radius;

		coord[1].vx += orb_ptr->radius;
		coord[1].vy -= orb_ptr->radius;

		coord[2].vx -= orb_ptr->radius;
		coord[2].vy += orb_ptr->radius;

		coord[3].vx += orb_ptr->radius;
		coord[3].vy += orb_ptr->radius;

	    SetTransMatrix(&IDENTITY_MATRIX);
	    SetRotMatrix(&IDENTITY_MATRIX);

	    z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
	                    &coord[3], (long *)&orb_ptr->face.x0,
	                    (long *)&orb_ptr->face.x1, (long *)&orb_ptr->face.x2,
	                    (long *)&orb_ptr->face.x3, &p, &flag);

	   	GsSortPoly(&orb_ptr->face, ot_ptr, z_position >> otzshift);
	   	GsSortPoly(&orb_ptr->face, ot_ptr, z_position >> otzshift);

		ot_ptr = &Wotwin1[outbuf_idx];
	}

	return;
}
/*
void PSX_process_plasma_stream(PLASMA_WEAPON *ptr, OBJ_STRUCT *obj_ptr)
{
    SVECTOR       			camera_orientation;
	SVECTOR					local_origin;

    PLASMA_STREAM           *fx_ptr, *last;
    SVECTOR                 coord[MAX_PLASMA_SECTIONS * 2];
    SVECTOR                 coord2[MAX_PLASMA_SECTIONS * 2];
    POLY_FT4                face_data, face;
    long                    z_position, p, flag, i, j, k;
	long					temp_origin, display_loop, in_range;
	GsOT					*ot_ptr;
	int						rotation, ian, z, plasma_length, coll;
	int						x_pos, y_pos, z_pos, temp_pos, offset, width;
	MATRIX					rot_matrix, craft_matrix;
	SVECTOR					diff, craft_orientation, front, craft_pos;
	vec32					f1, c_pos;
	s32						display_loop_start, display_loop_end;


	if( (obj_ptr->owner==0) && (plassfxchan==-1) )
    	plassfxchan=SOUND_sfx( 20 );

	offset = 200;

    y_pos = (offset * rsin(obj_ptr->r.vx >> 4) >> 12);
    temp_pos = (offset * rcos(obj_ptr->r.vx >> 4) >> 12);

    x_pos = (temp_pos * rsin(obj_ptr->r.vy >> 4) >> 12);
    z_pos = (temp_pos * rcos(obj_ptr->r.vy >> 4) >> 12);

    for (k = 0; k < 2; k++)
    {
        if (!(k))
        {
            fx_ptr = &PSX_plasma[obj_ptr->fx_id];

            last = &PSX_plasma[fx_ptr->next];
        }
        else
        {
            fx_ptr = last;

            if (fx_ptr->next != NULLVAL)
                last = &PSX_plasma[fx_ptr->next];
        }

        if (fx_ptr->timer == fx_ptr->end)       //Needs changing, as there are now 3 streams
        {
           	for (i = 0; i < MAX_PLASMAS; i++)
			{
				if (PSX_plasma[i].owner == obj_ptr->index)
					PSX_plasma[i].in_use = FALSE;
			}

            OBJ_delobj(obj_ptr->index);
            //moooo
            if(obj_ptr->owner==0)
               {
               SsUtKeyOffV(plassfxchan);
               plassfxchan=-1;
               }

        }

        fx_ptr->timer++;
	        fx_ptr->u0 = 31;
	        fx_ptr->u1 = 31;
	        fx_ptr->u2 = 16;
	        fx_ptr->u3 = 16;

		face_data.u0 = fx_ptr->u0;
		face_data.u1 = fx_ptr->u1;
		face_data.u2 = fx_ptr->u2;
		face_data.u3 = fx_ptr->u3;

  		if (!(fx_ptr->timer % 8))
        {
			if (!(fx_ptr->timer % 16))
			{
	            if (k == 0)
	                init_pulse(fx_ptr, 512, 25);

	            if (k == 1)
	                init_pulse(fx_ptr, -512, 25);
			}
			else
			{
			    if (k == 0)	//2
	                init_pulse(fx_ptr, -1536, 25);

	            if (k == 1)	//3
	                init_pulse(fx_ptr, 1536, 25);
			}

        }

		for (i = MAX_PLASMA_SECTIONS - 1; i > 0; i --)
		{
			fx_ptr->section[i].rotation.vx = fx_ptr->section[i - 1].rotation.vx;
			fx_ptr->section[i].rotation.vy = fx_ptr->section[i - 1].rotation.vy;
			fx_ptr->section[i].rotation.vz = fx_ptr->section[i - 1].rotation.vz;

			fx_ptr->section[i].origin.vy = (OBJ_objects[obj_ptr->owner].p.vy >> 8) + ((fx_ptr->section[i].length * rsin(fx_ptr->section[i].rotation.vx)) >> 12);
			temp_origin = (fx_ptr->section[i].length * rcos(fx_ptr->section[i].rotation.vx)) >> 12;

			fx_ptr->section[i].origin.vx = (OBJ_objects[obj_ptr->owner].p.vx >> 8) + ((temp_origin * rsin(fx_ptr->section[i].rotation.vy)) >> 12);
			fx_ptr->section[i].origin.vz = (OBJ_objects[obj_ptr->owner].p.vz >> 8) + ((temp_origin * rcos(fx_ptr->section[i].rotation.vy)) >> 12);
		}

		rotation = proximity_check(obj_ptr);

		fx_ptr->section[0].rotation.vx = OBJ_objects[obj_ptr->owner].r.vx >> 4;
		fx_ptr->section[0].rotation.vy = rotation;
		fx_ptr->section[0].rotation.vz = OBJ_objects[obj_ptr->owner].r.vz >> 4;

		fx_ptr->section[0].origin.vx = obj_ptr->p.vx >> 8;//OBJ_objects[obj_ptr->owner].p.vx >> 8;
		fx_ptr->section[0].origin.vy = obj_ptr->p.vy >> 8;//OBJ_objects[obj_ptr->owner].p.vy >> 8;
		fx_ptr->section[0].origin.vz = obj_ptr->p.vz >> 8;//OBJ_objects[obj_ptr->owner].p.vz >> 8;

        for (i = 0; i < MAX_PLASMA_PULSES; i++)
        {
           if (fx_ptr->pulse[i].in_use)
               process_plasma_pulse(fx_ptr, &fx_ptr->pulse[i]);
        }

        for (i = 0; i < MAX_PLASMA_SECTIONS; i++)
        {
            if (fx_ptr->section[i].in_use)
                process_plasma_packet(fx_ptr, &fx_ptr->section[i]);
        }

		ot_ptr = &Wotwin0[outbuf_idx];

		in_range = clip_point_short(&fx_ptr->section[0].origin, 0);

		if (!in_range)
		{
			display_loop_start = 1;

			if (STATE.numscreens == 2)
				display_loop_end = 2;
	 		else
				display_loop_end = 1;

	 		in_range = clip_point_short(&fx_ptr->section[0].origin, 1);

			if (!in_range)
				return;
		}
		else
		{
			display_loop_start = 0;

			if (STATE.numscreens == 2)
			{
				in_range = clip_point_short(&fx_ptr->section[0].origin, 1);

				if (!in_range)
					display_loop_end = 1;
				else
					display_loop_end = 2;
			}
			else
				display_loop_end = 1;
		}

		for (display_loop = display_loop_start; display_loop < display_loop_end; display_loop ++)
		{
			camera_orientation.vx = CAM_came[display_loop].vx >> 4;
			camera_orientation.vy = CAM_came[display_loop].vy >> 4;
			camera_orientation.vz = CAM_came[display_loop].vz >> 4;

		    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

	        for (i = 2, j = 0; i < (MAX_PLASMA_SECTIONS * 2); i += 2, j++)
	        {
				in_range = clip_point_short(&fx_ptr->section[j].origin, display_loop);

				if (!in_range)
					continue;

				local_origin.vx = fx_ptr->section[j].origin.vx - (CAM_camp[display_loop].vx);
				local_origin.vy = fx_ptr->section[j].origin.vy - (CAM_camp[display_loop].vy);
				local_origin.vz = fx_ptr->section[j].origin.vz - (CAM_camp[display_loop].vz);

				ApplyMatrixSV(&CAM_camm[display_loop], &local_origin, &local_origin);

				diff.vx = fx_ptr->section[j].position_x;
				diff.vy = fx_ptr->section[j].position_y;
				diff.vz = 0;

         		coord[i].vx = (local_origin.vx + diff.vx) - (35 - (j * (5 / 2)));//fx_ptr->section[j].position_x) - 30;
	            coord[i].vy = (local_origin.vy + diff.vy);//fx_ptr->section[j].position_y);
	            coord[i].vz = local_origin.vz;

	            coord[i + 1].vx = (local_origin.vx + diff.vx) + (35 - (j * (5 / 2)));//fx_ptr->section[j].position_x) + 30;
	            coord[i + 1].vy = (local_origin.vy + diff.vy);//fx_ptr->section[j].position_y);
	            coord[i + 1].vz = local_origin.vz;
	        }

  			local_origin.vx = fx_ptr->section[0].origin.vx - (CAM_camp[display_loop].vx);
			local_origin.vy = fx_ptr->section[0].origin.vy - (CAM_camp[display_loop].vy);
 			local_origin.vz = fx_ptr->section[0].origin.vz - (CAM_camp[display_loop].vz);

		    ApplyMatrixSV(&CAM_camm[display_loop], &local_origin, &local_origin);

			diff.vx = fx_ptr->section[0].position_x;
			diff.vy = fx_ptr->section[0].position_y;
			diff.vz = 0;

	        coord[0].vx = (local_origin.vx);
	        coord[0].vy = (local_origin.vy);
	        coord[0].vz = local_origin.vz;

	        coord[1].vx = (local_origin.vx);
	        coord[1].vy = (local_origin.vy);
	        coord[1].vz = local_origin.vz;

	        coord[MAX_PLASMA_SECTIONS * 2 - 2].vx += 30;
	        coord[MAX_PLASMA_SECTIONS * 2 - 1].vx -= 30;

	        for (i = 2, j = 0; i < (MAX_PLASMA_SECTIONS * 2); i += 2, j++)
	        {
				local_origin.vx = fx_ptr->section[j].origin.vx - (CAM_camp[display_loop].vx);
				local_origin.vy = fx_ptr->section[j].origin.vy - (CAM_camp[display_loop].vy);
				local_origin.vz = fx_ptr->section[j].origin.vz - (CAM_camp[display_loop].vz);

			    ApplyMatrixSV(&CAM_camm[display_loop], &local_origin, &local_origin);

				diff.vx = fx_ptr->section[j].position_x;
				diff.vy = fx_ptr->section[j].position_y;
				diff.vz = 0;

	            coord2[i].vx = (local_origin.vx + diff.vx);//fx_ptr->section[j].position_x);
	            coord2[i].vy = (local_origin.vy + diff.vy) - (35 - (j * (5 / 2)));//fx_ptr->section[j].position_y) - 30;
	            coord2[i].vz = local_origin.vz;

	            coord2[i + 1].vx = (local_origin.vx + diff.vx);//fx_ptr->section[j].position_x);
	            coord2[i + 1].vy = (local_origin.vy + diff.vy) + (35 - (j * (5 / 2)));//fx_ptr->section[j].position_y) + 30;
	            coord2[i + 1].vz = local_origin.vz;
	        }

			local_origin.vx = fx_ptr->section[0].origin.vx - (CAM_camp[display_loop].vx);
			local_origin.vy = fx_ptr->section[0].origin.vy - (CAM_camp[display_loop].vy);
			local_origin.vz = fx_ptr->section[0].origin.vz - (CAM_camp[display_loop].vz);

		    ApplyMatrixSV(&CAM_camm[display_loop], &local_origin, &local_origin);

			diff.vx = fx_ptr->section[0].position_x;
			diff.vy = fx_ptr->section[0].position_y;
			diff.vz = 0;

	        coord2[0].vx = (local_origin.vx);
	        coord2[0].vy = (local_origin.vy);
	        coord2[0].vz = local_origin.vz;

	        coord2[1].vx = (local_origin.vx);
	        coord2[1].vy = (local_origin.vy);
	        coord2[1].vz = local_origin.vz;

	        coord2[MAX_PLASMA_SECTIONS * 2 - 2].vy += 30;
	        coord2[MAX_PLASMA_SECTIONS * 2 - 1].vy -= 30;

	        if ((k == 3) || (k == 1))
	        {
		   	    face_data.r0 = 24;
		    	face_data.g0 = 48;
	    		face_data.b0 = 164;
			}
			else
	        {
		   	    face_data.r0 = 164;
		    	face_data.g0 = 48;
	    		face_data.b0 = 24;
			}

			SetRotMatrix(&IDENTITY_MATRIX);

	        for (i = 0, j = 0; i < ((MAX_PLASMA_SECTIONS - 3) * 2); i += 2, j ++)
	        {
	            z_position = RotTransPers4(&coord[i], &coord[i + 1], &coord[i + 2],
	                            &coord[i + 3], (long *)&face_data.x0, (long *)&face_data.x1,
	                            (long *)&face_data.x2, (long *)&face_data.x3, &p, &flag);

	           	GsSortPoly(&face_data, ot_ptr, z_position >> otzshift);

	            z_position = RotTransPers4(&coord2[i], &coord2[i + 1], &coord2[i + 2],
	                            &coord2[i + 3], (long *)&face_data.x0, (long *)&face_data.x1,
	                            (long *)&face_data.x2, (long *)&face_data.x3, &p, &flag);

	           	GsSortPoly(&face_data, ot_ptr, z_position >> otzshift);
	        }

			ot_ptr = &Wotwin1[outbuf_idx];
		}
    }

    return;
}
*/

int proximity_check(PLASMA_WEAPON *wpn_ptr, OBJ_STRUCT *obj_ptr)
{
	#define					PLASMA_RANGE				512

	OBJ_PLAYERSTRUCT		*plyr_ptr;
	OBJ_STRUCT				*plyr_obj_ptr;
	int						i, j, x_val, z_val, distance, closest_distance, target_id;
	short					angle, rotation;
	vec32					impact_vector;


	closest_distance = MAX_PLASMA_LENGTH * 2;
	target_id = NULLVAL;

	for (i = 0; i <  STATE.wankers; i++)
	{
		plyr_obj_ptr = OBJ_players[i].pobj;

		if (plyr_obj_ptr->index == obj_ptr->index)
			continue;

		x_val = (plyr_obj_ptr->p.vx >> 8) - (obj_ptr->p.vx >> 8);
		z_val = (plyr_obj_ptr->p.vz >> 8) - (obj_ptr->p.vz >> 8);

		angle = ratan2(x_val, z_val);

		rotation = vangdiff2(angle, (obj_ptr->r.vy >> 4));

		if (abs(rotation) > PLASMA_RANGE)
			continue;
		else
		{
			distance = SquareRoot0((x_val * x_val) + (z_val * z_val));

			if (distance < closest_distance)
			{
				closest_distance = distance;
				target_id = i;

				wpn_ptr->rotation.vy = angle;

//				wpn_ptr->target_id = i;

//				wpn_ptr->state = tracking;
//				wpn_ptr->transform_timer = 0;
//				wpn_ptr->velocity = 25;

//				for (j = 0; j < 2; j++)
//				{
//					wpn_ptr->stream[j].origin.vx = wpn_ptr->stream[j].section[(MAX_PLASMA_SECTIONS - 1)].origin.vx;
//					wpn_ptr->stream[j].origin.vy = wpn_ptr->stream[j].section[(MAX_PLASMA_SECTIONS - 1)].origin.vy;
//					wpn_ptr->stream[j].origin.vz = wpn_ptr->stream[j].section[(MAX_PLASMA_SECTIONS - 1)].origin.vz;
//				}
			}
		}
	}

	if (target_id != NULLVAL)
	{
	    plyr_ptr = &OBJ_players[target_id];

 		OBJ_damage_player(plyr_ptr, obj_ptr, TRUE);
	}

	if (target_id == NULLVAL)
		return FALSE;
	else
		return TRUE;

/*	plyr_rot.vx = obj_ptr->r.vx >> 4;
	plyr_rot.vy = obj_ptr->r.vy >> 4;
	plyr_rot.vz = obj_ptr->r.vz >> 4;

    RotMatrix(&plyr_rot, &rot_matrix);

	max_distance = MAX_PLASMA_LENGTH;
	final_angle = 0;
	detection = FALSE;

	for (i = 0; i <  STATE.wankers; i++)
	{
		ptr = &OBJ_objects[OBJ_players[i].pobj->index];

		if (obj_ptr->owner == i)
			continue;

		diff.vx = (ptr->p.vx >> 8) - (obj_ptr->p.vx >> 8);
		diff.vy = (ptr->p.vy >> 8) - (obj_ptr->p.vy >> 8);
		diff.vz = (ptr->p.vz >> 8) - (obj_ptr->p.vz >> 8);

		distance = SquareRoot0((diff.vx * diff.vx) + (diff.vz * diff.vz));

		if (distance > max_distance)
			continue;

//	    ApplyMatrixSV(&rot_matrix, &diff, &diff);

		angle = ratan2(diff.vx, diff.vz) << 4;

		if ((angle > (obj_ptr->r.vy - 8192)) && (angle < (obj_ptr->r.vy + 8192)))
		{
			if (!detection)
			{
				final_angle = angle >> 4;

				detection = TRUE;

				wpn_ptr->state = tracking;
				wpn_ptr->target_id = i;

				for (loop = 0; loop < 2; loop++)
					reverse_stream(wpn_ptr, &wpn_ptr->stream[loop]);

	            plyr_ptr = &OBJ_players[i];

	            //OPSX_init_new_explosion(&OBJ_objects[i], obj_ptr->pkup_data.type , OTHER_COLLISION);
			   	if (plyr_ptr->shield_strength)
			   	{
					if (plyr_ptr->shield_strength >= obj_ptr->pkup_data.power)
			        {
			        	plyr_ptr->shield_strength -= obj_ptr->pkup_data.power;
			        	impact_vector.vx = plyr_ptr->pobj->p.vx;
			        	impact_vector.vy = plyr_ptr->pobj->p.vy;
			        	impact_vector.vz = plyr_ptr->pobj->p.vz;
			        	PSX_init_shield_effect(plyr_ptr, &impact_vector);
			        }
			   	}
			   	else
			   	{
			   		plyr_ptr->armour_level -= obj_ptr->pkup_data.power;

			      	if (plyr_ptr->armour_level <= 0)
			        {
					 	if ((obj_ptr->owner > NULLVAL) && (obj_ptr->owner < 8))
							OBJ_players[obj_ptr->owner].frag_count ++;

						OPSX_init_new_explosion(plyr_ptr->pobj, craft_explosion, OTHER_COLLISION);
//						OBJ_delobj(plyr_ptr->pobj->index);
			        	printf("You're dead player %d!\n", plyr_ptr->plyrnum);
			         	FntPrint("You're dead!\n");
			    		OBJ_initplayer( plyr_ptr->plyrnum, plyr_ptr->crafttype, plyr_ptr->computer );
			        }
			    }
			}
			else
			{
				if (abs((angle >> 4)) < abs(final_angle))
					final_angle = angle >> 4;
			}
		}

//		if (abs(angle) > 1024)
//			continue;

//		if (distance > 10000)
//			continue;

//		if (distance < max_distance)
//			max_distance = distance;
	}

//	if (max_distance < 10001)
	if (detection)
		return final_angle;
	else
		return (obj_ptr->r.vy >> 4);
//	else
//		return 0;
*/
}

void reverse_stream(PLASMA_WEAPON *ptr, PLASMA_STREAM *str_ptr)
{
	int							i;
	return;
	for (i = 0; i < (MAX_PLASMA_SECTIONS - 1); i ++)
	{
		if (str_ptr->section[i + 1].rotation.vy > 0)
			str_ptr->section[i].rotation.vy = 4096 - str_ptr->section[i + 1].rotation.vy;
		else
			str_ptr->section[i].rotation.vy = 4096 + str_ptr->section[i + 1].rotation.vy;
	}

	str_ptr->section[(MAX_PLASMA_SECTIONS - 1)].rotation.vy = ptr->rotation.vy;

	return;
}

void init_pulse(PLASMA_WEAPON *wpn_ptr, PLASMA_STREAM *fx_ptr, int rot, int amp)
{
    s16                 i;
    PLASMA_PULSE        *ptr;


//	printf2("rot_inc = %d\nrot_val = %d\n\n", rot_inc, rot_vec.vz);

//	rot_inc = 0;
//	rot_vec.vz = 0;

    for (i = 0; i < MAX_PLASMA_PULSES; i++)
    {
        ptr = &fx_ptr->pulse[i];

        if (!(ptr->in_use))
        {
            ptr->in_use = TRUE;

            ptr->velocity = 1;
            ptr->origin = 0;
            ptr->direction = TRUE; //fowards;
            ptr->amplitude = amp;
            ptr->decay = 0;
            ptr->position = ptr->origin;

            ptr->rotation = rot;
            ptr->rot_inc = 0;//(4096 / MAX_PLASMA_SECTIONS);

			ptr->rot_val = 0;
            ptr->rot_inc_val = 0;//(4096 / MAX_PLASMA_SECTIONS);

			if (!(wpn_ptr->timer % 24))
				ptr->rot_sign = FALSE;
			else
				ptr->rot_sign = TRUE;

            return;
        }
    }

    return;
}

void process_plasma_pulse(PLASMA_WEAPON *wpn_ptr, PLASMA_STREAM *str_ptr, PLASMA_PULSE *ptr)
{
    PLASMA_PKT          *pkt_ptr;


    if (!(wpn_ptr->timer % ptr->velocity))
    {
        pkt_ptr = &str_ptr->section[ptr->position];

        pkt_ptr->in_use_x = TRUE;
        pkt_ptr->in_use_y = TRUE;

        if (!(pkt_ptr->in_use))
        {
            pkt_ptr->in_use = TRUE;

            pkt_ptr->velocity_x = (ptr->amplitude * rsin(ptr->rotation)) >> 12;
            pkt_ptr->velocity_y = (ptr->amplitude * rcos(ptr->rotation)) >> 12;

            if (pkt_ptr->velocity_x > 0)
                pkt_ptr->dir_x = TRUE;
            else
                pkt_ptr->dir_x = FALSE;

            if (pkt_ptr->velocity_y > 0)
                pkt_ptr->dir_y = TRUE;
            else
                pkt_ptr->dir_y = FALSE;
        }
        else
        {
            pkt_ptr->velocity_x += (ptr->amplitude * rsin(ptr->rotation)) >> 12;
            pkt_ptr->velocity_y += (ptr->amplitude * rcos(ptr->rotation)) >> 12;
        }

        if (ptr->direction)
        {
            ptr->position ++;

            if (ptr->position == MAX_PLASMA_SECTIONS)
                ptr->in_use = FALSE;
            else
            {
//				if (ptr->position < 3)
//    	            ptr->amplitude += 15;
//				else
//				{
                	ptr->amplitude -= ptr->decay;
                	ptr->rotation += ptr->rot_inc;
//                }

                if (ptr->amplitude <= 0)
                    ptr->in_use = FALSE;
            }
        }
        else
        {
            ptr->position --;

            if (ptr->position == 0)
                ptr->in_use = FALSE;
            else
            {
                ptr->amplitude -= ptr->decay;
                ptr->rotation += ptr->rot_inc;

                if (ptr->amplitude <= 0)
                    ptr->in_use = FALSE;
            }
        }
    }

	pkt_ptr->pulse_id = ptr->index;

	if (ptr->rot_sign)
		ptr->rot_val += ptr->rot_inc_val;
	else
		ptr->rot_val -= ptr->rot_inc_val;

	ptr->rot_inc_val += 0;

    return;
}

void process_plasma_packet(PLASMA_WEAPON *wpn_ptr, PLASMA_STREAM *str_ptr, PLASMA_PKT *ptr)
{
	if (ptr->pulse_id != NULLVAL)
		ptr->rot_vec.vz = str_ptr->pulse[ptr->pulse_id].rot_val;//(4096 / 15) * ptr->index;
	else
		ptr->rot_vec.vz = 0;

    if (!(wpn_ptr->timer % str_ptr->pulse[ptr->pulse_id].velocity))
    {
  	    ptr->position_x += ptr->velocity_x;
	    ptr->position_y += ptr->velocity_y;

	    if (ptr->dir_x)
	    {
	        if (ptr->position_x <= ptr->pulse_origin.vx)
	        {
	            ptr->in_use_x = FALSE;

	            ptr->velocity_x = 0;
	            ptr->position_x = ptr->pulse_origin.vx;
	        }
	        else
	            ptr->velocity_x -= 12;//POINT_DECAY;
	    }
	    else
	    {
	        if (ptr->position_x >= ptr->pulse_origin.vx)
	        {
	            ptr->in_use_x = FALSE;

	            ptr->velocity_x = 0;
	            ptr->position_x = ptr->pulse_origin.vx;
	        }
	        else
	            ptr->velocity_x += 12;//POINT_DECAY;
	    }

	    if (ptr->dir_y)
	    {
	        if (ptr->position_y <= ptr->pulse_origin.vy)
	        {
	            ptr->in_use_y = FALSE;

	            ptr->velocity_y = 0;
	            ptr->position_y = ptr->pulse_origin.vy;
	        }
	        else
	            ptr->velocity_y -= 12;//POINT_DECAY;
	    }
	    else
	    {
	        if (ptr->position_y >= ptr->pulse_origin.vy)
	        {
	            ptr->in_use_y = FALSE;

	            ptr->velocity_y = 0;
	            ptr->position_y = ptr->pulse_origin.vy;
	        }
	        else
	            ptr->velocity_y += 12;//POINT_DECAY;
	    }

	    if ((!(ptr->in_use_y)) && (!(ptr->in_use_x)))
	    {
	        ptr->in_use = FALSE;
			ptr->pulse_id = NULLVAL;
		}
	}

    return;
}
//start of new gas
s32 PSX_init_gas_cloud(OBJ_STRUCT *obj_ptr)
{
    GAS_CTRL_STRUCT   *ctrl_ptr;

    ctrl_ptr = (GAS_CTRL_STRUCT *)init_gas_ctrl_struct();
    if (ctrl_ptr == NULL)
        return FALSE;

	ctrl_ptr->fuel_level = 250;

    ctrl_ptr->owner = obj_ptr->owner;

	ctrl_ptr->first_flame = NULLVAL;
	ctrl_ptr->latest_flame = NULLVAL;

    ctrl_ptr->finished = FALSE;
   	ctrl_ptr->timer = 0;

	ctrl_ptr->origin.vx = obj_ptr->p.vx >> 8;
	ctrl_ptr->origin.vy = obj_ptr->p.vy >> 8;
	ctrl_ptr->origin.vz = obj_ptr->p.vz >> 8;

   S2_sfxdynamic( 21, obj_ptr->p.vx>>8, obj_ptr->p.vz>>8, 0, 126, 4600 );

	obj_ptr->type = OTgas_cloud;
//	obj_ptr->str_id = ctrl_ptr->index;
	ctrl_ptr->obj_index = obj_ptr->index;

    return TRUE;
}

void PSX_process_gas_cloud(GAS_CTRL_STRUCT *ctrl_ptr)
{
    GAS_FLAME_ANIM 		  	*ptr;
    OBJ_PICKUP		        *pk_ptr;
	OBJ_PLAYERSTRUCT		*plyr_ptr;
	s32						success, ian;

//	GsClearVcount();


	ctrl_ptr->timer ++;

	plyr_ptr = &OBJ_players[ctrl_ptr->owner];

	if (ctrl_ptr->first_flame != NULLVAL)
	{
		ptr = &PSX_gas_flames[ctrl_ptr->first_flame];

		update_gas_flame(ptr, ctrl_ptr);

		while (ptr->next_flame != NULLVAL)
		{
			ptr = &PSX_gas_flames[ptr->next_flame];

			update_gas_flame(ptr, ctrl_ptr);
		}
	}

	if ((ctrl_ptr->fuel_level > 0) && (!(ctrl_ptr->timer % 2)))
	{
        success = init_new_gas_flame(ctrl_ptr);

		if (success)
			ctrl_ptr->fuel_level --;
	}

//	ian = GsGetVcount();
//	FntPrint("gas = %d\n", ian);

	return;
}

void update_gas_flame(GAS_FLAME_ANIM *ptr, GAS_CTRL_STRUCT *ctrl_ptr)
{
    s32             x_vel, y_vel, z_vel, temp_vel;
    POLY_FT4       	face;
    SVECTOR        	coord[4], local_position, camera_orientation;
    long           	i, z_position, p, flag, success;
	long	  		display_loop, in_range;
	GsOT	  		*ot_ptr;
	GAS_FLAME_ANIM	*last_ptr, *next_ptr;


	ptr->timer ++;

	if (!(ptr->timer % ptr->delay))
	{
		ptr->uv_index += ptr->increment;

		if (ptr->uv_index >= ptr->end_point)
		{
			if (ptr->next_flame != NULLVAL)
			{
				if (ptr->prev_flame != NULLVAL)
				{
					last_ptr = &PSX_gas_flames[ptr->prev_flame];
					last_ptr->next_flame = ptr->next_flame;

					next_ptr = &PSX_gas_flames[ptr->next_flame];
					next_ptr->prev_flame = ptr->prev_flame;
				}
				else
				{
					next_ptr = &PSX_gas_flames[ptr->next_flame];
					next_ptr->prev_flame = NULLVAL;

					PSX_gas[ptr->owner].first_flame = ptr->next_flame;
				}
			}
			else
			{
				if (ptr->prev_flame != NULLVAL)
				{
					last_ptr = &PSX_gas_flames[ptr->prev_flame];

					last_ptr->next_flame = NULLVAL;
				}
				else
				{
					PSX_gas[ptr->owner].first_flame = NULLVAL;
					PSX_gas[ptr->owner].latest_flame = NULLVAL;

					if (ctrl_ptr->fuel_level <= 0)
					{
						OBJ_delobj(PSX_gas[ptr->owner].obj_index);
						PSX_gas[ptr->owner].in_use = FALSE;
					}
				}
			}

			ptr->in_use = FALSE;

			return;
		}

//		if (ptr->uv_index > 14)
//			ptr->size_scaler = 6;

//		if (ptr->uv_index == 18)
//		{
//			ptr->smoke_flag = TRUE;

//		    ptr->r = 32;
//			ptr->g = 64;
//		    ptr->b = 64;

//			ptr->size_scaler = 5;
//		}
	}

    ptr->velocity -= (ptr->velocity / 15);

    if (!(ptr->timer % 3))
//        anim_ptr->size_scaler ++;
        ptr->size_scaler --;



//	if (anim_ptr->uv_index < 20)
//		anim_ptr->size_scaler = abs(anim_ptr->position.vz) / 100;
//	else
//		anim_ptr->size_scaler = abs(anim_ptr->position.vz) / 200;

    ptr->r += 0;
    ptr->g += 0;
    ptr->b += 0;

    y_vel = (ptr->velocity * rsin(ptr->rotation.vx) >> 12);
    temp_vel = (ptr->velocity * rcos(ptr->rotation.vx) >> 12);

    x_vel = (temp_vel * rsin(ptr->rotation.vy) >> 12);
    z_vel = (temp_vel * rcos(ptr->rotation.vy) >> 12);

    ptr->position.vx += x_vel;
    ptr->position.vy += y_vel;
    ptr->position.vz += z_vel;


//    ptr->velocity += (ptr->velocity / 20);

//    y_vel = (ptr->velocity * rsin(ptr->rotation.vx) >> 12);
//    temp_vel = (ptr->velocity * rcos(ptr->rotation.vx) >> 12);

//    x_vel = (temp_vel * rsin(ptr->rotation.vy) >> 12);
//    z_vel = (temp_vel * rcos(ptr->rotation.vy) >> 12);

//    ptr->position.vx += x_vel;
//    ptr->position.vy += y_vel;
//    ptr->position.vz += z_vel;

//	ptr->craft_vel.vx = OBJ_players[ctrl_ptr->owner].pobj->v.vx >> 8;
//	ptr->craft_vel.vy = OBJ_players[ctrl_ptr->owner].pobj->v.vy >> 8;
//	ptr->craft_vel.vz = OBJ_players[ctrl_ptr->owner].pobj->v.vz >> 8;

//	ptr->position.vx += ptr->craft_vel.vx;
//	ptr->position.vy += ptr->craft_vel.vy;
//	ptr->position.vz += ptr->craft_vel.vz;

    SetPolyFT4(&face);
    SetSemiTrans(&face, 1);

	SetTransMatrix(&IDENTITY_MATRIX);

//	if (ptr->smoke_flag)
//	{
//	    face.tpage = GetTPage(0, 2, 704, 256);
//		face.clut = GetClut(704, 465);
//	}
//	else
//	{
//	    face.tpage = GetTPage(0, 3, 704, 256);
//		face.clut = GetClut(704, 462);
//	}

    face.tpage = GetTPage(0, 3, 704, 256);
    face.clut = GetClut(704, 469);

    face.r0 = ptr->r;
    face.g0 = ptr->g;
    face.b0 = ptr->b;

    face.u0 = EXP_fire_uv_table[ptr->uv_index][0];
    face.v0 = EXP_fire_uv_table[ptr->uv_index][1];

    face.u1 = EXP_fire_uv_table[ptr->uv_index][2];
    face.v1 = EXP_fire_uv_table[ptr->uv_index][1];

    face.u2 = EXP_fire_uv_table[ptr->uv_index][0];
    face.v2 = EXP_fire_uv_table[ptr->uv_index][3];

    face.u3 = EXP_fire_uv_table[ptr->uv_index][2];
    face.v3 = EXP_fire_uv_table[ptr->uv_index][3];

	ot_ptr = &Wotwin0[outbuf_idx];

	for (display_loop = 0; display_loop < STATE.numscreens; display_loop++)
	{
		in_range = clip_point_short(&ptr->position, display_loop);

		if (!in_range)
		{
			ot_ptr = &Wotwin1[outbuf_idx];

			continue;
		}

		camera_orientation.vx = CAM_came[display_loop].vx >> 4;
		camera_orientation.vy = CAM_came[display_loop].vy >> 4;
		camera_orientation.vz = CAM_came[display_loop].vz >> 4;

	    RotMatrix(&camera_orientation, &CAM_camm[display_loop]);

		local_position.vx = ptr->position.vx - (CAM_camp[display_loop].vx);
		local_position.vy = ptr->position.vy - (CAM_camp[display_loop].vy);
		local_position.vz = ptr->position.vz - (CAM_camp[display_loop].vz);

	    ApplyMatrixSV(&CAM_camm[display_loop], &local_position, &local_position);

//		if (local_position.vz < 0)
//		{
//			ot_ptr = &Wotwin1[outbuf_idx];
//			continue;
//		}

        coord[0].vx = local_position.vx + ((ptr->size_scaler + 1) * (-EXP_fire_uv_table[ptr->uv_index][4] / 2));
        coord[0].vy = local_position.vy + (ptr->size_scaler * (-EXP_fire_uv_table[ptr->uv_index][5] / 2));
        coord[0].vz = local_position.vz;

        coord[1].vx = local_position.vx + ((ptr->size_scaler + 1) * (EXP_fire_uv_table[ptr->uv_index][4] / 2));
        coord[1].vy = local_position.vy + (ptr->size_scaler * (-EXP_fire_uv_table[ptr->uv_index][5] / 2));
        coord[1].vz = local_position.vz;

        coord[2].vx = local_position.vx + ((ptr->size_scaler + 1) * (-EXP_fire_uv_table[ptr->uv_index][4] / 2));
        coord[2].vy = local_position.vy + (ptr->size_scaler * (EXP_fire_uv_table[ptr->uv_index][5] / 2));
        coord[2].vz = local_position.vz;

        coord[3].vx = local_position.vx + ((ptr->size_scaler + 1) * (EXP_fire_uv_table[ptr->uv_index][4] / 2));
        coord[3].vy = local_position.vy + (ptr->size_scaler * (EXP_fire_uv_table[ptr->uv_index][5] / 2));
        coord[3].vz = local_position.vz;

		SetRotMatrix(&IDENTITY_MATRIX);

        z_position = RotTransPers4(&coord[0], &coord[1], &coord[2],
                    &coord[3], (long *)&face.x0, (long *)&face.x1,
                    (long *)&face.x2, (long *)&face.x3, &p, &flag);

       	GsSortPoly(&face, ot_ptr, z_position >> otzshift);

		ot_ptr = &Wotwin1[outbuf_idx];
	}

    return;
}

s32 init_new_gas_flame(GAS_CTRL_STRUCT *ctrl_ptr)
{
    GAS_FLAME_ANIM              *ptr;


    ptr = (GAS_FLAME_ANIM *)init_gas_flame_object();

    if (ptr == NULL)
        return FALSE;

    ptr->owner = ctrl_ptr->index;

    ptr->uv_index = 2;
    ptr->timer = 0;
	ptr->smoke_flag = FALSE;
	ptr->size_scaler = 20;
	ptr->increment = 1;
	ptr->delay = 2;
	ptr->update = 1;
	ptr->end_point = MAX_EXP_TIMS;

	ptr->next_flame = NULLVAL;
	ptr->prev_flame = ctrl_ptr->latest_flame;

	if (ctrl_ptr->latest_flame == NULLVAL)
		ctrl_ptr->first_flame = ptr->index;
	else
		PSX_gas_flames[ctrl_ptr->latest_flame].next_flame = ptr->index;

	ctrl_ptr->latest_flame = ptr->index;

//    ptr->owner = ctrl_ptr->index;
//    ptr->plyr_owner = ctrl_ptr->plyr_owner;

//    ptr->uv_index = 0;
//    ptr->timer = 0;
//    ptr->size_scaler = 14;
//	ptr->type = gas;

//	ptr->update = 1;
//	ptr->increment = 1;

    ptr->r = 64;//64;
    ptr->g = 128;//196;
    ptr->b = 64;//32;

//    anim_ptr->position.vx = 0;
//    anim_ptr->position.vy = 0;
//   anim_ptr->position.vz = 0;

    ptr->position.vx = ctrl_ptr->origin.vx;
    ptr->position.vy = ctrl_ptr->origin.vy;
    ptr->position.vz = ctrl_ptr->origin.vz;

    ptr->rotation.vx = 0;// - (rand() % 128);
    ptr->rotation.vy = SDRAND(4096) - 2048;
    ptr->rotation.vz = 256;

    ptr->velocity = SDRAND(60);

	if (ptr->velocity < 20)
		ptr->velocity += 15;

    return TRUE;
}

//end of new gas

SHIELD_FX   *init_shield_object(void)
{
    s32          i;


    for (i = 0; i < MAX_SHIELDS; i++)
    {
        if (!PCK_shields[i].in_use)
        {
            PCK_shields[i].in_use = TRUE;

            return &PCK_shields[i];
        }
    }

    return NULL;
}
/*
BURST_FX   *init_burst_object(void)
{
    s32          i;


    for (i = 0; i < MAX_BURSTS; i++)
    {
        if (!PCK_bursts[i].in_use)
        {
            PCK_bursts[i].in_use = TRUE;

            return &PCK_bursts[i];
        }
    }

    return NULL;
}
*/
PLASMA_WEAPON   *init_plasma_weapon(void)
{
    s32          i;


    for (i = 0; i < MAX_PLASMAS; i++)
    {
        if (!PSX_plasma[i].in_use)
        {
            PSX_plasma[i].in_use = TRUE;

            return &PSX_plasma[i];
        }
    }

    return NULL;
}

TRAIL_STRUCT   *init_trail_struct(OBJ_STRUCT *obj_ptr)
{
    s32          i, bollocks;


    for (i = 0; i < MAX_ROCKET_TRAILS; i++)
    {
        if (!PSX_rocket_trail[i].in_use)
        {
            PSX_rocket_trail[i].in_use = TRUE;

            return &PSX_rocket_trail[i];
        }
    }

    return NULL;
}

void PSX_init_shield_structs(void)
{
    s32          i;


    for (i = 0; i < MAX_SHIELDS; i++)
    {
        PCK_shields[i].index = i;
        PCK_shields[i].in_use = FALSE;
        PCK_shields[i].owner = NULLVAL;
        PCK_shields[i].timer = FALSE;
    }

    return;
}

void PSX_init_burst_structs(void)
{
    s32          i;


//    for (i = 0; i < MAX_BURSTS; i++)
//    {
//        PCK_bursts[i].index = i;
//        PCK_bursts[i].in_use = FALSE;
//        PCK_bursts[i].owner = NULLVAL;
//    }

	for (i = 0; i < MAX_PLASMAS; i++)
	{
	    PSX_plasma[i].index = i;
	    PSX_plasma[i].in_use = FALSE;
	}

/*	for (i = 0; i < MAX_FLAMES; i++)
	{
	    PSX_flames[i].index = i;
	    PSX_flames[i].in_use = FALSE;
	}

	for (i = 0; i < MAX_FIRE_CTRL_STRUCTS; i++)
	{
	    PSX_fire[i].index = i;
	    PSX_fire[i].in_use = FALSE;
	}
*/
	for (i = 0; i < MAX_ROCKET_TRAILS; i++)
	{
	    PSX_rocket_trail[i].index = i;
	    PSX_rocket_trail[i].in_use = FALSE;
	}

	for (i = 0; i < MAX_FLAMER_FLAMES; i++)
	{
		PSX_flamer_flames[i].in_use = FALSE;
		PSX_flamer_flames[i].index = i;
	}

	for (i = 0; i < MAX_FLAMERS; i++)
	{
		PSX_flamers[i].in_use = FALSE;
		PSX_flamers[i].index = i;
	}

	for (i = 0; i < MAX_GAS_FLAMES; i++)
	{
		PSX_gas_flames[i].in_use = FALSE;
		PSX_gas_flames[i].index = i;
	}

	for (i = 0; i < MAX_GAS_CLOUDS; i++)
	{
		PSX_gas[i].in_use = FALSE;
		PSX_gas[i].index = i;
	}

	for (i = 0; i < MAX_SPLASHES; i++)
	{
		PSX_splash[i].in_use = FALSE;
		PSX_splash[i].index = i;
	}

	for (i = 0; i < MAX_SPLASHES; i++)
	{
		PSX_inner_splash[i].in_use = FALSE;
		PSX_inner_splash[i].index = i;
	}

	for (i = 0; i < MAX_SPLASHES; i++)
	{
		PSX_floor_splash[i].in_use = FALSE;
		PSX_floor_splash[i].index = i;
	}

	for (i = 0; i < MAX_DROPLETS; i++)
	{
		PSX_droplet[i].in_use = FALSE;
		PSX_droplet[i].index = i;
	}

	for (i = 0; i < MAX_RIPPLES; i++)
	{
		PSX_ripple[i].in_use = FALSE;
		PSX_ripple[i].index = i;
	}
/*
	for (i = 0; i < MAX_TORPEDO_WAKES; i++)
	{
		PSX_torpedo_wake[i].in_use = FALSE;
		PSX_torpedo_wake[i].index = i;
	}
*/
    return;
}

void allocate_player_pickups(OBJ_PLAYERSTRUCT *plyr_ptr)
{
	int				i, j;

#if JON
   printf("jon was here!\n");

   for (j = 0; j < 12; j++)
	{
		if (j == 0)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_ion;
			plyr_ptr->pickups.quantity[j] = 10;
		}

		if (j == 1)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_rocket;
			plyr_ptr->pickups.quantity[j] = 2;
		}

		if (j == 2)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_flare;
			plyr_ptr->pickups.quantity[j] = 3;
		}

		if (j == 3)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_plasma;
			plyr_ptr->pickups.quantity[j] = 5;
		}

		if (j == 4)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_gas;
			plyr_ptr->pickups.quantity[j] = 5;
		}

		if (j == 5)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_shield;
			plyr_ptr->pickups.quantity[j] = 1;
		}

		if (j == 6)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_missile;
			plyr_ptr->pickups.quantity[j] = 5;
		}

		if (j == 7)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_flame;
			plyr_ptr->pickups.quantity[j] = 3;
		}

		if (j == 8)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_turbo;
			plyr_ptr->pickups.quantity[j] = 5;
		}

		if (j == 9)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_torpedo;
			plyr_ptr->pickups.quantity[j] = 5;
		}

		if (j == 10)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_mine;
			plyr_ptr->pickups.quantity[j] = 5;
		}

		if (j == 11)
		{
			plyr_ptr->pickups.pickup_list[j] = pck_cluster;
			plyr_ptr->pickups.quantity[j] = 5;
		}

//		plyr_ptr->pickups.pickup_list[j] = OTmissile;
//		plyr_ptr->pickups.quantity[j] = 5;

//		plyr_ptr->pickups.pickup_list[j] = OTion;
//		plyr_ptr->pickups.quantity[j] = 10;

//		if (plyr_ptr->pickups.pickup_list[j] == OTion)
//			plyr_ptr->pickups.pickup_list[j] = OTgas;
//		if (plyr_ptr->pickups.pickup_list[j] == OTrocket)
//			plyr_ptr->pickups.quantity[j] = 120;
	}

	plyr_ptr->pickups.total = 12;
	plyr_ptr->pickups.current = plyr_ptr->pickups.pickup_list[0];

#endif

#if IANORCDMASTER
	plyr_ptr->ammo = MAX_AMMO_LEVEL;

	for (i = 0; i < MAXPICKUPS; i++)
	{
		plyr_ptr->pickups.pickup_list[i] = NULLVAL;//pck_rocket;//NULLVAL;
		plyr_ptr->pickups.quantity[i] = 0;//10;
	}

	plyr_ptr->pickups.total = 0;//MAXPICKUPS;//0;
	plyr_ptr->pickups.current = NULLVAL;
#endif

	return;
}
/*
void PSX_fire_fx(void)
{
	FIRE_CTRL_STRUCT		*ctrl_ptr;
	int						i, j, success;


	for (i = 0; i < MAX_FIRE_CTRL_STRUCTS; i++)
	{
		if (!PSX_fire[i].in_use)
			continue;

		if (PSX_fire[i].type == flame)
			continue;

		if (PSX_fire[i].type == gas)
			continue;

		ctrl_ptr = &PSX_fire[i];

		ctrl_ptr->timer ++;

	    if (ctrl_ptr->timer == ctrl_ptr->end)
		{
			ctrl_ptr->in_use = FALSE;
			OBJ_delobj(ctrl_ptr->obj_index);

			return;
		}

	    if ((!(ctrl_ptr->timer % 1)) && (!ctrl_ptr->finished))
	    {
			for (j = 0; j < 1; j++)
			{
		        if (ctrl_ptr->no_flames < ctrl_ptr->total_flames)
		        {
		            success = PSX_init_explosion(&OBJ_objects[ctrl_ptr->obj_index], KEEP, DO_SCALE);

		            if (success)
		                ctrl_ptr->no_flames ++;
		        }
				else
					break;
			}
	    }

		if (ctrl_ptr->no_flames == ctrl_ptr->total_flames)
		{
			ctrl_ptr->in_use = FALSE;

			OBJ_delobj(ctrl_ptr->obj_index);
		}
	}

	return;
}
*/
FLAMER_CTRL_STRUCT  *init_flamer_ctrl_struct(void)
{
    s32          i;


    for (i = 0; i < MAX_FLAMERS; i++)
    {
        if (!PSX_flamers[i].in_use)
        {
            PSX_flamers[i].in_use = TRUE;

            return &PSX_flamers[i];
        }
    }

    return NULL;
}

FLAMER_FLAME_ANIM   *init_flamer_flame_object(void)
{
    s32          i;


    for (i = 0; i < MAX_FLAMER_FLAMES; i++)
    {
        if (!PSX_flamer_flames[i].in_use)
        {
            PSX_flamer_flames[i].in_use = TRUE;

            return &PSX_flamer_flames[i];
        }
    }

    return NULL;
}

GAS_CTRL_STRUCT  *init_gas_ctrl_struct(void)
{
    s32          i;


    for (i = 0; i < MAX_GAS_CLOUDS; i++)
    {
        if (!PSX_gas[i].in_use)
        {
            PSX_gas[i].in_use = TRUE;

            return &PSX_gas[i];
        }
    }

    return NULL;
}

GAS_FLAME_ANIM   *init_gas_flame_object(void)
{
    s32          i;


    for (i = 0; i < MAX_GAS_FLAMES; i++)
    {
        if (!PSX_gas_flames[i].in_use)
        {
            PSX_gas_flames[i].in_use = TRUE;

            return &PSX_gas_flames[i];
        }
    }

    return NULL;
}

SPLASH_3D   *init_new_splash_struct(void)
{
    s32          i;


    for (i = 0; i < MAX_SPLASHES; i++)
    {
        if (!PSX_splash[i].in_use)
        {
            PSX_splash[i].in_use = TRUE;

            return &PSX_splash[i];
        }
    }

    return NULL;
}

INNER_SPLASH_3D   *init_new_inner_splash_struct(void)
{
    s32          i;


    for (i = 0; i < MAX_SPLASHES; i++)
    {
        if (!PSX_inner_splash[i].in_use)
        {
            PSX_inner_splash[i].in_use = TRUE;

            return &PSX_inner_splash[i];
        }
    }

    return NULL;
}

FLOOR_SPLASH_3D   *init_new_floor_splash_struct(void)
{
    s32          i;


    for (i = 0; i < MAX_SPLASHES; i++)
    {
        if (!PSX_floor_splash[i].in_use)
        {
            PSX_floor_splash[i].in_use = TRUE;

            return &PSX_floor_splash[i];
        }
    }

    return NULL;
}

DROPLET_STRUCT   *init_new_droplet_struct(void)
{
    s32          i;


    for (i = 0; i < MAX_DROPLETS; i++)
    {
        if (!PSX_droplet[i].in_use)
        {
            PSX_droplet[i].in_use = TRUE;

            return &PSX_droplet[i];
        }
    }

    return NULL;
}

RIPPLE_STRUCT   *init_new_ripple_struct(void)
{
    s32          i;


    for (i = 0; i < MAX_RIPPLES; i++)
    {
        if (!PSX_ripple[i].in_use)
        {
            PSX_ripple[i].in_use = TRUE;

            return &PSX_ripple[i];
        }
    }

    return NULL;
}
/*
WAKE_STRUCT   *init_new_torpedo_wake_struct(void)
{
    s32          i;


    for (i = 0; i < MAX_TORPEDO_WAKES; i++)
    {
        if (!PSX_torpedo_wake[i].in_use)
        {
            PSX_torpedo_wake[i].in_use = TRUE;

            return &PSX_torpedo_wake[i];
        }
    }

    return NULL;
}
*/
void display_vector(SVECTOR before, SVECTOR after, u8 red, u8 green, u8 blue)
{
	SVECTOR			camera_orientation;
	MATRIX			camera_matrix;
	SVECTOR			coord[4];
	POLY_F4			face;
	long			z_value, p, flag, x_dist, z_dist, in_range;

/*	x_dist = abs((5000 * rsin(512)) >> 12);
	z_dist = abs((5000 * rcos(512)) >> 12);

//	x_dist += CAM_camp[CAM_c].vx;
//	z_dist += CAM_camp[CAM_c].vz;
	if (x_dist >= 0)
	{
		if ((before.vx - CAM_camp[CAM_c].vx) > x_dist)
			return;

		if ((after.vx - CAM_camp[CAM_c].vx) > x_dist)
			return;
	}
	else
	{
		if ((before.vx - CAM_camp[CAM_c].vx) < x_dist)
			return;

		if ((after.vx - CAM_camp[CAM_c].vx) < x_dist)
			return;
	}

	if (z_dist >= 0)
	{
		if ((before.vz - CAM_camp[CAM_c].vz) > z_dist)
			return;

		if ((after.vz - CAM_camp[CAM_c].vz) > z_dist)
			return;
	}
	else
	{
		if ((before.vz - CAM_camp[CAM_c].vz) < z_dist)
			return;

		if ((after.vz - CAM_camp[CAM_c].vz) < z_dist)
			return;
	}
*/
	SetPolyF4(&face);

	face.r0 = red;
	face.g0 = green;
	face.b0 = blue;

//	in_range = clip_point_short(&before, 0);

//	if (!in_range)
//		return;

	camera_orientation.vx = CAM_came[CAM_c].vx >> 4;
	camera_orientation.vy = CAM_came[CAM_c].vy >> 4;
	camera_orientation.vz = CAM_came[CAM_c].vz >> 4;

    RotMatrix(&camera_orientation, &camera_matrix);

	before.vx -= CAM_camp[CAM_c].vx;
	before.vy -= CAM_camp[CAM_c].vy;
	before.vz -= CAM_camp[CAM_c].vz;

    ApplyMatrixSV(&camera_matrix, &before, &before);

	after.vx -= CAM_camp[CAM_c].vx;
	after.vy -= CAM_camp[CAM_c].vy;
	after.vz -= CAM_camp[CAM_c].vz;

    ApplyMatrixSV(&camera_matrix, &after, &after);

    SetTransMatrix(&IDENTITY_MATRIX);
	SetRotMatrix(&IDENTITY_MATRIX);


	if ((red == 0) && (green == 255) && (blue == 0))
	{
		coord[0].vx = before.vx - 75;
		coord[0].vy = before.vy;
		coord[0].vz = before.vz;

		coord[2].vx = before.vx + 75;
		coord[2].vy = before.vy;
		coord[2].vz = before.vz;

		coord[1].vx = after.vx - 75;
		coord[1].vy = after.vy;
		coord[1].vz = after.vz;

		coord[3].vx = after.vx + 75;
		coord[3].vy = after.vy;
		coord[3].vz = after.vz;
	}
	else
	{
		coord[0].vx = before.vx - 75;
		coord[0].vy = before.vy;
		coord[0].vz = before.vz;

		coord[2].vx = before.vx + 75;
		coord[2].vy = before.vy;
		coord[2].vz = before.vz;

		coord[1].vx = after.vx - 75;
		coord[1].vy = after.vy;
		coord[1].vz = after.vz;

		coord[3].vx = after.vx + 75;
		coord[3].vy = after.vy;
		coord[3].vz = after.vz;
	}

    z_value = RotTransPers4(&coord[0], &coord[1], &coord[2],
                &coord[3], (long *)&face.x0, (long *)&face.x1,
                (long *)&face.x2, (long *)&face.x3, &p, &flag);

	if ((flag & 0x80000000) == 0)
		GsSortPoly(&face, ptrwot, 0);

	return;
}

void display_direction(s8 pad_val)
{
	POLY_F3			face;
	POLY_F4			sqr;

	SetPolyF3(&face);

	face.r0 = 255;
	face.g0 = 96;
	face.b0 = 96;

	SetPolyF4(&sqr);

	sqr.r0 = 255;
	sqr.g0 = 255;
	sqr.b0 = 255;

	if (pad_val < 0)
	{
		if (pad_val > 5)
			pad_val = 5;

		face.x0 = -100;
		face.y0 = 100;

		face.x1 = -100 + pad_val;
		face.y1 = 80;

		face.x2 = -100;
		face.y2 = 60;

		sqr.x0 = -231;
		sqr.y0 = 100;

		sqr.x1 = -228;
		sqr.y1 = 100;

		sqr.x2 = -231;
		sqr.y2 = 60;

		sqr.x3 = -228;
		sqr.y3 = 60;
	}
	else
	{
		if (pad_val < 5)
			pad_val = 5;

		face.x0 = 100;
		face.y0 = 100;

		face.x1 = 100 + pad_val;
		face.y1 = 80;

		face.x2 = 100;
		face.y2 = 60;

		sqr.x0 = 227;
		sqr.y0 = 100;

		sqr.x1 = 230;
		sqr.y1 = 100;

		sqr.x2 = 227;
		sqr.y2 = 60;

		sqr.x3 = 230;
		sqr.y3 = 60;
	}

	GsSortPoly(&face, ptrwot, 0);
	GsSortPoly(&sqr, ptrwot, 0);

	sqr.r0 = 32;
	sqr.g0 = 64;
	sqr.b0 = 255;

	sqr.x0 = 200;
	sqr.y0 = 0;

	sqr.x1 = 220;
	sqr.y1 = 0;

	sqr.x2 = 200;
	sqr.y2 = 0;//AI_pilot[1].real_velocity / -250;

	sqr.x3 = 220;
	sqr.y3 = 0;//AI_pilot[1].real_velocity / -250;

//	GsSortPoly(&sqr, ptrwot, 0);

	sqr.x0 = 230;
	sqr.y0 = 0;

	sqr.x1 = 250;
	sqr.y1 = 0;

	sqr.x2 = 230;
	sqr.x3 = 250;

	if (AI_pilot[camera_craft_num].acceleration_pad_val == PAD_RD)
//	if (AI_pilot[1].acceleration_pad_val == PAD_RD)
	{
		sqr.r0 = 255;
		sqr.g0 = 0;
		sqr.b0 = 0;

		sqr.y2 = -50;
		sqr.y3 = -50;
	}
	else
	{
		if (AI_pilot[camera_craft_num].acceleration_pad_val == 0)
//		if (AI_pilot[1].acceleration_pad_val == 0)
		{
//			sqr.y2 = 0;
		sqr.r0 = 0;
		sqr.g0 = 255;
		sqr.b0 = 0;
//			sqr.y3 = 0;
		sqr.y2 = -50;
		sqr.y3 = -50;
		}
		else
		{
			sqr.r0 = 0;
			sqr.g0 = 0;
			sqr.b0 = 255;

			sqr.y2 = -50;
			sqr.y3 = -50;
		}
	}

	GsSortPoly(&sqr, ptrwot, 0);

	return;
}

s32	find_height(OBJ_STRUCT *obj_ptr)
{
	#define				TEST_LENGTH		3000

	vec32				end_point;
	s32					coll, temp, height;
	SVECTOR				target, PSX_c_pos;
	vec32				ship_pos;


	end_point.vy = (TEST_LENGTH * rsin(1024)) >> 12;
	temp = (TEST_LENGTH * rcos(1024)) >> 12;

	end_point.vx = (temp * rsin(obj_ptr->r.vy >> 4)) >> 12;
	end_point.vz = (temp * rcos(obj_ptr->r.vy >> 4)) >> 12;

	end_point.vx += obj_ptr->p.vx >> 8;
	end_point.vy += obj_ptr->p.vy >> 8;
	end_point.vz += obj_ptr->p.vz >> 8;

	ship_pos.vx = obj_ptr->p.vx >> 8;
	ship_pos.vy = obj_ptr->p.vy >> 8;
	ship_pos.vz = obj_ptr->p.vz >> 8;

	coll = COL_test2(&ship_pos, &end_point);

	if (coll > NULLVAL)
	{
		end_point.vx = COL_inter.vx;
		end_point.vy = COL_inter.vy;
		end_point.vz = COL_inter.vz;

		height = (COL_inter.vy - (obj_ptr->p.vy >> 8));
	}
	else
		return FALSE;

//	printf("inter = %d : obj = %d : height = %d\n", COL_inter.vy, obj_ptr->p.vy >> 8, height);

	PSX_c_pos.vx = obj_ptr->p.vx >> 8;
	PSX_c_pos.vy = obj_ptr->p.vy >> 8;
	PSX_c_pos.vz = obj_ptr->p.vz >> 8;

	target.vx = end_point.vx;
	target.vy = end_point.vy;
	target.vz = end_point.vz;

//	display_vector(PSX_c_pos, target, 255, 255, 255);

	return TRUE;
}

s8 clip_point_long(vec32 *ptr, int index)
{
	int				x_val, z_val, distance;
	short			angle, rot_diff;


	x_val = (ptr->vx >> 8) - CAM_camp[index].vx;
	z_val = (ptr->vz >> 8) - CAM_camp[index].vz;

	angle = ratan2(x_val, z_val);

	rot_diff = vangdiff2(angle, (-CAM_came[index].vy >> 4));

	if (abs(rot_diff) > 450)
		return FALSE;
	else
	{
		distance = SquareRoot0((x_val * x_val) + (z_val * z_val));

		if (distance > MAX_SFX_CAMERA_RANGE)
			return FALSE;
		else
			return TRUE;
	}
}

s8 clip_point_short(vec16 *ptr, int index)
{
	int				x_val, z_val, distance;
	short			angle, rot_diff;


	x_val = ptr->vx - CAM_camp[index].vx;
	z_val = ptr->vz - CAM_camp[index].vz;

	angle = ratan2(x_val, z_val);

	rot_diff = vangdiff2(angle, (-CAM_came[index].vy >> 4));

	if (abs(rot_diff) > 450)
		return FALSE;
	else
	{
		distance = SquareRoot0((x_val * x_val) + (z_val * z_val));

		if (distance > MAX_SFX_CAMERA_RANGE)
			return FALSE;
		else
			return TRUE;
	}
}	 