#include <sys/types.h>
#include <libetc.h>		/* for Control Pad */
#include <libgte.h>		/* LIBGS uses libgte */
#include <libgpu.h>		/* LIBGS uses libgpu */
#include <libgs.h>		/* for LIBGS */

#include <inline_c.h>

#include "sdtypes.h"
#include "sddemo.h"
#include "subdiv.h"
extern   GsOT        *ptrwot;//jof

int   Zoffset;
int   FarZDist=4000;
//#define  FarZDist 5000

#define SeeCol 0     // debug only
#define SeeNorm 0;    // debug only

Uint8 ColCol;
Uint8	ColColours[]={	128,64,64,
				64,128,64,
				64,64,128,
				128,128,64,
				64,128,128,
				128,64,128,
				192,32,32,
				32,192,32};


extern	Sint32	half_width;
extern	Sint32	half_height;

extern	GsRVIEW2  sview;		// for camera line only
extern	Sint32		viewvolLX;
extern	Sint32		viewvolLZ;
extern	Sint32		viewvolRX;
extern	Sint32		viewvolRZ;
extern	Uint8	SectionInView[20][20];
extern	Uint16		viewblocks;
extern	SVECTOR *VertPointer1;
extern	SVECTOR *VertPointer2;
extern	SVECTOR *VertPointer3;
extern	SVECTOR *VertPointer4;
extern	Uint32	Type;
extern	long	xpos;
extern	long	zpos;
extern	long	Theypos;
extern	SVECTOR Mid;
extern	SVECTOR TheNorm;


#define max3(x1,x2,x3,x4)			x1>x2?	(x4=x1):(x4=x2),	x3>x4?	(x4=x3):0

#define min3(x1,x2,x3,x4)			x1>x2?	(x4=x2):(x4=x1),	x3<x4?	(x4=x3):0

#define minmax3(x1,x2,x3,x4,x5)    x1>x2?(x5=x1,x4=x2):(x4=x1,x5=x2),\
								   x3>x5?x5=x3:x3<x4?x4=x3:0
#define minmax4(x1,x2,x3,x4,x5,x6) x1>x2?(x6=x1,x5=x2):(x5=x1,x6=x2),\
                                   x3>x6?x6=x3:x3<x5?x5=x3:0,\
                                   x4>x6?x6=x4:x4<x5?x5=x4:0


// Mat 6/april/1999
void	SubDivF3(register F3_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
						register SVECTOR *Vertc,
						register Sint32 *tag,
						register Uint32 backclip);


void	SubDivG3(	register GF3_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
						register SVECTOR *Vertc,
						register Sint32 *tag,
						register Uint32	backclip);


void	SubDivF4(register F4_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
		   				register SVECTOR *Vertc,
						register SVECTOR *Vertd,
						register Sint32 *tag,
						register Uint32 backclip);

void	SubDivG4(	register GF4_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
		   				register SVECTOR *Vertc,
						register SVECTOR *Vertd,
						register Sint32 *tag,
						register Uint32 backclip);

void	SubDivGT3(	register GT3_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
						register SVECTOR *Vertc,
						register Sint32 *tag,
						register Uint32	backclip);

void	SubDivFT3(register T3_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
						register SVECTOR *Vertc,
						register Sint32 *tag,
						register Uint32 backclip);


void	SubDivGT4(	register GT4_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
		   				register SVECTOR *Vertc,
						register SVECTOR *Vertd,
						register Sint32 *tag,
						register Uint32 backclip);

void	SubDivFT4(register T4_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
		   				register SVECTOR *Vertc,
						register SVECTOR *Vertd,
						register Sint32 *tag,
						register Uint32 backclip);

// eom


Uint32	NumberOfObjects;

extern	Uint32	TestSDF[];


void MapModelData(Uint32 *ModAddr);
void	SortClipBox();
void	SortGridBox();


extern	PACKET	*GsOUT_PACKET_P;

extern	int				outbuf_idx;       // from main.c
extern	GsOT		 		otT[2];				// from main.c
extern	GsOT		 		Wot[2];				// from main.c
GsLINE	ClipedLine;

//void  SortLinePoly(Sint16 x0,Sint16 y0,Sint16 x1,Sint16 y1,Sint16 x2,Sint16 y2,Uint8 r,Uint8 g,Uint8 b);
//void  SortLinePolyQ(Sint16 x0,Sint16 y0,Sint16 x1,Sint16 y1,Sint16 x2,Sint16 y2,Sint16 x3,Sint16 y3,Uint8 r,Uint8 g,Uint8 b);

//void	TempSubDivTri(POLY_GT3 *PPMod1A_GT,FACE_VERT *Vert,Sint32 *tag);


VERTC	DivWork[25] __attribute__ ((section("dscachedata"))) ={{0}};
//VERTC	DivWork[25];



POLY_F3		CornerT;
POLY_F4		CornerQ;


POLY_F3		Corner;
POLY_GT3		Corner2;
POLY_GT4		Corner3;
//POLY_GT3	GT3Out;

POLY_FT4	TQ;


Sint32	clipflag1=0x00000001;
Sint32	clipflag=0x00000300;
Sint32	clipflag2=0x00000001;
Sint32	clipflag3=400;	// only used for pollyfilla

Uint8	ShadCol=0x10;

extern u_long	GoGoAnalyser;
extern u_long	EndAnalyser;



//void		SdMapFile(Uint32 *MemPointer);	 // maps a Sd file into mem
//void	SdModelPrint(Uint32 *MemPointer,Uint8 md,GsOT *OT,Uint8 idx,Uint32 Sort);	// print Sd model


//int		SubDived;
//int		SubDived2;


Sint32	sz4[3] __attribute__ ((section("dscachedata"))) ={0};

//FACE_VERT	*PMod1Vert		 __attribute__ ((section("dscachedata"))) =0;
POLY_F3		*PMod1A_F	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1A_F	 __attribute__ ((section("dscachedata"))) =0;
POLY_F3		*PMod1A_FD	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1A_FD  __attribute__ ((section("dscachedata"))) =0;
POLY_FT3		*PMod1A_T	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1A_T	 __attribute__ ((section("dscachedata"))) =0;
POLY_FT3		*PMod1A_TD	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1A_TD  __attribute__ ((section("dscachedata"))) =0;

POLY_G3		*PMod1A_G	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1A_G	 __attribute__ ((section("dscachedata"))) =0;
POLY_G3		*PMod1A_GD	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1A_GD  __attribute__ ((section("dscachedata"))) =0;
POLY_GT3		*PMod1A_GT	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1A_GT	 __attribute__ ((section("dscachedata"))) =0;
POLY_GT3		*PMod1A_GTD	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1A_GTD  __attribute__((section("dscachedata"))) =0;

//FACE_VERT4	*PMod1Vert4	 __attribute__ ((section("dscachedata"))) =0;
POLY_F4		*PMod1F_F	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1F_F	 __attribute__ ((section("dscachedata"))) =0;
POLY_F4		*PMod1F_FD	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1F_FD  __attribute__ ((section("dscachedata"))) =0;
POLY_FT4		*PMod1F_T	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1F_T	 __attribute__ ((section("dscachedata"))) =0;
POLY_FT4		*PMod1F_TD	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1F_TD  __attribute__ ((section("dscachedata"))) =0;

POLY_G4		*PMod1F_G	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1F_G	 __attribute__ ((section("dscachedata"))) =0;
POLY_G4		*PMod1F_GD	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1F_GD  __attribute__ ((section("dscachedata"))) =0;
POLY_GT4		*PMod1F_GT	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1F_GT	 __attribute__ ((section("dscachedata"))) =0;
POLY_GT4		*PMod1F_GTD	 __attribute__ ((section("dscachedata"))) =0;
Sint32		PC_Mod1F_GTD  __attribute__((section("dscachedata"))) =0;

Sint32	otz	   __attribute__ ((section("dscachedata"))) =0;
Sint32	flag   __attribute__ ((section("dscachedata"))) =0;

Sint32	sz3[3] __attribute__ ((section("dscachedata"))) ={0};
Sint32	minz   __attribute__ ((section("dscachedata"))) =0;
Sint32	maxz   __attribute__ ((section("dscachedata"))) =0;
//Uint32	sz3[3] __attribute__ ((section("dscachedata"))) ={0};
//Uint32	minz   __attribute__ ((section("dscachedata"))) =0;
//Uint32	maxz   __attribute__ ((section("dscachedata"))) =0;
Sint16	minx   __attribute__ ((section("dscachedata"))) =0;
Sint16	maxx   __attribute__ ((section("dscachedata"))) =0;
Sint16	miny   __attribute__ ((section("dscachedata"))) =0;
Sint16	maxy   __attribute__ ((section("dscachedata"))) =0;

// added for sub div
Sint32	otz2	   __attribute__ ((section("dscachedata"))) =0;


Uint32	xy3s[2]	__attribute__ ((section("dscachedata"))) ={0};
Sint32	midflag	__attribute__ ((section("dscachedata"))) =0;
Sint32	midsz	__attribute__ ((section("dscachedata"))) =0;
Sint32	midxy	__attribute__ ((section("dscachedata"))) =0;

Sint32	minx2   __attribute__ ((section("dscachedata"))) =0;
Sint32	maxx2   __attribute__ ((section("dscachedata"))) =0;


/* ------------------------ */



void MapModelData(Uint32 *ModAddr)
{
Uint32	TopAddr=(Uint32)(ModAddr);
Uint32	NumObjects;
Uint32	lp,lp2;
Uint32	*ColListPointer;
Uint32	NumCols;
Uint32	NumColsT;
Uint32	NumColsB;


	if (*ModAddr) return;	//has been done

   //settempboxdata();

	*ModAddr++=1;
	NumObjects=*ModAddr++;	// number of objects

	(*ModAddr++)+=TopAddr;	// vert addr
	ModAddr++;
	(*ModAddr++)+=TopAddr;	// norm addr
	ModAddr++;

	for (lp=0;lp<NumObjects;lp++)
	{
	(*ModAddr++)+=TopAddr;	// f3 addr
	ModAddr+=8;

	(*ModAddr)+=TopAddr;	// ColListPointer addr
	ColListPointer=(Uint32 *)*ModAddr++;
	NumCols=*ModAddr++;
	NumColsT=(NumCols&0xffff0000)>>16;
	NumCols=(NumCols&0x0000ffff)+NumColsT;
	NumColsB=*ModAddr++;

		for(lp2=0;lp2<NumCols;lp2++)
		{
      (*ColListPointer++)+=TopAddr&0xffffff;
      (*ColListPointer++)+=TopAddr;
		}

		for(lp2=0;lp2<NumColsB;lp2++)
		{
      (*ColListPointer++)+=TopAddr&0xffffff;
      (*ColListPointer++)+=TopAddr;
      (*ColListPointer++)+=TopAddr;
		}

	}

NumberOfObjects=NumObjects;


}
void PrintModel(Uint32 *MemPointer,Uint16 md,GsOT *OT,Uint8 idx)
{

register	long	 	*tag;
register	int			lp;
register	GsOT_TAG	*WOT;

register	T4_Packet	*PPMod1F_T;
register	T4_Packet	*PPMod1F_T_L1;
register	T4_Packet	*PPMod1F_T_L2;

register	F4_Packet  	*PPMod1F_F;
register	F4_Packet  	*PPMod1F_F_L1;
register	F4_Packet  	*PPMod1F_F_L2;

register	GT4_Packet	*PPMod1F_GT;
register	GT4_Packet	*PPMod1F_GT_L1;
register	GT4_Packet	*PPMod1F_GT_L2;

register	GF4_Packet 	*PPMod1F_G;
register	GF4_Packet 	*PPMod1F_G_L1;
register	GF4_Packet 	*PPMod1F_G_L2;

register	F3_Packet  	*PPMod1A_F;
register	T3_Packet	*PPMod1A_T;

register	GF3_Packet	*PPMod1A_G;
register	GT3_Packet	*PPMod1A_GT;

register	u_long		OTSHIFT;

register	SVECTOR *VertPointer;
register	SVECTOR *NormPointer;
register	Uint32 NumVerts;
register	Uint32 NumNorms;

//register	Uint32 *ColListPointer;
//register	Uint32 NumTriCols;
//register	Uint32 NumQuadCols;

register	POLY_GT3	*GT3Out;
register	POLY_GT4	*GT4Out;
register	POLY_GT4	*GT4Out_L1;
register	POLY_GT4	*GT4Out_L2;

register	POLY_FT3	*T3Out;
register	POLY_FT4	*T4Out;
register	POLY_FT4	*T4Out_L1;
register	POLY_FT4	*T4Out_L2;

register	POLY_G3		*GF3Out;
register	POLY_G4		*GF4Out;
register	POLY_G4		*GF4Out_L1;
register	POLY_G4		*GF4Out_L2;

register	POLY_F3		*F3Out;
register	POLY_F4		*F4Out;
register	POLY_F4		*F4Out_L1;
register	POLY_F4		*F4Out_L2;

// for debug normals only
//SVECTOR	*NormP;
//SVECTOR	*NormP2;
//SVECTOR	MidPoint;
//SVECTOR	NormPoint;

   WOT=ptrwot->org+Zoffset;
   OTSHIFT=14-OT[0].length;

   //WOT=(OT[idx].org);   // set ot and size
   //OTSHIFT=14-OT[idx].length;

	if ((*MemPointer++)==0) return;		// not maped can print!
	MemPointer++;						// past num objs in file
	VertPointer=(SVECTOR *)*MemPointer++;
	NumVerts=*MemPointer++;
	NormPointer=(SVECTOR *)*MemPointer++;
	NumNorms=*MemPointer++;

//	MemPointer+=(md*35);		// move pointer to corect model header within data
	MemPointer+=(md*12);		// move pointer to corect model header within data



	/* ------------ tri faces first ------------- */

	/********************/
	/* flat colour tri */
	/********************/
	PPMod1A_F=(F3_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1A_F=*MemPointer++;
	PC_Mod1A_F=((*MemPointer)&0x0000ffff);

	for (lp=0;lp<PC_Mod1A_F;PPMod1A_F++,lp++)
	{
#if ForceSubDiv
//	PPMod1A_F->info|=0x0100;
	PPMod1A_F->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1A_F->vt0],&VertPointer[PPMod1A_F->vt1],
				&VertPointer[PPMod1A_F->vt2]);

	gte_rtpt();
	F3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr

	gte_stflg(&flag);						/* store flag */

	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz <=0) continue;	// except back facing
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1A_F->info&0x0300)==0) continue;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) continue;
	// if flaged an error and subdiv on and face not off front of screen
	gte_nclip();		// do nclip
	gte_stopz(&otz);
	if (otz <=0) continue;	// except back facing
 	}

	gte_stsxy3_f3(F3Out);

	// x's 2d virtices off edge of screen ?
	minmax3(F3Out->x0,
			F3Out->x1,
			F3Out->x2,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	continue;

	// y's 2d virtices off edge of screen ?
	minmax3(F3Out->y0,
			F3Out->y1,
			F3Out->y2,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) continue;


	// if get to here then poly is on screen at some point!
	switch ((PPMod1A_F->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	continue;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1A_F->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{


#if SeeLines
		SortLinePoly(F3Out->x0,F3Out->y0,
					 F3Out->x1,F3Out->y1,
					 F3Out->x2,F3Out->y2,
					 128,0,128);
#endif


		SubDivF3(PPMod1A_F,
			   	&VertPointer[PPMod1A_F->vt0],
			   	&VertPointer[PPMod1A_F->vt1],
			   	&VertPointer[PPMod1A_F->vt2],
			   	((u_long *)(WOT+(otz>>OTSHIFT))),
			   	0);

		/* SubDived ++; */
		continue;
		}



		*(Uint32 *)&F3Out->r0=*(Uint32 *)&PPMod1A_F->r0;

//#if 0	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		F3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (F3Out) & 0x00ffffff);
		GsOUT_PACKET_P+=0x14;
//#endif
	}



	/********************/
	/* flat colour tri  doub sided*/
	/********************/
//	PPMod1A_F=(F3_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1A_F=*MemPointer++;

	PC_Mod1A_F=((*MemPointer++)&0xffff0000)>>16;



	for (lp=0;lp<PC_Mod1A_F;PPMod1A_F++,lp++)
	{
#if ForceSubDiv
//	PPMod1A_F->info|=0x0100;
	PPMod1A_F->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1A_F->vt0],&VertPointer[PPMod1A_F->vt1],
				&VertPointer[PPMod1A_F->vt2]);

	gte_rtpt();
	F3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr

	gte_stflg(&flag);						/* store flag */

	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1A_F->info&0x0300)==0) continue;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) continue;
	// if flaged an error and subdiv on and face not off front of screen
 	}

	gte_stsxy3_f3(F3Out);

	// x's 2d virtices off edge of screen ?
	minmax3(F3Out->x0,
			F3Out->x1,
			F3Out->x2,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	continue;

	// y's 2d virtices off edge of screen ?
	minmax3(F3Out->y0,
			F3Out->y1,
			F3Out->y2,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) continue;


	// if get to here then poly is on screen at some point!
	switch ((PPMod1A_F->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	continue;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1A_F->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{


#if SeeLines
		SortLinePoly(F3Out->x0,F3Out->y0,
					 F3Out->x1,F3Out->y1,
					 F3Out->x2,F3Out->y2,
					 128,0,128);
#endif


		SubDivF3(PPMod1A_F,
			   	&VertPointer[PPMod1A_F->vt0],
			   	&VertPointer[PPMod1A_F->vt1],
			   	&VertPointer[PPMod1A_F->vt2],
			   	((u_long *)(WOT+(otz>>OTSHIFT))),
			   	1);

		/* SubDived ++; */
		continue;
		}



		*(Uint32 *)&F3Out->r0=*(Uint32 *)&PPMod1A_F->r0;

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		F3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (F3Out) & 0x00ffffff);
		GsOUT_PACKET_P+=0x14;
	}




	/********************/
	/* textured 3*/
	/********************/
//	PPMod1A_T=(T3_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1A_T=*MemPointer++;

	PPMod1A_T=(T3_Packet *)PPMod1A_F;
	PC_Mod1A_T=(*MemPointer)&0x0000ffff;

	for (lp=0;lp<PC_Mod1A_T;PPMod1A_T++,lp++)
	{
#if ForceSubDiv
//	PPMod1A_T->info|=0x0100;
	PPMod1A_T->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1A_T->vt0],&VertPointer[PPMod1A_T->vt1],
				&VertPointer[PPMod1A_T->vt2]);

	gte_rtpt();
	T3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	*(Uint32 *)&T3Out->u0=*(Uint32 *)&PPMod1A_T->u0;
	*(Uint32 *)&T3Out->u1=*(Uint32 *)&PPMod1A_T->u1;
	*(Uint32 *)&T3Out->u2=*(Uint32 *)&PPMod1A_T->u2;

	gte_stflg(&flag);						/* store flag */

	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz <=0) continue;	// except back facing
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1A_T->info&0x0300)==0) continue;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) continue;
	// if flaged an error and subdiv on and face not off front of screen
	gte_nclip();		// do nclip
	gte_stopz(&otz);
	if (otz <=0) continue;	// except back facing
 	}

	gte_stsxy3_ft3(T3Out);

	// x's 2d virtices off edge of screen ?
	minmax3(T3Out->x0,
			T3Out->x1,
			T3Out->x2,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	continue;

	// y's 2d virtices off edge of screen ?
	minmax3(T3Out->y0,
			T3Out->y1,
			T3Out->y2,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) continue;


	// if get to here then poly is on screen at some point!
	switch ((PPMod1A_T->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


	// new smooth z dist clip
	if((otz>FarZDist))	continue;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1A_T->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{


#if SeeLines
		SortLinePoly(T3Out->x0,T3Out->y0,
					 T3Out->x1,T3Out->y1,
					 T3Out->x2,T3Out->y2,
					 255,180,0);
#endif


		SubDivFT3(PPMod1A_T,
						&VertPointer[PPMod1A_T->vt0],
						&VertPointer[PPMod1A_T->vt1],
						&VertPointer[PPMod1A_T->vt2],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);
		/* SubDived ++; */
		continue;
		}



		*(Uint32 *)&T3Out->r0=*(Uint32 *)&PPMod1A_T->r0;

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		T3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (T3Out) & 0x00ffffff);
		GsOUT_PACKET_P+=0x20;
	}



	/********************/
	/* textured 3 doub sided*/
	/********************/
//	PPMod1A_T=(T3_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1A_T=*MemPointer++;
	PC_Mod1A_T=((*MemPointer++)&0xffff0000)>>16;

	for (lp=0;lp<PC_Mod1A_T;PPMod1A_T++,lp++)
	{
#if ForceSubDiv
//	PPMod1A_T->info|=0x0100;
	PPMod1A_T->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1A_T->vt0],&VertPointer[PPMod1A_T->vt1],
				&VertPointer[PPMod1A_T->vt2]);

	gte_rtpt();
	T3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	*(Uint32 *)&T3Out->u0=*(Uint32 *)&PPMod1A_T->u0;
	*(Uint32 *)&T3Out->u1=*(Uint32 *)&PPMod1A_T->u1;
	*(Uint32 *)&T3Out->u2=*(Uint32 *)&PPMod1A_T->u2;

	gte_stflg(&flag);						/* store flag */

	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1A_T->info&0x0300)==0) continue;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) continue;
	// if flaged an error and subdiv on and face not off front of screen
 	}

	gte_stsxy3_ft3(T3Out);

	// x's 2d virtices off edge of screen ?
	minmax3(T3Out->x0,
			T3Out->x1,
			T3Out->x2,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	continue;

	// y's 2d virtices off edge of screen ?
	minmax3(T3Out->y0,
			T3Out->y1,
			T3Out->y2,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) continue;


	// if get to here then poly is on screen at some point!
	switch ((PPMod1A_T->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


	// new smooth z dist clip
	if((otz>FarZDist))	continue;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1A_T->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{
#if SeeLines
		SortLinePoly(T3Out->x0,T3Out->y0,
					 T3Out->x1,T3Out->y1,
					 T3Out->x2,T3Out->y2,
					 255,180,0);
#endif


		SubDivFT3(PPMod1A_T,
						&VertPointer[PPMod1A_T->vt0],
						&VertPointer[PPMod1A_T->vt1],
						&VertPointer[PPMod1A_T->vt2],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);
		/* SubDived ++; */
		continue;
		}



		*(Uint32 *)&T3Out->r0=*(Uint32 *)&PPMod1A_T->r0;

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		T3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (T3Out) & 0x00ffffff);
		GsOUT_PACKET_P+=0x20;
	}




	/********************/
	/* GOURAUD flat coloured.. NO texture */
	/********************/
//	PPMod1A_G=(GF3_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1A_G=*MemPointer++;

	PPMod1A_G=(GF3_Packet *)PPMod1A_T;
	PC_Mod1A_G=(*MemPointer)&0x0000ffff;

	for (lp=0;lp<PC_Mod1A_G;PPMod1A_G++,lp++)
	{
#if ForceSubDiv
//	PPMod1A_G->info|=0x0100;
	PPMod1A_G->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1A_G->vt0],&VertPointer[PPMod1A_G->vt1],
				&VertPointer[PPMod1A_G->vt2]);

	gte_rtpt();
	GF3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr

	gte_stflg(&flag);						/* store flag */



	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz <=0) continue;	// except back facing
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1A_G->info&0x0300)==0) continue;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) continue;
	// if flaged an error and subdiv on and face not off front of screen
	gte_nclip();		// do nclip
	gte_stopz(&otz);
	if (otz <=0) continue;	// except back facing
 	}

	gte_stsxy3_g3(GF3Out);

	// x's 2d virtices off edge of screen ?
	minmax3(GF3Out->x0,
			GF3Out->x1,
			GF3Out->x2,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	continue;

	// y's 2d virtices off edge of screen ?
	minmax3(GF3Out->y0,
			GF3Out->y1,
			GF3Out->y2,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) continue;


	// if get to here then poly is on screen at some point!
	switch ((PPMod1A_G->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


	// new smooth z dist clip
	if((otz>FarZDist))	continue;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1A_G->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{
#if SeeLines
		SortLinePoly(GF3Out->x0,GF3Out->y0,
					 GF3Out->x1,GF3Out->y1,
					 GF3Out->x2,GF3Out->y2,
					 128,128,255);
#endif


		SubDivG3(PPMod1A_G,
				 &VertPointer[PPMod1A_G->vt0],
				 &VertPointer[PPMod1A_G->vt1],
				 &VertPointer[PPMod1A_G->vt2],
				 ((u_long *)(WOT+(otz>>OTSHIFT))),
				 0);
		/* SubDived ++; */
		continue;
		}



		*(Uint32 *)&GF3Out->r0=*(Uint32 *)&PPMod1A_G->r0;
		*(Uint32 *)&GF3Out->r1=*(Uint32 *)&PPMod1A_G->r1;
		*(Uint32 *)&GF3Out->r2=*(Uint32 *)&PPMod1A_G->r2;

//#if 0	// 4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GF3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GF3Out) & 0x00ffffff);
		GsOUT_PACKET_P+=0x1c;
//#endif
	}




	/********************/
	/* GOURAUD flat coloured DOUB SIDED.. NO texture */
	/********************/
//	PPMod1A_G=(GF3_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1A_G=*MemPointer++;
	PC_Mod1A_G=((*MemPointer++)&0xffff0000)>>16;

	for (lp=0;lp<PC_Mod1A_G;PPMod1A_G++,lp++)
	{
#if ForceSubDiv
//	PPMod1A_G->info|=0x0100;
	PPMod1A_G->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1A_G->vt0],&VertPointer[PPMod1A_G->vt1],
				&VertPointer[PPMod1A_G->vt2]);

	gte_rtpt();
	GF3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr

	gte_stflg(&flag);						/* store flag */


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1A_G->info&0x0300)==0) continue;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) continue;
	// if flaged an error and subdiv on and face not off front of screen
 	}

	gte_stsxy3_g3(GF3Out);

	// x's 2d virtices off edge of screen ?
	minmax3(GF3Out->x0,
			GF3Out->x1,
			GF3Out->x2,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	continue;

	// y's 2d virtices off edge of screen ?
	minmax3(GF3Out->y0,
			GF3Out->y1,
			GF3Out->y2,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) continue;


	// if get to here then poly is on screen at some point!
	switch ((PPMod1A_G->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


	// new smooth z dist clip
	if((otz>FarZDist))	continue;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1A_G->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{
#if SeeLines
		SortLinePoly(GF3Out->x0,GF3Out->y0,
					 GF3Out->x1,GF3Out->y1,
					 GF3Out->x2,GF3Out->y2,
					 128,128,255);
#endif


		SubDivG3(PPMod1A_G,
				 &VertPointer[PPMod1A_G->vt0],
				 &VertPointer[PPMod1A_G->vt1],
				 &VertPointer[PPMod1A_G->vt2],
				 ((u_long *)(WOT+(otz>>OTSHIFT))),
				 1);
		/* SubDived ++; */
		continue;
		}



		*(Uint32 *)&GF3Out->r0=*(Uint32 *)&PPMod1A_G->r0;
		*(Uint32 *)&GF3Out->r1=*(Uint32 *)&PPMod1A_G->r1;
		*(Uint32 *)&GF3Out->r2=*(Uint32 *)&PPMod1A_G->r2;

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GF3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GF3Out) & 0x00ffffff);
		GsOUT_PACKET_P+=0x1c;
//#endif
	}




	/********************/
	/* GOURAUD textured */
	/********************/
//	PPMod1A_GT=(GT3_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1A_GT=*MemPointer++;

	PPMod1A_GT=(GT3_Packet *)PPMod1A_G;
	PC_Mod1A_GT=(*MemPointer)&0x0000ffff;


	for (lp=0;lp<PC_Mod1A_GT;PPMod1A_GT++,lp++)
	{
#if ForceSubDiv
//	PPMod1A_GT->info|=0x0100;
	PPMod1A_GT->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1A_GT->vt0],&VertPointer[PPMod1A_GT->vt1],
				&VertPointer[PPMod1A_GT->vt2]);

	gte_rtpt();
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	*(Uint32 *)&GT3Out->u0=*(Uint32 *)&PPMod1A_GT->u0;
	*(Uint32 *)&GT3Out->u1=*(Uint32 *)&PPMod1A_GT->u1;
	*(Uint32 *)&GT3Out->u2=*(Uint32 *)&PPMod1A_GT->u2;

	gte_stflg(&flag);						/* store flag */



	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz <=0) continue;	// except back facing
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1A_GT->info&0x0300)==0) continue;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) continue;
	// if flaged an error and subdiv on and face not off front of screen
	gte_nclip();		// do nclip
	gte_stopz(&otz);
	if (otz <=0) continue;	// except back facing
 	}

// only need to check if face off front of screen if flaged an error
// also if subdiv is off and flaged an error cancel face
// so 2 lines below are now above
//	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);
// 	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) continue;

	gte_stsxy3_gt3(GT3Out);

	// x's 2d virtices off edge of screen ?
	minmax3(GT3Out->x0,
			GT3Out->x1,
			GT3Out->x2,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	continue;

	// y's 2d virtices off edge of screen ?
	minmax3(GT3Out->y0,
			GT3Out->y1,
			GT3Out->y2,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) continue;


	// if get to here then poly is on screen at some point!
	switch ((PPMod1A_GT->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


	// new smooth z dist clip
	if((otz>FarZDist))	continue;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1A_GT->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{
#if SeeLines
		SortLinePoly(GT3Out->x0,GT3Out->y0,
					 GT3Out->x1,GT3Out->y1,
					 GT3Out->x2,GT3Out->y2,
					 255,0,0);
#endif


		SubDivGT3(	PPMod1A_GT,
						&VertPointer[PPMod1A_GT->vt0],
						&VertPointer[PPMod1A_GT->vt1],
						&VertPointer[PPMod1A_GT->vt2],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);
		/* SubDived ++; */
		continue;
		}



//		*(Uint32 *)&GT3Out->u0=*(Uint32 *)&PPMod1A_GT->u0;
//		*(Uint32 *)&GT3Out->u1=*(Uint32 *)&PPMod1A_GT->u1;
//		*(Uint32 *)&GT3Out->u2=*(Uint32 *)&PPMod1A_GT->u2;
		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&PPMod1A_GT->r0;
		*(Uint32 *)&GT3Out->r1=*(Uint32 *)&PPMod1A_GT->r1;
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&PPMod1A_GT->r2;

//#if 0	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GsOUT_PACKET_P+=0x28;
//#endif
	}



	/********************/
	/* GOURAUD textured doub sided*/
	/********************/
//	PPMod1A_GT=(GT3_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1A_GT=*MemPointer++;
	PC_Mod1A_GT=((*MemPointer++)&0xffff0000)>>16;


	for (lp=0;lp<PC_Mod1A_GT;PPMod1A_GT++,lp++)
	{
#if ForceSubDiv
//	PPMod1A_GT->info|=0x0100;
	PPMod1A_GT->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1A_GT->vt0],&VertPointer[PPMod1A_GT->vt1],
				&VertPointer[PPMod1A_GT->vt2]);

	gte_rtpt();
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	*(Uint32 *)&GT3Out->u0=*(Uint32 *)&PPMod1A_GT->u0;
	*(Uint32 *)&GT3Out->u1=*(Uint32 *)&PPMod1A_GT->u1;
	*(Uint32 *)&GT3Out->u2=*(Uint32 *)&PPMod1A_GT->u2;

	gte_stflg(&flag);						/* store flag */


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1A_GT->info&0x0300)==0) continue;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) continue;
	// if flaged an error and subdiv on and face not off front of screen
 	}

	gte_stsxy3_gt3(GT3Out);

	// x's 2d virtices off edge of screen ?
	minmax3(GT3Out->x0,
			GT3Out->x1,
			GT3Out->x2,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	continue;

	// y's 2d virtices off edge of screen ?
	minmax3(GT3Out->y0,
			GT3Out->y1,
			GT3Out->y2,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) continue;


	// if get to here then poly is on screen at some point!
	switch ((PPMod1A_GT->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	otz=maxz>>2;
	break;
	}


	// new smooth z dist clip
	if((otz>FarZDist))	continue;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1A_GT->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{
#if SeeLines
		SortLinePoly(GT3Out->x0,GT3Out->y0,
					 GT3Out->x1,GT3Out->y1,
					 GT3Out->x2,GT3Out->y2,
					 255,0,0);
#endif


		SubDivGT3(	PPMod1A_GT,
						&VertPointer[PPMod1A_GT->vt0],
						&VertPointer[PPMod1A_GT->vt1],
						&VertPointer[PPMod1A_GT->vt2],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);
		/* SubDived ++; */
		continue;
		}



		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&PPMod1A_GT->r0;
		*(Uint32 *)&GT3Out->r1=*(Uint32 *)&PPMod1A_GT->r1;
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&PPMod1A_GT->r2;

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GsOUT_PACKET_P+=0x28;
	}



// QUADS QUADS QUADS QUADS QUADS QUADS QUADS QUADS QUADS QUADS QUADS QUADS


	/****************/
	/* F4 QUAD FLAT NO TEXTURE JUST COLOUR ! */
	/****************/

//	PPMod1F_F=(F4_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1F_F=*MemPointer++;
//	PPMod1F_F_L1=PPMod1F_F+1;
//	PPMod1F_F_L2=PPMod1F_F+2;

	PPMod1F_F=(F4_Packet *)PPMod1A_GT;
	PC_Mod1F_F=(*MemPointer)&0x0000ffff;
	PPMod1F_F_L1=PPMod1F_F+1;
	PPMod1F_F_L2=PPMod1F_F+2;



	for (lp=0;lp<PC_Mod1F_F;PPMod1F_F_L2+=3)
	{
#if ForceSubDiv
//	PPMod1F_F->info|=0x0100;
	PPMod1F_F->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_F->vt3],&VertPointer[PPMod1F_F_L1->vt3],
				&VertPointer[PPMod1F_F_L2->vt3]);

	gte_rtpt();								/* do rot trans pers */
	F4Out=
	F4Out_L1=
	F4Out_L2=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr
//	lp+=3;
	lp++;

	gte_stsz3c(&sz4[0]);   // store z's of 4th vertex of each quad
	gte_stsxy3(		&F4Out->x3,
					&xy3s[0],
					&xy3s[1]);


	gte_ldv3(	&VertPointer[PPMod1F_F->vt0],&VertPointer[PPMod1F_F->vt1],
				&VertPointer[PPMod1F_F->vt2]);

	gte_rtpt();								/* do rot trans pers */


	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_f4(F4Out);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok1tF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&F4Out->x3);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT2F;
Gok1tF:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_F->info&0x0300)==0) goto PT2F;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT2F;

	// nclip when error has occured ? hmm is this wise ?
	// maybe we should do nclip on sub-divided faces instead ??
	// if flaged an error and subdiv on and not off front screen
	gte_nclip();			// do nclip check
	gte_stopz(&otz);
	if (otz >0) goto Gok11tF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&F4Out->x3);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT2F;
Gok11tF:
 	}

	// x's 2d virtices off edge of screen ?
	minmax4(F4Out->x0,
			F4Out->x1,
			F4Out->x2,
			F4Out->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT2F;

	// y's 2d virtices off edge of screen ?
	minmax4(F4Out->y0,
			F4Out->y1,
			F4Out->y2,
			F4Out->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT2F;



	switch ((PPMod1F_F->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[0]) minz=sz4[0];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[0]) maxz=sz4[0];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT2F;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_F->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)F4Out;

#if SeeLines
		SortLinePolyQ(F4Out->x0,F4Out->y0,
					  F4Out->x1,F4Out->y1,
					  F4Out->x2,F4Out->y2,
					  F4Out->x3,F4Out->y3,
					  255,0,150);

#endif

		SubDivF4(PPMod1F_F,
				&VertPointer[PPMod1F_F->vt0],
				&VertPointer[PPMod1F_F->vt1],
				&VertPointer[PPMod1F_F->vt2],
				&VertPointer[PPMod1F_F->vt3],
				((u_long *)(WOT+(otz>>OTSHIFT))),
				0);


	F4Out_L1=
	F4Out_L2=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT2F;
		}


		*(Uint32 *)&F4Out->r0=*(Uint32 *)&PPMod1F_F->r0;

//#if 0 //4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		F4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (F4Out) & 0x00ffffff);
//#endif
		F4Out_L1=		// get next work base addr
		++F4Out_L2;	// get next work base addr

PT2F: if (lp==PC_Mod1F_F) {PPMod1F_F=PPMod1F_F_L1; goto PT4F;}
#if ForceSubDiv
//	PPMod1F_F_L1->info|=0x0100;
	PPMod1F_F_L1->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_F_L1->vt0],&VertPointer[PPMod1F_F_L1->vt1],
				&VertPointer[PPMod1F_F_L1->vt2]);


	gte_rtpt();								/* do rot trans pers */
	PPMod1F_F+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_f4(F4Out_L1);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok2tF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[0]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT3F;
Gok2tF:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_F_L1->info&0x0300)==0) goto PT3F;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT3F;


	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok22tF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[0]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT3F;
Gok22tF:


 	}

	*(Uint32 *)&F4Out_L1->x3=*(Uint32 *)&xy3s[0];


	// x's 2d virtices off edge of screen ?
	minmax4(F4Out_L1->x0,
			F4Out_L1->x1,
			F4Out_L1->x2,
			F4Out_L1->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT3F;

	// y's 2d virtices off edge of screen ?
	minmax4(F4Out_L1->y0,
			F4Out_L1->y1,
			F4Out_L1->y2,
			F4Out_L1->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT3F;


	switch ((PPMod1F_F_L1->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[1]) minz=sz4[1];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[1]) maxz=sz4[1];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT3F;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_F_L1->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)F4Out_L1;


#if SeeLines
		SortLinePolyQ(F4Out_L1->x0,F4Out_L1->y0,
					  F4Out_L1->x1,F4Out_L1->y1,
					  F4Out_L1->x2,F4Out_L1->y2,
					  F4Out_L1->x3,F4Out_L1->y3,
					  255,0,150);

#endif

		SubDivF4(PPMod1F_F_L1,
				&VertPointer[PPMod1F_F_L1->vt0],
				&VertPointer[PPMod1F_F_L1->vt1],
				&VertPointer[PPMod1F_F_L1->vt2],
				&VertPointer[PPMod1F_F_L1->vt3],
				((u_long *)(WOT+(otz>>OTSHIFT))),
				0);


	F4Out_L2=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT3F;
		}


		*(Uint32 *)&F4Out_L1->r0=*(Uint32 *)&PPMod1F_F_L1->r0;
		*(Uint32 *)&F4Out_L1->x3=*(Uint32 *)&xy3s[0];		// get xy3 dcache

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		F4Out_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (F4Out_L1) & 0x00ffffff);
//#endif

		F4Out_L2++;	// get next work base addr

PT3F: if (lp==PC_Mod1F_F) {PPMod1F_F=PPMod1F_F_L2; goto PT4F;}
#if ForceSubDiv
//	PPMod1F_F_L2->info|=0x0100;
	PPMod1F_F_L2->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_F_L2->vt0],&VertPointer[PPMod1F_F_L2->vt1],
				&VertPointer[PPMod1F_F_L2->vt2]);

	gte_rtpt();								/* do rot trans pers */
	PPMod1F_F_L1+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_f4(F4Out_L2);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok4tF;
	// failed 1st nclip...check 2nd
//	gte_ldsxy0(*(long *)&GT4Out_L1->x3);
	gte_ldsxy0(*(long *)&xy3s[1]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT4F;
Gok4tF:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_F_L2->info&0x0300)==0) goto PT4F;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT4F;

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok44tF;
	// failed 1st nclip...check 2nd
//	gte_ldsxy0(*(long *)&GT4Out_L1->x3);
	gte_ldsxy0(*(long *)&xy3s[1]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT4F;
Gok44tF:


 	}


	*(Uint32 *)&F4Out_L2->x3=*(Uint32 *)&xy3s[1];


	// x's 2d virtices off edge of screen ?
	minmax4(F4Out_L2->x0,
			F4Out_L2->x1,
			F4Out_L2->x2,
			F4Out_L2->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT4F;

	// y's 2d virtices off edge of screen ?
	minmax4(F4Out_L2->y0,
			F4Out_L2->y1,
			F4Out_L2->y2,
			F4Out_L2->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT4F;


	switch ((PPMod1F_F_L2->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[2]) minz=sz4[2];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[2]) maxz=sz4[2];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT4F;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_F_L2->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)F4Out_L2;


#if SeeLines
		SortLinePolyQ(F4Out_L2->x0,F4Out_L2->y0,
					  F4Out_L2->x1,F4Out_L2->y1,
					  F4Out_L2->x2,F4Out_L2->y2,
					  F4Out_L2->x3,F4Out_L2->y3,
					  255,0,150);

#endif

		SubDivF4(PPMod1F_F_L2,
				&VertPointer[PPMod1F_F_L2->vt0],
				&VertPointer[PPMod1F_F_L2->vt1],
				&VertPointer[PPMod1F_F_L2->vt2],
				&VertPointer[PPMod1F_F_L2->vt3],
				((u_long *)(WOT+(otz>>OTSHIFT))),
				0);


	F4Out_L2=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT4F;
		}


		*(Uint32 *)&F4Out_L2->r0=*(Uint32 *)&PPMod1F_F_L2->r0;
		*(Uint32 *)&F4Out_L2->x3=*(Uint32 *)&xy3s[1];		// get xy3 dcache

//#if 0	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		F4Out_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (F4Out_L2) & 0x00ffffff);
//#endif

		F4Out_L2++;	// get next work base addr

PT4F:

		GsOUT_PACKET_P=(PACKET *)F4Out_L2;

	}



	/****************/
	/* F4 QUAD FLAT doub sided NO TEXTURE JUST COLOUR ! */
	/****************/

//	PPMod1F_F=(F4_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1F_F=*MemPointer++;
	PC_Mod1F_F=((*MemPointer++)&0xffff0000)>>16;
	PPMod1F_F_L1=PPMod1F_F+1;
	PPMod1F_F_L2=PPMod1F_F+2;


	for (lp=0;lp<PC_Mod1F_F;PPMod1F_F_L2+=3)
	{
#if ForceSubDiv
//	PPMod1F_F->info|=0x0100;
	PPMod1F_F->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_F->vt3],&VertPointer[PPMod1F_F_L1->vt3],
				&VertPointer[PPMod1F_F_L2->vt3]);

	gte_rtpt();								/* do rot trans pers */
	F4Out=
	F4Out_L1=
	F4Out_L2=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr
//	lp+=3;
	lp++;

	gte_stsz3c(&sz4[0]);   // store z's of 4th vertex of each quad
	gte_stsxy3(		&F4Out->x3,
					&xy3s[0],
					&xy3s[1]);


	gte_ldv3(	&VertPointer[PPMod1F_F->vt0],&VertPointer[PPMod1F_F->vt1],
				&VertPointer[PPMod1F_F->vt2]);

	gte_rtpt();								/* do rot trans pers */


	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_f4(F4Out);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_F->info&0x0300)==0) goto PT2Fd;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT2Fd;
 	}

	// x's 2d virtices off edge of screen ?
	minmax4(F4Out->x0,
			F4Out->x1,
			F4Out->x2,
			F4Out->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT2Fd;

	// y's 2d virtices off edge of screen ?
	minmax4(F4Out->y0,
			F4Out->y1,
			F4Out->y2,
			F4Out->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT2Fd;



	switch ((PPMod1F_F->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[0]) minz=sz4[0];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[0]) maxz=sz4[0];
	otz=maxz>>2;
	break;
	}
	// new smooth z dist clip
	if((otz>FarZDist))	goto PT2Fd;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_F->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)F4Out;

#if SeeLines
		SortLinePolyQ(F4Out->x0,F4Out->y0,
					  F4Out->x1,F4Out->y1,
					  F4Out->x2,F4Out->y2,
					  F4Out->x3,F4Out->y3,
					  255,0,150);

#endif

		SubDivF4(PPMod1F_F,
				&VertPointer[PPMod1F_F->vt0],
				&VertPointer[PPMod1F_F->vt1],
				&VertPointer[PPMod1F_F->vt2],
				&VertPointer[PPMod1F_F->vt3],
				((u_long *)(WOT+(otz>>OTSHIFT))),
				1);


	F4Out_L1=
	F4Out_L2=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT2Fd;
		}


		*(Uint32 *)&F4Out->r0=*(Uint32 *)&PPMod1F_F->r0;

//#if 0 //4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		F4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (F4Out) & 0x00ffffff);
//#endif

		F4Out_L1=		// get next work base addr
		++F4Out_L2;	// get next work base addr

PT2Fd: if (lp==PC_Mod1F_F) {PPMod1F_F=PPMod1F_F_L1; goto PT4Fd;}
#if ForceSubDiv
//	PPMod1F_F_L1->info|=0x0100;
	PPMod1F_F_L1->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_F_L1->vt0],&VertPointer[PPMod1F_F_L1->vt1],
				&VertPointer[PPMod1F_F_L1->vt2]);


	gte_rtpt();								/* do rot trans pers */
	PPMod1F_F+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_f4(F4Out_L1);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_F_L1->info&0x0300)==0) goto PT3Fd;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT3Fd;
 	}

	*(Uint32 *)&F4Out_L1->x3=*(Uint32 *)&xy3s[0];


	// x's 2d virtices off edge of screen ?
	minmax4(F4Out_L1->x0,
			F4Out_L1->x1,
			F4Out_L1->x2,
			F4Out_L1->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT3Fd;

	// y's 2d virtices off edge of screen ?
	minmax4(F4Out_L1->y0,
			F4Out_L1->y1,
			F4Out_L1->y2,
			F4Out_L1->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT3Fd;


	switch ((PPMod1F_F_L1->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[1]) minz=sz4[1];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[1]) maxz=sz4[1];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT3Fd;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_F_L1->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)F4Out_L1;


#if SeeLines
		SortLinePolyQ(F4Out_L1->x0,F4Out_L1->y0,
					  F4Out_L1->x1,F4Out_L1->y1,
					  F4Out_L1->x2,F4Out_L1->y2,
					  F4Out_L1->x3,F4Out_L1->y3,
					  255,0,150);

#endif

		SubDivF4(PPMod1F_F_L1,
				&VertPointer[PPMod1F_F_L1->vt0],
				&VertPointer[PPMod1F_F_L1->vt1],
				&VertPointer[PPMod1F_F_L1->vt2],
				&VertPointer[PPMod1F_F_L1->vt3],
				((u_long *)(WOT+(otz>>OTSHIFT))),
				1);


	F4Out_L2=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT3Fd;
		}


		*(Uint32 *)&F4Out_L1->r0=*(Uint32 *)&PPMod1F_F_L1->r0;
		*(Uint32 *)&F4Out_L1->x3=*(Uint32 *)&xy3s[0];		// get xy3 dcache

//#if 0 //4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		F4Out_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (F4Out_L1) & 0x00ffffff);
//#endif

		F4Out_L2++;	// get next work base addr

PT3Fd: if (lp==PC_Mod1F_F) {PPMod1F_F=PPMod1F_F_L2; goto PT4Fd;}
#if ForceSubDiv
//	PPMod1F_F_L2->info|=0x0100;
	PPMod1F_F_L2->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_F_L2->vt0],&VertPointer[PPMod1F_F_L2->vt1],
				&VertPointer[PPMod1F_F_L2->vt2]);

	gte_rtpt();								/* do rot trans pers */
	PPMod1F_F_L1+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_f4(F4Out_L2);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_F_L2->info&0x0300)==0) goto PT4Fd;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT4Fd;
 	}


	*(Uint32 *)&F4Out_L2->x3=*(Uint32 *)&xy3s[1];


	// x's 2d virtices off edge of screen ?
	minmax4(F4Out_L2->x0,
			F4Out_L2->x1,
			F4Out_L2->x2,
			F4Out_L2->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT4Fd;

	// y's 2d virtices off edge of screen ?
	minmax4(F4Out_L2->y0,
			F4Out_L2->y1,
			F4Out_L2->y2,
			F4Out_L2->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT4Fd;


	switch ((PPMod1F_F_L2->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[2]) minz=sz4[2];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[2]) maxz=sz4[2];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT4Fd;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_F_L2->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)F4Out_L2;


#if SeeLines
		SortLinePolyQ(F4Out_L2->x0,F4Out_L2->y0,
					  F4Out_L2->x1,F4Out_L2->y1,
					  F4Out_L2->x2,F4Out_L2->y2,
					  F4Out_L2->x3,F4Out_L2->y3,
					  255,0,150);

#endif

		SubDivF4(PPMod1F_F_L2,
				&VertPointer[PPMod1F_F_L2->vt0],
				&VertPointer[PPMod1F_F_L2->vt1],
				&VertPointer[PPMod1F_F_L2->vt2],
				&VertPointer[PPMod1F_F_L2->vt3],
				((u_long *)(WOT+(otz>>OTSHIFT))),
				1);


	F4Out_L2=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT4Fd;
		}


		*(Uint32 *)&F4Out_L2->r0=*(Uint32 *)&PPMod1F_F_L2->r0;
		*(Uint32 *)&F4Out_L2->x3=*(Uint32 *)&xy3s[1];		// get xy3 dcache

//#if 0 //4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		F4Out_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (F4Out_L2) & 0x00ffffff);
//#endif

		F4Out_L2++;	// get next work base addr

PT4Fd:

		GsOUT_PACKET_P=(PACKET *)F4Out_L2;

	}





	// textured quad!		t4
	/****************/
	/* NEW textured 4 */
	/****************/

//	PPMod1F_T=(T4_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1F_T=*MemPointer++;
//	PPMod1F_T_L1=PPMod1F_T+1;
//	PPMod1F_T_L2=PPMod1F_T+2;

	PPMod1F_T=(T4_Packet *)PPMod1F_F;
	PC_Mod1F_T=(*MemPointer)&0x0000ffff;
	PPMod1F_T_L1=PPMod1F_T+1;
	PPMod1F_T_L2=PPMod1F_T+2;



	for (lp=0;lp<PC_Mod1F_T;PPMod1F_T_L2+=3)
	{
#if ForceSubDiv
//	PPMod1F_T->info|=0x0100;
	PPMod1F_T->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_T->vt3],&VertPointer[PPMod1F_T_L1->vt3],
				&VertPointer[PPMod1F_T_L2->vt3]);



	gte_rtpt();								/* do rot trans pers */
	T4Out=
	T4Out_L1=
	T4Out_L2=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr
//	lp+=3;
	lp++;


	gte_stsz3c(&sz4[0]);   // store z's of 4th vertex of each quad
	gte_stsxy3(		&T4Out->x3,
					&xy3s[0],
					&xy3s[1]);




	gte_ldv3(	&VertPointer[PPMod1F_T->vt0],&VertPointer[PPMod1F_T->vt1],
				&VertPointer[PPMod1F_T->vt2]);

	gte_rtpt();								/* do rot trans pers */


	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_ft4(T4Out);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok1t;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&T4Out->x3);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT2;
Gok1t:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_T->info&0x0300)==0) goto PT2;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT2;

	// nclip when error has occured ? hmm is this wise ?
	// maybe we should do nclip on sub-divided faces instead ??
	// if flaged an error and subdiv on and not off front screen
	gte_nclip();			// do nclip check
	gte_stopz(&otz);
	if (otz >0) goto Gok11t;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&T4Out->x3);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT2;
Gok11t:
 	}

	// x's 2d virtices off edge of screen ?
	minmax4(T4Out->x0,
			T4Out->x1,
			T4Out->x2,
			T4Out->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT2;

	// y's 2d virtices off edge of screen ?
	minmax4(T4Out->y0,
			T4Out->y1,
			T4Out->y2,
			T4Out->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT2;



	switch ((PPMod1F_T->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[0]) minz=sz4[0];
	otz=minz>>2;
	break;

	default:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far	sort
		max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[0]) maxz=sz4[0];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT2;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_T->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    //||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)T4Out;

#if SeeLines
		SortLinePolyQ(T4Out->x0,T4Out->y0,
					 T4Out->x1,T4Out->y1,
					 T4Out->x2,T4Out->y2,
					 T4Out->x3,T4Out->y3,
					 0,0,255);

#endif

		SubDivFT4(PPMod1F_T,
						&VertPointer[PPMod1F_T->vt0],
						&VertPointer[PPMod1F_T->vt1],
						&VertPointer[PPMod1F_T->vt2],
						&VertPointer[PPMod1F_T->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);


	T4Out_L1=
	T4Out_L2=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT2;
		}


		*(Uint32 *)&T4Out->u0=*(Uint32 *)&PPMod1F_T->u0;
		*(Uint32 *)&T4Out->u1=*(Uint32 *)&PPMod1F_T->u1;
		*(Uint32 *)&T4Out->u2=*(Uint32 *)&PPMod1F_T->u2;
		*(Uint32 *)&T4Out->u3=*(Uint32 *)&PPMod1F_T->u3;
		*(Uint32 *)&T4Out->r0=*(Uint32 *)&PPMod1F_T->r0;

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		T4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (T4Out) & 0x00ffffff);

		T4Out_L1=		// get next work base addr
		++T4Out_L2;	// get next work base addr



PT2: if (lp==PC_Mod1F_T) {PPMod1F_T=PPMod1F_T_L1; goto PT4;}
#if ForceSubDiv
//	PPMod1F_T_L1->info|=0x0100;
	PPMod1F_T_L1->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_T_L1->vt0],&VertPointer[PPMod1F_T_L1->vt1],
				&VertPointer[PPMod1F_T_L1->vt2]);


	gte_rtpt();								/* do rot trans pers */
	lp++;
	PPMod1F_T+=3;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_ft4(T4Out_L1);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok2t;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[0]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT3;
Gok2t:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_T_L1->info&0x0300)==0) goto PT3;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT3;


	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok22t;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[0]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT3;
Gok22t:


 	}

	*(Uint32 *)&T4Out_L1->x3=*(Uint32 *)&xy3s[0];


	// x's 2d virtices off edge of screen ?
	minmax4(T4Out_L1->x0,
			T4Out_L1->x1,
			T4Out_L1->x2,
			T4Out_L1->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT3;

	// y's 2d virtices off edge of screen ?
	minmax4(T4Out_L1->y0,
			T4Out_L1->y1,
			T4Out_L1->y2,
			T4Out_L1->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT3;


	switch ((PPMod1F_T_L1->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
 	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[1]) minz=sz4[1];
	otz=minz>>2;
	break;

	default:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far	sort
		max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[1]) maxz=sz4[1];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT3;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_T_L1->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    //||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)T4Out_L1;


#if SeeLines
		SortLinePolyQ(T4Out_L1->x0,T4Out_L1->y0,
					 T4Out_L1->x1,T4Out_L1->y1,
					 T4Out_L1->x2,T4Out_L1->y2,
					 T4Out_L1->x3,T4Out_L1->y3,
					 0,0,255);

#endif

		SubDivFT4(PPMod1F_T_L1,
					&VertPointer[PPMod1F_T_L1->vt0],
					&VertPointer[PPMod1F_T_L1->vt1],
					&VertPointer[PPMod1F_T_L1->vt2],
					&VertPointer[PPMod1F_T_L1->vt3],
					((u_long *)(WOT+(otz>>OTSHIFT))),
					0);


	T4Out_L2=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT3;
		}


		*(Uint32 *)&T4Out_L1->u0=*(Uint32 *)&PPMod1F_T_L1->u0;
		*(Uint32 *)&T4Out_L1->u1=*(Uint32 *)&PPMod1F_T_L1->u1;
		*(Uint32 *)&T4Out_L1->u2=*(Uint32 *)&PPMod1F_T_L1->u2;
		*(Uint32 *)&T4Out_L1->u3=*(Uint32 *)&PPMod1F_T_L1->u3;
		*(Uint32 *)&T4Out_L1->r0=*(Uint32 *)&PPMod1F_T_L1->r0;
		*(Uint32 *)&T4Out_L1->x3=*(Uint32 *)&xy3s[0];		// get xy3 dcache

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		T4Out_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (T4Out_L1) & 0x00ffffff);

		T4Out_L2++;	// get next work base addr

PT3: if (lp==PC_Mod1F_T) {PPMod1F_T=PPMod1F_T_L2; goto PT4;}
#if ForceSubDiv
//	PPMod1F_T_L2->info|=0x0100;
	PPMod1F_T_L2->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_T_L2->vt0],&VertPointer[PPMod1F_T_L2->vt1],
				&VertPointer[PPMod1F_T_L2->vt2]);

	gte_rtpt();								/* do rot trans pers */
	lp++;
	PPMod1F_T_L1+=3;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_ft4(T4Out_L2);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok4t;
	// failed 1st nclip...check 2nd
//	gte_ldsxy0(*(long *)&GT4Out_L1->x3);
	gte_ldsxy0(*(long *)&xy3s[1]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT4;
Gok4t:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_T_L2->info&0x0300)==0) goto PT4;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT4;

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok44t;
	// failed 1st nclip...check 2nd
//	gte_ldsxy0(*(long *)&GT4Out_L1->x3);
	gte_ldsxy0(*(long *)&xy3s[1]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PT4;
Gok44t:


 	}


	*(Uint32 *)&T4Out_L2->x3=*(Uint32 *)&xy3s[1];


	// x's 2d virtices off edge of screen ?
	minmax4(T4Out_L2->x0,
			T4Out_L2->x1,
			T4Out_L2->x2,
			T4Out_L2->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT4;

	// y's 2d virtices off edge of screen ?
	minmax4(T4Out_L2->y0,
			T4Out_L2->y1,
			T4Out_L2->y2,
			T4Out_L2->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT4;


	switch ((PPMod1F_T_L2->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
		min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[2]) minz=sz4[2];
	otz=minz>>2;
	break;

	default:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far	sort
		max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[2]) maxz=sz4[2];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT4;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_T_L2->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    //||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)T4Out_L2;


#if SeeLines
		SortLinePolyQ(T4Out_L2->x0,T4Out_L2->y0,
					 T4Out_L2->x1,T4Out_L2->y1,
					 T4Out_L2->x2,T4Out_L2->y2,
					 T4Out_L2->x3,T4Out_L2->y3,
					 0,0,255);

#endif

		SubDivFT4(PPMod1F_T_L2,
						&VertPointer[PPMod1F_T_L2->vt0],
						&VertPointer[PPMod1F_T_L2->vt1],
						&VertPointer[PPMod1F_T_L2->vt2],
						&VertPointer[PPMod1F_T_L2->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);


	T4Out_L2=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT4;
		}


		*(Uint32 *)&T4Out_L2->u0=*(Uint32 *)&PPMod1F_T_L2->u0;
		*(Uint32 *)&T4Out_L2->u1=*(Uint32 *)&PPMod1F_T_L2->u1;
		*(Uint32 *)&T4Out_L2->u2=*(Uint32 *)&PPMod1F_T_L2->u2;
		*(Uint32 *)&T4Out_L2->u3=*(Uint32 *)&PPMod1F_T_L2->u3;
		*(Uint32 *)&T4Out_L2->r0=*(Uint32 *)&PPMod1F_T_L2->r0;
		*(Uint32 *)&T4Out_L2->x3=*(Uint32 *)&xy3s[1];		// get xy3 dcache

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		T4Out_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (T4Out_L2) & 0x00ffffff);

		T4Out_L2++;	// get next work base addr

PT4:

		GsOUT_PACKET_P=(PACKET *)T4Out_L2;

	}







	// textured quad!		t4
	/****************/
	/* NEW textured quad doub sided */
	/****************/

//	PPMod1F_T=(T4_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1F_T=*MemPointer++;
	PC_Mod1F_T=((*MemPointer++)&0xffff0000)>>16;
	PPMod1F_T_L1=PPMod1F_T+1;
	PPMod1F_T_L2=PPMod1F_T+2;


	for (lp=0;lp<PC_Mod1F_T;PPMod1F_T_L2+=3)
	{
#if ForceSubDiv
//	PPMod1F_T->info|=0x0100;
	PPMod1F_T->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_T->vt3],&VertPointer[PPMod1F_T_L1->vt3],
				&VertPointer[PPMod1F_T_L2->vt3]);



	gte_rtpt();								/* do rot trans pers */
	T4Out=
	T4Out_L1=
	T4Out_L2=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr
	lp++;
//	lp+=3;


	gte_stsz3c(&sz4[0]);   // store z's of 4th vertex of each quad
	gte_stsxy3(		&T4Out->x3,
					&xy3s[0],
					&xy3s[1]);




	gte_ldv3(	&VertPointer[PPMod1F_T->vt0],&VertPointer[PPMod1F_T->vt1],
				&VertPointer[PPMod1F_T->vt2]);

	gte_rtpt();								/* do rot trans pers */


	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_ft4(T4Out);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_T->info&0x0300)==0) goto PT2D;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT2D;
 	}

	// x's 2d virtices off edge of screen ?
	minmax4(T4Out->x0,
			T4Out->x1,
			T4Out->x2,
			T4Out->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT2D;

	// y's 2d virtices off edge of screen ?
	minmax4(T4Out->y0,
			T4Out->y1,
			T4Out->y2,
			T4Out->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT2D;


	switch ((PPMod1F_T->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[0]) minz=sz4[0];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[0]) maxz=sz4[0];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT2D;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_T->info&0x0300))	&&
	   	( (flag & 0x80000000)
//	    ||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)T4Out;

#if SeeLines
		SortLinePolyQ(T4Out->x0,T4Out->y0,
					 T4Out->x1,T4Out->y1,
					 T4Out->x2,T4Out->y2,
					 T4Out->x3,T4Out->y3,
					 0,0,255);

#endif



		SubDivFT4(PPMod1F_T,
						&VertPointer[PPMod1F_T->vt0],
						&VertPointer[PPMod1F_T->vt1],
						&VertPointer[PPMod1F_T->vt2],
						&VertPointer[PPMod1F_T->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);


	T4Out_L1=
	T4Out_L2=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT2D;
		}


		*(Uint32 *)&T4Out->u0=*(Uint32 *)&PPMod1F_T->u0;
		*(Uint32 *)&T4Out->u1=*(Uint32 *)&PPMod1F_T->u1;
		*(Uint32 *)&T4Out->u2=*(Uint32 *)&PPMod1F_T->u2;
		*(Uint32 *)&T4Out->u3=*(Uint32 *)&PPMod1F_T->u3;
		*(Uint32 *)&T4Out->r0=*(Uint32 *)&PPMod1F_T->r0;

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		T4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (T4Out) & 0x00ffffff);

		T4Out_L1=		// get next work base addr
		++T4Out_L2;	// get next work base addr

PT2D: if (lp==PC_Mod1F_T) {PPMod1F_T=PPMod1F_T_L1; goto PT4D;}
#if ForceSubDiv
//	PPMod1F_T_L1->info|=0x0100;
	PPMod1F_T_L1->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_T_L1->vt0],&VertPointer[PPMod1F_T_L1->vt1],
				&VertPointer[PPMod1F_T_L1->vt2]);


	gte_rtpt();								/* do rot trans pers */
	PPMod1F_T+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_ft4(T4Out_L1);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_T_L1->info&0x0300)==0) goto PT3D;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT3D;
 	}

	*(Uint32 *)&T4Out_L1->x3=*(Uint32 *)&xy3s[0];

	// x's 2d virtices off edge of screen ?
	minmax4(T4Out_L1->x0,
			T4Out_L1->x1,
			T4Out_L1->x2,
			T4Out_L1->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT3D;

	// y's 2d virtices off edge of screen ?
	minmax4(T4Out_L1->y0,
			T4Out_L1->y1,
			T4Out_L1->y2,
			T4Out_L1->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT3D;

	switch ((PPMod1F_T_L1->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[1]) minz=sz4[1];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[1]) maxz=sz4[1];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT3D;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_T_L1->info&0x0300))	&&
	   	( (flag & 0x80000000)
//	    ||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)T4Out_L1;


#if SeeLines
		SortLinePolyQ(T4Out_L1->x0,T4Out_L1->y0,
					 T4Out_L1->x1,T4Out_L1->y1,
					 T4Out_L1->x2,T4Out_L1->y2,
					 T4Out_L1->x3,T4Out_L1->y3,
					 0,0,255);

#endif


		SubDivFT4(PPMod1F_T_L1,
					&VertPointer[PPMod1F_T_L1->vt0],
					&VertPointer[PPMod1F_T_L1->vt1],
					&VertPointer[PPMod1F_T_L1->vt2],
					&VertPointer[PPMod1F_T_L1->vt3],
					((u_long *)(WOT+(otz>>OTSHIFT))),
					1);


	T4Out_L2=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT3D;
		}


		*(Uint32 *)&T4Out_L1->u0=*(Uint32 *)&PPMod1F_T_L1->u0;
		*(Uint32 *)&T4Out_L1->u1=*(Uint32 *)&PPMod1F_T_L1->u1;
		*(Uint32 *)&T4Out_L1->u2=*(Uint32 *)&PPMod1F_T_L1->u2;
		*(Uint32 *)&T4Out_L1->u3=*(Uint32 *)&PPMod1F_T_L1->u3;
		*(Uint32 *)&T4Out_L1->r0=*(Uint32 *)&PPMod1F_T_L1->r0;
		*(Uint32 *)&T4Out_L1->x3=*(Uint32 *)&xy3s[0];		// get xy3 dcache

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		T4Out_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (T4Out_L1) & 0x00ffffff);

		T4Out_L2++;	// get next work base addr

PT3D:	if (lp==PC_Mod1F_T) {PPMod1F_T=PPMod1F_T_L2; goto PT4D; }
#if ForceSubDiv
//	PPMod1F_T_L2->info|=0x0100;
	PPMod1F_T_L2->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_T_L2->vt0],&VertPointer[PPMod1F_T_L2->vt1],
				&VertPointer[PPMod1F_T_L2->vt2]);

	gte_rtpt();								/* do rot trans pers */
	PPMod1F_T_L1+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_ft4(T4Out_L2);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_T_L2->info&0x0300)==0) goto PT4D;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PT4D;
 	}


	*(Uint32 *)&T4Out_L2->x3=*(Uint32 *)&xy3s[1];

	// x's 2d virtices off edge of screen ?
	minmax4(T4Out_L2->x0,
			T4Out_L2->x1,
			T4Out_L2->x2,
			T4Out_L2->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PT4D;

	// y's 2d virtices off edge of screen ?
	minmax4(T4Out_L2->y0,
			T4Out_L2->y1,
			T4Out_L2->y2,
			T4Out_L2->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PT4D;

	switch ((PPMod1F_T_L2->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[2]) minz=sz4[2];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[2]) maxz=sz4[2];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PT4D;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_T_L2->info&0x0300))	&&
	   	( (flag & 0x80000000)
//	    ||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{


		GsOUT_PACKET_P=(PACKET *)T4Out_L2;

#if SeeLines
		SortLinePolyQ(T4Out_L2->x0,T4Out_L2->y0,
					 T4Out_L2->x1,T4Out_L2->y1,
					 T4Out_L2->x2,T4Out_L2->y2,
					 T4Out_L2->x3,T4Out_L2->y3,
					 0,0,255);

#endif


		SubDivFT4(PPMod1F_T_L2,
						&VertPointer[PPMod1F_T_L2->vt0],
						&VertPointer[PPMod1F_T_L2->vt1],
						&VertPointer[PPMod1F_T_L2->vt2],
						&VertPointer[PPMod1F_T_L2->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);


	T4Out_L2=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PT4D;
		}


		*(Uint32 *)&T4Out_L2->u0=*(Uint32 *)&PPMod1F_T_L2->u0;
		*(Uint32 *)&T4Out_L2->u1=*(Uint32 *)&PPMod1F_T_L2->u1;
		*(Uint32 *)&T4Out_L2->u2=*(Uint32 *)&PPMod1F_T_L2->u2;
		*(Uint32 *)&T4Out_L2->u3=*(Uint32 *)&PPMod1F_T_L2->u3;
		*(Uint32 *)&T4Out_L2->r0=*(Uint32 *)&PPMod1F_T_L2->r0;
		*(Uint32 *)&T4Out_L2->x3=*(Uint32 *)&xy3s[1];		// get xy3 dcache

		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		T4Out_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (T4Out_L2) & 0x00ffffff);

		T4Out_L2++;	// get next work base addr

PT4D:

		GsOUT_PACKET_P=(PACKET *)T4Out_L2;

	}





	// GOURAUD!		gf4
	/****************/
	/* flat gouraud coloured quad */
	/****************/

//	PPMod1F_G=(GF4_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1F_G=*MemPointer++;
//	PPMod1F_G_L1=PPMod1F_G+1;
//	PPMod1F_G_L2=PPMod1F_G+2;

	PPMod1F_G=(GF4_Packet *)PPMod1F_T;
//	PC_Mod1F_G=*MemPointer++;
	PC_Mod1F_G=(*MemPointer)&0x0000ffff;
	PPMod1F_G_L1=PPMod1F_G+1;
	PPMod1F_G_L2=PPMod1F_G+2;



	for (lp=0;lp<PC_Mod1F_G;PPMod1F_G_L2+=3)
	{
#if ForceSubDiv
//	PPMod1F_G->info|=0x0100;
	PPMod1F_G->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_G->vt3],&VertPointer[PPMod1F_G_L1->vt3],
				&VertPointer[PPMod1F_G_L2->vt3]);



	gte_rtpt();								/* do rot trans pers */
	GF4Out=
	GF4Out_L1=
	GF4Out_L2=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr
//	lp+=3;
	lp++;

	gte_stsz3c(&sz4[0]);   // store z's of 4th vertex of each quad
	gte_stsxy3(		&GF4Out->x3,
					&xy3s[0],
					&xy3s[1]);


	gte_ldv3(	&VertPointer[PPMod1F_G->vt0],&VertPointer[PPMod1F_G->vt1],
				&VertPointer[PPMod1F_G->vt2]);

	gte_rtpt();								/* do rot trans pers */


	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_g4(GF4Out);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok1FF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&GF4Out->x3);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT2FF;
Gok1FF:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_G->info&0x0300)==0) goto PGT2FF;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT2FF;

	// nclip when error has occured ? hmm is this wise ?
	// maybe we should do nclip on sub-divided faces instead ??
	// if flaged an error and subdiv on and not off front screen
	gte_nclip();			// do nclip check
	gte_stopz(&otz);
	if (otz >0) goto Gok11FF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&GF4Out->x3);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT2FF;
Gok11FF:
 	}

	// x's 2d virtices off edge of screen ?
	minmax4(GF4Out->x0,
			GF4Out->x1,
			GF4Out->x2,
			GF4Out->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT2FF;

	// y's 2d virtices off edge of screen ?
	minmax4(GF4Out->y0,
			GF4Out->y1,
			GF4Out->y2,
			GF4Out->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT2FF;



	switch ((PPMod1F_G->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[0]) minz=sz4[0];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[0]) maxz=sz4[0];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT2FF;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_G->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GF4Out;


#if SeeLines
		SortLinePolyQ(GF4Out->x0,GF4Out->y0,
					  GF4Out->x1,GF4Out->y1,
					  GF4Out->x2,GF4Out->y2,
					  GF4Out->x3,GF4Out->y3,
					  0,255,0);

#endif

		SubDivG4(PPMod1F_G,
						&VertPointer[PPMod1F_G->vt0],
						&VertPointer[PPMod1F_G->vt1],
						&VertPointer[PPMod1F_G->vt2],
						&VertPointer[PPMod1F_G->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);


	GF4Out_L1=
	GF4Out_L2=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT2FF;
		}


		*(Uint32 *)&GF4Out->r0=*(Uint32 *)&PPMod1F_G->r0;
		*(Uint32 *)&GF4Out->r1=*(Uint32 *)&PPMod1F_G->r1;
		*(Uint32 *)&GF4Out->r2=*(Uint32 *)&PPMod1F_G->r2;
		*(Uint32 *)&GF4Out->r3=*(Uint32 *)&PPMod1F_G->r3;

//#if 0	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GF4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GF4Out) & 0x00ffffff);
//#endif

		GF4Out_L1=		// get next work base addr
		++GF4Out_L2;	// get next work base addr

PGT2FF: if (lp==PC_Mod1F_G) {PPMod1F_G=PPMod1F_G_L1; goto PGT4FF; }
#if ForceSubDiv
//	PPMod1F_G_L1->info|=0x0100;
	PPMod1F_G_L1->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_G_L1->vt0],&VertPointer[PPMod1F_G_L1->vt1],
				&VertPointer[PPMod1F_G_L1->vt2]);


	gte_rtpt();								/* do rot trans pers */
	PPMod1F_G+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_g4(GF4Out_L1);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok2FF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[0]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT3FF;
Gok2FF:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_G_L1->info&0x0300)==0) goto PGT3FF;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT3FF;


	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok22FF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[0]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT3FF;
Gok22FF:


 	}

	*(Uint32 *)&GF4Out_L1->x3=*(Uint32 *)&xy3s[0];


	// x's 2d virtices off edge of screen ?
	minmax4(GF4Out_L1->x0,
			GF4Out_L1->x1,
			GF4Out_L1->x2,
			GF4Out_L1->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT3FF;

	// y's 2d virtices off edge of screen ?
	minmax4(GF4Out_L1->y0,
			GF4Out_L1->y1,
			GF4Out_L1->y2,
			GF4Out_L1->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT3FF;


	switch ((PPMod1F_G_L1->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[1]) minz=sz4[1];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[1]) maxz=sz4[1];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT3FF;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_G_L1->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GF4Out_L1;

#if SeeLines
		SortLinePolyQ(GF4Out_L1->x0,GF4Out_L1->y0,
					  GF4Out_L1->x1,GF4Out_L1->y1,
					  GF4Out_L1->x2,GF4Out_L1->y2,
					  GF4Out_L1->x3,GF4Out_L1->y3,
					  0,255,0);

#endif

		SubDivG4(PPMod1F_G_L1,
						&VertPointer[PPMod1F_G_L1->vt0],
						&VertPointer[PPMod1F_G_L1->vt1],
						&VertPointer[PPMod1F_G_L1->vt2],
						&VertPointer[PPMod1F_G_L1->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);


	GF4Out_L2=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT3FF;
		}


		*(Uint32 *)&GF4Out_L1->r0=*(Uint32 *)&PPMod1F_G_L1->r0;
		*(Uint32 *)&GF4Out_L1->r1=*(Uint32 *)&PPMod1F_G_L1->r1;
		*(Uint32 *)&GF4Out_L1->r2=*(Uint32 *)&PPMod1F_G_L1->r2;
		*(Uint32 *)&GF4Out_L1->r3=*(Uint32 *)&PPMod1F_G_L1->r3;
		*(Uint32 *)&GF4Out_L1->x3=*(Uint32 *)&xy3s[0];		// get xy3 dcache

//#if 0 //4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GF4Out_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GF4Out_L1) & 0x00ffffff);
//#endif

		GF4Out_L2++;	// get next work base addr

PGT3FF: if (lp==PC_Mod1F_G) {PPMod1F_G=PPMod1F_G_L2; goto PGT4FF;}
#if ForceSubDiv
//	PPMod1F_G_L2->info|=0x0100;
	PPMod1F_G_L2->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_G_L2->vt0],&VertPointer[PPMod1F_G_L2->vt1],
				&VertPointer[PPMod1F_G_L2->vt2]);

	gte_rtpt();								/* do rot trans pers */
	PPMod1F_G_L1+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */


	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_g4(GF4Out_L2);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok4FF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[1]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT4FF;
Gok4FF:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_G_L2->info&0x0300)==0) goto PGT4FF;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT4FF;

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok44FF;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[1]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT4FF;
Gok44FF:


 	}

	*(Uint32 *)&GF4Out_L2->x3=*(Uint32 *)&xy3s[1];


	// x's 2d virtices off edge of screen ?
	minmax4(GF4Out_L2->x0,
			GF4Out_L2->x1,
			GF4Out_L2->x2,
			GF4Out_L2->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT4FF;

	// y's 2d virtices off edge of screen ?
	minmax4(GF4Out_L2->y0,
			GF4Out_L2->y1,
			GF4Out_L2->y2,
			GF4Out_L2->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT4FF;


	switch ((PPMod1F_G_L2->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[2]) minz=sz4[2];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[2]) maxz=sz4[2];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT4FF;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_G_L2->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GF4Out_L2;

#if SeeLines
		SortLinePolyQ(GF4Out_L2->x0,GF4Out_L2->y0,
					  GF4Out_L2->x1,GF4Out_L2->y1,
					  GF4Out_L2->x2,GF4Out_L2->y2,
					  GF4Out_L2->x3,GF4Out_L2->y3,
					  0,255,0);

#endif

		SubDivG4(PPMod1F_G_L2,
						&VertPointer[PPMod1F_G_L2->vt0],
						&VertPointer[PPMod1F_G_L2->vt1],
						&VertPointer[PPMod1F_G_L2->vt2],
						&VertPointer[PPMod1F_G_L2->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);


	GF4Out_L2=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT4FF;
		}


		*(Uint32 *)&GF4Out_L2->r0=*(Uint32 *)&PPMod1F_G_L2->r0;
		*(Uint32 *)&GF4Out_L2->r1=*(Uint32 *)&PPMod1F_G_L2->r1;
		*(Uint32 *)&GF4Out_L2->r2=*(Uint32 *)&PPMod1F_G_L2->r2;
		*(Uint32 *)&GF4Out_L2->r3=*(Uint32 *)&PPMod1F_G_L2->r3;
		*(Uint32 *)&GF4Out_L2->x3=*(Uint32 *)&xy3s[1];		// get xy3 dcache

//#if 0	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GF4Out_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GF4Out_L2) & 0x00ffffff);
//#endif
		GF4Out_L2++;	// get next work base addr

PGT4FF:

		GsOUT_PACKET_P=(PACKET *)GF4Out_L2;

	}



	// GOURAUD!		gfD4
	/****************/
	/* flat gouraud coloured quad doub sided*/
	/****************/

//	PPMod1F_G=(GF4_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1F_G=*MemPointer++;
	PC_Mod1F_G=((*MemPointer++)&0xffff0000)>>16;
	PPMod1F_G_L1=PPMod1F_G+1;
	PPMod1F_G_L2=PPMod1F_G+2;


	for (lp=0;lp<PC_Mod1F_G;PPMod1F_G_L2+=3)
	{
#if ForceSubDiv
//	PPMod1F_G->info|=0x0100;
	PPMod1F_G->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_G->vt3],&VertPointer[PPMod1F_G_L1->vt3],
				&VertPointer[PPMod1F_G_L2->vt3]);



	gte_rtpt();								/* do rot trans pers */
	GF4Out=
	GF4Out_L1=
	GF4Out_L2=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr
	lp++;
//	lp+=3;


	gte_stsz3c(&sz4[0]);   // store z's of 4th vertex of each quad
	gte_stsxy3(		&GF4Out->x3,
					&xy3s[0],
					&xy3s[1]);


	gte_ldv3(	&VertPointer[PPMod1F_G->vt0],&VertPointer[PPMod1F_G->vt1],
				&VertPointer[PPMod1F_G->vt2]);

	gte_rtpt();								/* do rot trans pers */


	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_g4(GF4Out);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_G->info&0x0300)==0) goto PGT2FFd;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT2FFd;
 	}

	// x's 2d virtices off edge of screen ?
	minmax4(GF4Out->x0,
			GF4Out->x1,
			GF4Out->x2,
			GF4Out->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT2FFd;

	// y's 2d virtices off edge of screen ?
	minmax4(GF4Out->y0,
			GF4Out->y1,
			GF4Out->y2,
			GF4Out->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT2FFd;



	switch ((PPMod1F_G->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[0]) minz=sz4[0];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[0]) maxz=sz4[0];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT2FFd;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_G->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GF4Out;


#if SeeLines
		SortLinePolyQ(GF4Out->x0,GF4Out->y0,
					  GF4Out->x1,GF4Out->y1,
					  GF4Out->x2,GF4Out->y2,
					  GF4Out->x3,GF4Out->y3,
					  0,255,0);

#endif

		SubDivG4(PPMod1F_G,
						&VertPointer[PPMod1F_G->vt0],
						&VertPointer[PPMod1F_G->vt1],
						&VertPointer[PPMod1F_G->vt2],
						&VertPointer[PPMod1F_G->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);


	GF4Out_L1=
	GF4Out_L2=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT2FFd;
		}


		*(Uint32 *)&GF4Out->r0=*(Uint32 *)&PPMod1F_G->r0;
		*(Uint32 *)&GF4Out->r1=*(Uint32 *)&PPMod1F_G->r1;
		*(Uint32 *)&GF4Out->r2=*(Uint32 *)&PPMod1F_G->r2;
		*(Uint32 *)&GF4Out->r3=*(Uint32 *)&PPMod1F_G->r3;

//#if 0	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GF4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GF4Out) & 0x00ffffff);
//#endif

		GF4Out_L1=		// get next work base addr
		++GF4Out_L2;	// get next work base addr

PGT2FFd: if (lp==PC_Mod1F_G) {PPMod1F_G=PPMod1F_G_L1; goto PGT4FFd;}
#if ForceSubDiv
//	PPMod1F_G_L1->info|=0x0100;
	PPMod1F_G_L1->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_G_L1->vt0],&VertPointer[PPMod1F_G_L1->vt1],
				&VertPointer[PPMod1F_G_L1->vt2]);


	gte_rtpt();								/* do rot trans pers */
	PPMod1F_G+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_g4(GF4Out_L1);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_G_L1->info&0x0300)==0) goto PGT3FFd;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT3FFd;
 	}

	*(Uint32 *)&GF4Out_L1->x3=*(Uint32 *)&xy3s[0];


	// x's 2d virtices off edge of screen ?
	minmax4(GF4Out_L1->x0,
			GF4Out_L1->x1,
			GF4Out_L1->x2,
			GF4Out_L1->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT3FFd;

	// y's 2d virtices off edge of screen ?
	minmax4(GF4Out_L1->y0,
			GF4Out_L1->y1,
			GF4Out_L1->y2,
			GF4Out_L1->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT3FFd;


	switch ((PPMod1F_G_L1->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[1]) minz=sz4[1];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[1]) maxz=sz4[1];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT3FFd;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_G_L1->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GF4Out_L1;

#if SeeLines
		SortLinePolyQ(GF4Out_L1->x0,GF4Out_L1->y0,
					  GF4Out_L1->x1,GF4Out_L1->y1,
					  GF4Out_L1->x2,GF4Out_L1->y2,
					  GF4Out_L1->x3,GF4Out_L1->y3,
					  0,255,0);

#endif

		SubDivG4(PPMod1F_G_L1,
						&VertPointer[PPMod1F_G_L1->vt0],
						&VertPointer[PPMod1F_G_L1->vt1],
						&VertPointer[PPMod1F_G_L1->vt2],
						&VertPointer[PPMod1F_G_L1->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);


	GF4Out_L2=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT3FFd;
		}


		*(Uint32 *)&GF4Out_L1->r0=*(Uint32 *)&PPMod1F_G_L1->r0;
		*(Uint32 *)&GF4Out_L1->r1=*(Uint32 *)&PPMod1F_G_L1->r1;
		*(Uint32 *)&GF4Out_L1->r2=*(Uint32 *)&PPMod1F_G_L1->r2;
		*(Uint32 *)&GF4Out_L1->r3=*(Uint32 *)&PPMod1F_G_L1->r3;
		*(Uint32 *)&GF4Out_L1->x3=*(Uint32 *)&xy3s[0];		// get xy3 dcache

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GF4Out_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GF4Out_L1) & 0x00ffffff);
//#endif

		GF4Out_L2++;	// get next work base addr

PGT3FFd: if (lp==PC_Mod1F_G) {PPMod1F_G=PPMod1F_G_L2; goto PGT4FFd;}
#if ForceSubDiv
//	PPMod1F_G_L2->info|=0x0100;
	PPMod1F_G_L2->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_G_L2->vt0],&VertPointer[PPMod1F_G_L2->vt1],
				&VertPointer[PPMod1F_G_L2->vt2]);

	gte_rtpt();								/* do rot trans pers */
	PPMod1F_G_L1+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */


	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_g4(GF4Out_L2);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_G_L2->info&0x0300)==0) goto PGT4FFd;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT4FFd;
 	}

	*(Uint32 *)&GF4Out_L2->x3=*(Uint32 *)&xy3s[1];


	// x's 2d virtices off edge of screen ?
	minmax4(GF4Out_L2->x0,
			GF4Out_L2->x1,
			GF4Out_L2->x2,
			GF4Out_L2->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT4FFd;

	// y's 2d virtices off edge of screen ?
	minmax4(GF4Out_L2->y0,
			GF4Out_L2->y1,
			GF4Out_L2->y2,
			GF4Out_L2->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT4FFd;


	switch ((PPMod1F_G_L2->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[2]) minz=sz4[2];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[2]) maxz=sz4[2];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT4FFd;

	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_G_L2->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GF4Out_L2;

#if SeeLines
		SortLinePolyQ(GF4Out_L2->x0,GF4Out_L2->y0,
					  GF4Out_L2->x1,GF4Out_L2->y1,
					  GF4Out_L2->x2,GF4Out_L2->y2,
					  GF4Out_L2->x3,GF4Out_L2->y3,
					  0,255,0);

#endif

		SubDivG4(PPMod1F_G_L2,
						&VertPointer[PPMod1F_G_L2->vt0],
						&VertPointer[PPMod1F_G_L2->vt1],
						&VertPointer[PPMod1F_G_L2->vt2],
						&VertPointer[PPMod1F_G_L2->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);


	GF4Out_L2=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT4FFd;
		}


		*(Uint32 *)&GF4Out_L2->r0=*(Uint32 *)&PPMod1F_G_L2->r0;
		*(Uint32 *)&GF4Out_L2->r1=*(Uint32 *)&PPMod1F_G_L2->r1;
		*(Uint32 *)&GF4Out_L2->r2=*(Uint32 *)&PPMod1F_G_L2->r2;
		*(Uint32 *)&GF4Out_L2->r3=*(Uint32 *)&PPMod1F_G_L2->r3;
		*(Uint32 *)&GF4Out_L2->x3=*(Uint32 *)&xy3s[1];		// get xy3 dcache

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GF4Out_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GF4Out_L2) & 0x00ffffff);
//#endif

		GF4Out_L2++;	// get next work base addr

PGT4FFd:

		GsOUT_PACKET_P=(PACKET *)GF4Out_L2;

	}





	// GOURAUD!		gt4
	/****************/
	/* NEW textured 4 */
	/****************/

//	PPMod1F_GT=(GT4_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1F_GT=*MemPointer++;
//	PPMod1F_GT_L1=PPMod1F_GT+1;
//	PPMod1F_GT_L2=PPMod1F_GT+2;

	PPMod1F_GT=(GT4_Packet *)PPMod1F_G;
	PC_Mod1F_GT=(*MemPointer)&0x0000ffff;
	PPMod1F_GT_L1=PPMod1F_GT+1;
	PPMod1F_GT_L2=PPMod1F_GT+2;



	for (lp=0;lp<PC_Mod1F_GT;PPMod1F_GT_L2+=3)
	{
#if ForceSubDiv
	PPMod1F_GT->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_GT->vt3],&VertPointer[PPMod1F_GT_L1->vt3],
				&VertPointer[PPMod1F_GT_L2->vt3]);



	gte_rtpt();								/* do rot trans pers */
	GT4Out=
	GT4Out_L1=
	GT4Out_L2=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr
	lp++;
//	lp+=3;


	gte_stsz3c(&sz4[0]);   // store z's of 4th vertex of each quad
	gte_stsxy3(		&GT4Out->x3,
					&xy3s[0],
					&xy3s[1]);




	gte_ldv3(	&VertPointer[PPMod1F_GT->vt0],&VertPointer[PPMod1F_GT->vt1],
				&VertPointer[PPMod1F_GT->vt2]);

	gte_rtpt();								/* do rot trans pers */


	gte_stflg(&flag);						/* store flag */
//	if (flag & 0x80000000) goto PGT2; /* */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_gt4(GT4Out);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok1;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&GT4Out->x3);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT2;
Gok1:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_GT->info&0x0300)==0) goto PGT2;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT2;

	// nclip when error has occured ? hmm is this wise ?
	// maybe we should do nclip on sub-divided faces instead ??
	// if flaged an error and subdiv on and not off front screen
	gte_nclip();			// do nclip check
	gte_stopz(&otz);
	if (otz >0) goto Gok11;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&GT4Out->x3);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT2;
Gok11:
 	}

	// new pos
//	gte_stsxy3_gt4(PPMod1F_GT);
//	gte_stsxy3_gt4(GT4Out);


	// x's 2d virtices off edge of screen ?
	minmax4(GT4Out->x0,
			GT4Out->x1,
			GT4Out->x2,
			GT4Out->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT2;

	// y's 2d virtices off edge of screen ?
	minmax4(GT4Out->y0,
			GT4Out->y1,
			GT4Out->y2,
			GT4Out->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT2;



	switch ((PPMod1F_GT->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
		min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[0]) minz=sz4[0];
	otz=minz>>2;
	break;

	default:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far	sort
		max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[0]) maxz=sz4[0];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT2;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_GT->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    //||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GT4Out;


#if SeeLines
		SortLinePolyQ(GT4Out->x0,GT4Out->y0,
					 GT4Out->x1,GT4Out->y1,
					 GT4Out->x2,GT4Out->y2,
					 GT4Out->x3,GT4Out->y3,
					 0,255,0);

#endif

	// tuesday ...tempsubdivquad need SubSubOn flag set to 1
	// and all code to subdiv subdiveded put in !

		SubDivGT4(PPMod1F_GT,
						&VertPointer[PPMod1F_GT->vt0],
						&VertPointer[PPMod1F_GT->vt1],
						&VertPointer[PPMod1F_GT->vt2],
						&VertPointer[PPMod1F_GT->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);


	GT4Out_L1=
	GT4Out_L2=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT2;
		}


		*(Uint32 *)&GT4Out->u0=*(Uint32 *)&PPMod1F_GT->u0;
		*(Uint32 *)&GT4Out->u1=*(Uint32 *)&PPMod1F_GT->u1;
		*(Uint32 *)&GT4Out->u2=*(Uint32 *)&PPMod1F_GT->u2;
		*(Uint32 *)&GT4Out->u3=*(Uint32 *)&PPMod1F_GT->u3;
		*(Uint32 *)&GT4Out->r0=*(Uint32 *)&PPMod1F_GT->r0;
		*(Uint32 *)&GT4Out->r1=*(Uint32 *)&PPMod1F_GT->r1;
		*(Uint32 *)&GT4Out->r2=*(Uint32 *)&PPMod1F_GT->r2;
		*(Uint32 *)&GT4Out->r3=*(Uint32 *)&PPMod1F_GT->r3;

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
//#endif

		GT4Out_L1=		// get next work base addr
		++GT4Out_L2;	// get next work base addr

PGT2: if (lp==PC_Mod1F_GT) {PPMod1F_GT=PPMod1F_GT_L1; goto PGT4;}
#if ForceSubDiv
	PPMod1F_GT_L1->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_GT_L1->vt0],&VertPointer[PPMod1F_GT_L1->vt1],
				&VertPointer[PPMod1F_GT_L1->vt2]);


	gte_rtpt();								/* do rot trans pers */
	PPMod1F_GT+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */
//	if (flag & 0x80000000) goto PGT3; /* */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_gt4(GT4Out_L1);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok2;
	// failed 1st nclip...check 2nd
//	gte_ldsxy0(*(long *)&GT4Out_L1->x3);
	gte_ldsxy0(*(long *)&xy3s[0]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT3;
Gok2:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_GT_L1->info&0x0300)==0) goto PGT3;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT3;


	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok22;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[0]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT3;
Gok22:


 	}

	// new pos
//	gte_stsxy3_gt4(PPMod1F_GT_L1);
//	gte_stsxy3_gt4(GT4Out_L1);
	*(Uint32 *)&GT4Out_L1->x3=*(Uint32 *)&xy3s[0];


#if 0
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok2;

	// failed 1st nclip...check 2nd

//	gte_ldsxy0(*(long *)&PPMod1F_GT_L1->x3);
//	gte_ldsxy0(*(long *)&GT4Out_L1->x3);
	gte_ldsxy0(*(long *)&xy3s[0]);	  // now from dcache

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT3;
Gok2:
#endif

	// x's 2d virtices off edge of screen ?
	minmax4(GT4Out_L1->x0,
			GT4Out_L1->x1,
			GT4Out_L1->x2,
			GT4Out_L1->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT3;

	// y's 2d virtices off edge of screen ?
	minmax4(GT4Out_L1->y0,
			GT4Out_L1->y1,
			GT4Out_L1->y2,
			GT4Out_L1->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT3;


	switch ((PPMod1F_GT_L1->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
		min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[1]) minz=sz4[1];
	otz=minz>>2;
	break;

	default:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far	sort
		max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[1]) maxz=sz4[1];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT3;



	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_GT_L1->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    //||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GT4Out_L1;

#if SeeLines
		SortLinePolyQ(GT4Out_L1->x0,GT4Out_L1->y0,
					 GT4Out_L1->x1,GT4Out_L1->y1,
					 GT4Out_L1->x2,GT4Out_L1->y2,
					 GT4Out_L1->x3,GT4Out_L1->y3,
					 0,255,0);

#endif

		SubDivGT4(PPMod1F_GT_L1,
						&VertPointer[PPMod1F_GT_L1->vt0],
						&VertPointer[PPMod1F_GT_L1->vt1],
						&VertPointer[PPMod1F_GT_L1->vt2],
						&VertPointer[PPMod1F_GT_L1->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);


	GT4Out_L2=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT3;
		}


		*(Uint32 *)&GT4Out_L1->u0=*(Uint32 *)&PPMod1F_GT_L1->u0;
		*(Uint32 *)&GT4Out_L1->u1=*(Uint32 *)&PPMod1F_GT_L1->u1;
		*(Uint32 *)&GT4Out_L1->u2=*(Uint32 *)&PPMod1F_GT_L1->u2;
		*(Uint32 *)&GT4Out_L1->u3=*(Uint32 *)&PPMod1F_GT_L1->u3;
		*(Uint32 *)&GT4Out_L1->r0=*(Uint32 *)&PPMod1F_GT_L1->r0;
		*(Uint32 *)&GT4Out_L1->r1=*(Uint32 *)&PPMod1F_GT_L1->r1;
		*(Uint32 *)&GT4Out_L1->r2=*(Uint32 *)&PPMod1F_GT_L1->r2;
		*(Uint32 *)&GT4Out_L1->r3=*(Uint32 *)&PPMod1F_GT_L1->r3;
		*(Uint32 *)&GT4Out_L1->x3=*(Uint32 *)&xy3s[0];		// get xy3 dcache

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GT4Out_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out_L1) & 0x00ffffff);
//#endif

		GT4Out_L2++;	// get next work base addr

PGT3: if (lp==PC_Mod1F_GT) {PPMod1F_GT=PPMod1F_GT_L2; goto PGT4; }
#if ForceSubDiv
	PPMod1F_GT_L2->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_GT_L2->vt0],&VertPointer[PPMod1F_GT_L2->vt1],
				&VertPointer[PPMod1F_GT_L2->vt2]);

	gte_rtpt();								/* do rot trans pers */
	PPMod1F_GT_L1+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */
//	if (flag & 0x80000000) goto PGT4; /* */


	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_gt4(GT4Out_L2);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok4;
	// failed 1st nclip...check 2nd
//	gte_ldsxy0(*(long *)&GT4Out_L1->x3);
	gte_ldsxy0(*(long *)&xy3s[1]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT4;
Gok4:
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_GT_L2->info&0x0300)==0) goto PGT4;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT4;

	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok44;
	// failed 1st nclip...check 2nd
	gte_ldsxy0(*(long *)&xy3s[1]);
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT4;
Gok44:


 	}



	// new pos
//	gte_stsxy3_gt4(PPMod1F_GT_L2);
//	gte_stsxy3_gt4(GT4Out_L2);
	*(Uint32 *)&GT4Out_L2->x3=*(Uint32 *)&xy3s[1];

#if 0
	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto Gok3;

	// failed 1st nclip...check 2nd

//	gte_ldsxy0(*(long *)&PPMod1F_GT_L2->x3);
//	gte_ldsxy0(*(long *)&GT4Out_L2->x3);
	gte_ldsxy0(*(long *)&xy3s[1]);	  // now from dcache


	gte_nclip();
	gte_stopz(&otz);
	if (otz >0) goto PGT4;

Gok3:
#endif

	// x's 2d virtices off edge of screen ?
	minmax4(GT4Out_L2->x0,
			GT4Out_L2->x1,
			GT4Out_L2->x2,
			GT4Out_L2->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT4;

	// y's 2d virtices off edge of screen ?
	minmax4(GT4Out_L2->y0,
			GT4Out_L2->y1,
			GT4Out_L2->y2,
			GT4Out_L2->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT4;


	switch ((PPMod1F_GT_L2->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// near z sort
		min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[2]) minz=sz4[2];
	otz=minz>>2;
	break;

	default:
//		gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);			// far	sort
		max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[2]) maxz=sz4[2];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT4;



	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_GT_L2->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    //||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GT4Out_L2;

#if SeeLines
		SortLinePolyQ(GT4Out_L2->x0,GT4Out_L2->y0,
					 GT4Out_L2->x1,GT4Out_L2->y1,
					 GT4Out_L2->x2,GT4Out_L2->y2,
					 GT4Out_L2->x3,GT4Out_L2->y3,
					 0,255,0);

#endif

		SubDivGT4(PPMod1F_GT_L2,
						&VertPointer[PPMod1F_GT_L2->vt0],
						&VertPointer[PPMod1F_GT_L2->vt1],
						&VertPointer[PPMod1F_GT_L2->vt2],
						&VertPointer[PPMod1F_GT_L2->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						0);


	GT4Out_L2=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT4;
		}


		*(Uint32 *)&GT4Out_L2->u0=*(Uint32 *)&PPMod1F_GT_L2->u0;
		*(Uint32 *)&GT4Out_L2->u1=*(Uint32 *)&PPMod1F_GT_L2->u1;
		*(Uint32 *)&GT4Out_L2->u2=*(Uint32 *)&PPMod1F_GT_L2->u2;
		*(Uint32 *)&GT4Out_L2->u3=*(Uint32 *)&PPMod1F_GT_L2->u3;
		*(Uint32 *)&GT4Out_L2->r0=*(Uint32 *)&PPMod1F_GT_L2->r0;
		*(Uint32 *)&GT4Out_L2->r1=*(Uint32 *)&PPMod1F_GT_L2->r1;
		*(Uint32 *)&GT4Out_L2->r2=*(Uint32 *)&PPMod1F_GT_L2->r2;
		*(Uint32 *)&GT4Out_L2->r3=*(Uint32 *)&PPMod1F_GT_L2->r3;
		*(Uint32 *)&GT4Out_L2->x3=*(Uint32 *)&xy3s[1];		// get xy3 dcache

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GT4Out_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out_L2) & 0x00ffffff);
//#endif

		GT4Out_L2++;	// get next work base addr

PGT4:

//		GsOUT_PACKET_P+=(0x34*3);
		GsOUT_PACKET_P=(PACKET *)GT4Out_L2;

	}



	// GOURAUD!		gt4
	/****************/
	/* NEW textured quad doub sided */
	/****************/

//	PPMod1F_GT=(GT4_Packet *)(u_long)(*MemPointer++);
//	PC_Mod1F_GT=*MemPointer++;
	PC_Mod1F_GT=((*MemPointer++)&0xffff0000)>>16;
	PPMod1F_GT_L1=PPMod1F_GT+1;
	PPMod1F_GT_L2=PPMod1F_GT+2;


	for (lp=0;lp<PC_Mod1F_GT;PPMod1F_GT_L2+=3)
	{
#if ForceSubDiv
//	PPMod1F_GT->info|=0x0100;
	PPMod1F_GT->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_GT->vt3],&VertPointer[PPMod1F_GT_L1->vt3],
				&VertPointer[PPMod1F_GT_L2->vt3]);



	gte_rtpt();								/* do rot trans pers */
	GT4Out=
	GT4Out_L1=
	GT4Out_L2=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr
//	lp+=3;
	lp++;


	gte_stsz3c(&sz4[0]);   // store z's of 4th vertex of each quad
	gte_stsxy3(		&GT4Out->x3,
					&xy3s[0],
					&xy3s[1]);




	gte_ldv3(	&VertPointer[PPMod1F_GT->vt0],&VertPointer[PPMod1F_GT->vt1],
				&VertPointer[PPMod1F_GT->vt2]);

	gte_rtpt();								/* do rot trans pers */


	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_gt4(GT4Out);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_GT->info&0x0300)==0) goto PGT2D;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT2D;
 	}

	// x's 2d virtices off edge of screen ?
	minmax4(GT4Out->x0,
			GT4Out->x1,
			GT4Out->x2,
			GT4Out->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT2D;

	// y's 2d virtices off edge of screen ?
	minmax4(GT4Out->y0,
			GT4Out->y1,
			GT4Out->y2,
			GT4Out->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT2D;



	switch ((PPMod1F_GT->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[0]) minz=sz4[0];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[0]) maxz=sz4[0];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT2D;



	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_GT->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    //||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GT4Out;


#if SeeLines
		SortLinePolyQ(GT4Out->x0,GT4Out->y0,
					 GT4Out->x1,GT4Out->y1,
					 GT4Out->x2,GT4Out->y2,
					 GT4Out->x3,GT4Out->y3,
					 0,255,0);

#endif


		SubDivGT4(PPMod1F_GT,
						&VertPointer[PPMod1F_GT->vt0],
						&VertPointer[PPMod1F_GT->vt1],
						&VertPointer[PPMod1F_GT->vt2],
						&VertPointer[PPMod1F_GT->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);


	GT4Out_L1=
	GT4Out_L2=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT2D;
		}


		*(Uint32 *)&GT4Out->u0=*(Uint32 *)&PPMod1F_GT->u0;
		*(Uint32 *)&GT4Out->u1=*(Uint32 *)&PPMod1F_GT->u1;
		*(Uint32 *)&GT4Out->u2=*(Uint32 *)&PPMod1F_GT->u2;
		*(Uint32 *)&GT4Out->u3=*(Uint32 *)&PPMod1F_GT->u3;
		*(Uint32 *)&GT4Out->r0=*(Uint32 *)&PPMod1F_GT->r0;
		*(Uint32 *)&GT4Out->r1=*(Uint32 *)&PPMod1F_GT->r1;
		*(Uint32 *)&GT4Out->r2=*(Uint32 *)&PPMod1F_GT->r2;
		*(Uint32 *)&GT4Out->r3=*(Uint32 *)&PPMod1F_GT->r3;

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
//#endif

		GT4Out_L1=		// get next work base addr
		++GT4Out_L2;	// get next work base addr

PGT2D: if (lp==PC_Mod1F_GT) {PPMod1F_GT=PPMod1F_GT_L1;	goto PGT4D;	}
#if ForceSubDiv
//	PPMod1F_GT_L1->info|=0x0100;
	PPMod1F_GT_L1->info=ForceSubVal;
#endif

	gte_ldv3(	&VertPointer[PPMod1F_GT_L1->vt0],&VertPointer[PPMod1F_GT_L1->vt1],
				&VertPointer[PPMod1F_GT_L1->vt2]);


	gte_rtpt();								/* do rot trans pers */
	PPMod1F_GT+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_gt4(GT4Out_L1);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_GT_L1->info&0x0300)==0) goto PGT3D;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT3D;
 	}

	*(Uint32 *)&GT4Out_L1->x3=*(Uint32 *)&xy3s[0];



	// x's 2d virtices off edge of screen ?
	minmax4(GT4Out_L1->x0,
			GT4Out_L1->x1,
			GT4Out_L1->x2,
			GT4Out_L1->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT3D;

	// y's 2d virtices off edge of screen ?
	minmax4(GT4Out_L1->y0,
			GT4Out_L1->y1,
			GT4Out_L1->y2,
			GT4Out_L1->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT3D;


	switch ((PPMod1F_GT_L1->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[1]) minz=sz4[1];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[1]) maxz=sz4[1];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT3D;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_GT_L1->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    //||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GT4Out_L1;

#if SeeLines
		SortLinePolyQ(GT4Out_L1->x0,GT4Out_L1->y0,
					 GT4Out_L1->x1,GT4Out_L1->y1,
					 GT4Out_L1->x2,GT4Out_L1->y2,
					 GT4Out_L1->x3,GT4Out_L1->y3,
					 0,255,0);

#endif

		SubDivGT4(PPMod1F_GT_L1,
						&VertPointer[PPMod1F_GT_L1->vt0],
						&VertPointer[PPMod1F_GT_L1->vt1],
						&VertPointer[PPMod1F_GT_L1->vt2],
						&VertPointer[PPMod1F_GT_L1->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);


	GT4Out_L2=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT3D;
		}


		*(Uint32 *)&GT4Out_L1->u0=*(Uint32 *)&PPMod1F_GT_L1->u0;
		*(Uint32 *)&GT4Out_L1->u1=*(Uint32 *)&PPMod1F_GT_L1->u1;
		*(Uint32 *)&GT4Out_L1->u2=*(Uint32 *)&PPMod1F_GT_L1->u2;
		*(Uint32 *)&GT4Out_L1->u3=*(Uint32 *)&PPMod1F_GT_L1->u3;
		*(Uint32 *)&GT4Out_L1->r0=*(Uint32 *)&PPMod1F_GT_L1->r0;
		*(Uint32 *)&GT4Out_L1->r1=*(Uint32 *)&PPMod1F_GT_L1->r1;
		*(Uint32 *)&GT4Out_L1->r2=*(Uint32 *)&PPMod1F_GT_L1->r2;
		*(Uint32 *)&GT4Out_L1->r3=*(Uint32 *)&PPMod1F_GT_L1->r3;
		*(Uint32 *)&GT4Out_L1->x3=*(Uint32 *)&xy3s[0];		// get xy3 dcache

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GT4Out_L1->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out_L1) & 0x00ffffff);
//#endif

		GT4Out_L2++;	// get next work base addr

PGT3D:  if (lp==PC_Mod1F_GT) {PPMod1F_GT=PPMod1F_GT_L2; goto PGT4D;}
#if ForceSubDiv
//	PPMod1F_GT_L2->info|=0x0100;
	PPMod1F_GT_L2->info=ForceSubVal;
#endif
	gte_ldv3(	&VertPointer[PPMod1F_GT_L2->vt0],&VertPointer[PPMod1F_GT_L2->vt1],
				&VertPointer[PPMod1F_GT_L2->vt2]);

	gte_rtpt();								/* do rot trans pers */
	PPMod1F_GT_L1+=3;
	lp++;

	gte_stflg(&flag);						/* store flag */

	// have to do before nclip because nclip stores over sxy0 in gte !
	gte_stsxy3_gt4(GT4Out_L2);


	// if poly ok do back clip check
	if ((flag & 0x80000000)==0)
	{
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
	}
	else
	{
	// if flaged an error and subdiv off cancel face
	if	((PPMod1F_GT_L2->info&0x0300)==0) goto PGT4D;
	// if flaged an error and subdiv on check face off front of screen
	gte_stsz3c(&sz3[0]);   // only store z's if face ok
  	if (sz3[0]<clipflag1 && sz3[1]<clipflag1 && sz3[2]<clipflag1) goto PGT4D;
 	}



	*(Uint32 *)&GT4Out_L2->x3=*(Uint32 *)&xy3s[1];

	// x's 2d virtices off edge of screen ?
	minmax4(GT4Out_L2->x0,
			GT4Out_L2->x1,
			GT4Out_L2->x2,
			GT4Out_L2->x3,minx,maxx);

	 // whole poly is off screen x ?
	if((maxx<-half_width) || (minx>half_width))	goto PGT4D;

	// y's 2d virtices off edge of screen ?
	minmax4(GT4Out_L2->y0,
			GT4Out_L2->y1,
			GT4Out_L2->y2,
			GT4Out_L2->y3,miny,maxy);

	 // whole poly is off screen y ?
	if((maxy<-half_height) || (miny>half_height)) goto PGT4D;


	switch ((PPMod1F_GT_L2->info&0x0003))
	{
	case 0:
	gte_avsz3();								// average z point sort
	gte_stotz(&otz);
	break;

	case 1:
	min3(sz3[0],sz3[1],sz3[2],minz);
	if (minz>sz4[2]) minz=sz4[2];
	otz=minz>>2;
	break;

	default:
	max3(sz3[0],sz3[1],sz3[2],maxz);
	if (maxz<sz4[2]) maxz=sz4[2];
	otz=maxz>>2;
	break;
	}

	// new smooth z dist clip
	if((otz>FarZDist))	goto PGT4D;


	// if subdiv on and any of the following are true...
	// if flag set
	// if large on x or y
	// if any point near screen plane then...  needs to be divided
	if(	((PPMod1F_GT_L2->info&0x0300))	&&
	   	( (flag & 0x80000000)
	    //||(1)
	    ||(sz3[0]<clipflag)
	    ||(sz3[1]<clipflag)
	    ||(sz3[2]<clipflag)
	    ||(maxx-minx>MAX_POLY_WIDTH)
	    ||(maxy-miny>MAX_POLY_HIGHT)
		)
	   )
		{

		GsOUT_PACKET_P=(PACKET *)GT4Out_L2;

#if SeeLines
		SortLinePolyQ(GT4Out_L2->x0,GT4Out_L2->y0,
					 GT4Out_L2->x1,GT4Out_L2->y1,
					 GT4Out_L2->x2,GT4Out_L2->y2,
					 GT4Out_L2->x3,GT4Out_L2->y3,
					 0,255,0);

#endif

		SubDivGT4(PPMod1F_GT_L2,
						&VertPointer[PPMod1F_GT_L2->vt0],
						&VertPointer[PPMod1F_GT_L2->vt1],
						&VertPointer[PPMod1F_GT_L2->vt2],
						&VertPointer[PPMod1F_GT_L2->vt3],
						((u_long *)(WOT+(otz>>OTSHIFT))),
						1);


	GT4Out_L2=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr


		/* SubDived ++; */
		goto PGT4D;
		}


		*(Uint32 *)&GT4Out_L2->u0=*(Uint32 *)&PPMod1F_GT_L2->u0;
		*(Uint32 *)&GT4Out_L2->u1=*(Uint32 *)&PPMod1F_GT_L2->u1;
		*(Uint32 *)&GT4Out_L2->u2=*(Uint32 *)&PPMod1F_GT_L2->u2;
		*(Uint32 *)&GT4Out_L2->u3=*(Uint32 *)&PPMod1F_GT_L2->u3;
		*(Uint32 *)&GT4Out_L2->r0=*(Uint32 *)&PPMod1F_GT_L2->r0;
		*(Uint32 *)&GT4Out_L2->r1=*(Uint32 *)&PPMod1F_GT_L2->r1;
		*(Uint32 *)&GT4Out_L2->r2=*(Uint32 *)&PPMod1F_GT_L2->r2;
		*(Uint32 *)&GT4Out_L2->r3=*(Uint32 *)&PPMod1F_GT_L2->r3;
		*(Uint32 *)&GT4Out_L2->x3=*(Uint32 *)&xy3s[1];		// get xy3 dcache

//#if 0 	//4-4
		tag = (u_long *) (WOT + (otz >> OTSHIFT));
		GT4Out_L2->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out_L2) & 0x00ffffff);
//#endif

		GT4Out_L2++;	// get next work base addr

PGT4D:

		GsOUT_PACKET_P=(PACKET *)GT4Out_L2;


	}


}



/* ------------------------ */


void	SortLinePoly(Sint16 x0,Sint16 y0,Sint16 x1,Sint16 y1,Sint16 x2,Sint16 y2,Uint8 r,Uint8 g,Uint8 b)
{
//Uint8	RND=rand()&0x000f;
Uint8	RND=10;


		ClipedLine.x0=x0;
		ClipedLine.y0=y0;
		ClipedLine.x1=x1;
		ClipedLine.y1=y1;
		ClipedLine.r=r;
		ClipedLine.g=g;
		ClipedLine.b=b;
      GsSortLine( &ClipedLine, ptrwot, 0 );
		Corner.x0=x0;
		Corner.y0=y0;
		Corner.x1=x0-RND;
		Corner.y1=y0-RND;
		Corner.x2=x0+RND;
		Corner.y2=y0-RND;
		Corner.r0=r;
		Corner.g0=g;
		Corner.b0=b;
      GsSortPoly( &Corner, ptrwot, 0 );


		ClipedLine.x0=x1;
		ClipedLine.y0=y1;
		ClipedLine.x1=x2;
		ClipedLine.y1=y2;
		ClipedLine.r=r;
		ClipedLine.g=g;
		ClipedLine.b=b;
      GsSortLine( &ClipedLine, ptrwot, 0 );
		Corner.x0=x1;
		Corner.y0=y1;
		Corner.x1=x1-RND;
		Corner.y1=y1-RND;
		Corner.x2=x1+RND;
		Corner.y2=y1-RND;
		Corner.r0=r;
		Corner.g0=g;
		Corner.b0=b;
      GsSortPoly( &Corner, ptrwot, 0 );

		ClipedLine.x0=x2;
		ClipedLine.y0=y2;
		ClipedLine.x1=x0;
		ClipedLine.y1=y0;
		ClipedLine.r=r;
		ClipedLine.g=g;
		ClipedLine.b=b;
      GsSortLine( &ClipedLine, ptrwot, 0 );
		Corner.x0=x2;
		Corner.y0=y2;
		Corner.x1=x2-RND;
		Corner.y1=y2-RND;
		Corner.x2=x2+RND;
		Corner.y2=y2-RND;
		Corner.r0=r;
		Corner.g0=g;
		Corner.b0=b;;
      GsSortPoly( &Corner, ptrwot, 0 );

}


void	SortLinePolyQ(Sint16 x0,Sint16 y0,Sint16 x1,Sint16 y1,Sint16 x2,Sint16 y2,Sint16 x3,Sint16 y3,Uint8 r,Uint8 g,Uint8 b)
{
//Uint8	RND=rand()&0x000f;
Uint8	RND=10;


		ClipedLine.x0=x0;
		ClipedLine.y0=y0;
		ClipedLine.x1=x1;
		ClipedLine.y1=y1;
		ClipedLine.r=r;
		ClipedLine.g=g;
		ClipedLine.b=b;
      GsSortLine( &ClipedLine, ptrwot, 0 );
		Corner.x0=x0;
		Corner.y0=y0;
		Corner.x1=x0-RND;
		Corner.y1=y0-RND;
		Corner.x2=x0+RND;
		Corner.y2=y0-RND;
		Corner.r0=r;
		Corner.g0=g;
		Corner.b0=b;
      GsSortPoly( &Corner, ptrwot, 0 );


		ClipedLine.x0=x1;
		ClipedLine.y0=y1;
		ClipedLine.x1=x3;
		ClipedLine.y1=y3;
		ClipedLine.r=r;
		ClipedLine.g=g;
		ClipedLine.b=b;
      GsSortLine( &ClipedLine, ptrwot, 0 );
		Corner.x0=x1;
		Corner.y0=y1;
		Corner.x1=x1-RND;
		Corner.y1=y1-RND;
		Corner.x2=x1+RND;
		Corner.y2=y1-RND;
		Corner.r0=r;
		Corner.g0=g;
		Corner.b0=b;
      GsSortPoly( &Corner, ptrwot, 0 );

		ClipedLine.x0=x3;
		ClipedLine.y0=y3;
		ClipedLine.x1=x2;
		ClipedLine.y1=y2;
		ClipedLine.r=r;
		ClipedLine.g=g;
		ClipedLine.b=b;
      GsSortLine( &ClipedLine, ptrwot, 0 );
		Corner.x0=x3;
		Corner.y0=y3;
		Corner.x1=x3-RND;
		Corner.y1=y3-RND;
		Corner.x2=x3+RND;
		Corner.y2=y3-RND;
		Corner.r0=r;
		Corner.g0=g;
		Corner.b0=b;;
      GsSortPoly( &Corner, ptrwot, 0 );

		ClipedLine.x0=x2;
		ClipedLine.y0=y2;
		ClipedLine.x1=x0;
		ClipedLine.y1=y0;
		ClipedLine.r=r;
		ClipedLine.g=g;
		ClipedLine.b=b;
      GsSortLine( &ClipedLine, ptrwot, 0 );
		Corner.x0=x2;
		Corner.y0=y2;
		Corner.x1=x2-RND;
		Corner.y1=y2-RND;
		Corner.x2=x2+RND;
		Corner.y2=y2-RND;
		Corner.r0=r;
		Corner.g0=g;
		Corner.b0=b;;
      GsSortPoly( &Corner, ptrwot, 0 );

}





// new model data functions!

// MemPointer	- Sd model format data in memory
// md			- model within that data
// OT			- which order table to sort faces to
// idx				- current double buffer index 0/1




/*
void	SortClipBox()
{
	ClipedLine.x0=-half_width;
	ClipedLine.y0=-half_height;
	ClipedLine.x1=half_width;
	ClipedLine.y1=-half_height;
	ClipedLine.r=
	ClipedLine.g=
	ClipedLine.b=255;
	GsSortLine(&ClipedLine, &Wot[outbuf_idx], 0 );
	ClipedLine.x0=half_width-1;
	ClipedLine.y0=-half_height;
	ClipedLine.x1=half_width-1;
	ClipedLine.y1=half_height;
	ClipedLine.r=
	ClipedLine.g=
	ClipedLine.b=255;
	GsSortLine(&ClipedLine, &Wot[outbuf_idx], 0 );
	ClipedLine.x0=half_width;
	ClipedLine.y0=half_height-1;
	ClipedLine.x1=-half_width;
	ClipedLine.y1=half_height-1;
	ClipedLine.r=
	ClipedLine.g=
	ClipedLine.b=255;
	GsSortLine(&ClipedLine, &Wot[outbuf_idx], 0 );
	ClipedLine.x0=-half_width;
	ClipedLine.y0=half_height;
	ClipedLine.x1=-half_width;
	ClipedLine.y1=-half_height;
	ClipedLine.r=
	ClipedLine.g=
	ClipedLine.b=255;
	GsSortLine(&ClipedLine, &Wot[outbuf_idx], 0 );
}
*/