// *****************************************************************************

//	SUBDIVGT4 has backclip removed..so if quad sent to be divided then we
//	are asuming that all faces (when subdivided) are showing ?? need to
//	make sure this is correct and put into all other subdiv functions

// *****************************************************************************
//	SUBDIVGT4 and G4 have this new clipflag2 
//	if ALL quad points off screen near z (clipflag1 0x01) clip off
//	if ANY points less than (clipflag 0x300) sub divide
//	if ALL points of sub divided quarter less than (clipflag2 0x01) clip off
//	if ANY pnts of sb div quarter less than (clipflag 0x300) sub div again!
//	make sure this is correct and put into all other subdiv functions

#include <sys/types.h>
#include <libetc.h>		/* for Control Pad */
#include <libgte.h>		/* LIBGS uses libgte */
#include <libgpu.h>		/* LIBGS uses libgpu */
#include <libgs.h>		/* for LIBGS */

#include <inline_c.h>

#include "sdtypes.h"
//#include "..\otlen.h"
//#include "..\header.h"
#include "subdiv.h"

// half size of screen for edge clip 
Sint32	half_width	__attribute__ ((section("cachedata"))) =256;
Sint32	half_height	__attribute__ ((section("cachedata"))) =64;




// vars

extern VERTC	DivWork[];
extern Sint32	otz2;   
extern Uint32	xy3s[];
extern Sint32	midflag;
extern Sint32	midsz;  
extern Sint32	midxy;  
extern Sint32	flag;   
extern Sint32	sz3[]; 
extern Sint32	clipflag2;
extern Sint32	clipflag1;
extern Sint32	clipflag;
extern int		SubDived;	
extern int		SubDived2;	




void	SubDivGT3(	register GT3_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
						register SVECTOR *Vertc,
						register Sint32 *tag,
						register Uint32	backclip)
{
register POLY_GT3	*GT3Out;
register POLY_GT3	*GT3Out2;
register POLY_GT3	*GT3Out3;
register POLY_GT3	*GT3Out4;
register POLY_GT3	*GT3Out5;
register POLY_GT3	*GT3Out6;
register POLY_GT3	*GT3Out7;

// reset flags to say mid points 11,12 and 7 have been made.
register Uint32		Done11=0;
register Uint32		Done12=0;
register Uint32		Done7=0;


	DivWork[3].vx=((Verta->vx+Vertb->vx)>>1);
	DivWork[3].vy=((Verta->vy+Vertb->vy)>>1);
	DivWork[3].vz=((Verta->vz+Vertb->vz)>>1);
	DivWork[3].col.r=(In->r0+In->r1)>>1;
	DivWork[3].col.g=(In->g0+In->g1)>>1;
	DivWork[3].col.b=(In->b0+In->b1)>>1;
	DivWork[3].tu=(In->u0+In->u1)>>1;
	DivWork[3].tv=(In->v0+In->v1)>>1;

	DivWork[4].vx=((Vertb->vx+Vertc->vx)>>1);
	DivWork[4].vy=((Vertb->vy+Vertc->vy)>>1);
	DivWork[4].vz=((Vertb->vz+Vertc->vz)>>1);
	DivWork[4].col.r=(In->r1+In->r2)>>1;
	DivWork[4].col.g=(In->g1+In->g2)>>1;
	DivWork[4].col.b=(In->b1+In->b2)>>1;
	DivWork[4].tu=(In->u1+In->u2)>>1;
	DivWork[4].tv=(In->v1+In->v2)>>1;

	DivWork[5].vx=((Vertc->vx+Verta->vx)>>1);
	DivWork[5].vy=((Vertc->vy+Verta->vy)>>1);
	DivWork[5].vz=((Vertc->vz+Verta->vz)>>1);
	DivWork[5].col.r=(In->r2+In->r0)>>1;
	DivWork[5].col.g=(In->g2+In->g0)>>1;
	DivWork[5].col.b=(In->b2+In->b0)>>1;
	DivWork[5].tu=(In->u2+In->u0)>>1;
	DivWork[5].tv=(In->v2+In->v0)>>1;



	// sub dived 0
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;

	gte_ldv3(Verta,&DivWork[3],&DivWork[5]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto skip1;
	}

	gte_stsxy3_gt3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip1;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag)
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )

	{
	// at end of these need to make extra polyfilla's around tri
	// sub div 0 into 4 5 6 7
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;	// now polyfilla
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=
		GT3Out5->tpage=
		GT3Out6->tpage=
		GT3Out7->tpage=In->tpage;
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=
		GT3Out5->clut=
		GT3Out6->clut=
		GT3Out7->clut=In->clut;


		// copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

	
		DivWork[6].vx=(Verta->vx+DivWork[3].vx)>>1;
		DivWork[6].vy=(Verta->vy+DivWork[3].vy)>>1;
		DivWork[6].vz=(Verta->vz+DivWork[3].vz)>>1;
		DivWork[6].col.r=(In->r0+DivWork[3].col.r)>>1;
		DivWork[6].col.g=(In->g0+DivWork[3].col.g)>>1;
		DivWork[6].col.b=(In->b0+DivWork[3].col.b)>>1;
		DivWork[6].tu=(In->u0+DivWork[3].tu)>>1;
		DivWork[6].tv=(In->v0+DivWork[3].tv)>>1;

		DivWork[7].vx=(DivWork[3].vx+DivWork[5].vx)>>1;
		DivWork[7].vy=(DivWork[3].vy+DivWork[5].vy)>>1;
		DivWork[7].vz=(DivWork[3].vz+DivWork[5].vz)>>1;
		DivWork[7].col.r=(DivWork[3].col.r+DivWork[5].col.r)>>1;
		DivWork[7].col.g=(DivWork[3].col.g+DivWork[5].col.g)>>1;
		DivWork[7].col.b=(DivWork[3].col.b+DivWork[5].col.b)>>1;
		DivWork[7].tu=(DivWork[3].tu+DivWork[5].tu)>>1;
		DivWork[7].tv=(DivWork[3].tv+DivWork[5].tv)>>1;
		Done7=1;

		DivWork[8].vx=(Verta->vx+DivWork[5].vx)>>1;
		DivWork[8].vy=(Verta->vy+DivWork[5].vy)>>1;
		DivWork[8].vz=(Verta->vz+DivWork[5].vz)>>1;
		DivWork[8].col.r=(In->r0+DivWork[5].col.r)>>1;
		DivWork[8].col.g=(In->g0+DivWork[5].col.g)>>1;
		DivWork[8].col.b=(In->b0+DivWork[5].col.b)>>1;
		DivWork[8].tu=(In->u0+DivWork[5].tu)>>1;
		DivWork[8].tv=(In->v0+DivWork[5].tv)>>1;

		gte_ldv3(&DivWork[6],&DivWork[7],&DivWork[8]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);

		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;

		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out7->r0=
		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
		*(Uint16 *)&GT3Out5->u0=
		*(Uint16 *)&GT3Out7->u0=
		*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

		*(Uint32 *)&GT3Out5->r1=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out2->r1=*(Uint32 *)&DivWork[3].col.r;
		*(Uint16 *)&GT3Out5->u1=
		*(Uint16 *)&GT3Out6->u0=
		*(Uint16 *)&GT3Out2->u1=*(Uint16 *)&DivWork[3].tu;

		*(Uint32 *)&GT3Out6->r1=
		*(Uint32 *)&GT3Out7->r2=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[5].col.r;
		*(Uint16 *)&GT3Out6->u1=
		*(Uint16 *)&GT3Out7->u2=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[5].tu;


		*(Uint32 *)&GT3Out5->r2= 
		*(Uint32 *)&GT3Out->r1= 
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[6].col.r;
		*(Uint16 *)&GT3Out5->u2= 
		*(Uint16 *)&GT3Out->u1= 
		*(Uint16 *)&GT3Out2->u0=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[6].tu;

		*(Uint32 *)&GT3Out7->r1= 
		*(Uint32 *)&GT3Out->r2= 
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[8].col.r;
		*(Uint16 *)&GT3Out7->u1= 
		*(Uint16 *)&GT3Out->u2= 
		*(Uint16 *)&GT3Out3->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[8].tu;

		*(Uint32 *)&GT3Out6->r2= 
		*(Uint32 *)&GT3Out2->r2= 
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[7].col.r;
		*(Uint16 *)&GT3Out6->u2= 
		*(Uint16 *)&GT3Out2->u2= 
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[7].tu;
#if SeeSplit
		SeeSplitTri4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif


#if SeePolyFilla	// write over correct rgbs already put in
	SeePolyFillaTri3(GT3Out5,GT3Out6,GT3Out7);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

#if 0	//2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x09000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x09000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x28*7;
#endif

		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x28*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x28*3;

	} 
	else
	{
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;
		  
	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[3].col.r;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[3].tu;
		  
	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[5].col.r;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[5].tu;
#if SeeSplit
	SeeSplitTri1(GT3Out,0);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;


	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;
	}



skip1:
	// sub dived 1
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
		  
	gte_ldv3(&DivWork[3],Vertb,&DivWork[4]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto skip2;
	}

	gte_stsxy3_gt3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip2;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 1 into 8 9 10 11
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;	// now polyfilla
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=
		GT3Out5->tpage=
		GT3Out6->tpage=
		GT3Out7->tpage=In->tpage;
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=
		GT3Out5->clut=
		GT3Out6->clut=
		GT3Out7->clut=In->clut;

		// copy sub div 1 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla
//		GT3Out2->y1=
//		GT3Out5->y1=
//		GT3Out6->y0=GT3Out->y1;

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla
//		GT3Out3->y2=
//		GT3Out6->y1=
//		GT3Out7->y2=GT3Out->y2;

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;
//		GT3Out5->y0=
//		GT3Out7->y0=GT3Out->y0;


	
		DivWork[9].vx=(Vertb->vx+DivWork[3].vx)>>1;
		DivWork[9].vy=(Vertb->vy+DivWork[3].vy)>>1;
		DivWork[9].vz=(Vertb->vz+DivWork[3].vz)>>1;
		DivWork[9].col.r=(In->r1+DivWork[3].col.r)>>1;
		DivWork[9].col.g=(In->g1+DivWork[3].col.g)>>1;
		DivWork[9].col.b=(In->b1+DivWork[3].col.b)>>1;
		DivWork[9].tu=(In->u1+DivWork[3].tu)>>1;
		DivWork[9].tv=(In->v1+DivWork[3].tv)>>1;

		DivWork[10].vx=(Vertb->vx+DivWork[4].vx)>>1;
		DivWork[10].vy=(Vertb->vy+DivWork[4].vy)>>1;
		DivWork[10].vz=(Vertb->vz+DivWork[4].vz)>>1;
		DivWork[10].col.r=(In->r1+DivWork[4].col.r)>>1;
		DivWork[10].col.g=(In->g1+DivWork[4].col.g)>>1;
		DivWork[10].col.b=(In->b1+DivWork[4].col.b)>>1;
		DivWork[10].tu=(In->u1+DivWork[4].tu)>>1;
		DivWork[10].tv=(In->v1+DivWork[4].tv)>>1;

		DivWork[11].vx=(DivWork[3].vx+DivWork[4].vx)>>1;
		DivWork[11].vy=(DivWork[3].vy+DivWork[4].vy)>>1;
		DivWork[11].vz=(DivWork[3].vz+DivWork[4].vz)>>1;
		DivWork[11].col.r=(DivWork[3].col.r+DivWork[4].col.r)>>1;
		DivWork[11].col.g=(DivWork[3].col.g+DivWork[4].col.g)>>1;
		DivWork[11].col.b=(DivWork[3].col.b+DivWork[4].col.b)>>1;
		DivWork[11].tu=(DivWork[3].tu+DivWork[4].tu)>>1;
		DivWork[11].tv=(DivWork[3].tv+DivWork[4].tv)>>1;
		Done11=1;


		gte_ldv3(&DivWork[9],&DivWork[10],&DivWork[11]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);


		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;





		*(Uint32 *)&GT3Out5->r1=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out2->r1=*(Uint32 *)&In->r1;
		*(Uint16 *)&GT3Out5->u1=
		*(Uint16 *)&GT3Out6->u0=
		*(Uint16 *)&GT3Out2->u1=*(Uint16 *)&In->u1;

		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out7->r0=
		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[3].col.r;
		*(Uint16 *)&GT3Out5->u0=
		*(Uint16 *)&GT3Out7->u0=
		*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[3].tu;

		*(Uint32 *)&GT3Out6->r1=
		*(Uint32 *)&GT3Out7->r2=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[4].col.r;
		*(Uint16 *)&GT3Out6->u1=
		*(Uint16 *)&GT3Out7->u2=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[4].tu;


		*(Uint32 *)&GT3Out5->r2= 
		*(Uint32 *)&GT3Out->r1= 
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[9].col.r;
		*(Uint16 *)&GT3Out5->u2= 
		*(Uint16 *)&GT3Out->u1= 
		*(Uint16 *)&GT3Out2->u0=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[9].tu;

		*(Uint32 *)&GT3Out7->r1= 
		*(Uint32 *)&GT3Out->r2= 
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[11].col.r;
		*(Uint16 *)&GT3Out7->u1= 
		*(Uint16 *)&GT3Out->u2= 
		*(Uint16 *)&GT3Out3->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[11].tu;

		*(Uint32 *)&GT3Out6->r2= 
		*(Uint32 *)&GT3Out2->r2= 
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[10].col.r;
		*(Uint16 *)&GT3Out6->u2= 
		*(Uint16 *)&GT3Out2->u2= 
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[10].tu;
#if SeeSplit
		SeeSplitTri4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif


#if SeePolyFilla	// write over correct rgbs already put in
	SeePolyFillaTri3(GT3Out5,GT3Out6,GT3Out7);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

#if 0	//2-2-99

		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x09000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x09000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x09000000;
//		GsOUT_PACKET_P+=(sizeof(POLY_GT3)*7);
		GsOUT_PACKET_P+=0x28*7;
#endif

		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x28*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x28*3;

	} 
	else
	{
	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r1;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u1;
		  
	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[4].col.r;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[4].tu;
		  
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[3].col.r;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[3].tu;
#if SeeSplit
	SeeSplitTri1(GT3Out,1);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;


	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;
	}





skip2:
	// subed dived 2
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;

	gte_ldv3(&DivWork[5],&DivWork[4],Vertc);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto  skip3;
	}

	gte_stsxy3_gt3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip3;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn)  )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 2 into 12 13 14 15
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=
		GT3Out5->tpage=
		GT3Out6->tpage=
		GT3Out7->tpage=In->tpage;
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=
		GT3Out5->clut=
		GT3Out6->clut=
		GT3Out7->clut=In->clut;

		// copy sub div 2 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;



		DivWork[12].vx=(DivWork[5].vx+DivWork[4].vx)>>1;
		DivWork[12].vy=(DivWork[5].vy+DivWork[4].vy)>>1;
		DivWork[12].vz=(DivWork[5].vz+DivWork[4].vz)>>1;
		DivWork[12].col.r=(DivWork[5].col.r+DivWork[4].col.r)>>1;
		DivWork[12].col.g=(DivWork[5].col.g+DivWork[4].col.g)>>1;
		DivWork[12].col.b=(DivWork[5].col.b+DivWork[4].col.b)>>1;
		DivWork[12].tu=(DivWork[5].tu+DivWork[4].tu)>>1;
		DivWork[12].tv=(DivWork[5].tv+DivWork[4].tv)>>1;
		Done12=1;
	
		DivWork[13].vx=(Vertc->vx+DivWork[4].vx)>>1;
		DivWork[13].vy=(Vertc->vy+DivWork[4].vy)>>1;
		DivWork[13].vz=(Vertc->vz+DivWork[4].vz)>>1;
		DivWork[13].col.r=(In->r2+DivWork[4].col.r)>>1;
		DivWork[13].col.g=(In->g2+DivWork[4].col.g)>>1;
		DivWork[13].col.b=(In->b2+DivWork[4].col.b)>>1;
		DivWork[13].tu=(In->u2+DivWork[4].tu)>>1;
		DivWork[13].tv=(In->v2+DivWork[4].tv)>>1;

		DivWork[14].vx=(Vertc->vx+DivWork[5].vx)>>1;
		DivWork[14].vy=(Vertc->vy+DivWork[5].vy)>>1;
		DivWork[14].vz=(Vertc->vz+DivWork[5].vz)>>1;
		DivWork[14].col.r=(In->r2+DivWork[5].col.r)>>1;
		DivWork[14].col.g=(In->g2+DivWork[5].col.g)>>1;
		DivWork[14].col.b=(In->b2+DivWork[5].col.b)>>1;
		DivWork[14].tu=(In->u2+DivWork[5].tu)>>1;
		DivWork[14].tv=(In->v2+DivWork[5].tv)>>1;


		gte_ldv3(&DivWork[12],&DivWork[13],&DivWork[14]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);


		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;



		*(Uint32 *)&GT3Out6->r1=
		*(Uint32 *)&GT3Out7->r2=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&In->r2;
		*(Uint16 *)&GT3Out6->u1=
		*(Uint16 *)&GT3Out7->u2=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&In->u2;

		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out7->r0=
		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[5].col.r;
		*(Uint16 *)&GT3Out5->u0=
		*(Uint16 *)&GT3Out7->u0=
		*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[5].tu;

		*(Uint32 *)&GT3Out5->r1=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out2->r1=*(Uint32 *)&DivWork[4].col.r;
		*(Uint16 *)&GT3Out5->u1=
		*(Uint16 *)&GT3Out6->u0=
		*(Uint16 *)&GT3Out2->u1=*(Uint16 *)&DivWork[4].tu;

		*(Uint32 *)&GT3Out5->r2= 
		*(Uint32 *)&GT3Out->r1= 
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[12].col.r;
		*(Uint16 *)&GT3Out5->u2= 
		*(Uint16 *)&GT3Out->u1= 
		*(Uint16 *)&GT3Out2->u0=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[12].tu;

		*(Uint32 *)&GT3Out7->r1= 
		*(Uint32 *)&GT3Out->r2= 
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[14].col.r;
		*(Uint16 *)&GT3Out7->u1= 
		*(Uint16 *)&GT3Out->u2= 
		*(Uint16 *)&GT3Out3->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[14].tu;

		*(Uint32 *)&GT3Out6->r2= 
		*(Uint32 *)&GT3Out2->r2= 
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[13].col.r;
		*(Uint16 *)&GT3Out6->u2= 
		*(Uint16 *)&GT3Out2->u2= 
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[13].tu;
#if SeeSplit
		SeeSplitTri4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

#if SeePolyFilla	// write over correct rgbs already put in
	SeePolyFillaTri3(GT3Out5,GT3Out6,GT3Out7);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

#if 0 //2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x09000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x09000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x09000000;
//		GsOUT_PACKET_P+=(sizeof(POLY_GT3)*7);
		GsOUT_PACKET_P+=0x28*7;
#endif

		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x28*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x28*3;

	} 
	else
	{
	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&In->r2;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&In->u2;
		  
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[5].col.r;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[5].tu;
		  
	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[4].col.r;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[4].tu;
#if SeeSplit
	SeeSplitTri1(GT3Out,2);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;
	}


skip3:
	// sub dived 3
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;

	gte_ldv3(&DivWork[3],&DivWork[4],&DivWork[5]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto  skip4;
	}

	gte_stsxy3_gt3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip4;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 3 into 16 17 18 19
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=
		GT3Out5->tpage=
		GT3Out6->tpage=
		GT3Out7->tpage=In->tpage;
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=
		GT3Out5->clut=
		GT3Out6->clut=
		GT3Out7->clut=In->clut;


		// copy sub div 2 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

		if (Done11==0)
		{
		DivWork[11].vx=(DivWork[3].vx+DivWork[4].vx)>>1;
		DivWork[11].vy=(DivWork[3].vy+DivWork[4].vy)>>1;
		DivWork[11].vz=(DivWork[3].vz+DivWork[4].vz)>>1;
		DivWork[11].col.r=(DivWork[3].col.r+DivWork[4].col.r)>>1;
		DivWork[11].col.g=(DivWork[3].col.g+DivWork[4].col.g)>>1;
		DivWork[11].col.b=(DivWork[3].col.b+DivWork[4].col.b)>>1;
		DivWork[11].tu=(DivWork[3].tu+DivWork[4].tu)>>1;
		DivWork[11].tv=(DivWork[3].tv+DivWork[4].tv)>>1;
		}
		if (Done12==0)
		{
		DivWork[12].vx=(DivWork[5].vx+DivWork[4].vx)>>1;
		DivWork[12].vy=(DivWork[5].vy+DivWork[4].vy)>>1;
		DivWork[12].vz=(DivWork[5].vz+DivWork[4].vz)>>1;
		DivWork[12].col.r=(DivWork[5].col.r+DivWork[4].col.r)>>1;
		DivWork[12].col.g=(DivWork[5].col.g+DivWork[4].col.g)>>1;
		DivWork[12].col.b=(DivWork[5].col.b+DivWork[4].col.b)>>1;
		DivWork[12].tu=(DivWork[5].tu+DivWork[4].tu)>>1;
		DivWork[12].tv=(DivWork[5].tv+DivWork[4].tv)>>1;
		}
		if (Done7==0)
		{
		DivWork[7].vx=(DivWork[3].vx+DivWork[5].vx)>>1;
		DivWork[7].vy=(DivWork[3].vy+DivWork[5].vy)>>1;
		DivWork[7].vz=(DivWork[3].vz+DivWork[5].vz)>>1;
		DivWork[7].col.r=(DivWork[3].col.r+DivWork[5].col.r)>>1;
		DivWork[7].col.g=(DivWork[3].col.g+DivWork[5].col.g)>>1;
		DivWork[7].col.b=(DivWork[3].col.b+DivWork[5].col.b)>>1;
		DivWork[7].tu=(DivWork[3].tu+DivWork[5].tu)>>1;
		DivWork[7].tv=(DivWork[3].tv+DivWork[5].tv)>>1;
		}

		// below may have been worked out already in other tris!
		// could we make improment here ?
		gte_ldv3(&DivWork[11],&DivWork[12],&DivWork[7]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);

	    *(Uint32 *)&GT3Out2->x0=
	    *(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;




		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out7->r0=
		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[3].col.r;
		*(Uint16 *)&GT3Out5->u0=
		*(Uint16 *)&GT3Out7->u0=
		*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[3].tu;

		*(Uint32 *)&GT3Out5->r1=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out2->r1=*(Uint32 *)&DivWork[4].col.r;
		*(Uint16 *)&GT3Out5->u1=
		*(Uint16 *)&GT3Out6->u0=
		*(Uint16 *)&GT3Out2->u1=*(Uint16 *)&DivWork[4].tu;

		*(Uint32 *)&GT3Out6->r1=
		*(Uint32 *)&GT3Out7->r2=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[5].col.r;
		*(Uint16 *)&GT3Out6->u1=
		*(Uint16 *)&GT3Out7->u2=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[5].tu;

		*(Uint32 *)&GT3Out5->r2= 		  
		*(Uint32 *)&GT3Out->r1= 		  
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[11].col.r;
		*(Uint16 *)&GT3Out5->u2= 		  
		*(Uint16 *)&GT3Out->u1= 
		*(Uint16 *)&GT3Out2->u0=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[11].tu;

		*(Uint32 *)&GT3Out7->r1= 	
		*(Uint32 *)&GT3Out->r2= 	
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[7].col.r;
		*(Uint16 *)&GT3Out7->u1= 	
		*(Uint16 *)&GT3Out->u2= 
		*(Uint16 *)&GT3Out3->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[7].tu;

		*(Uint32 *)&GT3Out6->r2= 	
		*(Uint32 *)&GT3Out2->r2= 	
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[12].col.r;
		*(Uint16 *)&GT3Out6->u2= 	
		*(Uint16 *)&GT3Out2->u2= 
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[12].tu;
#if SeeSplit
		SeeSplitTri4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

#if SeePolyFilla	// write over correct rgbs already put in
	SeePolyFillaTri3(GT3Out5,GT3Out6,GT3Out7);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;
#if 0 //2-2-99

		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x09000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x09000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x09000000;
//		GsOUT_PACKET_P+=(sizeof(POLY_GT3)*7);
		GsOUT_PACKET_P+=0x28*7;
#endif

		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x28*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x28*3;


	} 
	else
	{
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[3].col.r;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[3].tu;
		  
	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[4].col.r;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[4].tu;
		  
	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[5].col.r;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[5].tu;
#if SeeSplit
	SeeSplitTri1(GT3Out,3);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;
	}

skip4:



	// FILL IN POLY GAPS

	// new POLY_FILLA 1!
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Verta,&DivWork[5],Vertc);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[5].col.r;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[5].tu;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&In->r2;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&In->u2;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla1;
	gte_stsxy3_gt3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;


skipfilla1:

	// new POLY_FILLA 2!
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Verta,Vertb,&DivWork[3]);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r1;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u1;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[3].col.r;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[3].tu;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla2;
	gte_stsxy3_gt3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;


skipfilla2:

	// new POLY_FILLA 3!
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(&DivWork[4],Vertb,Vertc);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[4].col.r;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[4].tu;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r1;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u1;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&In->r2;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&In->u2;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla3;
	gte_stsxy3_gt3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;

skipfilla3:
{}


}




void	SubDivFT3(register T3_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
						register SVECTOR *Vertc,
						register Sint32 *tag,
						register Uint32 backclip)
{
register POLY_FT3	*GT3Out;
register POLY_FT3	*GT3Out2;
register POLY_FT3	*GT3Out3;
register POLY_FT3	*GT3Out4;
register POLY_FT3	*GT3Out5;
register POLY_FT3	*GT3Out6;
register POLY_FT3	*GT3Out7;

// reset flags to say mid points 11,12 and 7 have been made.
register Uint32		Done11=0;
register Uint32		Done12=0;
register Uint32		Done7=0;



	DivWork[3].vx=((Verta->vx+Vertb->vx)>>1);
	DivWork[3].vy=((Verta->vy+Vertb->vy)>>1);
	DivWork[3].vz=((Verta->vz+Vertb->vz)>>1);
	DivWork[3].tu=(In->u0+In->u1)>>1;
	DivWork[3].tv=(In->v0+In->v1)>>1;

	DivWork[4].vx=((Vertb->vx+Vertc->vx)>>1);
	DivWork[4].vy=((Vertb->vy+Vertc->vy)>>1);
	DivWork[4].vz=((Vertb->vz+Vertc->vz)>>1);
	DivWork[4].tu=(In->u1+In->u2)>>1;
	DivWork[4].tv=(In->v1+In->v2)>>1;

	DivWork[5].vx=((Vertc->vx+Verta->vx)>>1);
	DivWork[5].vy=((Vertc->vy+Verta->vy)>>1);
	DivWork[5].vz=((Vertc->vz+Verta->vz)>>1);
	DivWork[5].tu=(In->u2+In->u0)>>1;
	DivWork[5].tv=(In->v2+In->v0)>>1;



	// sub dived 0
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;

	gte_ldv3(Verta,&DivWork[3],&DivWork[5]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto skip1;
	}

	gte_stsxy3_ft3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip1;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag)
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )

	{
	// at end of these need to make extra polyfilla's around tri
	// sub div 0 into 4 5 6 7
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;	// now polyfilla
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=
		GT3Out5->tpage=
		GT3Out6->tpage=
		GT3Out7->tpage=In->tpage;
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=
		GT3Out5->clut=
		GT3Out6->clut=
		GT3Out7->clut=In->clut;
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=
		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out7->r0=*(Uint32 *)&In->r0;


		// copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

	
		DivWork[6].vx=(Verta->vx+DivWork[3].vx)>>1;
		DivWork[6].vy=(Verta->vy+DivWork[3].vy)>>1;
		DivWork[6].vz=(Verta->vz+DivWork[3].vz)>>1;
		DivWork[6].tu=(In->u0+DivWork[3].tu)>>1;
		DivWork[6].tv=(In->v0+DivWork[3].tv)>>1;

		DivWork[7].vx=(DivWork[3].vx+DivWork[5].vx)>>1;
		DivWork[7].vy=(DivWork[3].vy+DivWork[5].vy)>>1;
		DivWork[7].vz=(DivWork[3].vz+DivWork[5].vz)>>1;
		DivWork[7].tu=(DivWork[3].tu+DivWork[5].tu)>>1;
		DivWork[7].tv=(DivWork[3].tv+DivWork[5].tv)>>1;
		Done7=1;

		DivWork[8].vx=(Verta->vx+DivWork[5].vx)>>1;
		DivWork[8].vy=(Verta->vy+DivWork[5].vy)>>1;
		DivWork[8].vz=(Verta->vz+DivWork[5].vz)>>1;
		DivWork[8].tu=(In->u0+DivWork[5].tu)>>1;
		DivWork[8].tv=(In->v0+DivWork[5].tv)>>1;

		gte_ldv3(&DivWork[6],&DivWork[7],&DivWork[8]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);

		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;

#if SeeSplit
		setRGB0(GT3Out,128,0,0);
		setRGB0(GT3Out2,0,128,0);
		setRGB0(GT3Out3,0,0,128);
		setRGB0(GT3Out4,255,180,0);
#endif
		*(Uint16 *)&GT3Out5->u0=
		*(Uint16 *)&GT3Out7->u0=
		*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

		*(Uint16 *)&GT3Out5->u1=
		*(Uint16 *)&GT3Out6->u0=
		*(Uint16 *)&GT3Out2->u1=*(Uint16 *)&DivWork[3].tu;

		*(Uint16 *)&GT3Out6->u1=
		*(Uint16 *)&GT3Out7->u2=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[5].tu;


		*(Uint16 *)&GT3Out5->u2= 
		*(Uint16 *)&GT3Out->u1= 
		*(Uint16 *)&GT3Out2->u0=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[6].tu;

		*(Uint16 *)&GT3Out7->u1= 
		*(Uint16 *)&GT3Out->u2= 
		*(Uint16 *)&GT3Out3->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[8].tu;

		*(Uint16 *)&GT3Out6->u2= 
		*(Uint16 *)&GT3Out2->u2= 
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[7].tu;


#if SeePolyFilla	// write over correct rgbs already put in
//	SeePolyFillaTri3(GT3Out5,GT3Out6,GT3Out7);
		setRGB0(GT3Out5,255,0,0);
		setRGB0(GT3Out6,0,255,0);
		setRGB0(GT3Out7,0,0,255);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

#if 0
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x07000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x07000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x20*7;
#endif

		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x20*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x20*3;



	} 
	else
	{
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;
		  
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[3].tu;
		  
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[5].tu;
#if SeeSplit
	setRGB0(GT3Out,128,0,0);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;
	}



skip1:
	// sub dived 1
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
		  
	gte_ldv3(&DivWork[3],Vertb,&DivWork[4]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto skip2;
	}

	gte_stsxy3_ft3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip2;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 1 into 8 9 10 11
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;	// now polyfilla
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=
		GT3Out5->tpage=
		GT3Out6->tpage=
		GT3Out7->tpage=In->tpage;
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=
		GT3Out5->clut=
		GT3Out6->clut=
		GT3Out7->clut=In->clut;
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=
		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out7->r0=*(Uint32 *)&In->r0;

		// copy sub div 1 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

	
		DivWork[9].vx=(Vertb->vx+DivWork[3].vx)>>1;
		DivWork[9].vy=(Vertb->vy+DivWork[3].vy)>>1;
		DivWork[9].vz=(Vertb->vz+DivWork[3].vz)>>1;
		DivWork[9].tu=(In->u1+DivWork[3].tu)>>1;
		DivWork[9].tv=(In->v1+DivWork[3].tv)>>1;

		DivWork[10].vx=(Vertb->vx+DivWork[4].vx)>>1;
		DivWork[10].vy=(Vertb->vy+DivWork[4].vy)>>1;
		DivWork[10].vz=(Vertb->vz+DivWork[4].vz)>>1;
		DivWork[10].tu=(In->u1+DivWork[4].tu)>>1;
		DivWork[10].tv=(In->v1+DivWork[4].tv)>>1;

		DivWork[11].vx=(DivWork[3].vx+DivWork[4].vx)>>1;
		DivWork[11].vy=(DivWork[3].vy+DivWork[4].vy)>>1;
		DivWork[11].vz=(DivWork[3].vz+DivWork[4].vz)>>1;
		DivWork[11].tu=(DivWork[3].tu+DivWork[4].tu)>>1;
		DivWork[11].tv=(DivWork[3].tv+DivWork[4].tv)>>1;
		Done11=1;


		gte_ldv3(&DivWork[9],&DivWork[10],&DivWork[11]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);


		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;



#if SeeSplit
		setRGB0(GT3Out,128,0,0);
		setRGB0(GT3Out2,0,128,0);
		setRGB0(GT3Out3,0,0,128);
		setRGB0(GT3Out4,255,180,0);
#endif
		*(Uint16 *)&GT3Out5->u1=
		*(Uint16 *)&GT3Out6->u0=
		*(Uint16 *)&GT3Out2->u1=*(Uint16 *)&In->u1;

		*(Uint16 *)&GT3Out5->u0=
		*(Uint16 *)&GT3Out7->u0=
		*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[3].tu;

		*(Uint16 *)&GT3Out6->u1=
		*(Uint16 *)&GT3Out7->u2=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[4].tu;


		*(Uint16 *)&GT3Out5->u2= 
		*(Uint16 *)&GT3Out->u1= 
		*(Uint16 *)&GT3Out2->u0=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[9].tu;

		*(Uint16 *)&GT3Out7->u1= 
		*(Uint16 *)&GT3Out->u2= 
		*(Uint16 *)&GT3Out3->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[11].tu;

		*(Uint16 *)&GT3Out6->u2= 
		*(Uint16 *)&GT3Out2->u2= 
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[10].tu;


#if SeePolyFilla	// write over correct rgbs already put in
//	SeePolyFillaTri3(GT3Out5,GT3Out6,GT3Out7);
		setRGB0(GT3Out5,255,0,0);
		setRGB0(GT3Out6,0,255,0);
		setRGB0(GT3Out7,0,0,255);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

#if 0
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x07000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x07000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x20*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x20*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x20*3;

	} 
	else
	{
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u1;
		  
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[4].tu;
		  
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[3].tu;
#if SeeSplit
	setRGB0(GT3Out,0,128,0);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;


	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;
	}





skip2:
	// subed dived 2
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;

	gte_ldv3(&DivWork[5],&DivWork[4],Vertc);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto  skip3;
	}

	gte_stsxy3_ft3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip3;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn)  )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 2 into 12 13 14 15
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=
		GT3Out5->tpage=
		GT3Out6->tpage=
		GT3Out7->tpage=In->tpage;
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=
		GT3Out5->clut=
		GT3Out6->clut=
		GT3Out7->clut=In->clut;
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=
		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out7->r0=*(Uint32 *)&In->r0;

		// copy sub div 2 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;



		DivWork[12].vx=(DivWork[5].vx+DivWork[4].vx)>>1;
		DivWork[12].vy=(DivWork[5].vy+DivWork[4].vy)>>1;
		DivWork[12].vz=(DivWork[5].vz+DivWork[4].vz)>>1;
		DivWork[12].tu=(DivWork[5].tu+DivWork[4].tu)>>1;
		DivWork[12].tv=(DivWork[5].tv+DivWork[4].tv)>>1;
		Done12=1;
	
		DivWork[13].vx=(Vertc->vx+DivWork[4].vx)>>1;
		DivWork[13].vy=(Vertc->vy+DivWork[4].vy)>>1;
		DivWork[13].vz=(Vertc->vz+DivWork[4].vz)>>1;
		DivWork[13].tu=(In->u2+DivWork[4].tu)>>1;
		DivWork[13].tv=(In->v2+DivWork[4].tv)>>1;

		DivWork[14].vx=(Vertc->vx+DivWork[5].vx)>>1;
		DivWork[14].vy=(Vertc->vy+DivWork[5].vy)>>1;
		DivWork[14].vz=(Vertc->vz+DivWork[5].vz)>>1;
		DivWork[14].tu=(In->u2+DivWork[5].tu)>>1;
		DivWork[14].tv=(In->v2+DivWork[5].tv)>>1;


		gte_ldv3(&DivWork[12],&DivWork[13],&DivWork[14]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);


		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;


#if SeeSplit
		setRGB0(GT3Out,128,0,0);
		setRGB0(GT3Out2,0,128,0);
		setRGB0(GT3Out3,0,0,128);
		setRGB0(GT3Out4,255,180,0);
#endif

		*(Uint16 *)&GT3Out6->u1=
		*(Uint16 *)&GT3Out7->u2=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&In->u2;

		*(Uint16 *)&GT3Out5->u0=
		*(Uint16 *)&GT3Out7->u0=
		*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[5].tu;

		*(Uint16 *)&GT3Out5->u1=
		*(Uint16 *)&GT3Out6->u0=
		*(Uint16 *)&GT3Out2->u1=*(Uint16 *)&DivWork[4].tu;

		*(Uint16 *)&GT3Out5->u2= 
		*(Uint16 *)&GT3Out->u1= 
		*(Uint16 *)&GT3Out2->u0=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[12].tu;

		*(Uint16 *)&GT3Out7->u1= 
		*(Uint16 *)&GT3Out->u2= 
		*(Uint16 *)&GT3Out3->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[14].tu;

		*(Uint16 *)&GT3Out6->u2= 
		*(Uint16 *)&GT3Out2->u2= 
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[13].tu;


#if SeePolyFilla	// write over correct rgbs already put in
//	SeePolyFillaTri3(GT3Out5,GT3Out6,GT3Out7);
		setRGB0(GT3Out5,255,0,0);
		setRGB0(GT3Out6,0,255,0);
		setRGB0(GT3Out7,0,0,255);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

#if 0 	//2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x07000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x07000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x20*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x20*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x20*3;

	} 
	else
	{
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&In->u2;
		  
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[5].tu;
		  
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[4].tu;
#if SeeSplit
	setRGB0(GT3Out,0,0,128);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;
	}


skip3:
	// sub dived 3
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;

	gte_ldv3(&DivWork[3],&DivWork[4],&DivWork[5]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto  skip4;
	}

	gte_stsxy3_ft3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip4;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 3 into 16 17 18 19
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=
		GT3Out5->tpage=
		GT3Out6->tpage=
		GT3Out7->tpage=In->tpage;
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=
		GT3Out5->clut=
		GT3Out6->clut=
		GT3Out7->clut=In->clut;
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=
		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out7->r0=*(Uint32 *)&In->r0;


		// copy sub div 2 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

		if (Done11==0)
		{
		DivWork[11].vx=(DivWork[3].vx+DivWork[4].vx)>>1;
		DivWork[11].vy=(DivWork[3].vy+DivWork[4].vy)>>1;
		DivWork[11].vz=(DivWork[3].vz+DivWork[4].vz)>>1;
		DivWork[11].tu=(DivWork[3].tu+DivWork[4].tu)>>1;
		DivWork[11].tv=(DivWork[3].tv+DivWork[4].tv)>>1;
		}
		if (Done12==0)
		{
		DivWork[12].vx=(DivWork[5].vx+DivWork[4].vx)>>1;
		DivWork[12].vy=(DivWork[5].vy+DivWork[4].vy)>>1;
		DivWork[12].vz=(DivWork[5].vz+DivWork[4].vz)>>1;
		DivWork[12].tu=(DivWork[5].tu+DivWork[4].tu)>>1;
		DivWork[12].tv=(DivWork[5].tv+DivWork[4].tv)>>1;
		}
		if (Done7==0)
		{
		DivWork[7].vx=(DivWork[3].vx+DivWork[5].vx)>>1;
		DivWork[7].vy=(DivWork[3].vy+DivWork[5].vy)>>1;
		DivWork[7].vz=(DivWork[3].vz+DivWork[5].vz)>>1;
		DivWork[7].tu=(DivWork[3].tu+DivWork[5].tu)>>1;
		DivWork[7].tv=(DivWork[3].tv+DivWork[5].tv)>>1;
		}

		// below may have been worked out already in other tris!
		// could we make improment here ?
		gte_ldv3(&DivWork[11],&DivWork[12],&DivWork[7]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);

	    *(Uint32 *)&GT3Out2->x0=
	    *(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;



#if SeeSplit
		setRGB0(GT3Out,128,0,0);
		setRGB0(GT3Out2,0,128,0);
		setRGB0(GT3Out3,0,0,128);
		setRGB0(GT3Out4,255,180,0);
#endif
		*(Uint16 *)&GT3Out5->u0=
		*(Uint16 *)&GT3Out7->u0=
		*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[3].tu;

		*(Uint16 *)&GT3Out5->u1=
		*(Uint16 *)&GT3Out6->u0=
		*(Uint16 *)&GT3Out2->u1=*(Uint16 *)&DivWork[4].tu;

		*(Uint16 *)&GT3Out6->u1=
		*(Uint16 *)&GT3Out7->u2=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[5].tu;

		*(Uint16 *)&GT3Out5->u2= 		  
		*(Uint16 *)&GT3Out->u1= 
		*(Uint16 *)&GT3Out2->u0=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[11].tu;

		*(Uint16 *)&GT3Out7->u1= 	
		*(Uint16 *)&GT3Out->u2= 
		*(Uint16 *)&GT3Out3->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[7].tu;

		*(Uint16 *)&GT3Out6->u2= 	
		*(Uint16 *)&GT3Out2->u2= 
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[12].tu;


#if SeePolyFilla	// write over correct rgbs already put in
//	SeePolyFillaTri3(GT3Out5,GT3Out6,GT3Out7);
		setRGB0(GT3Out5,255,0,0);
		setRGB0(GT3Out6,0,255,0);
		setRGB0(GT3Out7,0,0,255);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

#if 0	//2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x07000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x07000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x20*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x20*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x20*3;

	} 
	else
	{
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[3].tu;
		  
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[4].tu;
		  
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[5].tu;
#if SeeSplit
	setRGB0(GT3Out,255,180,0);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;
	}

skip4:



	// FILL IN POLY GAPS

	// new POLY_FILLA 1!
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Verta,&DivWork[5],Vertc);	
	gte_rtpt();
#if SeePolyFilla
//	SeePolyFilla1(GT3Out);
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[5].tu;

	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&In->u2;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla1;
	gte_stsxy3_ft3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;


skipfilla1:

	// new POLY_FILLA 2!
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Verta,Vertb,&DivWork[3]);	
	gte_rtpt();
#if SeePolyFilla
//	SeePolyFilla1(GT3Out);
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u1;

	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[3].tu;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla2;
	gte_stsxy3_ft3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;


skipfilla2:

	// new POLY_FILLA 3!
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(&DivWork[4],Vertb,Vertc);	
	gte_rtpt();
#if SeePolyFilla
//	SeePolyFilla1(GT3Out);
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&DivWork[4].tu;

	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u1;

	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&In->u2;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla3;
	gte_stsxy3_ft3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;

skipfilla3:
{}



}



void	SubDivGT4(	register GT4_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
		   				register SVECTOR *Vertc,
						register SVECTOR *Vertd,
						register Sint32 *tag,
						register Uint32 backclip)
{
register POLY_GT3	*GT3Out;	// 3's are pollyfilla 
register POLY_GT3	*GT3Out2;
register POLY_GT3	*GT3Out3;
register POLY_GT3	*GT3Out4; 
register POLY_GT4	*GT4Out;	// 4's are faces
register POLY_GT4	*GT4Out2;
register POLY_GT4	*GT4Out3;
register POLY_GT4	*GT4Out4;			  

// reset flags to say mid points 11,12 and 7 have been made.
register Uint32		Done11=0;
//register Uint32		Done12=0;
//register Uint32		Done7=0;
register Uint32		Done10=0;
register Uint32		Done15=0;
register Uint32		Done19=0;



	DivWork[4].vx=((Verta->vx+Vertb->vx)>>1);
	DivWork[4].vy=((Verta->vy+Vertb->vy)>>1);
	DivWork[4].vz=((Verta->vz+Vertb->vz)>>1);
	DivWork[4].col.r=(In->r0+In->r1)>>1;
	DivWork[4].col.g=(In->g0+In->g1)>>1;
	DivWork[4].col.b=(In->b0+In->b1)>>1;
	DivWork[4].tu=(In->u0+In->u1)>>1;
	DivWork[4].tv=(In->v0+In->v1)>>1;

	DivWork[5].vx=((Vertb->vx+Vertd->vx)>>1);
	DivWork[5].vy=((Vertb->vy+Vertd->vy)>>1);
	DivWork[5].vz=((Vertb->vz+Vertd->vz)>>1);
	DivWork[5].col.r=(In->r1+In->r3)>>1;
	DivWork[5].col.g=(In->g1+In->g3)>>1;
	DivWork[5].col.b=(In->b1+In->b3)>>1;
	DivWork[5].tu=(In->u1+In->u3)>>1;
	DivWork[5].tv=(In->v1+In->v3)>>1;

	DivWork[6].vx=((Vertd->vx+Vertc->vx)>>1);
	DivWork[6].vy=((Vertd->vy+Vertc->vy)>>1);
	DivWork[6].vz=((Vertd->vz+Vertc->vz)>>1);
	DivWork[6].col.r=(In->r3+In->r2)>>1;
	DivWork[6].col.g=(In->g3+In->g2)>>1;
	DivWork[6].col.b=(In->b3+In->b2)>>1;
	DivWork[6].tu=(In->u3+In->u2)>>1;
	DivWork[6].tv=(In->v3+In->v2)>>1;

	DivWork[7].vx=((Vertc->vx+Verta->vx)>>1);
	DivWork[7].vy=((Vertc->vy+Verta->vy)>>1);
	DivWork[7].vz=((Vertc->vz+Verta->vz)>>1);
	DivWork[7].col.r=(In->r2+In->r0)>>1;
	DivWork[7].col.g=(In->g2+In->g0)>>1;
	DivWork[7].col.b=(In->b2+In->b0)>>1;
	DivWork[7].tu=(In->u2+In->u0)>>1;
	DivWork[7].tv=(In->v2+In->v0)>>1;


	DivWork[8].vx=((Verta->vx+Vertd->vx)>>1);
	DivWork[8].vy=((Verta->vy+Vertd->vy)>>1);
	DivWork[8].vz=((Verta->vz+Vertd->vz)>>1);
	DivWork[8].col.r=(In->r1+In->r2)>>1;			// across tri diag
	DivWork[8].col.g=(In->g1+In->g2)>>1;
	DivWork[8].col.b=(In->b1+In->b2)>>1;
	DivWork[8].tu=(In->u0+In->u3)>>1;
	DivWork[8].tv=(In->v0+In->v3)>>1;

	// rottranspers mid point into dcache
	gte_ldv3c_vertc(&DivWork[8]);	
	gte_rtps();	
	gte_stflg(&midflag);
	gte_stsz(&midsz);
	gte_stsxy2(&midxy);


	// sub dived 0
	GT4Out=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr
	GT4Out->tpage=In->tpage;
	GT4Out->clut=In->clut;

	gte_ldv3(Verta,&DivWork[4],&DivWork[7]);	
	gte_rtpt();

//	SUBDIVGT4 has backclip removed..so if quad sent to be divided then we
//	are asuming that all faces (when subdivided) are showing ?? need to
//	make sure this is correct and put into all other subdiv functions

//	if ((!backclip))
//	{
//	gte_nclip();			// only checks 1 tri part of quad
//	// may need to check both tri's in quad on quads that are across bend
//	// ie verts b and c.. so that will be sub-div quads	1+3 with 2 nclips				
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto skip1;
//	}

	gte_stsxy3_gt4(GT4Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip1;


	if ((( ((flag|midflag) & 0x80000000) // sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag)
	   ||(midsz<clipflag)
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )

	{
	// sub div 0 
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_GT3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT4Out2->tpage=
		GT4Out3->tpage=
		GT4Out4->tpage=
		GT3Out->tpage=
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=In->tpage;
		GT4Out2->clut=
		GT4Out3->clut=
		GT4Out4->clut=
		GT3Out->clut=
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=In->clut;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out4->x1=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x2;

		*(Uint32 *)&GT4Out3->x0=*(Uint32 *)&midxy;


		DivWork[9].vx=(Verta->vx+DivWork[4].vx)>>1;
		DivWork[9].vy=(Verta->vy+DivWork[4].vy)>>1;
		DivWork[9].vz=(Verta->vz+DivWork[4].vz)>>1;
		DivWork[9].col.r=(In->r0+DivWork[4].col.r)>>1;
		DivWork[9].col.g=(In->g0+DivWork[4].col.g)>>1;
		DivWork[9].col.b=(In->b0+DivWork[4].col.b)>>1;
		DivWork[9].tu=(In->u0+DivWork[4].tu)>>1;
		DivWork[9].tv=(In->v0+DivWork[4].tv)>>1;

		DivWork[10].vx=(DivWork[4].vx+DivWork[8].vx)>>1;
		DivWork[10].vy=(DivWork[4].vy+DivWork[8].vy)>>1;
		DivWork[10].vz=(DivWork[4].vz+DivWork[8].vz)>>1;
		DivWork[10].col.r=(DivWork[4].col.r+DivWork[8].col.r)>>1;
		DivWork[10].col.g=(DivWork[4].col.g+DivWork[8].col.g)>>1;
		DivWork[10].col.b=(DivWork[4].col.b+DivWork[8].col.b)>>1;
		DivWork[10].tu=(DivWork[4].tu+DivWork[8].tu)>>1;
		DivWork[10].tv=(DivWork[4].tv+DivWork[8].tv)>>1;
		Done10=1;

		DivWork[11].vx=(DivWork[7].vx+DivWork[8].vx)>>1;
		DivWork[11].vy=(DivWork[7].vy+DivWork[8].vy)>>1;
		DivWork[11].vz=(DivWork[7].vz+DivWork[8].vz)>>1;
		DivWork[11].col.r=(DivWork[7].col.r+DivWork[8].col.r)>>1;
		DivWork[11].col.g=(DivWork[7].col.g+DivWork[8].col.g)>>1;
		DivWork[11].col.b=(DivWork[7].col.b+DivWork[8].col.b)>>1;
		DivWork[11].tu=(DivWork[7].tu+DivWork[8].tu)>>1;
		DivWork[11].tv=(DivWork[7].tv+DivWork[8].tv)>>1;
		Done11=1;

		DivWork[12].vx=(Verta->vx+DivWork[7].vx)>>1;
		DivWork[12].vy=(Verta->vy+DivWork[7].vy)>>1;
		DivWork[12].vz=(Verta->vz+DivWork[7].vz)>>1;
		DivWork[12].col.r=(In->r0+DivWork[7].col.r)>>1;
		DivWork[12].col.g=(In->g0+DivWork[7].col.g)>>1;
		DivWork[12].col.b=(In->b0+DivWork[7].col.b)>>1;
		DivWork[12].tu=(In->u0+DivWork[7].tu)>>1;
		DivWork[12].tv=(In->v0+DivWork[7].tv)>>1;

		DivWork[13].vx=(DivWork[7].vx+DivWork[4].vx)>>1;
		DivWork[13].vy=(DivWork[7].vy+DivWork[4].vy)>>1;
		DivWork[13].vz=(DivWork[7].vz+DivWork[4].vz)>>1;
		DivWork[13].col.r=(DivWork[7].col.r+DivWork[4].col.r)>>1;
		DivWork[13].col.g=(DivWork[7].col.g+DivWork[4].col.g)>>1;
		DivWork[13].col.b=(DivWork[7].col.b+DivWork[4].col.b)>>1;
		DivWork[13].tu=(DivWork[7].tu+DivWork[4].tu)>>1;
		DivWork[13].tv=(DivWork[7].tv+DivWork[4].tv)>>1;

		gte_ldv3(&DivWork[9],&DivWork[13],&DivWork[12]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out->x1,&GT4Out->x3,&GT4Out->x2);
		gte_ldv01(&DivWork[10],&DivWork[11]);
		gte_rtpt();
		gte_stsxy01(&GT4Out2->x3,&GT4Out3->x1);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT4Out4->x3=*(Uint32 *)&GT4Out->x2;	
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT3Out4->x0=	
		*(Uint32 *)&GT3Out->x0=*(Uint32 *)&GT4Out->x0; 
		*(Uint32 *)&GT3Out->x1= 
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out2->x1;
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1;	

		*(Uint32 *)&GT4Out->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;
		*(Uint16 *)&GT4Out->u0=	
		*(Uint16 *)&GT3Out->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&In->u0;

		*(Uint32 *)&GT4Out->r1=
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[9].col.r;
		*(Uint16 *)&GT4Out->u1=
		*(Uint16 *)&GT4Out2->u0=
		*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[9].tu;

		*(Uint32 *)&GT4Out->r2=
		*(Uint32 *)&GT4Out4->r3=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[12].col.r;
		*(Uint16 *)&GT4Out->u2=
		*(Uint16 *)&GT4Out4->u3=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[12].tu;

		*(Uint32 *)&GT4Out->r3=
		*(Uint32 *)&GT4Out2->r2=
		*(Uint32 *)&GT4Out3->r3=
		*(Uint32 *)&GT4Out4->r2=*(Uint32 *)&DivWork[13].col.r;
		*(Uint16 *)&GT4Out->u3=
		*(Uint16 *)&GT4Out2->u2=
		*(Uint16 *)&GT4Out3->u3=
		*(Uint16 *)&GT4Out4->u2=*(Uint16 *)&DivWork[13].tu;

		*(Uint32 *)&GT4Out2->r1=
		*(Uint32 *)&GT3Out->r1=
		*(Uint32 *)&GT3Out2->r0=*(Uint32 *)&DivWork[4].col.r;
		*(Uint16 *)&GT4Out2->u1=
		*(Uint16 *)&GT3Out->u1=
		*(Uint16 *)&GT3Out2->u0=*(Uint16 *)&DivWork[4].tu;

		*(Uint32 *)&GT4Out2->r3=
		*(Uint32 *)&GT4Out3->r2=
		*(Uint32 *)&GT3Out2->r2=*(Uint32 *)&DivWork[10].col.r;
		*(Uint16 *)&GT4Out2->u3=
		*(Uint16 *)&GT4Out3->u2=
		*(Uint16 *)&GT3Out2->u2=*(Uint16 *)&DivWork[10].tu;

		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT3Out2->r1=
		*(Uint32 *)&GT3Out3->r0=*(Uint32 *)&DivWork[8].col.r;
		*(Uint16 *)&GT4Out3->u0=
		*(Uint16 *)&GT3Out2->u1=
		*(Uint16 *)&GT3Out3->u0=*(Uint16 *)&DivWork[8].tu;

		*(Uint32 *)&GT4Out3->r1=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[11].col.r;
		*(Uint16 *)&GT4Out3->u1=
		*(Uint16 *)&GT4Out4->u0=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[11].tu;

		*(Uint32 *)&GT4Out4->r1=
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[7].col.r;
		*(Uint16 *)&GT4Out4->u1=
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[7].tu;
#if SeeSplit
		SeeSplit4(GT4Out,GT4Out2,GT4Out3,GT4Out4);
#endif
		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
		SeePolyFilla4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		&0x03)|0x34;//gt3 with In->semi-trans and shade info


// 2-2-99 out
#if 0
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x0c000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x0c000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x0c000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x0c000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x34*4;	 // gt4
		GsOUT_PACKET_P+=0x28*4;	 // gt3
#endif

		// quad	*4
		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x0c000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x0c000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x0c000000;
		GsOUT_PACKET_P+=0x34*4;	 // gt4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x28*4;	 // gt3





	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT4Out->u0=*(Uint16 *)&In->u0;
	  	  
	*(Uint32 *)&GT4Out->r1=*(Uint32 *)&DivWork[4].col.r;
	*(Uint16 *)&GT4Out->u1=*(Uint16 *)&DivWork[4].tu;
	  	  
	*(Uint32 *)&GT4Out->r2=*(Uint32 *)&DivWork[7].col.r;
	*(Uint16 *)&GT4Out->u2=*(Uint16 *)&DivWork[7].tu;

	*(Uint32 *)&GT4Out->r3=*(Uint32 *)&DivWork[8].col.r;
	*(Uint16 *)&GT4Out->u3=*(Uint16 *)&DivWork[8].tu;
#if SeeSplit
	SeeSplit1(GT4Out,0);
#endif

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;
	*(Uint32 *)&GT4Out->x3=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT4);
	GsOUT_PACKET_P+=0x34;	 // gt4
	}



skip1:
	// sub dived 1
	GT4Out=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr
	GT4Out->tpage=In->tpage;
	GT4Out->clut=In->clut;
		  
	gte_ldv3(&DivWork[4],Vertb,&DivWork[5]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto skip2;
//	}

	gte_stsxy3(&GT4Out->x0,&GT4Out->x1,&GT4Out->x3);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip2;


	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 1
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_GT3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT4Out2->tpage=
		GT4Out3->tpage=
		GT4Out4->tpage=
		GT3Out->tpage=
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=In->tpage;
		GT4Out2->clut=
		GT4Out3->clut=
		GT4Out4->clut=
		GT3Out->clut=
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=In->clut;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out3->x0=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x3;

		*(Uint32 *)&GT4Out4->x1=*(Uint32 *)&midxy;


		DivWork[14].vx=(Vertb->vx+DivWork[5].vx)>>1;
		DivWork[14].vy=(Vertb->vy+DivWork[5].vy)>>1;
		DivWork[14].vz=(Vertb->vz+DivWork[5].vz)>>1;
		DivWork[14].col.r=(In->r1+DivWork[5].col.r)>>1;
		DivWork[14].col.g=(In->g1+DivWork[5].col.g)>>1;
		DivWork[14].col.b=(In->b1+DivWork[5].col.b)>>1;
		DivWork[14].tu=(In->u1+DivWork[5].tu)>>1;
		DivWork[14].tv=(In->v1+DivWork[5].tv)>>1;

		DivWork[15].vx=(DivWork[5].vx+DivWork[8].vx)>>1;
		DivWork[15].vy=(DivWork[5].vy+DivWork[8].vy)>>1;
		DivWork[15].vz=(DivWork[5].vz+DivWork[8].vz)>>1;
		DivWork[15].col.r=(DivWork[5].col.r+DivWork[8].col.r)>>1;
		DivWork[15].col.g=(DivWork[5].col.g+DivWork[8].col.g)>>1;
		DivWork[15].col.b=(DivWork[5].col.b+DivWork[8].col.b)>>1;
		DivWork[15].tu=(DivWork[5].tu+DivWork[8].tu)>>1;
		DivWork[15].tv=(DivWork[5].tv+DivWork[8].tv)>>1;
		Done15=1;

		DivWork[16].vx=(Vertb->vx+DivWork[4].vx)>>1;
		DivWork[16].vy=(Vertb->vy+DivWork[4].vy)>>1;
		DivWork[16].vz=(Vertb->vz+DivWork[4].vz)>>1;
		DivWork[16].col.r=(In->r1+DivWork[4].col.r)>>1;
		DivWork[16].col.g=(In->g1+DivWork[4].col.g)>>1;
		DivWork[16].col.b=(In->b1+DivWork[4].col.b)>>1;
		DivWork[16].tu=(In->u1+DivWork[4].tu)>>1;
		DivWork[16].tv=(In->v1+DivWork[4].tv)>>1;

		DivWork[17].vx=(Vertb->vx+DivWork[8].vx)>>1;
		DivWork[17].vy=(Vertb->vy+DivWork[8].vy)>>1;
		DivWork[17].vz=(Vertb->vz+DivWork[8].vz)>>1;
		DivWork[17].col.r=(In->r1+DivWork[8].col.r)>>1;
		DivWork[17].col.g=(In->g1+DivWork[8].col.g)>>1;
		DivWork[17].col.b=(In->b1+DivWork[8].col.b)>>1;
		DivWork[17].tu=(In->u1+DivWork[8].tu)>>1;
		DivWork[17].tv=(In->v1+DivWork[8].tv)>>1;

		if (Done10==0)
		{
		DivWork[10].vx=(DivWork[4].vx+DivWork[8].vx)>>1;
		DivWork[10].vy=(DivWork[4].vy+DivWork[8].vy)>>1;
		DivWork[10].vz=(DivWork[4].vz+DivWork[8].vz)>>1;
		DivWork[10].col.r=(DivWork[4].col.r+DivWork[8].col.r)>>1;
		DivWork[10].col.g=(DivWork[4].col.g+DivWork[8].col.g)>>1;
		DivWork[10].col.b=(DivWork[4].col.b+DivWork[8].col.b)>>1;
		DivWork[10].tu=(DivWork[4].tu+DivWork[8].tu)>>1;
		DivWork[10].tv=(DivWork[4].tv+DivWork[8].tv)>>1;
		Done10=1;
		}

		gte_ldv3(&DivWork[14],&DivWork[17],&DivWork[16]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out2->x3,&GT4Out->x3,&GT4Out->x1);
		// 10 below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[15],&DivWork[10]);
		gte_rtpt();
		gte_stsxy01(&GT4Out3->x1,&GT4Out->x2);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT4Out4->x3=*(Uint32 *)&GT4Out->x2;	
		*(Uint32 *)&GT3Out4->x0=	
		*(Uint32 *)&GT3Out->x0=*(Uint32 *)&GT4Out->x0; 
		*(Uint32 *)&GT3Out->x1= 
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out2->x1;
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1;	


		*(Uint32 *)&GT4Out->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[4].col.r;
		*(Uint16 *)&GT4Out->u0=
		*(Uint16 *)&GT3Out->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[4].tu;

		*(Uint32 *)&GT4Out->r1=
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[16].col.r;
		*(Uint16 *)&GT4Out->u1=
		*(Uint16 *)&GT4Out2->u0=
		*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[16].tu;

		*(Uint32 *)&GT4Out->r2=
		*(Uint32 *)&GT4Out4->r3=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[10].col.r;
		*(Uint16 *)&GT4Out->u2=
		*(Uint16 *)&GT4Out4->u3=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[10].tu;

		*(Uint32 *)&GT4Out->r3=
		*(Uint32 *)&GT4Out2->r2=
		*(Uint32 *)&GT4Out3->r3=
		*(Uint32 *)&GT4Out4->r2=*(Uint32 *)&DivWork[17].col.r;
		*(Uint16 *)&GT4Out->u3=
		*(Uint16 *)&GT4Out2->u2=
		*(Uint16 *)&GT4Out3->u3=
		*(Uint16 *)&GT4Out4->u2=*(Uint16 *)&DivWork[17].tu;

		*(Uint32 *)&GT4Out2->r1=
		*(Uint32 *)&GT3Out->r1=
		*(Uint32 *)&GT3Out2->r0=*(Uint32 *)&In->r1;
		*(Uint16 *)&GT4Out2->u1=
		*(Uint16 *)&GT3Out->u1=
		*(Uint16 *)&GT3Out2->u0=*(Uint16 *)&In->u1;

		*(Uint32 *)&GT4Out2->r3=
		*(Uint32 *)&GT4Out3->r2=
		*(Uint32 *)&GT3Out2->r2=*(Uint32 *)&DivWork[14].col.r;
		*(Uint16 *)&GT4Out2->u3=
		*(Uint16 *)&GT4Out3->u2=
		*(Uint16 *)&GT3Out2->u2=*(Uint16 *)&DivWork[14].tu;

		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT3Out2->r1=
		*(Uint32 *)&GT3Out3->r0=*(Uint32 *)&DivWork[5].col.r;
		*(Uint16 *)&GT4Out3->u0=
		*(Uint16 *)&GT3Out2->u1=
		*(Uint16 *)&GT3Out3->u0=*(Uint16 *)&DivWork[5].tu;

		*(Uint32 *)&GT4Out3->r1=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[15].col.r;
		*(Uint16 *)&GT4Out3->u1=
		*(Uint16 *)&GT4Out4->u0=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[15].tu;

		*(Uint32 *)&GT4Out4->r1=
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[8].col.r;
		*(Uint16 *)&GT4Out4->u1=
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[8].tu;
#if SeeSplit
		SeeSplit4(GT4Out,GT4Out2,GT4Out3,GT4Out4);
#endif
		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
		SeePolyFilla4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		 & 0x03)|0x34;//gt3 with In->semi-trans and shade info

// 2-2-99 out
#if 0
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x0c000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x0c000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x0c000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x0c000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
//		GsOUT_PACKET_P+=(sizeof(POLY_GT4)*4);
//		GsOUT_PACKET_P+=(sizeof(POLY_GT3)*4);
		GsOUT_PACKET_P+=0x34*4;	 // gt4
		GsOUT_PACKET_P+=0x28*4;	 // gt3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x0c000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x0c000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x0c000000;
		GsOUT_PACKET_P+=0x34*4;	 // gt4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x28*4;	 // gt3





	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&DivWork[4].col.r;
	*(Uint16 *)&GT4Out->u0=*(Uint16 *)&DivWork[4].tu;
		  
	*(Uint32 *)&GT4Out->r1=*(Uint32 *)&In->r1;
	*(Uint16 *)&GT4Out->u1=*(Uint16 *)&In->u1;
		  
	*(Uint32 *)&GT4Out->r2=*(Uint32 *)&DivWork[8].col.r;
	*(Uint16 *)&GT4Out->u2=*(Uint16 *)&DivWork[8].tu;

	*(Uint32 *)&GT4Out->r3=*(Uint32 *)&DivWork[5].col.r;
	*(Uint16 *)&GT4Out->u3=*(Uint16 *)&DivWork[5].tu;
#if SeeSplit
	SeeSplit1(GT4Out,1);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;
	*(Uint32 *)&GT4Out->x2=*(Uint32 *)&midxy;


	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT4);
	GsOUT_PACKET_P+=0x34;	 // gt4
	}



skip2:
	// subed dived 2
	GT4Out=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr
	GT4Out->tpage=In->tpage;
	GT4Out->clut=In->clut;

	gte_ldv3(Vertd,&DivWork[6],&DivWork[5]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto  skip3;
//	}

	gte_stsxy3_gt4(GT4Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip3;

	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn)  )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 2
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_GT3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT4Out2->tpage=
		GT4Out3->tpage=
		GT4Out4->tpage=
		GT3Out->tpage=
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=In->tpage;
		GT4Out2->clut=
		GT4Out3->clut=
		GT4Out4->clut=
		GT3Out->clut=
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=In->clut;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out4->x1=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x2;

		*(Uint32 *)&GT4Out3->x0=*(Uint32 *)&midxy;


		DivWork[18].vx=(Vertd->vx+DivWork[6].vx)>>1;
		DivWork[18].vy=(Vertd->vy+DivWork[6].vy)>>1;
		DivWork[18].vz=(Vertd->vz+DivWork[6].vz)>>1;
		DivWork[18].col.r=(In->r3+DivWork[6].col.r)>>1;
		DivWork[18].col.g=(In->g3+DivWork[6].col.g)>>1;
		DivWork[18].col.b=(In->b3+DivWork[6].col.b)>>1;
		DivWork[18].tu=(In->u3+DivWork[6].tu)>>1;
		DivWork[18].tv=(In->v3+DivWork[6].tv)>>1;

		DivWork[19].vx=(DivWork[6].vx+DivWork[8].vx)>>1;
		DivWork[19].vy=(DivWork[6].vy+DivWork[8].vy)>>1;
		DivWork[19].vz=(DivWork[6].vz+DivWork[8].vz)>>1;
		DivWork[19].col.r=(DivWork[6].col.r+DivWork[8].col.r)>>1;
		DivWork[19].col.g=(DivWork[6].col.g+DivWork[8].col.g)>>1;
		DivWork[19].col.b=(DivWork[6].col.b+DivWork[8].col.b)>>1;
		DivWork[19].tu=(DivWork[6].tu+DivWork[8].tu)>>1;
		DivWork[19].tv=(DivWork[6].tv+DivWork[8].tv)>>1;
		Done19=1;

		DivWork[20].vx=(Vertd->vx+DivWork[5].vx)>>1;
		DivWork[20].vy=(Vertd->vy+DivWork[5].vy)>>1;
		DivWork[20].vz=(Vertd->vz+DivWork[5].vz)>>1;
		DivWork[20].col.r=(In->r3+DivWork[5].col.r)>>1;
		DivWork[20].col.g=(In->g3+DivWork[5].col.g)>>1;
		DivWork[20].col.b=(In->b3+DivWork[5].col.b)>>1;
		DivWork[20].tu=(In->u3+DivWork[5].tu)>>1;
		DivWork[20].tv=(In->v3+DivWork[5].tv)>>1;

		DivWork[21].vx=(DivWork[5].vx+DivWork[6].vx)>>1;
		DivWork[21].vy=(DivWork[5].vy+DivWork[6].vy)>>1;
		DivWork[21].vz=(DivWork[5].vz+DivWork[6].vz)>>1;
		DivWork[21].col.r=(DivWork[5].col.r+DivWork[6].col.r)>>1;
		DivWork[21].col.g=(DivWork[5].col.g+DivWork[6].col.g)>>1;
		DivWork[21].col.b=(DivWork[5].col.b+DivWork[6].col.b)>>1;
		DivWork[21].tu=(DivWork[5].tu+DivWork[6].tu)>>1;
		DivWork[21].tv=(DivWork[5].tv+DivWork[6].tv)>>1;

		if (Done15==0)
		{
		DivWork[15].vx=(DivWork[5].vx+DivWork[8].vx)>>1;
		DivWork[15].vy=(DivWork[5].vy+DivWork[8].vy)>>1;
		DivWork[15].vz=(DivWork[5].vz+DivWork[8].vz)>>1;
		DivWork[15].col.r=(DivWork[5].col.r+DivWork[8].col.r)>>1;
		DivWork[15].col.g=(DivWork[5].col.g+DivWork[8].col.g)>>1;
		DivWork[15].col.b=(DivWork[5].col.b+DivWork[8].col.b)>>1;
		DivWork[15].tu=(DivWork[5].tu+DivWork[8].tu)>>1;
		DivWork[15].tv=(DivWork[5].tv+DivWork[8].tv)>>1;
		Done15=1;
		}

		gte_ldv3(&DivWork[18],&DivWork[21],&DivWork[20]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out->x1,&GT4Out->x3,&GT4Out->x2);
		// 15 below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[19],&DivWork[15]);
		gte_rtpt();
		gte_stsxy01(&GT4Out2->x3,&GT4Out3->x1);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT4Out4->x3=
		*(Uint32 *)&GT3Out4->x1=*(Uint32 *)&GT4Out->x2;	

		*(Uint32 *)&GT4Out->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r3;
		*(Uint16 *)&GT4Out->u0=
		*(Uint16 *)&GT3Out->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&In->u3;

		*(Uint32 *)&GT4Out->r1=
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[18].col.r;
		*(Uint16 *)&GT4Out->u1=
		*(Uint16 *)&GT4Out2->u0=
		*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[18].tu;

		*(Uint32 *)&GT4Out->r2=
		*(Uint32 *)&GT4Out4->r3=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[20].col.r;
		*(Uint16 *)&GT4Out->u2=
		*(Uint16 *)&GT4Out4->u3=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[20].tu;

		*(Uint32 *)&GT4Out->r3=
		*(Uint32 *)&GT4Out2->r2=
		*(Uint32 *)&GT4Out3->r3=
		*(Uint32 *)&GT4Out4->r2=*(Uint32 *)&DivWork[21].col.r;
		*(Uint16 *)&GT4Out->u3=
		*(Uint16 *)&GT4Out2->u2=
		*(Uint16 *)&GT4Out3->u3=
		*(Uint16 *)&GT4Out4->u2=*(Uint16 *)&DivWork[21].tu;

		*(Uint32 *)&GT4Out2->r1=
		*(Uint32 *)&GT3Out->r1=
		*(Uint32 *)&GT3Out2->r0=*(Uint32 *)&DivWork[6].col.r;
		*(Uint16 *)&GT4Out2->u1=
		*(Uint16 *)&GT3Out->u1=
		*(Uint16 *)&GT3Out2->u0=*(Uint16 *)&DivWork[6].tu;

		*(Uint32 *)&GT4Out2->r3=
		*(Uint32 *)&GT4Out3->r2=
		*(Uint32 *)&GT3Out2->r2=*(Uint32 *)&DivWork[19].col.r;
		*(Uint16 *)&GT4Out2->u3=
		*(Uint16 *)&GT4Out3->u2=
		*(Uint16 *)&GT3Out2->u2=*(Uint16 *)&DivWork[19].tu;

		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT3Out2->r1=
		*(Uint32 *)&GT3Out3->r0=*(Uint32 *)&DivWork[8].col.r;
		*(Uint16 *)&GT4Out3->u0=
		*(Uint16 *)&GT3Out2->u1=
		*(Uint16 *)&GT3Out3->u0=*(Uint16 *)&DivWork[8].tu;

		*(Uint32 *)&GT4Out3->r1=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[15].col.r;
		*(Uint16 *)&GT4Out3->u1=
		*(Uint16 *)&GT4Out4->u0=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[15].tu;

		*(Uint32 *)&GT4Out4->r1=
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[5].col.r;
		*(Uint16 *)&GT4Out4->u1=
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[5].tu;
#if SeeSplit
		SeeSplit4(GT4Out,GT4Out2,GT4Out3,GT4Out4);
#endif

		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
		SeePolyFilla4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;

		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		 & 0x03)|0x34;//gt3 with In->semi-trans and shade info

// 2-2-99 out
#if 0
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x0c000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x0c000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x0c000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x0c000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
//		GsOUT_PACKET_P+=(sizeof(POLY_GT4)*4);
//		GsOUT_PACKET_P+=(sizeof(POLY_GT3)*4);
		GsOUT_PACKET_P+=0x34*4;	 // gt4
		GsOUT_PACKET_P+=0x28*4;	 // gt3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x0c000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x0c000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x0c000000;
		GsOUT_PACKET_P+=0x34*4;	 // gt4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x28*4;	 // gt3

	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r3;
	*(Uint16 *)&GT4Out->u0=*(Uint16 *)&In->u3;
		  
	*(Uint32 *)&GT4Out->r1=*(Uint32 *)&DivWork[6].col.r;
	*(Uint16 *)&GT4Out->u1=*(Uint16 *)&DivWork[6].tu;
			  
	*(Uint32 *)&GT4Out->r2=*(Uint32 *)&DivWork[5].col.r;
	*(Uint16 *)&GT4Out->u2=*(Uint16 *)&DivWork[5].tu;
	
	*(Uint32 *)&GT4Out->r3=*(Uint32 *)&DivWork[8].col.r;
	*(Uint16 *)&GT4Out->u3=*(Uint16 *)&DivWork[8].tu;
#if SeeSplit
	SeeSplit1(GT4Out,2);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;
	*(Uint32 *)&GT4Out->x3=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT4);
	GsOUT_PACKET_P+=0x34;	 // gt4
	}


skip3:
	// sub dived 3
	GT4Out=(POLY_GT4 *)GsOUT_PACKET_P;	// get work base addr
	GT4Out->tpage=In->tpage;
	GT4Out->clut=In->clut;

	gte_ldv3(&DivWork[6],Vertc,&DivWork[7]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto  skip4;
//	}

	gte_stsxy3(&GT4Out->x0,&GT4Out->x1,&GT4Out->x3);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip4;


	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 3
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_GT3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT4Out2->tpage=
		GT4Out3->tpage=
		GT4Out4->tpage=
		GT3Out->tpage=
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=In->tpage;
		GT4Out2->clut=
		GT4Out3->clut=
		GT4Out4->clut=
		GT3Out->clut=
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=In->clut;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out3->x0=
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out->x3;

		*(Uint32 *)&GT4Out4->x1=*(Uint32 *)&midxy;


		DivWork[22].vx=(Vertc->vx+DivWork[7].vx)>>1;
		DivWork[22].vy=(Vertc->vy+DivWork[7].vy)>>1;
		DivWork[22].vz=(Vertc->vz+DivWork[7].vz)>>1;
		DivWork[22].col.r=(In->r2+DivWork[7].col.r)>>1;
		DivWork[22].col.g=(In->g2+DivWork[7].col.g)>>1;
		DivWork[22].col.b=(In->b2+DivWork[7].col.b)>>1;
		DivWork[22].tu=(In->u2+DivWork[7].tu)>>1;
		DivWork[22].tv=(In->v2+DivWork[7].tv)>>1;

		if (Done11==0)
		{
		DivWork[11].vx=(DivWork[7].vx+DivWork[8].vx)>>1;
		DivWork[11].vy=(DivWork[7].vy+DivWork[8].vy)>>1;
		DivWork[11].vz=(DivWork[7].vz+DivWork[8].vz)>>1;
		DivWork[11].col.r=(DivWork[7].col.r+DivWork[8].col.r)>>1;
		DivWork[11].col.g=(DivWork[7].col.g+DivWork[8].col.g)>>1;
		DivWork[11].col.b=(DivWork[7].col.b+DivWork[8].col.b)>>1;
		DivWork[11].tu=(DivWork[7].tu+DivWork[8].tu)>>1;
		DivWork[11].tv=(DivWork[7].tv+DivWork[8].tv)>>1;
		Done11=1;
		}

		if (Done19==0)
		{
		DivWork[19].vx=(DivWork[6].vx+DivWork[8].vx)>>1;
		DivWork[19].vy=(DivWork[6].vy+DivWork[8].vy)>>1;
		DivWork[19].vz=(DivWork[6].vz+DivWork[8].vz)>>1;
		DivWork[19].col.r=(DivWork[6].col.r+DivWork[8].col.r)>>1;
		DivWork[19].col.g=(DivWork[6].col.g+DivWork[8].col.g)>>1;
		DivWork[19].col.b=(DivWork[6].col.b+DivWork[8].col.b)>>1;
		DivWork[19].tu=(DivWork[6].tu+DivWork[8].tu)>>1;
		DivWork[19].tv=(DivWork[6].tv+DivWork[8].tv)>>1;
		Done19=1;
		}

		DivWork[23].vx=(Vertc->vx+DivWork[6].vx)>>1;
		DivWork[23].vy=(Vertc->vy+DivWork[6].vy)>>1;
		DivWork[23].vz=(Vertc->vz+DivWork[6].vz)>>1;
		DivWork[23].col.r=(In->r2+DivWork[6].col.r)>>1;
		DivWork[23].col.g=(In->g2+DivWork[6].col.g)>>1;
		DivWork[23].col.b=(In->b2+DivWork[6].col.b)>>1;
		DivWork[23].tu=(In->u2+DivWork[6].tu)>>1;
		DivWork[23].tv=(In->v2+DivWork[6].tv)>>1;

		DivWork[24].vx=(Vertc->vx+DivWork[8].vx)>>1;
		DivWork[24].vy=(Vertc->vy+DivWork[8].vy)>>1;
		DivWork[24].vz=(Vertc->vz+DivWork[8].vz)>>1;
		DivWork[24].col.r=(In->r2+DivWork[8].col.r)>>1;
		DivWork[24].col.g=(In->g2+DivWork[8].col.g)>>1;
		DivWork[24].col.b=(In->b2+DivWork[8].col.b)>>1;
		DivWork[24].tu=(In->u2+DivWork[8].tu)>>1;
		DivWork[24].tv=(In->v2+DivWork[8].tv)>>1;


		gte_ldv3(&DivWork[22],&DivWork[24],&DivWork[23]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out2->x3,&GT4Out->x3,&GT4Out->x1);
		// 11 and 19  below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[11],&DivWork[19]);
		gte_rtpt();
		gte_stsxy01(&GT4Out3->x1,&GT4Out->x2);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out4->x3=
		*(Uint32 *)&GT3Out4->x1=*(Uint32 *)&GT4Out->x2;
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1; 

		*(Uint32 *)&GT4Out->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[6].col.r;
		*(Uint16 *)&GT4Out->u0=
		*(Uint16 *)&GT3Out->u0=	
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[6].tu;

		*(Uint32 *)&GT4Out->r1=
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[23].col.r;
		*(Uint16 *)&GT4Out->u1=
		*(Uint16 *)&GT4Out2->u0=
		*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[23].tu;

		*(Uint32 *)&GT4Out->r2=
		*(Uint32 *)&GT4Out4->r3=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[19].col.r;
		*(Uint16 *)&GT4Out->u2=
		*(Uint16 *)&GT4Out4->u3=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[19].tu;

		*(Uint32 *)&GT4Out->r3=
		*(Uint32 *)&GT4Out2->r2=
		*(Uint32 *)&GT4Out3->r3=
		*(Uint32 *)&GT4Out4->r2=*(Uint32 *)&DivWork[24].col.r;
		*(Uint16 *)&GT4Out->u3=
		*(Uint16 *)&GT4Out2->u2=
		*(Uint16 *)&GT4Out3->u3=
		*(Uint16 *)&GT4Out4->u2=*(Uint16 *)&DivWork[24].tu;

		*(Uint32 *)&GT4Out2->r1=
		*(Uint32 *)&GT3Out->r1=
		*(Uint32 *)&GT3Out2->r0=*(Uint32 *)&In->r2;
		*(Uint16 *)&GT4Out2->u1=
		*(Uint16 *)&GT3Out->u1=
		*(Uint16 *)&GT3Out2->u0=*(Uint16 *)&In->u2;

		*(Uint32 *)&GT4Out2->r3=
		*(Uint32 *)&GT4Out3->r2=
		*(Uint32 *)&GT3Out2->r2=*(Uint32 *)&DivWork[22].col.r;
		*(Uint16 *)&GT4Out2->u3=
		*(Uint16 *)&GT4Out3->u2=
		*(Uint16 *)&GT3Out2->u2=*(Uint16 *)&DivWork[22].tu;

		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT3Out2->r1=
		*(Uint32 *)&GT3Out3->r0=*(Uint32 *)&DivWork[7].col.r;
		*(Uint16 *)&GT4Out3->u0=
		*(Uint16 *)&GT3Out2->u1=
		*(Uint16 *)&GT3Out3->u0=*(Uint16 *)&DivWork[7].tu;

		*(Uint32 *)&GT4Out3->r1=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[11].col.r;
		*(Uint16 *)&GT4Out3->u1=
		*(Uint16 *)&GT4Out4->u0=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[11].tu;

		*(Uint32 *)&GT4Out4->r1=
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[8].col.r;
		*(Uint16 *)&GT4Out4->u1=
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[8].tu;
#if SeeSplit
		SeeSplit4(GT4Out,GT4Out2,GT4Out3,GT4Out4);
#endif

		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
		SeePolyFilla4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		 & 0x03)|0x34;//gt3 with In->semi-trans and shade info

// 2-2-99 out
#if 0
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x0c000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x0c000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x0c000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x0c000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x09000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x09000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x09000000;
//		GsOUT_PACKET_P+=(sizeof(POLY_GT4)*4);
//		GsOUT_PACKET_P+=(sizeof(POLY_GT3)*4);
		GsOUT_PACKET_P+=0x34*4;	 // gt4
		GsOUT_PACKET_P+=0x28*4;	 // gt3
#endif
		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x0c000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x0c000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x0c000000;
		GsOUT_PACKET_P+=0x34*4;	 // gt4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x28*4;	 // gt3

	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&DivWork[6].col.r;
	*(Uint16 *)&GT4Out->u0=*(Uint16 *)&DivWork[6].tu;
		  
	*(Uint32 *)&GT4Out->r1=*(Uint32 *)&In->r2;
	*(Uint16 *)&GT4Out->u1=*(Uint16 *)&In->u2;
		  
	*(Uint32 *)&GT4Out->r2=*(Uint32 *)&DivWork[8].col.r;
	*(Uint16 *)&GT4Out->u2=*(Uint16 *)&DivWork[8].tu;

	*(Uint32 *)&GT4Out->r3=*(Uint32 *)&DivWork[7].col.r;
	*(Uint16 *)&GT4Out->u3=*(Uint16 *)&DivWork[7].tu;
#if SeeSplit
	SeeSplit1(GT4Out,3);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;
	*(Uint32 *)&GT4Out->x2=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x0c000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT4);
	GsOUT_PACKET_P+=0x34;	 // gt4
	}

skip4:




	// FILL IN POLY GAPS

	// new POLY_FILLA 1!
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Verta,Vertb,&DivWork[4]);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r1;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u1;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[4].col.r;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[4].tu;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla1;
	gte_stsxy3_gt3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x34;//gt3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;	 // gt3


skipfilla1:

	// new POLY_FILLA 2!
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Vertb,Vertd,&DivWork[5]);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r1;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u1;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r3;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u3;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[5].col.r;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[5].tu;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla2;
	gte_stsxy3_gt3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x34;//gt3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;	 // gt3


skipfilla2:

	// new POLY_FILLA 3!
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Vertd,Vertc,&DivWork[6]);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r3;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u3;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r2;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u2;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[6].col.r;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[6].tu;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla3;
	gte_stsxy3_gt3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x34;//gt3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;	 // gt3

skipfilla3:

	// new POLY_FILLA 4!
	GT3Out=(POLY_GT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Verta,&DivWork[7],Vertc);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[7].col.r;
	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[7].tu;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&In->r2;
	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&In->u2;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla4;
	gte_stsxy3_gt3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x34;//gt3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
//	GsOUT_PACKET_P+=sizeof(POLY_GT3);
	GsOUT_PACKET_P+=0x28;	 // gt3

skipfilla4:
{}

}



void	SubDivFT4(register T4_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
		   				register SVECTOR *Vertc,
						register SVECTOR *Vertd,
						register Sint32 *tag,
						register Uint32 backclip)
{
register POLY_FT3	*GT3Out;	// 3's are pollyfilla 
register POLY_FT3	*GT3Out2;
register POLY_FT3	*GT3Out3;
register POLY_FT3	*GT3Out4; 
register POLY_FT4	*GT4Out;	// 4's are faces
register POLY_FT4	*GT4Out2;
register POLY_FT4	*GT4Out3;
register POLY_FT4	*GT4Out4;			  

// reset flags to say mid points 11,12 and 7 have been made.
register Uint32		Done11=0;
//register Uint32		Done12=0;
//register Uint32		Done7=0;
register Uint32		Done10=0;
register Uint32		Done15=0;
register Uint32		Done19=0;


	DivWork[4].vx=((Verta->vx+Vertb->vx)>>1);
	DivWork[4].vy=((Verta->vy+Vertb->vy)>>1);
	DivWork[4].vz=((Verta->vz+Vertb->vz)>>1);
	DivWork[4].tu=(In->u0+In->u1)>>1;
	DivWork[4].tv=(In->v0+In->v1)>>1;

	DivWork[5].vx=((Vertb->vx+Vertd->vx)>>1);
	DivWork[5].vy=((Vertb->vy+Vertd->vy)>>1);
	DivWork[5].vz=((Vertb->vz+Vertd->vz)>>1);
	DivWork[5].tu=(In->u1+In->u3)>>1;
	DivWork[5].tv=(In->v1+In->v3)>>1;

	DivWork[6].vx=((Vertd->vx+Vertc->vx)>>1);
	DivWork[6].vy=((Vertd->vy+Vertc->vy)>>1);
	DivWork[6].vz=((Vertd->vz+Vertc->vz)>>1);
	DivWork[6].tu=(In->u3+In->u2)>>1;
	DivWork[6].tv=(In->v3+In->v2)>>1;

	DivWork[7].vx=((Vertc->vx+Verta->vx)>>1);
	DivWork[7].vy=((Vertc->vy+Verta->vy)>>1);
	DivWork[7].vz=((Vertc->vz+Verta->vz)>>1);
	DivWork[7].tu=(In->u2+In->u0)>>1;
	DivWork[7].tv=(In->v2+In->v0)>>1;


	DivWork[8].vx=((Verta->vx+Vertd->vx)>>1);
	DivWork[8].vy=((Verta->vy+Vertd->vy)>>1);
	DivWork[8].vz=((Verta->vz+Vertd->vz)>>1);
	DivWork[8].tu=(In->u0+In->u3)>>1;
	DivWork[8].tv=(In->v0+In->v3)>>1;

	// rottranspers mid point into dcache
	gte_ldv3c_vertc(&DivWork[8]);	
	gte_rtps();	
	gte_stflg(&midflag);
	gte_stsz(&midsz);
	gte_stsxy2(&midxy);


	// sub dived 0
	GT4Out=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr
	GT4Out->tpage=In->tpage;
	GT4Out->clut=In->clut;

	gte_ldv3(Verta,&DivWork[4],&DivWork[7]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();			// only checks 1 tri part of quad
//	// may need to check both tri's in quad on quads that are across bend
//	// ie verts b and c.. so that will be sub-div quads	1+3 with 2 nclips				
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto skip1;
//	}

	gte_stsxy3_ft4(GT4Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip1;

	if ((( ((flag|midflag) & 0x80000000) // sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag)
	   ||(midsz<clipflag)
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )

	{
	// sub div 0 
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_FT3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT4Out2->tpage=
		GT4Out3->tpage=
		GT4Out4->tpage=
		GT3Out->tpage=
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=In->tpage;
		GT4Out2->clut=
		GT4Out3->clut=
		GT4Out4->clut=
		GT3Out->clut=
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=In->clut;
		*(Uint32 *)&GT4Out->r0=		// no grd shading
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out4->x1=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x2;

		*(Uint32 *)&GT4Out3->x0=*(Uint32 *)&midxy;


		DivWork[9].vx=(Verta->vx+DivWork[4].vx)>>1;
		DivWork[9].vy=(Verta->vy+DivWork[4].vy)>>1;
		DivWork[9].vz=(Verta->vz+DivWork[4].vz)>>1;
		DivWork[9].tu=(In->u0+DivWork[4].tu)>>1;
		DivWork[9].tv=(In->v0+DivWork[4].tv)>>1;

		DivWork[10].vx=(DivWork[4].vx+DivWork[8].vx)>>1;
		DivWork[10].vy=(DivWork[4].vy+DivWork[8].vy)>>1;
		DivWork[10].vz=(DivWork[4].vz+DivWork[8].vz)>>1;
		DivWork[10].tu=(DivWork[4].tu+DivWork[8].tu)>>1;
		DivWork[10].tv=(DivWork[4].tv+DivWork[8].tv)>>1;
		Done10=1;

		DivWork[11].vx=(DivWork[7].vx+DivWork[8].vx)>>1;
		DivWork[11].vy=(DivWork[7].vy+DivWork[8].vy)>>1;
		DivWork[11].vz=(DivWork[7].vz+DivWork[8].vz)>>1;
		DivWork[11].tu=(DivWork[7].tu+DivWork[8].tu)>>1;
		DivWork[11].tv=(DivWork[7].tv+DivWork[8].tv)>>1;
		Done11=1;

		DivWork[12].vx=(Verta->vx+DivWork[7].vx)>>1;
		DivWork[12].vy=(Verta->vy+DivWork[7].vy)>>1;
		DivWork[12].vz=(Verta->vz+DivWork[7].vz)>>1;
		DivWork[12].tu=(In->u0+DivWork[7].tu)>>1;
		DivWork[12].tv=(In->v0+DivWork[7].tv)>>1;

		DivWork[13].vx=(DivWork[7].vx+DivWork[4].vx)>>1;
		DivWork[13].vy=(DivWork[7].vy+DivWork[4].vy)>>1;
		DivWork[13].vz=(DivWork[7].vz+DivWork[4].vz)>>1;
		DivWork[13].tu=(DivWork[7].tu+DivWork[4].tu)>>1;
		DivWork[13].tv=(DivWork[7].tv+DivWork[4].tv)>>1;

		gte_ldv3(&DivWork[9],&DivWork[13],&DivWork[12]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out->x1,&GT4Out->x3,&GT4Out->x2);
		gte_ldv01(&DivWork[10],&DivWork[11]);
		gte_rtpt();
		gte_stsxy01(&GT4Out2->x3,&GT4Out3->x1);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT4Out4->x3=*(Uint32 *)&GT4Out->x2;	
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT3Out4->x0=	
		*(Uint32 *)&GT3Out->x0=*(Uint32 *)&GT4Out->x0; 
		*(Uint32 *)&GT3Out->x1= 
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out2->x1;
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1;	

#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
#endif
		*(Uint16 *)&GT4Out->u0=	
		*(Uint16 *)&GT3Out->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&In->u0;

		*(Uint16 *)&GT4Out->u1=
		*(Uint16 *)&GT4Out2->u0=
		*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[9].tu;

		*(Uint16 *)&GT4Out->u2=
		*(Uint16 *)&GT4Out4->u3=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[12].tu;

		*(Uint16 *)&GT4Out->u3=
		*(Uint16 *)&GT4Out2->u2=
		*(Uint16 *)&GT4Out3->u3=
		*(Uint16 *)&GT4Out4->u2=*(Uint16 *)&DivWork[13].tu;

		*(Uint16 *)&GT4Out2->u1=
		*(Uint16 *)&GT3Out->u1=
		*(Uint16 *)&GT3Out2->u0=*(Uint16 *)&DivWork[4].tu;

		*(Uint16 *)&GT4Out2->u3=
		*(Uint16 *)&GT4Out3->u2=
		*(Uint16 *)&GT3Out2->u2=*(Uint16 *)&DivWork[10].tu;

		*(Uint16 *)&GT4Out3->u0=
		*(Uint16 *)&GT3Out2->u1=
		*(Uint16 *)&GT3Out3->u0=*(Uint16 *)&DivWork[8].tu;

		*(Uint16 *)&GT4Out3->u1=
		*(Uint16 *)&GT4Out4->u0=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[11].tu;

		*(Uint16 *)&GT4Out4->u1=
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[7].tu;
		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
//		SeePolyFilla4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
		setRGB0(GT3Out,255,0,0);
		setRGB0(GT3Out2,0,255,0);
		setRGB0(GT3Out3,0,0,255);
		setRGB0(GT3Out4,255,255,255);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x24;//ft3 with In->semi-trans and shade info

#if 0		// out 2-2-99
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x09000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x09000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x09000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x09000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x28*4;	 // ft4
		GsOUT_PACKET_P+=0x20*4;	 // ft3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x09000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x09000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x28*4;	 // ft4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x20*4;	 // ft3


	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT4Out->u0=*(Uint16 *)&In->u0;
	  	  
	*(Uint16 *)&GT4Out->u1=*(Uint16 *)&DivWork[4].tu;
	  	  
	*(Uint16 *)&GT4Out->u2=*(Uint16 *)&DivWork[7].tu;

	*(Uint16 *)&GT4Out->u3=*(Uint16 *)&DivWork[8].tu;
#if SeeSplit
	setRGB0(GT4Out,128,0,0);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
;
	*(Uint32 *)&GT4Out->x3=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x28;	 // ft4
	}



skip1:
	// sub dived 1
	GT4Out=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr
	GT4Out->tpage=In->tpage;
	GT4Out->clut=In->clut;
		  
	gte_ldv3(&DivWork[4],Vertb,&DivWork[5]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto skip2;
//	}

	gte_stsxy3(&GT4Out->x0,&GT4Out->x1,&GT4Out->x3);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip2;

	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 1
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_FT3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT4Out2->tpage=
		GT4Out3->tpage=
		GT4Out4->tpage=
		GT3Out->tpage=
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=In->tpage;
		GT4Out2->clut=
		GT4Out3->clut=
		GT4Out4->clut=
		GT3Out->clut=
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=In->clut;
		*(Uint32 *)&GT4Out->r0=		// no grd shading
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out3->x0=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x3;

		*(Uint32 *)&GT4Out4->x1=*(Uint32 *)&midxy;


		DivWork[14].vx=(Vertb->vx+DivWork[5].vx)>>1;
		DivWork[14].vy=(Vertb->vy+DivWork[5].vy)>>1;
		DivWork[14].vz=(Vertb->vz+DivWork[5].vz)>>1;
		DivWork[14].tu=(In->u1+DivWork[5].tu)>>1;
		DivWork[14].tv=(In->v1+DivWork[5].tv)>>1;

		DivWork[15].vx=(DivWork[5].vx+DivWork[8].vx)>>1;
		DivWork[15].vy=(DivWork[5].vy+DivWork[8].vy)>>1;
		DivWork[15].vz=(DivWork[5].vz+DivWork[8].vz)>>1;
		DivWork[15].tu=(DivWork[5].tu+DivWork[8].tu)>>1;
		DivWork[15].tv=(DivWork[5].tv+DivWork[8].tv)>>1;
		Done15=1;

		DivWork[16].vx=(Vertb->vx+DivWork[4].vx)>>1;
		DivWork[16].vy=(Vertb->vy+DivWork[4].vy)>>1;
		DivWork[16].vz=(Vertb->vz+DivWork[4].vz)>>1;
		DivWork[16].tu=(In->u1+DivWork[4].tu)>>1;
		DivWork[16].tv=(In->v1+DivWork[4].tv)>>1;

		DivWork[17].vx=(Vertb->vx+DivWork[8].vx)>>1;
		DivWork[17].vy=(Vertb->vy+DivWork[8].vy)>>1;
		DivWork[17].vz=(Vertb->vz+DivWork[8].vz)>>1;
		DivWork[17].tu=(In->u1+DivWork[8].tu)>>1;
		DivWork[17].tv=(In->v1+DivWork[8].tv)>>1;

		if (Done10==0)
		{
		DivWork[10].vx=(DivWork[4].vx+DivWork[8].vx)>>1;
		DivWork[10].vy=(DivWork[4].vy+DivWork[8].vy)>>1;
		DivWork[10].vz=(DivWork[4].vz+DivWork[8].vz)>>1;
		DivWork[10].tu=(DivWork[4].tu+DivWork[8].tu)>>1;
		DivWork[10].tv=(DivWork[4].tv+DivWork[8].tv)>>1;
		Done10=1;
		}

		gte_ldv3(&DivWork[14],&DivWork[17],&DivWork[16]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out2->x3,&GT4Out->x3,&GT4Out->x1);
		// 10 below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[15],&DivWork[10]);
		gte_rtpt();
		gte_stsxy01(&GT4Out3->x1,&GT4Out->x2);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT4Out4->x3=*(Uint32 *)&GT4Out->x2;	
		*(Uint32 *)&GT3Out4->x0=	
		*(Uint32 *)&GT3Out->x0=*(Uint32 *)&GT4Out->x0; 
		*(Uint32 *)&GT3Out->x1= 
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out2->x1;
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1;	


#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
#endif

		*(Uint16 *)&GT4Out->u0=
		*(Uint16 *)&GT3Out->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[4].tu;

		*(Uint16 *)&GT4Out->u1=
		*(Uint16 *)&GT4Out2->u0=
		*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[16].tu;

		*(Uint16 *)&GT4Out->u2=
		*(Uint16 *)&GT4Out4->u3=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[10].tu;

		*(Uint16 *)&GT4Out->u3=
		*(Uint16 *)&GT4Out2->u2=
		*(Uint16 *)&GT4Out3->u3=
		*(Uint16 *)&GT4Out4->u2=*(Uint16 *)&DivWork[17].tu;

		*(Uint16 *)&GT4Out2->u1=
		*(Uint16 *)&GT3Out->u1=
		*(Uint16 *)&GT3Out2->u0=*(Uint16 *)&In->u1;

		*(Uint16 *)&GT4Out2->u3=
		*(Uint16 *)&GT4Out3->u2=
		*(Uint16 *)&GT3Out2->u2=*(Uint16 *)&DivWork[14].tu;

		*(Uint16 *)&GT4Out3->u0=
		*(Uint16 *)&GT3Out2->u1=
		*(Uint16 *)&GT3Out3->u0=*(Uint16 *)&DivWork[5].tu;

		*(Uint16 *)&GT4Out3->u1=
		*(Uint16 *)&GT4Out4->u0=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[15].tu;

		*(Uint16 *)&GT4Out4->u1=
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[8].tu;
	  
		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
//		SeePolyFilla4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
		setRGB0(GT3Out,255,0,0);
		setRGB0(GT3Out2,0,255,0);
		setRGB0(GT3Out3,0,0,255);
		setRGB0(GT3Out4,255,255,255);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x24;//ft3 with In->semi-trans and shade info

#if 0	//2-2-99
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x09000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x09000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x09000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x09000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x28*4;	 // ft4
		GsOUT_PACKET_P+=0x20*4;	 // ft3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x09000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x09000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x28*4;	 // ft4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x20*4;	 // ft3


	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT4Out->u0=*(Uint16 *)&DivWork[4].tu;
		  
	*(Uint16 *)&GT4Out->u1=*(Uint16 *)&In->u1;
		  
	*(Uint16 *)&GT4Out->u2=*(Uint16 *)&DivWork[8].tu;

	*(Uint16 *)&GT4Out->u3=*(Uint16 *)&DivWork[5].tu;
#if SeeSplit
	setRGB0(GT4Out,0,128,0);
#endif  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x2=*(Uint32 *)&midxy;


	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x28;	 // ft4
	}



skip2:
	// subed dived 2
	GT4Out=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr
	GT4Out->tpage=In->tpage;
	GT4Out->clut=In->clut;

	gte_ldv3(Vertd,&DivWork[6],&DivWork[5]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto  skip3;
//	}

	gte_stsxy3_ft4(GT4Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip3;

	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn)  )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 2
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_FT3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT4Out2->tpage=
		GT4Out3->tpage=
		GT4Out4->tpage=
		GT3Out->tpage=
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=In->tpage;
		GT4Out2->clut=
		GT4Out3->clut=
		GT4Out4->clut=
		GT3Out->clut=
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=In->clut;
		*(Uint32 *)&GT4Out->r0=		// no grd shading
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out4->x1=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x2;

		*(Uint32 *)&GT4Out3->x0=*(Uint32 *)&midxy;


		DivWork[18].vx=(Vertd->vx+DivWork[6].vx)>>1;
		DivWork[18].vy=(Vertd->vy+DivWork[6].vy)>>1;
		DivWork[18].vz=(Vertd->vz+DivWork[6].vz)>>1;
		DivWork[18].tu=(In->u3+DivWork[6].tu)>>1;
		DivWork[18].tv=(In->v3+DivWork[6].tv)>>1;

		DivWork[19].vx=(DivWork[6].vx+DivWork[8].vx)>>1;
		DivWork[19].vy=(DivWork[6].vy+DivWork[8].vy)>>1;
		DivWork[19].vz=(DivWork[6].vz+DivWork[8].vz)>>1;
		DivWork[19].tu=(DivWork[6].tu+DivWork[8].tu)>>1;
		DivWork[19].tv=(DivWork[6].tv+DivWork[8].tv)>>1;
		Done19=1;

		DivWork[20].vx=(Vertd->vx+DivWork[5].vx)>>1;
		DivWork[20].vy=(Vertd->vy+DivWork[5].vy)>>1;
		DivWork[20].vz=(Vertd->vz+DivWork[5].vz)>>1;
		DivWork[20].tu=(In->u3+DivWork[5].tu)>>1;
		DivWork[20].tv=(In->v3+DivWork[5].tv)>>1;

		DivWork[21].vx=(DivWork[5].vx+DivWork[6].vx)>>1;
		DivWork[21].vy=(DivWork[5].vy+DivWork[6].vy)>>1;
		DivWork[21].vz=(DivWork[5].vz+DivWork[6].vz)>>1;
		DivWork[21].tu=(DivWork[5].tu+DivWork[6].tu)>>1;
		DivWork[21].tv=(DivWork[5].tv+DivWork[6].tv)>>1;

		if (Done15==0)
		{
		DivWork[15].vx=(DivWork[5].vx+DivWork[8].vx)>>1;
		DivWork[15].vy=(DivWork[5].vy+DivWork[8].vy)>>1;
		DivWork[15].vz=(DivWork[5].vz+DivWork[8].vz)>>1;
		DivWork[15].tu=(DivWork[5].tu+DivWork[8].tu)>>1;
		DivWork[15].tv=(DivWork[5].tv+DivWork[8].tv)>>1;
		Done15=1;
		}

		gte_ldv3(&DivWork[18],&DivWork[21],&DivWork[20]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out->x1,&GT4Out->x3,&GT4Out->x2);
		// 15 below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[19],&DivWork[15]);
		gte_rtpt();
		gte_stsxy01(&GT4Out2->x3,&GT4Out3->x1);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT4Out4->x3=
		*(Uint32 *)&GT3Out4->x1=*(Uint32 *)&GT4Out->x2;	

#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
#endif
		*(Uint16 *)&GT4Out->u0=
		*(Uint16 *)&GT3Out->u0=
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&In->u3;

		*(Uint16 *)&GT4Out->u1=
		*(Uint16 *)&GT4Out2->u0=
		*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[18].tu;

		*(Uint16 *)&GT4Out->u2=
		*(Uint16 *)&GT4Out4->u3=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[20].tu;

		*(Uint16 *)&GT4Out->u3=
		*(Uint16 *)&GT4Out2->u2=
		*(Uint16 *)&GT4Out3->u3=
		*(Uint16 *)&GT4Out4->u2=*(Uint16 *)&DivWork[21].tu;

		*(Uint16 *)&GT4Out2->u1=
		*(Uint16 *)&GT3Out->u1=
		*(Uint16 *)&GT3Out2->u0=*(Uint16 *)&DivWork[6].tu;

		*(Uint16 *)&GT4Out2->u3=
		*(Uint16 *)&GT4Out3->u2=
		*(Uint16 *)&GT3Out2->u2=*(Uint16 *)&DivWork[19].tu;

		*(Uint16 *)&GT4Out3->u0=
		*(Uint16 *)&GT3Out2->u1=
		*(Uint16 *)&GT3Out3->u0=*(Uint16 *)&DivWork[8].tu;

		*(Uint16 *)&GT4Out3->u1=
		*(Uint16 *)&GT4Out4->u0=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[15].tu;

		*(Uint16 *)&GT4Out4->u1=
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[5].tu;

		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
//		SeePolyFilla4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
		setRGB0(GT3Out,255,0,0);
		setRGB0(GT3Out2,0,255,0);
		setRGB0(GT3Out3,0,0,255);
		setRGB0(GT3Out4,255,255,255);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x24;//ft3 with In->semi-trans and shade info

#if 0	//2-2-99
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x09000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x09000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x09000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x09000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x28*4;	 // ft4
		GsOUT_PACKET_P+=0x20*4;	 // ft3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x09000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x09000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x28*4;	 // ft4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x20*4;	 // ft3


	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT4Out->u0=*(Uint16 *)&In->u3;
		  
	*(Uint16 *)&GT4Out->u1=*(Uint16 *)&DivWork[6].tu;
			  
	*(Uint16 *)&GT4Out->u2=*(Uint16 *)&DivWork[5].tu;
	
	*(Uint16 *)&GT4Out->u3=*(Uint16 *)&DivWork[8].tu;
#if SeeSplit
	setRGB0(GT4Out,0,0,128);
#endif  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x3=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x28;	 // ft4
	}


skip3:
	// sub dived 3
	GT4Out=(POLY_FT4 *)GsOUT_PACKET_P;	// get work base addr
	GT4Out->tpage=In->tpage;
	GT4Out->clut=In->clut;

	gte_ldv3(&DivWork[6],Vertc,&DivWork[7]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto  skip4;
//	}


	gte_stsxy3(&GT4Out->x0,&GT4Out->x1,&GT4Out->x3);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip4;

	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 3
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_FT3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT4Out2->tpage=
		GT4Out3->tpage=
		GT4Out4->tpage=
		GT3Out->tpage=
		GT3Out2->tpage=
		GT3Out3->tpage=
		GT3Out4->tpage=In->tpage;
		GT4Out2->clut=
		GT4Out3->clut=
		GT4Out4->clut=
		GT3Out->clut=
		GT3Out2->clut=
		GT3Out3->clut=
		GT3Out4->clut=In->clut;
		*(Uint32 *)&GT4Out->r0=		// no grd shading
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out3->x0=
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out->x3;

		*(Uint32 *)&GT4Out4->x1=*(Uint32 *)&midxy;


		DivWork[22].vx=(Vertc->vx+DivWork[7].vx)>>1;
		DivWork[22].vy=(Vertc->vy+DivWork[7].vy)>>1;
		DivWork[22].vz=(Vertc->vz+DivWork[7].vz)>>1;
		DivWork[22].tu=(In->u2+DivWork[7].tu)>>1;
		DivWork[22].tv=(In->v2+DivWork[7].tv)>>1;

		if (Done11==0)
		{
		DivWork[11].vx=(DivWork[7].vx+DivWork[8].vx)>>1;
		DivWork[11].vy=(DivWork[7].vy+DivWork[8].vy)>>1;
		DivWork[11].vz=(DivWork[7].vz+DivWork[8].vz)>>1;
		DivWork[11].tu=(DivWork[7].tu+DivWork[8].tu)>>1;
		DivWork[11].tv=(DivWork[7].tv+DivWork[8].tv)>>1;
		Done11=1;
		}

		if (Done19==0)
		{
		DivWork[19].vx=(DivWork[6].vx+DivWork[8].vx)>>1;
		DivWork[19].vy=(DivWork[6].vy+DivWork[8].vy)>>1;
		DivWork[19].vz=(DivWork[6].vz+DivWork[8].vz)>>1;
		DivWork[19].tu=(DivWork[6].tu+DivWork[8].tu)>>1;
		DivWork[19].tv=(DivWork[6].tv+DivWork[8].tv)>>1;
		Done19=1;
		}

		DivWork[23].vx=(Vertc->vx+DivWork[6].vx)>>1;
		DivWork[23].vy=(Vertc->vy+DivWork[6].vy)>>1;
		DivWork[23].vz=(Vertc->vz+DivWork[6].vz)>>1;
		DivWork[23].tu=(In->u2+DivWork[6].tu)>>1;
		DivWork[23].tv=(In->v2+DivWork[6].tv)>>1;

		DivWork[24].vx=(Vertc->vx+DivWork[8].vx)>>1;
		DivWork[24].vy=(Vertc->vy+DivWork[8].vy)>>1;
		DivWork[24].vz=(Vertc->vz+DivWork[8].vz)>>1;
		DivWork[24].tu=(In->u2+DivWork[8].tu)>>1;
		DivWork[24].tv=(In->v2+DivWork[8].tv)>>1;


		gte_ldv3(&DivWork[22],&DivWork[24],&DivWork[23]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out2->x3,&GT4Out->x3,&GT4Out->x1);
		// 11 and 19  below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[11],&DivWork[19]);
		gte_rtpt();
		gte_stsxy01(&GT4Out3->x1,&GT4Out->x2);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out4->x3=
		*(Uint32 *)&GT3Out4->x1=*(Uint32 *)&GT4Out->x2;
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1; 

#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
#endif
		*(Uint16 *)&GT4Out->u0=
		*(Uint16 *)&GT3Out->u0=	
		*(Uint16 *)&GT3Out4->u0=*(Uint16 *)&DivWork[6].tu;

		*(Uint16 *)&GT4Out->u1=
		*(Uint16 *)&GT4Out2->u0=
		*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[23].tu;

		*(Uint16 *)&GT4Out->u2=
		*(Uint16 *)&GT4Out4->u3=
		*(Uint16 *)&GT3Out4->u1=*(Uint16 *)&DivWork[19].tu;

		*(Uint16 *)&GT4Out->u3=
		*(Uint16 *)&GT4Out2->u2=
		*(Uint16 *)&GT4Out3->u3=
		*(Uint16 *)&GT4Out4->u2=*(Uint16 *)&DivWork[24].tu;

		*(Uint16 *)&GT4Out2->u1=
		*(Uint16 *)&GT3Out->u1=
		*(Uint16 *)&GT3Out2->u0=*(Uint16 *)&In->u2;

		*(Uint16 *)&GT4Out2->u3=
		*(Uint16 *)&GT4Out3->u2=
		*(Uint16 *)&GT3Out2->u2=*(Uint16 *)&DivWork[22].tu;

		*(Uint16 *)&GT4Out3->u0=
		*(Uint16 *)&GT3Out2->u1=
		*(Uint16 *)&GT3Out3->u0=*(Uint16 *)&DivWork[7].tu;

		*(Uint16 *)&GT4Out3->u1=
		*(Uint16 *)&GT4Out4->u0=
		*(Uint16 *)&GT3Out3->u2=*(Uint16 *)&DivWork[11].tu;

		*(Uint16 *)&GT4Out4->u1=
		*(Uint16 *)&GT3Out3->u1=
		*(Uint16 *)&GT3Out4->u2=*(Uint16 *)&DivWork[8].tu;

		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
//		SeePolyFilla4(GT3Out,GT3Out2,GT3Out3,GT3Out4);
		setRGB0(GT3Out,255,0,0);
		setRGB0(GT3Out2,0,255,0);
		setRGB0(GT3Out3,0,0,255);
		setRGB0(GT3Out4,255,255,255);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x24;//gt3 with In->semi-trans and shade info

#if 0	//2-2-99
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x09000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x09000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x09000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x09000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x07000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x07000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x07000000;
		GsOUT_PACKET_P+=0x28*4;	 // ft4
		GsOUT_PACKET_P+=0x20*4;	 // ft3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x09000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x09000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x09000000;
		GsOUT_PACKET_P+=0x28*4;	 // ft4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x20*4;	 // ft3


	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT4Out->u0=*(Uint16 *)&DivWork[6].tu;
		  
	*(Uint16 *)&GT4Out->u1=*(Uint16 *)&In->u2;
		  
	*(Uint16 *)&GT4Out->u2=*(Uint16 *)&DivWork[8].tu;

	*(Uint16 *)&GT4Out->u3=*(Uint16 *)&DivWork[7].tu;
#if SeeSplit
	setRGB0(GT4Out,255,180,0);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x2=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x09000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x28;	 // ft4
	}

skip4:




	// FILL IN POLY GAPS

	// new POLY_FILLA 1!
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Verta,Vertb,&DivWork[4]);	
	gte_rtpt();
#if SeePolyFilla
//	SeePolyFilla1(GT3Out);
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u1;

	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[4].tu;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla1;
	gte_stsxy3_ft3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x24;//ft3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;	 // ft3


skipfilla1:

	// new POLY_FILLA 2!
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Vertb,Vertd,&DivWork[5]);	
	gte_rtpt();
#if SeePolyFilla
//	SeePolyFilla1(GT3Out);
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u1;

	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u3;

	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[5].tu;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla2;
	gte_stsxy3_ft3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x24;//ft3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;	 // ft3


skipfilla2:

	// new POLY_FILLA 3!
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Vertd,Vertc,&DivWork[6]);	
	gte_rtpt();
#if SeePolyFilla
//	SeePolyFilla1(GT3Out);
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u3;

	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&In->u2;

	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&DivWork[6].tu;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla3;
	gte_stsxy3_ft3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x24;//ft3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;	 // ft3

skipfilla3:

	// new POLY_FILLA 4!
	GT3Out=(POLY_FT3 *)GsOUT_PACKET_P;	// get work base addr
	GT3Out->tpage=In->tpage;
	GT3Out->clut=In->clut;
	gte_ldv3(Verta,&DivWork[7],Vertc);	
	gte_rtpt();
#if SeePolyFilla
//	SeePolyFilla1(GT3Out);
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
	*(Uint16 *)&GT3Out->u0=*(Uint16 *)&In->u0;

	*(Uint16 *)&GT3Out->u1=*(Uint16 *)&DivWork[7].tu;

	*(Uint16 *)&GT3Out->u2=*(Uint16 *)&In->u2;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla4;
	gte_stsxy3_ft3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x24;//ft3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x07000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x20;	 // ft3

skipfilla4:
{}



}


void	SubDivF3(register F3_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
						register SVECTOR *Vertc,
						register Sint32 *tag,
						register Uint32 backclip)
{
register POLY_F3	*GT3Out;
register POLY_F3	*GT3Out2;
register POLY_F3	*GT3Out3;
register POLY_F3	*GT3Out4;
register POLY_F3	*GT3Out5;
register POLY_F3	*GT3Out6;
register POLY_F3	*GT3Out7;

// reset flags to say mid points 11,12 and 7 have been made.
register Uint32		Done11=0;
register Uint32		Done12=0;
register Uint32		Done7=0;


	DivWork[3].vx=((Verta->vx+Vertb->vx)>>1);
	DivWork[3].vy=((Verta->vy+Vertb->vy)>>1);
	DivWork[3].vz=((Verta->vz+Vertb->vz)>>1);

	DivWork[4].vx=((Vertb->vx+Vertc->vx)>>1);
	DivWork[4].vy=((Vertb->vy+Vertc->vy)>>1);
	DivWork[4].vz=((Vertb->vz+Vertc->vz)>>1);

	DivWork[5].vx=((Vertc->vx+Verta->vx)>>1);
	DivWork[5].vy=((Vertc->vy+Verta->vy)>>1);
	DivWork[5].vz=((Vertc->vz+Verta->vz)>>1);


	// sub dived 0
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(Verta,&DivWork[3],&DivWork[5]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto skip1;
	}

	gte_stsxy3_f3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip1;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag)
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )

	{
	// at end of these need to make extra polyfilla's around tri
	// sub div 0 into 4 5 6 7
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;	// now polyfilla
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=
		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out7->r0=*(Uint32 *)&In->r0;


		// copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

	
		DivWork[6].vx=(Verta->vx+DivWork[3].vx)>>1;
		DivWork[6].vy=(Verta->vy+DivWork[3].vy)>>1;
		DivWork[6].vz=(Verta->vz+DivWork[3].vz)>>1;

		DivWork[7].vx=(DivWork[3].vx+DivWork[5].vx)>>1;
		DivWork[7].vy=(DivWork[3].vy+DivWork[5].vy)>>1;
		DivWork[7].vz=(DivWork[3].vz+DivWork[5].vz)>>1;
		Done7=1;

		DivWork[8].vx=(Verta->vx+DivWork[5].vx)>>1;
		DivWork[8].vy=(Verta->vy+DivWork[5].vy)>>1;
		DivWork[8].vz=(Verta->vz+DivWork[5].vz)>>1;

		gte_ldv3(&DivWork[6],&DivWork[7],&DivWork[8]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);

		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;

#if SeeSplit
		setRGB0(GT3Out,128,0,0);
		setRGB0(GT3Out2,0,128,0);
		setRGB0(GT3Out3,0,0,128);
		setRGB0(GT3Out4,255,180,0);
#endif


#if SeePolyFilla	// write over correct rgbs already put in
//	SeePolyFillaTri3(GT3Out5,GT3Out6,GT3Out7);
		setRGB0(GT3Out5,255,0,0);
		setRGB0(GT3Out6,0,255,0);
		setRGB0(GT3Out7,0,0,255);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
		;

#if 0	//2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x04000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x04000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x14*7;
#endif

		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x14*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x14*3;

	} 
	else
	{
#if SeeSplit
	setRGB0(GT3Out,128,0,0);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;
	}



skip1:
	// sub dived 1
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr
		  
	gte_ldv3(&DivWork[3],Vertb,&DivWork[4]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto skip2;
	}

	gte_stsxy3_f3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip2;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 1 into 8 9 10 11
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;	// now polyfilla
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=
		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out7->r0=*(Uint32 *)&In->r0;

		// copy sub div 1 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

	
		DivWork[9].vx=(Vertb->vx+DivWork[3].vx)>>1;
		DivWork[9].vy=(Vertb->vy+DivWork[3].vy)>>1;
		DivWork[9].vz=(Vertb->vz+DivWork[3].vz)>>1;

		DivWork[10].vx=(Vertb->vx+DivWork[4].vx)>>1;
		DivWork[10].vy=(Vertb->vy+DivWork[4].vy)>>1;
		DivWork[10].vz=(Vertb->vz+DivWork[4].vz)>>1;

		DivWork[11].vx=(DivWork[3].vx+DivWork[4].vx)>>1;
		DivWork[11].vy=(DivWork[3].vy+DivWork[4].vy)>>1;
		DivWork[11].vz=(DivWork[3].vz+DivWork[4].vz)>>1;
		Done11=1;


		gte_ldv3(&DivWork[9],&DivWork[10],&DivWork[11]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);


		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;



#if SeeSplit
		setRGB0(GT3Out,128,0,0);
		setRGB0(GT3Out2,0,128,0);
		setRGB0(GT3Out3,0,0,128);
		setRGB0(GT3Out4,255,180,0);
#endif


#if SeePolyFilla	// write over correct rgbs already put in
		setRGB0(GT3Out5,255,0,0);
		setRGB0(GT3Out6,0,255,0);
		setRGB0(GT3Out7,0,0,255);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
		;

#if 0 //2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x04000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x04000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x14*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x14*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x14*3;


	} 
	else
	{
#if SeeSplit
	setRGB0(GT3Out,0,128,0);
#else	  
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;


	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;
	}





skip2:
	// subed dived 2
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(&DivWork[5],&DivWork[4],Vertc);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto  skip3;
	}

	gte_stsxy3_f3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip3;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn)  )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 2 into 12 13 14 15
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=
		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out7->r0=*(Uint32 *)&In->r0;

		// copy sub div 2 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;



		DivWork[12].vx=(DivWork[5].vx+DivWork[4].vx)>>1;
		DivWork[12].vy=(DivWork[5].vy+DivWork[4].vy)>>1;
		DivWork[12].vz=(DivWork[5].vz+DivWork[4].vz)>>1;
		Done12=1;
	
		DivWork[13].vx=(Vertc->vx+DivWork[4].vx)>>1;
		DivWork[13].vy=(Vertc->vy+DivWork[4].vy)>>1;
		DivWork[13].vz=(Vertc->vz+DivWork[4].vz)>>1;

		DivWork[14].vx=(Vertc->vx+DivWork[5].vx)>>1;
		DivWork[14].vy=(Vertc->vy+DivWork[5].vy)>>1;
		DivWork[14].vz=(Vertc->vz+DivWork[5].vz)>>1;


		gte_ldv3(&DivWork[12],&DivWork[13],&DivWork[14]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);


		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;


#if SeeSplit
		setRGB0(GT3Out,128,0,0);
		setRGB0(GT3Out2,0,128,0);
		setRGB0(GT3Out3,0,0,128);
		setRGB0(GT3Out4,255,180,0);
#endif

#if SeePolyFilla	// write over correct rgbs already put in
		setRGB0(GT3Out5,255,0,0);
		setRGB0(GT3Out6,0,255,0);
		setRGB0(GT3Out7,0,0,255);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
		;

#if 0 //2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x04000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x04000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x14*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x14*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x14*3;


	} 
	else
	{
#if SeeSplit
	setRGB0(GT3Out,0,0,128);
#else	  
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;
	}


skip3:
	// sub dived 3
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(&DivWork[3],&DivWork[4],&DivWork[5]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto  skip4;
	}

	gte_stsxy3_f3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip4;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 3 into 16 17 18 19
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=
		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out7->r0=*(Uint32 *)&In->r0;


		// copy sub div 2 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

		if (Done11==0)
		{
		DivWork[11].vx=(DivWork[3].vx+DivWork[4].vx)>>1;
		DivWork[11].vy=(DivWork[3].vy+DivWork[4].vy)>>1;
		DivWork[11].vz=(DivWork[3].vz+DivWork[4].vz)>>1;
		}
		if (Done12==0)
		{
		DivWork[12].vx=(DivWork[5].vx+DivWork[4].vx)>>1;
		DivWork[12].vy=(DivWork[5].vy+DivWork[4].vy)>>1;
		DivWork[12].vz=(DivWork[5].vz+DivWork[4].vz)>>1;
		}
		if (Done7==0)
		{
		DivWork[7].vx=(DivWork[3].vx+DivWork[5].vx)>>1;
		DivWork[7].vy=(DivWork[3].vy+DivWork[5].vy)>>1;
		DivWork[7].vz=(DivWork[3].vz+DivWork[5].vz)>>1;
		}

		// below may have been worked out already in other tris!
		// could we make improment here ?
		gte_ldv3(&DivWork[11],&DivWork[12],&DivWork[7]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);

	    *(Uint32 *)&GT3Out2->x0=
	    *(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;



#if SeeSplit
		setRGB0(GT3Out,128,0,0);
		setRGB0(GT3Out2,0,128,0);
		setRGB0(GT3Out3,0,0,128);
		setRGB0(GT3Out4,255,180,0);
#endif

#if SeePolyFilla	// write over correct rgbs already put in
		setRGB0(GT3Out5,255,0,0);
		setRGB0(GT3Out6,0,255,0);
		setRGB0(GT3Out7,0,0,255);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
		;

#if 0	//2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x04000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x04000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x14*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x14*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x14*3;


	} 
	else
	{
#if SeeSplit
	setRGB0(GT3Out,255,180,0);
#else	  
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;
	}

skip4:



	// FILL IN POLY GAPS

	// new POLY_FILLA 1!
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Verta,&DivWork[5],Vertc);	
	gte_rtpt();
#if SeePolyFilla
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla1;
	gte_stsxy3_f3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;


skipfilla1:

	// new POLY_FILLA 2!
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Verta,Vertb,&DivWork[3]);	
	gte_rtpt();
#if SeePolyFilla
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla2;
	gte_stsxy3_f3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;


skipfilla2:

	// new POLY_FILLA 3!
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(&DivWork[4],Vertb,Vertc);	
	gte_rtpt();
#if SeePolyFilla
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla3;
	gte_stsxy3_f3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;

skipfilla3:
{}



}



void	SubDivG3(	register GF3_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
						register SVECTOR *Vertc,
						register Sint32 *tag,
						register Uint32	backclip)
{
register POLY_G3	*GT3Out;
register POLY_G3	*GT3Out2;
register POLY_G3	*GT3Out3;
register POLY_G3	*GT3Out4;
register POLY_G3	*GT3Out5;
register POLY_G3	*GT3Out6;
register POLY_G3	*GT3Out7;

// reset flags to say mid points 11,12 and 7 have been made.
register Uint32		Done11=0;
register Uint32		Done12=0;
register Uint32		Done7=0;



	DivWork[3].vx=((Verta->vx+Vertb->vx)>>1);
	DivWork[3].vy=((Verta->vy+Vertb->vy)>>1);
	DivWork[3].vz=((Verta->vz+Vertb->vz)>>1);
	DivWork[3].col.r=(In->r0+In->r1)>>1;
	DivWork[3].col.g=(In->g0+In->g1)>>1;
	DivWork[3].col.b=(In->b0+In->b1)>>1;

	DivWork[4].vx=((Vertb->vx+Vertc->vx)>>1);
	DivWork[4].vy=((Vertb->vy+Vertc->vy)>>1);
	DivWork[4].vz=((Vertb->vz+Vertc->vz)>>1);
	DivWork[4].col.r=(In->r1+In->r2)>>1;
	DivWork[4].col.g=(In->g1+In->g2)>>1;
	DivWork[4].col.b=(In->b1+In->b2)>>1;

	DivWork[5].vx=((Vertc->vx+Verta->vx)>>1);
	DivWork[5].vy=((Vertc->vy+Verta->vy)>>1);
	DivWork[5].vz=((Vertc->vz+Verta->vz)>>1);
	DivWork[5].col.r=(In->r2+In->r0)>>1;
	DivWork[5].col.g=(In->g2+In->g0)>>1;
	DivWork[5].col.b=(In->b2+In->b0)>>1;



	// sub dived 0
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(Verta,&DivWork[3],&DivWork[5]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto skip1;
	}

	gte_stsxy3_g3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip1;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag)
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )

	{
	// at end of these need to make extra polyfilla's around tri
	// sub div 0 into 4 5 6 7
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;	// now polyfilla
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;


		// copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

	
		DivWork[6].vx=(Verta->vx+DivWork[3].vx)>>1;
		DivWork[6].vy=(Verta->vy+DivWork[3].vy)>>1;
		DivWork[6].vz=(Verta->vz+DivWork[3].vz)>>1;
		DivWork[6].col.r=(In->r0+DivWork[3].col.r)>>1;
		DivWork[6].col.g=(In->g0+DivWork[3].col.g)>>1;
		DivWork[6].col.b=(In->b0+DivWork[3].col.b)>>1;

		DivWork[7].vx=(DivWork[3].vx+DivWork[5].vx)>>1;
		DivWork[7].vy=(DivWork[3].vy+DivWork[5].vy)>>1;
		DivWork[7].vz=(DivWork[3].vz+DivWork[5].vz)>>1;
		DivWork[7].col.r=(DivWork[3].col.r+DivWork[5].col.r)>>1;
		DivWork[7].col.g=(DivWork[3].col.g+DivWork[5].col.g)>>1;
		DivWork[7].col.b=(DivWork[3].col.b+DivWork[5].col.b)>>1;
		Done7=1;

		DivWork[8].vx=(Verta->vx+DivWork[5].vx)>>1;
		DivWork[8].vy=(Verta->vy+DivWork[5].vy)>>1;
		DivWork[8].vz=(Verta->vz+DivWork[5].vz)>>1;
		DivWork[8].col.r=(In->r0+DivWork[5].col.r)>>1;
		DivWork[8].col.g=(In->g0+DivWork[5].col.g)>>1;
		DivWork[8].col.b=(In->b0+DivWork[5].col.b)>>1;

		gte_ldv3(&DivWork[6],&DivWork[7],&DivWork[8]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);

		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;

		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out7->r0=
		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;

		*(Uint32 *)&GT3Out5->r1=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out2->r1=*(Uint32 *)&DivWork[3].col.r;

		*(Uint32 *)&GT3Out6->r1=
		*(Uint32 *)&GT3Out7->r2=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[5].col.r;


		*(Uint32 *)&GT3Out5->r2= 
		*(Uint32 *)&GT3Out->r1= 
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[6].col.r;

		*(Uint32 *)&GT3Out7->r1= 
		*(Uint32 *)&GT3Out->r2= 
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[8].col.r;

		*(Uint32 *)&GT3Out6->r2= 
		*(Uint32 *)&GT3Out2->r2= 
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[7].col.r;
#if SeeSplit
		setRGB0(GT3Out,0,0,0);
		setRGB0(GT3Out2,64,64,64);
		setRGB0(GT3Out3,128,128,128);
		setRGB0(GT3Out4,192,192,192);
#endif


#if SeePolyFilla	// write over correct rgbs already put in
	SeePolyFillaTri3F(GT3Out5,GT3Out6,GT3Out7);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
		;

#if 0
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x06000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x06000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x1C*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x1c*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x1c*3;


	} 
	else
	{
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
		  
	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[3].col.r;
		  
	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[5].col.r;
#if SeeSplit
	setRGB0(GT3Out,128,0,0);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;
	}



skip1:
	// sub dived 1
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr
		  
	gte_ldv3(&DivWork[3],Vertb,&DivWork[4]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto skip2;
	}

	gte_stsxy3_g3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip2;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 1 into 8 9 10 11
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;	// now polyfilla
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;

		// copy sub div 1 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;


	
		DivWork[9].vx=(Vertb->vx+DivWork[3].vx)>>1;
		DivWork[9].vy=(Vertb->vy+DivWork[3].vy)>>1;
		DivWork[9].vz=(Vertb->vz+DivWork[3].vz)>>1;
		DivWork[9].col.r=(In->r1+DivWork[3].col.r)>>1;
		DivWork[9].col.g=(In->g1+DivWork[3].col.g)>>1;
		DivWork[9].col.b=(In->b1+DivWork[3].col.b)>>1;

		DivWork[10].vx=(Vertb->vx+DivWork[4].vx)>>1;
		DivWork[10].vy=(Vertb->vy+DivWork[4].vy)>>1;
		DivWork[10].vz=(Vertb->vz+DivWork[4].vz)>>1;
		DivWork[10].col.r=(In->r1+DivWork[4].col.r)>>1;
		DivWork[10].col.g=(In->g1+DivWork[4].col.g)>>1;
		DivWork[10].col.b=(In->b1+DivWork[4].col.b)>>1;

		DivWork[11].vx=(DivWork[3].vx+DivWork[4].vx)>>1;
		DivWork[11].vy=(DivWork[3].vy+DivWork[4].vy)>>1;
		DivWork[11].vz=(DivWork[3].vz+DivWork[4].vz)>>1;
		DivWork[11].col.r=(DivWork[3].col.r+DivWork[4].col.r)>>1;
		DivWork[11].col.g=(DivWork[3].col.g+DivWork[4].col.g)>>1;
		DivWork[11].col.b=(DivWork[3].col.b+DivWork[4].col.b)>>1;
		Done11=1;


		gte_ldv3(&DivWork[9],&DivWork[10],&DivWork[11]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);


		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;





		*(Uint32 *)&GT3Out5->r1=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out2->r1=*(Uint32 *)&In->r1;

		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out7->r0=
		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[3].col.r;

		*(Uint32 *)&GT3Out6->r1=
		*(Uint32 *)&GT3Out7->r2=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[4].col.r;


		*(Uint32 *)&GT3Out5->r2= 
		*(Uint32 *)&GT3Out->r1= 
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[9].col.r;

		*(Uint32 *)&GT3Out7->r1= 
		*(Uint32 *)&GT3Out->r2= 
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[11].col.r;

		*(Uint32 *)&GT3Out6->r2= 
		*(Uint32 *)&GT3Out2->r2= 
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[10].col.r;
#if SeeSplit
		setRGB0(GT3Out,0,0,0);
		setRGB0(GT3Out2,64,64,64);
		setRGB0(GT3Out3,128,128,128);
		setRGB0(GT3Out4,192,192,192);
#endif


#if SeePolyFilla	// write over correct rgbs already put in
	SeePolyFillaTri3F(GT3Out5,GT3Out6,GT3Out7);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
		;

#if 0 //2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x06000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x06000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x1C*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x1c*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x1c*3;


	} 
	else
	{
	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r1;
		  
	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[4].col.r;
		  
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[3].col.r;
#if SeeSplit
	setRGB0(GT3Out,0,128,0);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;


	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;
	}





skip2:
	// subed dived 2
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(&DivWork[5],&DivWork[4],Vertc);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto  skip3;
	}

	gte_stsxy3_g3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip3;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn)  )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 2 into 12 13 14 15
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;

		// copy sub div 2 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;



		DivWork[12].vx=(DivWork[5].vx+DivWork[4].vx)>>1;
		DivWork[12].vy=(DivWork[5].vy+DivWork[4].vy)>>1;
		DivWork[12].vz=(DivWork[5].vz+DivWork[4].vz)>>1;
		DivWork[12].col.r=(DivWork[5].col.r+DivWork[4].col.r)>>1;
		DivWork[12].col.g=(DivWork[5].col.g+DivWork[4].col.g)>>1;
		DivWork[12].col.b=(DivWork[5].col.b+DivWork[4].col.b)>>1;
		Done12=1;
	
		DivWork[13].vx=(Vertc->vx+DivWork[4].vx)>>1;
		DivWork[13].vy=(Vertc->vy+DivWork[4].vy)>>1;
		DivWork[13].vz=(Vertc->vz+DivWork[4].vz)>>1;
		DivWork[13].col.r=(In->r2+DivWork[4].col.r)>>1;
		DivWork[13].col.g=(In->g2+DivWork[4].col.g)>>1;
		DivWork[13].col.b=(In->b2+DivWork[4].col.b)>>1;

		DivWork[14].vx=(Vertc->vx+DivWork[5].vx)>>1;
		DivWork[14].vy=(Vertc->vy+DivWork[5].vy)>>1;
		DivWork[14].vz=(Vertc->vz+DivWork[5].vz)>>1;
		DivWork[14].col.r=(In->r2+DivWork[5].col.r)>>1;
		DivWork[14].col.g=(In->g2+DivWork[5].col.g)>>1;
		DivWork[14].col.b=(In->b2+DivWork[5].col.b)>>1;


		gte_ldv3(&DivWork[12],&DivWork[13],&DivWork[14]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);


		*(Uint32 *)&GT3Out2->x0=
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;



		*(Uint32 *)&GT3Out6->r1=
		*(Uint32 *)&GT3Out7->r2=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&In->r2;

		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out7->r0=
		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[5].col.r;

		*(Uint32 *)&GT3Out5->r1=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out2->r1=*(Uint32 *)&DivWork[4].col.r;

		*(Uint32 *)&GT3Out5->r2= 
		*(Uint32 *)&GT3Out->r1= 
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[12].col.r;

		*(Uint32 *)&GT3Out7->r1= 
		*(Uint32 *)&GT3Out->r2= 
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[14].col.r;

		*(Uint32 *)&GT3Out6->r2= 
		*(Uint32 *)&GT3Out2->r2= 
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[13].col.r;
#if SeeSplit
		setRGB0(GT3Out,0,0,0);
		setRGB0(GT3Out2,64,64,64);
		setRGB0(GT3Out3,128,128,128);
		setRGB0(GT3Out4,192,192,192);
#endif

#if SeePolyFilla	// write over correct rgbs already put in
	SeePolyFillaTri3F(GT3Out5,GT3Out6,GT3Out7);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
		;


#if 0	//2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x06000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x06000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x1C*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x1c*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x1c*3;


	} 
	else
	{
	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&In->r2;
		  
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[5].col.r;
		  
	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[4].col.r;
#if SeeSplit
	setRGB0(GT3Out,0,0,128);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;
	}


skip3:
	// sub dived 3
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(&DivWork[3],&DivWork[4],&DivWork[5]);	
	gte_rtpt();

	if ((!backclip))
	{
	gte_nclip();					
	gte_stopz(&otz2);
	if (otz2 <=0) goto  skip4;
	}

	gte_stsxy3_g3(GT3Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2))
		)  goto skip4;

	if ((( (flag & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 3 into 16 17 18 19
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		GT3Out5=GT3Out+4;
		GT3Out6=GT3Out+5;
		GT3Out7=GT3Out+6;


		// copy sub div 2 xy to new packets
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out5->x1=				 // 5 and	
		*(Uint32 *)&GT3Out6->x0=*(Uint32 *)&GT3Out->x1;		 // 6 is polyfilla

		*(Uint32 *)&GT3Out3->x2=
		*(Uint32 *)&GT3Out6->x1=				// 5 and	
		*(Uint32 *)&GT3Out7->x2=*(Uint32 *)&GT3Out->x2;		// 6  and 7 is polyfilla

		*(Uint32 *)&GT3Out5->x0=				//5 and 7 polyfilla
		*(Uint32 *)&GT3Out7->x0=*(Uint32 *)&GT3Out->x0;

		if (Done11==0)
		{
		DivWork[11].vx=(DivWork[3].vx+DivWork[4].vx)>>1;
		DivWork[11].vy=(DivWork[3].vy+DivWork[4].vy)>>1;
		DivWork[11].vz=(DivWork[3].vz+DivWork[4].vz)>>1;
		DivWork[11].col.r=(DivWork[3].col.r+DivWork[4].col.r)>>1;
		DivWork[11].col.g=(DivWork[3].col.g+DivWork[4].col.g)>>1;
		DivWork[11].col.b=(DivWork[3].col.b+DivWork[4].col.b)>>1;
		}
		if (Done12==0)
		{
		DivWork[12].vx=(DivWork[5].vx+DivWork[4].vx)>>1;
		DivWork[12].vy=(DivWork[5].vy+DivWork[4].vy)>>1;
		DivWork[12].vz=(DivWork[5].vz+DivWork[4].vz)>>1;
		DivWork[12].col.r=(DivWork[5].col.r+DivWork[4].col.r)>>1;
		DivWork[12].col.g=(DivWork[5].col.g+DivWork[4].col.g)>>1;
		DivWork[12].col.b=(DivWork[5].col.b+DivWork[4].col.b)>>1;
		}
		if (Done7==0)
		{
		DivWork[7].vx=(DivWork[3].vx+DivWork[5].vx)>>1;
		DivWork[7].vy=(DivWork[3].vy+DivWork[5].vy)>>1;
		DivWork[7].vz=(DivWork[3].vz+DivWork[5].vz)>>1;
		DivWork[7].col.r=(DivWork[3].col.r+DivWork[5].col.r)>>1;
		DivWork[7].col.g=(DivWork[3].col.g+DivWork[5].col.g)>>1;
		DivWork[7].col.b=(DivWork[3].col.b+DivWork[5].col.b)>>1;
		}

		// below may have been worked out already in other tris!
		// could we make improment here ?
		gte_ldv3(&DivWork[11],&DivWork[12],&DivWork[7]);	
		gte_rtpt();
		gte_stsxy3(&GT3Out->x1,&GT3Out2->x2,&GT3Out->x2);

	    *(Uint32 *)&GT3Out2->x0=
	    *(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT3Out5->x2=*(Uint32 *)&GT3Out->x1;			//5 6 7 polyfilla

		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=
		*(Uint32 *)&GT3Out6->x2=*(Uint32 *)&GT3Out2->x2;

		*(Uint32 *)&GT3Out3->x0=
		*(Uint32 *)&GT3Out4->x0=
		*(Uint32 *)&GT3Out7->x1=*(Uint32 *)&GT3Out->x2;




		*(Uint32 *)&GT3Out5->r0=
		*(Uint32 *)&GT3Out7->r0=
		*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[3].col.r;

		*(Uint32 *)&GT3Out5->r1=
		*(Uint32 *)&GT3Out6->r0=
		*(Uint32 *)&GT3Out2->r1=*(Uint32 *)&DivWork[4].col.r;

		*(Uint32 *)&GT3Out6->r1=
		*(Uint32 *)&GT3Out7->r2=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[5].col.r;

		*(Uint32 *)&GT3Out5->r2= 		  
		*(Uint32 *)&GT3Out->r1= 		  
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[11].col.r;

		*(Uint32 *)&GT3Out7->r1= 	
		*(Uint32 *)&GT3Out->r2= 	
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[7].col.r;

		*(Uint32 *)&GT3Out6->r2= 	
		*(Uint32 *)&GT3Out2->r2= 	
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[12].col.r;
#if SeeSplit
		setRGB0(GT3Out,0,0,0);
		setRGB0(GT3Out2,64,64,64);
		setRGB0(GT3Out3,128,128,128);
		setRGB0(GT3Out4,192,192,192);
#endif

#if SeePolyFilla	// write over correct rgbs already put in
	SeePolyFillaTri3F(GT3Out5,GT3Out6,GT3Out7);
#endif

		GT3Out->code= 
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
#if SeeSplit
		In->p0
		&0xfe;
#else 
#if SeePolyFilla
		In->p0;
#endif
#endif
		GT3Out5->code=
		GT3Out6->code=
		GT3Out7->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
		;

#if 0	//2-2-99
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GT3Out4->tag =((u_long) (GT3Out5) & 0x00ffffff)|0x06000000;
		GT3Out5->tag =((u_long) (GT3Out6) & 0x00ffffff)|0x06000000;
		GT3Out6->tag =((u_long) (GT3Out7) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x1C*7;
#endif
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff)| 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x1c*4;

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out5->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out5) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out6->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out6) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(sz3[0]>clipflag3)) )
		{
		GT3Out7->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out7) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x1c*3;


	} 
	else
	{
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[3].col.r;
		  
	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[4].col.r;
		  
	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[5].col.r;
#if SeeSplit
	setRGB0(GT3Out,255,180,0);
#endif	  

	GT3Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;
	}

skip4:



	// FILL IN POLY GAPS

	// new POLY_FILLA 1!
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Verta,&DivWork[5],Vertc);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1F(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[5].col.r;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&In->r2;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla1;
	gte_stsxy3_g3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;


skipfilla1:

	// new POLY_FILLA 2!
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Verta,Vertb,&DivWork[3]);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1F(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r1;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[3].col.r;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla2;
	gte_stsxy3_g3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;


skipfilla2:

	// new POLY_FILLA 3!
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(&DivWork[4],Vertb,Vertc);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1F(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&DivWork[4].col.r;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r1;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&In->r2;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla3;
	gte_stsxy3_g3(GT3Out);

	GT3Out->code=In->p0
#if SeePolyFilla
		&0xfe
#endif
	;

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;

skipfilla3:
{}



}



void	SubDivF4(register F4_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
		   				register SVECTOR *Vertc,
						register SVECTOR *Vertd,
						register Sint32 *tag,
						register Uint32 backclip)
{
register POLY_F3	*GT3Out;	// 3's are pollyfilla 
register POLY_F3	*GT3Out2;
register POLY_F3	*GT3Out3;
register POLY_F3	*GT3Out4; 
register POLY_F4	*GT4Out;	// 4's are faces
register POLY_F4	*GT4Out2;
register POLY_F4	*GT4Out3;
register POLY_F4	*GT4Out4;			  

// reset flags to say mid points 11,12 and 7 have been made.
register Uint32		Done11=0;
//register Uint32		Done12=0;
//register Uint32		Done7=0;
register Uint32		Done10=0;
register Uint32		Done15=0;
register Uint32		Done19=0;


	DivWork[4].vx=((Verta->vx+Vertb->vx)>>1);
	DivWork[4].vy=((Verta->vy+Vertb->vy)>>1);
	DivWork[4].vz=((Verta->vz+Vertb->vz)>>1);

	DivWork[5].vx=((Vertb->vx+Vertd->vx)>>1);
	DivWork[5].vy=((Vertb->vy+Vertd->vy)>>1);
	DivWork[5].vz=((Vertb->vz+Vertd->vz)>>1);

	DivWork[6].vx=((Vertd->vx+Vertc->vx)>>1);
	DivWork[6].vy=((Vertd->vy+Vertc->vy)>>1);
	DivWork[6].vz=((Vertd->vz+Vertc->vz)>>1);

	DivWork[7].vx=((Vertc->vx+Verta->vx)>>1);
	DivWork[7].vy=((Vertc->vy+Verta->vy)>>1);
	DivWork[7].vz=((Vertc->vz+Verta->vz)>>1);


	DivWork[8].vx=((Verta->vx+Vertd->vx)>>1);
	DivWork[8].vy=((Verta->vy+Vertd->vy)>>1);
	DivWork[8].vz=((Verta->vz+Vertd->vz)>>1);

	// rottranspers mid point into dcache
	gte_ldv3c_vertc(&DivWork[8]);	
	gte_rtps();	
	gte_stflg(&midflag);
	gte_stsz(&midsz);
	gte_stsxy2(&midxy);


	// sub dived 0
	GT4Out=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(Verta,&DivWork[4],&DivWork[7]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();			// only checks 1 tri part of quad
//	// may need to check both tri's in quad on quads that are across bend
//	// ie verts b and c.. so that will be sub-div quads	1+3 with 2 nclips				
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto skip1;
//	}

	gte_stsxy3_f4(GT4Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip1;

	if ((( ((flag|midflag) & 0x80000000) // sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag)
	   ||(midsz<clipflag)
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )

	{
	// sub div 0 
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_F3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		*(Uint32 *)&GT4Out->r0=		// no grd shading
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out4->x1=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x2;

		*(Uint32 *)&GT4Out3->x0=*(Uint32 *)&midxy;


		DivWork[9].vx=(Verta->vx+DivWork[4].vx)>>1;
		DivWork[9].vy=(Verta->vy+DivWork[4].vy)>>1;
		DivWork[9].vz=(Verta->vz+DivWork[4].vz)>>1;

		DivWork[10].vx=(DivWork[4].vx+DivWork[8].vx)>>1;
		DivWork[10].vy=(DivWork[4].vy+DivWork[8].vy)>>1;
		DivWork[10].vz=(DivWork[4].vz+DivWork[8].vz)>>1;
		Done10=1;

		DivWork[11].vx=(DivWork[7].vx+DivWork[8].vx)>>1;
		DivWork[11].vy=(DivWork[7].vy+DivWork[8].vy)>>1;
		DivWork[11].vz=(DivWork[7].vz+DivWork[8].vz)>>1;
		Done11=1;

		DivWork[12].vx=(Verta->vx+DivWork[7].vx)>>1;
		DivWork[12].vy=(Verta->vy+DivWork[7].vy)>>1;
		DivWork[12].vz=(Verta->vz+DivWork[7].vz)>>1;

		DivWork[13].vx=(DivWork[7].vx+DivWork[4].vx)>>1;
		DivWork[13].vy=(DivWork[7].vy+DivWork[4].vy)>>1;
		DivWork[13].vz=(DivWork[7].vz+DivWork[4].vz)>>1;

		gte_ldv3(&DivWork[9],&DivWork[13],&DivWork[12]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out->x1,&GT4Out->x3,&GT4Out->x2);
		gte_ldv01(&DivWork[10],&DivWork[11]);
		gte_rtpt();
		gte_stsxy01(&GT4Out2->x3,&GT4Out3->x1);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT4Out4->x3=*(Uint32 *)&GT4Out->x2;	
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT3Out4->x0=	
		*(Uint32 *)&GT3Out->x0=*(Uint32 *)&GT4Out->x0; 
		*(Uint32 *)&GT3Out->x1= 
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out2->x1;
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1;	

#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
#endif
		  
#if SeePolyFilla	// write over correct rgbs already put in
		setRGB0(GT3Out,255,0,0);
		setRGB0(GT3Out2,0,255,0);
		setRGB0(GT3Out3,0,0,255);
		setRGB0(GT3Out4,255,255,255);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x20;//f3 with In->semi-trans and shade info


#if 0 // out 2-2-99
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x05000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x05000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x05000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x05000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x18*4;	 // f4
		GsOUT_PACKET_P+=0x14*4;	 // f3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x05000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x05000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x05000000;
		GsOUT_PACKET_P+=0x18*4;	 // f4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x14*4;	 // f3

	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
#if SeeSplit
	setRGB0(GT4Out,128,0,0);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x3=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x18;	 // f4
	}



skip1:
	// sub dived 1
	GT4Out=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr
		  
	gte_ldv3(&DivWork[4],Vertb,&DivWork[5]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto skip2;
//	}

	gte_stsxy3(&GT4Out->x0,&GT4Out->x1,&GT4Out->x3);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip2;

	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 1
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_F3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		*(Uint32 *)&GT4Out->r0=		// no grd shading
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out3->x0=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x3;

		*(Uint32 *)&GT4Out4->x1=*(Uint32 *)&midxy;


		DivWork[14].vx=(Vertb->vx+DivWork[5].vx)>>1;
		DivWork[14].vy=(Vertb->vy+DivWork[5].vy)>>1;
		DivWork[14].vz=(Vertb->vz+DivWork[5].vz)>>1;

		DivWork[15].vx=(DivWork[5].vx+DivWork[8].vx)>>1;
		DivWork[15].vy=(DivWork[5].vy+DivWork[8].vy)>>1;
		DivWork[15].vz=(DivWork[5].vz+DivWork[8].vz)>>1;
		Done15=1;

		DivWork[16].vx=(Vertb->vx+DivWork[4].vx)>>1;
		DivWork[16].vy=(Vertb->vy+DivWork[4].vy)>>1;
		DivWork[16].vz=(Vertb->vz+DivWork[4].vz)>>1;

		DivWork[17].vx=(Vertb->vx+DivWork[8].vx)>>1;
		DivWork[17].vy=(Vertb->vy+DivWork[8].vy)>>1;
		DivWork[17].vz=(Vertb->vz+DivWork[8].vz)>>1;

		if (Done10==0)
		{
		DivWork[10].vx=(DivWork[4].vx+DivWork[8].vx)>>1;
		DivWork[10].vy=(DivWork[4].vy+DivWork[8].vy)>>1;
		DivWork[10].vz=(DivWork[4].vz+DivWork[8].vz)>>1;
		Done10=1;
		}

		gte_ldv3(&DivWork[14],&DivWork[17],&DivWork[16]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out2->x3,&GT4Out->x3,&GT4Out->x1);
		// 10 below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[15],&DivWork[10]);
		gte_rtpt();
		gte_stsxy01(&GT4Out3->x1,&GT4Out->x2);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT4Out4->x3=*(Uint32 *)&GT4Out->x2;	
		*(Uint32 *)&GT3Out4->x0=	
		*(Uint32 *)&GT3Out->x0=*(Uint32 *)&GT4Out->x0; 
		*(Uint32 *)&GT3Out->x1= 
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out2->x1;
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1;	


#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
#endif

#if SeePolyFilla	// write over correct rgbs already put in
		setRGB0(GT3Out,255,0,0);
		setRGB0(GT3Out2,0,255,0);
		setRGB0(GT3Out3,0,0,255);
		setRGB0(GT3Out4,255,255,255);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code= In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x20;//f3 with In->semi-trans and shade info

#if 0 //2-2-99
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x05000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x05000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x05000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x05000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x18*4;	 // f4
		GsOUT_PACKET_P+=0x14*4;	 // f3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x05000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x05000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x05000000;
		GsOUT_PACKET_P+=0x18*4;	 // f4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x14*4;	 // f3



	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
#if SeeSplit
	setRGB0(GT4Out,0,128,0);
#endif  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x2=*(Uint32 *)&midxy;


	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x18;	 // f4
	}



skip2:
	// subed dived 2
	GT4Out=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(Vertd,&DivWork[6],&DivWork[5]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto  skip3;
//	}

	gte_stsxy3_f4(GT4Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip3;

	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn)  )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 2
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_F3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		*(Uint32 *)&GT4Out->r0=		// no grd shading
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out4->x1=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x2;

		*(Uint32 *)&GT4Out3->x0=*(Uint32 *)&midxy;


		DivWork[18].vx=(Vertd->vx+DivWork[6].vx)>>1;
		DivWork[18].vy=(Vertd->vy+DivWork[6].vy)>>1;
		DivWork[18].vz=(Vertd->vz+DivWork[6].vz)>>1;

		DivWork[19].vx=(DivWork[6].vx+DivWork[8].vx)>>1;
		DivWork[19].vy=(DivWork[6].vy+DivWork[8].vy)>>1;
		DivWork[19].vz=(DivWork[6].vz+DivWork[8].vz)>>1;
		Done19=1;

		DivWork[20].vx=(Vertd->vx+DivWork[5].vx)>>1;
		DivWork[20].vy=(Vertd->vy+DivWork[5].vy)>>1;
		DivWork[20].vz=(Vertd->vz+DivWork[5].vz)>>1;

		DivWork[21].vx=(DivWork[5].vx+DivWork[6].vx)>>1;
		DivWork[21].vy=(DivWork[5].vy+DivWork[6].vy)>>1;
		DivWork[21].vz=(DivWork[5].vz+DivWork[6].vz)>>1;

		if (Done15==0)
		{
		DivWork[15].vx=(DivWork[5].vx+DivWork[8].vx)>>1;
		DivWork[15].vy=(DivWork[5].vy+DivWork[8].vy)>>1;
		DivWork[15].vz=(DivWork[5].vz+DivWork[8].vz)>>1;
		Done15=1;
		}

		gte_ldv3(&DivWork[18],&DivWork[21],&DivWork[20]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out->x1,&GT4Out->x3,&GT4Out->x2);
		// 15 below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[19],&DivWork[15]);
		gte_rtpt();
		gte_stsxy01(&GT4Out2->x3,&GT4Out3->x1);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT4Out4->x3=
		*(Uint32 *)&GT3Out4->x1=*(Uint32 *)&GT4Out->x2;	

#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
#endif
		  
#if SeePolyFilla	// write over correct rgbs already put in
		setRGB0(GT3Out,255,0,0);
		setRGB0(GT3Out2,0,255,0);
		setRGB0(GT3Out3,0,0,255);
		setRGB0(GT3Out4,255,255,255);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x20;//f3 with In->semi-trans and shade info

#if 0 //2-2-99
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x05000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x05000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x05000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x05000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x18*4;	 // f4
		GsOUT_PACKET_P+=0x14*4;	 // f3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x05000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x05000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x05000000;
		GsOUT_PACKET_P+=0x18*4;	 // f4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x14*4;	 // f3


	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
#if SeeSplit
	setRGB0(GT4Out,0,0,128);
#endif  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x3=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x18;	 // f4
	}


skip3:
	// sub dived 3
	GT4Out=(POLY_F4 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(&DivWork[6],Vertc,&DivWork[7]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto  skip4;
//	}

	gte_stsxy3(&GT4Out->x0,&GT4Out->x1,&GT4Out->x3);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(			// new
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip4;

	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 3
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_F3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;
		*(Uint32 *)&GT4Out->r0=		// no grd shading
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out2->r0=
		*(Uint32 *)&GT3Out3->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out3->x0=
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out->x3;

		*(Uint32 *)&GT4Out4->x1=*(Uint32 *)&midxy;


		DivWork[22].vx=(Vertc->vx+DivWork[7].vx)>>1;
		DivWork[22].vy=(Vertc->vy+DivWork[7].vy)>>1;
		DivWork[22].vz=(Vertc->vz+DivWork[7].vz)>>1;

		if (Done11==0)
		{
		DivWork[11].vx=(DivWork[7].vx+DivWork[8].vx)>>1;
		DivWork[11].vy=(DivWork[7].vy+DivWork[8].vy)>>1;
		DivWork[11].vz=(DivWork[7].vz+DivWork[8].vz)>>1;
		Done11=1;
		}

		if (Done19==0)
		{
		DivWork[19].vx=(DivWork[6].vx+DivWork[8].vx)>>1;
		DivWork[19].vy=(DivWork[6].vy+DivWork[8].vy)>>1;
		DivWork[19].vz=(DivWork[6].vz+DivWork[8].vz)>>1;
		Done19=1;
		}

		DivWork[23].vx=(Vertc->vx+DivWork[6].vx)>>1;
		DivWork[23].vy=(Vertc->vy+DivWork[6].vy)>>1;
		DivWork[23].vz=(Vertc->vz+DivWork[6].vz)>>1;

		DivWork[24].vx=(Vertc->vx+DivWork[8].vx)>>1;
		DivWork[24].vy=(Vertc->vy+DivWork[8].vy)>>1;
		DivWork[24].vz=(Vertc->vz+DivWork[8].vz)>>1;


		gte_ldv3(&DivWork[22],&DivWork[24],&DivWork[23]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out2->x3,&GT4Out->x3,&GT4Out->x1);
		// 11 and 19  below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[11],&DivWork[19]);
		gte_rtpt();
		gte_stsxy01(&GT4Out3->x1,&GT4Out->x2);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out4->x3=
		*(Uint32 *)&GT3Out4->x1=*(Uint32 *)&GT4Out->x2;
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1; 

#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
#endif
		  
#if SeePolyFilla	// write over correct rgbs already put in
		setRGB0(GT3Out,255,0,0);
		setRGB0(GT3Out2,0,255,0);
		setRGB0(GT3Out3,0,0,255);
		setRGB0(GT3Out4,255,255,255);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x20;//F3 with In->semi-trans and shade info

#if 0 // 2-2-99
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x05000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x05000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x05000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x05000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x04000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x04000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x04000000;
		GsOUT_PACKET_P+=0x18*4;	 // f4
		GsOUT_PACKET_P+=0x14*4;	 // f3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x05000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x05000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x05000000;
		GsOUT_PACKET_P+=0x18*4;	 // f4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x14*4;	 // f3

	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
#if SeeSplit
	setRGB0(GT4Out,255,180,0);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x2=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x05000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x18;	 // f4
	}

skip4:




	// FILL IN POLY GAPS

	// new POLY_FILLA 1!
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Verta,Vertb,&DivWork[4]);	
	gte_rtpt();
#if SeePolyFilla
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla1;
	gte_stsxy3_f3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x20;//f3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;	 // f3


skipfilla1:

	// new POLY_FILLA 2!
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Vertb,Vertd,&DivWork[5]);	
	gte_rtpt();
#if SeePolyFilla
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla2;
	gte_stsxy3_f3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x20;//f3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;	 // f3


skipfilla2:

	// new POLY_FILLA 3!
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Vertd,Vertc,&DivWork[6]);	
	gte_rtpt();
#if SeePolyFilla
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla3;
	gte_stsxy3_f3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x20;//f3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;	 // f3

skipfilla3:

	// new POLY_FILLA 4!
	GT3Out=(POLY_F3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Verta,&DivWork[7],Vertc);	
	gte_rtpt();
#if SeePolyFilla
	setRGB0(GT3Out,255,255,255);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla4;
	gte_stsxy3_f3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x20;//f3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x04000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x14;	 // f3

skipfilla4:
{}

}



void	SubDivG4(	register GF4_Packet *In,
						register SVECTOR *Verta,
						register SVECTOR *Vertb,
		   				register SVECTOR *Vertc,
						register SVECTOR *Vertd,
						register Sint32 *tag,
						register Uint32 backclip)
{
register POLY_G3	*GT3Out;	// 3's are pollyfilla 
register POLY_G3	*GT3Out2;
register POLY_G3	*GT3Out3;
register POLY_G3	*GT3Out4; 
register POLY_G4	*GT4Out;	// 4's are faces
register POLY_G4	*GT4Out2;
register POLY_G4	*GT4Out3;
register POLY_G4	*GT4Out4;			  

// reset flags to say mid points 11,12 and 7 have been made.
register Uint32		Done11=0;
//register Uint32		Done12=0;
//register Uint32		Done7=0;
register Uint32		Done10=0;
register Uint32		Done15=0;
register Uint32		Done19=0;


	DivWork[4].vx=((Verta->vx+Vertb->vx)>>1);
	DivWork[4].vy=((Verta->vy+Vertb->vy)>>1);
	DivWork[4].vz=((Verta->vz+Vertb->vz)>>1);
	DivWork[4].col.r=(In->r0+In->r1)>>1;
	DivWork[4].col.g=(In->g0+In->g1)>>1;
	DivWork[4].col.b=(In->b0+In->b1)>>1;

	DivWork[5].vx=((Vertb->vx+Vertd->vx)>>1);
	DivWork[5].vy=((Vertb->vy+Vertd->vy)>>1);
	DivWork[5].vz=((Vertb->vz+Vertd->vz)>>1);
	DivWork[5].col.r=(In->r1+In->r3)>>1;
	DivWork[5].col.g=(In->g1+In->g3)>>1;
	DivWork[5].col.b=(In->b1+In->b3)>>1;

	DivWork[6].vx=((Vertd->vx+Vertc->vx)>>1);
	DivWork[6].vy=((Vertd->vy+Vertc->vy)>>1);
	DivWork[6].vz=((Vertd->vz+Vertc->vz)>>1);
	DivWork[6].col.r=(In->r3+In->r2)>>1;
	DivWork[6].col.g=(In->g3+In->g2)>>1;
	DivWork[6].col.b=(In->b3+In->b2)>>1;

	DivWork[7].vx=((Vertc->vx+Verta->vx)>>1);
	DivWork[7].vy=((Vertc->vy+Verta->vy)>>1);
	DivWork[7].vz=((Vertc->vz+Verta->vz)>>1);
	DivWork[7].col.r=(In->r2+In->r0)>>1;
	DivWork[7].col.g=(In->g2+In->g0)>>1;
	DivWork[7].col.b=(In->b2+In->b0)>>1;


	DivWork[8].vx=((Verta->vx+Vertd->vx)>>1);
	DivWork[8].vy=((Verta->vy+Vertd->vy)>>1);
	DivWork[8].vz=((Verta->vz+Vertd->vz)>>1);
	DivWork[8].col.r=(In->r1+In->r2)>>1;			// across tri diag
	DivWork[8].col.g=(In->g1+In->g2)>>1;
	DivWork[8].col.b=(In->b1+In->b2)>>1;

	// rottranspers mid point into dcache
	gte_ldv3c_vertc(&DivWork[8]);	
	gte_rtps();	
	gte_stflg(&midflag);
	gte_stsz(&midsz);
	gte_stsxy2(&midxy);


	// sub dived 0
	GT4Out=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(Verta,&DivWork[4],&DivWork[7]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();			// only checks 1 tri part of quad
//	// may need to check both tri's in quad on quads that are across bend
//	// ie verts b and c.. so that will be sub-div quads	1+3 with 2 nclips				
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto skip1;
//	}

	gte_stsxy3_g4(GT4Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);


	if	(
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip1;

	
	if ((( ((flag|midflag) & 0x80000000) // sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag)
	   ||(midsz<clipflag)
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )

	{
	// sub div 0 
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_G3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out4->x1=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x2;

		*(Uint32 *)&GT4Out3->x0=*(Uint32 *)&midxy;


		DivWork[9].vx=(Verta->vx+DivWork[4].vx)>>1;
		DivWork[9].vy=(Verta->vy+DivWork[4].vy)>>1;
		DivWork[9].vz=(Verta->vz+DivWork[4].vz)>>1;
		DivWork[9].col.r=(In->r0+DivWork[4].col.r)>>1;
		DivWork[9].col.g=(In->g0+DivWork[4].col.g)>>1;
		DivWork[9].col.b=(In->b0+DivWork[4].col.b)>>1;

		DivWork[10].vx=(DivWork[4].vx+DivWork[8].vx)>>1;
		DivWork[10].vy=(DivWork[4].vy+DivWork[8].vy)>>1;
		DivWork[10].vz=(DivWork[4].vz+DivWork[8].vz)>>1;
		DivWork[10].col.r=(DivWork[4].col.r+DivWork[8].col.r)>>1;
		DivWork[10].col.g=(DivWork[4].col.g+DivWork[8].col.g)>>1;
		DivWork[10].col.b=(DivWork[4].col.b+DivWork[8].col.b)>>1;
		Done10=1;

		DivWork[11].vx=(DivWork[7].vx+DivWork[8].vx)>>1;
		DivWork[11].vy=(DivWork[7].vy+DivWork[8].vy)>>1;
		DivWork[11].vz=(DivWork[7].vz+DivWork[8].vz)>>1;
		DivWork[11].col.r=(DivWork[7].col.r+DivWork[8].col.r)>>1;
		DivWork[11].col.g=(DivWork[7].col.g+DivWork[8].col.g)>>1;
		DivWork[11].col.b=(DivWork[7].col.b+DivWork[8].col.b)>>1;
		Done11=1;

		DivWork[12].vx=(Verta->vx+DivWork[7].vx)>>1;
		DivWork[12].vy=(Verta->vy+DivWork[7].vy)>>1;
		DivWork[12].vz=(Verta->vz+DivWork[7].vz)>>1;
		DivWork[12].col.r=(In->r0+DivWork[7].col.r)>>1;
		DivWork[12].col.g=(In->g0+DivWork[7].col.g)>>1;
		DivWork[12].col.b=(In->b0+DivWork[7].col.b)>>1;

		DivWork[13].vx=(DivWork[7].vx+DivWork[4].vx)>>1;
		DivWork[13].vy=(DivWork[7].vy+DivWork[4].vy)>>1;
		DivWork[13].vz=(DivWork[7].vz+DivWork[4].vz)>>1;
		DivWork[13].col.r=(DivWork[7].col.r+DivWork[4].col.r)>>1;
		DivWork[13].col.g=(DivWork[7].col.g+DivWork[4].col.g)>>1;
		DivWork[13].col.b=(DivWork[7].col.b+DivWork[4].col.b)>>1;

		gte_ldv3(&DivWork[9],&DivWork[13],&DivWork[12]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out->x1,&GT4Out->x3,&GT4Out->x2);
		gte_ldv01(&DivWork[10],&DivWork[11]);
		gte_rtpt();
		gte_stsxy01(&GT4Out2->x3,&GT4Out3->x1);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT4Out4->x3=*(Uint32 *)&GT4Out->x2;	
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT3Out4->x0=	
		*(Uint32 *)&GT3Out->x0=*(Uint32 *)&GT4Out->x0; 
		*(Uint32 *)&GT3Out->x1= 
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out2->x1;
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1;	

		*(Uint32 *)&GT4Out->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r0;

		*(Uint32 *)&GT4Out->r1=
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[9].col.r;

		*(Uint32 *)&GT4Out->r2=
		*(Uint32 *)&GT4Out4->r3=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[12].col.r;

		*(Uint32 *)&GT4Out->r3=
		*(Uint32 *)&GT4Out2->r2=
		*(Uint32 *)&GT4Out3->r3=
		*(Uint32 *)&GT4Out4->r2=*(Uint32 *)&DivWork[13].col.r;

		*(Uint32 *)&GT4Out2->r1=
		*(Uint32 *)&GT3Out->r1=
		*(Uint32 *)&GT3Out2->r0=*(Uint32 *)&DivWork[4].col.r;

		*(Uint32 *)&GT4Out2->r3=
		*(Uint32 *)&GT4Out3->r2=
		*(Uint32 *)&GT3Out2->r2=*(Uint32 *)&DivWork[10].col.r;

		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT3Out2->r1=
		*(Uint32 *)&GT3Out3->r0=*(Uint32 *)&DivWork[8].col.r;

		*(Uint32 *)&GT4Out3->r1=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[11].col.r;

		*(Uint32 *)&GT4Out4->r1=
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[7].col.r;
#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB1(GT4Out,0,0,0);
		setRGB2(GT4Out,0,0,0);
		setRGB3(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB1(GT4Out2,64,64,64);
		setRGB2(GT4Out2,64,64,64);
		setRGB3(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB1(GT4Out3,128,128,128);
		setRGB2(GT4Out3,128,128,128);
		setRGB3(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
		setRGB1(GT4Out4,192,192,192);
		setRGB2(GT4Out4,192,192,192);
		setRGB3(GT4Out4,192,192,192);
#endif
		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
		SeePolyFilla4F(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x30;//g3 with In->semi-trans and shade info

#if 0
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x08000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x08000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x08000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x08000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x24*4;	 // g4
		GsOUT_PACKET_P+=0x1C*4;	 // g3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x08000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x08000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x08000000;
		GsOUT_PACKET_P+=0x24*4;	 // g4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x1c*4;	 // g3


	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r0;
	  	  
	*(Uint32 *)&GT4Out->r1=*(Uint32 *)&DivWork[4].col.r;
	  	  
	*(Uint32 *)&GT4Out->r2=*(Uint32 *)&DivWork[7].col.r;

	*(Uint32 *)&GT4Out->r3=*(Uint32 *)&DivWork[8].col.r;
#if SeeSplit
	setRGB0(GT4Out,128,0,0);
	setRGB1(GT4Out,128,0,0);
	setRGB2(GT4Out,128,0,0);
	setRGB3(GT4Out,128,0,0);
#endif

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x3=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x24;	 // g4
	}



skip1:
	// sub dived 1
	GT4Out=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr
		  
	gte_ldv3(&DivWork[4],Vertb,&DivWork[5]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto skip2;
//	}

	gte_stsxy3(&GT4Out->x0,&GT4Out->x1,&GT4Out->x3);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip2;


	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 1
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_G3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out3->x0=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x3;

		*(Uint32 *)&GT4Out4->x1=*(Uint32 *)&midxy;


		DivWork[14].vx=(Vertb->vx+DivWork[5].vx)>>1;
		DivWork[14].vy=(Vertb->vy+DivWork[5].vy)>>1;
		DivWork[14].vz=(Vertb->vz+DivWork[5].vz)>>1;
		DivWork[14].col.r=(In->r1+DivWork[5].col.r)>>1;
		DivWork[14].col.g=(In->g1+DivWork[5].col.g)>>1;
		DivWork[14].col.b=(In->b1+DivWork[5].col.b)>>1;

		DivWork[15].vx=(DivWork[5].vx+DivWork[8].vx)>>1;
		DivWork[15].vy=(DivWork[5].vy+DivWork[8].vy)>>1;
		DivWork[15].vz=(DivWork[5].vz+DivWork[8].vz)>>1;
		DivWork[15].col.r=(DivWork[5].col.r+DivWork[8].col.r)>>1;
		DivWork[15].col.g=(DivWork[5].col.g+DivWork[8].col.g)>>1;
		DivWork[15].col.b=(DivWork[5].col.b+DivWork[8].col.b)>>1;
		Done15=1;

		DivWork[16].vx=(Vertb->vx+DivWork[4].vx)>>1;
		DivWork[16].vy=(Vertb->vy+DivWork[4].vy)>>1;
		DivWork[16].vz=(Vertb->vz+DivWork[4].vz)>>1;
		DivWork[16].col.r=(In->r1+DivWork[4].col.r)>>1;
		DivWork[16].col.g=(In->g1+DivWork[4].col.g)>>1;
		DivWork[16].col.b=(In->b1+DivWork[4].col.b)>>1;

		DivWork[17].vx=(Vertb->vx+DivWork[8].vx)>>1;
		DivWork[17].vy=(Vertb->vy+DivWork[8].vy)>>1;
		DivWork[17].vz=(Vertb->vz+DivWork[8].vz)>>1;
		DivWork[17].col.r=(In->r1+DivWork[8].col.r)>>1;
		DivWork[17].col.g=(In->g1+DivWork[8].col.g)>>1;
		DivWork[17].col.b=(In->b1+DivWork[8].col.b)>>1;

		if (Done10==0)
		{
		DivWork[10].vx=(DivWork[4].vx+DivWork[8].vx)>>1;
		DivWork[10].vy=(DivWork[4].vy+DivWork[8].vy)>>1;
		DivWork[10].vz=(DivWork[4].vz+DivWork[8].vz)>>1;
		DivWork[10].col.r=(DivWork[4].col.r+DivWork[8].col.r)>>1;
		DivWork[10].col.g=(DivWork[4].col.g+DivWork[8].col.g)>>1;
		DivWork[10].col.b=(DivWork[4].col.b+DivWork[8].col.b)>>1;
		Done10=1;
		}

		gte_ldv3(&DivWork[14],&DivWork[17],&DivWork[16]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out2->x3,&GT4Out->x3,&GT4Out->x1);
		// 10 below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[15],&DivWork[10]);
		gte_rtpt();
		gte_stsxy01(&GT4Out3->x1,&GT4Out->x2);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT3Out4->x1=
		*(Uint32 *)&GT4Out4->x3=*(Uint32 *)&GT4Out->x2;	
		*(Uint32 *)&GT3Out4->x0=	
		*(Uint32 *)&GT3Out->x0=*(Uint32 *)&GT4Out->x0; 
		*(Uint32 *)&GT3Out->x1= 
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out2->x1;
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1;	


		*(Uint32 *)&GT4Out->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[4].col.r;

		*(Uint32 *)&GT4Out->r1=
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[16].col.r;

		*(Uint32 *)&GT4Out->r2=
		*(Uint32 *)&GT4Out4->r3=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[10].col.r;

		*(Uint32 *)&GT4Out->r3=
		*(Uint32 *)&GT4Out2->r2=
		*(Uint32 *)&GT4Out3->r3=
		*(Uint32 *)&GT4Out4->r2=*(Uint32 *)&DivWork[17].col.r;

		*(Uint32 *)&GT4Out2->r1=
		*(Uint32 *)&GT3Out->r1=
		*(Uint32 *)&GT3Out2->r0=*(Uint32 *)&In->r1;

		*(Uint32 *)&GT4Out2->r3=
		*(Uint32 *)&GT4Out3->r2=
		*(Uint32 *)&GT3Out2->r2=*(Uint32 *)&DivWork[14].col.r;

		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT3Out2->r1=
		*(Uint32 *)&GT3Out3->r0=*(Uint32 *)&DivWork[5].col.r;

		*(Uint32 *)&GT4Out3->r1=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[15].col.r;

		*(Uint32 *)&GT4Out4->r1=
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[8].col.r;
#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB1(GT4Out,0,0,0);
		setRGB2(GT4Out,0,0,0);
		setRGB3(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB1(GT4Out2,64,64,64);
		setRGB2(GT4Out2,64,64,64);
		setRGB3(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB1(GT4Out3,128,128,128);
		setRGB2(GT4Out3,128,128,128);
		setRGB3(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
		setRGB1(GT4Out4,192,192,192);
		setRGB2(GT4Out4,192,192,192);
		setRGB3(GT4Out4,192,192,192);
#endif
		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
		SeePolyFilla4F(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x30;//g3 with In->semi-trans and shade info

#if 0
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x08000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x08000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x08000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x08000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x24*4;	 // g4
		GsOUT_PACKET_P+=0x1C*4;	 // g3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x08000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x08000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x08000000;
		GsOUT_PACKET_P+=0x24*4;	 // g4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x1c*4;	 // g3

	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&DivWork[4].col.r;
		  
	*(Uint32 *)&GT4Out->r1=*(Uint32 *)&In->r1;
		  
	*(Uint32 *)&GT4Out->r2=*(Uint32 *)&DivWork[8].col.r;

	*(Uint32 *)&GT4Out->r3=*(Uint32 *)&DivWork[5].col.r;
#if SeeSplit
	setRGB0(GT4Out,0,128,0);
	setRGB1(GT4Out,0,128,0);
	setRGB2(GT4Out,0,128,0);
	setRGB3(GT4Out,0,128,0);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x2=*(Uint32 *)&midxy;


	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x24;	 // g4
	}



skip2:
	// subed dived 2
	GT4Out=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(Vertd,&DivWork[6],&DivWork[5]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto  skip3;
//	}

	gte_stsxy3_g4(GT4Out);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip3;

	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn)  )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 2
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_G3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out4->x1=
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out->x2;

		*(Uint32 *)&GT4Out3->x0=*(Uint32 *)&midxy;


		DivWork[18].vx=(Vertd->vx+DivWork[6].vx)>>1;
		DivWork[18].vy=(Vertd->vy+DivWork[6].vy)>>1;
		DivWork[18].vz=(Vertd->vz+DivWork[6].vz)>>1;
		DivWork[18].col.r=(In->r3+DivWork[6].col.r)>>1;
		DivWork[18].col.g=(In->g3+DivWork[6].col.g)>>1;
		DivWork[18].col.b=(In->b3+DivWork[6].col.b)>>1;

		DivWork[19].vx=(DivWork[6].vx+DivWork[8].vx)>>1;
		DivWork[19].vy=(DivWork[6].vy+DivWork[8].vy)>>1;
		DivWork[19].vz=(DivWork[6].vz+DivWork[8].vz)>>1;
		DivWork[19].col.r=(DivWork[6].col.r+DivWork[8].col.r)>>1;
		DivWork[19].col.g=(DivWork[6].col.g+DivWork[8].col.g)>>1;
		DivWork[19].col.b=(DivWork[6].col.b+DivWork[8].col.b)>>1;
		Done19=1;

		DivWork[20].vx=(Vertd->vx+DivWork[5].vx)>>1;
		DivWork[20].vy=(Vertd->vy+DivWork[5].vy)>>1;
		DivWork[20].vz=(Vertd->vz+DivWork[5].vz)>>1;
		DivWork[20].col.r=(In->r3+DivWork[5].col.r)>>1;
		DivWork[20].col.g=(In->g3+DivWork[5].col.g)>>1;
		DivWork[20].col.b=(In->b3+DivWork[5].col.b)>>1;

		DivWork[21].vx=(DivWork[5].vx+DivWork[6].vx)>>1;
		DivWork[21].vy=(DivWork[5].vy+DivWork[6].vy)>>1;
		DivWork[21].vz=(DivWork[5].vz+DivWork[6].vz)>>1;
		DivWork[21].col.r=(DivWork[5].col.r+DivWork[6].col.r)>>1;
		DivWork[21].col.g=(DivWork[5].col.g+DivWork[6].col.g)>>1;
		DivWork[21].col.b=(DivWork[5].col.b+DivWork[6].col.b)>>1;

		if (Done15==0)
		{
		DivWork[15].vx=(DivWork[5].vx+DivWork[8].vx)>>1;
		DivWork[15].vy=(DivWork[5].vy+DivWork[8].vy)>>1;
		DivWork[15].vz=(DivWork[5].vz+DivWork[8].vz)>>1;
		DivWork[15].col.r=(DivWork[5].col.r+DivWork[8].col.r)>>1;
		DivWork[15].col.g=(DivWork[5].col.g+DivWork[8].col.g)>>1;
		DivWork[15].col.b=(DivWork[5].col.b+DivWork[8].col.b)>>1;
		Done15=1;
		}

		gte_ldv3(&DivWork[18],&DivWork[21],&DivWork[20]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out->x1,&GT4Out->x3,&GT4Out->x2);
		// 15 below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[19],&DivWork[15]);
		gte_rtpt();
		gte_stsxy01(&GT4Out2->x3,&GT4Out3->x1);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;	
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out3->x0;
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;	
		*(Uint32 *)&GT4Out4->x3=
		*(Uint32 *)&GT3Out4->x1=*(Uint32 *)&GT4Out->x2;	

		*(Uint32 *)&GT4Out->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&In->r3;

		*(Uint32 *)&GT4Out->r1=
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[18].col.r;

		*(Uint32 *)&GT4Out->r2=
		*(Uint32 *)&GT4Out4->r3=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[20].col.r;

		*(Uint32 *)&GT4Out->r3=
		*(Uint32 *)&GT4Out2->r2=
		*(Uint32 *)&GT4Out3->r3=
		*(Uint32 *)&GT4Out4->r2=*(Uint32 *)&DivWork[21].col.r;

		*(Uint32 *)&GT4Out2->r1=
		*(Uint32 *)&GT3Out->r1=
		*(Uint32 *)&GT3Out2->r0=*(Uint32 *)&DivWork[6].col.r;

		*(Uint32 *)&GT4Out2->r3=
		*(Uint32 *)&GT4Out3->r2=
		*(Uint32 *)&GT3Out2->r2=*(Uint32 *)&DivWork[19].col.r;

		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT3Out2->r1=
		*(Uint32 *)&GT3Out3->r0=*(Uint32 *)&DivWork[8].col.r;

		*(Uint32 *)&GT4Out3->r1=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[15].col.r;

		*(Uint32 *)&GT4Out4->r1=
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[5].col.r;
#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB1(GT4Out,0,0,0);
		setRGB2(GT4Out,0,0,0);
		setRGB3(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB1(GT4Out2,64,64,64);
		setRGB2(GT4Out2,64,64,64);
		setRGB3(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB1(GT4Out3,128,128,128);
		setRGB2(GT4Out3,128,128,128);
		setRGB3(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
		setRGB1(GT4Out4,192,192,192);
		setRGB2(GT4Out4,192,192,192);
		setRGB3(GT4Out4,192,192,192);
#endif

		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
		SeePolyFilla4F(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x30;//g3 with In->semi-trans and shade info

#if 0
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x08000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x08000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x08000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x08000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x24*4;	 // g4
		GsOUT_PACKET_P+=0x1C*4;	 // g3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x08000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x08000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x08000000;
		GsOUT_PACKET_P+=0x24*4;	 // g4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x1c*4;	 // g3

	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&In->r3;
		  
	*(Uint32 *)&GT4Out->r1=*(Uint32 *)&DivWork[6].col.r;
			  
	*(Uint32 *)&GT4Out->r2=*(Uint32 *)&DivWork[5].col.r;
	
	*(Uint32 *)&GT4Out->r3=*(Uint32 *)&DivWork[8].col.r;
#if SeeSplit
	setRGB0(GT4Out,0,0,128);
	setRGB1(GT4Out,0,0,128);
	setRGB2(GT4Out,0,0,128);
	setRGB3(GT4Out,0,0,128);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x3=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x24;	 // g4
	}


skip3:
	// sub dived 3
	GT4Out=(POLY_G4 *)GsOUT_PACKET_P;	// get work base addr

	gte_ldv3(&DivWork[6],Vertc,&DivWork[7]);	
	gte_rtpt();

//	if ((!backclip))
//	{
//	gte_nclip();					
//	gte_stopz(&otz2);
//	if (otz2 <=0) goto  skip4;
//	}

	gte_stsxy3(&GT4Out->x0,&GT4Out->x1,&GT4Out->x3);
	gte_stflg(&flag);
	gte_stsz3(&sz3[0],&sz3[1],&sz3[2]);

	if	(
	   ((sz3[0]<clipflag2)	
	   &&(sz3[1]<clipflag2)	
	   &&(sz3[2]<clipflag2)
	   &&(midsz<clipflag2))
		)  goto skip4;


	if ((( ((flag|midflag) & 0x80000000)		// sub divide the sub divided poly *4  !
	   ||(sz3[0]<clipflag)	
	   ||(sz3[1]<clipflag)	
	   ||(sz3[2]<clipflag) 
	   ||(midsz<clipflag) 
		)
//	   && (SubSubOn) )
//	   && (!(In->info&0x0400)) )
	   && ((In->info&0x0300)==0x0100) )
	   )
	{
	// sub div 3
		/* SubDived2 ++; */
		// set all new poly pointers in out_packet area
		GT4Out2=GT4Out+1;
		GT4Out3=GT4Out+2;
		GT4Out4=GT4Out+3;
		GT3Out=(POLY_G3 *)(GT4Out+4);	// now polyfilla
		GT3Out2=GT3Out+1;
		GT3Out3=GT3Out+2;
		GT3Out4=GT3Out+3;

		//copy sub div 0 xy to new packets
		*(Uint32 *)&GT3Out->x0=
		*(Uint32 *)&GT3Out4->x0=*(Uint32 *)&GT4Out->x0;

		*(Uint32 *)&GT4Out2->x1=
		*(Uint32 *)&GT3Out->x1=
		*(Uint32 *)&GT3Out2->x0=*(Uint32 *)&GT4Out->x1;	

		*(Uint32 *)&GT4Out3->x0=
		*(Uint32 *)&GT3Out2->x1=
		*(Uint32 *)&GT3Out3->x0=*(Uint32 *)&GT4Out->x3;

		*(Uint32 *)&GT4Out4->x1=*(Uint32 *)&midxy;


		DivWork[22].vx=(Vertc->vx+DivWork[7].vx)>>1;
		DivWork[22].vy=(Vertc->vy+DivWork[7].vy)>>1;
		DivWork[22].vz=(Vertc->vz+DivWork[7].vz)>>1;
		DivWork[22].col.r=(In->r2+DivWork[7].col.r)>>1;
		DivWork[22].col.g=(In->g2+DivWork[7].col.g)>>1;
		DivWork[22].col.b=(In->b2+DivWork[7].col.b)>>1;

		if (Done11==0)
		{
		DivWork[11].vx=(DivWork[7].vx+DivWork[8].vx)>>1;
		DivWork[11].vy=(DivWork[7].vy+DivWork[8].vy)>>1;
		DivWork[11].vz=(DivWork[7].vz+DivWork[8].vz)>>1;
		DivWork[11].col.r=(DivWork[7].col.r+DivWork[8].col.r)>>1;
		DivWork[11].col.g=(DivWork[7].col.g+DivWork[8].col.g)>>1;
		DivWork[11].col.b=(DivWork[7].col.b+DivWork[8].col.b)>>1;
		Done11=1;
		}

		if (Done19==0)
		{
		DivWork[19].vx=(DivWork[6].vx+DivWork[8].vx)>>1;
		DivWork[19].vy=(DivWork[6].vy+DivWork[8].vy)>>1;
		DivWork[19].vz=(DivWork[6].vz+DivWork[8].vz)>>1;
		DivWork[19].col.r=(DivWork[6].col.r+DivWork[8].col.r)>>1;
		DivWork[19].col.g=(DivWork[6].col.g+DivWork[8].col.g)>>1;
		DivWork[19].col.b=(DivWork[6].col.b+DivWork[8].col.b)>>1;
		Done19=1;
		}

		DivWork[23].vx=(Vertc->vx+DivWork[6].vx)>>1;
		DivWork[23].vy=(Vertc->vy+DivWork[6].vy)>>1;
		DivWork[23].vz=(Vertc->vz+DivWork[6].vz)>>1;
		DivWork[23].col.r=(In->r2+DivWork[6].col.r)>>1;
		DivWork[23].col.g=(In->g2+DivWork[6].col.g)>>1;
		DivWork[23].col.b=(In->b2+DivWork[6].col.b)>>1;

		DivWork[24].vx=(Vertc->vx+DivWork[8].vx)>>1;
		DivWork[24].vy=(Vertc->vy+DivWork[8].vy)>>1;
		DivWork[24].vz=(Vertc->vz+DivWork[8].vz)>>1;
		DivWork[24].col.r=(In->r2+DivWork[8].col.r)>>1;
		DivWork[24].col.g=(In->g2+DivWork[8].col.g)>>1;
		DivWork[24].col.b=(In->b2+DivWork[8].col.b)>>1;


		gte_ldv3(&DivWork[22],&DivWork[24],&DivWork[23]);	
		gte_rtpt();
		gte_stsxy3(&GT4Out2->x3,&GT4Out->x3,&GT4Out->x1);
		// 11 and 19  below may have been done already...could we make improv here?!
		gte_ldv01(&DivWork[11],&DivWork[19]);
		gte_rtpt();
		gte_stsxy01(&GT4Out3->x1,&GT4Out->x2);

		*(Uint32 *)&GT4Out2->x0=
		*(Uint32 *)&GT3Out->x2=*(Uint32 *)&GT4Out->x1;	
		*(Uint32 *)&GT4Out2->x2=
		*(Uint32 *)&GT4Out3->x3=
		*(Uint32 *)&GT4Out4->x2=*(Uint32 *)&GT4Out->x3;	
		*(Uint32 *)&GT4Out4->x3=
		*(Uint32 *)&GT3Out4->x1=*(Uint32 *)&GT4Out->x2;
		*(Uint32 *)&GT4Out3->x2=
		*(Uint32 *)&GT3Out2->x2=*(Uint32 *)&GT4Out2->x3;
		*(Uint32 *)&GT4Out4->x0=
		*(Uint32 *)&GT3Out3->x2=*(Uint32 *)&GT4Out3->x1;
		*(Uint32 *)&GT3Out3->x1=
		*(Uint32 *)&GT3Out4->x2=*(Uint32 *)&GT4Out4->x1; 

		*(Uint32 *)&GT4Out->r0=
		*(Uint32 *)&GT3Out->r0=
		*(Uint32 *)&GT3Out4->r0=*(Uint32 *)&DivWork[6].col.r;

		*(Uint32 *)&GT4Out->r1=
		*(Uint32 *)&GT4Out2->r0=
		*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[23].col.r;

		*(Uint32 *)&GT4Out->r2=
		*(Uint32 *)&GT4Out4->r3=
		*(Uint32 *)&GT3Out4->r1=*(Uint32 *)&DivWork[19].col.r;

		*(Uint32 *)&GT4Out->r3=
		*(Uint32 *)&GT4Out2->r2=
		*(Uint32 *)&GT4Out3->r3=
		*(Uint32 *)&GT4Out4->r2=*(Uint32 *)&DivWork[24].col.r;

		*(Uint32 *)&GT4Out2->r1=
		*(Uint32 *)&GT3Out->r1=
		*(Uint32 *)&GT3Out2->r0=*(Uint32 *)&In->r2;

		*(Uint32 *)&GT4Out2->r3=
		*(Uint32 *)&GT4Out3->r2=
		*(Uint32 *)&GT3Out2->r2=*(Uint32 *)&DivWork[22].col.r;

		*(Uint32 *)&GT4Out3->r0=
		*(Uint32 *)&GT3Out2->r1=
		*(Uint32 *)&GT3Out3->r0=*(Uint32 *)&DivWork[7].col.r;

		*(Uint32 *)&GT4Out3->r1=
		*(Uint32 *)&GT4Out4->r0=
		*(Uint32 *)&GT3Out3->r2=*(Uint32 *)&DivWork[11].col.r;

		*(Uint32 *)&GT4Out4->r1=
		*(Uint32 *)&GT3Out3->r1=
		*(Uint32 *)&GT3Out4->r2=*(Uint32 *)&DivWork[8].col.r;
#if SeeSplit
		setRGB0(GT4Out,0,0,0);
		setRGB1(GT4Out,0,0,0);
		setRGB2(GT4Out,0,0,0);
		setRGB3(GT4Out,0,0,0);
		setRGB0(GT4Out2,64,64,64);
		setRGB1(GT4Out2,64,64,64);
		setRGB2(GT4Out2,64,64,64);
		setRGB3(GT4Out2,64,64,64);
		setRGB0(GT4Out3,128,128,128);
		setRGB1(GT4Out3,128,128,128);
		setRGB2(GT4Out3,128,128,128);
		setRGB3(GT4Out3,128,128,128);
		setRGB0(GT4Out4,192,192,192);
		setRGB1(GT4Out4,192,192,192);
		setRGB2(GT4Out4,192,192,192);
		setRGB3(GT4Out4,192,192,192);
#endif

		  
		  
#if SeePolyFilla	// write over correct rgbs already put in
		SeePolyFilla4F(GT3Out,GT3Out2,GT3Out3,GT3Out4);
#endif

		GT4Out->code= 
		GT4Out2->code=
		GT4Out3->code=
		GT4Out4->code=In->p0
#if SeeSplit
		&0xfe
#endif 
		;
		GT3Out->code=
		GT3Out2->code=
		GT3Out3->code=
		GT3Out4->code=
		(In->p0
#if SeePolyFilla
		&0xfe
#endif
		& 0x03)|0x30;//g3 with In->semi-trans and shade info

#if 0
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x08000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x08000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x08000000;
		GT4Out4->tag =((u_long) (GT3Out) & 0x00ffffff)|0x08000000;
		GT3Out->tag =((u_long) (GT3Out2) & 0x00ffffff)|0x06000000;
		GT3Out2->tag =((u_long) (GT3Out3) & 0x00ffffff)|0x06000000;
		GT3Out3->tag =((u_long) (GT3Out4) & 0x00ffffff)|0x06000000;
		GsOUT_PACKET_P+=0x24*4;	 // g4
		GsOUT_PACKET_P+=0x1C*4;	 // g3
#endif

		GT4Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
		*tag = ((u_long) (GT4Out) & 0x00ffffff);
		GT4Out->tag =((u_long)  (GT4Out2) & 0x00ffffff)|0x08000000;
		GT4Out2->tag =((u_long) (GT4Out3) & 0x00ffffff)|0x08000000;
		GT4Out3->tag =((u_long) (GT4Out4) & 0x00ffffff)|0x08000000;
		GsOUT_PACKET_P+=0x24*4;	 // g4

		if (!(In->info&0x0400))
		{
		if ( ((sz3[0]>clipflag3)&&(sz3[1]>clipflag3)) )
		{
		GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out) & 0x00ffffff);
		}
		if ( ((sz3[1]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out2->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out2) & 0x00ffffff);
		}
		if ( ((sz3[2]>clipflag3)&&(midsz>clipflag3)) )
		{
		GT3Out3->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out3) & 0x00ffffff);
		}
		if ( ((sz3[0]>clipflag3)&&(sz3[2]>clipflag3)) )
		{
		GT3Out4->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
		*tag = ((u_long) (GT3Out4) & 0x00ffffff);
		}
		}
		GsOUT_PACKET_P+=0x1c*4;	 // g3

	} 
	else
	{
	*(Uint32 *)&GT4Out->r0=*(Uint32 *)&DivWork[6].col.r;
		  
	*(Uint32 *)&GT4Out->r1=*(Uint32 *)&In->r2;
		  
	*(Uint32 *)&GT4Out->r2=*(Uint32 *)&DivWork[8].col.r;

	*(Uint32 *)&GT4Out->r3=*(Uint32 *)&DivWork[7].col.r;
#if SeeSplit
	setRGB0(GT4Out,255,180,0);
	setRGB1(GT4Out,255,180,0);
	setRGB2(GT4Out,255,180,0);
	setRGB3(GT4Out,255,180,0);
#endif	  

	GT4Out->code=In->p0
#if SeeSplit
		&0xfe
#endif
	;
	*(Uint32 *)&GT4Out->x2=*(Uint32 *)&midxy;

	GT4Out->tag = (u_long)((*tag & 0x00ffffff) | 0x08000000);
	*tag = ((u_long) (GT4Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x24;	 // g4
	}

skip4:



	// FILL IN POLY GAPS

	// new POLY_FILLA 1!
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Verta,Vertb,&DivWork[4]);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1F(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r1;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[4].col.r;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla1;
	gte_stsxy3_g3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x30;//g3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;	 // g3


skipfilla1:

	// new POLY_FILLA 2!
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Vertb,Vertd,&DivWork[5]);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1F(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r1;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r3;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[5].col.r;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla2;
	gte_stsxy3_g3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x30;//g3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;	 // g3


skipfilla2:

	// new POLY_FILLA 3!
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Vertd,Vertc,&DivWork[6]);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1F(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r3;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&In->r2;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&DivWork[6].col.r;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla3;
	gte_stsxy3_g3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x30;//gt3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;	 // g3

skipfilla3:

	// new POLY_FILLA 4!
	GT3Out=(POLY_G3 *)GsOUT_PACKET_P;	// get work base addr
	gte_ldv3(Verta,&DivWork[7],Vertc);	
	gte_rtpt();
#if SeePolyFilla
	SeePolyFilla1F(GT3Out);
#else
	*(Uint32 *)&GT3Out->r0=*(Uint32 *)&In->r0;

	*(Uint32 *)&GT3Out->r1=*(Uint32 *)&DivWork[7].col.r;

	*(Uint32 *)&GT3Out->r2=*(Uint32 *)&In->r2;
#endif
	gte_stflg(&flag);
	if (flag & 0x80000000) goto skipfilla4;
	gte_stsxy3_g3(GT3Out);

	GT3Out->code=(In->p0
#if SeePolyFilla
		&0xfe
#endif
	& 0x03)|0x30;//g3 with In->semi-trans and shade info

	GT3Out->tag = (u_long)((*tag & 0x00ffffff) | 0x06000000);
	*tag = ((u_long) (GT3Out) & 0x00ffffff);
	GsOUT_PACKET_P+=0x1C;	 // g3

skipfilla4:
{}

}







